/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/base/common/buffer","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(Q){for(var e=[],P=0,R=Q.length;P<R;P++)e[P]=oe[Q[P]];return e};define(oe[134],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(m,$,d){const h=R(m,$);if(h!==-1)return m[h]}e.$fb=P;function R(m,$,d=m.length-1){for(let h=d;h>=0;h--){const g=m[h];if($(g))return h}return-1}e.$gb=R;function s(m,$){const d=M(m,$);return d===-1?void 0:m[d]}e.$hb=s;function M(m,$,d=0,h=m.length){let g=d,v=h;for(;g<v;){const u=Math.floor((g+v)/2);$(m[u])?g=u+1:v=u}return g-1}e.$ib=M;function D(m,$){const d=S(m,$);return d===m.length?void 0:m[d]}e.$jb=D;function S(m,$,d=0,h=m.length){let g=d,v=h;for(;g<v;){const u=Math.floor((g+v)/2);$(m[u])?v=u:g=u+1}return g}e.$kb=S;function f(m,$,d=0,h=m.length){const g=S(m,$,d,h);return g===m.length?-1:g}e.$lb=f;class l{static{this.assertInvariants=!1}constructor($){this.e=$,this.c=0}findLastMonotonous($){if(l.assertInvariants){if(this.d){for(const h of this.e)if(this.d(h)&&!$(h))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=$}const d=M(this.e,$,this.c);return this.c=d+1,d===-1?void 0:this.e[d]}}e.$mb=l;function y(m,$){if(m.length===0)return;let d=m[0];for(let h=1;h<m.length;h++){const g=m[h];$(g,d)>0&&(d=g)}return d}e.$nb=y;function k(m,$){if(m.length===0)return;let d=m[0];for(let h=1;h<m.length;h++){const g=m[h];$(g,d)>=0&&(d=g)}return d}e.$ob=k;function p(m,$){return y(m,(d,h)=>-$(d,h))}e.$pb=p;function c(m,$){if(m.length===0)return-1;let d=0;for(let h=1;h<m.length;h++){const g=m[h];$(g,m[d])>0&&(d=h)}return d}e.$qb=c;function b(m,$){for(const d of m){const h=$(d);if(h!==void 0)return h}}e.$rb=b}),define(oe[135],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function P(D,S){const f=Object.create(null);for(const l of D){const y=S(l);let k=f[y];k||(k=f[y]=[]),k.push(l)}return f}e.$K=P;function R(D,S){const f=[],l=[];for(const y of D)S.has(y)||f.push(y);for(const y of S)D.has(y)||l.push(y);return{removed:f,added:l}}e.$L=R;function s(D,S){const f=[],l=[];for(const[y,k]of D)S.has(y)||f.push(k);for(const[y,k]of S)D.has(y)||l.push(k);return{removed:f,added:l}}e.$M=s;function M(D,S){const f=new Set;for(const l of S)D.has(l)&&f.add(l);return f}e.$N=M}),define(oe[136],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=e.$_s=void 0;function P(S,f){const l=Math.pow(10,f);return Math.round(S*l)/l}class R{constructor(f,l,y,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,y))|0,this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.$_s=R;class s{constructor(f,l,y,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,y=f.g/255,k=f.b/255,p=f.a,c=Math.max(l,y,k),b=Math.min(l,y,k);let m=0,$=0;const d=(b+c)/2,h=c-b;if(h>0){switch($=Math.min(d<=.5?h/(2*d):h/(2-2*d),1),c){case l:m=(y-k)/h+(y<k?6:0);break;case y:m=(k-l)/h+2;break;case k:m=(l-y)/h+4;break}m*=60,m=Math.round(m)}return new s(m,$,d,p)}static i(f,l,y){return y<0&&(y+=1),y>1&&(y-=1),y<1/6?f+(l-f)*6*y:y<1/2?l:y<2/3?f+(l-f)*(2/3-y)*6:f}static toRGBA(f){const l=f.h/360,{s:y,l:k,a:p}=f;let c,b,m;if(y===0)c=b=m=k;else{const $=k<.5?k*(1+y):k+y-k*y,d=2*k-$;c=s.i(d,$,l+1/3),b=s.i(d,$,l),m=s.i(d,$,l-1/3)}return new R(Math.round(c*255),Math.round(b*255),Math.round(m*255),p)}}e.$at=s;class M{constructor(f,l,y,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,y),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,y=f.g/255,k=f.b/255,p=Math.max(l,y,k),c=Math.min(l,y,k),b=p-c,m=p===0?0:b/p;let $;return b===0?$=0:p===l?$=((y-k)/b%6+6)%6:p===y?$=(k-l)/b+2:$=(l-y)/b+4,new M(Math.round($*60),m,p,f.a)}static toRGBA(f){const{h:l,s:y,v:k,a:p}=f,c=k*y,b=c*(1-Math.abs(l/60%2-1)),m=k-c;let[$,d,h]=[0,0,0];return l<60?($=c,d=b):l<120?($=b,d=c):l<180?(d=c,h=b):l<240?(d=b,h=c):l<300?($=b,h=c):l<=360&&($=c,h=b),$=Math.round(($+m)*255),d=Math.round((d+m)*255),h=Math.round((h+m)*255),new R($,d,h,p)}}e.$bt=M;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),l=D.k(this.rgba.g),y=D.k(this.rgba.b),k=.2126*f+.7152*l+.0722*y;return P(k,4)}static k(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),y=f.getRelativeLuminance();return l>y?(l+.05)/(y+.05):(y+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),y=f.getRelativeLuminance();return l>y}isDarkerThan(f){const l=this.getRelativeLuminance(),y=f.getRelativeLuminance();return l<y}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:y,b:k,a:p}=this.rgba;return new D(new R(l,y,k,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,y=this.rgba.a,k=l.a,p=y+k*(1-y);if(p<1e-6)return D.transparent;const c=this.rgba.r*y/p+l.r*k*(1-y)/p,b=this.rgba.g*y/p+l.g*k*(1-y)/p,m=this.rgba.b*y/p+l.b*k*(1-y)/p;return new D(new R(c,b,m,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:y,b:k,a:p}=this.rgba;return new D(new R(f.rgba.r-p*(f.rgba.r-l),f.rgba.g-p*(f.rgba.g-y),f.rgba.b-p*(f.rgba.b-k),1))}flatten(...f){const l=f.reduceRight((y,k)=>D.o(k,y));return D.o(this,l)}static o(f,l){const y=1-f.rgba.a;return new D(new R(y*l.rgba.r+f.rgba.a*f.rgba.r,y*l.rgba.g+f.rgba.a*f.rgba.g,y*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,l,y){if(f.isLighterThan(l))return f;y=y||.5;const k=f.getRelativeLuminance(),p=l.getRelativeLuminance();return y=y*(p-k)/p,f.lighten(y)}static getDarkerColor(f,l,y){if(f.isDarkerThan(l))return f;y=y||.5;const k=f.getRelativeLuminance(),p=l.getRelativeLuminance();return y=y*(k-p)/k,f.darken(y)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$ct=D,function(S){let f;(function(l){let y;(function(k){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}k.formatRGB=p;function c(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}k.formatRGBA=c;function b(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}k.formatHSL=b;function m(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}k.formatHSLA=m;function $(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function d(t){return`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}`}k.formatHex=d;function h(t,o=!1){return o&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${$(t.rgba.r)}${$(t.rgba.g)}${$(t.rgba.b)}${$(Math.round(t.rgba.a*255))}`}k.formatHexA=h;function g(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}k.format=g;function v(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new S(new R(r,i,n,1))}if(o===9){const r=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),a=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new S(new R(r,i,n,a/255))}if(o===4){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new S(new R(16*r+r,16*i+i,16*n+n))}if(o===5){const r=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),a=u(t.charCodeAt(4));return new S(new R(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}k.parseHex=v;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(y=l.CSS||(l.CSS={}))})(f=S.Format||(S.Format={}))}(D||(e.$ct=D={}))}),define(oe[50],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function P(D){return(S,f,l)=>{let y=null,k=null;if(typeof l.value=="function"?(y="value",k=l.value):typeof l.get=="function"&&(y="get",k=l.get),!k)throw new Error("not supported");l[y]=D(k,f)}}function R(D,S,f){let l=null,y=null;if(typeof f.value=="function"?(l="value",y=f.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",y=f.get),!y)throw new Error("not supported");const k=`$memoize$${S}`;f[l]=function(...p){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,p)}),this[k]}}e.$vh=R;function s(D,S,f){return P((l,y)=>{const k=`$debounce$${y}`,p=`$debounce$result$${y}`;return function(...c){this[p]||(this[p]=f?f():void 0),clearTimeout(this[k]),S&&(this[p]=S(this[p],...c),c=[this[p]]),this[k]=setTimeout(()=>{l.apply(this,c),this[p]=f?f():void 0},D)}})}e.$wh=s;function M(D,S,f){return P((l,y)=>{const k=`$throttle$timer$${y}`,p=`$throttle$result$${y}`,c=`$throttle$lastRun$${y}`,b=`$throttle$pending$${y}`;return function(...m){if(this[p]||(this[p]=f?f():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...m)),this[b])return;const $=this[c]+D;$<=Date.now()?(this[c]=Date.now(),l.apply(this,[this[p]]),this[p]=f?f():void 0):(this[b]=!0,this[k]=setTimeout(()=>{this[b]=!1,this[c]=Date.now(),l.apply(this,[this[p]]),this[p]=f?f():void 0},$-Date.now()))}})}e.$xh=M}),define(oe[14],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?g.isErrorNoTelemetry(t)?new g(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=P,e.$X=new P;function R(u){e.$X.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=R;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function M(u){l(u)||e.$X.onUnexpectedError(u)}e.$1=M;function D(u){l(u)||e.$X.onUnexpectedExternalError(u)}e.$2=D;function S(u){if(u instanceof Error){const{name:t,message:o}=u,r=u.stacktrace||u.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:g.isErrorNoTelemetry(u)}}return u}e.$3=S;const f="Canceled";function l(u){return u instanceof y?!0:u instanceof Error&&u.name===f&&u.message===f}e.$4=l;class y extends Error{constructor(){super(f),this.name=this.message}}e.$5=y;function k(){const u=new Error(f);return u.name=u.message,u}e.$6=k;function p(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$7=p;function c(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$8=c;class b extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=b;function m(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$0=m;class $ extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=$;class d extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=d;class h extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=h;class g extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof g)return t;const o=new g;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=g;class v extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}e.$cb=v}),define(oe[23],ae([0,1,14,134]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(z,X=0){return z[z.length-(1+X)]}e.$sb=s;function M(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=M;function D(z,X,N=(B,_)=>B===_){if(z===X)return!0;if(!z||!X||z.length!==X.length)return!1;for(let B=0,_=z.length;B<_;B++)if(!N(z[B],X[B]))return!1;return!0}e.$ub=D;function S(z,X){const N=z.length-1;X<N&&(z[X]=z[N]),z.pop()}e.$vb=S;function f(z,X,N){return l(z.length,B=>N(z[B],X))}e.$wb=f;function l(z,X){let N=0,B=z-1;for(;N<=B;){const _=(N+B)/2|0,ce=X(_);if(ce<0)N=_+1;else if(ce>0)B=_-1;else return _}return-(N+1)}e.$xb=l;function y(z,X,N){if(z=z|0,z>=X.length)throw new TypeError("invalid index");const B=X[Math.floor(X.length*Math.random())],_=[],ce=[],se=[];for(const $e of X){const me=N($e,B);me<0?_.push($e):me>0?ce.push($e):se.push($e)}return z<_.length?y(z,_,N):z<_.length+se.length?se[0]:y(z-(_.length+se.length),ce,N)}e.$yb=y;function k(z,X){const N=[];let B;for(const _ of z.slice(0).sort(X))!B||X(B[0],_)!==0?(B=[_],N.push(B)):B.push(_);return N}e.$zb=k;function*p(z,X){let N,B;for(const _ of z)B!==void 0&&X(B,_)?N.push(_):(N&&(yield N),N=[_]),B=_;N&&(yield N)}e.$Ab=p;function c(z,X){for(let N=0;N<=z.length;N++)X(N===0?void 0:z[N-1],N===z.length?void 0:z[N])}e.$Bb=c;function b(z,X){for(let N=0;N<z.length;N++)X(N===0?void 0:z[N-1],z[N],N+1===z.length?void 0:z[N+1])}e.$Cb=b;function m(z,X,N){const B=[];function _($e,me,ye){if(me===0&&ye.length===0)return;const Pe=B[B.length-1];Pe&&Pe.start+Pe.deleteCount===$e?(Pe.deleteCount+=me,Pe.toInsert.push(...ye)):B.push({start:$e,deleteCount:me,toInsert:ye})}let ce=0,se=0;for(;;){if(ce===z.length){_(ce,0,X.slice(se));break}if(se===X.length){_(ce,z.length-ce,[]);break}const $e=z[ce],me=X[se],ye=N($e,me);ye===0?(ce+=1,se+=1):ye<0?(_(ce,1,[]),ce+=1):ye>0&&(_(ce,0,[me]),se+=1)}return B}e.$Db=m;function $(z,X,N){const B=m(z,X,N),_=[],ce=[];for(const se of B)_.push(...z.slice(se.start,se.start+se.deleteCount)),ce.push(...se.toInsert);return{removed:_,added:ce}}e.$Eb=$;function d(z,X,N){if(N===0)return[];const B=z.slice(0,N).sort(X);return g(z,X,B,N,z.length),B}e.top=d;function h(z,X,N,B,_){return N===0?Promise.resolve([]):new Promise((ce,se)=>{(async()=>{const $e=z.length,me=z.slice(0,N).sort(X);for(let ye=N,Pe=Math.min(N+B,$e);ye<$e;ye=Pe,Pe=Math.min(Pe+B,$e)){if(ye>N&&await new Promise(Le=>setTimeout(Le)),_&&_.isCancellationRequested)throw new P.$5;g(z,X,me,ye,Pe)}return me})().then(ce,se)})}e.$Gb=h;function g(z,X,N,B,_){for(const ce=N.length;B<_;B++){const se=z[B];if(X(se,N[ce-1])<0){N.pop();const $e=(0,R.$kb)(N,me=>X(se,me)<0);N.splice($e,0,se)}}}function v(z){return z.filter(X=>!!X)}e.$Hb=v;function u(z){let X=0;for(let N=0;N<z.length;N++)z[N]&&(z[X]=z[N],X+=1);z.length=X}e.$Ib=u;function t(z,X,N){z.splice(N,0,z.splice(X,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,X=N=>N){const N=new Set;return z.filter(B=>{const _=X(B);return N.has(_)?!1:(N.add(_),!0)})}e.$Mb=i;function n(z){const X=new Set;return N=>{const B=z(N);return X.has(B)?!1:(X.add(B),!0)}}e.$Nb=n;function a(z,X){return z.length>0?z[0]:X}e.$Ob=a;function w(z,X){return z.length>0?z[z.length-1]:X}e.$Pb=w;function A(z,X,N=(B,_)=>B===_){let B=0;for(let _=0,ce=Math.min(z.length,X.length);_<ce&&N(z[_],X[_]);_++)B++;return B}e.$Qb=A;function I(z){return[].concat(...z)}e.$Rb=I;function E(z,X){let N=typeof X=="number"?z:0;typeof X=="number"?N=z:(N=0,X=z);const B=[];if(N<=X)for(let _=N;_<X;_++)B.push(_);else for(let _=N;_>X;_--)B.push(_);return B}e.$Sb=E;function C(z,X,N){return z.reduce((B,_)=>(B[X(_)]=N?N(_):_,B),Object.create(null))}e.$Tb=C;function j(z,X){return z.push(X),()=>W(z,X)}e.$Ub=j;function W(z,X){const N=z.indexOf(X);if(N>-1)return z.splice(N,1),X}e.$Vb=W;function T(z,X,N){const B=z.slice(0,X),_=z.slice(X);return B.concat(N,_)}e.$Wb=T;function G(z,X){let N;if(typeof X=="number"){let B=X;N=()=>{const _=Math.sin(B++)*179426549;return _-Math.floor(_)}}else N=Math.random;for(let B=z.length-1;B>0;B-=1){const _=Math.floor(N()*(B+1)),ce=z[B];z[B]=z[_],z[_]=ce}}e.$Xb=G;function K(z,X){const N=z.indexOf(X);N>-1&&(z.splice(N,1),z.unshift(X))}e.$Yb=K;function le(z,X){const N=z.indexOf(X);N>-1&&(z.splice(N,1),z.push(X))}e.$Zb=le;function re(z,X){for(const N of X)z.push(N)}e.$1b=re;function ue(z,X){return Array.isArray(z)?z.map(X):X(z)}e.$2b=ue;function Y(z){return Array.isArray(z)?z:[z]}e.$3b=Y;function Z(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=Z;function H(z,X,N){const B=U(z,X),_=z.length,ce=N.length;z.length=_+ce;for(let se=_-1;se>=B;se--)z[se+ce]=z[se];for(let se=0;se<ce;se++)z[se+B]=N[se]}e.$5b=H;function L(z,X,N,B){const _=U(z,X);let ce=z.splice(_,N);return ce===void 0&&(ce=[]),H(z,_,B),ce}e.$6b=L;function U(z,X){return X<0?Math.max(X+z.length,0):Math.min(X,z.length)}var V;(function(z){function X(ce){return ce<0}z.isLessThan=X;function N(ce){return ce<=0}z.isLessThanOrEqual=N;function B(ce){return ce>0}z.isGreaterThan=B;function _(ce){return ce===0}z.isNeitherLessOrGreaterThan=_,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function q(z,X){return(N,B)=>X(z(N),z(B))}e.$7b=q;function te(...z){return(X,N)=>{for(const B of z){const _=B(X,N);if(!V.isNeitherLessOrGreaterThan(_))return _}return V.neitherLessOrGreaterThan}}e.$8b=te;const he=(z,X)=>z-X;e.$9b=he;const J=(z,X)=>(0,e.$9b)(z?1:0,X?1:0);e.$0b=J;function O(z){return(X,N)=>-z(X,N)}e.$$b=O;class F{constructor(X){this.g=X,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(X){let N=this.c;for(;N<this.g.length&&X(this.g[N]);)N++;const B=N===this.c?null:this.g.slice(this.c,N);return this.c=N,B}takeFromEndWhile(X){let N=this.d;for(;N>=0&&X(this.g[N]);)N--;const B=N===this.d?null:this.g.slice(N+1,this.d+1);return this.d=N,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const X=this.g[this.c];return this.c++,X}removeLast(){const X=this.g[this.d];return this.d--,X}takeCount(X){const N=this.g.slice(this.c,this.c+X);return this.c+=X,N}}e.$_b=F;class x{static{this.empty=new x(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(N=>(X(N),!0))}toArray(){const X=[];return this.iterate(N=>(X.push(N),!0)),X}filter(X){return new x(N=>this.iterate(B=>X(B)?N(B):!0))}map(X){return new x(N=>this.iterate(B=>N(X(B))))}some(X){let N=!1;return this.iterate(B=>(N=X(B),!N)),N}findFirst(X){let N;return this.iterate(B=>X(B)?(N=B,!1):!0),N}findLast(X){let N;return this.iterate(B=>(X(B)&&(N=B),!0)),N}findLastMaxBy(X){let N,B=!0;return this.iterate(_=>((B||V.isGreaterThan(X(_,N)))&&(B=!1,N=_),!0)),N}}e.$ac=x}),define(oe[137],ae([0,1,14]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function R(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=R;function s(f,l="Unreachable"){throw new Error(l)}e.$6c=s;function M(f){if(!f)throw new P.$cb("Assertion Failed")}e.$7c=M;function D(f){if(!f()){debugger;f(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$8c=D;function S(f,l){let y=0;for(;y<f.length-1;){const k=f[y],p=f[y+1];if(!l(k,p))return!1;y++}return!0}e.$9c=S}),define(oe[84],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(R,s){const M=this;let D=!1,S;return function(){if(D)return S;if(D=!0,s)try{S=R.apply(M,arguments)}finally{s()}else S=R.apply(M,arguments);return S}}e.$db=P}),define(oe[72],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(R){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=s;const M=Object.freeze([]);function D(){return M}R.empty=D;function*S(t){yield t}R.single=S;function f(t){return s(t)?t:S(t)}R.wrap=f;function l(t){return t||M}R.from=l;function*y(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=y;function k(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=k;function p(t){return t[Symbol.iterator]().next().value}R.first=p;function c(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=c;function b(t,o){for(const r of t)if(o(r))return r}R.find=b;function*m(t,o){for(const r of t)o(r)&&(yield r)}R.filter=m;function*$(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=$;function*d(...t){for(const o of t)yield*o}R.concat=d;function h(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}R.reduce=h;function*g(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=g;function v(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const a=i.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=v;async function u(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=u})(P||(e.Iterable=P={}))}),define(oe[44],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,o=!1){let r=0;const i=t.length;let n="",a=0,w=16,A=0;function I(K){let le=0,re=0;for(;le<K;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,le++}return le<K&&(re=-1),re}function E(K){r=K,n="",a=0,w=16,A=0}function C(){const K=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return A=3,t.substring(K,r);let le=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;le=r}else A=3;return t.substring(K,le)}function j(){let K="",le=r;for(;;){if(r>=i){K+=t.substring(le,r),A=2;break}const re=t.charCodeAt(r);if(re===34){K+=t.substring(le,r),r++;break}if(re===92){if(K+=t.substring(le,r),r++,r>=i){A=2;break}switch(t.charCodeAt(r++)){case 34:K+='"';break;case 92:K+="\\";break;case 47:K+="/";break;case 98:K+="\b";break;case 102:K+="\f";break;case 110:K+=`
`;break;case 114:K+="\r";break;case 116:K+="	";break;case 117:{const Y=I(4);Y>=0?K+=String.fromCharCode(Y):A=4;break}default:A=5}le=r;continue}if(re>=0&&re<=31)if(f(re)){K+=t.substring(le,r),A=2;break}else A=6;r++}return K}function W(){if(n="",A=0,a=r,r>=i)return a=i,w=17;let K=t.charCodeAt(r);if(S(K)){do r++,n+=String.fromCharCode(K),K=t.charCodeAt(r);while(S(K));return w=15}if(f(K))return r++,n+=String.fromCharCode(K),K===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),w=14;switch(K){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,n=j(),w=10;case 47:{const le=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(le,r),w=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,A=1),n=t.substring(le,r),w=13}return n+=String.fromCharCode(K),r++,w=16}case 45:if(n+=String.fromCharCode(K),r++,r===i||!l(t.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=C(),w=11;default:for(;r<i&&T(K);)r++,K=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return n+=String.fromCharCode(K),r++,w=16}}function T(K){if(S(K)||f(K))return!1;switch(K){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let K;do K=W();while(K>=12&&K<=15);return K}return{setPosition:E,getPosition:()=>r,scan:o?G:W,getToken:()=>w,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>A}}e.$$m=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function k(t,o){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function A(I,E,C,j){a.value=I,a.offset=E,a.length=C,a.type=j,a.colonOffset=void 0,n=a}try{g(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,w=o>I,r.push("")},onObjectProperty:(I,E,C)=>{if(o<E||(A(I,E,C,"property"),r[r.length-1]=I,o<=E+C))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,C)=>{if(o<E||(A(I,E,C,u(I)),o<=E+C))throw i},onSeparator:(I,E,C)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,w=!1,n=void 0;else if(I===","){const j=r[r.length-1];typeof j=="number"?r[r.length-1]=j+1:(w=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:w,matches:I=>{let E=0;for(let C=0;E<I.length&&C<r.length;C++)if(I[E]===r[C]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$_m=k;function p(t,o=[],r=M.DEFAULT){let i=null,n=[];const a=[];function w(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return g(t,{onObjectBegin:()=>{const I={};w(I),a.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const I=[];w(I),a.push(n),n=I,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:w,onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r),n[0]}e.$an=p;function c(t,o=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}g(t,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,C)=>{i=a({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:C,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,C)=>{a({type:u(I),offset:E,length:C,parent:i,value:I}),n(E+C)},onSeparator:(I,E,C)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,C)=>{o.push({error:I,offset:E,length:C})}},r);const A=i.children[0];return A&&delete A.parent,A}e.$bn=c;function b(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$cn=b;function m(t){if(!t.parent||!t.parent.children)return[];const o=m(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$dn=m;function $(t){switch(t.type){case"array":return t.children.map($);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=$(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$en=$;function d(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$fn=d;function h(t,o,r=!1){if(d(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const a=h(i[n],o,r);if(a)return a}return t}}e.$gn=h;function g(t,o,r=M.DEFAULT){const i=D(t,!1);function n(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(q){return q?te=>q(te,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=n(o.onObjectBegin),A=a(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),C=n(o.onArrayEnd),j=a(o.onLiteralValue),W=a(o.onSeparator),T=n(o.onComment),G=a(o.onError),K=r&&r.disallowComments,le=r&&r.allowTrailingComma;function re(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:K||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:K?ue(10):T();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,te=[],he=[]){if(G(q),te.length+he.length>0){let J=i.getToken();for(;J!==17;){if(te.indexOf(J)!==-1){re();break}else if(he.indexOf(J)!==-1)break;J=re()}}}function Y(q){const te=i.getTokenValue();return q?j(te):A(te),re(),!0}function Z(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}j(q);break}case 7:j(null);break;case 8:j(!0);break;case 9:j(!1);break;default:return!1}return re(),!0}function H(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(W(":"),re(),V()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){w(),re();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),W(","),re(),i.getToken()===2&&le)break}else q&&ue(6,[],[]);H()||ue(4,[],[2,5]),q=!0}return I(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function U(){E(),re();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),W(","),re(),i.getToken()===4&&le)break}else q&&ue(6,[],[]);V()||ue(4,[],[4,5]),q=!0}return C(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function V(){switch(i.getToken()){case 3:return U();case 1:return L();case 10:return Y(!0);default:return Z()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):V()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$hn=g;function v(t,o){const r=D(t),i=[];let n,a=0,w;do switch(w=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==w&&i.push(t.substring(a,w)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$in=v;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$jn=u}),define(oe[138],ae([0,1,44]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=e.$2T=e.$1T=e.$ZT=void 0;function R(l,y,k){let p,c,b,m,$;if(y){for(m=y.offset,$=m+y.length,b=m;b>0&&!f(l,b-1);)b--;let w=$;for(;w<l.length&&!f(l,w);)w++;c=l.substring(b,w),p=D(c,k)}else c=l,p=0,b=0,m=0,$=l.length;const d=S(k,l);let h=!1,g=0,v;k.insertSpaces?v=M(" ",k.tabSize||4):v="	";const u=(0,P.$$m)(c,!1);let t=!1;function o(){return d+M(v,p+g)}function r(){let w=u.scan();for(h=!1;w===15||w===14;)h=h||w===14,w=u.scan();return t=w===16||u.getTokenError()!==0,w}const i=[];function n(w,A,I){!t&&A<$&&I>m&&l.substring(A,I)!==w&&i.push({offset:A,length:I-A,content:w})}let a=r();if(a!==17){const w=u.getTokenOffset()+b,A=M(v,p);n(A,b,w)}for(;a!==17;){let w=u.getTokenOffset()+u.getTokenLength()+b,A=r(),I="";for(;!h&&(A===12||A===13);){const C=u.getTokenOffset()+b;n(" ",w,C),w=u.getTokenOffset()+u.getTokenLength()+b,I=A===12?o():"",A=r()}if(A===2)a!==1&&(g--,I=o());else if(A===4)a!==3&&(g--,I=o());else{switch(a){case 3:case 1:g++,I=o();break;case 5:case 12:I=o();break;case 13:h?I=o():I=" ";break;case 6:I=" ";break;case 10:if(A===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:A===12||A===13?I=" ":A!==5&&A!==17&&(t=!0);break;case 16:t=!0;break}h&&(A===12||A===13)&&(I=o())}const E=u.getTokenOffset()+b;n(I,w,E),a=A}return i}e.$ZT=R;function s(l,y){const k=JSON.stringify(l,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?k.replace(/\r\n|\r|\n/g,y.eol):k}e.$1T=s;function M(l,y){let k="";for(let p=0;p<y;p++)k+=l;return k}function D(l,y){let k=0,p=0;const c=y.tabSize||4;for(;k<l.length;){const b=l.charAt(k);if(b===" ")p++;else if(b==="	")p+=c;else break;k++}return Math.floor(p/c)}function S(l,y){for(let k=0;k<y.length;k++){const p=y.charAt(k);if(p==="\r")return k+1<y.length&&y.charAt(k+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return l&&l.eol||`
`}e.$2T=S;function f(l,y){return`\r
`.indexOf(l.charAt(y))!==-1}e.$3T=f}),define(oe[139],ae([0,1,44,138]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8T=e.$7T=e.$6T=e.$5T=e.$4T=void 0;function s(l,y,k){return M(l,y,void 0,k)}e.$4T=s;function M(l,y,k,p,c){const b=y.slice(),m=[],$=(0,P.$bn)(l,m);let d,h;for(;b.length>0&&(h=b.pop(),d=(0,P.$cn)($,b),d===void 0&&k!==void 0);)typeof h=="string"?k={[h]:k}:k=[k];if(d)if(d.type==="object"&&typeof h=="string"&&Array.isArray(d.children)){const g=(0,P.$cn)(d,[h]);if(g!==void 0)if(k===void 0){if(!g.parent)throw new Error("Malformed AST");const v=d.children.indexOf(g.parent);let u,t=g.parent.offset+g.parent.length;if(v>0){const o=d.children[v-1];u=o.offset+o.length}else u=d.offset+1,d.children.length>1&&(t=d.children[1].offset);return D(l,{offset:u,length:t-u,content:""},p)}else return D(l,{offset:g.offset,length:g.length,content:JSON.stringify(k)},p);else{if(k===void 0)return[];const v=`${JSON.stringify(h)}: ${JSON.stringify(k)}`,u=c?c(d.children.map(o=>o.children[0].value)):d.children.length;let t;if(u>0){const o=d.children[u-1];t={offset:o.offset+o.length,length:0,content:","+v}}else d.children.length===0?t={offset:d.offset+1,length:0,content:v}:t={offset:d.offset+1,length:0,content:v+","};return D(l,t,p)}}else if(d.type==="array"&&typeof h=="number"&&Array.isArray(d.children))if(k!==void 0){const g=`${JSON.stringify(k)}`;let v;if(d.children.length===0||h===0)v={offset:d.offset+1,length:0,content:d.children.length===0?g:g+","};else{const u=h===-1||h>d.children.length?d.children.length:h,t=d.children[u-1];v={offset:t.offset+t.length,length:0,content:","+g}}return D(l,v,p)}else{const g=h,v=d.children[g];let u;if(d.children.length===1)u={offset:d.offset+1,length:d.length-2,content:""};else if(d.children.length-1===g){const t=d.children[g-1],o=t.offset+t.length,r=d.offset+d.length;u={offset:o,length:r-2-o,content:""}}else u={offset:v.offset,length:d.children[g+1].offset-v.offset,content:""};return D(l,u,p)}else throw new Error(`Can not add ${typeof h!="number"?"index":"property"} to parent of type ${d.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(k)},p)}}e.$5T=M;function D(l,y,k){let p=S(l,y),c=y.offset,b=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;c>0&&!(0,R.$3T)(p,c-1);)c--;for(;b<p.length&&!(0,R.$3T)(p,b);)b++}const m=(0,R.$ZT)(p,{offset:c,length:b-c},k);for(let d=m.length-1;d>=0;d--){const h=m[d];p=S(p,h),c=Math.min(c,h.offset),b=Math.max(b,h.offset+h.length),b+=h.content.length-h.length}const $=l.length-(p.length-b)-c;return[{offset:c,length:$,content:p.substring(c,b)}]}e.$6T=D;function S(l,y){return l.substring(0,y.offset)+y.content+l.substring(y.offset+y.length)}e.$7T=S;function f(l,y){const k=y.slice(0).sort((c,b)=>{const m=c.offset-b.offset;return m===0?c.length-b.length:m});let p=l.length;for(let c=k.length-1;c>=0;c--){const b=k[c];if(b.offset+b.length<=p)l=S(l,b);else throw new Error("Overlapping edit");p=b.offset}return l}e.$8T=f}),define(oe[62],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(oe[101],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class R{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$4c=R}),define(oe[31],ae([0,1]),function(Q,e){"use strict";var P,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function M(g,v,u){let t=g.get(v);return t===void 0&&(t=u,g.set(v,t)),t}e.$xc=M;function D(g){const v=[];return g.forEach((u,t)=>{v.push(`${t} => ${u}`)}),`Map(${g.size}) {${v.join(", ")}}`}e.$yc=D;function S(g){const v=[];return g.forEach(u=>{v.push(u)}),`Set(${g.size}) {${v.join(", ")}}`}e.$zc=S;class f{constructor(v,u){this.uri=v,this.value=u}}function l(g){return Array.isArray(g)}class y{static{this.c=v=>v.toString()}constructor(v,u){if(this[P]="ResourceMap",v instanceof y)this.d=new Map(v.d),this.e=u??y.c;else if(l(v)){this.d=new Map,this.e=u??y.c;for(const[t,o]of v)this.set(t,o)}else this.d=new Map,this.e=v??y.c}set(v,u){return this.d.set(this.e(v),new f(v,u)),this}get(v){return this.d.get(this.e(v))?.value}has(v){return this.d.has(this.e(v))}get size(){return this.d.size}clear(){this.d.clear()}delete(v){return this.d.delete(this.e(v))}forEach(v,u){typeof u<"u"&&(v=v.bind(u));for(const[t,o]of this.d)v(o.value,o.uri,this)}*values(){for(const v of this.d.values())yield v.value}*keys(){for(const v of this.d.values())yield v.uri}*entries(){for(const v of this.d.values())yield[v.uri,v.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,v]of this.d)yield[v.uri,v.value]}}e.$Ac=y;class k{constructor(v,u){this[R]="ResourceSet",!v||typeof v=="function"?this.c=new y(v):(this.c=new y(u),v.forEach(this.add,this))}get size(){return this.c.size}add(v){return this.c.set(v,v),this}clear(){this.c.clear()}delete(v){return this.c.delete(v)}forEach(v,u){this.c.forEach((t,o)=>v.call(u,o,o,this))}has(v){return this.c.has(v)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var p;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class c{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(v){return this.c.has(v)}get(v,u=0){const t=this.c.get(v);if(t)return u!==0&&this.l(t,u),t.value}set(v,u,t=0){let o=this.c.get(v);if(o)o.value=u,t!==0&&this.l(o,t);else{switch(o={key:v,value:u,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(v,o),this.f++}return this}delete(v){return!!this.remove(v)}remove(v){const u=this.c.get(v);if(u)return this.c.delete(v),this.k(u),this.f--,u.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const v=this.d;return this.c.delete(v.key),this.k(v),this.f--,v.value}forEach(v,u){const t=this.g;let o=this.d;for(;o;){if(u?v.bind(u)(o.value,o.key,this):v(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const v=this,u=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(v.g!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const v=this,u=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(v.g!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const v=this,u=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(v.g!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(v){if(v>=this.size)return;if(v===0){this.clear();return}let u=this.d,t=this.size;for(;u&&t>v;)this.c.delete(u.key),u=u.next,t--;this.d=u,this.f=t,u&&(u.previous=void 0),this.g++}i(v){if(!this.d&&!this.e)this.e=v;else if(this.d)v.next=this.d,this.d.previous=v;else throw new Error("Invalid list");this.d=v,this.g++}j(v){if(!this.d&&!this.e)this.d=v;else if(this.e)v.previous=this.e,this.e.next=v;else throw new Error("Invalid list");this.e=v,this.g++}k(v){if(v===this.d&&v===this.e)this.d=void 0,this.e=void 0;else if(v===this.d){if(!v.next)throw new Error("Invalid list");v.next.previous=void 0,this.d=v.next}else if(v===this.e){if(!v.previous)throw new Error("Invalid list");v.previous.next=void 0,this.e=v.previous}else{const u=v.next,t=v.previous;if(!u||!t)throw new Error("Invalid list");u.previous=t,t.next=u}v.next=void 0,v.previous=void 0,this.g++}l(v,u){if(!this.d||!this.e)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(v===this.d)return;const t=v.next,o=v.previous;v===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),v.previous=void 0,v.next=this.d,this.d.previous=v,this.d=v,this.g++}else if(u===2){if(v===this.e)return;const t=v.next,o=v.previous;v===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),v.next=void 0,v.previous=this.e,this.e.next=v,this.e=v,this.g++}}}toJSON(){const v=[];return this.forEach((u,t)=>{v.push([t,u])}),v}fromJSON(v){this.clear();for(const[u,t]of v)this.set(u,t)}}e.$Cc=c;class b extends c{constructor(v,u=1){super(),this.m=v,this.n=Math.min(Math.max(0,u),1)}get limit(){return this.m}set limit(v){this.m=v,this.o()}get ratio(){return this.n}set ratio(v){this.n=Math.min(Math.max(0,v),1),this.o()}get(v,u=2){return super.get(v,u)}peek(v){return super.get(v,0)}set(v,u){return super.set(v,u,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=b;class m{constructor(){this.c=new Map}add(v){return this.c.set(v,(this.c.get(v)||0)+1),this}delete(v){let u=this.c.get(v)||0;return u===0?!1:(u--,u===0?this.c.delete(v):this.c.set(v,u),!0)}has(v){return this.c.has(v)}}e.$Ec=m;class ${constructor(v){if(this.c=new Map,this.d=new Map,v)for(const[u,t]of v)this.set(u,t)}clear(){this.c.clear(),this.d.clear()}set(v,u){this.c.set(v,u),this.d.set(u,v)}get(v){return this.c.get(v)}getKey(v){return this.d.get(v)}delete(v){const u=this.c.get(v);return u===void 0?!1:(this.c.delete(v),this.d.delete(u),!0)}forEach(v,u){this.c.forEach((t,o)=>{v.call(u,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=$;class d{constructor(){this.c=new Map}add(v,u){let t=this.c.get(v);t||(t=new Set,this.c.set(v,t)),t.add(u)}delete(v,u){const t=this.c.get(v);t&&(t.delete(u),t.size===0&&this.c.delete(v))}forEach(v,u){const t=this.c.get(v);t&&t.forEach(u)}get(v){const u=this.c.get(v);return u||new Set}}e.$Gc=d;function h(g,v){if(g===v)return!0;if(g.size!==v.size)return!1;for(const[u,t]of g)if(!v.has(u)||v.get(u)!==t)return!1;for(const[u]of v)if(!g.has(u))return!1;return!0}e.$Hc=h}),define(oe[2],ae([0,1,23,135,31,84,72]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let f=null;class l{constructor(){this.b=new Map}static{this.a=0}c(j){let W=this.b.get(j);return W||(W={parent:null,source:null,isSingleton:!1,value:j,idx:l.a++},this.b.set(j,W)),W}trackDisposable(j){const W=this.c(j);W.source||(W.source=new Error().stack)}setParent(j,W){const T=this.c(j);T.parent=W}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,W){const T=W.get(j);if(T)return T;const G=j.parent?this.f(this.c(j.parent),W):j;return W.set(j,G),G}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,j).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(j=10,W){let T;if(W)T=W;else{const ue=new Map,Y=[...this.b.values()].filter(H=>H.source!==null&&!this.f(H,ue).isSingleton);if(Y.length===0)return;const Z=new Set(Y.map(H=>H.value));if(T=Y.filter(H=>!(H.parent&&Z.has(H.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function G(ue){function Y(H,L){for(;H.length>0&&L.some(U=>typeof U=="string"?U===H[0]:H[0].match(U));)H.shift()}const Z=ue.source.split(`
`).map(H=>H.trim().replace("at ","")).filter(H=>H!=="");return Y(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const K=new s.$Gc;for(const ue of T){const Y=G(ue);for(let Z=0;Z<=Y.length;Z++)K.add(Y.slice(0,Z).join(`
`),ue)}T.sort((0,P.$7b)(ue=>ue.idx,P.$9b));let le="",re=0;for(const ue of T.slice(0,j)){re++;const Y=G(ue),Z=[];for(let H=0;H<Y.length;H++){let L=Y[H];L=`(shared with ${K.get(Y.slice(0,H+1).join(`
`)).size}/${T.length} leaks) at ${L}`;const V=K.get(Y.slice(0,H).join(`
`)),q=(0,R.$K)([...V].map(te=>G(te)[H]),te=>te);delete q[Y[H]];for(const[te,he]of Object.entries(q))Z.unshift(`    - stacktraces of ${he.length} other leaks continue with ${te}`);Z.unshift(L)}le+=`


==================== Leaking disposable ${re}/${T.length}: ${ue.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return T.length>j&&(le+=`


... and ${T.length-j} more leaking disposables

`),{leaks:T,details:le}}}e.$Ic=l;function y(C){f=C}if(e.$Jc=y,S){const C="__is_disposable_tracked__";y(new class{trackDisposable(j){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[C]||console.log(W)},3e3)}setParent(j,W){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsDisposed(j){if(j&&j!==t.None)try{j[C]=!0}catch{}}markAsSingleton(j){}})}function k(C){return f?.trackDisposable(C),C}e.$Kc=k;function p(C){f?.markAsDisposed(C)}e.$Lc=p;function c(C,j){f?.setParent(C,j)}function b(C,j){if(f)for(const W of C)f.setParent(W,j)}function m(C){return f?.markAsSingleton(C),C}e.$Mc=m;function $(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$Nc=$;function d(C){if(D.Iterable.is(C)){const j=[];for(const W of C)if(W)try{W.dispose()}catch(T){j.push(T)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$Oc=d;function h(C){for(const j of C)$(j)&&j.dispose();return[]}e.$Pc=h;function g(...C){const j=v(()=>d(C));return b(C,j),j}e.$Qc=g;function v(C){const j=k({dispose:(0,M.$db)(()=>{p(j),C()})});return j}e.$Rc=v;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return c(j,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),c(j,null))}}e.$Sc=u;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,k(this),c(this.q,this)}dispose(){p(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}e.$Tc=t;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&c(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&c(j,null),j}}e.$Uc=o;class r{constructor(j){this.a=new o,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(j){let W=j;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,p(this))},this}}e.$Xc=n;class a{constructor(){this.a=new Map}acquire(j,...W){let T=this.a.get(j);T||(T={counter:0,object:this.b(j,...W)},this.a.set(j,T));const{object:G}=T,K=(0,M.$db)(()=>{--T.counter===0&&(this.c(j,T.object),this.a.delete(j))});return T.counter++,{object:G,dispose:K}}}e.$Yc=a;class w{constructor(j){this.a=j}async acquire(j,...W){const T=this.a.acquire(j,...W);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(G){throw T.dispose(),G}}}e.$Zc=w;class A{constructor(j){this.object=j}dispose(){}}e.$1c=A;function I(C){const j=new u;try{C(j)}finally{j.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,W,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(j)?.dispose(),this.a.set(j,W)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(oe[85],ae([0,1,31]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=void 0;const R=new P.$Dc(1e4);function s(l){return f(l,"NFC",R)}e.$El=s;const M=new P.$Dc(1e4);function D(l){return f(l,"NFD",M)}e.$Fl=D;const S=/[^\u0000-\u0080]/;function f(l,y,k){if(!l)return l;const p=k.get(l);if(p)return p;let c;return S.test(l)?c=l.normalize(y):c=l,k.set(l,c),c}e.$Gl=function(){const l=/[\u0300-\u036f]/g;return function(y){return D(y).replace(l,"")}}()}),define(oe[140],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.rot=e.$5l=void 0;function P(S,f,l){return Math.min(Math.max(S,f),l)}e.$5l=P;function R(S,f){return(f+S%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$7l=s;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$8l=M;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$9l=D}),function(){function Q(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(f){M.push(f,Date.now())}function S(){const f=[];for(let l=0;l<M.length;l+=2)f.push({name:M[l],startTime:M[l+1]});return f}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=P(R))}(),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var R in P)(typeof exports=="object"?exports:Q)[R]=P[R]}}(typeof self<"u"?self:this,function(){return function(Q){var e={};function P(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return Q[R].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=Q,P.c=e,P.d=function(R,s,M){P.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:M})},P.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},P.t=function(R,s){if(1&s&&(R=P(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)P.d(M,D,function(S){return R[S]}.bind(null,D));return M},P.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return P.d(s,"a",s),s},P.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},P.p="",P(P.s=0)}([function(Q,e,P){(function(R){var s;e=Q.exports=he,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],l=0,y=l++;f[y]="0|[1-9]\\d*";var k=l++;f[k]="[0-9]+";var p=l++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=l++;f[c]="("+f[y]+")\\.("+f[y]+")\\.("+f[y]+")";var b=l++;f[b]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var m=l++;f[m]="(?:"+f[y]+"|"+f[p]+")";var $=l++;f[$]="(?:"+f[k]+"|"+f[p]+")";var d=l++;f[d]="(?:-("+f[m]+"(?:\\."+f[m]+")*))";var h=l++;f[h]="(?:-?("+f[$]+"(?:\\."+f[$]+")*))";var g=l++;f[g]="[0-9A-Za-z-]+";var v=l++;f[v]="(?:\\+("+f[g]+"(?:\\."+f[g]+")*))";var u=l++,t="v?"+f[c]+f[d]+"?"+f[v]+"?";f[u]="^"+t+"$";var o="[v=\\s]*"+f[b]+f[h]+"?"+f[v]+"?",r=l++;f[r]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[k]+"|x|X|\\*";var a=l++;f[a]=f[y]+"|x|X|\\*";var w=l++;f[w]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[d]+")?"+f[v]+"?)?)?";var A=l++;f[A]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[h]+")?"+f[v]+"?)?)?";var I=l++;f[I]="^"+f[i]+"\\s*"+f[w]+"$";var E=l++;f[E]="^"+f[i]+"\\s*"+f[A]+"$";var C=l++;f[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var j=l++;f[j]="(?:~>?)";var W=l++;f[W]="(\\s*)"+f[j]+"\\s+",S[W]=new RegExp(f[W],"g");var T=l++;f[T]="^"+f[j]+f[w]+"$";var G=l++;f[G]="^"+f[j]+f[A]+"$";var K=l++;f[K]="(?:\\^)";var le=l++;f[le]="(\\s*)"+f[K]+"\\s+",S[le]=new RegExp(f[le],"g");var re=l++;f[re]="^"+f[K]+f[w]+"$";var ue=l++;f[ue]="^"+f[K]+f[A]+"$";var Y=l++;f[Y]="^"+f[i]+"\\s*("+o+")$|^$";var Z=l++;f[Z]="^"+f[i]+"\\s*("+t+")$|^$";var H=l++;f[H]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[w]+")",S[H]=new RegExp(f[H],"g");var L=l++;f[L]="^\\s*("+f[w]+")\\s+-\\s+("+f[w]+")\\s*$";var U=l++;f[U]="^\\s*("+f[A]+")\\s+-\\s+("+f[A]+")\\s*$";var V=l++;f[V]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,f[q]),S[q]||(S[q]=new RegExp(f[q]));function te(ee,fe){if(ee instanceof he)return ee;if(typeof ee!="string"||ee.length>M||!(fe?S[r]:S[u]).test(ee))return null;try{return new he(ee,fe)}catch{return null}}function he(ee,fe){if(ee instanceof he){if(ee.loose===fe)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof he))return new he(ee,fe);s("SemVer",ee,fe),this.loose=fe;var ge=ee.trim().match(fe?S[r]:S[u]);if(!ge)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Me=+Ie;if(Me>=0&&Me<D)return Me}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=te,e.valid=function(ee,fe){var ge=te(ee,fe);return ge?ge.version:null},e.clean=function(ee,fe){var ge=te(ee.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(ee){return s("SemVer.compare",this.version,this.loose,ee),ee instanceof he||(ee=new he(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},he.prototype.compareMain=function(ee){return ee instanceof he||(ee=new he(ee,this.loose)),O(this.major,ee.major)||O(this.minor,ee.minor)||O(this.patch,ee.patch)},he.prototype.comparePre=function(ee){if(ee instanceof he||(ee=new he(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=ee.prerelease[fe];if(s("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return O(ge,Ie)}while(++fe)},he.prototype.inc=function(ee,fe){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new he(ee,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(ee,fe){if(X(ee,fe))return null;var ge=te(ee),Ie=te(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Me in ge)if((Me==="major"||Me==="minor"||Me==="patch")&&ge[Me]!==Ie[Me])return"pre"+Me;return"prerelease"}for(var Me in ge)if((Me==="major"||Me==="minor"||Me==="patch")&&ge[Me]!==Ie[Me])return Me},e.compareIdentifiers=O;var J=/^[0-9]+$/;function O(ee,fe){var ge=J.test(ee),Ie=J.test(fe);return ge&&Ie&&(ee=+ee,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:ee<fe?-1:ee>fe?1:0}function F(ee,fe,ge){return new he(ee,ge).compare(new he(fe,ge))}function x(ee,fe,ge){return F(ee,fe,ge)>0}function z(ee,fe,ge){return F(ee,fe,ge)<0}function X(ee,fe,ge){return F(ee,fe,ge)===0}function N(ee,fe,ge){return F(ee,fe,ge)!==0}function B(ee,fe,ge){return F(ee,fe,ge)>=0}function _(ee,fe,ge){return F(ee,fe,ge)<=0}function ce(ee,fe,ge,Ie){var Me;switch(fe){case"===":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Me=ee===ge;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ge=="object"&&(ge=ge.version),Me=ee!==ge;break;case"":case"=":case"==":Me=X(ee,ge,Ie);break;case"!=":Me=N(ee,ge,Ie);break;case">":Me=x(ee,ge,Ie);break;case">=":Me=B(ee,ge,Ie);break;case"<":Me=z(ee,ge,Ie);break;case"<=":Me=_(ee,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Me}function se(ee,fe){if(ee instanceof se){if(ee.loose===fe)return ee;ee=ee.value}if(!(this instanceof se))return new se(ee,fe);s("comparator",ee,fe),this.loose=fe,this.parse(ee),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(ee,fe){return O(fe,ee)},e.major=function(ee,fe){return new he(ee,fe).major},e.minor=function(ee,fe){return new he(ee,fe).minor},e.patch=function(ee,fe){return new he(ee,fe).patch},e.compare=F,e.compareLoose=function(ee,fe){return F(ee,fe,!0)},e.rcompare=function(ee,fe,ge){return F(fe,ee,ge)},e.sort=function(ee,fe){return ee.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(ee,fe){return ee.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=x,e.lt=z,e.eq=X,e.neq=N,e.gte=B,e.lte=_,e.cmp=ce,e.Comparator=se;var $e={};function me(ee,fe){if(ee instanceof me)return ee.loose===fe?ee:new me(ee.raw,fe);if(ee instanceof se)return new me(ee.value,fe);if(!(this instanceof me))return new me(ee,fe);if(this.loose=fe,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function ye(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function Pe(ee,fe,ge,Ie,Me,We,je,Ke,Be,He,Ve,ie,de){return((fe=ye(ge)?"":ye(Ie)?">="+ge+".0.0":ye(Me)?">="+ge+"."+Ie+".0":">="+fe)+" "+(Ke=ye(Be)?"":ye(He)?"<"+(+Be+1)+".0.0":ye(Ve)?"<"+Be+"."+(+He+1)+".0":ie?"<="+Be+"."+He+"."+Ve+"-"+ie:"<="+Ke)).trim()}function Le(ee,fe){for(var ge=0;ge<ee.length;ge++)if(!ee[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<ee.length;ge++)if(s(ee[ge].semver),ee[ge].semver!==$e&&ee[ge].semver.prerelease.length>0){var Ie=ee[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function ke(ee,fe,ge){try{fe=new me(fe,ge)}catch{return!1}return fe.test(ee)}function pe(ee,fe,ge,Ie){var Me,We,je,Ke,Be;switch(ee=new he(ee,Ie),fe=new me(fe,Ie),ge){case">":Me=x,We=_,je=z,Ke=">",Be=">=";break;case"<":Me=z,We=B,je=x,Ke="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(ee,fe,Ie))return!1;for(var He=0;He<fe.set.length;++He){var Ve=fe.set[He],ie=null,de=null;if(Ve.forEach(function(be){be.semver===$e&&(be=new se(">=0.0.0")),ie=ie||be,de=de||be,Me(be.semver,ie.semver,Ie)?ie=be:je(be.semver,de.semver,Ie)&&(de=be)}),ie.operator===Ke||ie.operator===Be||(!de.operator||de.operator===Ke)&&We(ee,de.semver)||de.operator===Be&&je(ee,de.semver))return!1}return!0}se.prototype.parse=function(ee){var fe=this.loose?S[Y]:S[Z],ge=ee.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+ee);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new he(ge[2],this.loose):this.semver=$e},se.prototype.toString=function(){return this.value},se.prototype.test=function(ee){return s("Comparator.test",ee,this.loose),this.semver===$e||(typeof ee=="string"&&(ee=new he(ee,this.loose)),ce(ee,this.operator,this.semver,this.loose))},se.prototype.intersects=function(ee,fe){if(!(ee instanceof se))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new me(ee.value,fe),ke(this.value,ge,fe);if(ee.operator==="")return ge=new me(this.value,fe),ke(ee.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),Me=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),We=this.semver.version===ee.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Ke=ce(this.semver,"<",ee.semver,fe)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),Be=ce(this.semver,">",ee.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return Ie||Me||We&&je||Ke||Be},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(ee){var fe=this.loose;ee=ee.trim(),s("range",ee,fe);var ge=fe?S[U]:S[L];ee=ee.replace(ge,Pe),s("hyphen replace",ee),ee=ee.replace(S[H],"$1$2$3"),s("comparator trim",ee,S[H]),ee=(ee=(ee=ee.replace(S[W],"$1~")).replace(S[le],"$1^")).split(/\s+/).join(" ");var Ie=fe?S[Y]:S[Z],Me=ee.split(" ").map(function(We){return function(je,Ke){return s("comp",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){s("caret",ie,de);var be=de?S[ue]:S[re];return ie.replace(be,function(Se,ve,Re,Ue,qe){var Qe;return s("caret",ie,Se,ve,Re,Ue,qe),ye(ve)?Qe="":ye(Re)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Ue)?Qe=ve==="0"?">="+ve+"."+Re+".0 <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+".0 <"+(+ve+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=ve==="0"?Re==="0"?">="+ve+"."+Re+"."+Ue+qe+" <"+ve+"."+Re+"."+(+Ue+1):">="+ve+"."+Re+"."+Ue+qe+" <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+"."+Ue+qe+" <"+(+ve+1)+".0.0"):(s("no pr"),Qe=ve==="0"?Re==="0"?">="+ve+"."+Re+"."+Ue+" <"+ve+"."+Re+"."+(+Ue+1):">="+ve+"."+Re+"."+Ue+" <"+ve+"."+(+Re+1)+".0":">="+ve+"."+Re+"."+Ue+" <"+(+ve+1)+".0.0"),s("caret return",Qe),Qe})}(Ve,He)}).join(" ")}(je,Ke),s("caret",je),je=function(Be,He){return Be.trim().split(/\s+/).map(function(Ve){return function(ie,de){var be=de?S[G]:S[T];return ie.replace(be,function(Se,ve,Re,Ue,qe){var Qe;return s("tilde",ie,Se,ve,Re,Ue,qe),ye(ve)?Qe="":ye(Re)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Ue)?Qe=">="+ve+"."+Re+".0 <"+ve+"."+(+Re+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=">="+ve+"."+Re+"."+Ue+qe+" <"+ve+"."+(+Re+1)+".0"):Qe=">="+ve+"."+Re+"."+Ue+" <"+ve+"."+(+Re+1)+".0",s("tilde return",Qe),Qe})}(Ve,He)}).join(" ")}(je,Ke),s("tildes",je),je=function(Be,He){return s("replaceXRanges",Be,He),Be.split(/\s+/).map(function(Ve){return function(ie,de){ie=ie.trim();var be=de?S[E]:S[I];return ie.replace(be,function(Se,ve,Re,Ue,qe,Qe){s("xRange",ie,Se,ve,Re,Ue,qe,Qe);var xe=ye(Re),Ze=xe||ye(Ue),Xe=Ze||ye(qe);return ve==="="&&Xe&&(ve=""),xe?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Xe?(Ze&&(Ue=0),Xe&&(qe=0),ve===">"?(ve=">=",Ze?(Re=+Re+1,Ue=0,qe=0):Xe&&(Ue=+Ue+1,qe=0)):ve==="<="&&(ve="<",Ze?Re=+Re+1:Ue=+Ue+1),Se=ve+Re+"."+Ue+"."+qe):Ze?Se=">="+Re+".0.0 <"+(+Re+1)+".0.0":Xe&&(Se=">="+Re+"."+Ue+".0 <"+Re+"."+(+Ue+1)+".0"),s("xRange return",Se),Se})}(Ve,He)}).join(" ")}(je,Ke),s("xrange",je),je=function(Be,He){return s("replaceStars",Be,He),Be.trim().replace(S[V],"")}(je,Ke),s("stars",je),je}(We,fe)}).join(" ").split(/\s+/);return this.loose&&(Me=Me.filter(function(We){return!!We.match(Ie)})),Me=Me.map(function(We){return new se(We,fe)})},me.prototype.intersects=function(ee,fe){if(!(ee instanceof me))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return ee.set.some(function(Me){return Me.every(function(We){return Ie.intersects(We,fe)})})})})},e.toComparators=function(ee,fe){return new me(ee,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},me.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new he(ee,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],ee))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(ee,fe,ge){var Ie=null,Me=null;try{var We=new me(fe,ge)}catch{return null}return ee.forEach(function(je){We.test(je)&&(Ie&&Me.compare(je)!==-1||(Me=new he(Ie=je,ge)))}),Ie},e.minSatisfying=function(ee,fe,ge){var Ie=null,Me=null;try{var We=new me(fe,ge)}catch{return null}return ee.forEach(function(je){We.test(je)&&(Ie&&Me.compare(je)!==1||(Me=new he(Ie=je,ge)))}),Ie},e.validRange=function(ee,fe){try{return new me(ee,fe).range||"*"}catch{return null}},e.ltr=function(ee,fe,ge){return pe(ee,fe,"<",ge)},e.gtr=function(ee,fe,ge){return pe(ee,fe,">",ge)},e.outside=pe,e.prerelease=function(ee,fe){var ge=te(ee,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(ee,fe,ge){return ee=new me(ee,ge),fe=new me(fe,ge),ee.intersects(fe)},e.coerce=function(ee){if(ee instanceof he)return ee;if(typeof ee!="string")return null;var fe=ee.match(S[C]);return fe==null?null:te((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(Q,e){var P,R,s=Q.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S($){if(P===setTimeout)return setTimeout($,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout($,0);try{return P($,0)}catch{try{return P.call(null,$,0)}catch{return P.call(this,$,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var f,l=[],y=!1,k=-1;function p(){y&&f&&(y=!1,f.length?l=f.concat(l):k=-1,l.length&&c())}function c(){if(!y){var $=S(p);y=!0;for(var d=l.length;d;){for(f=l,l=[];++k<d;)f&&f[k].run();k=-1,d=l.length}f=null,y=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}($)}}function b($,d){this.fun=$,this.array=d}function m(){}s.nextTick=function($){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];l.push(new b($,d)),l.length!==1||y||S(c)},b.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=m,s.addListener=m,s.once=m,s.off=m,s.removeListener=m,s.removeAllListeners=m,s.emit=m,s.prependListener=m,s.prependOnceListener=m,s.listeners=function($){return[]},s.binding=function($){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function($){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(oe[141],ae([0,1]),function(Q,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;class R{constructor(S,f,l){this.level=S,this.key=f,this.value=l,this.forward=[]}}const s=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let l=this.e.forward[0];for(;l;)S.call(f,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,l){let y=S.e;for(let k=S.d-1;k>=0;k--)for(;y.forward[k]&&l(y.forward[k].key,f)<0;)y=y.forward[k];if(y=y.forward[0],y&&l(y.key,f)===0)return y}static h(S,f,l,y){const k=[];let p=S.e;for(let c=S.d-1;c>=0;c--){for(;p.forward[c]&&y(p.forward[c].key,f)<0;)p=p.forward[c];k[c]=p}if(p=p.forward[0],p&&y(p.key,f)===0)return p.value=l,!1;{const c=M.j(S);if(c>S.d){for(let b=S.d;b<c;b++)k[b]=S.e;S.d=c}p=new R(c,f,l);for(let b=0;b<c;b++)p.forward[b]=k[b].forward[b],k[b].forward[b]=p;return!0}}static j(S,f=.5){let l=1;for(;Math.random()<f&&l<S.c;)l+=1;return l}static k(S,f,l){const y=[];let k=S.e;for(let p=S.d-1;p>=0;p--){for(;k.forward[p]&&l(k.forward[p].key,f)<0;)k=k.forward[p];y[p]=k}if(k=k.forward[0],!k||l(k.key,f)!==0)return!1;for(let p=0;p<S.d&&y[p].forward[p]===k;p++)y[p].forward[p]=k.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$Pr=M}),define(oe[73],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(M){return new R(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Pd=R}),define(oe[3],ae([0,1,14,84,2,101,73]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.Event=void 0;const S=!1,f=!1;var l;(function(I){I.None=()=>s.$Tc.None;function E(ce){if(f){const{onDidAddListener:se}=ce,$e=b.create();let me=0;ce.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),$e.print()),se?.()}}}function C(ce,se){return Z(ce,()=>{},0,void 0,!0,void 0,se)}I.defer=C;function j(ce){return(se,$e=null,me)=>{let ye=!1,Pe;return Pe=ce(Le=>{if(!ye)return Pe?Pe.dispose():ye=!0,se.call($e,Le)},null,me),ye&&Pe.dispose(),Pe}}I.once=j;function W(ce,se,$e){return ue((me,ye=null,Pe)=>ce(Le=>me.call(ye,se(Le)),null,Pe),$e)}I.map=W;function T(ce,se,$e){return ue((me,ye=null,Pe)=>ce(Le=>{se(Le),me.call(ye,Le)},null,Pe),$e)}I.forEach=T;function G(ce,se,$e){return ue((me,ye=null,Pe)=>ce(Le=>se(Le)&&me.call(ye,Le),null,Pe),$e)}I.filter=G;function K(ce){return ce}I.signal=K;function le(...ce){return(se,$e=null,me)=>{const ye=(0,s.$Qc)(...ce.map(Pe=>Pe(Le=>se.call($e,Le))));return Y(ye,me)}}I.any=le;function re(ce,se,$e,me){let ye=$e;return W(ce,Pe=>(ye=se(ye,Pe),ye),me)}I.reduce=re;function ue(ce,se){let $e;const me={onWillAddFirstListener(){$e=ce(ye.fire,ye)},onDidRemoveLastListener(){$e?.dispose()}};se||E(me);const ye=new g(me);return se?.add(ye),ye.event}function Y(ce,se){return se instanceof Array?se.push(ce):se&&se.add(ce),ce}function Z(ce,se,$e=100,me=!1,ye=!1,Pe,Le){let ke,pe,ee,fe=0,ge;const Ie={leakWarningThreshold:Pe,onWillAddFirstListener(){ke=ce(We=>{fe++,pe=se(pe,We),me&&!ee&&(Me.fire(pe),pe=void 0),ge=()=>{const je=pe;pe=void 0,ee=void 0,(!me||fe>1)&&Me.fire(je),fe=0},typeof $e=="number"?(clearTimeout(ee),ee=setTimeout(ge,$e)):ee===void 0&&(ee=0,queueMicrotask(ge))})},onWillRemoveListener(){ye&&fe>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,ke.dispose()}};Le||E(Ie);const Me=new g(Ie);return Le?.add(Me),Me.event}I.debounce=Z;function H(ce,se=0,$e){return I.debounce(ce,(me,ye)=>me?(me.push(ye),me):[ye],se,void 0,!0,void 0,$e)}I.accumulate=H;function L(ce,se=(me,ye)=>me===ye,$e){let me=!0,ye;return G(ce,Pe=>{const Le=me||!se(Pe,ye);return me=!1,ye=Pe,Le},$e)}I.latch=L;function U(ce,se,$e){return[I.filter(ce,se,$e),I.filter(ce,me=>!se(me),$e)]}I.split=U;function V(ce,se=!1,$e=[],me){let ye=$e.slice(),Pe=ce(pe=>{ye?ye.push(pe):ke.fire(pe)});me&&me.add(Pe);const Le=()=>{ye?.forEach(pe=>ke.fire(pe)),ye=null},ke=new g({onWillAddFirstListener(){Pe||(Pe=ce(pe=>ke.fire(pe)),me&&me.add(Pe))},onDidAddFirstListener(){ye&&(se?setTimeout(Le):Le())},onDidRemoveLastListener(){Pe&&Pe.dispose(),Pe=null}});return me&&me.add(ke),ke.event}I.buffer=V;function q(ce,se){return(me,ye,Pe)=>{const Le=se(new he);return ce(function(ke){const pe=Le.evaluate(ke);pe!==te&&me.call(ye,pe)},void 0,Pe)}}I.chain=q;const te=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(se){return this.f.push(se),this}forEach(se){return this.f.push($e=>(se($e),$e)),this}filter(se){return this.f.push($e=>se($e)?$e:te),this}reduce(se,$e){let me=$e;return this.f.push(ye=>(me=se(me,ye),me)),this}latch(se=($e,me)=>$e===me){let $e=!0,me;return this.f.push(ye=>{const Pe=$e||!se(ye,me);return $e=!1,me=ye,Pe?ye:te}),this}evaluate(se){for(const $e of this.f)if(se=$e(se),se===te)break;return se}}function J(ce,se,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ce.on(se,me),Pe=()=>ce.removeListener(se,me),Le=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromNodeEventEmitter=J;function O(ce,se,$e=me=>me){const me=(...ke)=>Le.fire($e(...ke)),ye=()=>ce.addEventListener(se,me),Pe=()=>ce.removeEventListener(se,me),Le=new g({onWillAddFirstListener:ye,onDidRemoveLastListener:Pe});return Le.event}I.fromDOMEventEmitter=O;function F(ce){return new Promise(se=>j(ce)(se))}I.toPromise=F;function x(ce){const se=new g;return ce.then($e=>{se.fire($e)},()=>{se.fire(void 0)}).finally(()=>{se.dispose()}),se.event}I.fromPromise=x;function z(ce,se,$e){return se($e),ce(me=>se(me))}I.runAndSubscribe=z;function X(ce,se){let $e=null;function me(Pe){$e?.dispose(),$e=new s.$Sc,se(Pe,$e)}me(void 0);const ye=ce(Pe=>me(Pe));return(0,s.$Rc)(()=>{ye.dispose(),$e?.dispose()})}I.runAndSubscribeWithStore=X;class N{constructor(se,$e){this._observable=se,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{se.addObserver(this)},onDidRemoveLastListener:()=>{se.removeObserver(this)}};$e||E(me),this.emitter=new g(me),$e&&$e.add(this.emitter)}beginUpdate(se){this.f++}handlePossibleChange(se){}handleChange(se,$e){this.g=!0}endUpdate(se){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function B(ce,se){return new N(ce,se).emitter.event}I.fromObservable=B;function _(ce){return(se,$e,me)=>{let ye=0,Pe=!1;const Le={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(ce.reportChanges(),Pe&&(Pe=!1,se.call($e)))},handlePossibleChange(){},handleChange(){Pe=!0}};ce.addObserver(Le),ce.reportChanges();const ke={dispose(){ce.removeObserver(Le)}};return me instanceof s.$Sc?me.add(ke):Array.isArray(me)&&me.push(ke),ke}}I.fromObservableLight=_})(l||(e.Event=l={}));class y{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${y.f++}`,y.all.add(this)}start(E){this.g=new D.$Pd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Rd=y;let k=-1;function p(I){const E=k;return k=I,{dispose(){k=E}}}e.$Sd=p;class c{constructor(E,C=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=C,this.g=0}dispose(){this.f?.clear()}check(E,C){const j=this.threshold;if(j<=0||C<j)return;this.f||(this.f=new Map);const W=this.f.get(E.value)||0;if(this.f.set(E.value,W+1),this.g-=1,this.g<=0){this.g=j*.5;let T,G=0;for(const[K,le]of this.f)(!T||G<le)&&(T=K,G=le);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${G}):`),console.warn(T)}return()=>{const T=this.f.get(E.value)||0;this.f.set(E.value,T-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class ${constructor(E){this.value=E,this.id=m++}}const d=2,h=(I,E)=>{if(I instanceof $)E(I);else for(let C=0;C<I.length;C++){const j=I[C];j&&E(j)}};class g{constructor(E){this.w=0,this.f=E,this.g=k>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{h(E,C=>C.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,C,j)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;C&&(E=E.bind(C));const W=new $(E);let T,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(W.stack=b.create(),T=this.g.check(W.stack,this.w+1)),S&&(W.stack=G??b.create()),this.t?this.t instanceof $?(this.u??=new u,this.t=[this.t,W]):this.t.push(W):(this.f?.onWillAddFirstListener?.(this),this.t=W,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,s.$Rc)(()=>{T?.(),this.x(W)});return j instanceof s.$Sc?j.add(K):Array.isArray(j)&&j.push(K),K},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const C=this.t,j=C.indexOf(E);if(j===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,C[j]=void 0;const W=this.u.current===this;if(this.w*d<=C.length){let T=0;for(let G=0;G<C.length;G++)C[G]?C[T++]=C[G]:W&&(this.u.end--,T<this.u.i&&this.u.i--);C.length=T}}y(E,C){if(!E)return;const j=this.f?.onListenerError||P.$1;if(!j){E.value(C);return}try{E.value(C)}catch(W){j(W)}}z(E){const C=E.current.t;for(;E.i<E.end;)this.y(C[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,E);else{const C=this.u;C.enqueue(this,E,this.t.length),this.z(C)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Td=g;const v=()=>new u;e.$Ud=v;class u{constructor(){this.i=-1,this.end=0}enqueue(E,C,j){this.i=0,this.end=j,this.current=E,this.value=C}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends g{async fireAsync(E,C,j){if(this.t)for(this.h||(this.h=new M.$4c),h(this.t,W=>this.h.push([W.value,E]));this.h.size>0&&!C.isCancellationRequested;){const[W,T]=this.h.shift(),G=[],K={...T,token:C,waitUntil:le=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");j&&(le=j(le,W)),G.push(le)}};try{W(K)}catch(le){(0,P.$1)(le);continue}Object.freeze(G),await Promise.allSettled(G).then(le=>{for(const re of le)re.status==="rejected"&&(0,P.$1)(re.reason)})}}}e.$Vd=t;class o extends g{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new M.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Wd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Xd=r;class i extends g{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(C=>super.fire(C)),this.h=[]}))}}e.$Yd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new g({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const C={event:E,listener:null};this.h.push(C),this.g&&this.m(C);const j=()=>{this.g&&this.o(C);const W=this.h.indexOf(C);this.h.splice(W,1)};return(0,s.$Rc)((0,R.$db)(j))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(C=>this.f.fire(C))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$Zd=n;class a{constructor(E,C,j,W){this.f=new s.$Sc;const T=this.f.add(new n),G=this.f.add(new s.$3c);function K(le){G.set(le,T.add(W(le)))}for(const le of E)K(le);this.f.add(C(le=>{K(le)})),this.f.add(j(le=>{G.deleteAndDispose(le)})),this.event=T.event}dispose(){this.f.dispose()}}e.$1d=a;class w{constructor(){this.f=[]}wrapEvent(E){return(C,j,W)=>E(T=>{const G=this.f[this.f.length-1];G?G.push(()=>C.call(j,T)):C.call(j,T)},void 0,W)}bufferEvents(E){const C=[];this.f.push(C);const j=E();return this.f.pop(),C.forEach(W=>W()),j}}e.$2d=w;class A{constructor(){this.f=!1,this.g=l.None,this.h=s.$Tc.None,this.j=new g({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$3d=A}),define(oe[22],ae([0,1,3]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.CancellationToken=void 0;const R=Object.freeze(function(S,f){const l=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function f(l){return l===S.None||l===S.Cancelled||l instanceof M?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new P.$Td),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$4d=D}),define(oe[142],ae([0,1,22]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=void 0;class R{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$4d,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Ce=R;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$De=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$Ee=M}),define(oe[63],ae([0,1,14,2]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;function s(v){const u=v;return u?typeof u.read=="function":!1}e.$5d=s;function M(v){const u=v;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$6d=M;function D(v){const u=v;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$7d=D;function S(v,u){return new f(v,u)}e.$8d=S;class f{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let o;switch(u){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(v,u){const t=[];let o;for(;(o=v.read())!==null;)t.push(o);return u(t)}e.$9d=l;function y(v,u,t){const o=[];let r;for(;(r=v.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?u(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return v.read()}}}e.$0d=y;function k(v,u){return new Promise((t,o)=>{const r=[];p(v,{onData:i=>{u&&r.push(i)},onError:i=>{u?o(i):t(void 0)},onEnd:()=>{t(u?u(r):void 0)}})})}e.$$d=k;function p(v,u,t){v.on("error",o=>{t?.isCancellationRequested||u.onError(o)}),v.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),v.on("data",o=>{t?.isCancellationRequested||u.onData(o)})}e.$_d=p;function c(v,u){return new Promise((t,o)=>{const r=new R.$Sc,i=[],n=A=>{if(i.push(A),i.length>u)return r.dispose(),v.pause(),t({stream:v,buffer:i,ended:!1})},a=A=>(r.dispose(),o(A)),w=()=>(r.dispose(),t({stream:v,buffer:i,ended:!0}));r.add((0,R.$Rc)(()=>v.removeListener("error",a))),v.on("error",a),r.add((0,R.$Rc)(()=>v.removeListener("end",w))),v.on("end",w),r.add((0,R.$Rc)(()=>v.removeListener("data",n))),v.on("data",n)})}e.$ae=c;function b(v,u){const t=S(u);return t.end(v),t}e.$be=b;function m(){const v=S(()=>{throw new Error("not supported")});return v.end(),v}e.$ce=m;function $(v){let u=!1;return{read:()=>u?null:(u=!0,v)}}e.$de=$;function d(v,u,t){const o=S(t);return p(v,{onData:r=>o.write(u.data(r)),onError:r=>o.error(u.error?u.error(r):r),onEnd:()=>o.end()}),o}e.$ee=d;function h(v,u,t){let o=!1;return{read:()=>{const r=u.read();return o?r:(o=!0,r!==null?t([v,r]):v)}}}e.$fe=h;function g(v,u,t){let o=!1;const r=S(t);return p(u,{onData:i=>o?r.write(i):(o=!0,r.write(t([v,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(v)),r.end()}}),r}e.$ge=g}),define(oe[18],ae([0,1,62,63]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=void 0;const s=typeof Buffer<"u",M=new P.$V(()=>new Uint8Array(256));let D,S;class f{static alloc(C){return s?new f(Buffer.allocUnsafe(C)):new f(new Uint8Array(C))}static wrap(C){return s&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new f(C)}static fromString(C,j){return!(j?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(C)):(D||(D=new TextEncoder),new f(D.encode(C)))}static fromByteArray(C){const j=f.alloc(C.length);for(let W=0,T=C.length;W<T;W++)j.buffer[W]=C[W];return j}static concat(C,j){if(typeof j>"u"){j=0;for(let G=0,K=C.length;G<K;G++)j+=C[G].byteLength}const W=f.alloc(j);let T=0;for(let G=0,K=C.length;G<K;G++){const le=C[G];W.set(le,T),T+=le.byteLength}return W}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=f.alloc(this.byteLength);return C.set(this),C}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(C,j){return new f(this.buffer.subarray(C,j))}set(C,j){if(C instanceof f)this.buffer.set(C.buffer,j);else if(C instanceof Uint8Array)this.buffer.set(C,j);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),j);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return p(this.buffer,C)}writeUInt32BE(C,j){c(this.buffer,C,j)}readUInt32LE(C){return b(this.buffer,C)}writeUInt32LE(C,j){m(this.buffer,C,j)}readUInt8(C){return $(this.buffer,C)}writeUInt8(C,j){d(this.buffer,C,j)}indexOf(C,j=0){return l(this.buffer,C instanceof f?C.buffer:C,j)}}e.$he=f;function l(E,C,j=0){const W=C.byteLength,T=E.byteLength;if(W===0)return 0;if(W===1)return E.indexOf(C[0]);if(W>T-j)return-1;const G=M.value;G.fill(C.length);for(let ue=0;ue<C.length;ue++)G[C[ue]]=C.length-ue-1;let K=j+C.length-1,le=K,re=-1;for(;K<T;)if(E[K]===C[le]){if(le===0){re=K;break}K--,le--}else K+=Math.max(C.length-le,G[E[K]]),le=C.length-1;return re}e.$ie=l;function y(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0}e.$je=y;function k(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255}e.$ke=k;function p(E,C){return E[C]*2**24+E[C+1]*2**16+E[C+2]*2**8+E[C+3]}e.$le=p;function c(E,C,j){E[j+3]=C,C=C>>>8,E[j+2]=C,C=C>>>8,E[j+1]=C,C=C>>>8,E[j]=C}e.$me=c;function b(E,C){return E[C+0]<<0>>>0|E[C+1]<<8>>>0|E[C+2]<<16>>>0|E[C+3]<<24>>>0}e.$ne=b;function m(E,C,j){E[j+0]=C&255,C=C>>>8,E[j+1]=C&255,C=C>>>8,E[j+2]=C&255,C=C>>>8,E[j+3]=C&255}e.$oe=m;function $(E,C){return E[C]}e.$pe=$;function d(E,C,j){E[j]=C}e.$qe=d;function h(E){return R.$9d(E,C=>f.concat(C))}e.$re=h;function g(E){return R.$de(E)}e.$se=g;function v(E){return R.$$d(E,C=>f.concat(C))}e.$te=v;async function u(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await v(E.stream)])}e.$ue=u;function t(E){return R.$be(E,C=>f.concat(C))}e.$ve=t;function o(E){return R.$ee(E,{data:C=>typeof C=="string"?f.fromString(C):f.wrap(C)},C=>f.concat(C))}e.$we=o;function r(E){return R.$8d(C=>f.concat(C),E)}e.$xe=r;function i(E,C){return R.$fe(E,C,j=>f.concat(j))}e.$ye=i;function n(E,C){return R.$ge(E,C,j=>f.concat(j))}e.$ze=n;function a(E){let C=0,j=0,W=0;const T=new Uint8Array(Math.floor(E.length/4*3)),G=le=>{switch(j){case 3:T[W++]=C|le,j=0;break;case 2:T[W++]=C|le>>>2,C=le<<6,j=3;break;case 1:T[W++]=C|le>>>4,C=le<<4,j=2;break;default:C=le<<2,j=1}};for(let le=0;le<E.length;le++){const re=E.charCodeAt(le);if(re>=65&&re<=90)G(re-65);else if(re>=97&&re<=122)G(re-97+26);else if(re>=48&&re<=57)G(re-48+52);else if(re===43||re===45)G(62);else if(re===47||re===95)G(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[le]}`)}}const K=W;for(;j>0;)G(0);return f.wrap(T).slice(0,K)}e.$Ae=a;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},C=!0,j=!1){const W=j?A:w;let T="";const G=E.byteLength%3;let K=0;for(;K<E.byteLength-G;K+=3){const le=E[K+0],re=E[K+1],ue=E[K+2];T+=W[le>>>2],T+=W[(le<<4|re>>>4)&63],T+=W[(re<<2|ue>>>6)&63],T+=W[ue&63]}if(G===1){const le=E[K+0];T+=W[le>>>2],T+=W[le<<4&63],C&&(T+="==")}else if(G===2){const le=E[K+0],re=E[K+1];T+=W[le>>>2],T+=W[(le<<4|re>>>4)&63],T+=W[re<<2&63],C&&(T+="=")}return T}e.$Be=I}),define(oe[25],ae([0,1,142,62]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ff=e.$Ef=e.$Df=e.$Cf=e.GraphemeBreakType=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$He=s;const M=/{(\d+)}/g;function D(ie,...de){return de.length===0?ie:ie.replace(M,function(be,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=de.length?be:de[ve]})}e.$Ie=D;const S=/{([^}]+)}/g;function f(ie,de){return Object.keys(de).length===0?ie:ie.replace(S,(be,Se)=>de[Se]??be)}e.$Je=f;function l(ie){return ie.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.$Ke=l;function y(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Le=y;function k(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Me=k;function p(ie,de){let be=0;const Se=de.charCodeAt(0);for(let ve=ie.length-1;ve>=0;ve--)ie.charCodeAt(ve)===Se&&be++;return be}e.$Ne=p;function c(ie,de,be="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${be}`}e.$Oe=c;function b(ie,de,be="\u2026"){if(ie.length<=de)return ie;const Se=Math.ceil(de/2)-be.length/2,ve=Math.floor(de/2)-be.length/2;return`${ie.substr(0,Se)}${be}${ie.substr(ie.length-ve)}`}e.$Pe=b;function m(ie,de=" "){const be=$(ie,de);return d(be,de)}e.$Qe=m;function $(ie,de){if(!ie||!de)return ie;const be=de.length;if(be===0||ie.length===0)return ie;let Se=0;for(;ie.indexOf(de,Se)===Se;)Se=Se+be;return ie.substring(Se)}e.$Re=$;function d(ie,de){if(!ie||!de)return ie;const be=de.length,Se=ie.length;if(be===0||Se===0)return ie;let ve=Se,Re=-1;for(;Re=ie.lastIndexOf(de,ve-1),!(Re===-1||Re+be!==ve);){if(Re===0)return"";ve=Re}return ie.substring(0,ve)}e.$Se=d;function h(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Te=h;function g(ie){return ie.replace(/\*/g,"")}e.$Ue=g;function v(ie,de,be={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=k(ie)),be.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Se="";return be.global&&(Se+="g"),be.matchCase||(Se+="i"),be.multiline&&(Se+="m"),be.unicode&&(Se+="u"),new RegExp(ie,Se)}e.$Ve=v;function u(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$We=u;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$Xe=t;function o(ie){for(let de=0,be=ie.length;de<be;de++){const Se=ie.charCodeAt(de);if(Se!==32&&Se!==9)return de}return-1}e.$Ye=o;function r(ie,de=0,be=ie.length){for(let Se=de;Se<be;Se++){const ve=ie.charCodeAt(Se);if(ve!==32&&ve!==9)return ie.substring(de,Se)}return ie.substring(de,be)}e.$Ze=r;function i(ie,de=ie.length-1){for(let be=de;be>=0;be--){const Se=ie.charCodeAt(be);if(Se!==32&&Se!==9)return be}return-1}e.$1e=i;function n(ie,de,be){const Se=[];let ve=0;for(const Re of ie.matchAll(de)){if(Se.push(ie.slice(ve,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ve=Re.index+Re[0].length,Se.push(be(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return Se.push(ie.slice(ve)),Promise.all(Se).then(Re=>Re.join(""))}e.$2e=n;function a(ie,de){return ie<de?-1:ie>de?1:0}e.$3e=a;function w(ie,de,be=0,Se=ie.length,ve=0,Re=de.length){for(;be<Se&&ve<Re;be++,ve++){const Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe<xe)return-1;if(Qe>xe)return 1}const Ue=Se-be,qe=Re-ve;return Ue<qe?-1:Ue>qe?1:0}e.$4e=w;function A(ie,de){return I(ie,de,0,ie.length,0,de.length)}e.$5e=A;function I(ie,de,be=0,Se=ie.length,ve=0,Re=de.length){for(;be<Se&&ve<Re;be++,ve++){let Qe=ie.charCodeAt(be),xe=de.charCodeAt(ve);if(Qe===xe)continue;if(Qe>=128||xe>=128)return w(ie.toLowerCase(),de.toLowerCase(),be,Se,ve,Re);C(Qe)&&(Qe-=32),C(xe)&&(xe-=32);const Ze=Qe-xe;if(Ze!==0)return Ze}const Ue=Se-be,qe=Re-ve;return Ue<qe?-1:Ue>qe?1:0}e.$6e=I;function E(ie){return ie>=48&&ie<=57}e.$7e=E;function C(ie){return ie>=97&&ie<=122}e.$8e=C;function j(ie){return ie>=65&&ie<=90}e.$9e=j;function W(ie,de){return ie.length===de.length&&I(ie,de)===0}e.$0e=W;function T(ie,de){const be=de.length;return de.length>ie.length?!1:I(ie,de,0,be)===0}e.$$e=T;function G(ie,de){const be=Math.min(ie.length,de.length);let Se;for(Se=0;Se<be;Se++)if(ie.charCodeAt(Se)!==de.charCodeAt(Se))return Se;return be}e.$_e=G;function K(ie,de){const be=Math.min(ie.length,de.length);let Se;const ve=ie.length-1,Re=de.length-1;for(Se=0;Se<be;Se++)if(ie.charCodeAt(ve-Se)!==de.charCodeAt(Re-Se))return Se;return be}e.$af=K;function le(ie){return 55296<=ie&&ie<=56319}e.$bf=le;function re(ie){return 56320<=ie&&ie<=57343}e.$cf=re;function ue(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.$df=ue;function Y(ie,de,be){const Se=ie.charCodeAt(be);if(le(Se)&&be+1<de){const ve=ie.charCodeAt(be+1);if(re(ve))return ue(Se,ve)}return Se}e.$ef=Y;function Z(ie,de){const be=ie.charCodeAt(de-1);if(re(be)&&de>1){const Se=ie.charCodeAt(de-2);if(le(Se))return ue(Se,be)}return be}class H{get offset(){return this.e}constructor(de,be=0){this.c=de,this.d=de.length,this.e=be}setOffset(de){this.e=de}prevCodePoint(){const de=Z(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=Y(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$ff=H;class L{get offset(){return this.c.offset}constructor(de,be=0){this.c=new H(de,be)}nextGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,Ue=de.getGraphemeBreakType(be.nextCodePoint());if(fe(ve,Ue)){be.setOffset(Re);break}ve=Ue}return be.offset-Se}prevGraphemeLength(){const de=Ie.getInstance(),be=this.c,Se=be.offset;let ve=de.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,Ue=de.getGraphemeBreakType(be.prevCodePoint());if(fe(Ue,ve)){be.setOffset(Re);break}ve=Ue}return Se-be.offset}eol(){return this.c.eol()}}e.$gf=L;function U(ie,de){return new L(ie,de).nextGraphemeLength()}e.$hf=U;function V(ie,de){return new L(ie,de).prevGraphemeLength()}e.$if=V;function q(ie,de){de>0&&re(ie.charCodeAt(de))&&de--;const be=de+U(ie,de);return[be-V(ie,be),be]}e.$jf=q;function te(ie){const de=new L(ie);let be=0;for(;!de.eol();)be++,de.nextGraphemeLength();return be}e.$kf=te;let he;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(ie){return he||(he=J()),he.test(ie)}e.$lf=O;const F=/^[\t\n\r\x20-\x7E]*$/;function x(ie){return F.test(ie)}e.$mf=x,e.$nf=/[\u2028\u2029]/;function z(ie){return e.$nf.test(ie)}e.$of=z;function X(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$pf=X;function N(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$qf=N;function B(ie,de,be=""){const Se=ie.trimStart();if(Se.length<de)return Se;const ve=/\b/g;let Re=0;for(;ve.test(Se)&&!(Se.length-ve.lastIndex<de);)Re=ve.lastIndex,ve.lastIndex+=1;return Re===0?Se:be+Se.substring(Re).trimStart()}e.$rf=B;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function se(ie){return ie&&(ie=ie.replace(_,"").replace(ce,"")),ie}e.$sf=se,e.$tf=String.fromCharCode(65279);function $e(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$uf=$e;function me(ie){return $e(ie)?ie.substr(1):ie}e.$vf=me;function ye(ie,de){if(!ie||!de||ie.length<de.length)return!1;const be=de.length,Se=ie.toLowerCase();let ve=0,Re=-1;for(;ve<be;){const Ue=Se.indexOf(de[ve],Re+1);if(Ue<0)return!1;Re=Ue,ve++}return!0}e.$wf=ye;function Pe(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$xf=Pe;function Le(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$yf=Le;function ke(ie,de=1){if(de===0)return"";let be=-1;do be=ie.indexOf(`
`,be+1),de--;while(de>0&&be>=0);return be===-1?ie:(ie[be-1]==="\r"&&be--,ie.substr(0,be))}e.$zf=ke;function pe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$Af=pe;function ee(ie){return Ie.getInstance().getGraphemeBreakType(ie)}e.$Bf=ee;function fe(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var ge;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})(ge||(e.GraphemeBreakType=ge={}));class Ie{static{this.c=null}static getInstance(){return Ie.c||(Ie.c=new Ie),Ie.c}constructor(){this.d=Me()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const be=this.d,Se=be.length/3;let ve=1;for(;ve<=Se;)if(de<be[3*ve])ve=2*ve;else if(de>be[3*ve+1])ve=2*ve+1;else return be[3*ve+2];return 0}}function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(ie,de){if(ie===0)return 0;const be=je(ie,de);if(be!==void 0)return be;const Se=new H(de,ie);return Se.prevCodePoint(),Se.offset}e.$Cf=We;function je(ie,de){const be=new H(de,ie);let Se=be.prevCodePoint();for(;Ke(Se)||Se===65039||Se===8419;){if(be.offset===0)return;Se=be.prevCodePoint()}if(!N(Se))return;let ve=be.offset;return ve>0&&be.prevCodePoint()===8205&&(ve=be.offset),ve}function Ke(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Df="\xA0";class He{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$De(de=>{function be(Ze){const Xe=new Map;for(let nt=0;nt<Ze.length;nt+=2)Xe.set(Ze[nt],Ze[nt+1]);return Xe}function Se(Ze,Xe){const nt=new Map(Ze);for(const[st,ot]of Xe)nt.set(st,ot);return nt}function ve(Ze,Xe){if(!Ze)return Xe;const nt=new Map;for(const[st,ot]of Ze)Xe.has(st)&&nt.set(st,ot);return nt}const Re=this.c.value;let Ue=de.filter(Ze=>!Ze.startsWith("_")&&Ze in Re);Ue.length===0&&(Ue=["_default"]);let qe;for(const Ze of Ue){const Xe=be(Re[Ze]);qe=ve(qe,Xe)}const Qe=be(Re._common),xe=Se(Qe,qe);return new He(xe)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new R.$V(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Ef=He;class Ve{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ve.c())),this.d}static isInvisibleCharacter(de){return Ve.e().has(de)}static get codePoints(){return Ve.e()}}e.$Ff=Ve}),define(oe[45],ae([0,1,25]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=void 0;function R(d){return s(d,0)}e.$Ri=R;function s(d,h){switch(typeof d){case"object":return d===null?M(349,h):Array.isArray(d)?f(d,h):l(d,h);case"string":return S(d,h);case"boolean":return D(d,h);case"number":return M(d,h);case"undefined":return M(937,h);default:return M(617,h)}}e.$Si=s;function M(d,h){return(h<<5)-h+d|0}e.$Ti=M;function D(d,h){return M(d?433:863,h)}function S(d,h){h=M(149417,h);for(let g=0,v=d.length;g<v;g++)h=M(d.charCodeAt(g),h);return h}e.$Ui=S;function f(d,h){return h=M(104579,h),d.reduce((g,v)=>s(v,g),h)}function l(d,h){return h=M(181387,h),Object.keys(d).sort().reduce((g,v)=>(g=S(v,g),s(d[v],g)),h)}class y{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=s(h,this.g),this.g}}e.$Vi=y;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function p(d,h,g=32){const v=g-h,u=~((1<<v)-1);return(d<<h|(u&d)>>>v)>>>0}function c(d,h=0,g=d.byteLength,v=0){for(let u=0;u<g;u++)d[h+u]=v}function b(d,h,g="0"){for(;d.length<h;)d=g+d;return d}function m(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(g=>g.toString(16).padStart(2,"0")).join(""):b((d>>>0).toString(16),h/4)}e.$Wi=m;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const g=h.length;if(g===0)return;const v=this.p;let u=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=h.charCodeAt(0),r=0);;){let i=o;if(P.$bf(o))if(r+1<g){const n=h.charCodeAt(r+1);P.$cf(n)?(r++,i=P.$df(o,n)):i=65533}else{t=o;break}else P.$cf(o)&&(i=65533);if(u=this.w(v,u,i),r++,r<g)o=h.charCodeAt(r);else break}this.r=u,this.u=t}w(h,g,v){return v<128?h[g++]=v:v<2048?(h[g++]=192|(v&1984)>>>6,h[g++]=128|(v&63)>>>0):v<65536?(h[g++]=224|(v&61440)>>>12,h[g++]=128|(v&4032)>>>6,h[g++]=128|(v&63)>>>0):(h[g++]=240|(v&1835008)>>>18,h[g++]=128|(v&258048)>>>12,h[g++]=128|(v&4032)>>>6,h[g++]=128|(v&63)>>>0),g>=64&&(this.y(),g-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),g}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=$.g,g=this.q;for(let w=0;w<64;w+=4)h.setUint32(w,g.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)h.setUint32(w,p(h.getUint32(w-12,!1)^h.getUint32(w-32,!1)^h.getUint32(w-56,!1)^h.getUint32(w-64,!1),1),!1);let v=this.h,u=this.l,t=this.m,o=this.n,r=this.o,i,n,a;for(let w=0;w<80;w++)w<20?(i=u&t|~u&o,n=1518500249):w<40?(i=u^t^o,n=1859775393):w<60?(i=u&t|u&o|t&o,n=2400959708):(i=u^t^o,n=3395469782),a=p(v,5)+i+r+n+h.getUint32(w*4,!1)&4294967295,r=o,o=t,t=p(u,30),u=v,v=a;this.h=this.h+v&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Xi=$}),define(oe[74],ae([0,1,25]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const M="error",D="warning",S="warn",f="info",l="ignore";function y(p){return p?P.$0e(M,p)?s.Error:P.$0e(D,p)||P.$0e(S,p)?s.Warning:P.$0e(f,p)?s.Info:s.Ignore:s.Ignore}s.fromValue=y;function k(p){switch(p){case s.Error:return M;case s.Warning:return D;case s.Info:return f;default:return l}}s.toString=k}(R||(R={})),e.default=R}),define(oe[143],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=void 0,e.$Qd=Symbol("MicrotaskDelay")}),define(oe[57],ae([0,1,23,25]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class s{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const b=c.charCodeAt(0),m=this.b.charCodeAt(this.c);return b-m}value(){return this.b[this.c]}}e.$6h=s;class M{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,R.$4e)(c,this.b,0,c.length,this.c,this.d):(0,R.$6e)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$7h=M;class D{constructor(c=!0,b=!0){this.f=c,this.g=b}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let b=c.length-1;b>=0;b--,this.c--){const m=this.b.charCodeAt(b);if(!(m===47||this.f&&m===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,R.$4e)(c,this.b,0,c.length,this.d,this.e):(0,R.$6e)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$8h=D;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(c,b){this.f=c,this.g=b,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,R.$5e)(c,this.c.scheme);if(this.d[this.e]===2)return(0,R.$5e)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,R.$3e)(c,this.c.query);if(this.d[this.e]===5)return(0,R.$3e)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$9h=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(y||(y={}));class k{static forUris(c=()=>!1,b=()=>!1){return new k(new f(c,b))}static forPaths(c=!1){return new k(new D(void 0,!c))}static forStrings(){return new k(new s)}static forConfigKeys(){return new k(new M)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,b){if(b){const m=b.slice(0);(0,P.$Xb)(m);for(const $ of m)this.set($,c)}else{const m=c.slice(0);(0,P.$Xb)(m);for(const $ of m)this.set($[0],$[1])}}set(c,b){const m=this.b.reset(c);let $;this.c||(this.c=new l,this.c.segment=m.value());const d=[];for($=this.c;;){const g=m.cmp($.segment);if(g>0)$.left||($.left=new l,$.left.segment=m.value()),d.push([-1,$]),$=$.left;else if(g<0)$.right||($.right=new l,$.right.segment=m.value()),d.push([1,$]),$=$.right;else if(m.hasNext())m.next(),$.mid||($.mid=new l,$.mid.segment=m.value()),d.push([0,$]),$=$.mid;else break}const h=$.value;$.value=b,$.key=c;for(let g=d.length-1;g>=0;g--){const v=d[g][1];v.updateHeight();const u=v.balanceFactor();if(u<-1||u>1){const t=d[g][0],o=d[g+1][0];if(t===1&&o===1)d[g][1]=v.rotateLeft();else if(t===-1&&o===-1)d[g][1]=v.rotateRight();else if(t===1&&o===-1)v.right=d[g+1][1]=d[g+1][1].rotateRight(),d[g][1]=v.rotateLeft();else if(t===-1&&o===1)v.left=d[g+1][1]=d[g+1][1].rotateLeft(),d[g][1]=v.rotateRight();else throw new Error;if(g>0)switch(d[g-1][0]){case-1:d[g-1][1].left=d[g][1];break;case 1:d[g-1][1].right=d[g][1];break;case 0:d[g-1][1].mid=d[g][1];break}else this.c=d[0][1]}}return h}get(c){return this.d(c)?.value}d(c){const b=this.b.reset(c);let m=this.c;for(;m;){const $=b.cmp(m.segment);if($>0)m=m.left;else if($<0)m=m.right;else if(b.hasNext())b.next(),m=m.mid;else break}return m}has(c){const b=this.d(c);return!(b?.value===void 0&&b?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,b){const m=this.b.reset(c),$=[];let d=this.c;for(;d;){const h=m.cmp(d.segment);if(h>0)$.push([-1,d]),d=d.left;else if(h<0)$.push([1,d]),d=d.right;else if(m.hasNext())m.next(),$.push([0,d]),d=d.mid;else break}if(d){if(b?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:g,value:v,segment:u}=h;this.e(h.key,!1),d.key=g,d.value=v,d.segment=u}}else{const h=d.left??d.right;if($.length>0){const[g,v]=$[$.length-1];switch(g){case-1:v.left=h;break;case 0:v.mid=h;break;case 1:v.right=h;break}}else this.c=h}for(let h=$.length-1;h>=0;h--){const g=$[h][1];g.updateHeight();const v=g.balanceFactor();if(v>1?(g.right.balanceFactor()>=0||(g.right=g.right.rotateRight()),$[h][1]=g.rotateLeft()):v<-1&&(g.left.balanceFactor()<=0||(g.left=g.left.rotateLeft()),$[h][1]=g.rotateRight()),h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const b=this.b.reset(c);let m=this.c,$;for(;m;){const d=b.cmp(m.segment);if(d>0)m=m.left;else if(d<0)m=m.right;else if(b.hasNext())b.next(),$=m.value||$,m=m.mid;else break}return m&&m.value||$}findSuperstr(c){return this.g(c,!1)}g(c,b){const m=this.b.reset(c);let $=this.c;for(;$;){const d=m.cmp($.segment);if(d>0)$=$.left;else if(d<0)$=$.right;else if(m.hasNext())m.next(),$=$.mid;else return $.mid?this.h($.mid):b?$.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[b,m]of this)c(m,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const b=[];return this.j(c,b),b[Symbol.iterator]()}j(c,b){c&&(c.left&&this.j(c.left,b),c.value&&b.push([c.key,c.value]),c.mid&&this.j(c.mid,b),c.right&&this.j(c.right,b))}_isBalanced(){const c=b=>{if(!b)return!0;const m=b.balanceFactor();return m<-1||m>1?!1:c(b.left)&&c(b.right)};return c(this.c)}}e.$0h=k}),define(oe[12],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=void 0;function P(u){return typeof u=="string"}e.$Gf=P;function R(u){return Array.isArray(u)&&u.every(t=>P(t))}e.$Hf=R;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$If=s;function M(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$Jf=M;function D(u){return typeof u=="number"&&!isNaN(u)}e.$Kf=D;function S(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$Lf=S;function f(u){return u===!0||u===!1}e.$Mf=f;function l(u){return typeof u>"u"}e.$Nf=l;function y(u){return!k(u)}e.$Of=y;function k(u){return l(u)||u===null}e.$Pf=k;function p(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Qf=p;function c(u){if(k(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$Rf=c;function b(...u){const t=[];for(let o=0;o<u.length;o++){const r=u[o];if(k(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Sf=b;const m=Object.prototype.hasOwnProperty;function $(u){if(!s(u))return!1;for(const t in u)if(m.call(u,t))return!1;return!0}e.$Tf=$;function d(u){return typeof u=="function"}e.$Uf=d;function h(...u){return u.length>0&&u.every(d)}e.$Vf=h;function g(u,t){const o=Math.min(u.length,t.length);for(let r=0;r<o;r++)v(u[r],t[r])}e.$Wf=g;function v(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(d(t)){try{if(u instanceof t)return}catch{}if(!k(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Xf=v}),define(oe[75],ae([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0j=e.$9j=e.$8j=void 0;const R=Object.create(null);function s(S,f){if((0,P.$Gf)(f)){const l=R[f];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=l}return R[S]=f,{id:S}}function M(){return R}e.$8j=M;function D(){return Object.values(e.$0j)}e.$9j=D,e.$0j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(oe[38],ae([0,1,12]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([g,v])=>{h[g]=v&&typeof v=="object"?R(v):v}),h}e.$kn=R;function s(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const v in g)if(M.call(g,v)){const u=g[v];typeof u=="object"&&!Object.isFrozen(u)&&!(0,P.$Jf)(u)&&h.push(u)}}return d}e.$ln=s;const M=Object.prototype.hasOwnProperty;function D(d,h){return S(d,h,new Set)}e.$mn=D;function S(d,h,g){if((0,P.$Pf)(d))return d;const v=h(d);if(typeof v<"u")return v;if(Array.isArray(d)){const u=[];for(const t of d)u.push(S(t,h,g));return u}if((0,P.$If)(d)){if(g.has(d))throw new Error("Cannot clone recursive data-structure");g.add(d);const u={};for(const t in d)M.call(d,t)&&(u[t]=S(d[t],h,g));return g.delete(d),u}return d}function f(d,h,g=!0){return(0,P.$If)(d)?((0,P.$If)(h)&&Object.keys(h).forEach(v=>{v in d?g&&((0,P.$If)(d[v])&&(0,P.$If)(h[v])?f(d[v],h[v],g):d[v]=h[v]):d[v]=h[v]}),d):h}e.$nn=f;function l(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let g,v;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(g=0;g<d.length;g++)if(!l(d[g],h[g]))return!1}else{const u=[];for(v in d)u.push(v);u.sort();const t=[];for(v in h)t.push(v);if(t.sort(),!l(u,t))return!1;for(g=0;g<u.length;g++)if(!l(d[u[g]],h[u[g]]))return!1}return!0}e.$on=l;function y(d){const h=new Set;return JSON.stringify(d,(g,v)=>{if((0,P.$If)(v)||Array.isArray(v)){if(h.has(v))return"[Circular]";h.add(v)}return v})}e.$pn=y;function k(d,h){const g=Object.create(null);return!d||!h||Object.keys(h).forEach(u=>{const t=d[u],o=h[u];l(t,o)||(g[u]=o)}),g}e.$qn=k;function p(d,h){const g=h.toLowerCase(),v=Object.keys(d).find(u=>u.toLowerCase()===g);return v?d[v]:d[h]}e.$rn=p;function c(d,h){const g=Object.create(null);for(const[v,u]of Object.entries(d))h(v,u)&&(g[v]=u);return g}e.$sn=c;function b(d){let h=[];for(;Object.prototype!==d;)h=h.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return h}e.$tn=b;function m(d){const h=[];for(const g of b(d))typeof d[g]=="function"&&h.push(g);return h}e.$un=m;function $(d,h){const g=u=>function(){const t=Array.prototype.slice.call(arguments,0);return h(u,t)},v={};for(const u of d)v[u]=g(u);return v}e.$vn=$}),define(oe[102],ae([0,1,75]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$$j=e.ThemeColor=void 0;var R;(function(D){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=S})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$$j=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(h){const g=S.exec(h.id);if(!g)return f(P.$0j.error);const[,v,u]=g,t=["codicon","codicon-"+v];return u&&t.push("codicon-modifier-"+u.substring(1)),t}D.asClassNameArray=f;function l(h){return f(h).join(" ")}D.asClassName=l;function y(h){return"."+f(h).join(".")}D.asCSSSelector=y;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}D.isThemeIcon=k;const p=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function c(h){const g=p.exec(h);if(!g)return;const[,v]=g;return{id:v}}D.fromString=c;function b(h){return{id:h}}D.fromId=b;function m(h,g){let v=h.id;const u=v.lastIndexOf("~");return u!==-1&&(v=v.substring(0,u)),g&&(v=`${v}~${g}`),{id:v}}D.modify=m;function $(h){const g=h.id.lastIndexOf("~");if(g!==-1)return h.id.substring(g+1)}D.getModifier=$;function d(h,g){return h.id===g.id&&h.color?.id===g.color?.id}D.isEqual=d})(M||(e.ThemeIcon=M={}))}),define(oe[32],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return P.test(s)}e.$ng=R,e.$og=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,l="";return l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+="-",l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l+=D[M[f++]],l}}()}),define(oe[144],ae([0,1,86,46,84]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kU=void 0;async function M(D,S){if(await new Promise((y,k)=>{const p=R.createReadStream(D),c=P.createHash("sha256");p.pipe(c);const b=(0,s.$db)((m,$)=>{p.removeAllListeners(),c.removeAllListeners(),m?k(m):y($)});p.once("error",b),p.once("end",b),c.once("error",b),c.once("data",m=>b(void 0,m.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$kU=M}),define(oe[145],ae([0,1,26]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!R.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const f=D[S];if(f){for(const{mac:l}of f)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$7m=M}),define(oe[103],ae([0,1,87]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.$rg=e.$qg=void 0;function R(S,f,l,y=1){let k=!1;return new Promise(p=>{const c=setTimeout(()=>{if(!k)return k=!0,p(0)},l);s(S,f,y,b=>{if(!k)return k=!0,clearTimeout(c),p(b)})})}e.$qg=R;function s(S,f,l,y){if(f===0)return y(0);const k=new P.Socket;k.once("connect",()=>(D(k),s(S+l,f-1,l,y))),k.once("data",()=>{}),k.once("error",p=>(D(k),p.code!=="ECONNREFUSED"?s(S+l,f-1,l,y):y(S))),k.connect(S,"127.0.0.1")}e.$rg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,l,y="127.0.0.1"){let k=!1,p,c=1;const b=P.createServer({pauseOnConnect:!0});function m($,d){k||(k=!0,b.removeAllListeners(),b.close(),p&&clearTimeout(p),d($))}return new Promise($=>{p=setTimeout(()=>{m(0,$)},l),b.on("listening",()=>{m(S,$)}),b.on("error",d=>{d&&(d.code==="EADDRINUSE"||d.code==="EACCES")&&c<f?(S++,c++,b.listen(S,y)):m(0,$)}),b.on("close",()=>{m(0,$)}),b.listen(S,y)})}e.$sg=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function Q(){function e(){return process.uncHostAllowlist}function P(f){const l=new Set;if(Array.isArray(f))for(const y of f)typeof y=="string"&&l.add(y);return Array.from(l)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const l=e();if(l)if(typeof f=="string")l.add(f.toLowerCase());else for(const y of P(f))s(y)}function M(f){if(typeof f!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const k of l){if(f.indexOf(k)!==0)continue;const c=f.indexOf("\\",k.length);if(c===-1)continue;const b=f.substring(k.length,c);if(b){y=b;break}}return y}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return Q()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=Q():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[146],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oU=e.$nU=void 0,e.$nU="vscode:contextmenu",e.$oU="vscode:onCloseContextMenu"}),define(oe[147],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vU=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$vU=P}),define(oe[148],ae([11,10]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(oe[149],ae([0,1,148]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0;const R=60,s=R*60,M=s*24,D=M*7,S=M*30,f=M*365;function l(k,p,c,b){typeof k!="number"&&(k=k.getTime());const m=Math.round((new Date().getTime()-k)/1e3);if(m<-30)return(0,P.localize)(0,null,l(new Date().getTime()+m*1e3,!1));if(!b&&m<30)return(0,P.localize)(1,null);let $;return m<R?($=m,p?$===1?c?(0,P.localize)(2,null,$):(0,P.localize)(3,null,$):c?(0,P.localize)(4,null,$):(0,P.localize)(5,null,$):$===1?c?(0,P.localize)(6,null,$):(0,P.localize)(7,null,$):c?(0,P.localize)(8,null,$):(0,P.localize)(9,null,$)):m<s?($=Math.floor(m/R),p?$===1?c?(0,P.localize)(10,null,$):(0,P.localize)(11,null,$):c?(0,P.localize)(12,null,$):(0,P.localize)(13,null,$):$===1?c?(0,P.localize)(14,null,$):(0,P.localize)(15,null,$):c?(0,P.localize)(16,null,$):(0,P.localize)(17,null,$)):m<M?($=Math.floor(m/s),p?$===1?c?(0,P.localize)(18,null,$):(0,P.localize)(19,null,$):c?(0,P.localize)(20,null,$):(0,P.localize)(21,null,$):$===1?c?(0,P.localize)(22,null,$):(0,P.localize)(23,null,$):c?(0,P.localize)(24,null,$):(0,P.localize)(25,null,$)):m<D?($=Math.floor(m/M),p?$===1?(0,P.localize)(26,null,$):(0,P.localize)(27,null,$):$===1?(0,P.localize)(28,null,$):(0,P.localize)(29,null,$)):m<S?($=Math.floor(m/D),p?$===1?c?(0,P.localize)(30,null,$):(0,P.localize)(31,null,$):c?(0,P.localize)(32,null,$):(0,P.localize)(33,null,$):$===1?c?(0,P.localize)(34,null,$):(0,P.localize)(35,null,$):c?(0,P.localize)(36,null,$):(0,P.localize)(37,null,$)):m<f?($=Math.floor(m/S),p?$===1?c?(0,P.localize)(38,null,$):(0,P.localize)(39,null,$):c?(0,P.localize)(40,null,$):(0,P.localize)(41,null,$):$===1?c?(0,P.localize)(42,null,$):(0,P.localize)(43,null,$):c?(0,P.localize)(44,null,$):(0,P.localize)(45,null,$)):($=Math.floor(m/f),p?$===1?c?(0,P.localize)(46,null,$):(0,P.localize)(47,null,$):c?(0,P.localize)(48,null,$):(0,P.localize)(49,null,$):$===1?c?(0,P.localize)(50,null,$):(0,P.localize)(51,null,$):c?(0,P.localize)(52,null,$):(0,P.localize)(53,null,$))}e.$tm=l;function y(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$um=y}),define(oe[150],ae([11,10]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(oe[51],ae([0,1,23,12,150]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=void 0;function M(k,p){return p&&(k.stack||k.stacktrace)?s.localize(0,null,S(k),D(k.stack)||D(k.stacktrace)):S(k)}function D(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?s.localize(1,null,k.message):k.message||s.localize(2,null)}function f(k=null,p=!1){if(!k)return s.localize(3,null);if(Array.isArray(k)){const c=P.$Hb(k),b=f(c[0],p);return c.length>1?s.localize(4,null,b,c.length):b}if(R.$Gf(k))return k;if(k.detail){const c=k.detail;if(c.error)return M(c.error,p);if(c.exception)return M(c.exception,p)}return k.stack?M(k,p):k.message?k.message:s.localize(5,null)}e.$Oi=f;function l(k){const p=k;return p instanceof Error&&Array.isArray(p.actions)}e.$Pi=l;function y(k,p){let c;return typeof k=="string"?c=new Error(k):c=k,c.actions=p,c}e.$Qi=y}),define(oe[151],ae([11,10]),function(Q,e){return Q.create("vs/base/common/jsonErrorMessages",e)}),define(oe[152],ae([0,1,151]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function R(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Mp=R}),define(oe[153],ae([11,10]),function(Q,e){return Q.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,153]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,s=!1,M=!1,D=!1,S=!1,f=!1,l=!1,y=!1,k=!1,p=!1,c,b=e.$g,m=e.$g,$,d;const h=globalThis;let g;typeof h.vscode<"u"&&typeof h.vscode.process<"u"?g=h.vscode.process:typeof process<"u"&&(g=process);const v=typeof g?.versions?.electron=="string",u=v&&g?.type==="renderer";if(typeof g=="object"){R=g.platform==="win32",s=g.platform==="darwin",M=g.platform==="linux",D=M&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,l=v,k=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,b=e.$g;const E=g.env.VSCODE_NLS_CONFIG;if(E)try{const C=JSON.parse(E),j=C.availableLanguages["*"];c=C.locale,m=C.osLocale,b=j||e.$g,$=C._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!u?(d=navigator.userAgent,R=d.indexOf("Windows")>=0,s=d.indexOf("Macintosh")>=0,y=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=d.indexOf("Linux")>=0,p=d?.indexOf("Mobi")>=0,f=!0,c=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,b=c,m=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:R?r=3:M&&(r=2),e.$i=R,e.$j=s,e.$k=M,e.$l=D,e.$m=S,e.$n=l,e.$o=f,e.$p=f&&typeof h.importScripts=="function",e.$q=e.$p?h.origin:void 0,e.$r=y,e.$s=p,e.$t=k,e.$u=r,e.$v=d,e.$w=b;var i;(function(E){function C(){return e.$w}E.value=C;function j(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=j;function W(){return e.$w==="en"}E.isDefault=W})(i||(e.Language=i={})),e.$x=c,e.$y=m,e.$z=$,e.$A=typeof h.postMessage=="function"&&!h.importScripts,e.$B=(()=>{if(e.$A){const E=[];h.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let W=0,T=E.length;W<T;W++){const G=E[W];if(G.id===j.data.vscodeScheduleAsyncWork){E.splice(W,1),G.callback();return}}});let C=0;return j=>{const W=++C;E.push({id:W,callback:j}),h.postMessage({vscodeScheduleAsyncWork:W},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||y?2:R?1:3;let a=!0,w=!1;function A(){if(!w){w=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,a=new Uint16Array(E.buffer)[0]===(2<<8)+1}return a}e.$D=A,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(oe[35],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const M=s.process;R={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(oe[9],ae([0,1,35]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,M=90,D=122,S=46,f=47,l=92,y=58,k=63;class p extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=o.indexOf(".")!==-1?"property":"argument";let w=`The "${o}" ${a} ${n} of type ${r}`;w+=`. Received type ${typeof i}`,super(w),this.code="ERR_INVALID_ARG_TYPE"}}function c(t,o){if(t===null||typeof t!="object")throw new p(o,"Object",t)}function b(t,o){if(typeof t!="string")throw new p(o,"string",t)}const m=P.$dc==="win32";function $(t){return t===f||t===l}function d(t){return t===f}function h(t){return t>=R&&t<=M||t>=s&&t<=D}function g(t,o,r,i){let n="",a=0,w=-1,A=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=f}if(i(I)){if(!(w===E-1||A===1))if(A===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const C=n.lastIndexOf(r);C===-1?(n="",a=0):(n=n.slice(0,C),a=n.length-1-n.lastIndexOf(r)),w=E,A=0;continue}else if(n.length!==0){n="",a=0,w=E,A=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(w+1,E)}`:n=t.slice(w+1,E),a=E-w-1;w=E,A=0}else I===S&&A!==-1?++A:A=-1}return n}function v(t,o){c(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],b(a,"path"),a.length===0)continue}else o.length===0?a=P.cwd():(a=P.env[`=${o}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===l)&&(a=`${o}\\`));const w=a.length;let A=0,I="",E=!1;const C=a.charCodeAt(0);if(w===1)$(C)&&(A=1,E=!0);else if($(C))if(E=!0,$(a.charCodeAt(1))){let j=2,W=j;for(;j<w&&!$(a.charCodeAt(j));)j++;if(j<w&&j!==W){const T=a.slice(W,j);for(W=j;j<w&&$(a.charCodeAt(j));)j++;if(j<w&&j!==W){for(W=j;j<w&&!$(a.charCodeAt(j));)j++;(j===w||j!==W)&&(I=`\\\\${T}\\${a.slice(W,j)}`,A=j)}}}else A=1;else h(C)&&a.charCodeAt(1)===y&&(I=a.slice(0,2),A=2,w>2&&$(a.charCodeAt(2))&&(E=!0,A=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${a.slice(A)}\\${r}`,i=E,E&&o.length>0)break}return r=g(r,!i,"\\",$),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){b(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(o===1)return d(a)?"\\":t;if($(a))if(n=!0,$(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!$(t.charCodeAt(A));)A++;if(A<o&&A!==I){const E=t.slice(I,A);for(I=A;A<o&&$(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!$(t.charCodeAt(A));)A++;if(A===o)return`\\\\${E}\\${t.slice(I)}\\`;A!==I&&(i=`\\\\${E}\\${t.slice(I,A)}`,r=A)}}}else r=1;else h(a)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,o>2&&$(t.charCodeAt(2))&&(n=!0,r=3));let w=r<o?g(t.slice(r),!n,"\\",$):"";return w.length===0&&!n&&(w="."),w.length>0&&$(t.charCodeAt(o-1))&&(w+="\\"),i===void 0?n?`\\${w}`:w:n?`${i}\\${w}`:`${i}${w}`},isAbsolute(t){b(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return $(r)||o>2&&h(r)&&t.charCodeAt(1)===y&&$(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let a=0;a<t.length;++a){const w=t[a];b(w,"path"),w.length>0&&(o===void 0?o=r=w:o+=`\\${w}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&$(r.charCodeAt(0))){++n;const a=r.length;a>1&&$(r.charCodeAt(1))&&(++n,a>2&&($(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&$(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(b(t,"from"),b(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===l;)a--;const w=a-n;let A=0;for(;A<o.length&&o.charCodeAt(A)===l;)A++;let I=o.length;for(;I-1>A&&o.charCodeAt(I-1)===l;)I--;const E=I-A,C=w<E?w:E;let j=-1,W=0;for(;W<C;W++){const G=t.charCodeAt(n+W);if(G!==o.charCodeAt(A+W))break;G===l&&(j=W)}if(W!==C){if(j===-1)return i}else{if(E>C){if(o.charCodeAt(A+W)===l)return i.slice(A+W+1);if(W===2)return i.slice(A+W)}w>C&&(t.charCodeAt(n+W)===l?j=W:W===2&&(j=3)),j===-1&&(j=0)}let T="";for(W=n+j+1;W<=a;++W)(W===a||t.charCodeAt(W)===l)&&(T+=T.length===0?"..":"\\..");return A+=j,T.length>0?`${T}${i.slice(A,I)}`:(i.charCodeAt(A)===l&&++A,i.slice(A,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const r=o.charCodeAt(2);if(r!==k&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(h(o.charCodeAt(0))&&o.charCodeAt(1)===y&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){b(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return $(n)?t:".";if($(n)){if(r=i=1,$(t.charCodeAt(1))){let A=2,I=A;for(;A<o&&!$(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&$(t.charCodeAt(A));)A++;if(A<o&&A!==I){for(I=A;A<o&&!$(t.charCodeAt(A));)A++;if(A===o)return t;A!==I&&(r=i=A+1)}}}}else h(n)&&t.charCodeAt(1)===y&&(r=o>2&&$(t.charCodeAt(2))?3:2,i=r);let a=-1,w=!0;for(let A=o-1;A>=i;--A)if($(t.charCodeAt(A))){if(!w){a=A;break}}else w=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,o){o!==void 0&&b(o,"ext"),b(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,A=-1;for(a=t.length-1;a>=r;--a){const I=t.charCodeAt(a);if($(I)){if(!n){r=a+1;break}}else A===-1&&(n=!1,A=a+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(i=a):(w=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if($(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){b(t,"path");let o=0,r=-1,i=0,n=-1,a=!0,w=0;t.length>=2&&t.charCodeAt(1)===y&&h(t.charCodeAt(0))&&(o=i=2);for(let A=t.length-1;A>=o;--A){const I=t.charCodeAt(A);if($(I)){if(!a){i=A+1;break}continue}n===-1&&(a=!1,n=A+1),I===S?r===-1?r=A:w!==1&&(w=1):r!==-1&&(w=-1)}return r===-1||n===-1||w===0||w===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:v.bind(null,"\\"),parse(t){b(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return $(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if($(n)){if(i=1,$(t.charCodeAt(1))){let j=2,W=j;for(;j<r&&!$(t.charCodeAt(j));)j++;if(j<r&&j!==W){for(W=j;j<r&&$(t.charCodeAt(j));)j++;if(j<r&&j!==W){for(W=j;j<r&&!$(t.charCodeAt(j));)j++;j===r?i=j:j!==W&&(i=j+1)}}}}else if(h(n)&&t.charCodeAt(1)===y){if(r<=2)return o.root=o.dir=t,o;if(i=2,$(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let a=-1,w=i,A=-1,I=!0,E=t.length-1,C=0;for(;E>=i;--E){if(n=t.charCodeAt(E),$(n)){if(!I){w=E+1;break}continue}A===-1&&(I=!1,A=E+1),n===S?a===-1?a=E:C!==1&&(C=1):a!==-1&&(C=-1)}return A!==-1&&(a===-1||C===0||C===1&&a===A-1&&a===w+1?o.base=o.name=t.slice(w,A):(o.name=t.slice(w,a),o.base=t.slice(w,A),o.ext=t.slice(a,A))),w>0&&w!==i?o.dir=t.slice(0,w-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(m){const t=/\\/g;return()=>{const o=P.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:u();b(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===f)}return o=g(o,!r,"/",d),r?`/${o}`:o.length>0?o:"."},normalize(t){if(b(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=g(t,!o,"/",d),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return b(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];b(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(b(t,"from"),b(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,a=1,w=o.length-a,A=n<w?n:w;let I=-1,E=0;for(;E<A;E++){const j=t.charCodeAt(r+E);if(j!==o.charCodeAt(a+E))break;j===f&&(I=E)}if(E===A)if(w>A){if(o.charCodeAt(a+E)===f)return o.slice(a+E+1);if(E===0)return o.slice(a+E)}else n>A&&(t.charCodeAt(r+E)===f?I=E:E===0&&(I=0));let C="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===f)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(b(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&b(o,"ext"),b(t,"path");let r=0,i=-1,n=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let w=o.length-1,A=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!n){r=a+1;break}}else A===-1&&(n=!1,A=a+1),w>=0&&(I===o.charCodeAt(w)?--w===-1&&(i=a):(w=-1,i=A))}return r===i?i=A:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){b(t,"path");let o=-1,r=0,i=-1,n=!0,a=0;for(let w=t.length-1;w>=0;--w){const A=t.charCodeAt(w);if(A===f){if(!n){r=w+1;break}continue}i===-1&&(n=!1,i=w+1),A===S?o===-1?o=w:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:v.bind(null,"/"),parse(t){b(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===f;let i;r?(o.root="/",i=1):i=0;let n=-1,a=0,w=-1,A=!0,I=t.length-1,E=0;for(;I>=i;--I){const C=t.charCodeAt(I);if(C===f){if(!A){a=I+1;break}continue}w===-1&&(A=!1,w=I+1),C===S?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(w!==-1){const C=a===0&&r?1:a;n===-1||E===0||E===1&&n===w-1&&n===a+1?o.base=o.name=t.slice(C,w):(o.name=t.slice(C,n),o.base=t.slice(C,w),o.ext=t.slice(n,w))}return a>0?o.dir=t.slice(0,a-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=m?e.$fc.normalize:e.$gc.normalize,e.$ic=m?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=m?e.$fc.join:e.$gc.join,e.$kc=m?e.$fc.resolve:e.$gc.resolve,e.$lc=m?e.$fc.relative:e.$gc.relative,e.$mc=m?e.$fc.dirname:e.$gc.dirname,e.$nc=m?e.$fc.basename:e.$gc.basename,e.$oc=m?e.$fc.extname:e.$gc.extname,e.$pc=m?e.$fc.format:e.$gc.format,e.$qc=m?e.$fc.parse:e.$gc.parse,e.$rc=m?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=m?e.$fc.sep:e.$gc.sep,e.$tc=m?e.$fc.delimiter:e.$gc.delimiter}),define(oe[33],ae([0,1,9,4,25,12]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=void 0;function D(a){return a===47||a===92}e.$Yf=D;function S(a){return a.replace(/[\\/]/g,P.$gc.sep)}e.$Zf=S;function f(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$1f=f;function l(a,w=P.$gc.sep){if(!a)return"";const A=a.length,I=a.charCodeAt(0);if(D(I)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let C=3;const j=C;for(;C<A&&!D(a.charCodeAt(C));C++);if(j!==C&&!D(a.charCodeAt(C+1))){for(C+=1;C<A;C++)if(D(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,w)}}return w}else if(d(I)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+w:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<A;E++)if(D(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$2f=l;function y(a){if(!R.$i||!a||a.length<5)return!1;let w=a.charCodeAt(0);if(w!==92||(w=a.charCodeAt(1),w!==92))return!1;let A=2;const I=A;for(;A<a.length&&(w=a.charCodeAt(A),w!==92);A++);return!(I===A||(w=a.charCodeAt(A+1),isNaN(w)||w===92))}e.$3f=y;const k=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(a,w=R.$i){const A=w?k:p;return!(!a||a.length===0||/^\s+$/.test(a)||(A.lastIndex=0,A.test(a))||w&&c.test(a)||a==="."||a===".."||w&&a[a.length-1]==="."||w&&a.length!==a.trim().length||a.length>255)}e.$4f=b;function m(a,w,A){const I=a===w;return!A||I?I:!a||!w?!1:(0,s.$0e)(a,w)}e.$5f=m;function $(a,w,A,I=P.sep){if(a===w)return!0;if(!a||!w||w.length>a.length)return!1;if(A){if(!(0,s.$$e)(a,w))return!1;if(w.length===a.length)return!0;let C=w.length;return w.charAt(w.length-1)===I&&C--,a.charAt(C)===I}return w.charAt(w.length-1)!==I&&(w+=I),a.indexOf(w)===0}e.$6f=$;function d(a){return a>=65&&a<=90||a>=97&&a<=122}e.$7f=d;function h(a,w){return R.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$ic)(a)||(a=(0,P.$jc)(w,a)),a=(0,P.$hc)(a),R.$i?(a=(0,s.$Se)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$Se)(a,P.sep),a||(a=P.sep)),a}e.$8f=h;function g(a){const w=(0,P.$hc)(a);return R.$i?a.length>3?!1:v(w)&&(a.length===2||w.charCodeAt(2)===92):w===P.$gc.sep}e.$9f=g;function v(a,w=R.$i){return w?d(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$0f=v;function u(a,w=R.$i){return v(a,w)?a[0]:void 0}e.$$f=u;function t(a,w,A){return w.length>a.length?-1:a===w?0:(A&&(a=a.toLowerCase(),w=w.toLowerCase()),a.indexOf(w))}e.$_f=t;function o(a){const w=a.split(":");let A,I,E;for(const C of w){const j=Number(C);(0,M.$Kf)(j)?I===void 0?I=j:E===void 0&&(E=j):A=A?[A,C].join(":"):C}if(!A)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:A,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$ag=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,w,A=8){let I="";for(let C=0;C<A;C++){let j;C===0&&R.$i&&!w&&(A===3||A===4)?j=i:j=r,I+=j.charAt(Math.floor(Math.random()*j.length))}let E;return w?E=`${w}-${I}`:E=I,a?(0,P.$jc)(a,E):E}e.$bg=n}),define(oe[76],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...f){const l=f.reduce((p,c)=>(p[c]=!0,p),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!l[p]).forEach(p=>{for(let c=0;c<y.length;c++)if(p.search(y[c])!==-1){delete S[p];break}})}e.$Pl=M;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$Ql=D}),define(oe[7],ae([0,1,9,4]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const y="",k="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(n){return n instanceof c?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,w,A,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=f(n,E),this.authority=a||y,this.path=l(this.scheme,w||y),this.query=A||y,this.fragment=I||y,S(this,E))}get fsPath(){return v(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:w,path:A,query:I,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=y),w===void 0?w=this.authority:w===null&&(w=y),A===void 0?A=this.path:A===null&&(A=y),I===void 0?I=this.query:I===null&&(I=y),E===void 0?E=this.fragment:E===null&&(E=y),a===this.scheme&&w===this.authority&&A===this.path&&I===this.query&&E===this.fragment?this:new $(a,w,A,I,E)}static parse(n,a=!1){const w=p.exec(n);return w?new $(w[2]||y,r(w[4]||y),r(w[5]||y),r(w[7]||y),r(w[9]||y),a):new $(y,y,y,y,y)}static file(n){let a=y;if(R.$i&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const w=n.indexOf(k,2);w===-1?(a=n.substring(2),n=k):(a=n.substring(2,w),n=n.substring(w)||k)}return new $("file",a,n,y,y)}static from(n,a){return new $(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return R.$i&&n.scheme==="file"?w=c.file(P.$fc.join(v(n,!0),...a)).path:w=P.$gc.join(n.path,...a),n.with({path:w})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof c)return n;{const a=new $(n);return a._formatted=n.external??null,a._fsPath=n._sep===m?n.fsPath??null:null,a}}else return n}}e.URI=c;function b(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=b;const m=R.$i?1:void 0;class $ extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const d={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,a){let w,A=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||a&&E===91||a&&E===93||a&&E===58)A!==-1&&(w+=encodeURIComponent(i.substring(A,I)),A=-1),w!==void 0&&(w+=i.charAt(I));else{w===void 0&&(w=i.substr(0,I));const C=d[E];C!==void 0?(A!==-1&&(w+=encodeURIComponent(i.substring(A,I)),A=-1),w+=C):A===-1&&(A=I)}}return A!==-1&&(w+=encodeURIComponent(i.substring(A))),w!==void 0?w:i}function g(i){let n;for(let a=0;a<i.length;a++){const w=i.charCodeAt(a);w===35||w===63?(n===void 0&&(n=i.substr(0,a)),n+=d[w]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function v(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=v;function u(i,n){const a=n?g:h;let w="",{scheme:A,authority:I,path:E,query:C,fragment:j}=i;if(A&&(w+=A,w+=":"),(I||A==="file")&&(w+=k,w+=k),I){let W=I.indexOf("@");if(W!==-1){const T=I.substr(0,W);I=I.substr(W+1),W=T.lastIndexOf(":"),W===-1?w+=a(T,!1,!1):(w+=a(T.substr(0,W),!1,!1),w+=":",w+=a(T.substr(W+1),!1,!0)),w+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?w+=a(I,!1,!0):(w+=a(I.substr(0,W),!1,!0),w+=I.substr(W))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const W=E.charCodeAt(1);W>=65&&W<=90&&(E=`/${String.fromCharCode(W+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const W=E.charCodeAt(0);W>=65&&W<=90&&(E=`${String.fromCharCode(W+32)}:${E.substr(2)}`)}w+=a(E,!0,!1)}return C&&(w+="?",w+=a(C,!1,!1)),j&&(w+="#",w+=n?j:h(j,!1,!1)),w}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(oe[154],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$dq=e.$cq=e.$bq=void 0;function R(l){const y=l;return y&&typeof y.type=="string"&&typeof y.severity=="string"}e.$bq=R;function s(l){const y=[];let k;try{const p=JSON.parse(l.arguments),c=p[p.length-1];c&&c.__$stack&&(p.pop(),k=c.__$stack),y.push(...p)}catch{y.push("Unable to log remote console arguments",l.arguments)}return{args:y,stack:k}}e.$cq=s;function M(l){if(typeof l!="string")return M(s(l).stack);const y=l;if(y){const k=D(y),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(p&&p.length===4)return{uri:P.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$dq=M;function D(l){if(!l)return l;const y=l.indexOf(`
`);return y===-1?l:l.substring(0,y)}function S(l,y){const{args:k,stack:p}=s(l),c=typeof k[0]=="string"&&k.length===1;let b=D(p);b&&(b=`(${b.trim()})`);let m=[];if(typeof k[0]=="string"?b&&c?m=[`%c[${y}] %c${k[0]} %c${b}`,f("blue"),f(""),f("grey")]:m=[`%c[${y}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:m=[`%c[${y}]%`,f("blue"),...k],b&&!c&&m.push(b),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,m)}e.log=S;function f(l){return`color: ${l}`}}),define(oe[77],ae([0,1,18,7]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function s(f){return JSON.stringify(f,D)}e.$yh=s;function M(f){let l=JSON.parse(f);return l=S(l),l}e.$zh=M;function D(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$he||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let y=0;y<f.length;++y)f[y]=S(f[y],l+1);else for(const y in f)Object.hasOwnProperty.call(f,y)&&(f[y]=S(f[y],l+1))}return f}e.$Ah=S}),define(oe[13],ae([0,1,14,4,25,7]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.Schemas=void 0;var D;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(p,c){return M.URI.isUri(p)?(0,s.$0e)(p.scheme,c):(0,s.$$e)(p,c+":")}e.$cg=S;function f(p,...c){return c.some(b=>S(p,b))}e.$dg=f,e.$eg="vscode-tkn",e.$fg="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${D.vscodeRemoteResource}`}set(c,b,m){this.a[c]=b,this.b[c]=m}setConnectionToken(c,b){this.c[c]=b}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(g){return P.$1(g),c}const b=c.authority;let m=this.a[b];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const $=this.b[b],d=this.c[b];let h=`path=${encodeURIComponent(c.path)}`;return typeof d=="string"&&(h+=`&${e.$fg}=${encodeURIComponent(d)}`),M.URI.from({scheme:R.$o?this.d:D.vscodeRemoteResource,authority:`${m}:${$}`,path:this.f,query:h})}}e.$gg=new l,e.$hg="vs/../../extensions",e.$ig="vs/../../node_modules",e.$jg="vs/../../node_modules.asar",e.$kg="vs/../../node_modules.asar.unpacked",e.$lg="vscode-app";class y{static{this.a=e.$lg}asBrowserUri(c){const b=this.b(c,Q);return this.uriToBrowserUri(b)}uriToBrowserUri(c){return c.scheme===D.vscodeRemote?e.$gg.rewrite(c):c.scheme===D.file&&(R.$m||R.$q===`${D.vscodeFileResource}://${y.a}`)?c.with({scheme:D.vscodeFileResource,authority:c.authority||y.a,query:null,fragment:null}):c}asFileUri(c){const b=this.b(c,Q);return this.uriToFileUri(b)}uriToFileUri(c){return c.scheme===D.vscodeFileResource?c.with({scheme:D.file,authority:c.authority!==y.a?c.authority:null,query:null,fragment:null}):c}b(c,b){return M.URI.isUri(c)?c:M.URI.parse(b.toUrl(c))}}e.$mg=new y;var k;(function(p){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(c.get("3"));const b="vscode-coi";function m(d){let h;typeof d=="string"?h=new URL(d).searchParams:d instanceof URL?h=d.searchParams:M.URI.isUri(d)&&(h=new URL(d.toString(!0)).searchParams);const g=h?.get(b);if(g)return c.get(g)}p.getHeadersFromQuery=m;function $(d,h,g){if(!globalThis.crossOriginIsolated)return;const v=h&&g?"3":g?"2":"1";d instanceof URLSearchParams?d.set(b,v):d[b]=v}p.addSearchParam=$})(k||(e.COI=k={}))}),define(oe[19],ae([0,1,33,13,9,4,25,7]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=e.DataUri=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function f(c){return(0,S.$wc)(c,!0)}e.$tg=f;class l{constructor(b){this.a=b}compare(b,m,$=!1){return b===m?0:(0,D.$3e)(this.getComparisonKey(b,$),this.getComparisonKey(m,$))}isEqual(b,m,$=!1){return b===m?!0:!b||!m?!1:this.getComparisonKey(b,$)===this.getComparisonKey(m,$)}getComparisonKey(b,m=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,m,$=!1){if(b.scheme===m.scheme){if(b.scheme===R.Schemas.file)return P.$6f(f(b),f(m),this.a(b))&&b.query===m.query&&($||b.fragment===m.fragment);if((0,e.$Kg)(b.authority,m.authority))return P.$6f(b.path,m.path,this.a(b),"/")&&b.query===m.query&&($||b.fragment===m.fragment)}return!1}joinPath(b,...m){return S.URI.joinPath(b,...m)}basenameOrAuthority(b){return(0,e.$Cg)(b)||b.authority}basename(b){return s.$gc.basename(b.path)}extname(b){return s.$gc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let m;return b.scheme===R.Schemas.file?m=S.URI.file(s.$mc(f(b))).path:(m=s.$gc.dirname(b.path),b.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),m="/")),b.with({path:m})}normalizePath(b){if(!b.path.length)return b;let m;return b.scheme===R.Schemas.file?m=S.URI.file(s.$hc(f(b))).path:m=s.$gc.normalize(b.path),b.with({path:m})}relativePath(b,m){if(b.scheme!==m.scheme||!(0,e.$Kg)(b.authority,m.authority))return;if(b.scheme===R.Schemas.file){const h=s.$lc(f(b),f(m));return M.$i?P.$Zf(h):h}let $=b.path||"/";const d=m.path||"/";if(this.a(b)){let h=0;for(const g=Math.min($.length,d.length);h<g&&!($.charCodeAt(h)!==d.charCodeAt(h)&&$.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);$=d.substr(0,h)+$.substr(h)}return s.$gc.relative($,d)}resolvePath(b,m){if(b.scheme===R.Schemas.file){const $=S.URI.file(s.$kc(f(b),m));return b.with({authority:$.authority,path:$.path})}return m=P.$1f(m),b.with({path:s.$gc.resolve(b.path,m)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,m){return b===m||b!==void 0&&m!==void 0&&(0,D.$0e)(b,m)}hasTrailingPathSeparator(b,m=s.sep){if(b.scheme===R.Schemas.file){const $=f(b);return $.length>P.$2f($).length&&$[$.length-1]===m}else{const $=b.path;return $.length>1&&$.charCodeAt($.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,m=s.sep){return(0,e.$Lg)(b,m)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,m=s.sep){let $=!1;if(b.scheme===R.Schemas.file){const d=f(b);$=d!==void 0&&d.length===P.$2f(d).length&&d[d.length-1]===m}else{m="/";const d=b.path;$=d.length===1&&d.charCodeAt(d.length-1)===47}return!$&&!(0,e.$Lg)(b,m)?b.with({path:b.path+"/"}):b}}e.$ug=l,e.$vg=new l(()=>!1),e.$wg=new l(c=>c.scheme===R.Schemas.file?!M.$k:!0),e.$xg=new l(c=>!0),e.$yg=e.$vg.isEqual.bind(e.$vg),e.$zg=e.$vg.isEqualOrParent.bind(e.$vg),e.$Ag=e.$vg.getComparisonKey.bind(e.$vg),e.$Bg=e.$vg.basenameOrAuthority.bind(e.$vg),e.$Cg=e.$vg.basename.bind(e.$vg),e.$Dg=e.$vg.extname.bind(e.$vg),e.$Eg=e.$vg.dirname.bind(e.$vg),e.$Fg=e.$vg.joinPath.bind(e.$vg),e.$Gg=e.$vg.normalizePath.bind(e.$vg),e.$Hg=e.$vg.relativePath.bind(e.$vg),e.$Ig=e.$vg.resolvePath.bind(e.$vg),e.$Jg=e.$vg.isAbsolutePath.bind(e.$vg),e.$Kg=e.$vg.isEqualAuthority.bind(e.$vg),e.$Lg=e.$vg.hasTrailingPathSeparator.bind(e.$vg),e.$Mg=e.$vg.removeTrailingPathSeparator.bind(e.$vg),e.$Ng=e.$vg.addTrailingPathSeparator.bind(e.$vg);function y(c,b){const m=[];for(let $=0;$<c.length;$++){const d=b(c[$]);c.some((h,g)=>g===$?!1:(0,e.$zg)(d,b(h)))||m.push(c[$])}return m}e.$Og=y;var k;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function b(m){const $=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(g=>{const[v,u]=g.split(":");v&&u&&$.set(v,u)});const h=m.path.substring(0,m.path.indexOf(";"));return h&&$.set(c.META_DATA_MIME,h),$}c.parseMetaData=b})(k||(e.DataUri=k={}));function p(c,b,m){if(b){let $=c.path;return $&&$[0]!==s.$gc.sep&&($=s.$gc.sep+$),c.with({scheme:m,authority:b,path:$})}return c.with({scheme:m})}e.$Pg=p}),define(oe[8],ae([0,1,22,14,3,2,19,4,143,62]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.Promises=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=void 0;function y(N){return!!N&&typeof N.then=="function"}e.$Qg=y;function k(N){const B=new P.$4d,_=N(B.token),ce=new Promise((se,$e)=>{const me=B.token.onCancellationRequested(()=>{me.dispose(),$e(new R.$5)});Promise.resolve(_).then(ye=>{me.dispose(),B.dispose(),se(ye)},ye=>{me.dispose(),B.dispose(),$e(ye)})});return new class{cancel(){B.cancel(),B.dispose()}then(se,$e){return ce.then(se,$e)}catch(se){return this.then(void 0,se)}finally(se){return ce.finally(se)}}}e.$Rg=k;function p(N,B,_){return new Promise((ce,se)=>{const $e=B.onCancellationRequested(()=>{$e.dispose(),ce(_)});N.then(ce,se).finally(()=>$e.dispose())})}e.$Sg=p;function c(N,B){return new Promise((_,ce)=>{const se=B.onCancellationRequested(()=>{se.dispose(),ce(new R.$5)});N.then(_,ce).finally(()=>se.dispose())})}e.$Tg=c;async function b(N){let B=-1;const _=N.map((ce,se)=>ce.then($e=>(B=se,$e)));try{return await Promise.race(_)}finally{N.forEach((ce,se)=>{se!==B&&ce.cancel()})}}e.$Ug=b;function m(N,B,_){let ce;const se=setTimeout(()=>{ce?.(void 0),_?.()},B);return Promise.race([N.finally(()=>clearTimeout(se)),new Promise($e=>ce=$e)])}e.$Vg=m;function $(N){return new Promise((B,_)=>{const ce=N();y(ce)?ce.then(B,_):B(ce)})}e.$Wg=$;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const _=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(_,_).then(ce)})}return new Promise((_,ce)=>{this.b.then(_,ce)})}return this.a=B(),new Promise((_,ce)=>{this.a.then(se=>{this.a=null,_(se)},se=>{this.a=null,ce(se)})})}dispose(){this.f=!0}}e.$Xg=d;class h{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$Yg=h;class g{constructor(){this.a=new Map}queue(B,_){const se=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(B)===se&&this.a.delete(B)});return this.a.set(B,se),se}}e.$Zg=g;const v=(N,B)=>{let _=!0;const ce=setTimeout(()=>{_=!1,B()},N);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ce),_=!1}}},u=N=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,N())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class t{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,_=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((se,$e)=>{this.d=se,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=_===f.$Qd?u(ce):v(_,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$1g=t;class o{constructor(B){this.a=new t(B),this.b=new d}trigger(B,_){return this.a.trigger(()=>this.b.queue(B),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$2g=o;class r{constructor(){this.a=!1,this.b=new Promise((B,_)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$3g=r;class i extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$4g=i;function n(N,B){return B?new Promise((_,ce)=>{const se=setTimeout(()=>{$e.dispose(),_()},N),$e=B.onCancellationRequested(()=>{clearTimeout(se),$e.dispose(),ce(new R.$5)})}):k(_=>n(N,_))}e.$5g=n;function a(N,B=0,_){const ce=setTimeout(()=>{N(),_&&se.dispose()},B),se=(0,M.$Rc)(()=>{clearTimeout(ce),_?.deleteAndLeak(se)});return _?.add(se),se}e.$6g=a;function w(N){const B=[];let _=0;const ce=N.length;function se(){return _<ce?N[_++]():null}function $e(me){me!=null&&B.push(me);const ye=se();return ye?ye.then($e):Promise.resolve(B)}return Promise.resolve(null).then($e)}e.$7g=w;function A(N,B=ce=>!!ce,_=null){let ce=0;const se=N.length,$e=()=>{if(ce>=se)return Promise.resolve(_);const me=N[ce++];return Promise.resolve(me()).then(Pe=>B(Pe)?Promise.resolve(Pe):$e())};return $e()}e.$8g=A;function I(N,B=ce=>!!ce,_=null){if(N.length===0)return Promise.resolve(_);let ce=N.length;const se=()=>{ce=-1;for(const $e of N)$e.cancel?.()};return new Promise(($e,me)=>{for(const ye of N)ye.then(Pe=>{--ce>=0&&B(Pe)?(se(),$e(Pe)):ce===0&&$e(_)}).catch(Pe=>{--ce>=0&&(se(),me(Pe))})})}e.$9g=I;class E{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new s.$Td}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((_,ce)=>{this.f.push({factory:B,c:_,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const _=B.factory();_.then(B.c,B.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$0g=E;class C extends E{constructor(){super(1)}}e.$$g=C;class j{constructor(){this.a=new L,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$_g=j;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new q;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,_=D.$vg){const ce=_.getComparisonKey(B);let se=this.a.get(ce);if(!se){se=new C;const $e=this.f++,me=s.Event.once(se.onDrained)(()=>{se?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$3c),this.d.set($e,me),this.a.set(ce,se)}return se}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ah=W;class T{constructor(B,_){this.a=-1,typeof B=="function"&&typeof _=="number"&&this.setIfNotSet(B,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},_)}setIfNotSet(B,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},_))}}e.$bh=T;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,_,ce=globalThis){this.cancel();const se=ce.setInterval(()=>{B()},_);this.d=(0,M.$Rc)(()=>{ce.clearInterval(se),this.d=void 0})}dispose(){this.cancel()}}e.$ch=G;class K{constructor(B,_){this.b=-1,this.a=B,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$dh=K;class le{constructor(B,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=B,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$eh=le;class re extends K{constructor(B,_){super(B,_),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$fh=re;class ue extends M.$Tc{constructor(B,_){super(),this.g=B,this.h=_,this.a=[],this.b=this.B(new M.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of B)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$gh=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ih=(N,B)=>{(0,S.$B)(()=>{if(_)return;const ce=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$ih=(N,B,_)=>{const ce=N.requestIdleCallback(B,typeof _=="number"?{timeout:_}:void 0);let se=!1;return{dispose(){se||(se=!0,N.cancelIdleCallback(ce))}}},e.$hh=N=>(0,e.$ih)(globalThis,N)}();class Y{constructor(B,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ih)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$jh=Y;class Z extends Y{constructor(B){super(globalThis,B)}}e.$kh=Z;async function H(N,B,_){let ce;for(let se=0;se<_;se++)try{return await N()}catch($e){ce=$e,await n(B)}throw ce}e.$lh=H;class L{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,_,ce){return this.a={taskId:B,cancel:()=>ce?.(),promise:_},_.then(()=>this.d(B),()=>this.d(B)),_}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let _,ce;const se=new Promise(($e,me)=>{_=$e,ce=me});this.b={run:B,promise:se,promiseResolve:_,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$mh=L;class U{constructor(B,_=()=>Date.now()){this.d=B,this.f=_,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$nh=U;var V;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(V||(V={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,_)=>{this.a=B,this.b=_})}complete(B){return new Promise(_=>{this.a(B),this.d={outcome:0,value:B},_()})}error(B){return new Promise(_=>{this.b(B),this.d={outcome:1,value:B},_()})}cancel(){return this.error(new R.$5)}}e.$oh=q;var te;(function(N){async function B(ce){let se;const $e=await Promise.all(ce.map(me=>me.then(ye=>ye,ye=>{se||(se=ye)})));if(typeof se<"u")throw se;return $e}N.settled=B;function _(ce){return new Promise(async(se,$e)=>{try{await ce(se,$e)}catch(me){$e(me)}})}N.withAsyncBody=_})(te||(e.Promises=te={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$ph=he;class J{constructor(B){this.b=B,this.a=new l.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$qh=J;var O;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(O||(O={}));class F{static fromArray(B){return new F(_=>{_.emitMany(B)})}static fromPromise(B){return new F(async _=>{_.emitMany(await B)})}static fromPromises(B){return new F(async _=>{await Promise.all(B.map(async ce=>_.emitOne(await ce)))})}static merge(B){return new F(async _=>{await Promise.all(B.map(async ce=>{for await(const se of ce)_.emitOne(se)}))})}static{this.EMPTY=F.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new s.$Td,queueMicrotask(async()=>{const _={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(B(_)),this.j()}catch(ce){this.k(ce)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(B,_){return new F(async ce=>{for await(const se of B)ce.emitOne(_(se))})}map(B){return F.map(this,B)}static filter(B,_){return new F(async ce=>{for await(const se of B)_(se)&&ce.emitOne(se)})}filter(B){return F.filter(this,B)}static coalesce(B){return F.filter(B,_=>!!_)}coalesce(){return F.coalesce(this)}static async toPromise(B){const _=[];for await(const ce of B)_.push(ce);return _}toPromise(){return F.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$rh=F;class x extends F{constructor(B,_){super(_),this.l=B}cancel(){this.l.cancel()}}e.$sh=x;function z(N){const B=new P.$4d,_=N(B.token);return new x(B,async ce=>{const se=B.token.onCancellationRequested(()=>{se.dispose(),B.dispose(),ce.reject(new R.$5)});try{for await(const $e of _){if(B.token.isCancellationRequested)return;ce.emitOne($e)}se.dispose(),B.dispose()}catch($e){se.dispose(),B.dispose(),ce.reject($e)}})}e.$th=z;class X{constructor(){this.a=new q,this.b=new F(ce=>{if(B){ce.reject(B);return}return _&&ce.emitMany(_),this.d=se=>ce.reject(se),this.f=se=>ce.emitOne(se),this.a.p});let B,_;this.f=ce=>{_||(_=[]),_.push(ce)},this.d=ce=>{B||(B=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$uh=X}),define(oe[104],ae([0,1,23,8,33,31,9,4,25]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=void 0;function l(){return Object.create(null)}e.$Fj=l,e.$Gj="**",e.$Hj="/";const y="[/\\\\]",k="[^/\\\\]",p=/\//g;function c(Z,H){switch(Z){case 0:return"";case 1:return`${k}*?`;default:return`(?:${y}|${k}+${y}${H?`|${y}${k}+`:""})*?`}}function b(Z,H){if(!Z)return[];const L=[];let U=!1,V=!1,q="";for(const te of Z){switch(te){case H:if(!U&&!V){L.push(q),q="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":V=!0;break;case"]":V=!1;break}q+=te}return q&&L.push(q),L}e.$Ij=b;function m(Z){if(!Z)return"";let H="";const L=b(Z,e.$Hj);if(L.every(U=>U===e.$Gj))H=".*";else{let U=!1;L.forEach((V,q)=>{if(V===e.$Gj){if(U)return;H+=c(2,q===L.length-1)}else{let te=!1,he="",J=!1,O="";for(const F of V){if(F!=="}"&&te){he+=F;continue}if(J&&(F!=="]"||!O)){let x;F==="-"?x=F:(F==="^"||F==="!")&&!O?x="^":F===e.$Hj?x="":x=(0,f.$Me)(F),O+=x;continue}switch(F){case"{":te=!0;continue;case"[":J=!0;continue;case"}":{const z=`(?:${b(he,",").map(X=>m(X)).join("|")})`;H+=z,te=!1,he="";break}case"]":{H+="["+O+"]",J=!1,O="";break}case"?":H+=k;continue;case"*":H+=c(1);continue;default:H+=(0,f.$Me)(F)}}q<L.length-1&&(L[q+1]!==e.$Gj||q+2<L.length)&&(H+=y)}U=V===e.$Gj})}return H}const $=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,v=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Z,H){if(!Z)return r;let L;typeof Z!="string"?L=Z.pattern:L=Z,L=L.trim();const U=`${L}_${!!H.trimForExclusions}`;let V=t.get(U);if(V)return n(V,Z);let q;return $.test(L)?V=w(L.substr(4),L):(q=d.exec(a(L,H)))?V=A(q[1],L):(H.trimForExclusions?g:h).test(L)?V=I(L,H):(q=v.exec(a(L,H)))?V=E(q[1].substr(1),L,!0):(q=u.exec(a(L,H)))?V=E(q[1],L,!1):V=C(L),t.set(U,V),n(V,Z)}function n(Z,H){if(typeof H=="string")return Z;const L=function(U,V){return(0,s.$6f)(U,H.base,!S.$k)?Z((0,f.$Re)(U.substr(H.base.length),D.sep),V):null};return L.allBasenames=Z.allBasenames,L.allPaths=Z.allPaths,L.basenames=Z.basenames,L.patterns=Z.patterns,L}function a(Z,H){return H.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function w(Z,H){return function(L,U){return typeof L=="string"&&L.endsWith(Z)?H:null}}function A(Z,H){const L=`/${Z}`,U=`\\${Z}`,V=function(te,he){return typeof te!="string"?null:he?he===Z?H:null:te===Z||te.endsWith(L)||te.endsWith(U)?H:null},q=[Z];return V.basenames=q,V.patterns=[H],V.allBasenames=q,V}function I(Z,H){const L=ue(Z.slice(1,-1).split(",").map(he=>i(he,H)).filter(he=>he!==r),Z),U=L.length;if(!U)return r;if(U===1)return L[0];const V=function(he,J){for(let O=0,F=L.length;O<F;O++)if(L[O](he,J))return Z;return null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function E(Z,H,L){const U=D.sep===D.$gc.sep,V=U?Z:Z.replace(p,D.sep),q=D.sep+V,te=D.$gc.sep+Z;let he;return L?he=function(J,O){return typeof J=="string"&&(J===V||J.endsWith(q)||!U&&(J===Z||J.endsWith(te)))?H:null}:he=function(J,O){return typeof J=="string"&&(J===V||!U&&J===Z)?H:null},he.allPaths=[(L?"*/":"./")+Z],he}function C(Z){try{const H=new RegExp(`^${m(Z)}$`);return function(L){return H.lastIndex=0,typeof L=="string"&&H.test(L)?Z:null}}catch{return r}}function j(Z,H,L){return!Z||typeof H!="string"?!1:W(Z)(H,void 0,L)}e.$Jj=j;function W(Z,H={}){if(!Z)return o;if(typeof Z=="string"||T(Z)){const L=i(Z,H);if(L===r)return o;const U=function(V,q){return!!L(V,q)};return L.allBasenames&&(U.allBasenames=L.allBasenames),L.allPaths&&(U.allPaths=L.allPaths),U}return le(Z,H)}e.$Kj=W;function T(Z){const H=Z;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$Lj=T;function G(Z){return Z.allBasenames||[]}e.$Mj=G;function K(Z){return Z.allPaths||[]}e.$Nj=K;function le(Z,H){const L=ue(Object.getOwnPropertyNames(Z).map(he=>re(he,Z[he],H)).filter(he=>he!==r)),U=L.length;if(!U)return r;if(!L.some(he=>!!he.requiresSiblings)){if(U===1)return L[0];const he=function(F,x){let z;for(let X=0,N=L.length;X<N;X++){const B=L[X](F,x);if(typeof B=="string")return B;(0,R.$Qg)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const X of z){const N=await X;if(typeof N=="string")return N}return null})():null},J=L.find(F=>!!F.allBasenames);J&&(he.allBasenames=J.allBasenames);const O=L.reduce((F,x)=>x.allPaths?F.concat(x.allPaths):F,[]);return O.length&&(he.allPaths=O),he}const V=function(he,J,O){let F,x;for(let z=0,X=L.length;z<X;z++){const N=L[z];N.requiresSiblings&&O&&(J||(J=(0,D.$nc)(he)),F||(F=J.substr(0,J.length-(0,D.$oc)(he).length)));const B=N(he,J,F,O);if(typeof B=="string")return B;(0,R.$Qg)(B)&&(x||(x=[]),x.push(B))}return x?(async()=>{for(const z of x){const X=await z;if(typeof X=="string")return X}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(V.allBasenames=q.allBasenames);const te=L.reduce((he,J)=>J.allPaths?he.concat(J.allPaths):he,[]);return te.length&&(V.allPaths=te),V}function re(Z,H,L){if(H===!1)return r;const U=i(Z,L);if(U===r)return r;if(typeof H=="boolean")return U;if(H){const V=H.when;if(typeof V=="string"){const q=(te,he,J,O)=>{if(!O||!U(te,he))return null;const F=V.replace("$(basename)",()=>J),x=O(F);return(0,R.$Qg)(x)?x.then(z=>z?Z:null):x?Z:null};return q.requiresSiblings=!0,q}}return U}function ue(Z,H){const L=Z.filter(he=>!!he.basenames);if(L.length<2)return Z;const U=L.reduce((he,J)=>{const O=J.basenames;return O?he.concat(O):he},[]);let V;if(H){V=[];for(let he=0,J=U.length;he<J;he++)V.push(H)}else V=L.reduce((he,J)=>{const O=J.patterns;return O?he.concat(O):he},[]);const q=function(he,J){if(typeof he!="string")return null;if(!J){let F;for(F=he.length;F>0;F--){const x=he.charCodeAt(F-1);if(x===47||x===92)break}J=he.substr(F)}const O=U.indexOf(J);return O!==-1?V[O]:null};q.basenames=U,q.patterns=V,q.allBasenames=U;const te=Z.filter(he=>!he.basenames);return te.push(q),te}function Y(Z,H){return(0,P.$ub)(Z,H,(L,U)=>typeof L=="string"&&typeof U=="string"?L===U:typeof L!="string"&&typeof U!="string"?L.base===U.base&&L.pattern===U.pattern:!1)}e.$Oj=Y}),define(oe[47],ae([0,1,23,33,9,4,19,25]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uv=e.$Tv=e.$Sv=e.$Rv=e.$Qv=e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=void 0;function f(i,n){const{os:a,tildify:w,relative:A}=n;if(A){const C=l(i,A,a);if(typeof C=="string")return C}let I=i.fsPath;if(a===1&&!M.$i?I=I.replace(/\//g,"\\"):a!==1&&M.$i&&(I=I.replace(/\\/g,"/")),a!==1&&w?.userHome){const C=w.userHome.fsPath;let j;i.scheme!==w.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?j=w.userHome.with({path:i.path}).fsPath:j=I,I=p(j,C,a)}return(a===1?s.$fc:s.$gc).normalize(y(I,a===1))}e.$Lv=f;function l(i,n,a){const w=a===1?s.$fc:s.$gc,A=a===3?D.$vg:D.$xg,I=n.getWorkspace(),E=(0,P.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let j;if(A.isEqual(C.uri,i)?j="":j=A.relativePath(C.uri,i)??"",j&&(j=w.normalize(j)),I.folders.length>1&&!n.noPrefix){const W=C.name?C.name:A.basenameOrAuthority(C.uri);j=j?`${W} \u2022 ${j}`:W}return j}function y(i,n=M.$i){return(0,R.$0f)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Mv=y;let k=Object.create(null);function p(i,n,a=M.OS){if(a===1||!i||!n)return i;let w=k.original===n?k.normalized:void 0;w||(w=n,M.$i&&(w=(0,R.$Zf)(w)),w=`${(0,S.$Se)(w,s.$gc.sep)}${s.$gc.sep}`,k={original:n,normalized:w});let A=i;return M.$i&&(A=(0,R.$Zf)(A)),(a===3?A.startsWith(w):(0,S.$$e)(A,w))?`~/${A.substr(w.length)}`:i}e.$Nv=p;function c(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Ov=c;const b="\u2026",m="\\\\",$="~";function d(i,n=s.sep){const a=new Array(i.length);let w=!1;for(let A=0;A<i.length;A++){const I=i[A];if(I===""){a[A]=`.${n}`;continue}if(!I){a[A]=I;continue}w=!0;let E="",C=I;C.indexOf(m)===0?(E=C.substr(0,C.indexOf(m)+m.length),C=C.substr(C.indexOf(m)+m.length)):C.indexOf(n)===0?(E=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf($)===0&&(E=C.substr(0,C.indexOf($)+$.length),C=C.substr(C.indexOf($)+$.length));const j=C.split(n);for(let W=1;w&&W<=j.length;W++)for(let T=j.length-W;w&&T>=0;T--){w=!1;let G=j.slice(T,T+W).join(n);for(let K=0;!w&&K<i.length;K++)if(K!==A&&i[K]&&i[K].indexOf(G)>-1){const le=T+W===j.length,re=T>0&&i[K].indexOf(n)>-1?n+G:G,ue=i[K].endsWith(re);w=!le||ue}if(!w){let K="";(j[0].endsWith(":")||E!=="")&&(T===1&&(T=0,W++,G=j[0]+n+G),T>0&&(K=j[0]+n),K=E+K),T>0&&(K=K+b+n),K=K+G,T+W<j.length&&(K=K+n+b),a[A]=K}}w&&(a[A]=I)}return a}e.$Pv=d;var h;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function g(i,n=Object.create(null)){const a=[];let w=!1,A="";for(const I of i)if(I==="$"||w&&I==="{")A&&a.push({value:A,type:h.TEXT}),A="",w=!0;else if(I==="}"&&w){const E=n[A];if(typeof E=="string")E.length&&a.push({value:E,type:h.VARIABLE});else if(E){const C=a[a.length-1];(!C||C.type!==h.SEPARATOR)&&a.push({value:E.label,type:h.SEPARATOR})}A="",w=!1}else A+=I;return A&&!w&&a.push({value:A,type:h.TEXT}),a.filter((I,E)=>{if(I.type===h.SEPARATOR){const C=a[E-1],j=a[E+1];return[C,j].every(W=>W&&(W.type===h.VARIABLE||W.type===h.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}e.$Qv=g;function v(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$Rv=v;function u(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$Sv=u;function t(i){return i.replace(/&/g,"&&")}e.$Tv=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n)),w=i.substring(n);return{name:a.name+w,parentPath:a.parentPath}}}return r(i)}e.$Uv=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,a=n.basename(i),w=n.dirname(i);return a.length?{name:a,parentPath:w}:{name:w,parentPath:""}}}),define(oe[155],ae([0,1,18,7]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function s(k){return k.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const c=this.a.transformIncoming(p);return c===p?p:s(R.URI.from(c))}transformOutgoing(p){const c=this.a.transformOutgoing(p);return c===p?p:s(R.URI.from(c))}transformOutgoingURI(p){const c=this.a.transformOutgoing(p);return c===p?p:R.URI.from(c)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$2m=M,e.$3m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function D(k,p,c){if(!k||c>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return p.transformOutgoing(k);for(const b in k)if(Object.hasOwnProperty.call(k,b)){const m=D(k[b],p,c+1);m!==null&&(k[b]=m)}}return null}function S(k,p){const c=D(k,p,0);return c===null?k:c}e.$4m=S;function f(k,p,c,b){if(!k||b>200)return null;if(typeof k=="object"){if(k.$mid===1)return c?R.URI.revive(p.transformIncoming(k)):p.transformIncoming(k);if(k instanceof P.$he)return null;for(const m in k)if(Object.hasOwnProperty.call(k,m)){const $=f(k[m],p,c,b+1);$!==null&&(k[m]=$)}}return null}function l(k,p){const c=f(k,p,!1,0);return c===null?k:c}e.$5m=l;function y(k,p){const c=f(k,p,!0,0);return c===null?k:c}e.$6m=y}),define(oe[88],ae([0,1,26,57,32,145,4]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=new class{c(p){return this.a||(this.a=R.$0h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,c=0;const b=(0,P.networkInterfaces)();for(const m in b){const $=b[m];if($)for(const{mac:d,internal:h}of $)h||(c+=1,this.c(d.toUpperCase())&&(p+=1))}this.b=c>0?p/c:0}return this.b}};let S;async function f(p){return S||(S=(async()=>await l(p)||s.$og())()),S}e.$9m=f;async function l(p){try{const c=await new Promise((m,$)=>{Q(["crypto"],m,$)}),b=(0,M.$7m)();return c.createHash("sha256").update(b,"utf8").digest("hex")}catch(c){p(c);return}}const y="Software\\Microsoft\\SQMClient";async function k(p){if(D.$i){const c=await new Promise((b,m)=>{Q(["@vscode/windows-registry"],b,m)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(b){return p(b),""}}return""}e.$0m=k}),define(oe[21],ae([0,1,46,26,156,8,33,85,9,4,19,7]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function c(re,ue=p.UNLINK,Y){if((0,D.$9f)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===p.UNLINK?m(re):b(re,Y)}async function b(re,ue=(0,D.$bg)((0,R.tmpdir)())){try{try{await P.promises.rename(re,ue)}catch(Y){return Y.code==="ENOENT"?void 0:m(re)}m(ue).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function m(re){return(0,s.promisify)(P.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function $(re){if((0,D.$9f)(re))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=$;async function d(re,ue){return v(await(ue?h(re):(0,s.promisify)(P.readdir)(re)))}async function h(re){try{return await(0,s.promisify)(P.readdir)(re,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const ue=[],Y=await d(re);for(const Z of Y){let H=!1,L=!1,U=!1;try{const V=await e.Promises.lstat((0,f.$jc)(re,Z));H=V.isFile(),L=V.isDirectory(),U=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ue.push({name:Z,isFile:()=>H,isDirectory:()=>L,isSymbolicLink:()=>U})}return ue}function g(re){return v(P.readdirSync(re))}e.readdirSync=g;function v(re){return re.map(ue=>typeof ue=="string"?l.$j?(0,S.$El)(ue):ue:(ue.name=l.$j?(0,S.$El)(ue.name):ue.name,ue))}async function u(re){const ue=await d(re),Y=[];for(const Z of ue)await o.existsDirectory((0,f.$jc)(re,Z))&&Y.push(Z);return Y}function t(re,ue=1e3){return new Promise(Y=>{let Z=!1;const H=setInterval(()=>{Z||(Z=!0,P.access(re,L=>{Z=!1,L&&(clearInterval(H),Y(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(H){let L;try{if(L=await e.Promises.lstat(H),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw V}throw U}}re.stat=ue;async function Y(H){try{const{stat:L,symbolicLink:U}=await re.stat(H);return L.isFile()&&U?.dangling!==!0}catch{}return!1}re.existsFile=Y;async function Z(H){try{const{stat:L,symbolicLink:U}=await re.stat(H);return L.isDirectory()&&U?.dangling!==!0}catch{}return!1}re.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const r=new M.$ah;function i(re,ue,Y){return r.queueFor(k.URI.file(re),y.$wg).queue(()=>{const Z=I(Y);return new Promise((H,L)=>w(re,ue,Z,U=>U?L(U):H()))})}let n=!0;function a(re){n=re}e.configureFlushOnWrite=a;function w(re,ue,Y,Z){if(!n)return P.writeFile(re,ue,{mode:Y.mode,flag:Y.flag},Z);P.open(re,Y.flag,Y.mode,(H,L)=>{if(H)return Z(H);P.writeFile(L,ue,U=>{if(U)return P.close(L,()=>Z(U));P.fdatasync(L,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),P.close(L,q=>Z(q))))})})}function A(re,ue,Y){const Z=I(Y);if(!n)return P.writeFileSync(re,ue,{mode:Z.mode,flag:Z.flag});const H=P.openSync(re,Z.flag,Z.mode);try{P.writeFileSync(H,ue);try{P.fdatasyncSync(H)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a(!1)}}finally{P.closeSync(H)}}e.writeFileSync=A;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Y=6e4){if(re!==ue)try{l.$i&&typeof Y=="number"?await C(re,ue,Date.now(),Y):await(0,s.promisify)(P.rename)(re,ue)}catch(Z){if(re.toLowerCase()!==ue.toLowerCase()&&Z.code==="EXDEV"||re.endsWith("."))await j(re,ue,{preserveSymlinks:!1}),await c(re,p.MOVE);else throw Z}}async function C(re,ue,Y,Z,H=0){try{return await(0,s.promisify)(P.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Y>=Z)throw console.error(`[node.js fs] rename failed after ${H} retries with error: ${L}`),L;if(H===0){let U=!1;try{const{stat:V}=await o.stat(ue);V.isFile()||(U=!0)}catch{}if(U)throw L}return await(0,M.$5g)(Math.min(100,H*10)),C(re,ue,Y,Z,H+1)}}async function j(re,ue,Y){return T(re,ue,{root:{source:re,target:ue},options:Y,handledSourcePaths:new Set})}const W=511;async function T(re,ue,Y){if(Y.handledSourcePaths.has(re))return;Y.handledSourcePaths.add(re);const{stat:Z,symbolicLink:H}=await o.stat(re);if(H){if(Y.options.preserveSymlinks)try{return await le(re,ue,Y)}catch{}if(H.dangling)return}return Z.isDirectory()?G(re,ue,Z.mode&W,Y):K(re,ue,Z.mode&W)}async function G(re,ue,Y,Z){await e.Promises.mkdir(ue,{recursive:!0,mode:Y});const H=await d(re);for(const L of H)await T((0,f.$jc)(re,L),(0,f.$jc)(ue,L),Z)}async function K(re,ue,Y){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Y)}async function le(re,ue,Y){let Z=await e.Promises.readlink(re);(0,D.$6f)(Z,Y.root.source,!l.$k)&&(Z=(0,f.$jc)(Y.root.target,Z.substr(Y.root.source.length+1))),await e.Promises.symlink(Z,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(re,ue,Y,Z,H)=>new Promise((L,U)=>{P.read(re,ue,Y,Z,H,(V,q,te)=>V?U(V):L({bytesRead:q,buffer:te}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(re,ue,Y,Z,H)=>new Promise((L,U)=>{P.write(re,ue,Y,Z,H,(V,q,te)=>V?U(V):L({bytesWritten:q,buffer:te}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return c}get rename(){return E}get copy(){return j}}}),define(oe[105],ae([0,1,46,9,4,25,21]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=void 0;function S(p){if(s.$k)return p;const c=(0,R.$mc)(p);if(p===c)return p;const b=((0,R.$nc)(p)||p).toLowerCase();try{const $=(0,D.readdirSync)(c).filter(d=>d.toLowerCase()===b);if($.length===1){const d=S(c);if(d)return(0,R.$jc)(d,$[0])}else if($.length>1){const d=$.indexOf(b);if(d>=0){const h=S(c);if(h)return(0,R.$jc)(h,$[d])}}}catch{}return null}e.$iq=S;async function f(p){if(s.$k)return p;const c=(0,R.$mc)(p);if(p===c)return p;const b=((0,R.$nc)(p)||p).toLowerCase();try{const $=(await D.Promises.readdir(c)).filter(d=>d.toLowerCase()===b);if($.length===1){const d=await f(c);if(d)return(0,R.$jc)(d,$[0])}else if($.length>1){const d=$.indexOf(b);if(d>=0){const h=await f(c);if(h)return(0,R.$jc)(h,$[d])}}}catch{}return null}e.$jq=f;async function l(p){try{return await D.Promises.realpath(p)}catch{const b=k(p);return await D.Promises.access(b,P.constants.R_OK),b}}e.$kq=l;function y(p){try{return P.realpathSync(p)}catch{const b=k(p);return P.accessSync(b,P.constants.R_OK),b}}e.$lq=y;function k(p){return(0,M.$Se)((0,R.$hc)(p),R.sep)}}),define(oe[106],ae([0,1,26,9,21]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class k{constructor(u,t,o){this.exePath=u,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:v=!1}={}){return v?l===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function c({useAlternateBitness:v=!1,findPreview:u=!1}={}){const t=p({useAlternateBitness:v});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const w of await s.Promises.readdir(o)){let A=-1;if(u){const E=w.indexOf("-");if(E<0)continue;const C=w.substring(0,E);if(!M.test(C)||w.substring(E+1)!=="preview")continue;A=parseInt(C,10)}else{if(!M.test(w))continue;A=parseInt(w,10)}if(A<=r)continue;const I=R.$jc(o,w,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=A)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=u?" Preview":"";return new k(i,`PowerShell${a}${n}`,!0)}async function b({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const u=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=v?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(u))if(t.test(r)){const i=R.$jc(u,r,"pwsh.exe");return new k(i,o)}return null}function m(){const v=R.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new k(v,".NET Core PowerShell Global Tool")}function $(){const v=R.$jc(process.env.windir,l===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(v,"Windows PowerShell",!0)}async function*d(){let v=await c();v&&(yield v),v=await c({useAlternateBitness:!0}),v&&(yield v),v=await b(),v&&(yield v),v=m(),v&&(yield v),v=await c({findPreview:!0}),v&&(yield v),v=await b({findPreview:!0}),v&&(yield v),v=await c({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=$(),v&&(yield v)}async function*h(){for await(const v of d())await v.exists()&&(yield v)}e.$Nl=h;async function g(){for await(const v of h())return v;return null}e.$Ol=g}),define(oe[89],ae([0,1,9,4,35,76,12,21]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(k=s.env){return k.comspec||"cmd.exe"}e.$Rl=f;function l(k){let p=[],c=!1;const b=function(m){if(c){p.push(m);return}(!k.send(m,d=>{if(d&&console.error(d),c=!1,p.length>0){const h=p.slice(0);p=[],h.forEach(g=>b(g))}})||R.$i)&&(c=!0)};return{send:b}}e.$Sl=l;var y;(function(k){async function p(c,b,m){if(P.$ic(c))return c;if(b===void 0&&(b=s.cwd()),P.$mc(c)!=="."||(m===void 0&&D.$Gf(s.env.PATH)&&(m=s.env.PATH.split(P.$tc)),m===void 0||m.length===0))return P.$jc(b,c);async function d(h){if(await S.Promises.exists(h)){let g;try{g=await S.Promises.stat(h)}catch(v){v.message.startsWith("EACCES")&&(g=await S.Promises.lstat(h))}return g?!g.isDirectory():!1}return!1}for(const h of m){let g;if(P.$ic(h)?g=P.$jc(h,c):g=P.$jc(b,h,c),await d(g))return g;let v=g+".com";if(await d(v)||(v=g+".exe",await d(v)))return v}return P.$jc(b,c)}k.findExecutable=p})(y||(e.win32=y={}))}),define(oe[107],ae([0,1,48,13]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;function s(D){return new Promise((S,f)=>{let l;const y=new Map;function k(c,b,m,$,d){const h=y.get(b);if(c===D||h){const g={name:p(m),cmd:m,pid:c,ppid:b,load:$,mem:d};y.set(c,g),c===D&&(l=g),h&&(h.children||(h.children=[]),h.children.push(g),h.children.length>1&&(h.children=h.children.sort((v,u)=>v.pid-u.pid)))}}function p(c){const b=/--utility-sub-type=network/i,m=/--ms-enable-electron-run-as-node/i,$=/--crashes-directory/i,d=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,g=/--type=([a-zA-Z-]+)/;if($.exec(c))return"electron-crash-reporter";if(d.exec(c))return"winpty-agent";if(h.exec(c))return"conpty-agent";let v=g.exec(c);if(v&&v.length===2)return v[1]==="renderer"?"window":v[1]==="utility"?b.exec(c)?"utility-network-service":"utility-process":v[1]==="extensionHost"?"extension-host":v[1];const u=/[a-zA-Z-]+\.js/g;let t="";do v=u.exec(c),v&&(t+=v+" ");while(v);return t&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${t})`:m.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=b=>b.indexOf("\\\\?\\")===0||b.indexOf("\\??\\")===0?b.substring(4):b.indexOf('"\\\\?\\')===0||b.indexOf('"\\??\\')===0?'"'+b.substring(5):b;new Promise((b,m)=>{Q(["@vscode/windows-process-tree"],b,m)}).then(b=>{b.getProcessList(D,m=>{if(!m){f(new Error(`Root process ${D} not found`));return}b.getProcessCpuUsage(m,$=>{const d=new Map;$.forEach(h=>{const g=c(h.commandLine||"");d.set(h.pid,{name:p(g),cmd:g,pid:h.pid,ppid:h.ppid,load:h.cpu||0,mem:h.memory||0})}),l=d.get(D),l?(d.forEach(h=>{const g=d.get(h.ppid);g&&(g.children||(g.children=[]),g.children.push(h))}),d.forEach(h=>{h.children&&(h.children=h.children.sort((g,v)=>g.pid-v.pid))}),S(l)):f(new Error(`Root process ${D} not found`))})},b.ProcessDataFlag.CommandLine|b.ProcessDataFlag.Memory)})}else{let c=function(){let b=[l];const m=[];for(;b.length;){const d=b.shift();d&&(m.push(d.pid),d.children&&(b=b.concat(d.children)))}let $=JSON.stringify(R.$mg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);$+=" "+m.join(" "),(0,P.exec)($,{},(d,h,g)=>{if(d||g)f(d||new Error(g.toString()));else{const v=h.toString().split(`
`);for(let u=0;u<m.length;u++){const t=y.get(m[u]);t.load=parseFloat(v[u])}if(!l){f(new Error(`Root process ${D} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(b,m,$)=>{if(b||$)if(process.platform!=="linux")f(b||new Error($.toString()));else{const d=JSON.stringify(R.$mg.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(d,{},(h,g,v)=>{h||v?f(h||new Error(v.toString())):(M(g,k),c())})}else{const d=m.toString().trim(),h="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${d} ${h}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,v,u)=>{g||u&&!u.includes("screen size is bogus")?f(g||new Error(u.toString())):(M(v,k),process.platform==="linux"?c():l?S(l):f(new Error(`Root process ${D} not found`)))})}})}})}e.$Tr=s;function M(D,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const y of l){const k=f.exec(y.trim());k&&k.length===6&&S(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(oe[108],ae([0,1,26,4,106,89]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;async function D(k,p){return k===1?R.$i?y():M.$Rl(p):f(k,p)}e.$Tl=D;let S=null;function f(k,p){if(R.$k&&k===2||R.$j&&k===3)return"/bin/bash";if(!S){let c;if(R.$i)c="/bin/bash";else{if(c=p.SHELL,!c)try{c=(0,P.userInfo)().shell}catch{}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}S=c}return S}let l=null;async function y(){return l||(l=(await(0,s.$Ol)()).exePath),l}});var Ee=this&&this.__decorate||function(Q,e,P,R){var s=arguments.length,M=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,P):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,e,P,R);else for(var S=Q.length-1;S>=0;S--)(D=Q[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(oe[42],ae([0,1,23,8,18,22,50,14,3,2,77,25,12]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.ProxyChannel=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.RequestInitiator=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;var c;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(c||(c={}));function b(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(m||(m={}));function $(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(d||(d={}));function h(H){let L=0;for(let U=0;;U+=7){const V=H.read(1);if(L|=(V.buffer[0]&127)<<U,!(V.buffer[0]&128))return L}}const g=r(0);function v(H,L){if(L===0){H.write(g);return}let U=0;for(let q=L;q!==0;q=q>>>7)U++;const V=s.$he.alloc(U);for(let q=0;L!==0;q++)V.buffer[q]=L&127,L=L>>>7,L>0&&(V.buffer[q]|=128);H.write(V)}class u{constructor(L){this.b=L,this.a=0}read(L){const U=this.b.slice(this.a,this.a+L);return this.a+=U.byteLength,U}}e.$Bh=u;class t{constructor(){this.a=[]}get buffer(){return s.$he.concat(this.a)}write(L){this.a.push(L)}}e.$Ch=t;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function r(H){const L=s.$he.alloc(1);return L.writeUInt8(H,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function a(H,L){if(typeof L>"u")H.write(i.Undefined);else if(typeof L=="string"){const U=s.$he.fromString(L);H.write(i.String),v(H,U.byteLength),H.write(U)}else if(n&&Buffer.isBuffer(L)){const U=s.$he.wrap(L);H.write(i.Buffer),v(H,U.byteLength),H.write(U)}else if(L instanceof s.$he)H.write(i.VSBuffer),v(H,L.byteLength),H.write(L);else if(Array.isArray(L)){H.write(i.Array),v(H,L.length);for(const U of L)a(H,U)}else if(typeof L=="number"&&(L|0)===L)H.write(i.Uint),v(H,L);else{const U=s.$he.fromString(JSON.stringify(L));H.write(i.Object),v(H,U.byteLength),H.write(U)}}e.$Dh=a;function w(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(h(H)).toString();case o.Buffer:return H.read(h(H)).buffer;case o.VSBuffer:return H.read(h(H));case o.Array:{const U=h(H),V=[];for(let q=0;q<U;q++)V.push(w(H));return V}case o.Object:return JSON.parse(H.read(h(H)).toString());case o.Int:return h(H)}}e.$Eh=w;class A{constructor(L,U,V=null,q=1e3){this.h=L,this.j=U,this.k=V,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(te=>this.q(te)),this.m({type:200})}registerChannel(L,U){this.b.set(L,U),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const U=this.o([L.type]);this.k?.logOutgoing(U,0,1,$(L.type));return}case 201:case 202:case 204:case 203:{const U=this.o([L.type,L.id],L.data);this.k?.logOutgoing(U,L.id,1,$(L.type),L.data);return}}}o(L,U=void 0){const V=new t;return a(V,L),a(V,U),this.p(V.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const U=new u(L),V=w(U),q=w(U),te=V[0];switch(te){case 100:return this.k?.logIncoming(L.byteLength,V[1],1,`${b(te)}: ${V[2]}.${V[3]}`,q),this.s({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,V[1],1,`${b(te)}: ${V[2]}.${V[3]}`,q),this.t({type:te,id:V[1],channelName:V[2],name:V[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,V[1],1,`${b(te)}`),this.u({type:te,id:V[1]});case 103:return this.k?.logIncoming(L.byteLength,V[1],1,`${b(te)}`),this.u({type:te,id:V[1]})}}s(L){const U=this.b.get(L.channelName);if(!U){this.v(L);return}const V=new M.$4d;let q;try{q=U.call(this.j,L.name,L.arg,V.token)}catch(J){q=Promise.reject(J)}const te=L.id;q.then(J=>{this.m({id:te,data:J,type:201})},J=>{J instanceof Error?this.m({id:te,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:te,data:J,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,l.$Rc)(()=>V.cancel());this.d.set(L.id,he)}t(L){const U=this.b.get(L.channelName);if(!U){this.v(L);return}const V=L.id,te=U.listen(this.j,L.name,L.arg)(he=>this.m({id:V,data:he,type:204}));this.d.set(L.id,te)}u(L){const U=this.d.get(L.id);U&&(U.dispose(),this.d.delete(L.id))}v(L){let U=this.g.get(L.channelName);U||(U=[],this.g.set(L.channelName,U));const V=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:L,timeoutTimer:V})}w(L){const U=this.g.get(L);if(U){for(const V of U)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Fh=A;var I;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,U=null){this.l=L,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=U}getChannel(L){const U=this;return{call(V,q,te){return U.a?Promise.reject(new S.$5):U.m(L,V,q,te)},listen(V,q){return U.a?f.Event.None:U.o(L,V,q)}}}m(L,U,V,q=M.CancellationToken.None){const te=this.g++,J={id:te,type:100,channelName:L,name:U,arg:V};if(q.isCancellationRequested)return Promise.reject(new S.$5);let O;return new Promise((x,z)=>{if(q.isCancellationRequested)return z(new S.$5);const X=()=>{const ce=se=>{switch(se.type){case 201:this.f.delete(te),x(se.data);break;case 202:{this.f.delete(te);const $e=new Error(se.data.message);$e.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,$e.name=se.data.name,z($e);break}case 203:this.f.delete(te),z(se.data);break}};this.f.set(te,ce),this.p(J)};let N=null;this.b===d.Idle?X():(N=(0,R.$Rg)(ce=>this.u()),N.then(()=>{N=null,X()}));const B=()=>{N?(N.cancel(),N=null):this.p({id:te,type:101}),z(new S.$5)},_=q.onCancellationRequested(B);O=(0,l.$Qc)((0,l.$Rc)(B),_),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,U,V){const q=this.g++,he={id:q,type:102,channelName:L,name:U,arg:V};let J=null;const O=new f.$Td({onWillAddFirstListener:()=>{J=(0,R.$Rg)(x=>this.u()),J.then(()=>{J=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(O),this.p({id:q,type:103}))}}),F=x=>O.fire(x.data);return this.f.set(q,F),O.event}p(L){switch(L.type){case 100:case 102:{const U=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(U,L.id,0,`${b(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const U=this.q([L.type,L.id]);this.j?.logOutgoing(U,L.id,0,b(L.type));return}}}q(L,U=void 0){const V=new t;return a(V,L),a(V,U),this.r(V.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const U=new u(L),V=w(U),q=w(U),te=V[0];switch(te){case 200:return this.j?.logIncoming(L.byteLength,0,0,$(te)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,V[1],0,$(te),q),this.t({type:V[0],id:V[1],data:q})}}t(L){if(L.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=E,Ee([D.$vh],E.prototype,"onDidInitializePromise",null);class C{get connections(){const L=[];return this.f.forEach(U=>L.push(U)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new f.$Td,this.onDidAddConnection=this.g.event,this.h=new f.$Td,this.onDidRemoveConnection=this.h.event,this.j=new l.$Sc,this.j.add(L(({protocol:U,onDidClientDisconnect:V})=>{const q=f.Event.once(U.onMessage);this.j.add(q(te=>{const he=new u(te),J=w(he),O=new A(U,J),F=new E(U);this.a.forEach((z,X)=>O.registerChannel(X,z));const x={channelServer:O,channelClient:F,ctx:J};this.f.add(x),this.g.fire(x),this.j.add(V(()=>{O.dispose(),F.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(L,U){const V=this;return{call(q,te,he){let J;if((0,p.$Uf)(U)){const F=(0,P.$4b)(V.connections.filter(U));J=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(V.onDidAddConnection,U))}else J=U.routeCall(V,q,te);const O=J.then(F=>F.channelClient.getChannel(L));return W(O).call(q,te,he)},listen(q,te){if((0,p.$Uf)(U))return V.k(L,U,q,te);const he=U.routeEvent(V,q,te).then(J=>J.channelClient.getChannel(L));return W(he).listen(q,te)}}}k(L,U,V,q){const te=this;let he;const J=new f.$Td({onWillAddFirstListener:()=>{he=new l.$Sc;const O=new f.$Zd,F=new Map,x=X=>{const B=X.channelClient.getChannel(L).listen(V,q),_=O.add(B);F.set(X,_)},z=X=>{const N=F.get(X);N&&(N.dispose(),F.delete(X))};te.connections.filter(U).forEach(x),f.Event.filter(te.onDidAddConnection,U)(x,void 0,he),te.onDidRemoveConnection(z,void 0,he),O.event(J.fire,J,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return J.event}registerChannel(L,U){this.a.set(L,U);for(const V of this.f)V.channelServer.registerChannel(L,U)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Hh=C;class j{constructor(L,U,V=null){const q=new t;a(q,U),L.send(q.buffer),this.a=new E(L,V),this.d=new A(L,U,V)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,U){this.d.registerChannel(L,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ih=j;function W(H){return{call(L,U,V){return H.then(q=>q.call(L,U,V))},listen(L,U){const V=new f.$3d;return H.then(q=>V.input=q.listen(L,U)),V.event}}}e.$Jh=W;function T(H){let L=!1;return{call(U,V,q){return L?H.call(U,V,q):(0,R.$5g)(0).then(()=>L=!0).then(()=>H.call(U,V,q))},listen(U,V){if(L)return H.listen(U,V);const q=new f.$3d;return(0,R.$5g)(0).then(()=>L=!0).then(()=>q.input=H.listen(U,V)),q.event}}}e.$Kh=T;class G{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const U of L.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await f.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Lh=G;var K;(function(H){function L(te,he,J){const O=te,F=J&&J.disableMarshalling,x=new Map;for(const z in O)V(z)&&x.set(z,f.Event.buffer(O[z],!0,void 0,he));return new class{listen(z,X,N){const B=x.get(X);if(B)return B;if(q(X)){const _=O[X];if(typeof _=="function")return _.call(O,N)}throw new S.$bb(`Event not found: ${X}`)}call(z,X,N){const B=O[X];if(typeof B=="function"){if(!F&&Array.isArray(N))for(let ce=0;ce<N.length;ce++)N[ce]=(0,y.$Ah)(N[ce]);let _=B.apply(O,N);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new S.$bb(`Method not found: ${X}`)}}}H.fromService=L;function U(te,he){const J=he&&he.disableMarshalling;return new Proxy({},{get(O,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):q(F)?function(x){return te.listen(F,x)}:V(F)?te.listen(F):async function(...x){let z;he&&!(0,p.$Pf)(he.context)?z=[he.context,...x]:z=x;const X=await te.call(F,z);return J?X:(0,y.$Ah)(X)};throw new S.$bb(`Property not found: ${String(F)}`)}})}H.toService=U;function V(te){return te[0]==="o"&&te[1]==="n"&&k.$9e(te.charCodeAt(2))}function q(te){return/^onDynamic/.test(te)&&k.$9e(te.charCodeAt(9))}})(K||(e.ProxyChannel=K={}));const le=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const L=H.toString();if(L!=="[object Object]")return L}return H}function ue(H){return Array.isArray(H)?H.map(re):re(H)}function Y(H,L,U,V,q,te,he){he=ue(he);const J=le[q],O=J[V%J.length];let F=[`%c[${H}]%c[${String(L).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(te)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class Z{constructor(L,U){this.d=L,this.f=U,this.a=0,this.b=0}logOutgoing(L,U,V,q,te){this.b+=L,Y(this.d,this.b,L,U,V,q,te)}logIncoming(L,U,V,q,te){this.a+=L,Y(this.f,this.a,L,U,V,q,te)}}e.$Mh=Z}),define(oe[157],ae([0,1,18,3,42]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tU=e.$sU=void 0;class M{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?P.$he.wrap(l.data):P.$he.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$sU=M;class D extends s.$Ih{constructor(f,l){const y=new M(f);super(y,l),this.b=y}dispose(){this.b.disconnect(),super.dispose()}}e.$tU=D}),define(oe[109],ae([0,1,18,3,2,42]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.ProtocolConstants=e.$Nh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function w(I,E){if(!n.has(I)){const C=String(++a);n.set(I,C)}return n.get(I)}function A(I,E,C,j){if(!i.enableDiagnostics)return;const W=w(I,E);if(j instanceof P.$he||j instanceof Uint8Array||j instanceof ArrayBuffer||ArrayBuffer.isView(j)){const T=P.$he.alloc(j.byteLength);T.set(j),i.records.push({timestamp:Date.now(),id:W,label:E,type:C,buff:T})}else i.records.push({timestamp:Date.now(),id:W,label:E,type:C,data:j})}i.traceSocketEvent=A})(S||(e.SocketDiagnostics=S={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let l=null;function y(){return l||(l=P.$he.alloc(0)),l}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return y();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return a&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const w=P.$he.alloc(n);let A=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const C=E.slice(0,n);w.set(C,A),A+=n,a&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else w.set(E,A),A+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return w}}e.$Nh=k;var p;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(p||(p={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var b;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(b||(e.ProtocolConstants=b={}));class m{constructor(n,a,w,A){this.type=n,this.id=a,this.ack=w,this.data=A,this.writtenTime=0}get size(){return this.data.byteLength}}class $ extends s.$Tc{constructor(n){super(),this.f=this.B(new R.$Td),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new k,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const w=this.g.messageType,A=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new m(w,A,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class d{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$he.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const w=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,w}h(){const n=P.$he.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class h extends s.$Tc{constructor(n){super(),this.f=new R.$Td,this.onMessage=this.f.event,this.g=new R.$Td,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new d(this.a)),this.c=this.B(new $(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new m(1,0,0,n))}}e.$Oh=h;class g extends M.$Ih{static fromSocket(n,a){return new g(new h(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,w=null){super(n,a,w),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Ph=g;class v{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Td({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Qh=v;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,w=this.a;for(;w;)n[a++]=w.data,w=w.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new u(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<o.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+o.a)*1e3;let w=0;for(let A=0;A<o.a;A++)n-this.c[A]<=a&&w++;return 1-w/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new v,this.onControlMessage=this.u.event,this.v=new v,this.onMessage=this.v.event,this.w=new v,this.onDidDispose=this.w.event,this.x=new v,this.onSocketClose=this.x.event,this.y=new v,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new m(5,0,0,y());this.p.write(n),this.p.flush()}sendPause(){const n=new m(7,0,0,y());this.p.write(n)}sendResume(){const n=new m(8,0,0,y());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new d(this.o)),this.q=this.r.add(new $(this.o)),this.r.add(this.q.onMessage(w=>this.z(w))),this.r.add(this.o.onClose(w=>this.x.fire(w))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new m(3,0,this.h,y());this.p.write(n);const a=this.b.toArray();for(let w=0,A=a.length;w<A;w++)this.p.write(a[w]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new m(6,0,0,y())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let w=0,A=a.length;w<A;w++)this.p.write(a[w]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const w=new m(1,a,this.h,n);this.b.push(w),this.a||(this.p.write(w),this.B())}sendControl(n){const a=new m(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,w=Date.now()-this.q.lastReadTime,A=Date.now()-this.n;if(a>=2e4&&w>=2e4&&A>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:w});return}const I=Math.max(2e4-a,2e4-w,2e4-A,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new m(3,0,this.h,y());this.p.write(n)}D(){this.h=this.g;const n=new m(9,0,this.h,y());this.p.write(n)}}e.$Rh=r}),define(oe[36],ae([0,1,15,14,13]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pU=void 0;class M{constructor(){this.a=new WeakMap}on(S,f){const l=(y,...k)=>{this.b(S,y)&&f(y,...k)};return this.a.set(f,l),P.ipcMain.on(S,l),this}once(S,f){return P.ipcMain.once(S,(l,...y)=>{this.b(S,l)&&f(l,...y)}),this}handle(S,f){return P.ipcMain.handle(S,(l,...y)=>this.b(S,l)?f(l,...y):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,f){const l=this.a.get(f);return l&&(P.ipcMain.removeListener(S,l),this.a.delete(f)),this}b(S,f){if(!S||!S.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const l=f.senderFrame,y=l.url;if(!y||y==="about:blank")return!0;let k="unknown";try{k=new URL(y).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${y}'.`),!1}return k!==s.$lg?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${k}'.`),!1):l.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${k}' is not a main frame.`),!1):!0}}e.$pU=new M}),define(oe[158],ae([0,1,15,36,146]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=void 0;function M(){R.$pU.on(s.$nU,(S,f,l,y,k)=>{const p=D(S,y,l);p.popup({x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{p&&S.sender.send(s.$oU,f)}})})}e.$qU=M;function D(S,f,l){const y=new P.Menu;return l.forEach(k=>{let p;k.type==="separator"?p=new P.MenuItem({type:k.type}):Array.isArray(k.submenu)?p=new P.MenuItem({submenu:D(S,f,k.submenu),label:k.label}):p=new P.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(c,b,m)=>S.sender.send(f,k.id,m)}),y.append(p)}),y}}),define(oe[159],ae([0,1,36,18,3,2,42,147]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wU=void 0;function f(y,k){const p=s.Event.fromNodeEventEmitter(P.$pU,k,(b,m)=>({event:b,message:m})),c=s.Event.filter(p,({event:b})=>b.sender.id===y);return s.Event.map(c,({message:b})=>b&&R.$he.wrap(b))}class l extends D.$Hh{static{this.b=new Map}static d(){const k=s.Event.fromNodeEventEmitter(P.$pU,"vscode:hello",({sender:p})=>p);return s.Event.map(k,p=>{const c=p.id;l.b.get(c)?.dispose();const m=new s.$Td;l.b.set(c,(0,M.$Rc)(()=>m.fire()));const $=f(c,"vscode:message"),d=s.Event.any(s.Event.signal(f(c,"vscode:disconnect")),m.event);return{protocol:new S.$vU(p,$),onDidClientDisconnect:d}})}constructor(){super(l.d())}}e.$wU=l}),define(oe[110],ae([0,1,36,3,32,157]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yU=e.$xU=void 0;class D extends M.$tU{constructor(l,y){super({addEventListener:(k,p)=>l.addListener(k,p),removeEventListener:(k,p)=>l.removeListener(k,p),postMessage:k=>l.postMessage(k),start:()=>l.start(),close:()=>l.close()},y)}}e.$xU=D;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$og)();f.webContents.send("vscode:createMessageChannel",l);const y=R.Event.fromNodeEventEmitter(P.$pU,"vscode:createMessageChannelResult",(p,c)=>({nonce:c,port:p.ports[0]})),{port:k}=await R.Event.toPromise(R.Event.once(R.Event.filter(y,p=>p.nonce===l)));return k}e.$yU=S}),define(oe[160],ae([0,1,48,8,18,22,154,14,3,2,38,89,76,42]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class b extends c.$Fh{constructor(d){super({send:h=>{try{process.send?.(h.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",h=>s.$he.wrap(Buffer.from(h,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$fq=b;class m{constructor(d,h){this.i=d,this.j=h,this.c=new Set,this.g=new Map,this.h=new f.$Td,this.onDidProcessExit=this.h.event;const g=h&&h.timeout?h.timeout:6e4;this.b=new R.$1g(g),this.d=null,this.f=null}getChannel(d){const h=this;return{call(g,v,u){return h.k(d,g,v,u)},listen(g,v){return h.l(d,g,v)}}}k(d,h,g,v=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const u=this.n(d),t=(0,R.$Rg)(i=>u.call(h,g,i)),o=v.onCancellationRequested(()=>t.cancel()),r=(0,l.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,h,g){if(!this.b)return f.Event.None;this.b.cancel();let v;const u=new f.$Td({onWillAddFirstListener:()=>{v=this.n(d).listen(h,g)(u.fire,u),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],h=Object.create(null);h.env={...(0,y.$kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(h.env={...h.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(h.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(h.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(h.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),h.execArgv===void 0&&(h.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,p.$Ql)(h.env),this.d=(0,P.fork)(this.i,d,h);const g=new f.$Td;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$bq)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}g.fire(s.$he.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,k.$Sl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),o=g.event,r={send:t,onMessage:o};this.f=new c.$Gh(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(w=>(0,l.$Oc)(w)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(d){let h=this.g.get(d);return h||(h=this.m.getChannel(d),this.g.set(d,h)),h}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gq=m}),define(oe[111],ae([0,1,8,3,2,77,12]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.StorageState=e.$ep=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(p){const c=p;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$ep=f;var l;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(l||(e.StorageState=l={}));class y extends s.$Tc{static{this.a=100}constructor(c,b=Object.create(null)){super(),this.r=c,this.s=b,this.b=this.B(new R.$Wd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$2g(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach((b,m)=>this.w(m,b)),c.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(c,b){if(this.c===l.Closed)return;let m=!1;(0,D.$Pf)(b)?m=this.f.delete(c):this.f.get(c)!==b&&(this.f.set(c,b),m=!0),m&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,b){const m=this.f.get(c);return(0,D.$Pf)(m)?b:m}getBoolean(c,b){const m=this.get(c);return(0,D.$Pf)(m)?b:m==="true"}getNumber(c,b){const m=this.get(c);return(0,D.$Pf)(m)?b:parseInt(m,10)}getObject(c,b){const m=this.get(c);return(0,D.$Pf)(m)?b:(0,M.$zh)(m)}async set(c,b,m=!1){if(this.c===l.Closed)return;if((0,D.$Pf)(b))return this.delete(c,m);const $=(0,D.$If)(b)||Array.isArray(b)?(0,M.$yh)(b):String(b);if(this.f.get(c)!==$)return this.f.set(c,$),this.j.set(c,$),this.h.delete(c),this.b.fire({key:c,external:m}),this.D()}async delete(c,b=!1){if(!(this.c===l.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:b}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$fp=y;class k{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach((b,m)=>this.a.set(m,b)),c.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$gp=k}),define(oe[161],ae([0,1,8,3,31,9,21]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UU=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(y,k=Object.create(null)){this.g=y,this.h=k,this.c=(0,M.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const y=await this.f,k=new Map;return(await this.s(y,"SELECT * FROM ItemTable")).forEach(c=>k.set(c.key,c.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${k.size} rows`),k}async updateItems(y){const k=await this.f;return this.j(k,y)}j(y,k){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${k.insert?(0,s.$yc)(k.insert):"0"}), delete(${k.delete?(0,s.$zc)(k.delete):"0"})`),this.t(y,()=>{const p=k.insert,c=k.delete;if(p&&p.size>0){const b=[];b.push([]);let m=0;p.forEach(($,d)=>{let h=b[m];h.length>S.b&&(m++,h=[],b.push(h)),h.push(d,$)}),b.forEach($=>{this.u(y,`INSERT INTO ItemTable VALUES ${new Array($.length/2).fill("(?,?)").join(",")}`,d=>d.run($),()=>{const d=[];let h=0;return p.forEach((g,v)=>{d.push(v),h+=g.length}),`Keys: ${d.join(", ")} Length: ${h}`})})}if(c&&c.size){const b=[];b.push([]);let m=0;c.forEach($=>{let d=b[m];d.length>S.b&&(m++,d=[],b.push(d)),d.push($)}),b.forEach($=>{this.u(y,`DELETE FROM ItemTable WHERE key IN (${new Array($.length).fill("?").join(",")})`,d=>d.run($),()=>{const d=[];return c.forEach(h=>{d.push(h)}),`Keys: ${d.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const y=await this.f;return this.q(y,"VACUUM")}async close(y){this.d.trace(`[storage ${this.c}] close()`);const k=await this.f;return this.k(k,y)}k(y,k){return new Promise((p,c)=>{y.db.close(b=>(b&&this.o(y,`[storage ${this.c}] close(): ${b}`),this.g===S.IN_MEMORY_PATH?p():!y.isErroneous&&!y.isInMemory?this.l().then(p,m=>(this.d.error(`[storage ${this.c}] backup(): ${m}`),p())):typeof k=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(m=>{const $=()=>this.k(m,void 0);return this.j(m,{insert:k()}).then(()=>$(),d=>($(),Promise.reject(d)))})).then(p,c):c(b||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const y=this.m(this.g);return D.Promises.copy(this.g,y,{preserveSymlinks:!1})}m(y){return`${y}.backup`}async checkIntegrity(y){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${y})`);const k=await this.f,p=await this.r(k,y?"PRAGMA integrity_check":"PRAGMA quick_check"),c=y?p.integrity_check:p.quick_check;return k.isErroneous?`${c} (last error: ${k.lastError})`:k.isInMemory?`${c} (in-memory!)`:c}async n(y,k=!0){this.d.trace(`[storage ${this.c}] open(${y}, retryOnBusy: ${k})`);try{return await this.p(y)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&k)return await(0,P.$5g)(S.a),this.n(y,!1);try{await D.Promises.unlink(y);try{await D.Promises.rename(this.m(y),y,!1)}catch{}return await this.p(y)}catch(c){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${c}`),this.p(S.IN_MEMORY_PATH)}}}o(y,k){y.isErroneous=!0,y.lastError=k,this.d.error(k)}p(y){return new Promise((k,p)=>{new Promise((c,b)=>{Q(["@vscode/sqlite3"],c,b)}).then(c=>{const b={db:new(this.d.isTracing?c.verbose().Database:c.Database)(y,m=>m?b.db&&m.code!=="SQLITE_CANTOPEN"?b.db.close(()=>p(m)):p(m):this.q(b,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(b),$=>b.db.close(()=>p($)))),isInMemory:y===S.IN_MEMORY_PATH};b.db.on("error",m=>this.o(b,`[storage ${this.c}] Error (event): ${m}`)),this.d.isTracing&&b.db.on("trace",m=>this.d.trace(`[storage ${this.c}] Trace (event): ${m}`))},p)})}q(y,k){return new Promise((p,c)=>{y.db.exec(k,b=>b?(this.o(y,`[storage ${this.c}] exec(): ${b}`),c(b)):p())})}r(y,k){return new Promise((p,c)=>{y.db.get(k,(b,m)=>b?(this.o(y,`[storage ${this.c}] get(): ${b}`),c(b)):p(m))})}s(y,k){return new Promise((p,c)=>{y.db.all(k,(b,m)=>b?(this.o(y,`[storage ${this.c}] all(): ${b}`),c(b)):p(m))})}t(y,k){return new Promise((p,c)=>{y.db.serialize(()=>{y.db.run("BEGIN TRANSACTION"),k(),y.db.run("END TRANSACTION",b=>b?(this.o(y,`[storage ${this.c}] transaction(): ${b}`),c(b)):p())})})}u(y,k,p,c){const b=y.db.prepare(k),m=$=>{this.o(y,`[storage ${this.c}] prepare(): ${$} (${k}). Details: ${c()}`)};b.on("error",m),p(b),b.finalize($=>{$&&m($),b.removeListener("error",m)})}}e.$UU=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(y){y&&typeof y.logTrace=="function"&&process.env[f.a]&&(this.b=y.logTrace),y&&typeof y.logError=="function"&&(this.c=y.logError)}get isTracing(){return!!this.b}trace(y){this.b?.(y)}error(y){this.c?.(y)}}}),define(oe[162],ae([11,10]),function(Q,e){return Q.create("vs/code/electron-main/app",e)}),define(oe[163],ae([11,10]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[164],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[165],ae([11,10]),function(Q,e){return Q.create("vs/platform/contextkey/common/scanner",e)}),define(oe[166],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[167],ae([11,10]),function(Q,e){return Q.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[168],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(oe[169],ae([11,10]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(oe[170],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[171],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[172],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[173],ae([11,10]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[174],ae([11,10]),function(Q,e){return Q.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[175],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(oe[176],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(oe[177],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(oe[178],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[179],ae([11,10]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[180],ae([11,10]),function(Q,e){return Q.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[181],ae([11,10]),function(Q,e){return Q.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[182],ae([11,10]),function(Q,e){return Q.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[183],ae([11,10]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(oe[184],ae([11,10]),function(Q,e){return Q.create("vs/platform/shell/node/shellEnv",e)}),define(oe[185],ae([11,10]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[186],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[187],ae([11,10]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[188],ae([11,10]),function(Q,e){return Q.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[189],ae([11,10]),function(Q,e){return Q.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[190],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[191],ae([11,10]),function(Q,e){return Q.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[192],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspace/common/workspace",e)}),define(oe[193],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[194],ae([11,10]),function(Q,e){return Q.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[195],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$icb=e.$hcb=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$hcb=P;function R(s){return s&&s.hasOwnProperty("workspace")}e.$icb=R}),define(oe[196],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D9b=e.$C9b=e.$B9b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$B9b=R;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$C9b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$D9b=M}),define(oe[197],ae([0,1,14,165]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...l){switch(l.length){case 1:return(0,R.localize)(0,null,l[0]);case 2:return(0,R.localize)(1,null,l[0],l[1]);case 3:return(0,R.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,R.localize)(3,null),S=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const k=this.d,p=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:p};this.g.push({offset:k,lexeme:p,additionalInfo:y}),this.f.push(c)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const k=this.c.substring(this.d,this.e),p=f.b.get(k);p?this.k(p):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,k=!1,p=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(S);return}const b=this.c.charCodeAt(y);if(k)k=!1;else if(b===47&&!p){y++;break}else b===91?p=!0:b===92?k=!0:b===93&&(p=!1);y++}for(;y<this.c.length&&f.a.has(this.c.charCodeAt(y));)y++;this.e=y;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Yi=f}),define(oe[198],ae([0,1,3,2]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4n=e.$3n=void 0;class s{constructor(){this.a=new P.$Td,this.b=new P.$Td,this.c=new P.$Td,this.d=new P.$Td}static{this.ChannelName="extensionhostdebugservice"}call(S,f,l){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,f,l){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$3n=s;class M extends R.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,l){this.b.call("attach",[S,f,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$4n=M}),define(oe[199],ae([0,1,149,50,13,9,35,19,7]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$vm=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,M.$mc)(s.$mg.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Fg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Fg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,P.$um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$jc)(this.userDataPath,"logs",c)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Fg)(f.URI.file((0,M.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Fg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Fg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Fg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=D.env.VSCODE_PORTABLE;return c?f.URI.file((0,M.$jc)(c,"argv.json")):(0,S.$Fg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,M.$kc)(c):(0,M.$hc)((0,M.$jc)(s.$mg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?f.URI.file((0,M.$kc)(c)):f.URI.file((0,M.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,M.$kc)(c);const b=D.env.VSCODE_EXTENSIONS;if(b)return b;const m=D.env.VSCODE_PORTABLE;return m?(0,M.$jc)(m,"extensions"):(0,S.$Fg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map(b=>/^[^:/?#]+?:\/\//.test(b)?f.URI.parse(b):f.URI.file((0,M.$hc)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?f.URI.parse(c):f.URI.file((0,M.$hc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$vm.test(c))}get extensionLogLevel(){const c=[];for(const b of this.args.log||[]){const m=e.$vm.exec(b);m&&m[1]&&m[2]&&c.push([m[1],m[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,S.$Fg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=D.env.VSCODE_PORTABLE;return c?f.URI.file((0,M.$jc)(c,"policy.json")):(0,S.$Fg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,b,m){this.a=c,this.b=b,this.c=m,this.editSessionId=this.args.editSessionId}}e.$wm=l,Ee([R.$vh],l.prototype,"appRoot",null),Ee([R.$vh],l.prototype,"userHome",null),Ee([R.$vh],l.prototype,"userDataPath",null),Ee([R.$vh],l.prototype,"appSettingsHome",null),Ee([R.$vh],l.prototype,"tmpDir",null),Ee([R.$vh],l.prototype,"cacheHome",null),Ee([R.$vh],l.prototype,"stateResource",null),Ee([R.$vh],l.prototype,"userRoamingDataHome",null),Ee([R.$vh],l.prototype,"userDataSyncHome",null),Ee([R.$vh],l.prototype,"sync",null),Ee([R.$vh],l.prototype,"machineSettingsResource",null),Ee([R.$vh],l.prototype,"workspaceStorageHome",null),Ee([R.$vh],l.prototype,"localHistoryHome",null),Ee([R.$vh],l.prototype,"keyboardLayoutResource",null),Ee([R.$vh],l.prototype,"argvResource",null),Ee([R.$vh],l.prototype,"isExtensionDevelopment",null),Ee([R.$vh],l.prototype,"untitledWorkspacesHome",null),Ee([R.$vh],l.prototype,"builtinExtensionsPath",null),Ee([R.$vh],l.prototype,"extensionsPath",null),Ee([R.$vh],l.prototype,"extensionDevelopmentLocationURI",null),Ee([R.$vh],l.prototype,"extensionDevelopmentKind",null),Ee([R.$vh],l.prototype,"extensionTestsLocationURI",null),Ee([R.$vh],l.prototype,"debugExtensionHost",null),Ee([R.$vh],l.prototype,"logLevel",null),Ee([R.$vh],l.prototype,"extensionLogLevel",null),Ee([R.$vh],l.prototype,"serviceMachineIdResource",null),Ee([R.$vh],l.prototype,"disableTelemetry",null),Ee([R.$vh],l.prototype,"disableWorkspaceTrust",null),Ee([R.$vh],l.prototype,"useInMemorySecretStorage",null),Ee([R.$vh],l.prototype,"policyFile",null);function y(p,c){return k(p["inspect-extensions"],p["inspect-brk-extensions"],5870,c,p.debugId,p.extensionEnvironment)}e.$xm=y;function k(p,c,b,m,$,d){const g=Number(c||p)||(m?null:b),v=g?!!c:!1;let u;if(d)try{u=JSON.parse(d)}catch{}return{port:g,break:v,debugId:$,env:u}}e.$ym=k}),define(oe[112],ae([0,1,309,4,168]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Ul=["tunnel","serve-web"],e.$Vl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},sandbox:{type:"boolean"},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(m,$,d=D){const h=m.find(a=>a.length>0&&a[0]!=="-"),g={},v=["_"],u=[],t={};let o;for(const a in $){const w=$[a];w.type==="subcommand"?a===h&&(o=w):(w.alias&&(g[a]=w.alias),w.type==="string"||w.type==="string[]"?(v.push(a),w.deprecates&&v.push(...w.deprecates)):w.type==="boolean"&&(u.push(a),w.deprecates&&u.push(...w.deprecates)),w.global&&(t[a]=w))}if(o&&h){const a=t;for(const E in o.options)a[E]=o.options[E];const w=m.filter(E=>E!==h),A=d.getSubcommandReporter?d.getSubcommandReporter(h):void 0,I=S(w,a,A);return{[h]:I,_:[]}}const r=P(m,{string:v,boolean:u,alias:g}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in $){const w=$[a];if(w.type==="subcommand")continue;w.alias&&delete n[w.alias];let A=n[a];if(w.deprecates)for(const I of w.deprecates)n.hasOwnProperty(I)&&(A||(A=n[I],A&&d.onDeprecatedOption(I,w.deprecationMessage||(0,s.localize)(37,null,a))),delete n[I]);if(typeof A<"u"){if(w.type==="string[]"){if(Array.isArray(A)||(A=[A]),!w.allowEmptyValue){const I=A.filter(E=>E.length>0);I.length!==A.length&&(d.onEmptyValue(a),A=I.length>0?I:void 0)}}else w.type==="string"&&(Array.isArray(A)?(A=A.pop(),d.onMultipleValues(a,A)):!A&&!w.allowEmptyValue&&(d.onEmptyValue(a),A=void 0));i[a]=A,w.deprecationMessage&&d.onDeprecatedOption(a,w.deprecationMessage)}delete n[a]}for(const a in n)d.onUnknownOption(a);return i}e.$Wl=S;function f(m,$){let d="";return $.args&&(Array.isArray($.args)?d=` <${$.args.join("> <")}>`:d=` <${$.args}>`),$.alias?`-${$.alias} --${m}${d}`:`--${m}${d}`}function l(m,$){const d=[];for(const h in m){const g=m[h],v=f(h,g);d.push([v,g.description])}return y(d,$)}e.$Xl=l;function y(m,$){const h=m.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if($-h<25)return m.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const g=$-h-1,v=[];for(const u of m){const t=u[0],o=p(u[1],g),r=k(h-t.length-2);v.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)v.push(k(h)+o[i])}return v}function k(m){return" ".repeat(m)}function p(m,$){const d=[];for(;m.length;){const h=m.length<$?m.length:m.lastIndexOf(" ",$),g=m.slice(0,h).trim();m=m.slice(h),d.push(g)}return d}function c(m,$,d,h,g){const v=process.stdout.isTTY&&process.stdout.columns||80,u=g?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${m} ${d}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${$} [${(0,s.localize)(40,null)}]${u}`),t.push(""),g?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(41,null,$)):t.push((0,s.localize)(42,null,$)),t.push(""));const o={},r=[];for(const i in h){const n=h[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=o[n.cat];a||(o[n.cat]=a={}),a[i]=n}}for(const i in o){const n=i,a=o[n];a&&(t.push(M[n]),t.push(...l(a,v)),t.push(""))}return r.length&&(t.push((0,s.localize)(43,null)),t.push(...y(r.map(i=>[i.command,i.description]),v)),t.push("")),t.join(`
`)}e.$Yl=c;function b(m,$){return`${m||(0,s.localize)(44,null)}
${$||(0,s.localize)(45,null)}
${process.arch}`}e.$Zl=b}),define(oe[200],ae([0,1,87,198,112]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g0b=void 0;class M extends R.$3n{constructor(S){super(),this.f=S}call(S,f,l){return f==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,f,l)}async g(S,f){const l=(0,s.$Wl)(S,s.$Vl);l.debugRenderer=f;const y=l.extensionDevelopmentPath;if(!y)return{success:!1};const[k]=await this.f.openExtensionDevelopmentHostWindow(y,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const p=k.win;if(!p)return{success:!0};const c=p.webContents.debugger;let b=c.isAttached()?1/0:0;const m=(0,P.createServer)($=>{b++===0&&c.attach();let d=!1;const h=u=>{d||$.write(JSON.stringify(u)+"\0")},g=(u,t,o,r)=>h({method:t,params:o,sessionId:r});p.on("close",()=>{c.removeListener("message",g),$.end(),d=!0}),c.addListener("message",g);let v=Buffer.alloc(0);$.on("data",u=>{v=Buffer.concat([v,u]);for(let t=v.indexOf(0);t!==-1;t=v.indexOf(0)){let o;try{const r=v.slice(0,t).toString("utf8");v=v.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}c.sendCommand(o.method,o.params,o.sessionId).then(r=>h({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>h({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),$.on("error",u=>{console.error("error on cdp pipe:",u)}),$.on("close",()=>{d=!0,--b===0&&c.detach()})});return await new Promise($=>m.listen(0,$)),p.on("close",()=>m.close()),{rendererDebugPort:m.address().port,success:!0}}}e.$g0b=M}),define(oe[64],ae([0,1,310,169,112]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.$2l=e.$1l=void 0;function M(k,p){const c=(g,v)=>{console.warn((0,R.localize)(0,null,g,v))},b=g=>{console.warn((0,R.localize)(1,null,g))},m=(g,v)=>{console.warn((0,R.localize)(2,null,g,v))},$=g=>({onUnknownOption:v=>{s.$Ul.includes(g)||console.warn((0,R.localize)(3,null,v,g))},onMultipleValues:c,onEmptyValue:b,onDeprecatedOption:m,getSubcommandReporter:s.$Ul.includes(g)?$:void 0}),d={onUnknownOption:g=>{console.warn((0,R.localize)(4,null,g))},onMultipleValues:c,onEmptyValue:b,onDeprecatedOption:m,getSubcommandReporter:$},h=(0,s.$Wl)(k,s.$Vl,p?d:void 0);return h.goto&&h._.forEach(g=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(g),(0,R.localize)(5,null))),h}function D(k){const p=k.findIndex(c=>!/^-/.test(c));if(p>-1)return[...k.slice(0,p),...k.slice(p+1)]}function S(k){let[,...p]=k;process.env.VSCODE_DEV&&(p=D(p)||[]);const c=!y(process.env);return M(p,c)}e.$1l=S;function f(k){let[,,...p]=k;return process.env.VSCODE_DEV&&(p=D(p)||[]),M(p,!0)}e.$2l=f;function l(k,...p){const c=k.indexOf("--");return c===-1?k.push(...p):k.splice(c,0,...p),k}e.$3l=l;function y(k){return k.VSCODE_CLI==="1"}e.$4l=y}),function(){"use strict";function Q(e,P,R){function s(D,S){const f=M(D,S),l=[f];return e.isAbsolute(f)||l.unshift(R),e.resolve(...l)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const y=D["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(k,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(oe[201],ae([113,26,35]),function(e,P,R){return Q(e,P,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=Q(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[90],ae([0,1,26,199,201]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=void 0;class M extends R.$wm{constructor(l,y){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,y.nameShort)},y)}}e.$zm=M;function D(f,l){return(0,R.$ym)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.$Am=D;function S(f,l){return(0,R.$ym)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.$Bm=S}),define(oe[202],ae([0,1,46,26,33]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=void 0;function M(D){const S=(0,s.$bg)((0,R.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$y$b=M}),define(oe[203],ae([0,1,12,171]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;function s(D,S,f,l){try{M(D,S,f,l)}catch(y){D.error(y?.message??y)}return S}e.$Np=s;function M(D,S,f,l){const y=(k,p,c)=>{const b=k[p];if((0,P.$Gf)(b)){const m=b,$=m.length;if($>1&&m[0]==="%"&&m[$-1]==="%"){const d=m.substr(1,$-2);let h=f[d];h===void 0&&l&&(h=l[d]);const g=typeof h=="string"?h:h?.message,v=l?.[d],u=typeof v=="string"?v:v?.message;if(!g){u||D.warn(`[${S.name}]: ${(0,R.localize)(0,null,d)}`);return}if(c&&(p==="title"||p==="category")&&u&&u!==g){const t={value:g,original:u};k[p]=t}else k[p]=g}}else if((0,P.$If)(b))for(const m in b)b.hasOwnProperty(m)&&(m==="commands"?y(b,m,!0):y(b,m,c));else if(Array.isArray(b))for(let m=0;m<b.length;m++)y(b,m,c)};for(const k in S)S.hasOwnProperty(k)&&y(S,k)}}),define(oe[204],ae([0,1,19,74,173,205]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(d){return d=d.trim(),d==="*"||D.test(d)}e.$2o=f;function l(d){if(!f(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(D);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.$3o=l;function y(d){if(!d)return null;const h=d.majorBase,g=d.majorMustEqual,v=d.minorBase;let u=d.minorMustEqual;const t=d.patchBase;let o=d.patchMustEqual;d.hasCaret&&(h===0||(u=!1),o=!1);let r=0;if(d.preRelease){const i=S.exec(d.preRelease);if(i){const[,n,a,w]=i;r=Date.UTC(Number(n),Number(a)-1,Number(w))}}return{majorBase:h,majorMustEqual:g,minorBase:v,minorMustEqual:u,patchBase:t,patchMustEqual:o,isMinimum:d.hasGreaterEquals,notBefore:r}}e.$4o=y;function k(d,h,g){let v;typeof d=="string"?v=y(l(d)):v=d;let u;h instanceof Date?u=h.getTime():typeof h=="string"&&(u=new Date(h).getTime());let t;if(typeof g=="string"?t=y(l(g)):t=g,!v||!t)return!1;const o=v.majorBase,r=v.minorBase,i=v.patchBase;let n=t.majorBase,a=t.minorBase,w=t.patchBase;const A=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>a?!0:r<a||u&&u<A?!1:i>=w:(o===1&&n===0&&(!I||!E||!C)&&(n=1,a=0,w=0,I=!0,E=!1,C=!1),o<n?!1:o>n?!I:r<a?!1:r>a?!E:i<w?!1:i>w?!C:!(u&&u<A))}e.$5o=k;function p(d,h,g,v,u){const t=[];if(typeof v.publisher<"u"&&typeof v.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof v.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof v.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!v.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof v.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof v.extensionDependencies<"u"&&!$(v.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof v.activationEvents<"u"){if(!$(v.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof v.main>"u"&&typeof v.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof v.extensionKind<"u"&&typeof v.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof v.main<"u"){if(typeof v.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$Fg)(g,v.main);(0,P.$zg)(i,g)||t.push([R.default.Warning,s.localize(10,null,i.path,g.path)])}}if(typeof v.browser<"u"){if(typeof v.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$Fg)(g,v.browser);(0,P.$zg)(i,g)||t.push([R.default.Warning,s.localize(12,null,i.path,g.path)])}}if(!M.valid(v.version))return t.push([R.default.Error,s.localize(13,null)]),t;const o=[];if(!c(d,h,v,u,o))for(const i of o)t.push([R.default.Error,i]);return t}e.$6o=p;function c(d,h,g,v,u){return v||typeof g.main>"u"&&typeof g.browser>"u"?!0:m(d,h,g.engines.vscode,u)}e.$7o=c;function b(d,h,g){return d==="*"||m(h,g,d)}e.$8o=b;function m(d,h,g,v=[]){const u=y(l(g));if(!u)return v.push(s.localize(14,null,g)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return v.push(s.localize(15,null,g)),!1}else if(!u.majorMustEqual)return v.push(s.localize(16,null,g)),!1;return k(d,h,u)?!0:(v.push(s.localize(17,null,d,g)),!1)}function $(d){if(!Array.isArray(d))return!1;for(let h=0,g=d.length;h<g;h++)if(typeof d[h]!="string")return!1;return!0}}),define(oe[206],ae([0,1,18,32]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function s(M,D,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const y=(await D.readFile(M.serviceMachineIdResource)).value.toString();f=(0,R.$ng)(y)?y:null}catch{f=null}if(!f){f=(0,R.$og)();try{await D.writeFile(M.serviceMachineIdResource,P.$he.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$pp=s}),define(oe[78],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$1h=P}),define(oe[207],ae([0,1,78]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.InstantiationType=void 0;const R=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,f,l){f instanceof P.$1h||(f=new P.$1h(f,[],!!l)),R.push([S,f])}e.$Nr=M;function D(){return R}e.$Or=D}),define(oe[208],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$rq=P;class R{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(D);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),f=this.c(D,S);if(f)return f}}c(M,D){for(const[S,f]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const l=this.c(f,D);if(l)return l;D.delete(S)}}}e.$sq=R}),define(oe[6],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$3h=s("instantiationService");function R(D,S,f){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:f}):(S[P.DI_DEPENDENCIES]=[{id:D,index:f}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(f,l,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,f,y)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$4h=s;function M(D){return D}e.$5h=M}),define(oe[65],ae([0,1,13,6]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9b=e.$K9b=void 0,e.$K9b=(0,R.$4h)("auxiliaryWindowsMainService");function s(M){return M?.opener?.url.startsWith(`${P.Schemas.vscodeFileResource}://${P.$lg}/`)}e.$L9b=s}),define(oe[66],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E9b=void 0,e.$E9b=(0,P.$4h)("backupMainService")}),define(oe[17],ae([0,1,12,7,6]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.ConfigurationTarget=e.$zi=e.$yi=e.$xi=void 0,e.$xi=(0,s.$4h)("configurationService");function M(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof R.URI)}e.$yi=M;function D(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof R.URI)}e.$zi=D;var S;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ai=f;function l(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Bi=l;function y(d,h){const g=Object.create(null);for(const v in d)k(g,v,d[v],h);return g}e.$Ci=y;function k(d,h,g,v){const u=h.split("."),t=u.pop();let o=d;for(let r=0;r<u.length;r++){const i=u[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:v(`Ignoring ${h} as ${u.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=g}catch{v(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(o)}`)}else v(`Ignoring ${h} as ${u.join(".")} is ${JSON.stringify(o)}`)}e.$Di=k;function p(d,h){const g=h.split(".");c(d,g)}e.$Ei=p;function c(d,h){const g=h.shift();if(h.length===0){delete d[g];return}if(Object.keys(d).indexOf(g)!==-1){const v=d[g];typeof v=="object"&&!Array.isArray(v)&&(c(v,h),Object.keys(v).length===0&&delete d[g])}}function b(d,h,g){function v(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=h.split("."),t=v(d,u);return typeof t>"u"?g:t}e.$Fi=b;function m(d,h,g){Object.keys(h).forEach(v=>{v!=="__proto__"&&(v in d?P.$If(d[v])&&P.$If(h[v])?m(d[v],h[v],g):g&&(d[v]=h[v]):d[v]=h[v])})}e.$Gi=m;function $(d){return d.replace(/[\[\]]/g,"")}e.$Hi=$}),define(oe[114],ae([0,1,4,25,197,6,164,14]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.ContextKeyExprType=e.$Zi=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$j),f.set("isLinux",P.$k),f.set("isWindows",P.$i),f.set("isWeb",P.$o),f.set("isMacNative",P.$j&&!P.$o),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function l(J,O){if(f.get(J)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(J,O)}e.$Zi=l;const y=Object.prototype.hasOwnProperty;var k;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const p={regexParsingWithErrorRecovery:!0},c=(0,D.localize)(0,null),b=(0,D.localize)(1,null),m=(0,D.localize)(2,null),$=(0,D.localize)(3,null),d=(0,D.localize)(4,null),h=(0,D.localize)(5,null),g=(0,D.localize)(6,null),v=(0,D.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=p){this.k=O,this.d=new s.$Yi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const x=this.D(),z=x.type===17?h:void 0;throw this.h.push({message:d,offset:x.offset,lexeme:s.$Yi.getLexeme(x),additionalInfo:z}),u.c}return F}catch(F){if(F!==u.c)throw F;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const F=this.o();O.push(F)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const F=this.s();O.push(F)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,$),F?.negate()}case 17:return this.z(),j.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,$),F}case 17:{const F=O.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const X=z.lexeme,N=X.lastIndexOf("/"),B=N===X.length-1?void 0:this.w(X.substring(N+1));let _;try{_=new RegExp(X.substring(1,N),B)}catch{throw this.B("REGEX",z)}return re.create(F,_)}switch(z.type){case 10:case 19:{const X=[z.lexeme];this.z();let N=this.D(),B=0;for(let me=0;me<z.lexeme.length;me++)z.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--;for(;!this.E()&&N.type!==15&&N.type!==16;){switch(N.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let me=0;me<N.lexeme.length;me++)N.lexeme.charCodeAt(me)===40?B++:z.lexeme.charCodeAt(me)===41&&B--}if(B<0)break;X.push(s.$Yi.getLexeme(N)),this.z(),N=this.D()}const _=X.join(""),ce=_.lastIndexOf("/"),se=ce===_.length-1?void 0:this.w(_.substring(ce+1));let $e;try{$e=new RegExp(_.substring(1,ce),se)}catch{throw this.B("REGEX",z)}return t.regex(F,$e)}case 18:{const X=z.lexeme;this.z();let N=null;if(!(0,R.$He)(X)){const B=X.indexOf("/"),_=X.lastIndexOf("/");if(B!==_&&B>=0){const ce=X.slice(B+1,_),se=X[_+1]==="i"?"i":"";try{N=new RegExp(ce,se)}catch{throw this.B("REGEX",z)}}}if(N===null)throw this.B("REGEX",z);return re.create(F,N)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,m);const z=this.u();return t.notIn(F,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case 5:return this.z(),K.create(F,this.u());case 6:return this.z(),le.create(F,this.u());case 7:return this.z(),T.create(F,this.u());case 8:return this.z(),G.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:g,offset:O.offset,lexeme:"",additionalInfo:v}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,F){if(this.C(O))return this.z();throw this.B(F,this.D())}B(O,F,x){const z=(0,D.localize)(8,null,O,s.$Yi.getLexeme(F)),X=F.offset,N=s.$Yi.getLexeme(F);return this.h.push({message:z,offset:X,lexeme:N,additionalInfo:x}),u.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$1i=u;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return w.create(O)}static equals(O,F){return A.create(O,F)}static notEquals(O,F){return C.create(O,F)}static regex(O,F){return re.create(O,F)}static in(O,F){return I.create(O,F)}static notIn(O,F){return E.create(O,F)}static not(O){return j.create(O)}static and(...O){return Z.create(O,null,!0)}static or(...O){return H.create(O,null,!0)}static greater(O,F){return T.create(O,F)}static greaterEquals(O,F){return G.create(O,F)}static smaller(O,F){return K.create(O,F)}static smallerEquals(O,F){return le.create(O,F)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$2i=t;function o(J){const O=new u({regexParsingWithErrorRecovery:!1});return J.map(F=>(O.parse(F),O.lexingErrors.length>0?O.lexingErrors.map(x=>({errorMessage:x.additionalInfo?(0,D.localize)(9,null,x.additionalInfo):(0,D.localize)(10,null),offset:x.offset,length:x.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(x=>({errorMessage:x.additionalInfo?`${x.message}. ${x.additionalInfo}`:x.message,offset:x.offset,length:x.lexeme.length})):[]))}e.$3i=o;function r(J,O){const F=J?J.substituteConstants():void 0,x=O?O.substituteConstants():void 0;return!F&&!x?!0:!F||!x?!1:F.equals(x)}e.$4i=r;function i(J,O){return J.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$5i=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$6i=a;class w{static create(O,F=null){const x=f.get(O);return typeof x=="boolean"?x?a.INSTANCE:n.INSTANCE:new w(O,F)}constructor(O,F){this.key=O,this.c=F,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:U(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=j.create(this.key,this)),this.c}}e.$7i=w;class A{static create(O,F,x=null){if(typeof F=="boolean")return F?w.create(O,x):j.create(O,x);const z=f.get(O);return typeof z=="boolean"?F===(z?"true":"false")?a.INSTANCE:n.INSTANCE:new A(O,F,x)}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$8i=A;class I{static create(O,F){return new I(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:V(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.f),x=O.getValue(this.d);return Array.isArray(F)?F.includes(x):typeof x=="string"&&typeof F=="object"&&F!==null?y.call(F,x):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$9i=I;class E{static create(O,F){return new E(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=11,this.c=I.create(O,F)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$0i=E;class C{static create(O,F,x=null){if(typeof F=="boolean")return F?j.create(O,x):w.create(O,x);const z=f.get(O);return typeof z=="boolean"?F===(z?"true":"false")?n.INSTANCE:a.INSTANCE:new C(O,F,x)}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$$i=C;class j{static create(O,F=null){const x=f.get(O);return typeof x=="boolean"?x?n.INSTANCE:a.INSTANCE:new j(O,F)}constructor(O,F){this.c=O,this.d=F,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:U(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$_i=j;function W(J,O){if(typeof J=="string"){const F=parseFloat(J);isNaN(F)||(J=F)}return typeof J=="string"||typeof J=="number"?O(J):n.INSTANCE}class T{static create(O,F,x=null){return W(F,z=>new T(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$aj=T;class G{static create(O,F,x=null){return W(F,z=>new G(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$bj=G;class K{static create(O,F,x=null){return W(F,z=>new K(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$cj=K;class le{static create(O,F,x=null){return W(F,z=>new le(O,z,x))}constructor(O,F,x){this.c=O,this.d=F,this.f=x,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:V(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$dj=le;class re{static create(O,F){return new re(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const F=this.f?this.f.source:"",x=O.f?O.f.source:"";return F<x?-1:F>x?1:0}equals(O){if(O.type===this.type){const F=this.f?this.f.source:"",x=O.f?O.f.source:"";return this.d===O.d&&F===x}return!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$ej=re;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$fj=ue;function Y(J){let O=null;for(let F=0,x=J.length;F<x;F++){const z=J[F].substituteConstants();if(J[F]!==z&&O===null){O=[];for(let X=0;X<F;X++)O[X]=J[X]}O!==null&&(O[F]=z)}return O===null?J:O}class Z{static create(O,F,x){return Z.d(O,F,x)}constructor(O,F){this.expr=O,this.c=F,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:Z.create(O,this.c,!1)}evaluate(O){for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].evaluate(O))return!1;return!0}static d(O,F,x){const z=[];let X=!1;for(const N of O)if(N){if(N.type===1){X=!0;continue}if(N.type===0)return n.INSTANCE;if(N.type===6){z.push(...N.expr);continue}z.push(N)}if(z.length===0&&X)return a.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];for(;z.length>1;){const N=z[z.length-1];if(N.type!==9)break;z.pop();const B=z.pop(),_=z.length===0,ce=H.create(N.expr.map(se=>Z.create([se,B],null,x)),null,_);ce&&(z.push(ce),z.sort(i))}if(z.length===1)return z[0];if(x){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return n.INSTANCE;if(z.length===1)return z[0]}return new Z(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new Z(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());this.c=H.create(O,this,!0)}return this.c}}e.$gj=Z;class H{static create(O,F,x){return H.d(O,F,x)}constructor(O,F){this.expr=O,this.c=F,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,x=this.expr.length;F<x;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,x=this.expr.length;F<x;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Y(this.expr);return O===this.expr?this:H.create(O,this.c,!1)}evaluate(O){for(let F=0,x=this.expr.length;F<x;F++)if(this.expr[F].evaluate(O))return!0;return!1}static d(O,F,x){let z=[],X=!1;if(O){for(let N=0,B=O.length;N<B;N++){const _=O[N];if(_){if(_.type===0){X=!0;continue}if(_.type===1)return a.INSTANCE;if(_.type===9){z=z.concat(_.expr);continue}z.push(_)}}if(z.length===0&&X)return n.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];if(x){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return a.INSTANCE;if(z.length===1)return z[0]}return new H(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new H(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());for(;O.length>1;){const F=O.shift(),x=O.shift(),z=[];for(const X of he(F))for(const N of he(x))z.push(Z.create([X,N],null,!1));O.unshift(H.create(z,null,!1))}this.c=H.create(O,this,!0)}return this.c}}e.$hj=H;class L extends w{static{this.d=[]}static all(){return L.d.values()}constructor(O,F,x){super(O,null),this.f=F,typeof x=="object"?L.d.push({...x,key:O}):x!==!0&&L.d.push({key:O,description:x,type:F!=null?typeof F:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return A.create(this.key,O)}notEqualsTo(O){return C.create(this.key,O)}}e.$ij=L,e.$jj=(0,M.$4h)("contextKeyService");function U(J,O){return J<O?-1:J>O?1:0}function V(J,O,F,x){return J<F?-1:J>F?1:O<x?-1:O>x?1:0}function q(J,O){if(J.type===0||O.type===1)return!0;if(J.type===9)return O.type===9?te(J.expr,O.expr):!1;if(O.type===9){for(const F of O.expr)if(q(J,F))return!0;return!1}if(J.type===6){if(O.type===6)return te(O.expr,J.expr);for(const F of J.expr)if(q(F,O))return!0;return!1}return J.equals(O)}e.$kj=q;function te(J,O){let F=0,x=0;for(;F<J.length&&x<O.length;){const z=J[F].cmp(O[x]);if(z<0)return!1;z===0&&F++,x++}return F===J.length}function he(J){return J.type===9?J.expr:[J]}}),define(oe[91],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.ID=void 0,e.ID="diagnosticsService",e.$Gm=(0,P.$4h)(e.ID);function R(M){return!!M.hostName&&!!M.errorMessage}e.$Hm=R;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Im=s}),define(oe[115],ae([0,1,19,74,166,6,47,4,38]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zv=e.$Yv=e.ConfirmResult=e.$Xv=e.$Wv=e.$Vv=void 0,e.$Vv=(0,M.$4h)("dialogService");var l;(function(m){m[m.Confirmation=1]="Confirmation",m[m.Prompt=2]="Prompt",m[m.Input=3]="Input"})(l||(l={}));class y{a($){return this.d($,l.Confirmation)}b($){return this.d($,l.Prompt)}c($){return this.d($,l.Input)}d($,d){const h=[];switch(d){case l.Confirmation:{const g=$;g.primaryButton?h.push(g.primaryButton):h.push((0,s.localize)(0,null)),g.cancelButton?h.push(g.cancelButton):h.push((0,s.localize)(1,null));break}case l.Prompt:{const g=$;Array.isArray(g.buttons)&&g.buttons.length>0&&h.push(...g.buttons.map(v=>v.label)),g.cancelButton&&(g.cancelButton===!0?h.push((0,s.localize)(2,null)):typeof g.cancelButton=="string"?h.push(g.cancelButton):g.cancelButton.label?h.push(g.cancelButton.label):h.push((0,s.localize)(3,null))),h.length===0&&h.push((0,s.localize)(4,null));break}case l.Input:{const g=$;g.primaryButton?h.push(g.primaryButton):h.push((0,s.localize)(5,null)),g.cancelButton?h.push(g.cancelButton):h.push((0,s.localize)(6,null));break}}return h}e($){if(typeof $=="string")return $;if(typeof $=="number")return $===R.default.Info?"info":$===R.default.Error?"error":$===R.default.Warning?"warning":"none"}f($,d,h){const g=[...$.buttons??[]];$.cancelButton&&typeof $.cancelButton!="string"&&typeof $.cancelButton!="boolean"&&g.push($.cancelButton);let v=g[d]?.run({checkboxChecked:h});return v instanceof Promise||(v=Promise.resolve(v)),{result:v,checkboxChecked:h}}}e.$Wv=y,e.$Xv=(0,M.$4h)("fileDialogService");var k;(function(m){m[m.SAVE=0]="SAVE",m[m.DONT_SAVE=1]="DONT_SAVE",m[m.CANCEL=2]="CANCEL"})(k||(e.ConfirmResult=k={}));const p=10;function c(m){const $=[];return $.push(...m.slice(0,p).map(d=>typeof d=="string"?d:(0,P.$Cg)(d))),m.length>p&&(m.length-p===1?$.push((0,s.localize)(7,null)):$.push((0,s.localize)(8,null,m.length-p))),$.push(""),$.join(`
`)}e.$Yv=c;function b(m,$){const d=(0,f.$kn)(m);let h=(d.buttons??[]).map(t=>(0,D.$Sv)(t)),g=(m.buttons||[]).map((t,o)=>o),v=0,u=d.cancelId??h.length-1;if(h.length>1){const t=typeof u=="number"?h[u]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&h.length>1&&u!==1){h.splice(u,1),h.splice(1,0,t);const o=g[u];g.splice(u,1),g.splice(1,0,o),u=1}S.$k&&h.length>1&&(h=h.reverse(),g=g.reverse(),v=h.length-1,typeof t=="string"&&(u=v-1))}else if(S.$i&&typeof t=="string"&&h.length>1&&u!==h.length-1){h.splice(u,1),h.push(t);const o=g[u];g.splice(u,1),g.push(o),u=h.length-1}}return d.buttons=h,d.defaultId=v,d.cancelId=u,d.noLink=!0,d.title=d.title||$.nameLong,{options:d,buttonIndeces:g}}e.$Zv=b}),define(oe[116],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aV=e.$_U=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$$U=e.$0U=void 0,e.$0U=(0,P.$4h)("encryptionService"),e.$$U=(0,P.$4h)("encryptionMainService");var R;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$_U=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$aV=D}),define(oe[37],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=void 0,e.$$h=(0,P.$4h)("environmentService"),e.$_h=(0,P.$5h)(e.$$h)}),define(oe[117],ae([0,1,170,6]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$no=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0,e.$bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$co=new RegExp(e.$bo),e.$do="__web_extension",e.$eo="skipWalkthrough",e.$fo="extensionsSync",e.$go="dependecyOrPackExtensionInstall";function s(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ho=s;function M(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$io=M;function D(d,h){switch(d){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$jo=D;function S(d,h){return h==="web"&&!d.includes("web")}e.$ko=S;function f(d,h,g){return S(h,g)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===g}e.$lo=f;function l(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$mo=l;var y;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var k;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var p;(function(d){d.Install="install",d.Uninstall="uninstall"})(p||(e.StatisticType=p={}));var c;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$no=(0,R.$4h)("extensionGalleryService");var b;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var m;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(m||(e.ExtensionSignaturetErrorCode=m={}));class $ extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$oo=$,e.$po=(0,R.$4h)("extensionManagementService"),e.$qo="extensionsIdentifiers/disabled",e.$ro="extensionsIdentifiers/enabled",e.$so=(0,R.$4h)("IGlobalExtensionEnablementService"),e.$to=(0,R.$4h)("IExtensionTipsService"),e.$uo=(0,P.localize)(0,null),e.$vo={value:e.$uo,original:"Extensions"},e.$wo=(0,P.localize2)(1,"Preferences")}),define(oe[209],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o0b=e.$n0b=void 0,e.$n0b=(0,P.$4h)("extensionHostStarter"),e.$o0b="extensionHostStarter"}),define(oe[210],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u2b=e.$t2b=void 0,e.$t2b=(0,P.$4h)("externalTerminal"),e.$u2b="Terminal.app"}),define(oe[211],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q0b=void 0,e.$q0b=(0,P.$4h)("externalTerminal")}),define(oe[212],ae([0,1,48,50,13,9,4,76,21,89,174,210]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t0b=e.$s0b=e.$r0b=void 0;const p=y.localize(0,null);class c{async getDefaultTerminalForPlatforms(){return{windows:b.getDefaultTerminalWindows(),linux:await $.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class b extends c{static{this.b="cmd.exe"}openTerminal(u,t){return this.spawnTerminal(P,u,l.$Rl(),t)}spawnTerminal(u,t,o,r){const i=t.windowsExec||b.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=M.$nc(i,".exe").toLowerCase();if(n==="cmder")return u.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((w,A)=>{const I=d(process),E=u.spawn(o,a,{cwd:r,env:I,detached:!0});E.on("error",A),E.on("exit",()=>w())})}async runInTerminal(u,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:b.getDefaultTerminalWindows(),a=await b.f();return new Promise((w,A)=>{const I=`"${t} - ${p}"`,E=`""${o.join('" "')}" & pause"`,C=Object.assign({},d(process),r);Object.keys(C).filter(K=>C[K]===null).forEach(K=>delete C[K]);const j={cwd:t,env:C,windowsVerbatimArguments:!0};let W,T;M.$nc(n,".exe")==="wt"?(W=n,T=["-d",".",b.b,"/c",E]):a?(W=a,T=["-d",t,n,"/c",E]):(W=b.b,T=["/c","start",I,"/wait",n,"/c",E]),P.spawn(W,T,j).on("error",K=>{A(h(K))}),w(void 0)})}static getDefaultTerminalWindows(){if(!b.d){const u=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");b.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${u?"Sysnative":"System32"}\\cmd.exe`}return b.d}static async f(){try{const u=await l.win32.findExecutable("wt");return await f.Promises.exists(u)?u:void 0}catch{return}}}e.$r0b=b,Ee([R.$vh],b,"f",null);class m extends c{static{this.b="/usr/bin/osascript"}openTerminal(u,t){return this.spawnTerminal(P,u,t)}runInTerminal(u,t,o,r,i){const n=i.osxExec||k.$u2b;return new Promise((a,w)=>{if(n===k.$u2b||n==="iTerm.app"){const A=n===k.$u2b?"TerminalHelper":"iTermHelper",E=[s.$mg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${A}.scpt`).fsPath,"-t",u||p,"-w",t];for(const W of o)E.push("-a"),E.push(W);if(r){const W=Object.assign({},d(process),r);for(const T in W){const G=W[T];G===null?(E.push("-u"),E.push(T)):(E.push("-e"),E.push(`${T}=${G}`))}}let C="";const j=P.spawn(m.b,E);j.on("error",W=>{w(h(W))}),j.stderr.on("data",W=>{C+=W.toString()}),j.on("exit",W=>{if(W===0)a(void 0);else if(C){const T=C.split(`
`,1);w(new Error(T[0]))}else w(new Error(y.localize(1,null,A,W)))})}else w(new Error(y.localize(2,null,n)))})}spawnTerminal(u,t,o){const r=t.osxExec||k.$u2b;return new Promise((i,n)=>{const a=["-a",r];o&&a.push(o);const w=d(process),A=u.spawn("/usr/bin/open",a,{cwd:o,env:w});A.on("error",n),A.on("exit",()=>i())})}}e.$s0b=m;class $ extends c{static{this.b=y.localize(3,null)}openTerminal(u,t){return this.spawnTerminal(P,u,t)}runInTerminal(u,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((a,w)=>{const A=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?A.push("-x"):A.push("-e"),A.push("bash"),A.push("-c");const E=`${g(o)}; echo; read -p "${$.b}" -n1;`;A.push(`''${E}''`);const C=Object.assign({},d(process),r);Object.keys(C).filter(G=>C[G]===null).forEach(G=>delete C[G]);const j={cwd:t,env:C};let W="";const T=P.spawn(I,A,j);T.on("error",G=>{w(h(G))}),T.stderr.on("data",G=>{W+=G.toString()}),T.on("exit",G=>{if(G===0)a(void 0);else if(W){const K=W.split(`
`,1);w(new Error(K[0]))}else w(new Error(y.localize(4,null,I,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!$.d)if(!D.$k)$.d=Promise.resolve("xterm");else{const u=await f.Promises.exists("/etc/debian_version");$.d=new Promise(t=>{u?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return $.d}spawnTerminal(u,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):$.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(a=>{const w=d(process),A=u.spawn(a,[],{cwd:o,env:w});A.on("error",n),A.on("exit",()=>i())})})}}e.$t0b=$;function d(v){const u={...v.env};return(0,S.$Pl)(u),u}function h(v){return"errno"in v&&v.errno==="ENOENT"&&"path"in v&&typeof v.path=="string"?new Error(y.localize(5,null,v.path)):v}function g(v){let u="";for(const t of v)t.indexOf(" ")>=0?u+='"'+t+'"':u+=t,u+=" ";return u}}),define(oe[16],ae([0,1,57,9,25,12,7,176,6,4,13,62]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.FileKind=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.FileOperationResult=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileChangeType=e.$Gk=e.FileOperation=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileSystemProviderErrorCode=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileSystemProviderCapabilities=e.$qk=e.FilePermission=e.FileType=e.$pk=e.$ok=void 0,e.$ok=(0,f.$4h)("fileService");function p(q){return q.create===!0}e.$pk=p;var c;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var b;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function m(q){const te=q;return!!te&&typeof te.onDidChange=="function"}e.$qk=m;var $;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function d(q){return!!(q.capabilities&2)}e.$rk=d;function h(q){return!!(q.capabilities&8)}e.$sk=h;function g(q){return!!(q.capabilities&131072)}e.$tk=g;function v(q){return!!(q.capabilities&4)}e.$uk=v;function u(q){return!!(q.capabilities&16)}e.$vk=u;function t(q){return d(q)?!!(q.capabilities&16384):!1}e.$wk=t;function o(q){return d(q)?!!(q.capabilities&32768):!1}e.$xk=o;function r(q){return!!(q.capabilities&65536)}e.$yk=r;function i(q){return!!(q.capabilities&2048)}e.$zk=i;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(te,he){const J=new a(te.toString(),he);return I(J,he),J}constructor(te,he){super(te),this.code=he}}e.$Ak=a;function w(q,te){return a.create(q,te)}e.$Bk=w;function A(q){return q||w((0,S.localize)(0,null),n.Unknown)}e.$Ck=A;function I(q,te){return q.name=te?`${te} (FileSystemError)`:"FileSystemError",q}e.$Dk=I;function E(q){if(!q)return n.Unknown;if(q instanceof a)return q.code;const te=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!te)return n.Unknown;switch(te[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Ek=E;function C(q){if(q instanceof le)return q.fileOperationResult;switch(E(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Fk=C;var j;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(j||(e.FileOperation=j={}));class W{constructor(te,he,J){this.resource=te,this.operation=he,this.target=J}isOperation(te){return this.operation===te}}e.$Gk=W;var T;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class G{static{this.a=null}constructor(te,he){this.c=he,this.b=void 0,this.d=new k.$V(()=>{const J=P.$0h.forUris(()=>this.c);return J.fill(this.rawAdded.map(O=>[O,!0])),J}),this.f=new k.$V(()=>{const J=P.$0h.forUris(()=>this.c);return J.fill(this.rawUpdated.map(O=>[O,!0])),J}),this.g=new k.$V(()=>{const J=P.$0h.forUris(()=>this.c);return J.fill(this.rawDeleted.map(O=>[O,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of te){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==G.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(te,...he){return this.h(te,{includeChildren:!1},...he)}affects(te,...he){return this.h(te,{includeChildren:!0},...he)}h(te,he,...J){if(!te)return!1;const O=J.length>0;return!!((!O||J.includes(1))&&(this.d.value.get(te)||he.includeChildren&&this.d.value.findSuperstr(te))||(!O||J.includes(0))&&(this.f.value.get(te)||he.includeChildren&&this.f.value.findSuperstr(te))||(!O||J.includes(2))&&(this.g.value.findSubstr(te)||he.includeChildren&&this.g.value.findSuperstr(te)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(te){return this.b===te}hasCorrelation(){return typeof this.b=="number"}}e.$Hk=G;function K(q,te,he){return!q||!te||q===te||te.length>q.length?!1:(te.charAt(te.length-1)!==R.sep&&(te+=R.sep),he?(0,s.$$e)(q,te):q.indexOf(te)===0)}e.$Ik=K;class le extends Error{constructor(te,he,J){super(te),this.fileOperationResult=he,this.options=J}}e.$Jk=le;class re extends le{constructor(te,he,J,O){super(te,he,O),this.fileOperationResult=he,this.size=J}}e.$Kk=re;class ue extends le{constructor(te,he,J){super(te,2,J),this.stat=he}}e.$Lk=ue;var Y;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Mk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Nk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ok="files.associations",e.$Pk="files.exclude",e.$Qk="files.readonlyInclude",e.$Rk="files.readonlyExclude",e.$Sk="files.readonlyFromPermissions";var Z;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$Tk="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Uk=H;async function L(q,te){if(!te.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(he=>{const J=te.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(J.dispose(),he())})})}e.$Vk=L;class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(te){return(0,M.$Kf)(te)||(te=0),te<U.KB?(0,S.localize)(1,null,te.toFixed(0)):te<U.MB?(0,S.localize)(2,null,(te/U.KB).toFixed(2)):te<U.GB?(0,S.localize)(3,null,(te/U.MB).toFixed(2)):te<U.TB?(0,S.localize)(4,null,(te/U.GB).toFixed(2)):(0,S.localize)(5,null,(te/U.TB).toFixed(2))}}e.$Wk=U;function V(q){const te=typeof q=="string"||q?.scheme===y.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===y.Schemas.file?1024*U.MB:te?10*U.MB:l.$o?50*U.MB:1024*U.MB}e.$Xk=V}),define(oe[118],ae([0,1,18,14,177,16]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;async function D(y,k,p,c,b,m){let $;try{await S(y,k,p,c,b,m)}catch(d){$=d}finally{$&&b.errorTransformer&&($=b.errorTransformer($)),typeof $<"u"&&p.error($),p.end()}}e.$3p=D;async function S(y,k,p,c,b,m){f(m);const $=await y.open(k,{create:!1});try{f(m);let d=0,h=0,g=b&&typeof b.length=="number"?b.length:void 0,v=P.$he.alloc(Math.min(b.bufferSize,typeof g=="number"?g:b.bufferSize)),u=b&&typeof b.position=="number"?b.position:0,t=0;do h=await y.read($,u,v.buffer,t,v.byteLength-t),u+=h,t+=h,d+=h,typeof g=="number"&&(g-=h),t===v.byteLength&&(await p.write(c(v)),v=P.$he.alloc(Math.min(b.bufferSize,typeof g=="number"?g:b.bufferSize)),t=0);while(h>0&&(typeof g!="number"||g>0)&&f(m)&&l(d,b));if(t>0){let o=t;typeof g=="number"&&(o=Math.min(t,g)),p.write(c(v.slice(0,o)))}}catch(d){throw(0,M.$Ck)(d)}finally{await y.close($)}}function f(y){if(y.isCancellationRequested)throw(0,R.$6)();return!0}function l(y,k){if(typeof k?.limits?.size=="number"&&y>k.limits.size)throw(0,M.$Bk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[67],ae([0,1,104,2,9,4,7,16]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=void 0;function f(d){return d.recursive===!0}e.$5p=f;class l extends R.$Tc{static{this.a=5}constructor(h,g,v,u){super(),this.h=h,this.j=g,this.m=v,this.n=u,this.c=this.B(new R.$Uc),this.f=void 0,this.g=0}s(){const h=new R.$Sc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(g=>this.h(g))),h.add(this.b.onDidLogMessage(g=>this.j(g))),h.add(this.b.onDidError(g=>this.t(g)))}t(h){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6p=l;class y extends l{constructor(h,g,v){super(h,g,v,{type:"node.js",restartOnError:!1})}}e.$7p=y;class k extends l{constructor(h,g,v){super(h,g,v,{type:"universal",restartOnError:!0})}}e.$8p=k;function p(d){return d.map(h=>({type:h.type,resource:D.URI.revive(h.resource),cId:h.cId}))}e.$9p=p;function c(d){const h=new $;for(const g of d)h.processEvent(g);return h.coalesce()}e.$0p=c;function b(d,h){return typeof h=="string"&&!h.startsWith(P.$Gj)&&!(0,s.$ic)(h)?{base:d,pattern:h}:h}e.$$p=b;function m(d,h){const g=[];for(const v of h)g.push((0,P.$Kj)(b(d,v)));return g}e.$_p=m;class ${constructor(){this.a=new Set,this.b=new Map}c(h){return M.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const g=this.b.get(this.c(h));let v=!1;if(g){const u=g.type,t=h.type;g.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?v=!0:u===1&&t===2?(this.b.delete(this.c(h)),this.a.delete(g)):u===2&&t===1?g.type=0:u===1&&t===0||(g.type=t)}else v=!0;v&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],g=[];return Array.from(this.a).filter(v=>v.type!==2?(h.push(v),!1):!0).sort((v,u)=>v.resource.fsPath.length-u.resource.fsPath.length).filter(v=>g.some(u=>(0,S.$Ik)(v.resource.fsPath,u,!M.$k))?!1:(g.push(v.resource.fsPath),!0)).concat(h)}}}),define(oe[213],ae([0,1,18,51,14,3,2,63,32,16,67]),function(Q,e,P,R,s,M,D,S,f,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0,e.$5N="localFilesystem";class k extends D.$Tc{constructor(c,b){super(),this.a=c,this.b=b,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$Td),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$Td),this.onDidWatchError=this.g.event,this.h=(0,f.$og)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,b){const{buffer:m}=await this.a.call("readFile",[c,b]);return m}readFileStream(c,b,m){const $=(0,S.$8d)(h=>P.$he.concat(h.map(g=>P.$he.wrap(g))).buffer),d=new D.$Sc;return d.add(this.a.listen("readFileStream",[c,b])(h=>{if(h instanceof P.$he)$.write(h.buffer);else{if(h==="end")$.end();else{let g;if(h instanceof Error)g=h;else{const v=h;g=(0,l.$Bk)(v.message??(0,R.$Oi)(v),v.code??l.FileSystemProviderErrorCode.Unknown)}$.error(g),$.end()}d.dispose()}})),d.add(m.onCancellationRequested(()=>{$.error((0,s.$6)()),$.end(),d.dispose()})),$}writeFile(c,b,m){return this.a.call("writeFile",[c,P.$he.wrap(b),m])}open(c,b){return this.a.call("open",[c,b])}close(c){return this.a.call("close",[c])}async read(c,b,m,$,d){const[h,g]=await this.a.call("read",[c,b,d]);return m.set(h.buffer.slice(0,g),$),g}write(c,b,m,$,d){return this.a.call("write",[c,b,P.$he.wrap(m),$,d])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,b){return this.a.call("delete",[c,b])}rename(c,b,m){return this.a.call("rename",[c,b,m])}copy(c,b,m){return this.a.call("copy",[c,b,m])}cloneFile(c,b){return this.a.call("cloneFile",[c,b])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const b=c;this.f.fire((0,y.$9p)(b))}else{const b=c;this.g.fire(b)}}))}watch(c,b){const m=(0,f.$og)();return this.a.call("watch",[this.h,m,c,b]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,m]))}}e.$6N=k}),define(oe[214],ae([0,1,46,8,22,33,2,85,9,4,19,7,105,21,67]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0;class m extends D.$Tc{static{this.a=100}static{this.b=75}constructor(h,g,v,u){super(),this.m=h,this.n=g,this.r=v,this.s=u,this.c=this.B(new R.$gh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$fh(t=>this.z(t),m.b)),this.g=(0,b.$_p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,b.$_p)(this.m.path,this.m.includes):void 0,this.j=new s.$4d,this.ready=this.t()}async t(){try{const h=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const g=await c.Promises.stat(h);this.B(await this.w(h,g.isDirectory()))}catch(h){h.code!=="ENOENT"?this.D(h):this.G(h)}}async u(h){let g=h.path;try{g=await c.Promises.realpath(h.path),h.path===g&&(g=await(0,p.$jq)(h.path)??h.path),h.path!==g&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${h.path}, real: ${g})`)}catch{}return g}async w(h,g){if(l.$j&&(0,M.$6f)(h,"/Volumes/",!0))return this.D(`Refusing to watch ${h} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const v=new s.$4d(this.j.token),u=new D.$Sc;try{const t=k.URI.file(this.m.path),o=(0,f.$nc)(h),r=(0,P.watch)(h);u.add((0,D.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${h}'`);const i=new Set;if(g)try{for(const a of await c.Promises.readdir(h))i.add(a)}catch(a){this.D(a)}const n=new Map;u.add((0,D.$Rc)(()=>{for(const[,a]of n)a.dispose();n.clear()})),r.on("error",(a,w)=>{this.D(`Failed to watch ${h} for changes using fs.watch() (${a}, ${w})`),this.dispose()}),r.on("change",(a,w)=>{if(v.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${w}`);let A="";if(w&&(A=w.toString(),l.$j&&(A=(0,S.$El)(A))),!(!A||a!=="change"&&a!=="rename"))if(g)if(a==="rename"){n.get(A)?.dispose();const I=setTimeout(async()=>{if(n.delete(A),A===o&&!await c.Promises.exists(h)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,f.$jc)(h,A));if(v.token.isCancellationRequested)return;let C;E?i.has(A)?C=0:(C=1,i.add(A)):(i.delete(A),C=2),this.y({resource:(0,y.$Fg)(t,A),type:C,cId:this.m.correlationId})},m.a);n.set(A,(0,D.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(A)?I=0:(I=1,i.add(A)),this.y({resource:(0,y.$Fg)(t,A),type:I,cId:this.m.correlationId})}else if(a==="rename"||A!==o){const I=setTimeout(async()=>{const E=await c.Promises.exists(h);v.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),u.add(await this.w(h,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},m.a);u.clear(),u.add((0,D.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await c.Promises.exists(h)&&!v.token.isCancellationRequested&&this.D(`Failed to watch ${h} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{v.dispose(!0),u.dispose()})}y(h,g=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`),!g&&this.g.some(v=>v(h.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${h.resource.fsPath}`):!g&&this.h&&this.h.length>0&&!this.h.some(v=>v(h.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${h.resource.fsPath}`):this.f.work(h))}z(h){const g=(0,b.$0p)(h);if(g.length>0){if(this.s)for(const u of g)this.G(` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`);this.c.work(g)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(h){if(l.$k)return c.Promises.exists(h);try{const g=(0,f.$nc)(h);return(await c.Promises.readdir((0,f.$mc)(h))).some(u=>u===g)}catch(g){return this.G(g),!1}}setVerboseLogging(h){this.s=h}D(h){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${h}`})}F(h){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${h}`})}G(h){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${h}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$mq=m;async function $(d,h,g,v,u=512){const t=await c.Promises.open(d,"r"),o=Buffer.allocUnsafe(u),r=new s.$4d(v);let i,n=!1;const a={path:d,excludes:[],recursive:!1},w=new m(a,A=>{(async()=>{for(const{type:I}of A)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await c.Promises.read(t,o,0,u,null);if(!E||r.token.isCancellationRequested)break;h(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await w.ready,g(),new Promise((A,I)=>{r.token.onCancellationRequested(async()=>{w.dispose();try{await c.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):A()})})}e.$nq=$}),define(oe[215],ae([0,1,3,104,2,4,214]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class S extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new P.$Td),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Td),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const y=this.j(l),k=y.filter(c=>{const b=this.c.get(c.path);return b?!(0,R.$Oj)(b.request.excludes,c.excludes)||!(0,R.$Oj)(b.request.includes,c.includes):!0}),p=Array.from(this.c.values()).filter(({request:c})=>!y.find(b=>b.path===c.path&&(0,R.$Oj)(b.excludes,c.excludes)&&(0,R.$Oj)(b.includes,c.includes))).map(({request:c})=>c.path);k.length&&this.m(`Request to start watching: ${k.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),p.length&&this.m(`Request to stop watching: ${p.join(",")}`);for(const c of p)this.h(c);for(const c of k)this.g(c)}g(l){const y=new D.$mq(l,p=>this.a.fire(p),p=>this.b.fire(p),this.f),k={request:l,instance:y};this.c.set(l.path,k)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const y=this.c.get(l);y&&(this.c.delete(l),y.instance.dispose())}j(l){const y=new Map;for(const k of l){const p=M.$k?k.path:k.path.toLowerCase();let c=y.get(k.correlationId);c||(c=new Map,y.set(k.correlationId,c)),c.set(p,k)}return Array.from(y.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(l){this.f=l;for(const[,y]of this.c)y.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,y){return y?`[File Watcher (node.js)] ${l} (path: ${y.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$oq=S}),define(oe[216],ae([0,1,67,215]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;class s extends P.$7p{constructor(D,S,f){super(D,S,f),this.s()}r(D){return D.add(new R.$oq)}}e.$pq=s}),define(oe[217],ae([0,1,13,42,160,67]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class D extends M.$8p{constructor(f,l,y){super(f,l,y),this.s()}r(f){const l=f.add(new s.$gq(P.$mg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:y,signal:k})=>this.t(`terminated by itself with code ${y}, signal: ${k}`))),R.ProxyChannel.toService((0,R.$Kh)(l.getChannel("watcher")))}}e.$hq=D}),define(oe[92],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$2h=P}),define(oe[218],ae([0,1,8,14,2,78,208,6,92,101]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0;const y=!1;class k extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class p{constructor($=new f.$2h,d=!1,h,g=y){this.f=$,this.g=d,this.h=h,this.i=g,this.o=new Set,this.f.set(S.$3h,this),this._globalGraph=g?h?._globalGraph??new D.$sq(v=>v):void 0}createChild($){return new p($,this.g,this,this.i)}invokeFunction($,...d){const h=b.traceInvocation(this.i,$);let g=!1;try{return $({get:u=>{if(g)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,h);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...d)}finally{g=!0,h.stop()}}createInstance($,...d){let h,g;return $ instanceof M.$1h?(h=b.traceCreation(this.i,$.ctor),g=this.j($.ctor,$.staticArguments.concat(d),h)):(h=b.traceCreation(this.i,$),g=this.j($,d,h)),h.stop(),g}j($,d=[],h){const g=S._util.getServiceDependencies($).sort((t,o)=>t.index-o.index),v=[];for(const t of g){const o=this.m(t.id,h);o||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${t.id}.`,!1),v.push(o)}const u=g.length>0?g[0].index:d.length;if(d.length!==u){console.trace(`[createInstance] First service dependency of ${$.name} at position ${u+1} conflicts with ${d.length} static arguments`);const t=u-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,u)}return Reflect.construct($,d.concat(v))}k($,d){if(this.f.get($)instanceof M.$1h)this.f.set($,d);else if(this.h)this.h.k($,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const d=this.f.get($);return!d&&this.h?this.h.l($):d}m($,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const h=this.l($);return h instanceof M.$1h?this.q($,h,d.branch($,!0)):(d.branch($,!1),h)}q($,d,h){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,d,h)}finally{this.o.delete($)}}r($,d,h){const g=new D.$sq(t=>t.id.toString());let v=0;const u=[{id:$,desc:d,_trace:h}];for(;u.length;){const t=u.pop();if(g.lookupOrInsertNode(t),v++>1e3)throw new k(g);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${$} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof M.$1h){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};g.insertEdge(t,i),u.push(i)}}}for(;;){const t=g.roots();if(t.length===0){if(!g.isEmpty())throw new k(g);break}for(const{data:o}of t){if(this.l(o.id)instanceof M.$1h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}g.removeNode(o)}}return this.l($)}s($,d,h=[],g,v){if(this.f.get($)instanceof M.$1h)return this.t($,d,h,g,v);if(this.h)return this.h.s($,d,h,g,v);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t($,d,h=[],g,v){if(g){const u=new p(void 0,this.g,this,this.i);u.c=String($);const t=new Map,o=new P.$kh(()=>{const r=u.j(d,h,v);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const w of n)a.apply(r,w)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let w=t.get(i);return w||(w=new l.$4c,t.set(i,w)),(I,E,C)=>{const j=w.push([I,E,C]);return(0,s.$Rc)(j)}}if(i in r)return r[i];const n=o.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,h,v)}u($,d){if(d&&console.warn($),this.g)throw new Error($)}}e.$tq=p;var c;(function(m){m[m.None=0]="None",m[m.Creation=1]="Creation",m[m.Invocation=2]="Invocation",m[m.Branch=3]="Branch"})(c||(c={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,d){return $?new b(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation($,d){return $?new b(1,d.name):b.c}static{this.f=0}constructor($,d){this.type=$,this.name=d,this.g=Date.now(),this.h=[]}branch($,d){const h=new b(3,$.toString());return this.h.push([$,d,h]),h}stop(){const $=Date.now()-this.g;b.f+=$;let d=!1;function h(v,u){const t=[],o=new Array(v+1).join("	");for(const[r,i,n]of u.h)if(i&&n){d=!0,t.push(`${o}CREATES -> ${r}`);const a=h(v+1,n);a&&t.push(a)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const g=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];($>2||d)&&b.all.add(g.join(`
`))}}e.$uq=b}),define(oe[219],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jzb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$jzb=(0,P.$4h)("issueService")}),define(oe[5],ae([0,1,51,3,45,2,31,4,19,12,7,114,6]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.log=e.$oj=e.LogLevel=e.$nj=e.$mj=e.$lj=void 0,e.$lj=(0,p.$4h)("logService"),e.$mj=(0,p.$4h)("loggerService");function c(){return new Date().toISOString()}function b(I){return(0,l.$Kf)(I)}e.$nj=b;var m;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$oj=m.Info;function $(I,E,C){switch(E){case m.Trace:I.trace(C);break;case m.Debug:I.debug(C);break;case m.Info:I.info(C);break;case m.Warning:I.warn(C);break;case m.Error:I.error(C);break;case m.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=$;function d(I,E=!1){let C="";for(let j=0;j<I.length;j++){let W=I[j];if(W instanceof Error&&(W=(0,P.$Oi)(W,E)),typeof W=="object")try{W=JSON.stringify(W)}catch{}C+=(j>0?" ":"")+W}return C}class h extends M.$Tc{constructor(){super(...arguments),this.b=e.$oj,this.c=this.B(new R.$Td),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==m.Off&&this.b<=E}}e.$qj=h;class g extends h{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...C){this.f(m.Trace)&&this.g(m.Trace,d([E,...C],!0))}debug(E,...C){this.f(m.Debug)&&this.g(m.Debug,d([E,...C]))}info(E,...C){this.f(m.Info)&&this.g(m.Info,d([E,...C]))}warn(E,...C){this.f(m.Warning)&&this.g(m.Warning,d([E,...C]))}error(E,...C){if(this.f(m.Error))if(E instanceof Error){const j=Array.prototype.slice.call(arguments);j[0]=E.stack,this.g(m.Error,d(j))}else this.g(m.Error,d([E,...C]))}flush(){}}e.$rj=g;class v extends h{constructor(E=e.$oj){super(),this.setLevel(E),this.g=!S.$i}trace(E,...C){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,E,...C):console.log(`[main ${c()}]`,E,...C))}debug(E,...C){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,E,...C):console.log(`[main ${c()}]`,E,...C))}info(E,...C){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,E,...C):console.log(`[main ${c()}]`,E,...C))}warn(E,...C){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,E,...C):console.warn(`[main ${c()}]`,E,...C))}error(E,...C){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,E,...C):console.error(`[main ${c()}]`,E,...C))}flush(){}}e.$sj=v;class u extends h{constructor(E=e.$oj,C=!0){super(),this.g=C,this.setLevel(E)}trace(E,...C){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...C):console.log(E,...C))}debug(E,...C){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...C):console.log(E,...C))}info(E,...C){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...C):console.log(E,...C))}warn(E,...C){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...C):console.log(E,...C))}error(E,...C){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...C):console.error(E,...C))}flush(){}}e.$tj=u;class t extends h{constructor(E,C=e.$oj){super(),this.g=E,this.setLevel(C)}trace(E,...C){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(E),...C])}debug(E,...C){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(E),...C])}info(E,...C){this.f(m.Info)&&this.g.log(m.Info,[this.h(E),...C])}warn(E,...C){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(E),...C])}error(E,...C){this.f(m.Error)&&this.g.log(m.Error,[this.h(E),...C])}h(E){return typeof E=="string"?E:(0,P.$Oi)(E,this.f(m.Trace))}flush(){}}e.$uj=t;class o extends h{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const C of this.g)C.setLevel(E);super.setLevel(E)}trace(E,...C){for(const j of this.g)j.trace(E,...C)}debug(E,...C){for(const j of this.g)j.debug(E,...C)}info(E,...C){for(const j of this.g)j.info(E,...C)}warn(E,...C){for(const j of this.g)j.warn(E,...C)}error(E,...C){for(const j of this.g)j.error(E,...C)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$vj=o;class r extends M.$Tc{constructor(E,C,j){if(super(),this.h=E,this.j=C,this.b=new D.$Ac,this.c=this.B(new R.$Td),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Td),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Td),this.onDidChangeVisibility=this.g.event,j)for(const W of j)this.b.set(W.resource,{logger:void 0,info:W})}m(E){return(0,l.$Gf)(E)?[...this.b.values()].find(C=>C.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,C){const j=this.n(E),W=(0,l.$Gf)(E)?E:C?.id??(0,s.$Ri)(j.toString()).toString(16);let T=this.b.get(j)?.logger;const G=C?.logLevel==="always"?m.Trace:C?.logLevel;T||(T=this.s(j,G??this.getLogLevel(j)??this.h,{...C,id:W}));const K={logger:T,info:{resource:j,id:W,logLevel:G,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(K.info),this.b.set(j,K),T}n(E){return(0,l.$Gf)(E)?(0,f.$Fg)(this.j,`${E}.log`):E}setLogLevel(E,C){if(y.URI.isUri(E)){const j=E,W=C,T=this.b.get(j);T&&W!==T.info.logLevel&&(T.info.logLevel=W===this.h?void 0:W,T.logger?.setLevel(W),this.b.set(T.info.resource,T),this.f.fire([j,W]))}else{this.h=E;for(const[j,W]of this.b.entries())this.b.get(j)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,C){const j=this.m(E);j&&C!==!j.info.hidden&&(j.info.hidden=!C,this.b.set(j.info.resource,j),this.g.fire([j.info.resource,C]))}getLogLevel(E){let C;return E&&(C=this.b.get(E)?.info.logLevel),C??this.h}registerLogger(E){const C=this.b.get(E.resource);C?C.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const C=this.b.get(E);C&&(C.logger&&C.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$wj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$Td().event}setLevel(E){}getLevel(){return m.Info}trace(E,...C){}debug(E,...C){}info(E,...C){}warn(E,...C){}error(E,...C){}critical(E,...C){}dispose(){}flush(){}}e.$xj=i;class n extends i{}e.$yj=n;function a(I){if(I.verbose)return m.Trace;if(typeof I.logLevel=="string"){const E=A(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$oj}e.$zj=a;function w(I){switch(I){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}e.$Aj=w;function A(I){switch(I){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$Bj=A,e.$Cj=new k.$ij("logLevel",w(m.Info))});var ne=this&&this.__param||function(Q,e){return function(P,R){e(P,R,Q)}};define(oe[220],ae([0,1,15,4,5]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m0b=void 0;const M=P.safeStorage;let D=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(M.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(f){let l;try{if(l=JSON.parse(f),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const y=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const k=M.decryptString(y);return this.a.trace("[EncryptionMainService] Decrypted value."),k}catch(y){throw this.a.error(y),y}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$m0b=D,e.$m0b=D=Ee([ne(0,s.$lj)],D)}),define(oe[221],ae([0,1,23,8,14,3,2,9,67,5]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class y extends D.$Tc{constructor(p,c){super(),this.a=p,this.b=c,this.c=this.B(new M.$Td),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$Td),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$2g(0)),this.w=[],this.y=this.B(new R.$2g(0))}watch(p,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(p,c):this.z(p,c)}n(p,c){const b={path:this.H(p),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},m=(0,P.$Ub)(this.j,b);return this.r(),(0,D.$Rc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(p=>(0,s.$1)(p))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,f.$9p)(c)),c=>this.G(c),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const c of this.j)(0,f.$5p)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const c of this.j)(0,f.$5p)(c)&&p.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(p,c){const b={path:this.H(p),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},m=(0,P.$Ub)(this.w,b);return this.C(),(0,D.$Rc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(p=>(0,s.$1)(p))}D(){return this.u||(this.u=this.B(this.F(p=>this.c.fire((0,f.$9p)(p)),p=>this.G(p),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}H(p){return(0,S.$hc)(p.fsPath)}}e.$aq=y}),define(oe[222],ae([0,1,23,8,18,22,3,45,72,2,57,13,68,19,63,175,16,118,5,14]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;let u=class extends l.$Tc{static{v=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Td),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Td),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Td),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Td),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Td),this.Y=this.B(new D.$Td),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Td),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$ah)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${o}`);const i=new l.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const a=new $.$Hk(n,!this.S(r));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,l.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,l.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return f.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,c.$Jg)(o))throw new $.$Jk((0,m.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new g.$bb;throw i.message=(0,m.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,$.$uk)(r)||(0,$.$rk)(r)||(0,$.$vk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,$.$uk)(r)||(0,$.$rk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,$.$Ek)(i)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Jk((0,m.localize)(2,null,this.sb(o)),1):(0,$.$Ck)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),a=r?.resolveTo,w=r?.resolveSingleChildDescendants,A=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!A,(C,j)=>(E||(E=y.$0h.forUris(()=>!n),E.set(o,!0),a&&E.fill(!0,a)),E.get(C.resource)||E.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&w?j===1:!1))}async t(o,r,i,n,a,w){const{providerExtUri:A}=this.R(o),I={resource:r,name:A.basename(r),isFile:(i.type&$.FileType.File)!==0,isDirectory:(i.type&$.FileType.Directory)!==0,isSymbolicLink:(i.type&$.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&$.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Uk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&w(I,n)){try{const E=await o.readdir(r),C=await R.Promises.settled(E.map(async([j,W])=>{try{const T=A.joinPath(r,j),G=a?await o.stat(T):{type:W};return await this.t(o,T,G,E.length,a,w)}catch(T){return this.b.trace(T),null}}));I.children=(0,P.$Hb)(C)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new $.$Jk((0,m.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$he.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new $.$Gk(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(n);let w=i;if((0,$.$xk)(n)&&!w?.atomic){const A=n.enforceAtomicWriteFile?.(o);A&&(w={...i,atomic:A})}try{await this.w(n,o,w)||await this.U(n,a.dirname(o));let I;if((0,$.$rk)(n)&&!(r instanceof s.$he))if((0,b.$6d)(r)){const E=await(0,b.$ae)(r,3);E.ended?I=s.$he.concat(E.buffer):I=E}else I=(0,b.$0d)(r,E=>s.$he.concat(E),3);else I=r;!(0,$.$uk)(n)||(0,$.$rk)(n)&&I instanceof s.$he||(0,$.$rk)(n)&&(0,$.$xk)(n)&&w?.atomic?await this.hb(n,o,w,I):await this.db(n,o,w,I instanceof s.$he?(0,s.$se)(I):I),this.r.fire(new $.$Gk(o,4))}catch(A){throw new $.$Jk((0,m.localize)(4,null,this.sb(o),(0,$.$Ck)(A).toString()),(0,$.$Fk)(A),w)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,m.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,m.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,m.localize)(7,null,this.sb(r)));if(n)throw new Error((0,m.localize)(8,null,this.sb(r)))}let w;try{w=await o.stat(r)}catch{return}if(w.type&$.FileType.Directory)throw new $.$Jk((0,m.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,w),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==$.$Tk&&typeof w.mtime=="number"&&typeof w.size=="number"&&i.mtime<w.mtime&&i.etag!==(0,$.$Uk)({mtime:i.mtime,size:w.size}))throw new $.$Jk((0,m.localize)(10,null),3,i);return w}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((a,w)=>{this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{try{const A=await this.C(o,r,i,n);a(A)}catch(A){w(A)}})})}async C(o,r,i,n){const a=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.$te)(a.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const a=new M.$4d(n);let w=i;(0,$.$wk)(o)&&o.enforceAtomicReadFile?.(r)&&(w={...i,atomic:!0});const A=this.J(r,w).then(E=>E,E=>{throw a.dispose(!0),E});let I;try{return typeof w?.etag=="string"&&w.etag!==$.$Tk&&await A,w?.atomic&&(0,$.$wk)(o)||!((0,$.$uk)(o)||(0,$.$vk)(o))||(0,$.$rk)(o)&&w?.preferUnbuffered?I=this.I(o,r,w):(0,$.$vk)(o)?I=this.G(o,r,a.token,w):I=this.H(o,r,a.token,w),I.on("end",()=>a.dispose()),I.on("error",()=>a.dispose()),{...await A,value:I}}catch(E){throw I&&await(0,b.$$d)(I),this.F(E,r,w)}}F(o,r,i){const n=(0,m.localize)(11,null,this.sb(r),(0,$.$Ck)(o).toString());return o instanceof $.$Lk?new $.$Lk(n,o.stat,i):o instanceof $.$Kk?new $.$Kk(n,o.fileOperationResult,o.size,o.options):new $.$Jk(n,(0,$.$Fk)(o),i)}G(o,r,i,n=Object.create(null)){const a=o.readFileStream(r,n,i);return(0,b.$ee)(a,{data:w=>w instanceof s.$he?w:s.$he.wrap(w),error:w=>this.F(w,r,n)},w=>s.$he.concat(w))}H(o,r,i,n=Object.create(null)){const a=(0,s.$xe)();return(0,d.$3p)(o,r,a,w=>w,{...n,bufferSize:this.a,errorTransformer:w=>this.F(w,r,n)},i),a}I(o,r,i){const n=(0,b.$8d)(a=>s.$he.concat(a));return(async()=>{try{let a;i?.atomic&&(0,$.$wk)(o)?a=await o.readFile(r,{atomic:!0}):a=await o.readFile(r),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.L(r,a.byteLength,i),n.end(s.$he.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new $.$Jk((0,m.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==$.$Tk&&r.etag===i.etag)throw new $.$Lk((0,m.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new $.$Kk((0,m.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const a=i==="move"?this.qb(await this.n(o),o):await this.m(o),w=this.qb(await this.n(r),r);await this.Q(a,o,w,r,i,n)}catch(a){return a}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),a=this.qb(await this.n(r),r),w=await this.N(n,o,a,r,"move",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Gk(o,w==="move"?2:3,A)),A}async copy(o,r,i){const n=await this.m(o),a=this.qb(await this.n(r),r),w=await this.N(n,o,a,r,"copy",!!i),A=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Gk(o,w==="copy"?3:2,A)),A}async N(o,r,i,n,a,w){if(r.toString()===n.toString())return a;const{exists:A,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,a,w);if(A&&!I&&w&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),a==="copy"){if(o===i&&(0,$.$sk)(o))await o.copy(r,n,{overwrite:w});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return a}else return o===i?(await o.rename(r,n,{overwrite:w}),a):(await this.N(o,r,i,n,"copy",w),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,$.$uk)(o)&&(0,$.$uk)(i))return this.jb(o,r,i,n);if((0,$.$uk)(o)&&(0,$.$rk)(i))return this.pb(o,r,i,n);if((0,$.$rk)(o)&&(0,$.$uk)(i))return this.nb(o,r,i,n);if((0,$.$rk)(o)&&(0,$.$rk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async a=>{const w=this.R(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),i,w):this.O(o,a.resource,i,w)}))}async Q(o,r,i,n,a,w){let A=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:C}=this.R(o);if(C||(A=E.isEqual(r,n)),A&&a==="copy")throw new Error((0,m.localize)(15,null,this.sb(r),this.sb(n)));if(!A&&E.isEqualOrParent(n,r))throw new Error((0,m.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!A){if(!w)throw new $.$Jk((0,m.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,m.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:A}}R(o){const r=this.S(o);return{providerExtUri:r?c.$vg:c.$xg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new $.$Gk(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&$.FileType.Directory))throw new Error((0,m.localize)(19,null,this.sb(r)));break}catch(a){if((0,$.$Ek)(a)!==$.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.mkdir(r)}catch(w){if((0,$.$Ek)(w)!==$.FileSystemProviderErrorCode.FileExists)throw w}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,m.localize)(20,null,this.sb(o)));const a=r?.atomic;if(a&&!(i.capabilities&65536))throw new Error((0,m.localize)(21,null,this.sb(o)));if(n&&a)throw new Error((0,m.localize)(22,null,this.sb(o)));let w;try{w=await i.stat(o)}catch{}if(w)this.rb(o,w);else throw new $.$Jk((0,m.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,m.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,$.$yk)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const a=!!n?.useTrash,w=!!n?.recursive,A=n?.atomic??!1;await i.delete(o,{recursive:w,useTrash:a,atomic:A}),this.r.fire(new $.$Gk(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(i===n&&this.R(i).providerExtUri.isEqual(o,r))return;if(i===n&&(0,$.$tk)(i))return i.cloneFile(o,r);await this.U(n,this.R(n).providerExtUri.dirname(r));const a=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,$.$sk)(i)?a.queue(()=>i.copy(o,r,{overwrite:!0})):a.queue(()=>this.O(i,o,n,r))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:v.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new l.$Sc;let n=!1,a=()=>{n=!0};i.add((0,l.$Rc)(()=>a())),(async()=>{try{const A=await this.bb(o,r);n?(0,l.$Oc)(A):a=()=>(0,l.$Oc)(A)}catch(A){this.b.error(A)}})();const w=r.correlationId;if(typeof w=="number"){const A=i.add(new D.$Td);return i.add(this.X.event(E=>{E.correlates(w)&&A.fire(E)})),{onDidChange:A.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,S.$Ri)([this.R(i).providerExtUri.getComparisonKey(o),r]);let a=this.$.get(n);return a||(a={count:0,disposable:i.watch(o,r)},this.$.set(n,a)),a.count+=1,(0,l.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,l.$Oc)(a.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(async()=>{const a=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,b.$6d)(n)||(0,b.$7d)(n)?await this.eb(o,a,n):await this.fb(o,a,n)}catch(w){throw(0,$.$Ck)(w)}finally{await o.close(a)}})}async eb(o,r,i){let n=0,a;if((0,b.$7d)(i)){if(i.buffer.length>0){const w=s.$he.concat(i.buffer);await this.gb(o,r,w,w.byteLength,n,0),n+=w.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((w,A)=>{(0,b.$_d)(a,{onData:async I=>{a.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return A(E)}n+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>A(I),onEnd:()=>w()})})}async fb(o,r,i){let n=0,a;for(;(a=i.read())!==null;)await this.gb(o,r,a,a.byteLength,n,0),n+=a.byteLength}async gb(o,r,i,n,a,w){let A=0;for(;A<n;){const I=await o.write(r,a+A,i.buffer,w+A,n-A);A+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,this.R(o).providerExtUri).queue(()=>this.ib(o,r,i,n))}async ib(o,r,i,n){let a;n instanceof s.$he?a=n:(0,b.$6d)(n)?a=await(0,s.$te)(n):(0,b.$7d)(n)?a=await(0,s.$ue)(n):a=(0,s.$re)(n),await o.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,r,i,n))}async kb(o,r,i,n){let a,w;try{a=await o.open(r,{create:!1}),w=await i.open(n,{create:!0,unlock:!1});const A=s.$he.alloc(this.a);let I=0,E=0,C=0;do C=await o.read(a,I,A.buffer,E,A.byteLength-E),await this.gb(i,w,A,C,I,E),I+=C,E+=C,E===A.byteLength&&(E=0);while(C>0)}catch(A){throw(0,$.$Ck)(A)}finally{await R.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof w=="number"?i.close(w):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,r,i,n))}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,r,i,n))}async ob(o,r,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const w=await o.readFile(r);await this.gb(i,a,s.$he.wrap(w),w.byteLength,0,0)}catch(w){throw(0,$.$Ck)(w)}finally{await i.close(a)}}async pb(o,r,i,n){const a=await(0,s.$te)(this.H(o,r,M.CancellationToken.None));await this.hb(i,n,void 0,a)}qb(o,r){if(o.capabilities&2048)throw new $.$Jk((0,m.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&$.FilePermission.Readonly)throw new $.$Jk((0,m.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$4p=u,e.$4p=u=v=Ee([ne(0,h.$lj)],u)}),define(oe[93],ae([0,1,46,311,8,31,18,3,33,2,9,4,19,63,21,179,16,118,221,51,217,216]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0,(()=>{try{(0,R.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,g.$Oi)(o)}`)}})();class t extends h.$aq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$Ac(n=>p.$wg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await b.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:$.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await b.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let w;a.isSymbolicLink()?w=(await this.stat((0,p.$Fg)(r,a.name))).type:w=this.M(a),n.push([a.name,w])}catch(w){this.a.trace(w)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=$.FileType.Unknown:r.isFile()?n=$.FileType.File:r.isDirectory()?n=$.FileType.Directory:n=$.FileType.Unknown,i&&(n|=$.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$3g;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await b.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,c.$8d)(w=>D.$he.concat(w.map(A=>D.$he.wrap(A))).buffer);return(0,d.$3p)(this,r,a,w=>w.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,p.$Fg)((0,p.$Eg)(r),`${(0,p.$Cg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await b.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,a){const w=new l.$Sc;try{w.add(await this.O(r)),w.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,r,{overwrite:!0})}catch(A){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw A}}finally{w.dispose()}}async S(r,i,n,a){let w;try{const A=this.H(r);if(!n.create||!n.overwrite){if(await b.Promises.exists(A)){if(!n.overwrite)throw(0,$.$Bk)((0,m.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,$.$Bk)((0,m.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(w,0,i,0,i.byteLength)}catch(A){throw await this.gb(r,A)}finally{typeof w=="number"&&await this.close(w)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const a=this.H(r);let w;(0,$.$pk)(i)&&!n&&(w=await this.O(r));let A;try{if((0,$.$pk)(i)&&i.unlock)try{const{stat:E}=await b.SymlinkSupport.stat(a);E.mode&128||await b.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,$.$pk)(i)){if(k.$i)try{await b.Promises.truncate(a,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";A=await b.Promises.open(a,I)}catch(I){throw w?.dispose(),(0,$.$pk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(A,0),(0,$.$pk)(i)&&this.X.set(A,r),w){const I=this.W.get(A);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${A} (${a})`),this.W.set(A,w),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${A} (${a})`),I.dispose())}return A}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await b.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await b.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,w){const A=this.Z(r,i);let I=null;try{I=(await b.Promises.read(r,n,a,w,A)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,A,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const a=this.U.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,a+n):this.U.delete(r)))}async write(r,i,n,a,w){return(0,s.$lh)(()=>this.ab(r,i,n,a,w),100,3)}async ab(r,i,n,a,w){const A=this.Z(r,i);let I=null;try{I=(await b.Promises.write(r,n,a,w,A)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,A,I)}return I}async mkdir(r){try{await b.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,y.$jc)((0,y.$mc)(n),`${(0,y.$nc)(n)}${i.atomic.postfix}`)),await b.Promises.rm(n,b.RimRafMode.MOVE,a)}else try{await b.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let w=!1;try{const{stat:A,symbolicLink:I}=await b.SymlinkSupport.stat(n);w=A.isDirectory()&&!I}catch{}if(w)await b.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(r,i,n){const a=this.H(r),w=this.H(i);if(a!==w)try{await this.bb(r,i,"move",n.overwrite),await b.Promises.rename(a,w)}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(2,null,(0,y.$nc)(a),(0,y.$nc)((0,y.$mc)(w)),A.toString()))),this.fb(A)}}async copy(r,i,n){const a=this.H(r),w=this.H(i);if(a!==w)try{await this.bb(r,i,"copy",n.overwrite),await b.Promises.copy(a,w,{preserveSymlinks:!0})}catch(A){throw(A.code==="EINVAL"||A.code==="EBUSY"||A.code==="ENAMETOOLONG")&&(A=new Error((0,m.localize)(3,null,(0,y.$nc)(a),(0,y.$nc)((0,y.$mc)(w)),A.toString()))),this.fb(A)}}async bb(r,i,n,a){const w=this.H(r),A=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$5f)(w,A,!0)),I){if(n==="copy")throw(0,$.$Bk)((0,m.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const C=await this.L(r);if(!C)throw(0,$.$Bk)((0,m.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const j=await this.L(i);if(j){if(!a)throw(0,$.$Bk)((0,m.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);C.type&$.FileType.File&&j.type&$.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const a=this.H(r),w=this.H(i),A=!!(this.capabilities&1024);if((0,f.$5f)(a,w,!A))return;const I=new l.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await b.Promises.mkdir((0,y.$mc)(w),{recursive:!0}),await b.Promises.copyFile(a,w)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new v.$hq(a=>r(a),a=>i(a),n)}F(r,i,n){return new u.$pq(a=>r(a),a=>i(a),n)}fb(r){if(r instanceof $.$Ak)return r;let i=r,n;switch(r.code){case"ENOENT":n=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=$.FileSystemProviderErrorCode.Unknown;break;default:n=$.FileSystemProviderErrorCode.Unknown}return(0,$.$Bk)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await b.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,$.$Bk)(i,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$qq=t}),define(oe[223],ae([0,1,3,93,2,18,63,22]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=e.$Zr=void 0;class f extends s.$Tc{constructor(k,p){super(),this.a=k,this.b=p,this.F=new Map,this.G=new Map}call(k,p,c){const b=this.c(k);switch(p){case"stat":return this.g(b,c[0]);case"readdir":return this.h(b,c[0]);case"open":return this.r(b,c[0],c[1]);case"close":return this.s(c[0]);case"read":return this.t(c[0],c[1],c[2]);case"readFile":return this.j(b,c[0],c[1]);case"write":return this.u(c[0],c[1],c[2],c[3],c[4]);case"writeFile":return this.n(b,c[0],c[1],c[2]);case"rename":return this.z(b,c[0],c[1],c[2]);case"copy":return this.C(b,c[0],c[1],c[2]);case"cloneFile":return this.D(b,c[0],c[1]);case"mkdir":return this.w(b,c[0]);case"delete":return this.y(b,c[0],c[1]);case"watch":return this.I(b,c[0],c[1],c[2],c[3]);case"unwatch":return this.J(c[0],c[1])}throw new Error(`IPC Command ${p} not found`)}listen(k,p,c){const b=this.c(k);switch(p){case"fileChange":return this.H(b,c[0]);case"readFileStream":return this.m(b,c[0],c[1])}throw new Error(`Unknown event ${p}`)}g(k,p){const c=this.f(k,p,!0);return this.a.stat(c)}h(k,p){const c=this.f(k,p);return this.a.readdir(c)}async j(k,p,c){const b=this.f(k,p,!0),m=await this.a.readFile(b,c);return M.$he.wrap(m)}m(k,p,c){const b=this.f(k,p,!0),m=new S.$4d,$=new P.$Td({onDidRemoveLastListener:()=>{m.cancel()}}),d=this.a.readFileStream(b,c,m.token);return(0,D.$_d)(d,{onData:h=>$.fire(M.$he.wrap(h)),onError:h=>$.fire(h),onEnd:()=>{$.fire("end"),$.dispose(),m.dispose()}}),$.event}n(k,p,c,b){const m=this.f(k,p);return this.a.writeFile(m,c.buffer,b)}r(k,p,c){const b=this.f(k,p,!0);return this.a.open(b,c)}s(k){return this.a.close(k)}async t(k,p,c){const b=M.$he.alloc(c),m=0,$=await this.a.read(k,p,b.buffer,m,c);return[b,$]}u(k,p,c,b,m){return this.a.write(k,p,c.buffer,b,m)}w(k,p){const c=this.f(k,p);return this.a.mkdir(c)}y(k,p,c){const b=this.f(k,p);return this.a.delete(b,c)}z(k,p,c,b){const m=this.f(k,p),$=this.f(k,c);return this.a.rename(m,$,b)}C(k,p,c,b){const m=this.f(k,p),$=this.f(k,c);return this.a.copy(m,$,b)}D(k,p,c){const b=this.f(k,p),m=this.f(k,c);return this.a.cloneFile(b,m)}H(k,p){const c=new P.$Td({onWillAddFirstListener:()=>{this.F.set(p,this.L(k,c))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(p)),this.F.delete(p)}});return c.event}async I(k,p,c,b,m){const $=this.F.get(p);if($){const d=this.f(k,b),h=$.watch(c,d,m);this.G.set(p+c,h)}}async J(k,p){const c=k+p,b=this.G.get(c);b&&((0,s.$Oc)(b),this.G.delete(c))}dispose(){super.dispose();for(const[,k]of this.G)k.dispose();this.G.clear();for(const[,k]of this.F)k.dispose();this.F.clear()}}e.$Zr=f;class l extends s.$Tc{constructor(k,p,c,b){super(),this.c=k,this.f=c,this.g=b,this.a=new Map,this.b=this.B(new R.$qq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(p)}h(k){const p=this.B(new P.$Td);this.B(p.event(c=>{k.fire(c.map(b=>({resource:this.c.transformOutgoingURI(b.resource),type:b.type,cId:b.cId})))})),this.B(this.b.onDidChangeFile(c=>p.fire(c))),this.B(this.b.onDidWatchError(c=>k.fire(c)))}j(k){}m(k){}watch(k,p,c){const b=this.m(this.g);return Array.isArray(b)&&(c.excludes=[...c.excludes,...b]),this.a.set(k,this.b.watch(p,c)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(k)),this.a.delete(k)})}dispose(){for(const[,k]of this.a)k.dispose();this.a.clear(),super.dispose()}}e.$1r=l}),define(oe[224],ae([0,1,15,178,4,7,16,9,223,155]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u0b=void 0;class y extends f.$Zr{constructor(c,b,m){super(c,b),this.M=m}c(c){return l.$3m}f(c,b){return M.URI.revive(b)}async y(c,b,m){if(!m.useTrash)return super.y(c,b,m);const $=this.f(c,b),d=(0,S.$hc)($.fsPath);try{await P.shell.trashItem(d)}catch{throw(0,D.$Bk)(s.$i?(0,R.localize)(0,null,(0,S.$nc)(d)):(0,R.localize)(1,null,(0,S.$nc)(d)),D.FileSystemProviderErrorCode.Unknown)}}L(c,b){return new k(c,b,this.b,this.M)}}e.$u0b=y;class k extends f.$1r{watch(c,b,m){if(m.recursive)throw(0,D.$Bk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(c,b,m)}}}),define(oe[225],ae([0,1,5]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;class R extends P.$rj{constructor(M=P.$oj){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$i7b=R}),define(oe[226],ae([0,1,7,3,5,2]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=void 0;class D extends s.$wj{constructor(k,p,c,b,m){super(p,c,b),this.r=k,this.t=m,this.B(m.listen("onDidChangeLogLevel",k)($=>{(0,s.$nj)($)?super.setLogLevel($):super.setLogLevel(P.URI.revive($[0]),$[1])})),this.B(m.listen("onDidChangeVisibility",k)(([$,d])=>super.setVisibility(P.URI.revive($),d))),this.B(m.listen("onDidChangeLoggers",k)(({added:$,removed:d})=>{for(const h of $)super.registerLogger({...h,resource:P.URI.revive(h.resource)});for(const h of d)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new s.$uj({log:(k,p)=>{this.t.call("consoleLog",[k,p])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,p){super.setLogLevel(k,p),this.t.call("setLogLevel",[k,p])}setVisibility(k,p){super.setVisibility(k,p),this.t.call("setVisibility",[this.n(k),p])}s(k,p,c){return new S(this.t,k,p,c,this.r)}static setLogLevel(k,p,c){return k.call("setLogLevel",[p,c])}}e.$pr=D;class S extends s.$rj{constructor(k,p,c,b,m){super(b?.logLevel==="always"),this.r=k,this.s=p,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[p,b,m]).then(()=>{this.u(this.n),this.m=!0})}g(k,p){const c=[[k,p]];this.m?this.u(c):this.n.push(...c)}u(k){this.r.call("log",[this.s,k])}}class f{constructor(k,p){this.a=k,this.b=p}listen(k,p){const c=this.b(k);switch(p){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,b=>({added:[...b.added].map(m=>this.c(m,c)),removed:[...b.removed].map(m=>this.c(m,c))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,b=>[c.transformOutgoingURI(b[0]),b[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,b=>(0,s.$nj)(b)?b:[c.transformOutgoingURI(b[0]),b[1]])}throw new Error(`Event not found: ${p}`)}async call(k,p,c){const b=this.b(k);switch(p){case"setLogLevel":return(0,s.$nj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(P.URI.revive(b.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(m=>this.c(m,b)))}throw new Error(`Call not found: ${p}`)}c(k,p){return{...k,resource:p.transformOutgoingURI(k.resource)}}}e.$qr=f;class l extends M.$Tc{constructor(k,p){super(),p.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(c=>p.call("setLogLevel",[c]))),p.call("getRegisteredLoggers").then(c=>{for(const b of c)k.registerLogger({...b,resource:P.URI.revive(b.resource)})}),this.B(p.listen("onDidChangeVisibility")(([c,b])=>k.setVisibility(P.URI.revive(c),b))),this.B(p.listen("onDidChangeLoggers")(({added:c,removed:b})=>{for(const m of c)k.registerLogger({...m,resource:P.URI.revive(m.resource)});for(const m of b)k.deregisterLogger(m.resource)}))}}e.$rr=l}),define(oe[227],ae([0,1,2,5]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=void 0;class s extends P.$Tc{constructor(D,S=[]){super(),this.a=new R.$vj([D,...S]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$kO=s}),define(oe[228],ae([0,1,31,7,5]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o$b=void 0;class M{constructor(S){this.b=S,this.a=new P.$Ac}listen(S,f,l){switch(f){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,l){switch(f){case"createLogger":this.c(R.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(R.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$nj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(R.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:R.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,l){this.a.set(S,this.b.createLogger(S,f,l))}d(S,f){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...f)}e(S,f){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[y,k]of f)(0,s.log)(l,y,k)}}e.$o$b=M}),define(oe[229],ae([0,1,16,5]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function M(l,y,k,p,c){try{const b=await new Promise(($,d)=>{Q(["@vscode/spdlog"],$,d)});b.setFlushOn(s.Trace);const m=await b.createAsyncRotatingLogger(l,y,k,p);return c?m.clearFormatters():m.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),m}catch(b){console.error(b)}return null}function D(l,y,k){switch(y){case R.LogLevel.Trace:l.trace(k);break;case R.LogLevel.Debug:l.debug(k);break;case R.LogLevel.Info:l.info(k);break;case R.LogLevel.Warning:l.warn(k);break;case R.LogLevel.Error:l.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function S(l,y){switch(y){case R.LogLevel.Trace:l.setLevel(s.Trace);break;case R.LogLevel.Debug:l.setLevel(s.Debug);break;case R.LogLevel.Info:l.setLevel(s.Info);break;case R.LogLevel.Warning:l.setLevel(s.Warning);break;case R.LogLevel.Error:l.setLevel(s.Error);break;case R.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class f extends R.$rj{constructor(y,k,p,c,b){super(),this.m=[],this.setLevel(b),this.n=this.s(y,k,p,c),this.B(this.onDidChangeLogLevel(m=>{this.r&&S(this.r,m)}))}async s(y,k,p,c){const b=p?6:1,m=30/b*P.$Wk.MB,$=await M(y,k,m,b,c);if($){this.r=$,S(this.r,this.getLevel());for(const{level:d,message:h}of this.m)D(this.r,d,h);this.m=[]}}g(y,k){this.r?D(this.r,y,k):this.getLevel()<=y&&this.m.push({level:y,message:k})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$_N=f}),define(oe[230],ae([0,1,32,5,229]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;class M extends R.$wj{s(S,f,l){return new s.$_N((0,P.$og)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.$aO=M}),define(oe[69],ae([0,1,31,3,6,5,230]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$39b=e.$29b=void 0,e.$29b=(0,s.$5h)(M.$mj);class S extends D.$aO{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(l,y,k){k!==void 0&&this.u.set(this.n(l),k);try{return super.createLogger(l,y)}catch(p){throw this.u.delete(this.n(l)),p}}registerLogger(l,y){y!==void 0&&this.u.set(l.resource,y),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const y=[];for(const k of super.getRegisteredLoggers())l===this.u.get(k.resource)&&y.push(k);return y}getOnDidChangeLogLevelEvent(l){return R.Event.filter(this.onDidChangeLogLevel,y=>(0,M.$nj)(y)||this.w(y[0],l))}getOnDidChangeVisibilityEvent(l){return R.Event.filter(this.onDidChangeVisibility,([y])=>this.w(y,l))}getOnDidChangeLoggersEvent(l){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,y=>({added:[...y.added].filter(p=>this.w(p.resource,l)),removed:[...y.removed].filter(p=>this.w(p.resource,l))})),y=>y.added.length>0||y.removed.length>0)}deregisterLoggers(l){for(const[y,k]of this.u)k===l&&this.deregisterLogger(y)}w(l,y){const k=this.u.get(l);return k===void 0||k===y}dispose(){super.dispose(),this.u.clear()}}e.$39b=S}),define(oe[231],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J0b=e.$I0b=e.$H0b=e.$G0b=void 0;function P(D){return D.submenu!==void 0}e.$G0b=P;function R(D){return D.id==="vscode.menubar.separator"}e.$H0b=R;function s(D){return D.uri!==void 0}e.$I0b=s;function M(D){return!P(D)&&!R(D)&&!s(D)}e.$J0b=M}),define(oe[39],ae([0,1,3,72,2,6]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0,e.$yn=(0,M.$4h)("policy");class D extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Td),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const y=Object.keys(this.f).length;return this.f={...l,...this.f},y!==Object.keys(this.f).length&&await this.j(l),R.Iterable.reduce(this.g.entries(),(k,[p,c])=>({...k,[p]:c}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(l,[y,k])=>({...l,[y]:{definition:k,value:this.g.get(y)}}),{})}}e.$zn=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$An=S}),define(oe[232],ae([0,1,8,3,72,12,16,5,39]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;function l(k,p){const c=[];for(const b of new Set(s.Iterable.concat(k.keys(),p.keys())))k.get(b)!==p.get(b)&&c.push(b);return c}let y=class extends f.$zn{constructor(p,c,b){super(),this.m=p,this.n=c,this.s=b,this.c=this.B(new P.$2g(500));const m=R.Event.filter(c.onDidFilesChange,$=>$.affects(p));this.B(c.watch(p)),this.B(m(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const p=new Map;try{const c=await this.n.readFile(this.m),b=JSON.parse(c.value.toString());if(!(0,M.$If)(b))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(b))this.f[m]&&p.set(m,b[m])}catch(c){c.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",c)}return p}async w(){const p=await this.u(),c=l(this.g,p);this.g=p,c.length>0&&this.h.fire(c)}};e.$H$b=y,e.$H$b=y=Ee([ne(1,D.$ok),ne(2,S.$lj)],y)}),define(oe[233],ae([0,1,3,2,39]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.$f$b=void 0;class M{constructor(f){this.b=f,this.a=new R.$Sc}listen(f,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,y=>y.reduce((k,p)=>({...k,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(f,l,y){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(y)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$f$b=M;class D extends s.$zn{constructor(f,l){super(),this.a=l;for(const y in f){const{definition:k,value:p}=f[y];this.f[y]=k,p!==void 0&&this.g.set(y,p)}this.a.listen("onDidChange")(y=>{for(const k in y){const p=y[k];p===null?this.g.delete(k):this.g.set(k,p)}this.h.fire(Object.keys(y))})}async j(f){const l=await this.a.call("updatePolicyDefinitions",f);for(const y in l)this.g.set(y,l[y])}}e.$g$b=D}),define(oe[234],ae([0,1,39,8,2,5]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=void 0;let D=class extends P.$zn{constructor(f,l){super(),this.m=f,this.n=l,this.a=new R.$Xg,this.b=this.B(new s.$Uc)}async j(f){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:l}=await new Promise((y,k)=>{Q(["@vscode/policy-watcher"],y,k)});await this.a.queue(()=>new Promise((y,k)=>{try{this.b.value=l(this.n,f,p=>{this.t(p),y()})}catch(p){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),k(p)}}))}t(f){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const l in f){const y=f[l];y===void 0?this.g.delete(l):this.g.set(l,y)}this.h.fire(Object.keys(f))}};e.$G$b=D,e.$G$b=D=Ee([ne(0,M.$lj)],D)}),define(oe[79],ae([0,1,35]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const M=s.context.configuration();if(M)R=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:M.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(oe[27],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=void 0,e.$Dj=(0,P.$4h)("productService"),e.$Ej="vscode://schemas/vscode-product"}),define(oe[235],ae([0,1,8,5]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=void 0;let s=class{constructor(D,S,f){this.a=D,this.b=S,this.c=f}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$5g)(D);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$x0b=s,e.$x0b=s=Ee([ne(2,R.$lj)],s)}),define(oe[80],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H9b=void 0,e.$H9b=(0,P.$4h)("protocolMainService")}),define(oe[43],ae([0,1,137,12]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(R.$Gf(D)),P.ok(R.$If(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$wn=new s}),define(oe[236],ae([0,1,3,43]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0,e.$xn={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[s(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;R.$wn.add(e.$xn.JSONContribution,D)}),define(oe[58],ae([0,1,23,3,12,163,17,236,43]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.ConfigurationScope=e.$Bn=e.EditPresentationTypes=void 0;var l;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Bn={Configuration:"base.contributions.configuration"};var y;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn={properties:{},patternProperties:{}},e.$In="vscode://schemas/settings/resourceLanguage",e.$Jn="vscode://schemas/settings/configurationDefaults";const k=f.$wn.as(S.$xn.JSONContribution);class p{constructor(){this.h=new Set,this.i=new R.$Td,this.onDidSchemaChange=this.i.event,this.j=new R.$Td,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$In,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),k.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),k.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(o.add(a),e.$Ln.test(a)){const w=this.a.get(a),A=w?.valuesSources??new Map;if(n)for(const j of Object.keys(i[a]))A.set(j,n);const I={...w?.value||{},...i[a]};this.a.set(a,{source:n,value:I,valuesSources:A});const E=(0,D.$Hi)(a),C={type:"object",default:I,description:M.localize(1,null,E),$ref:e.$In,defaultDefaultValue:I,source:s.$Gf(n)?void 0:n,defaultValueSource:n};r.push(...m(a)),this.d[a]=C,this.b.properties[a]=C}else{this.a.set(a,{value:i[a],source:n});const w=this.d[a];w&&(this.w(a,w),this.r(a,w))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),w=s.$Gf(i)?i:i?.id,A=s.$Gf(a?.source)?a?.source:a?.source?.id;if(w===A)if(o.add(n),this.a.delete(n),e.$Ln.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,a){n=s.$Pf(t.scope)?n:t.scope;const w=t.properties;if(w)for(const I in w){const E=w[I];if(o&&g(I,E)){delete w[I];continue}if(E.source=r,E.defaultDefaultValue=w[I].default,this.w(I,E),e.$Ln.test(I)?E.scope=void 0:(E.scope=s.$Pf(E.scope)?n:E.scope,E.restricted=s.$Pf(E.restricted)?!!i?.includes(I):E.restricted),w[I].hasOwnProperty("included")&&!w[I].included){this.f[I]=w[I],delete w[I];continue}else this.d[I]=w[I],w[I].policy?.name&&this.e.set(w[I].policy.name,I);!w[I].deprecationMessage&&w[I].markdownDeprecationMessage&&(w[I].deprecationMessage=w[I].markdownDeprecationMessage),a.add(I)}const A=t.allOf;if(A)for(const I of A)this.p(I,o,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Cn.properties[t]=o,o.scope){case 1:e.$Dn.properties[t]=o;break;case 2:e.$En.properties[t]=o;break;case 6:e.$Fn.properties[t]=o;break;case 3:e.$Gn.properties[t]=o;break;case 4:e.$Hn.properties[t]=o;break;case 5:e.$Hn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Cn.properties[t],o.scope){case 1:delete e.$Dn.properties[t];break;case 2:delete e.$En.properties[t];break;case 6:delete e.$Fn.properties[t];break;case 3:delete e.$Gn.properties[t];break;case 4:case 5:delete e.$Hn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$In};this.w(o,r),e.$Cn.properties[o]=r,e.$Dn.properties[o]=r,e.$En.properties[o]=r,e.$Fn.properties[o]=r,e.$Gn.properties[o]=r,e.$Hn.properties[o]=r}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$In};e.$Cn.patternProperties[e.$Kn]=t,e.$Dn.patternProperties[e.$Kn]=t,e.$En.patternProperties[e.$Kn]=t,e.$Fn.patternProperties[e.$Kn]=t,e.$Gn.patternProperties[e.$Kn]=t,e.$Hn.patternProperties[e.$Kn]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Nf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Nf(i)&&(i=d(o.type)),o.default=i,o.defaultValueSource=n}}const c="\\[([^\\]]+)\\]",b=new RegExp(c,"g");e.$Kn=`^(${c})+$`,e.$Ln=new RegExp(e.$Kn);function m(u){const t=[];if(e.$Ln.test(u)){let o=b.exec(u);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=b.exec(u)}}return(0,P.$Mb)(t)}e.$Mn=m;function $(u){return u.reduce((t,o)=>`${t}[${o}]`,"")}e.$Nn=$;function d(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$On=d;const h=new p;f.$wn.add(e.$Bn.Configuration,h);function g(u,t){return u.trim()?e.$Ln.test(u)?M.localize(7,null,u):h.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,u,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$Pn=g;function v(){const u=[],t=h.getConfigurationProperties();for(const o of Object.keys(t))u.push([o,t[o].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$Qn=v}),define(oe[119],ae([0,1,23,3,44,2,31,38,12,7,17,58,43]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=void 0;function c(o){return Object.isFrozen(o)?o:S.$ln(o)}class b{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof b)return i;const n=new m("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$Fi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,w=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:w}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,y.$Fi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$kn(this.contents),n=S.$kn(this.overrides),a=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const A of r)if(w.push(...A.raw?.length?A.raw:[A]),!A.isEmpty()){this.h(i,A.contents);for(const I of A.overrides){const[E]=n.filter(C=>P.$ub(C.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=P.$Mb(E.keys)):n.push(S.$kn(I))}for(const I of A.keys)a.indexOf(I)===-1&&a.push(I)}return new b(i,a,n,w.every(A=>A instanceof b)?void 0:w)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[a];const A=i[a];A&&(typeof w=="object"&&typeof A=="object"?(w=S.$kn(w),this.h(w,A)):w=A),n[a]=w}return new b(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$If(r[n])&&f.$If(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$kn(i[n])}}i(r){let i=null,n=null;const a=w=>{w&&(n?this.h(n,w):n=S.$kn(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===r?i=w.contents:w.identifiers.includes(r)&&a(w.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$Ei)(this.contents,r),k.$Ln.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,k.$Mn)(r))),1))}j(r,i,n){(0,y.$Di)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),k.$Ln.test(r)&&this.overrides.push({identifiers:(0,k.$Mn)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$Ci)(this.contents[r],a=>console.error(a))})}}e.$Rn=b;class m{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Pf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:w,restricted:A,hasExcludedProperties:I}=this.h(r,i);this.b=new b(n,a,w,I?[r]:void 0),this.c=A||[]}g(r){let i={},n=null,a=[];const w=[],A=[];function I(C){Array.isArray(a)?a.push(C):n!==null&&(a[n]=C)}const E={onObjectBegin:()=>{const C={};I(C),w.push(a),a=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{a=w.pop()},onArrayBegin:()=>{const C=[];I(C),w.push(a),a=C,n=null},onArrayEnd:()=>{a=w.pop()},onLiteralValue:I,onError:(C,j,W)=>{A.push({error:C,offset:j,length:W})}};if(r)try{s.$hn(r,E),i=a[0]||{}}catch(C){console.error(`Error while parsing settings file ${this.f}: ${C}`),this.d=[C]}return i}h(r,i){const n=p.$wn.as(k.$Bn.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const w=(0,y.$Ci)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),A=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:w,keys:A,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let w=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:w};const A={},I=[];for(const E in r)if(k.$Ln.test(E)&&n){const C=this.i(r[E],i,!1,a);A[E]=C.raw,w=w||C.hasExcludedProperties,I.push(...C.restricted)}else{const C=i[E],j=C?typeof C.scope<"u"?C.scope:3:void 0;C?.restricted&&I.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(j===void 0||a.scopes===void 0||a.scopes.includes(j))&&!(a.skipRestricted&&C?.restricted))?A[E]=r[E]:w=!0}return{raw:A,restricted:I,hasExcludedProperties:w}}j(r,i){const n=[];for(const a of Object.keys(r))if(k.$Ln.test(a)){const w={};for(const A in r[a])w[A]=r[a][A];n.push({identifiers:(0,k.$Mn)(a),keys:Object.keys(w),contents:(0,y.$Ci)(w,i)})}return n}}e.$Sn=m;class $ extends M.$Tc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new R.$Td),this.onDidChange=this.b.event,this.a=new m(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&n.isEqual(w.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Tn=$;class d{constructor(r,i,n,a,w,A,I,E,C,j,W,T,G){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=w,this.f=A,this.g=I,this.h=E,this.i=C,this.j=j,this.k=W,this.l=T,this.m=G}get value(){return c(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return c(a.value)},get override(){return c(a.override)},get merged(){return c(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,i,n,a,w=new b,A=new b,I=new D.$Ac,E=new b,C=new D.$Ac){this.c=r,this.d=i,this.f=n,this.g=a,this.h=w,this.i=A,this.j=I,this.l=E,this.m=C,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new b,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.p(r,i,n),w=this.t(i.resource,n),A=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of a.overrides)for(const C of E.identifiers)a.getOverrideValue(r,C)!==void 0&&I.add(C);return new d(r,i,a.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,w||void 0,A)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:w,removed:A}=u(this.c,r);i=[...a,...w,...A]}for(const a of i)for(const w of(0,k.$Mn)(a)){const A=this.c.getKeysForOverrideIdentifier(w),I=r.getKeysForOverrideIdentifier(w),E=[...I.filter(C=>A.indexOf(C)===-1),...A.filter(C=>I.indexOf(C)===-1),...A.filter(C=>!S.$on(this.c.override(w).getValue(C),r.override(w).getValue(C)))];n.push([w,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=u(this.d,r),w=[...i,...n,...a];return w.length&&this.updatePolicyConfiguration(r),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:w}=u(this.applicationConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateApplicationConfiguration(r),{keys:A,overrides:w}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:w}=u(this.localUserConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateLocalUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:w}=u(this.remoteUserConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateRemoteUserConfiguration(r),{keys:A,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:w}=u(this.workspaceConfiguration,r),A=[...i,...n,...a];return A.length&&this.updateWorkspaceConfiguration(r),{keys:A,overrides:w}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:a,updated:w,removed:A,overrides:I}=u(n,i),E=[...a,...w,...A];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:w,overrides:A}=u(i,void 0);return{keys:[...n,...a,...w],overrides:A}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let a=this.q(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}q({resource:r},i){let n=this.r();if(i&&r){const a=i.getFolder(r);a&&(n=this.s(a.uri)||n);const w=this.m.get(r);w&&(n=n.merge(w))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:w}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:w}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),a=this.w(r.application),w=this.w(r.user),A=this.w(r.workspace),I=r.folders.reduce((E,C)=>(E.set(l.URI.revive(C[0]),this.w(C[1])),E),new D.$Ac);return new h(i,n,a,w,new b,A,I,new b,new D.$Ac)}static w(r){return new b(r.contents,r.keys,r.overrides)}}e.$Un=h;function g(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const a of o)a.keys.forEach(w=>r.add(w)),a.overrides.forEach(([w,A])=>{const I=(0,D.$xc)(i,w,new Set);A.forEach(E=>I.add(E))});const n=[];return i.forEach((a,w)=>n.push([w,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$Vn=g;class v{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const w of r.keys)this.affectedKeys.add(w);for(const[,w]of r.overrides)for(const A of w)this.affectedKeys.add(A);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const w=a+n.length;if(w>=this.d.length)return!1;const A=this.d.charCodeAt(w);if(A!==this.b&&A!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!S.$on(I,E)}return!0}}e.$Wn=v;function u(o,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,o?.rawConfiguration),w=[],A=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(C=>!A.includes(C));for(const C of E)w.push([C,r.getKeysForOverrideIdentifier(C)])}if(o){const E=A.filter(C=>!I.includes(C));for(const C of E)w.push([C,o.getKeysForOverrideIdentifier(C)])}if(r&&o){for(const E of A)if(I.includes(E)){const C=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});w.push([E,[...C.added,...C.removed,...C.updated]])}}return{added:i,removed:n,updated:a,overrides:w}}function t(o,r){const i=o?r?o.keys.filter(w=>r.keys.indexOf(w)===-1):[...o.keys]:[],n=r?o?r.keys.filter(w=>o.keys.indexOf(w)===-1):[...r.keys]:[],a=[];if(o&&r){for(const w of r.keys)if(o.keys.indexOf(w)!==-1){const A=(0,y.$Fi)(r.contents,w),I=(0,y.$Fi)(o.contents,w);S.$on(A,I)||a.push(w)}}return{added:i,removed:n,updated:a}}}),define(oe[237],ae([0,1,23,3,2,38,12,119,58,5,39,43]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=e.$Yn=e.$Xn=void 0;class p extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new R.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$wn.as(f.$Bn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:d})=>this.c(Array.from($),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,d){this.h($,k.$wn.as(f.$Bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new S.$Rn;const $=k.$wn.as(f.$Bn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,d){const h=this.f();for(const g of $){const v=h[g],u=d[g];v!==void 0?this.b.addValue(g,v):u?this.b.addValue(g,u.default):this.b.removeValue(g)}}}e.$Xn=p;class c{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.$Rn}async initialize(){return this.configurationModel}}e.$Yn=c;let b=class extends s.$Tc{get configurationModel(){return this.b}constructor($,d,h){super(),this.c=$,this.f=d,this.g=h,this.a=this.B(new R.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new S.$Rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const d={},h=[],g=k.$wn.as(f.$Bn.Configuration).getConfigurationProperties();for(const v of $){const u=g[v];if(!u){h.push(v);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}h.push(v),d[u.policy.name]={type:u.type}}}return(0,D.$Tf)(d)||await this.f.updatePolicyDefinitions(d),h}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const d=k.$wn.as(f.$Bn.Configuration).getPolicyConfigurations(),h=(0,P.$Hb)($.map(g=>d.get(g)));this.m(h,!0)}m($,d){this.g.trace("PolicyConfiguration#update",$);const h=k.$wn.as(f.$Bn.Configuration).getConfigurationProperties(),g=[],v=this.b.isEmpty();for(const u of $){const t=h[u]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(v?o!==void 0:!(0,M.$on)(this.b.getValue(u),o))&&g.push([u,o])}else this.b.getValue(u)!==void 0&&g.push([u,void 0])}if(g.length){this.g.trace("PolicyConfiguration#changed",g);const u=this.b;this.b=new S.$Rn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,o]of g)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);d&&this.a.fire(this.b)}}};e.$Zn=b,e.$Zn=b=Ee([ne(1,y.$yn),ne(2,l.$lj)],b)}),define(oe[238],ae([0,1,8,3,2,19,17,119,237,39]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class y extends s.$Tc{constructor(p,c,b,m){super(),this.j=p,this.h=this.B(new R.$Td),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Xn),this.c=b instanceof l.$An?new f.$Yn:this.B(new f.$Zn(this.b,b,m)),this.f=this.B(new S.$Tn(this.j,{},M.$wg,c)),this.a=new S.$Un(this.b.configurationModel,this.c.configurationModel,new S.$Rn,new S.$Rn),this.g=this.B(new P.$dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:$,properties:d})=>this.n($,d))),this.B(this.c.onDidChangeConfiguration($=>this.r($))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,c,b]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$Un(p,c,new S.$Rn,b)}getConfigurationData(){return this.a.toData()}getValue(p,c){const b=typeof p=="string"?p:void 0,m=(0,D.$yi)(p)?p:(0,D.$yi)(c)?c:{};return this.a.getValue(b,m,void 0)}updateValue(p,c,b,m){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.m(p)}m(p){const c=this.a.toData(),b=this.a.compareAndUpdateLocalUserConfiguration(p);this.s(b,c,2)}n(p,c){const b=this.a.toData(),m=this.a.compareAndUpdateDefaultConfiguration(p,c);this.s(m,b,7)}r(p){const c=this.a.toData(),b=this.a.compareAndUpdatePolicyConfiguration(p);this.s(b,c,7)}s(p,c,b){const m=new S.$Wn(p,{data:c},this.a);m.source=b,m.sourceConfig=this.t(b),this.h.fire(m)}t(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$1n=y}),define(oe[239],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=e.$u$b=e.$t$b=void 0,e.$t$b="request",e.$u$b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$t$b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const f=s.connections.find(l=>l.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$v$b=P}),define(oe[240],ae([0,1,14,6]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.RemoteAuthorityResolverErrorCode=e.$8k=e.$7k=e.RemoteConnectionType=e.$6k=void 0,e.$6k=(0,R.$4h)("remoteAuthorityResolverService");var s;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$7k=M;class D{constructor(k,p){this.host=k,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$8k=D;var S;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends P.$bb{static isNotAvailable(k){return k instanceof f&&k._code===S.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===S.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===S.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===S.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,p=S.Unknown,c){super(k),this._message=k,this._code=p,this._detail=c,this.isHandled=p===S.NotAvailable&&c===!0,Object.setPrototypeOf(this,f.prototype)}}e.$9k=f;function l(y){const k=y.indexOf("+");return k===-1?y:y.substring(0,k)}e.$0k=l}),define(oe[59],ae([0,1,13]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0;function R(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$$k=R;function s(l){if(!l)return;const y=l.indexOf("+");return y<0?l:l.substr(0,y)}e.$_k=s;function M(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$al=M;function D(l){const{host:y,port:k}=f(l);if(typeof k>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:y,port:k}}e.$bl=D;function S(l,y){let{host:k,port:p}=f(l);return typeof p>"u"&&(p=y),{host:k,port:p}}e.$cl=S;function f(l){const y=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(y)return{host:y[1],port:parseInt(y[2],10)};const k=l.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const p=l.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:l,port:void 0}}}),define(oe[120],ae([0,1,25,6,59]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.TargetPlatform=e.ExtensionType=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm="extensions.user.cache",e.$em="extensions.builtin.cache",e.$fm="undefined_publisher",e.$gm=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.$hm=M,e.$im=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(m){m.WIN32_X64="win32-x64",m.WIN32_ARM64="win32-arm64",m.LINUX_X64="linux-x64",m.LINUX_ARM64="linux-arm64",m.LINUX_ARMHF="linux-armhf",m.ALPINE_X64="alpine-x64",m.ALPINE_ARM64="alpine-arm64",m.DARWIN_X64="darwin-x64",m.DARWIN_ARM64="darwin-arm64",m.WEB="web",m.UNIVERSAL="universal",m.UNKNOWN="unknown",m.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,d){if(typeof $>"u"||$===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof $=="string"||typeof d=="string"){const h=typeof $=="string"?$:$.value,g=typeof d=="string"?d:d.value;return P.$0e(h,g)}return $._lower===d._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$jm=f;class l{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const d of $)this.add(d)}add($){this.c.add(f.toKey($))}delete($){return this.c.delete(f.toKey($))}has($){return this.c.has(f.toKey($))}}e.$km=l;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(f.toKey($))}get($){return this.c.get(f.toKey($))}has($){return this.c.has(f.toKey($))}set($,d){this.c.set(f.toKey($),d)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$lm=y;function k(m){return p(m)}e.$mm=k;function p(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.$nm=p;function c(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.$om=c;function b(m,$){if($){const d=`onResolveRemoteAuthority:${(0,s.$_k)($)}`;return!!m.activationEvents?.includes(d)}return!1}e.$pm=b,e.$qm=(0,R.$4h)("IBuiltinExtensionsScannerService")}),define(oe[241],ae([0,1,8,18,22,14,3,2,68,73,32,109,240,59]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.PersistentConnectionEventType=e.$jl=e.$il=e.$hl=e.ConnectionType=void 0;const b=30*1e3;var m;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(m||(e.ConnectionType=m={}));function $(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(J){const O=new s.$4d;return setTimeout(()=>O.cancel(),J),O.token}function h(J,O){if(J.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const F=new s.$4d;return J.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class g{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Sc,this.promise=new Promise((F,x)=>{this.f=F,this.g=x}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function v(J,O){const F=new g(O);return F.registerDisposable(J.onControlMessage(x=>{const z=JSON.parse(x.toString()),X=L(z);X?F.reject(X):F.resolve(z)})),F.promise}function u(J,O,F,x,z,X,N,B){const _=new g(B),ce=l.$Pd.create(!1);return J.info(`Creating a socket (${N})...`),f.mark(`code/willCreateSocket/${X}`),O.connect(F,x,z,N).then(se=>{_.didTimeout?(f.mark(`code/didCreateSocketError/${X}`),J.info(`Creating a socket (${N}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),se?.dispose()):(f.mark(`code/didCreateSocketOK/${X}`),J.info(`Creating a socket (${N}) was successful after ${ce.elapsed()} ms.`),_.resolve(se))},se=>{f.mark(`code/didCreateSocketError/${X}`),J.info(`Creating a socket (${N}) returned an error after ${ce.elapsed()} ms.`),J.error(se),_.reject(se)}),_.promise}function t(J,O){const F=new g(O);return J.then(x=>{F.didTimeout||F.resolve(x)},x=>{F.didTimeout||F.reject(x)}),F.promise}async function o(J,O,F,x){const z=te(J,O);J.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let X;try{X=await u(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,c.$al)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,$(O),`renderer-${$(O)}-${J.reconnectionToken}`,x)}catch(se){throw J.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),J.logService.error(se),se}J.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let N,B;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(X,null),N=J.reconnectionProtocol,B=!1):(N=new k.$Rh({socket:X}),B=!0),J.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const _=await t(J.signService.createNewMessage((0,y.$og)()),x),ce={type:"auth",auth:J.connectionToken||"00000000000000000000",data:_.data};N.sendControl(R.$he.fromString(JSON.stringify(ce)));try{const se=await v(N,h(x,d(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(J.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(J.signService.validate(_,se.signedData),x)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const me=await t(J.signService.sign(se.data),x),ye={type:"connectionType",commit:J.commit,signedData:me,desiredConnectionType:O};return F&&(ye.args=F),J.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(R.$he.fromString(JSON.stringify(ye))),{protocol:N,ownsProtocol:B}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(J.logService.error(`${z} the handshake timed out. Error:`),J.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${z} received error control message when negotiating connection. Error:`),J.logService.error(se)),B&&H(N),se}}async function r(J,O,F,x){const z=Date.now(),X=te(J,O),{protocol:N,ownsProtocol:B}=await o(J,O,F,x),_=new g(x);return _.registerDisposable(N.onControlMessage(ce=>{const se=JSON.parse(ce.toString()),$e=L(se);$e?(J.logService.error(`${X} received error control message when negotiating connection. Error:`),J.logService.error($e),B&&H(N),_.reject($e)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${X} 6/6. handshake finished, connection is up and running after ${he(z)}!`),_.resolve({protocol:N,firstMessage:se}))})),_.promise}async function i(J,O){const{protocol:F}=await r(J,1,void 0,O);return{protocol:F}}async function n(J,O,F){const{protocol:x,firstMessage:z}=await r(J,2,O,F),X=z&&z.debugPort;return{protocol:x,debugPort:X}}async function a(J,O,F){const x=Date.now(),z=te(J,3),{protocol:X}=await o(J,3,O,F);return J.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(x)}!`),X}async function w(J,O,F){const{connectTo:x,connectionToken:z}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:x,connectionToken:z,reconnectionToken:O,reconnectionProtocol:F,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function A(J,O,F){return E(J,async x=>{const{protocol:z}=await i(x,s.CancellationToken.None);return new Y(J,O,F,x.reconnectionToken,z)})}e.$hl=A;async function I(J,O){return E(J,async F=>{const{protocol:x,debugPort:z}=await n(F,O,s.CancellationToken.None);return new Z(J,O,F.reconnectionToken,x,z)})}e.$il=I;async function E(J,O){for(let x=1;;x++)try{const z=(0,y.$og)(),X=await w(J,z,null);return await O(X)}catch(z){if(x<5)J.logService.error(`[remote-connection][attempt ${x}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(z);else throw J.logService.error(`[remote-connection][attempt ${x}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(z),ue.triggerPermanentFailure(0,0,p.$9k.isHandled(z)),z}}async function C(J,O,F){const x=await w(J,(0,y.$og)(),null);return await a(x,{host:O,port:F},s.CancellationToken.None)}e.$jl=C;function j(J){return(0,P.$Rg)(O=>new Promise((F,x)=>{const z=setTimeout(F,J*1e3);O.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var W;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class T{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.$kl=T;class G{constructor(O,F,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=x,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$ll=G;class K{constructor(O,F,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=2}}e.$ml=K;class le{constructor(O,F,x){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.type=4}}e.$nl=le;class re{constructor(O,F,x,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=x,this.handled=z,this.type=3}}e.$ol=re;class ue extends S.$Tc{static triggerPermanentFailure(O,F,x){this._permanentFailure=!0,this.f=O,this.g=F,this.h=x,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,F,x,z,X){super(),this.t=O,this.u=F,this.reconnectionToken=x,this.protocol=z,this.w=X,this.m=this.B(new D.$Td),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new le(this.reconnectionToken,0,0)),this.B(z.onSocketClose(N=>{const B=q(this.t,this.reconnectionToken,!0);N?N.type===0?(this.u.logService.info(`${B} received socket close event (hadError: ${N.hadError}).`),N.error&&this.u.logService.error(N.error)):(this.u.logService.info(`${B} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this.u.logService.error(N.event)):this.u.logService.info(`${B} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(N=>{const B=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} received socket timeout event (unacknowledgedMsgCount: ${N.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${N.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${N.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,S.$Rc)(()=>{const N=ue.j.indexOf(this);N>=0&&ue.j.splice(N,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let x=-1;do{x++;const z=x<F.length?F[x]:F[F.length-1];try{if(z>0){const N=j(z);this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,N)),this.u.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await N}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new K(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1)),this.u.logService.info(`${O} resolving connection...`);const X=await w(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${X.connectTo}...`),await this.G(X,d(b)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new le(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),x+1));break}catch(X){if(X.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(x>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}if(p.$9k.isTemporarilyNotAvailable(X)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((X.code==="ETIMEDOUT"||X.code==="ENETUNREACH"||X.code==="ECONNREFUSED"||X.code==="ECONNRESET")&&X.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if((0,M.$4)(X)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(X);continue}if(X instanceof p.$9k){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,p.$9k.isHandled(X));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(X),this.C(this.protocol.getMillisSinceLastIncomingData(),x+1,!1);break}}while(!this.n&&!this.s)}C(O,F,x){this.w?ue.triggerPermanentFailure(O,F,x):this.D(O,F,x)}D(O,F,x){this.m.fire(new re(this.reconnectionToken,O,F,x)),H(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$pl=ue;class Y extends ue{constructor(O,F,x,z,X){super(1,O,z,X,!0),this.client=this.B(new k.$Ph(X,{remoteAuthority:F,clientId:x},O.ipcLogger))}async G(O,F){await i(O,F)}}e.$ql=Y;class Z extends ue{constructor(O,F,x,z,X){super(2,O,x,z,!1),this.H=F,this.debugPort=X}async G(O,F){await n(O,this.H,F)}}e.$rl=Z;function H(J){try{J.acceptDisconnect();const O=J.getSocket();J.dispose(),O.dispose()}catch(O){(0,M.$1)(O)}}function L(J){if(J&&J.type==="error"){const O=new Error(`Connection error: ${J.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function U(J,O){for(;J.length<O;)J+=" ";return J}function V(J,O){return`[remote-connection][${U($(J),13)}][${O.substr(0,5)}\u2026]`}function q(J,O,F){return`${V(J,O)}[${F?"reconnect":"initial"}]`}function te(J,O){return`${q(O,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function he(J){return`${Date.now()-J} ms`}}),define(oe[242],ae([0,1,2,6]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0,e.$dl=(0,R.$4h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$Rc)(()=>{const f=this.a[D]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,S,f,l){const y=this.b(D);if(!y)throw new Error(`No socket factory found for ${D}`);return y.connect(D,S,f,l)}}e.$el=s}),define(oe[243],ae([0,1,26,48,21,113]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w0b=void 0;let D;async function S(c=!1){return(D===void 0||c)&&(D=f()),D}e.$w0b=S;async function f(){const c=l();if(c===void 0)return!1;if(c>=22e3){const b=k();if(b)return new Promise(m=>{R.execFile(b,["--status"],$=>m(!$))})}else{const b=p();if(b)try{if((await s.Promises.stat(b)).isFile())return!0}catch{}}return!1}function l(){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(c)return parseInt(c[3])}function y(c){const b=process.env.SystemRoot;if(b){const m=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(b,m?"Sysnative":"System32",c)}}function k(){return y("wsl.exe")}function p(){return y("lxss\\LxssManager.dll")}}),define(oe[52],ae([0,1,18,14,2,183,58,6,5,43]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$9o=(0,S.$4h)("requestService");class y{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class k extends s.$Tc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:f.$Cj.isEqualTo((0,f.$Aj)(f.LogLevel.Trace)).serialize()})}async c(u,t,o){const r=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$0o=k;function p(v){return v.res.statusCode&&v.res.statusCode>=200&&v.res.statusCode<300||v.res.statusCode===1223}e.$$o=p;function c(v){return v.res.statusCode===204}e.$_o=c;async function b(v){return c(v)?null:(await(0,P.$te)(v.stream)).toString()}e.$ap=b;async function m(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);return b(v)}e.$bp=m;async function $(v){if(!p(v))throw new Error("Server returned "+v.res.statusCode);if(c(v))return null;const t=(await(0,P.$te)(v.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$cp=$;function d(v){g(v)}e.$dp=d;let h;function g(v){const u=l.$wn.as(D.$Bn.Configuration),t=h;h={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:v,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,M.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[h],remove:t?[t]:[]})}g(1)}),define(oe[244],ae([0,1,18,22]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,l,y=R.CancellationToken.None){switch(f){case"request":return this.a.request(l[0],y).then(async({res:k,stream:p})=>{const c=await(0,P.$te)(p);return[{statusCode:k.statusCode,headers:k.headers},c]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_q=s;class M{constructor(S){this.a=S}async request(S,f){const[l,y]=await this.a.call("request",[S],f);return{res:l,stream:(0,P.$ve)(y)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ar=M}),define(oe[245],ae([0,1,246,12]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,f={}){const l=(0,P.parse)(D),y=f.proxyUrl||s(l,S);if(!y)return null;const k=(0,P.parse)(y);if(!/^https?:$/.test(k.protocol||""))return null;const p={host:k.hostname||"",port:(k.port?+k.port:0)||(k.protocol==="https"?443:80),auth:k.auth,rejectUnauthorized:(0,R.$Mf)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((c,b)=>{Q(["http-proxy-agent"],c,b)})).HttpProxyAgent(y,p):new(await new Promise((c,b)=>{Q(["https-proxy-agent"],c,b)})).HttpsProxyAgent(y,p)}e.$br=M}),define(oe[247],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=e.$P0b=void 0,e.$P0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Q0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$R0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[94],ae([0,1,48,9,184,22,51,14,4,32,108,64,8,140]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0;let b;async function m(d,h,g,v){return g["force-disable-user-env"]?(h.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(h.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$4l)(v)&&!g["force-user-env"]?(h.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$4l)(v)?h.trace("resolveShellEnv(): running (--force-user-env)"):h.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=p.Promises.withAsyncBody(async(u,t)=>{const o=new M.$4d;let r=1e4;const i=d.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,c.$5l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{u(await $(h,o.token))}catch(a){!(0,S.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$Oi)(a)))):u({})}finally{clearTimeout(n),o.dispose()}})),b)}e.$0l=m;async function $(d,h){const g=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",g);const v=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",v);const u=(0,l.$og)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",o);const r=await(0,y.$Tl)(f.OS,o);return d.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(h.isCancellationRequested)return n(new S.$5);const a=(0,R.$nc)(r);let w,A;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(w=`& '${process.execPath}' ${I} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,A=["-Login","-Command"]):a==="nu"?(w=`^'${process.execPath}' ${I} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,A=["-i","-l","-c"]):a==="xonsh"?(w=`import os, json; print("${u}", json.dumps(dict(os.environ)), "${u}")`,A=["-i","-l","-c"]):(w=`'${process.execPath}' ${I} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"||a==="csh"?A=["-ic"]:A=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(A),w);const E=(0,P.spawn)(r,[...A,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});h.onCancellationRequested(()=>(E.kill(),n(new S.$5))),E.on("error",W=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Oi)(W)),n(W)});const C=[];E.stdout.on("data",W=>C.push(W));const j=[];E.stderr.on("data",W=>j.push(W)),E.on("close",(W,T)=>{const G=Buffer.concat(C).toString("utf8");d.trace("getUnixShellEnvironment#raw",G);const K=Buffer.concat(j).toString("utf8");if(K.trim()&&d.trace("getUnixShellEnvironment#stderr",K),W||T)return n(new Error((0,s.localize)(2,null,W,T)));const le=t.exec(G),re=le?le[1]:"{}";try{const ue=JSON.parse(re);g?ue.ELECTRON_RUN_AS_NODE=g:delete ue.ELECTRON_RUN_AS_NODE,v?ue.ELECTRON_NO_ATTACH_CONSOLE=v:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){d.error("getUnixShellEnvironment#errorCaught",(0,D.$Oi)(ue)),n(ue)}})})}}),define(oe[248],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$K6b=P}),define(oe[95],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl="signService",e.$gl=(0,P.$4h)(e.$fl)}),define(oe[249],ae([0,1,248]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0;class R extends P.$K6b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>Q(["vsda"],M,D))}}e.$F$b=R}),define(oe[34],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=void 0,e.$bO=(0,P.$4h)("stateReadService"),e.$cO=(0,P.$4h)("stateService")}),define(oe[121],ae([0,1,8,18,2,12,37,16,5]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=e.$dO=e.SaveStrategy=void 0;var l;(function(c){c[c.IMMEDIATE=0]="IMMEDIATE",c[c.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class y extends s.$Tc{constructor(b,m,$,d){super(),this.h=b,this.j=m,this.m=$,this.n=d,this.a=Object.create(null),this.b="",this.c=this.B(new P.$2g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(b){b.fileOperationResult!==1&&this.m.error(b)}}getItem(b,m){const $=this.a[b];return(0,M.$Pf)($)?m:$}setItem(b,m){this.setItems([{key:b,data:m}])}setItems(b){let m=!1;for(const{key:$,data:d}of b)this.a[$]!==d&&((0,M.$Pf)(d)?(0,M.$Nf)(this.a[$])||(this.a[$]=void 0,m=!0):(this.a[$]=d,m=!0));m&&this.s()}removeItem(b){(0,M.$Nf)(this.a[b])||(this.a[b]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const b=JSON.stringify(this.a,null,4);if(b!==this.b)try{await this.n.writeFile(this.h,R.$he.fromString(b),{atomic:{postfix:".vsctmp"}}),this.b=b}catch(m){this.m.error(m)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$dO=y;let k=class extends s.$Tc{constructor(b,m,$,d){super(),this.a=this.B(new y(m.stateResource,b,$,d))}async init(){await this.a.init()}getItem(b,m){return this.a.getItem(b,m)}};e.$eO=k,e.$eO=k=Ee([ne(1,D.$$h),ne(2,f.$lj),ne(3,S.$ok)],k);class p extends k{setItem(b,m){this.a.setItem(b,m)}setItems(b){this.a.setItems(b)}removeItem(b){this.a.removeItem(b)}close(){return this.a.close()}}e.$fO=p}),define(oe[122],ae([0,1,4,35,32]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=void 0;function M(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,l,y,k,p,c,b,m,$){const d=Object.create(null);d["common.machineId"]=c,d["common.sqmId"]=b,d.sessionID=(0,s.$og)()+Date.now(),d.commitHash=k,d.version=p,d["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$h)(P.$u),d["common.nodePlatform"]=R.$dc,d["common.nodeArch"]=y,d["common.product"]=$||"desktop",m&&(d["common.msftInternal"]=m);let h=0;const g=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),P.$l&&(d["common.snap"]="true");const v=M(l);return v&&(d["common.platformDetail"]=v),d}e.$xo=D;function S(f){const l=R.env.USERDNSDOMAIN;if(!l)return!1;const y=l.toLowerCase();return f.some(k=>y===k)}e.$yo=S}),define(oe[28],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=void 0,e.$sl=(0,P.$4h)("telemetryService"),e.$tl=(0,P.$4h)("customEndpointTelemetryService"),e.$ul="telemetry.currentSessionDate",e.$vl="telemetry.firstSessionDate",e.$wl="telemetry.lastSessionDate",e.$xl="telemetry.machineId",e.$yl="telemetry.sqmId",e.$zl="telemetry",e.$Al="telemetry.telemetryLevel",e.$Bl="telemetry.enableCrashReporter",e.$Cl="telemetry.enableTelemetry";var R;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(oe[250],ae([0,1,26,8,44,13,9,4,7,88,21,107,91,16,27,28]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0;const $=new Map;async function d(t,o){const r=`${t}::${o.join(":")}`,i=$.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,w=new Map,A=2e4;function I(C,j,W,T){const G=j.substring(C.length+1);return R.Promises.withAsyncBody(async K=>{let le;try{le=await y.Promises.readdir(j,{withFileTypes:!0})}catch{K();return}if(T.count>=A){T.count+=le.length,T.maxReached=!0,K();return}let re=le.length;if(re===0){K();return}let ue=le;T.count+le.length>A&&(T.maxReached=!0,re=A-T.count,ue=le.slice(0,re)),T.count+=le.length;for(const Y of ue)if(Y.isDirectory()){if(W.includes(Y.name)||await I(C,(0,D.$jc)(j,Y.name),W,T),--re===0){K();return}}else{const Z=Y.name.lastIndexOf(".");if(Z>=0){const H=Y.name.substring(Z+1);H&&a.set(H,(a.get(H)??0)+1)}for(const H of n)H.relativePathPattern?.test(G)!==!1&&H.filePattern.test(Y.name)&&w.set(H.tag,(w.get(H.tag)??0)+1);if(--re===0){K();return}}})}const E=R.Promises.withAsyncBody(async C=>{const j={count:0,maxReached:!1};await I(t,t,o,j);const W=await v(t);C({configFiles:h(w),fileTypes:h(a),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:W})});return $.set(r,E),E}e.$Ur=d;function h(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function g(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/c.$Wk.GB).toFixed(2)}GB (${(P.freemem()/c.$Wk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$8m.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$Vr=g;async function v(t){try{const o=new Map,r=(0,D.$jc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),n=[],a=(0,s.$an)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$jn)(a)==="object"&&a.configurations)for(const w of a.configurations){const A=w.type;A&&(o.has(A)?o.set(A,o.get(A)+1):o.set(A,1))}return h(o)}catch{return[]}}e.$Wr=v;let u=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/c.$Wk.GB).toFixed(2)}GB (${(P.freemem()/c.$Wk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$8m.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,k.$Tr)(o.mainPID),this.k(o)]).then(async i=>{let[n,a]=i,w=this.m(o,n);return r.forEach(A=>{if((0,p.$Hm)(A))w+=`
${A.errorMessage}`,a+=`
${A.errorMessage}`;else if(w+=`

Remote: ${A.hostName}`,A.processes&&(w+=`
${this.m(o,A.processes)}`),A.workspaceMetadata){a+=`
|  Remote: ${A.hostName}`;for(const I of Object.keys(A.workspaceMetadata)){const E=A.workspaceMetadata[I];let C=`${E.fileCount} files`;E.maxFilesReached&&(C=`more than ${C}`),a+=`|    Folder (${I}): ${C}`,a+=this.h(E)}}}),{processInfo:w,workspaceInfo:a}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:a,cpus:w}=g(),A={os:a,memory:i,cpus:w,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(A.load=`${P.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(o,r){const i=[];return(0,k.$Tr)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(a=>{if((0,p.$Hm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(o,a.processes)),a.workspaceMetadata)for(const w of Object.keys(a.workspaceMetadata)){const A=a.workspaceMetadata[w];let I=`${A.fileCount} files`;A.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${w}): ${I}`),i.push(this.h(A))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const a=(E,C)=>{const j=` ${E}(${C})`;n+j.length>60?(r.push(w),w="|                 ",n=w.length):n+=j.length,w+=j};let w="|      File types:";const A=10,I=o.fileTypes.length>A?A:o.fileTypes.length;for(let E=0;E<I;E++){const C=o.fileTypes[E];a(C.name,C.count)}if(r.push(w),o.configFiles.length>=0&&(w="|      Conf files:",n=0,o.configFiles.forEach(E=>{a(E.name,E.count)}),r.push(w)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const j=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;E+=j}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const w=f.URI.revive(a);if(w.scheme===M.Schemas.file){const A=w.fsPath;i.push(d(A,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,D.$nc)(A)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${A} (${I.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:w})=>i.set(a,w));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,a){const w=a===0;let A;w?A=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?A=r.get(n.pid):A=`${"  ".repeat(a)} ${n.name}`;const I=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/c.$Wk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,a+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await d(a,["node_modules",".git"])).fileTypes.forEach(A=>r.add(A.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=f.URI.revive(r);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await d(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(w=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),a.launchConfigFiles.forEach(w=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),a.configFiles.forEach(w=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};e.$Xr=u,e.$Xr=u=Ee([ne(0,m.$sl),ne(1,b.$Dj)],u)}),define(oe[251],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=e.$U0b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:f}){return this.b.forEach(l=>l.log(S,f)),Promise.resolve(null)}}e.$U0b=P;class R{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$V0b=R}),define(oe[53],ae([0,1,38,12,3,17,59,122,28]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;class l{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$zo=l;class y{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ao=y,e.$Bo=new y;class k{async publicLog(n,a,w){}async publicLogError(n,a,w){}}e.$Co=k,e.$Do="telemetry",e.$Eo="extensionTelemetryLog",e.$Fo={log:()=>null,flush:()=>Promise.resolve(null)};function p(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(w,A)=>{const I=w?new Set([...w.affectedKeys,...A.affectedKeys]):A.affectedKeys;return{...A,affectedKeys:I}},1e3,!0)(w=>{w.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$Ai)(w.source),configurationKeys:Array.from(w.affectedKeys)})})}e.$Go=p;function c(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Ho=c;function b(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Io=b;function m(i){const n=i.getValue(f.$Al),a=i.getValue(f.$Bl);if(i.getValue(f.$Cl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Jo=m;function $(i){const n={},a={},w={};g(i,w);for(let A in w){A=A.length>150?A.substr(A.length-149):A;const I=w[A];typeof I=="number"?a[A]=I:typeof I=="boolean"?a[A]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${A} has been trimmed to 8192, the original length is ${I.length}`),n[A]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(n[A]=I)}return{properties:n,measurements:a}}e.$Ko=$;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(i){if(!i)return"none";const n=(0,D.$_k)(i);return d.has(n)?n:"other"}e.$Lo=h;function g(i,n,a=0,w){if(i)for(const A of Object.getOwnPropertyNames(i)){const I=i[A],E=w?w+A:A;Array.isArray(I)?n[E]=(0,P.$pn)(I):I instanceof Date?n[E]=I.toISOString():(0,R.$If)(I)?a<2?g(I,n,a+1,E+"."):n[E]=(0,P.$pn)(I):n[E]=I}}function v(i,n){const a=i.msftInternalDomains||[],w=n.getValue("telemetry.internalTesting");return(0,S.$yo)(a)||w}e.$Mo=v;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$No=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const w=[];for(const C of n)for(;;){const j=C.exec(i);if(!j)break;w.push([j.index,C.lastIndex])}const A=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(a="";;){const C=I.exec(i);if(!C)break;const j=w.some(([W,T])=>C.index<T&&W<I.lastIndex);!A.test(C[0])&&!j&&(a+=i.substring(E,C.index)+"<REDACTED: user-file-path>",E=I.lastIndex)}return E<i.length&&(a+=i.substr(E)),a}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function r(i,n){return(0,P.$mn)(i,a=>{if(a instanceof l||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let w=a.replaceAll("%20"," ");w=t(w,n);for(const A of n)w=w.replace(A,"");return w=o(w),w}})}e.$Oo=r}),define(oe[123],ae([0,1,25,117,120,4,7,14,35,53]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$5e)(r.id,i.id)===0}e.$Po=y;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new p(i.identifier,n,a)}static parse(i){const n=k.exec(i);return n&&n[1]&&n[2]?new p({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof p?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Qo=p;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(r){const i=c.exec(r);return i&&i[1]?[$(i[1]),i[2]]:[$(r),void 0]}e.$Ro=b;function m(r,i){return`${r}.${i}`}e.$So=m;function $(r){return r.toLowerCase()}e.$To=$;function d(r,i){return $(m(r??s.$fm,i))}e.$Uo=d;function h(r,i){const n=[],a=w=>{for(const A of n)if(A.some(I=>y(i(I),i(w))))return A;return null};for(const w of r){const A=a(w);A?A.push(w):n.push([w])}return n}e.$Vo=h;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$Wo=g;function v(r){return{id:new l.$zo(r.identifier.id),name:new l.$zo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Xo=v,e.$Yo=new s.$jm("pprice.better-merge");function u(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const w=a.shift();if(w&&n.every(A=>!y(A.identifier,{id:w}))){const A=r.filter(I=>y(I.identifier,{id:w}));A.length===1&&(n.push(A[0]),a.push(...A[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Zo=u;async function t(r,i){if(!M.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(w){i.debug("Error while getting the os-release file.",(0,S.$0)(w))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),a=(0,R.$jo)(n?"alpine":M.$u,f.$ec);return i.debug("ComputeTargetPlatform:",a),a}e.$1o=o}),define(oe[252],ae([0,1,206,53]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;async function s(M,D,S,f,l,y,k){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,R.$Ho)(D,S)&&(0,R.$Jo)(f)===3){const c=await(0,P.$pp)(S,l,y);p["X-Market-User-Id"]=c,p["VSCode-SessionId"]=k.machineId||c}return p}e.$qp=s}),define(oe[253],ae([0,1,2,38,4,25,185,17,58,79,27,43,28,53]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,h,g){this.k=h,this.l=g,this.d={},this.i=new P.$Sc,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const v of this.f)this.j.push(new RegExp((0,M.$Me)(v),"gi")),v.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$Me)(v.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(v=>{(v.affectsConfiguration(p.$Al)||v.affectsConfiguration(p.$Cl)||v.affectsConfiguration(p.$Bl))&&this.m()}))}setExperimentProperty(d,h){this.d[d]=h}m(){let d=(0,c.$Jo)(this.k);const h=this.l.enabledTelemetryLevels;if(h){this.h=this.sendErrorTelemetry?h.error:!1;const g=h.usage?3:h.error?2:0;d=Math.min(d,g)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,h,g){this.g<h||(g=(0,R.$nn)(g,this.d),g=(0,c.$Oo)(g,this.j),g=(0,R.$nn)(g,this.c),this.b.forEach(v=>v.log(d,g)))}publicLog(d,h){this.n(d,3,h)}publicLog2(d,h){this.publicLog(d,h)}publicLogError(d,h){this.h&&this.n(d,2,h)}publicLogError2(d,h){this.publicLogError(d,h)}};e.$er=b,e.$er=b=Ee([ne(1,S.$xi),ne(2,y.$Dj)],b);function m(){const $=(0,D.localize)(0,null,l.default.nameLong),d=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),h=s.$o?"":(0,D.localize)(3,null),g=(0,D.localize)(4,null),v=(0,D.localize)(5,null),u=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${g} | ${v} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${$} ${d} ${h}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}k.$wn.as(f.$Bn.Configuration).registerConfiguration({id:p.$zl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[p.$Al]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$wn.as(f.$Bn.Configuration).registerConfiguration({id:p.$zl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[p.$Cl]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${p.$Al}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[254],ae([0,1,4,88,28]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=e.$k$b=void 0;async function M(S,f){let l=S.getItem(s.$xl);return(typeof l!="string"||P.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,R.$9m)(f.error.bind(f))),l}e.$k$b=M;async function D(S,f){let l=S.getItem(s.$yl);return typeof l!="string"&&(l=await(0,R.$0m)(f.error.bind(f))),l}e.$l$b=D}),define(oe[255],ae([0,1,28,254]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=e.$m$b=void 0;async function s(D,S){const f=await(0,R.$k$b)(D,S);return D.setItem(P.$xl,f),f}e.$m$b=s;async function M(D,S){const f=await(0,R.$l$b)(D,S);return D.setItem(P.$yl,f),f}e.$n$b=M}),define(oe[124],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(oe[256],ae([0,1,4,124]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((k,p)=>{this.d(k,p);const c=k.map.entries();let b=c.next();for(;!b.done;){const m=b.value[1],$=b.value[0];let d=this.a.get($);if(d||(d=[],this.a.set($,d)),d.length>0&&d[0].type===R.EnvironmentVariableMutatorType.Replace){b=c.next();continue}const h={extensionIdentifier:p,value:m.value,type:m.type,scope:m.scope,variable:m.variable,options:m.options};h.scope||delete h.scope,d.unshift(h),b=c.next()}})}async applyToProcessEnvironment(y,k,p){let c;P.$i&&(c={},Object.keys(y).forEach(b=>c[b.toLowerCase()]=b));for(const[b,m]of this.getVariableMap(k)){const $=P.$i&&c[b.toLowerCase()]||b;for(const d of m){const h=p?await p(d.value):d.value;if(d.options?.applyAtProcessCreation??!0)switch(d.type){case R.EnvironmentVariableMutatorType.Append:y[$]=(y[$]||"")+h;break;case R.EnvironmentVariableMutatorType.Prepend:y[$]=h+(y[$]||"");break;case R.EnvironmentVariableMutatorType.Replace:y[$]=h;break}if(d.options?.applyAtShellIntegration??!1){const g=`VSCODE_ENV_${s.get(d.type)}`;y[g]=(y[g]?y[g]+":":"")+b+"="+this.c(h)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,k){const p=new Map,c=new Map,b=new Map;if(y.getVariableMap(k).forEach((m,$)=>{const d=this.getVariableMap(k).get($),h=S(m,d);h&&p.set($,h)}),this.getVariableMap(k).forEach((m,$)=>{const d=y.getVariableMap(k).get($),h=S(m,d);h&&b.set($,h)}),this.getVariableMap(k).forEach((m,$)=>{const d=y.getVariableMap(k).get($),h=f(m,d);h&&c.set($,h)}),!(p.size===0&&c.size===0&&b.size===0))return{added:p,changed:c,removed:b}}getVariableMap(y){const k=new Map;for(const p of this.a.values()){const c=p.filter(b=>D(b,y));c.length>0&&k.set(c[0].variable,c)}return k}getDescriptionMap(y){const k=new Map;for(const p of this.b.values()){const c=p.filter(b=>D(b,y,!0));for(const b of c)k.set(b.extensionIdentifier,b.description)}return k}d(y,k){if(!y.descriptionMap)return;const p=y.descriptionMap.entries();let c=p.next();for(;!c.done;){const b=c.value[1],m=c.value[0];let $=this.b.get(m);$||($=[],this.b.set(m,$));const d={extensionIdentifier:k,scope:b.scope,description:b.description};d.scope||delete d.scope,$.push(d),c=p.next()}}}e.$Hr=M;function D(l,y,k=!1){return l.scope?!!(l.scope.workspaceFolder&&y?.workspaceFolder&&l.scope.workspaceFolder.index===y.workspaceFolder.index):k?y===l.scope:!0}function S(l,y){if(!y)return l;const k=new Set;y.forEach(c=>k.add(c.extensionIdentifier));const p=[];return l.forEach(c=>{k.has(c.extensionIdentifier)||p.push(c)}),p.length===0?void 0:p}function f(l,y){if(!y)return;const k=new Map;y.forEach(c=>k.set(c.extensionIdentifier,c));const p=[];return l.forEach(c=>{const b=k.get(c.extensionIdentifier);b&&(c.type!==b.type||c.value!==b.value||c.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index)&&p.push(b)}),p.length===0?void 0:p}}),define(oe[257],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gr=e.$Fr=e.$Er=e.$Dr=e.$Cr=e.$Br=void 0;function P(f){return[...f.entries()]}e.$Br=P;function R(f){return f?[...f.entries()]:[]}e.$Cr=R;function s(f){return new Map(f)}e.$Dr=s;function M(f){return new Map(f??[])}e.$Er=M;function D(f){return Array.from(f.entries()).map(l=>[l[0],P(l[1].map),R(l[1].descriptionMap)])}e.$Fr=D;function S(f){return new Map(f.map(l=>[l[0],{map:s(l[1]),descriptionMap:M(l[2])}]))}e.$Gr=S}),define(oe[258],ae([0,1,8,22,3,2,5]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;let S=class extends M.$Tc{constructor(l,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Td),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,M.$Rc)(()=>{for(const k of this.f.values())(0,M.$Oc)(k)}))}createRequest(l){return new Promise((y,k)=>{const p=++this.a;this.c.set(p,y),this.g.fire({requestId:p,...l});const c=new R.$4d;(0,P.$5g)(this.b,c.token).then(()=>k(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$Rc)(()=>c.cancel())])})}acceptReply(l,y){const k=this.c.get(l);k?(this.c.delete(l),(0,M.$Oc)(this.f.get(l)||[]),this.f.delete(l),k(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$sr=S,e.$sr=S=Ee([ne(1,D.$lj)],S)}),define(oe[125],ae([0,1,6,114,43]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=e.$mr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$lr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$kr=void 0,e.$kr=new R.$ij("terminalTabFocusMode",!1,!0);var M;(function(u){u.AutomationProfile="terminal.integrated.automationProfile.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",u.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",u.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",u.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",u.MouseWheelZoom="terminal.integrated.mouseWheelZoom",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var l;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var y;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var k;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$lr=(0,P.$4h)("ptyService");var p;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var c;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(c||(e.TerminalLocation=c={}));var b;(function(u){u.TerminalView="view",u.Editor="editor"})(b||(e.TerminalLocationString=b={}));var m;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(m||(e.LocalReconnectConstants=m={}));var $;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})($||(e.FlowControlConstants=$={}));var d;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(d||(e.ProfileSource=d={}));var h;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var g;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(g||(e.TerminalExitReason=g={})),e.$mr={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$wn.add(e.$mr.Backend,new v),e.$nr=(0,P.$4h)("localPtyService"),e.$or=(0,P.$4h)("terminalLogService")}),define(oe[259],ae([0,1,75,7,187,102]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;function D(p,c){const b=[{name:null,description:(0,s.localize)(0,null)}];return b.push(...p.map(m=>({name:m.profileName,description:S(m)}))),c&&b.push(...c.map(m=>({name:m.title,description:f(m)}))),{values:b.map(m=>m.name),markdownDescriptions:b.map(m=>m.description)}}e.$tr=D;function S(p){let c=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$0j.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?c+=`
- args: "${p.args}"`:c+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(c+=`
- overrideName: ${p.overrideName}`),p.color&&(c+=`
- color: ${p.color}`),p.env&&(c+=`
- env: ${JSON.stringify(p.env)}`),c}function f(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:P.$0j.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function l(p,c){if(!p&&!c)return!0;if(typeof p=="string"&&typeof c=="string")return p===c;if(Array.isArray(p)&&Array.isArray(c)){if(p.length!==c.length)return!1;for(let b=0;b<p.length;b++)if(p[b]!==c[b])return!1;return!0}return!1}e.$ur=l;function y(p,c){if(!p&&!c)return!0;if(!p||!c)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(c))return p.id===c.id&&p.color===c.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof c=="object"&&"light"in c&&"dark"in c){const b=p,m=c;if((R.URI.isUri(b.light)||k(b.light))&&(R.URI.isUri(b.dark)||k(b.dark))&&(R.URI.isUri(m.light)||k(m.light))&&(R.URI.isUri(m.dark)||k(m.dark)))return b.light.path===m.light.path&&b.dark.path===m.dark.path}if(R.URI.isUri(p)&&R.URI.isUri(c)||k(p)||k(c)){const b=p,m=c;return b.path===m.path&&b.scheme===m.scheme}return!1}e.$vr=y;function k(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$wr=k}),define(oe[260],ae([0,1,75,4,186,58,43,259]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ar=e.$zr=e.$yr=e.$xr=void 0,e.$xr={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$yr={type:"string",enum:Array.from((0,P.$9j)(),$=>$.id),markdownEnumDescriptions:Array.from((0,P.$9j)(),$=>`$(${$.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$yr},color:{description:(0,s.localize)(3,null),...e.$xr},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},y={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function k($){const d=$===2?"linux":$===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)($),'```json\n"terminal.integrated.profile.'+d+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function c(){D.$wn.as(M.$Bn.Configuration).registerConfiguration(p),m()}e.$zr=c;let b;function m($,d){const h=D.$wn.as(M.$Bn.Configuration);let g;$&&(g=(0,S.$tr)($?.profiles,d));const v=b;b={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:$?.os===3?g?.values:void 0,markdownEnumDescriptions:$?.os===3?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:$?.os===2?g?.values:void 0,markdownEnumDescriptions:$?.os===2?g?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:$?.os===1?g?.values:void 0,markdownEnumDescriptions:$?.os===1?g?.markdownDescriptions:void 0}}},h.updateConfigurations({add:[b],remove:v?[v]:[]})}e.$Ar=m}),define(oe[261],ae([0,1,26,13,38,9,4,35,25,12,21,124,257,256]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=void 0;function b(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Ir=b;async function m(i,n,a,w=S.env,A=y.Promises.exists){if(M.$ic(i))return await A(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$mc(i)!=="."){const j=M.$jc(n,i);return await A(j)?j:void 0}const E=(0,s.$rn)(w,"PATH");if(a===void 0&&(0,l.$Gf)(E)&&(a=E.split(M.$tc)),a===void 0||a.length===0){const j=M.$jc(n,i);return await A(j)?j:void 0}for(const j of a){let W;if(M.$ic(j)?W=M.$jc(j,i):W=M.$jc(n,j,i),await A(W))return W;if(D.$i){let T=W+".com";if(await A(T)||(T=W+".exe",await A(T)))return T}}const C=M.$jc(n,i);return await A(C)?C:void 0}e.$Jr=m;function $(i,n,a,w,A){const I=D.$i&&(!n.windowsEnableConpty||b()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,C=S.$dc==="win32"?M.$nc(i.executable).toLowerCase():M.$nc(i.executable),j=M.$mc(R.$mg.asFileUri("").fsPath);let W;const T={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(T.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(C==="pwsh.exe"||C==="powershell.exe")return!E||o(E)?W=g.get(h.WindowsPwsh):t(E)&&(W=g.get(h.WindowsPwshLogin)),W?(W=[...W],W[W.length-1]=(0,f.$Ie)(W[W.length-1],j,""),n.shellIntegration.suggestEnabled&&(T.VSCODE_SUGGEST="1"),{newArgs:W,envMixin:T}):void 0;w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(C){case"bash":return!E||E.length===0?W=g.get(h.Bash):r(E)&&(T.VSCODE_SHELL_LOGIN="1",d(n,T),W=g.get(h.Bash)),W?(W=[...W],W[W.length-1]=(0,f.$Ie)(W[W.length-1],j),{newArgs:W,envMixin:T}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",K=M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return T.XDG_DATA_DIRS=`${G}:${K}`,d(n,T),{newArgs:void 0,envMixin:T}}case"pwsh":return!E||o(E)?W=g.get(h.Pwsh):t(E)&&(W=g.get(h.PwshLogin)),W?(n.shellIntegration.suggestEnabled&&(T.VSCODE_SUGGEST="1"),W=[...W],W[W.length-1]=(0,f.$Ie)(W[W.length-1],j,""),{newArgs:W,envMixin:T}):void 0;case"zsh":{if(!E||E.length===0?W=g.get(h.Zsh):r(E)?(W=g.get(h.ZshLogin),d(n,T)):(E===g.get(h.Zsh)||E===g.get(h.ZshLogin))&&(W=E),!W)return;W=[...W],W[W.length-1]=(0,f.$Ie)(W[W.length-1],j);let G;try{G=P.userInfo().username}catch{G="unknown"}const K=M.$jc(P.tmpdir(),`${G}-${A.applicationName}-zsh`);T.ZDOTDIR=K;const le=a?.ZDOTDIR??P.homedir()??"~";T.USER_ZDOTDIR=le;const re=[];return re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$jc(K,".zshrc")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$jc(K,".zprofile")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$jc(K,".zshenv")}),re.push({source:M.$jc(j,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$jc(K,".zlogin")}),{newArgs:W,envMixin:T,filesToCopy:re}}}w.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Kr=$;function d(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,p.$Gr)(i.environmentVariableCollections),A=new c.$Hr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(A)for(const E of A)E.type===k.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var h;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(h||(h={}));const g=new Map;g.set(h.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),g.set(h.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),g.set(h.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),g.set(h.Zsh,["-i"]),g.set(h.ZshLogin,["-il"]),g.set(h.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?v.includes(i.toLowerCase()):i.length===1&&v.includes(i[0].toLowerCase())||i.length===2&&(v.includes(i[0].toLowerCase())||v.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function r(i){return i==="string"&&v.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&v.includes(i[0].toLowerCase())}}),define(oe[262],ae([0,1,48,75,9,4,12,21,106,261,113]),function(Q,e,P,R,s,M,D,S,f,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;var k;(function(a){a.UnixShellsPath="/etc/shells"})(k||(k={}));let p,c=!0;function b(a,w,A,I,E=process.env,C,j,W,T){return C=C||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?m(A,C,E,j,I.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:I.getValue("terminal.integrated.profiles.windows"),typeof w=="string"?w:I.getValue("terminal.integrated.defaultProfile.windows"),T,W):r(C,j,A,a&&typeof a=="object"?{...a}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof w=="string"?w:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),T,W,E)}e.$Lr=b;async function m(a,w,A,I,E,C,j,W,T){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),K=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let le=!1;(0,l.$Ir)()>=16299&&(le=!0),await g(W);const re=new Map;if(a){re.set("PowerShell",{source:"PowerShell",icon:R.$0j.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${K}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$0j.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${K}\\cmd.exe`,icon:R.$0j.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$0j.terminalBash,isAutoDetected:!0});const Y=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${K}\\cmd.exe`,args:["/K",Y],requiresPath:process.env.CMDER_ROOT?Y:{path:Y,isUnsafe:!0},isAutoDetected:!0})}i(C,re);const ue=await $(re.entries(),j,w,A,I,T);if(a&&E)try{const Y=await t(`${K}\\${le?"wsl":"bash"}.exe`,j);for(const Z of Y)(!C||!(Z.profileName in C))&&ue.push(Z)}catch{c&&(I?.info("WSL is not installed, so could not detect WSL profiles"),c=!1)}return ue}async function $(a,w,A,I=process.env,E,C){const j=[];for(const[W,T]of a)j.push(d(W,T,w,A,I,E,C));return(await Promise.all(j)).filter(W=>!!W)}async function d(a,w,A,I,E=process.env,C,j){if(w===null)return;let W,T,G;if("source"in w&&!("path"in w)){const ue=p?.get(w.source);if(!ue)return;W=ue.paths,T=w.args||ue.args,w.icon?G=h(w.icon):ue.icon&&(G=ue.icon)}else W=Array.isArray(w.path)?w.path:[w.path],T=M.$i||Array.isArray(w.args)?w.args:void 0,G=h(w.icon);let K;if(j){const ue=W.map(Z=>typeof Z=="string"?Z:Z.path),Y=await j(ue);K=new Array(W.length);for(let Z=0;Z<W.length;Z++)typeof W[Z]=="string"?K[Z]=Y[Z]:K[Z]={path:Y[Z],isUnsafe:!0}}else K=W.slice();let le;if(w.requiresPath){let ue;if((0,D.$Gf)(w.requiresPath)?ue=w.requiresPath:(ue=w.requiresPath.path,w.requiresPath.isUnsafe&&(le=ue)),!await I.existsFile(ue))return}const re=await n(a,A,K,I,E,T,w.env,w.overrideName,w.isAutoDetected,le);if(!re){C?.debug("Terminal profile not validated",a,W);return}return re.isAutoDetected=w.isAutoDetected,re.icon=G,re.color=w.color,re}function h(a){return typeof a=="string"?{id:a}:a}async function g(a){if(p&&!a)return;const[w,A]=await Promise.all([v(),a||u()]);p=new Map,p.set("Git Bash",{profileName:"Git Bash",paths:w,args:["--login","-i"]}),p.set("PowerShell",{profileName:"PowerShell",paths:A,icon:R.$0j.terminalPowershell})}async function v(){const a=new Set,w=await(0,l.$Jr)("git.exe");if(w){const E=(0,y.dirname)(w);a.add((0,y.resolve)(E,"../.."))}function A(E,C){C&&E.add(C)}A(a,process.env.ProgramW6432),A(a,process.env.ProgramFiles),A(a,process.env["ProgramFiles(X86)"]),A(a,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of a)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function u(){const a=[];for await(const w of(0,f.$Nl)())a.push(w.exePath);return a}async function t(a,w){const A=[],I=await new Promise((j,W)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(T,G)=>{if(T)return W("Problem occurred when getting wsl distros");j(G)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),C=I.split(E).filter(j=>j.trim().length>0&&j!=="");for(const j of C){if(j===""||j.startsWith("docker-desktop"))continue;const W=`${j} (WSL)`,T={profileName:W,path:a,args:["-d",`${j}`],isDefault:W===w,icon:o(j),isAutoDetected:!1};A.push(T)}return A}function o(a){return a.includes("Ubuntu")?R.$0j.terminalUbuntu:a.includes("Debian")?R.$0j.terminalDebian:R.$0j.terminalLinux}async function r(a,w,A,I,E,C,j,W){const T=new Map;if(A&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),K=(C||G.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),le=new Map;for(const re of K){let ue=(0,s.$nc)(re),Y=le.get(ue)||0;Y++,Y>1&&(ue=`${ue} (${Y})`),le.set(ue,Y),T.set(ue,{path:re,isAutoDetected:!0})}}return i(I,T),await $(T.entries(),E,a,W,w,j)}function i(a,w){if(a)for(const[A,I]of Object.entries(a))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?w.delete(A):(I.icon=I.icon||w.get(A)?.icon,w.set(A,I))}async function n(a,w,A,I,E,C,j,W,T,G){if(A.length===0)return Promise.resolve(void 0);const K=A.shift();if(K==="")return n(a,w,A,I,E,C,j,W,T);const le=typeof K!="string"&&K.isUnsafe,re=typeof K=="string"?K:K.path,ue={profileName:a,path:re,args:C,env:j,overrideName:W,isAutoDetected:T,isDefault:a===w,isUnsafePath:le,requiresUnsafePath:G};if((0,s.$nc)(re)===re){const Z=E.PATH?E.PATH.split(s.$tc):void 0,H=await(0,l.$Jr)(re,void 0,Z,void 0,I.existsFile);return H?(ue.path=H,ue.isFromPath=!0,ue):n(a,w,A,I,E,C)}return await I.existsFile((0,s.$hc)(re))?ue:n(a,w,A,I,E,C,j,W,T)}}),define(oe[263],ae([0,1,3,2,4,42,17,5,226,94,258,125,260,262,108,73]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;var $;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})($||($={}));let d=class extends R.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(g,v,u,t){super(),this.M=g,this.N=v,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Td),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Td),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Td),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Td),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Td),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Td),this.onProcessData=this.D.event,this.F=this.B(new P.$Td),this.onProcessReady=this.F.event,this.G=this.B(new P.$Td),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Td),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Td),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Td),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Td),this.onProcessExit=this.L.event,(0,p.$zr)(),this.B(this.M),this.B((0,R.$Rc)(()=>this.W())),this.j=this.B(new y.$sr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$0l)(this.N,this.O,{_:[]},process.env)}catch(g){return this.O.error("ptyHost was unable to resolve shell environment",g),{}}}U(){const g=this.M.start(),v=g.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(v.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(g.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=$.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=M.ProxyChannel.toService(v.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new f.$rr(this.P,v.getChannel(k.TerminalIpcChannels.Logger))),this.a=g,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[g,t]}async createProcess(g,v,u,t,o,r,i,n,a,w,A){const I=setTimeout(()=>this.$(),k.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(g,v,u,t,o,r,i,n,a,w,A);return clearTimeout(I),E}updateTitle(g,v,u){return this.f.updateTitle(g,v,u)}updateIcon(g,v,u,t){return this.f.updateIcon(g,v,u,t)}attachToProcess(g){return this.f.attachToProcess(g)}detachFromProcess(g,v){return this.f.detachFromProcess(g,v)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(g){return this.f.start(g)}shutdown(g,v){return this.f.shutdown(g,v)}input(g,v){return this.f.input(g,v)}processBinary(g,v){return this.f.processBinary(g,v)}resize(g,v,u){return this.f.resize(g,v,u)}clearBuffer(g){return this.f.clearBuffer(g)}acknowledgeDataEvent(g,v){return this.f.acknowledgeDataEvent(g,v)}setUnicodeVersion(g,v){return this.f.setUnicodeVersion(g,v)}getInitialCwd(g){return this.f.getInitialCwd(g)}getCwd(g){return this.f.getCwd(g)}async getLatency(){const g=new m.$Pd,v=await this.f.getLatency();return g.stop(),[{label:"ptyhostservice<->ptyhost",latency:g.elapsed()},...v]}orphanQuestionReply(g){return this.f.orphanQuestionReply(g)}installAutoReply(g,v){return this.f.installAutoReply(g,v)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(g){return this.f.uninstallAutoReply(g)}getDefaultSystemShell(g){return this.g?.getDefaultSystemShell(g)??(0,b.$Tl)(g??s.OS,process.env)}async getProfiles(g,v,u,t=!1){const o=await this.S();return(0,c.$Lr)(v,u,t,this.N,o,void 0,this.O,this.bb.bind(this,g))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(g,v){return this.f.getWslPath(g,v)}getRevivedPtyNewId(g,v){return this.f.getRevivedPtyNewId(g,v)}setTerminalLayoutInfo(g){return this.f.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return this.g?.getTerminalLayoutInfo(g)}async requestDetachInstance(g,v){return this.f.requestDetachInstance(g,v)}async acceptDetachInstanceReply(g,v){return this.f.acceptDetachInstanceReply(g,v)}async freePortKillProcess(g){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(g)}async serializeTerminalState(g){return this.f.serializeTerminalState(g)}async reviveTerminalProcesses(g,v,u){return this.f.reviveTerminalProcesses(g,v,u)}async refreshProperty(g,v){return this.f.refreshProperty(g,v)}async updateProperty(g,v,u){return this.f.updateProperty(g,v,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(g){this.ab(),this.s=setTimeout(()=>this.Y(),g?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(g,v){return this.j.createRequest({workspaceId:g,originalText:v})}async acceptPtyHostResolvedVariables(g,v){this.j.acceptReply(g,v)}};e.$Mr=d,e.$Mr=d=Ee([ne(1,D.$xi),ne(2,S.$lj),ne(3,S.$mj)],d)}),define(oe[70],ae([0,1,15,3,2,4,17,6,34]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J9b=e.$I9b=void 0;const l="#FFFFFF",y="#1E1E1E",k="#000000",p="#FFFFFF",c="theme",b="themeBackground",m="windowSplash";e.$I9b=(0,S.$4h)("themeMainService");let $=class extends s.$Tc{constructor(h,g){super(),this.b=h,this.c=g,this.a=this.B(new R.$Td),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(v=>{v.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(P.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":P.nativeTheme.themeSource="dark";break;case"light":P.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":P.nativeTheme.themeSource="light";break;case"vs-dark":P.nativeTheme.themeSource="dark";break;default:P.nativeTheme.themeSource="system"}break;default:P.nativeTheme.themeSource="system";break}}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?k:p;let g=this.b.getItem(b,null);if(!g)switch(this.g()){case"vs":g=l;break;case"hc-black":g=k;break;case"hc-light":g=p;break;default:g=y}return M.$j&&g.toUpperCase()===y&&(g="#171717"),g}g(){switch(this.b.getItem(c,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(h,g){this.b.setItems([{key:c,data:g.baseTheme},{key:b,data:g.colorInfo.background},{key:m,data:g}]),typeof h=="number"&&this.h(h,g),this.f()}h(h,g){for(const v of P.BrowserWindow.getAllWindows())if(v.id===h){v.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(m)}};e.$J9b=$,e.$J9b=$=Ee([ne(0,f.$cO),ne(1,D.$xi)],$)}),define(oe[126],ae([0,1,3,17,6,5]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.ProvidedOnAutoForward=e.$sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$rv=e.$qv=void 0,e.$qv=(0,s.$4h)("tunnelService"),e.$rv=(0,s.$4h)("sharedTunnelsService");var D;(function($){$.Http="http",$.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function($){$.ConstantPrivate="constantPrivate",$.Private="private",$.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f($){return!!$.forwardPort}e.$sv=f;var l;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function y($){if($.scheme!=="http"&&$.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec($.authority);if(d)return{address:d[1],port:+d[2]}}e.$tv=y,e.$uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k($){return e.$uv.indexOf($)>=0}e.$vv=k,e.$wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p($){return e.$wv.indexOf($)>=0}e.$xv=p;function c($,d,h,g){if(h===1)return!1;if(h===2&&p(d)){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(g);if(v?.length===4&&parseInt(v[1])>=18)return!1}return $<1024}e.$yv=c;class b{constructor(d,h,g){this.remoteAddress=d,this.localAddress=h,this.b=g,this.a=new P.$Td,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$zv=b;let m=class{constructor(d,h){this.j=d,this.k=h,this.a=new P.$Td,this.onTunnelOpened=this.a.event,this.b=new P.$Td,this.onTunnelClosed=this.b.event,this.c=new P.$Td,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const d=this.k.getValue("remote.localPortHost");return!d||d==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(d){return this.f=d,d?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this.g=d.elevation,this.h=d.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const d=[],h=Array.from(this.e.values());for(const g of h){const v=Array.from(g.values());for(const u of v){const t=await u.value;t&&typeof t!="string"&&d.push(t)}}return d}async dispose(){for(const d of this.e.values()){for(const{value:h}of d.values())await h.then(g=>typeof g!="string"?g?.dispose():void 0);d.clear()}this.e.clear()}setEnvironmentTunnel(d,h,g,v,u){this.p(d,h,Promise.resolve({tunnelRemoteHost:d,tunnelRemotePort:h,localAddress:g,privacy:v,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(d,h){(p(d)||k(d))&&(d=e.$uv[0]);const g=this.r(d,h);if(g)return++g.refcount,g.value}openTunnel(d,h,g,v,u,t=!1,o,r){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${g} on local port ${u}.`);const i=this.f??d;if(!i)return;if(h||(h="localhost"),v||(v=this.l),this.f&&this.i.has(g)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,h,g,v,u,t,o,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(h,g),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(h,g);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const w=this.n(a);return(a.tunnelRemoteHost!==h||a.tunnelRemotePort!==g)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&a.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(w),w}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const h=this.e.get(d.tunnelRemoteHost);if(h){const g=h.get(d.tunnelRemotePort);g&&(g.refcount--,await this.o(d.tunnelRemoteHost,d.tunnelRemotePort,g))}}}}async o(d,h,g){if(g.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${h}.`);const v=g.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(d)&&this.e.get(d).delete(h),v}}async closeTunnel(d,h){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${h} `);const g=this.e.get(d);if(g&&g.has(h)){const v=g.get(h);v.refcount=0,await this.o(d,h,v)}}p(d,h,g){this.e.has(d)||this.e.set(d,new Map),this.e.get(d).set(h,{refcount:1,value:g})}async q(d,h){const g=this.e.get(d);if(g){const v=g.get(h),u=v?await v.value:void 0;(!u||typeof u=="string")&&g.delete(h),g.size===0&&this.e.delete(d)}}r(d,h){const g=[d];k(d)?(g.push(...e.$uv),g.push(...e.$wv)):p(d)&&g.push(...e.$wv);const v=g.map(u=>this.e.get(u));for(const u of v){const t=u?.get(h);if(t)return t}}canTunnel(d){return!!y(d)}t(d,h,g,v,u,t,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${g} on local port ${v}.`);const r=g;this.i.add(r);const i=v===void 0?g:v,n={elevationRequired:u?this.isPortPrivileged(i):!1},a={remoteAddress:{host:h,port:g},localAddressPort:v,privacy:t,public:t?t!==S.Private:void 0,protocol:o},w=d.forwardPort(a,n);return w?(this.p(h,g,w),w.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(r)})):this.i.delete(r),w}};e.$Av=m,e.$Av=m=Ee([ne(0,M.$lj),ne(1,R.$xi)],m)}),define(oe[49],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oV=e.$nV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$nV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$oV=(0,P.$4h)("updateService")}),define(oe[264],ae([0,1,4,188,58,43]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$wn.as(s.$Bn.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[265],ae([0,1,3,49]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X0b=e.$W0b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.$W0b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Td,this.onStateChange=this.a.event,this.b=R.$nV.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$X0b=M}),define(oe[40],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=void 0,e.$Yk=(0,P.$4h)("IUriIdentityService")}),define(oe[266],ae([0,1,40,207,16,19,141,3,2]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;class l{static{this._clock=0}constructor(p){this.uri=p,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let y=class{constructor(p){this.g=p,this.c=new f.$Sc,this.f=2**16;const c=new Map,b=m=>{let $=c.get(m.scheme);return $===void 0&&($=p.hasProvider(m)&&!this.g.hasCapability(m,1024),c.set(m.scheme,$)),$};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(m=>{c.delete(m.scheme)})),this.extUri=new M.$ug(b),this.d=new D.$Pr((m,$)=>this.extUri.compare(m,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$Gg)(p));const c=this.d.get(p);return c?c.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new l(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((b,m)=>b[1].time<m[1].time?1:b[1].time>m[1].time?-1:0);l._clock=0,this.d.clear();const c=this.f*.5;for(let b=0;b<c;b++)this.d.set(p[b][0],p[b][1].touch())}};e.$Qr=y,e.$Qr=y=Ee([ne(0,s.$ok)],y),(0,R.$Nr)(P.$Yk,y,1)}),define(oe[127],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eV=void 0,e.$eV=(0,P.$4h)("urlService")}),define(oe[267],ae([0,1,7]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=e.$60b=e.$50b=void 0;class R{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.$50b=R;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$60b=s;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,l,y){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const k=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",k.toString(!0)),k.query){const p=/\bwindowId=(\d+)/.exec(k.query);if(p){const c=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${c}"`,k.toString(!0));const b=new RegExp(`window:${c}`),m=S.connections.find($=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",$.ctx),b.test($.ctx)));if(m)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",k.toString(!0)),m;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",k.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",k.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,l,y)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$70b=M}),define(oe[268],ae([0,1,8,2,7,27]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gV=e.$fV=void 0;class D extends R.$Tc{constructor(){super(...arguments),this.a=new Set}open(l,y){const k=[...this.a.values()];return(0,P.$8g)(k.map(p=>()=>p.handleURL(l,y)),void 0,!1).then(p=>p||!1)}registerHandler(l){return this.a.add(l),(0,R.$Rc)(()=>this.a.delete(l))}}e.$fV=D;let S=class extends D{constructor(l){super(),this.b=l}create(l){let{authority:y,path:k,query:p,fragment:c}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return y&&k&&k.indexOf("/")!==0&&(k=`/${k}`),s.URI.from({scheme:this.b.urlProtocol,authority:y,path:k,query:p,fragment:c})}};e.$gV=S,e.$gV=S=Ee([ne(0,M.$Dj)],S)}),define(oe[269],ae([0,1,15,8,3,2,4,7]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$80b=void 0;class f extends M.$Tc{constructor(y,k,p,c,b,m){if(super(),this.c=k,this.f=m,this.a=[],this.b=0,y&&(m.trace("ElectronURLListener initialUrisToHandle:",y.map(h=>h.originalUrl)),this.a=y),D.$i){const h=c.isBuilt?[]:[`"${c.appRoot}"`];h.push("--open-url","--"),P.app.setAsDefaultProtocolClient(b.urlProtocol,process.execPath,h)}const $=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(h,g)=>({event:h,url:g})),({event:h,url:g})=>(h.preventDefault(),g));this.B($(h=>{const g=this.g(h);g&&this.c.open(g,{originalUrl:h})})),p.getWindows().filter(h=>h.isReady).length>0?(m.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(m.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(p.onDidSignalReadyWindow)(()=>this.h())))}g(y){try{return S.URI.parse(y)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const y=[];for(const k of this.a)await this.c.open(k.uri,{originalUrl:k.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",k.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",k.originalUrl),y.push(k));y.length!==0&&(this.a=y,(0,R.$6g)(()=>this.h(),500,this.q))}}e.$80b=f}),define(oe[270],ae([0,1,3,2,16,57,31]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class S extends R.$Tc{constructor(l,y,k,p,c,b){super(),this.f=l,this.g=y,this.h=k,this.j=p,this.m=c,this.n=b,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Td),this.onDidChangeFile=this.a.event,this.b=M.$0h.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(m=>this.m.extUri.getComparisonKey(this.t(m))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(m=>this.s(m)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,y){return this.g.open(this.t(l),y)}close(l){return this.g.close(l)}read(l,y,k,p,c){return this.g.read(l,y,k,p,c)}write(l,y,k,p,c){return this.g.write(l,y,k,p,c)}watch(l,y){this.b.set(l,l);const k=this.g.watch(this.t(l),y);return(0,R.$Rc)(()=>{this.b.delete(l),k.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,y,k){return this.g.rename(this.t(l),this.t(y),k)}readFile(l,y){return this.g.readFile(this.t(l),y)}readFileStream(l,y,k){return this.g.readFileStream(this.t(l),y,k)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,y,k){return this.g.writeFile(this.t(l),y,k)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,y){return this.g.delete(this.t(l),y)}copy(l,y,k){if((0,s.$sk)(this.g))return this.g.copy(this.t(l),this.t(y),k);throw new Error("copy not supported")}cloneFile(l,y){if((0,s.$tk)(this.g))return this.g.cloneFile(this.t(l),this.t(y));throw new Error("clone not supported")}s(l){const y=[];for(const k of l){if(k.resource.scheme!==this.f)continue;const p=this.u(k.resource);this.b.findSubstr(p)&&y.push({resource:p,type:k.type,cId:k.cId})}y.length&&(this.n.debug("User data changed"),this.a.fire(y))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$I$b=S}),define(oe[271],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=void 0,e.$p$b="utilityProcessWorker"}),define(oe[272],ae([0,1,6]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=void 0,e.$90b=(0,P.$4h)("webviewManagerService")}),define(oe[273],ae([0,1,15,2,13,7]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$00b=void 0;class D extends R.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,l){try{const y=M.URI.parse(f.url),k=D.a.get(y.path);if(typeof k=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${k}`,c=s.$mg.asFileUri(p);return l({path:c.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$00b=D}),define(oe[60],ae([0,1,4]),function(Q,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MC=e.$LC=e.$KC=e.$JC=e.$IC=e.$HC=e.$GC=e.$FC=e.$EC=e.$DC=void 0,e.$DC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(p){return typeof p.parentId=="number"}e.$EC=R;function s(p){return!!p.workspaceUri}e.$FC=s;function M(p){return!!p.folderUri}e.$GC=M;function D(p){return!!p.fileUri}e.$HC=D;function S(p){const c=f(p),b=p.getValue("window.menuBarVisibility");return b==="default"||c==="native"&&b==="compact"||P.$j&&P.$m?"classic":b}e.$IC=S;function f(p){if(P.$o)return"custom";const c=p.getValue("window");if(c){if(P.$j&&c.nativeTabs===!0||P.$j&&c.nativeFullScreen===!1)return"native";const $=c.titleBarStyle;if($==="native"||$==="custom")return $}return P.$k?"native":"custom"}e.$JC=f;function l(p){return!(!P.$i||P.$o||f(p)==="native")}e.$KC=l;function y(p){const c=p.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}e.$LC=y;function k(p=0){return Math.pow(1.2,p)}e.$MC=k}),define(oe[128],ae([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$y9b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var R;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$y9b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(oe[274],ae([0,1,8,3,2]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;class M extends s.$Tc{constructor({onDidOpenMainWindow:S,onDidFocusMainWindow:f,getActiveWindowId:l}){super(),this.a=this.B(new s.$Sc),R.Event.latch(R.Event.any(S,f))(this.f,this,this.a),this.b=(0,P.$Rg)(()=>l()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$d$b=M}),define(oe[30],ae([0,1,192,9,57,19,7,6,13]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.WorkbenchState=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0,e.$ai=(0,S.$4h)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$bi=l;function y(i){return typeof i?.id=="string"&&!l(i)&&!p(i)}e.$ci=y,e.$di={id:"ext-dev"},e.$ei={id:"empty-window"};function k(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$di:e.$ei;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$fi=k;function p(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$gi=p;function c(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$hi=c;var b;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ii=m;function $(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ji=$;class d{constructor(n,a,w,A,I){this.h=n,this.j=w,this.k=A,this.l=I,this.c=s.$0h.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$0h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ki=d;class h{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$Fg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$li=h;function g(i){return new h({uri:i,index:0,name:(0,M.$Bg)(i)},{uri:i.toString()})}e.$mi=g,e.$ni="code-workspace",e.$oi=`.${e.$ni}`,e.$pi=[{name:(0,P.localize)(0,null),extensions:[e.$ni]}],e.$qi="workspace.json";function v(i,n){return M.$wg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ri=v;function u(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$si=u,e.$ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$ti}e.$ui=t;function o(i,n){return!v(i,n)&&!u(i)}e.$vi=o;function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,M.$Dg)(i))===e.$oi}e.$wi=r}),define(oe[54],ae([0,1,15,8,45,47,2,85,4,21,167,115,6,5,27,30]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9b=e.$F9b=void 0,e.$F9b=(0,p.$4h)("dialogMainService");let $=class{constructor(h,g){this.d=h,this.e=g,this.a=new Map,this.b=new Map,this.c=new R.$$g}pickFileFolder(h,g){return this.f({...h,pickFolders:!0,pickFiles:!0,title:(0,y.localize)(0,null)},g)}pickFolder(h,g){return this.f({...h,pickFolders:!0,title:(0,y.localize)(1,null)},g)}pickFile(h,g){return this.f({...h,pickFiles:!0,title:(0,y.localize)(2,null)},g)}pickWorkspace(h,g){const v=(0,y.localize)(3,null),u=(0,M.$Sv)((0,y.localize)(4,null)),t=m.$pi;return this.f({...h,pickFiles:!0,title:v,filters:t,buttonLabel:u},g)}async f(h,g){const v={title:h.title,buttonLabel:h.buttonLabel,filters:h.filters,defaultPath:h.defaultPath};(typeof h.pickFiles=="boolean"||typeof h.pickFolders=="boolean")&&(v.properties=void 0,h.pickFiles&&h.pickFolders&&(v.properties=["multiSelections","openDirectory","openFile","createDirectory"])),v.properties||(v.properties=["multiSelections",h.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&v.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(v,(g||P.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(h){if(h){let g=this.b.get(h.id);return g||(g=new R.$$g,this.b.set(h.id,g)),g}else return this.c}showMessageBox(h,g){return this.g(g).queue(async()=>{const{options:v,buttonIndeces:u}=(0,k.$Zv)(h,this.e);let t;return g?t=await P.dialog.showMessageBox(g,v):t=await P.dialog.showMessageBox(v),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(h,g){const v=this.j(h,g);if(!v)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(g).queue(async()=>{let u;return g?u=await P.dialog.showSaveDialog(g,h):u=await P.dialog.showSaveDialog(h),u.filePath=this.h(u.filePath),u})}finally{(0,D.$Oc)(v)}}h(h){return h&&f.$j&&(h=(0,S.$El)(h)),h}i(h){return h.map(g=>this.h(g))}async showOpenDialog(h,g){h.defaultPath&&(await l.Promises.exists(h.defaultPath)||(h.defaultPath=void 0));const v=this.j(h,g);if(!v)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(g).queue(async()=>{let u;return g?u=await P.dialog.showOpenDialog(g,h):u=await P.dialog.showOpenDialog(h),u.filePaths=this.i(u.filePaths),u})}finally{(0,D.$Oc)(v)}}j(h,g){if(!g)return D.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",h);let v=this.a.get(g.id);v||(v=new Set,this.a.set(g.id,v));const u=(0,s.$Ri)(h);if(!v.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",h),v.add(u),(0,D.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",h),v?.delete(u),v?.size===0&&this.a.delete(g.id)})}};e.$G9b=$,e.$G9b=$=Ee([ne(0,c.$lj),ne(1,b.$Dj)],$)}),define(oe[275],ae([0,1,3,2,77,30]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T0b=void 0;class D extends R.$Tc{static{this.a=100}constructor(f,l){super(),this.f=f,this.g=l,this.b=this.B(new P.$Td),this.c=new Map,this.h(l.applicationStorage,this.b)}h(f,l){this.B(P.Event.debounce(f.onDidChangeStorage,(y,k)=>(y?y.push(k):y=[k],y),D.a)(y=>{y.length&&l.fire(this.j(y,f))}))}j(f,l){const y=new Map,k=new Set;return f.forEach(p=>{const c=l.get(p.key);typeof c=="string"?y.set(p.key,c):k.add(p.key)}),{changed:Array.from(y.entries()),deleted:Array.from(k.values())}}listen(f,l,y){switch(l){case"onDidChangeStorage":{const k=y.profile?(0,s.$Ah)(y.profile):void 0;if(!k)return this.b.event;let p=this.c.get(k.id);return p||(p=this.B(new P.$Td),this.h(this.g.profileStorage(k),p),this.c.set(k.id,p)),p.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,y){const k=y.profile?(0,s.$Ah)(y.profile):void 0,p=(0,M.$hi)(y.workspace),c=await this.m(k,p);switch(l){case"getItems":return Array.from(c.items.entries());case"updateItems":{const b=y;if(b.insert)for(const[m,$]of b.insert)c.set(m,$);b.delete?.forEach(m=>c.delete(m));break}case"optimize":return c.optimize();case"isUsed":{const b=y.payload;if(typeof b=="string")return this.g.isUsed(b)}default:throw new Error(`Call not found: ${l}`)}}async m(f,l){let y;l?y=this.g.workspaceStorage(l):f?y=this.g.profileStorage(f):y=this.g.applicationStorage;try{await y.init()}catch(k){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${k}`)}return y}}e.$T0b=D}),define(oe[41],ae([0,1,45,3,2,19,7,189,37,16,6,5,30,31,40,8,32,25,12]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.ProfileResourceType=void 0;var g;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(g||(e.ProfileResourceType=g={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Zk=v,e.$1k=(0,y.$4h)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$2k=u;function t(i,n,a,w,A,I){return{id:i,name:n,location:a,isDefault:!1,shortName:A?.shortName,icon:A?.icon,globalStorageHome:I&&A?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$Fg)(a,"globalStorage"),settingsResource:I&&A?.useDefaultFlags?.settings?I.settingsResource:(0,M.$Fg)(a,"settings.json"),keybindingsResource:I&&A?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$Fg)(a,"keybindings.json"),tasksResource:I&&A?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$Fg)(a,"tasks.json"),snippetsHome:I&&A?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$Fg)(a,"snippets"),extensionsResource:I&&A?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$Fg)(a,"extensions.json"),cacheHome:(0,M.$Fg)(w,i),useDefaultFlags:A?.useDefaultFlags,isTransient:A?.transient}}e.$3k=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,w,A){super(),this.t=n,this.u=a,this.w=w,this.y=A,this.f=!0,this.h=this.B(new R.$Td),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Td),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Td),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Td),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$Ac,emptyWindows:new Map},this.profilesHome=(0,M.$Fg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$Fg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,h.$Gf)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,M.$Cg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const w=new c.$Ac,A=new Map;if(a.length)try{const I=this.Q();if(I.workspaces)for(const[E,C]of Object.entries(I.workspaces)){const j=D.URI.parse(E),W=a.find(T=>T.id===C);W&&w.set(j,W)}if(I.emptyWindows)for(const[E,C]of Object.entries(I.emptyWindows)){const j=a.find(W=>W.id===C);j&&A.set(E,j)}}catch(I){this.y.error(I)}this.z={profiles:a,workspaces:w,emptyWindows:A}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",w=new RegExp(`${(0,d.$Me)(a)}\\s(\\d+)`);let A=0;for(const E of this.profiles){const C=w.exec(E.name),j=C?parseInt(C[1]):0;A=j>A?j:A}const I=`${a} ${A+1}`;return this.createProfile((0,P.$Ri)((0,$.$og)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,a,w){return this.createProfile((0,P.$Ri)((0,$.$og)()).toString(16),n,a,w)}async createProfile(n,a,w,A){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,a,w);return A&&await this.setProfileForWorkspace(A,I),I}async F(n,a,w){if(!(0,h.$Gf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let A=this.r.get(a);return A||(A=(async()=>{try{const I=this.profiles.find(j=>j.name===a||j.id===n);if(I)return I;const E=t(n,a,(0,M.$Fg)(this.profilesHome,n),this.g,w,this.defaultProfile);await this.u.createFolder(E.location);const C=[];return this.j.fire({profile:E,join(j){C.push(j)}}),await m.Promises.settled(C),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,A)),A}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let w=this.profiles.find(A=>A.id===n.id);if(!w)throw new Error(`Profile '${n.name}' does not exist`);return w=t(w.id,a.name??w.name,w.location,this.g,{shortName:a.shortName??w.shortName,icon:a.icon===null?void 0:a.icon??w.icon,transient:a.transient??w.isTransient,useDefaultFlags:a.useDefaultFlags??w.useDefaultFlags},this.defaultProfile),this.I([],[],[w]),w}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(A=>A.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const w=[];this.m.fire({profile:a,join(A){w.push(A)}});try{await Promise.allSettled(w)}catch(A){this.y.error(A)}for(const A of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(A)?.id&&this.C.emptyWindows.delete(A);for(const A of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(A)?.id&&this.C.workspaces.delete(A);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(A){(0,l.$Fk)(A)!==1&&this.y.error(A)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=this.profiles.find(A=>A.id===a.id);if(!w)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,w)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(w=>!this.w.extUri.isEqual(w.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,p.$bi)(n)?n.uri:(0,p.$gi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,w){const A=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of A)E.isDefault||a.some(C=>E.id===C.id)||(E=w.find(C=>E.id===C.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,a,w)}J(n,a,w){this.h.fire({added:n,removed:a,updated:w,all:this.profiles})}L(n,a,w){w=a?.isTransient?!0:w,w||this.L(n,void 0,!0);const A=this.G(n),I=w?this.s:this.C;D.URI.isUri(A)?(I.workspaces.delete(A),a&&I.workspaces.set(A,a)):(I.emptyWindows.delete(A),a&&I.emptyWindows.set(A,a)),w||this.M()}M(){const n={};for(const[w,A]of this.C.workspaces.entries())n[w.toString()]=A.id;const a={};for(const[w,A]of this.C.emptyWindows.entries())a[w.toString()]=A.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},w=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const C=D.URI.parse(E);a[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}const A={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const C=D.URI.parse(E);A[I]=this.w.extUri.isEqual(C,w.location)?w.id:this.w.extUri.basename(C)}return{workspaces:a,emptyWindows:A}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$4k=o,e.$4k=o=Ee([ne(0,f.$$h),ne(1,l.$ok),ne(2,b.$Yk),ne(3,k.$lj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$5k=r}),define(oe[81],ae([0,1,8,18,2,3,31,7,117,123,16,6,5,41,40,12,14,28]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.ExtensionsProfileScanningErrorCode=void 0;var h;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(h||(e.ExtensionsProfileScanningErrorCode=h={}));class g extends Error{constructor(r,i){super(r),this.code=i}}e.$Jp=g,e.$Kp=(0,k.$4h)("IExtensionsProfileScannerService");let v=class extends s.$Tc{constructor(r,i,n,a,w,A){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=w,this.t=A,this.b=this.B(new M.$Td),this.onAddExtensions=this.b.event,this.c=this.B(new M.$Td),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$Td),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$Td),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,w=>{const A=[];for(const I of w)r.some(([E])=>(0,l.$Po)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):A.push(I);for(const[I,E]of r){const C=A.findIndex(W=>(0,l.$Po)(W.identifier,I.identifier)&&W.version===I.manifest.version),j={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};C===-1?(a.push(j),A.push(j)):A.splice(C,1,j)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),A}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(w){throw a.length&&this.c.fire({extensions:a,error:w,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:w,profileLocation:i}),w}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const w=[];for(const A of a){const I=r.find(([E])=>(0,l.$Po)(E.identifier,A.identifier)&&E.manifest.version===A.version);I&&(A.metadata={...A.metadata,...I[1]},n.push(A)),w.push(A)}return w}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const w=[];for(const A of a)(0,l.$Po)(A.identifier,r.identifier)?n.push(A):w.push(A);return n.length&&this.f.fire({extensions:n,profileLocation:i}),w}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],w;try{const A=await this.m.readFile(r);w=JSON.parse(A.value.toString().trim()||"[]")}catch(A){if((0,y.$Fk)(A)!==1)throw A;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(w=await this.D()),!w&&n?.bailOutWhenFileNotFound)throw new g((0,$.$0)(A),"ERROR_PROFILE_NOT_FOUND")}if(w){Array.isArray(w)||this.w(r);let A=!1;for(const I of w){u(I)||this.w(r);let E;if((0,m.$Gf)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,m.$Gf)(I.location))E=this.z(I.location),A=!0,I.relativeLocation=I.location,I.location=E.toJSON();else{E=S.URI.revive(I.location);const C=this.y(E);C&&(A=!0,I.relativeLocation=C)}a.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}A&&await this.m.writeFile(r,R.$he.fromString(JSON.stringify(w)))}if(i){a=i(a);const A=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,R.$he.fromString(JSON.stringify(A)))}return a})}w(r){const i=new g(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(w){if((0,y.$Fk)(w)===1)return;throw w}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const w=JSON.parse(n);Array.isArray(w)&&w.every(A=>u(A))?a=w:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",w)}catch(w){this.t.error(w)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$he.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(w){if((0,y.$Fk)(w)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw w}try{await this.m.del(r)}catch(w){(0,y.$Fk)(w)!==1&&this.t.error(w)}try{await this.m.del(i)}catch(w){(0,y.$Fk)(w)!==1&&this.t.error(w)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$$g,this.h.set(r,i)),i}};e.$Lp=v,e.$Lp=v=Ee([ne(1,y.$ok),ne(2,c.$1k),ne(3,b.$Yk),ne(4,d.$sl),ne(5,p.$lj)],v);function u(o){return(0,m.$If)(o)&&(0,f.$mo)(o.identifier)&&(t(o.location)||(0,m.$Gf)(o.location)&&o.location)&&((0,m.$Nf)(o.relativeLocation)||(0,m.$Gf)(o.relativeLocation))&&o.version&&(0,m.$Gf)(o.version)}function t(o){return o?(0,m.$Gf)(o.path)&&(0,m.$Gf)(o.scheme):!1}}),define(oe[129],ae([0,1,23,8,38,18,14,44,152,2,13,9,4,19,205,74,12,7,172,37,123,120,204,16,6,5,27,3,77,81,41,40,203]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.Translations=void 0;var j;(function(ue){function Y(Z,H){if(Z===H)return!0;const L=Object.keys(Z),U=new Set;for(const V of Object.keys(H))U.add(V);if(L.length!==U.size)return!1;for(const V of L){if(Z[V]!==H[V])return!1;U.delete(V)}return U.size===0}ue.equals=Y})(j||(e.Translations=j={})),e.$Op=(0,r.$4h)("IExtensionsScannerService");let W=class extends l.$Tc{constructor(Y,Z,H,L,U,V,q,te,he,J,O,F){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=Z,this.r=H,this.s=L,this.t=U,this.u=V,this.w=q,this.y=te,this.z=he,this.C=J,this.D=O,this.F=F,this.g=this.B(new a.$Td),this.onDidChangeCache=this.g.event,this.h=(0,c.$Fg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(K,this.s,this.h)),this.m=this.B(this.F.createInstance(K,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,v.$1o)(this.w,this.y)),this.G}async scanAllExtensions(Y,Z,H){const[L,U]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions(Z)]),V=H?await this.scanExtensionsUnderDevelopment(Y,[...L,...U]):[];return this.L(L,U,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const Z=[];Z.push(this.M(!!Y.useCache,Y.language)),Z.push(this.N(Y.language,!!Y.checkControlFile));const[H,L]=await Promise.all(Z);return this.J([...H,...L],0,Y,!1)}async scanUserExtensions(Y){const Z=Y.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const H=this.D.extUri.isEqual(Y.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Z,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,H),U=Y.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let V;try{V=await U.scanExtensions(L)}catch(q){if(q instanceof A.$Jp&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await U.scanExtensions(L);else throw q}return V=await this.J(V,1,Y,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(Y,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const H=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===y.Schemas.file).map(async L=>{const U=await this.P(L,!1,1,!0,Y.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(U)).map(q=>(q.type=Z.find(te=>(0,v.$Po)(te.identifier,q.identifier))?.type??q.type,this.n.validate(q,U)))}))).flat();return this.J(H,"development",Y,!0)}return[]}async scanExistingExtension(Y,Z,H){const L=await this.P(Y,!1,Z,!0,H.language,!0,void 0),U=await this.n.scanExtension(L);return!U||!H.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(Y,Z,H){const L=await this.P(Y,!1,Z,!0,H.language,!0,void 0),U=await this.n.scanOneOrMultipleExtensions(L);return this.J(U,Z,H,!0)}async scanMetadata(Y){const Z=(0,c.$Fg)(Y,"package.json"),H=(await this.w.readFile(Z)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Y,Z){const H=(0,c.$Fg)(Y,"package.json"),L=(await this.w.readFile(H)).value.toString(),U=JSON.parse(L);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,U.__metadata={...U.__metadata,...Z},await this.w.writeFile((0,c.$Fg)(Y,"package.json"),M.$he.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof A.$Jp&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Y}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.u.addExtensionsToProfile(Y.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$he.fromString(JSON.stringify([])))}catch(Z){(0,o.$Fk)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.y.error(Y)}finally{this.H=void 0}})()),this.H}async J(Y,Z,H,L){return H.includeAllVersions||(Y=this.L(Z===0?Y:void 0,Z===1?Y:void 0,Z==="development"?Y:void 0,await this.getTargetPlatform(),L)),H.includeInvalid||(Y=Y.filter(U=>U.isValid)),Y.sort((U,V)=>{const q=k.$nc(U.location.fsPath),te=k.$nc(V.location.fsPath);return q<te?-1:q>te?1:0})}L(Y,Z,H,L,U){const V=(te,he,J)=>{if(te.isValid&&!he.isValid)return!1;if(te.isValid===he.isValid){if(U&&b.gt(te.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${te.location.path} with version ${te.manifest.version}`),!1;if(b.eq(te.manifest.version,he.manifest.version)){if(te.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${te.location.path} with same version`),!1;if(te.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return J?this.y.warn(`Overwriting user extension ${te.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${te.location.path} with ${he.location.path}.`),!0},q=new u.$lm;return Y?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),Z?.forEach(te=>{const he=q.get(te.identifier.id);if(!he&&Y&&te.type===0){this.y.debug(`Skipping obsolete system extension ${te.location.path}.`);return}(!he||V(he,te,!1))&&q.set(te.identifier.id,te)}),H?.forEach(te=>{const he=q.get(te.identifier.id);(!he||V(he,te,!0))&&q.set(te.identifier.id,te),q.set(te.identifier.id,te)}),[...q.values()]}async M(Y,Z){this.y.trace("Started scanning system extensions");const H=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),U=await(Y&&!H.devMode?this.j:this.n).scanExtensions(H);return this.y.trace("Scanned system extensions:",U.length),U}async N(Y,Z){const H=this.z.isBuilt?[]:this.C.builtInExtensions;if(!H?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Z?await this.O():{},U=[],V=d.URI.file(k.$hc(k.$jc(y.$mg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const te of H){const he=L[te.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":U.push((0,c.$Fg)(V,te.name));break;default:U.push(d.URI.file(he));break}}const q=await Promise.all(U.map(async te=>this.n.scanExtension(await this.P(te,!1,0,!0,Y,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Hb)(q)}async O(){try{const Y=await this.w.readFile(this.r);return JSON.parse(Y.value.toString())}catch{return{}}}async P(Y,Z,H,L,U,V,q){const te=await this.f(U??p.$w),he=await this.Q(Y),J=Z&&!this.D.extUri.isEqual(Y,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=J?await this.Q(J):void 0;return new T(Y,he,J,O,Z,q,H,L,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,U,te)}async Q(Y){try{const Z=await this.w.stat(Y);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$Pp=W,e.$Pp=W=Ee([ne(4,I.$1k),ne(5,A.$Kp),ne(6,o.$ok),ne(7,i.$lj),ne(8,g.$$h),ne(9,n.$Dj),ne(10,E.$Yk),ne(11,r.$3h)],W);class T{constructor(Y,Z,H,L,U,V,q,te,he,J,O,F,x,z,X){this.location=Y,this.mtime=Z,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=L,this.profile=U,this.profileScanOptions=V,this.type=q,this.excludeObsolete=te,this.validate=he,this.productVersion=J,this.productDate=O,this.productCommit=F,this.devMode=x,this.language=z,this.translations=X}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,Z){return(0,c.$yg)(Y.location,Z.location)&&Y.mtime===Z.mtime&&(0,c.$yg)(Y.applicationExtensionslocation,Z.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&Y.profile===Z.profile&&s.$on(Y.profileScanOptions,Z.profileScanOptions)&&Y.type===Z.type&&Y.excludeObsolete===Z.excludeObsolete&&Y.validate===Z.validate&&Y.productVersion===Z.productVersion&&Y.productDate===Z.productDate&&Y.productCommit===Z.productCommit&&Y.devMode===Z.devMode&&Y.language===Z.language&&j.equals(Y.translations,Z.translations)}}e.$Qp=T;let G=class extends l.$Tc{constructor(Y,Z,H,L,U){super(),this.f=Y,this.g=Z,this.h=H,this.j=L,this.m=U}async scanExtensions(Y){const Z=Y.profile?await this.r(Y):await this.n(Y);let H={};if(Y.excludeObsolete&&Y.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();H=JSON.parse(L)}catch{}return(0,$.$Tf)(H)?Z:Z.filter(L=>!H[v.$Qo.create(L).toString()])}async n(Y){const Z=await this.j.resolve(Y.location);if(!Z.children?.length)return[];const H=await Promise.all(Z.children.map(async L=>{if(!L.isDirectory||Y.type===1&&(0,c.$Cg)(L.resource).indexOf(".")===0)return null;const U=new T(L.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(U)}));return(0,P.$Hb)(H).sort((L,U)=>L.location.path<U.location.path?-1:1)}async r(Y){let Z=await this.s(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){Z=Z.filter(L=>!L.metadata?.isApplicationScoped);const H=await this.s(Y.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Y);Z.push(...H)}return Z}async s(Y,Z,H){const L=await this.g.scanProfileExtensions(Y,H.profileScanOptions);if(!L.length)return[];const U=await Promise.all(L.map(async V=>{if(Z(V)){const q=new T(V.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(q,V.metadata)}return null}));return(0,P.$Hb)(U)}async scanOneOrMultipleExtensions(Y){try{if(await this.j.exists((0,c.$Fg)(Y.location,"package.json"))){const Z=await this.scanExtension(Y);return Z?[Z]:[]}else return await this.scanExtensions(Y)}catch(Z){return this.m.error(`Error scanning extensions at ${Y.location.path}:`,(0,D.$0)(Z)),[]}}async scanExtension(Y,Z){try{let H=await this.scanExtensionManifest(Y.location);if(H){H.publisher||(H.publisher=u.$fm),Z=Z??H.__metadata,delete H.__metadata;const L=(0,v.$Uo)(H.publisher,H.name),U=Z?.id?{id:L,uuid:Z.id}:{id:L},V=Z?.isSystem?0:Y.type,q=V===0||!!Z?.isBuiltin;H=await this.t(Y.location,H,T.createNlsConfiguration(Y));const te={type:V,identifier:U,manifest:H,location:Y.location,isBuiltin:q,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return Y.validate?this.validate(te,Y):te}}catch(H){Y.type!==0&&this.m.error(H)}return null}validate(Y,Z){let H=!0;const L=(0,t.$6o)(Z.productVersion,Z.productDate,Z.location,Y.manifest,Y.isBuiltin);for(const[U,V]of L)U===m.default.Error&&(H=!1,this.m.error(this.z(Z.location,V)));return Y.isValid=H,Y.validations=L,Y}async scanExtensionManifest(Y){const Z=(0,c.$Fg)(Y,"package.json");let H;try{H=(await this.j.readFile(Z)).value.toString()}catch(U){return(0,o.$Fk)(U)!==1&&this.m.error(this.z(Y,(0,h.localize)(0,null,Z.path,U.message))),null}let L;try{L=JSON.parse(H)}catch{const V=[];(0,S.$an)(H,V);for(const q of V)this.m.error(this.z(Y,(0,h.localize)(1,null,Z.path,q.offset,q.length,(0,f.$Mp)(q.error))));return null}return(0,S.$jn)(L)!=="object"?(this.m.error(this.z(Y,(0,h.localize)(2,null,Z.path))),null):L}async t(Y,Z,H){const L=await this.u(Y,Z,H);if(L)try{const U=[],V=await this.w(L.default,U);if(U.length>0)return U.forEach(te=>{this.m.error(this.z(Y,(0,h.localize)(3,null,L.default?.path,(0,f.$Mp)(te.error))))}),Z;if((0,S.$jn)(L)!=="object")return this.m.error(this.z(Y,(0,h.localize)(4,null,L.default?.path))),Z;const q=L.values||Object.create(null);return(0,C.$Np)(this.m,Z,q,V)}catch{}return Z}async u(Y,Z,H){const L=(0,c.$Fg)(Y,"package.nls.json"),U=(he,J)=>{J.forEach(O=>{this.m.error(this.z(Y,(0,h.localize)(5,null,he?.path,(0,f.$Mp)(O.error))))})},V=he=>{this.m.error(this.z(Y,(0,h.localize)(6,null,he?.path)))},q=`${Z.publisher}.${Z.name}`,te=H.translations[q];if(te)try{const he=d.URI.file(te),J=(await this.j.readFile(he)).value.toString(),O=[],F=(0,S.$an)(J,O);return O.length>0?(U(he,O),{values:void 0,default:L}):(0,S.$jn)(F)!=="object"?(V(he),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let J;try{J=await this.y(Y,H)}catch{return}if(!J.localized)return{values:void 0,default:J.original};try{const O=(await this.j.readFile(J.localized)).value.toString(),F=[],x=(0,S.$an)(O,F);return F.length>0?(U(J.localized,F),{values:void 0,default:J.original}):(0,S.$jn)(x)!=="object"?(V(J.localized),{values:void 0,default:J.original}):{values:x,default:J.original}}catch{return{values:void 0,default:J.original}}}}async w(Y,Z){if(Y)try{const H=(await this.j.readFile(Y)).value.toString();return(0,S.$an)(H,Z)}catch{}}y(Y,Z){return new Promise((H,L)=>{const U=V=>{const q=(0,c.$Fg)(Y,`package.nls.${V}.json`);this.j.exists(q).then(te=>{te&&H({localized:q,original:(0,c.$Fg)(Y,"package.nls.json")});const he=V.lastIndexOf("-");he===-1?H({localized:(0,c.$Fg)(Y,"package.nls.json"),original:null}):(V=V.substring(0,he),U(V))})};if(Z.devMode||Z.pseudo||!Z.language)return H({localized:(0,c.$Fg)(Y,"package.nls.json"),original:null});U(Z.language)})}z(Y,Z){return`[${Y.path}]: ${Z}`}};G=Ee([ne(1,A.$Kp),ne(2,E.$Yk),ne(3,o.$ok),ne(4,i.$lj)],G);let K=class extends G{constructor(Y,Z,H,L,U,V,q){super(Z,L,U,V,q),this.G=Y,this.H=H,this.D=this.B(new R.$2g(3e3)),this.F=this.B(new a.$Td),this.onDidChangeCache=this.F.event}async scanExtensions(Y){const Z=this.M(Y),H=await this.I(Z);if(this.C=Y,H&&H.input&&T.equals(H.input,this.C))return this.m.debug("Using cached extensions scan result",Y.location.toString()),this.D.trigger(()=>this.L()),H.result.map(U=>(U.location=d.URI.revive(U.location),U));const L=await super.scanExtensions(Y);return await this.J(Z,{input:Y,result:L}),L}async I(Y){try{const Z=await this.j.readFile(Y),H=JSON.parse(Z.value.toString());return{result:H.result,input:(0,w.$Ah)(H.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",Y.path,(0,D.$0)(Z))}return null}async J(Y,Z){try{await this.j.writeFile(Y,M.$he.fromString(JSON.stringify(Z)))}catch(H){this.m.debug("Error while writing the extension cache file:",Y.path,(0,D.$0)(H))}}async L(){if(!this.C)return;const Y=this.M(this.C),Z=await this.I(Y);if(!Z)return;const H=Z.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$on(L,H))try{this.m.info("Invalidating Cache",H,L),await this.j.del(Y),this.F.fire()}catch(U){this.m.error(U)}}M(Y){const Z=this.N(Y);return this.h.extUri.joinPath(Z.cacheHome,Y.type===0?u.$em:u.$dm)}N(Y){return Y.type===0?this.H.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(Y.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};K=Ee([ne(2,I.$1k),ne(3,A.$Kp),ne(4,E.$Yk),ne(5,o.$ok),ne(6,i.$lj)],K);function le(ue,Y){const Z=(0,v.$So)(ue.manifest.publisher,ue.manifest.name);return{id:Z,identifier:new u.$jm(Z),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Y,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$Rp=le;class re extends W{constructor(Y,Z,H,L,U,V,q,te,he,J,O,F){super(Y,Z,(0,c.$Fg)(H,".vscode-oss-dev","extensions","control.json"),L,U,V,q,te,he,J,O,F),this.R=(async()=>{if(p.$z)try{const x=await this.w.readFile(d.URI.file(p.$z));return JSON.parse(x.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.R}}e.$Sp=re}),define(oe[276],ae([0,1,5,41,40,28,81,16,37,7]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let y=class extends D.$Lp{constructor(p,c,b,m,$,d){super(l.URI.file(p.extensionsPath),c,b,m,$,d)}};e.$jO=y,e.$jO=y=Ee([ne(0,f.$_h),ne(1,S.$ok),ne(2,R.$1k),ne(3,s.$Yk),ne(4,M.$sl),ne(5,P.$lj)],y)}),define(oe[277],ae([0,1,7,37,81,129,16,6,5,27,40,41]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;let p=class extends M.$Sp{constructor(b,m,$,d,h,g,v,u){super(P.URI.file(h.builtinExtensionsPath),P.URI.file(h.extensionsPath),h.userHome,b.defaultProfile,b,m,$,d,h,g,v,u)}};e.$h$b=p,e.$h$b=p=Ee([ne(0,k.$1k),ne(1,s.$Kp),ne(2,D.$ok),ne(3,f.$lj),ne(4,R.$_h),ne(5,l.$Dj),ne(6,y.$Yk),ne(7,S.$3h)],p)}),define(oe[278],ae([0,1,15,2,13,9,4,57,7,32,36,37,5,41]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z$b=void 0;let b=class extends R.$Tc{constructor($,d,h){super(),this.c=$,this.f=h,this.a=S.$0h.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot($.appRoot),this.addValidFileRoot($.extensionsPath),this.addValidFileRoot(d.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot($.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:$}=P.session;$.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(d,h)=>this.j(d,h)),$.protocol.interceptFileProtocol(s.Schemas.file,(d,h)=>this.h(d,h)),this.B((0,R.$Rc)(()=>{$.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),$.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot($){const d=(0,M.$hc)($);return this.a.get(d)?R.$Tc.None:(this.a.set(d,!0),(0,R.$Rc)(()=>this.a.delete(d)))}h($,d){const h=f.URI.parse($.url);return this.f.error(`Refused to load resource ${h.fsPath} from ${s.Schemas.file}: protocol (original URL: ${$.url})`),d({error:-3})}j($,d){const h=this.m($);let g;return this.c.crossOriginIsolated&&((0,M.$nc)(h)==="workbench.html"||(0,M.$nc)(h)==="workbench-dev.html"?g=s.COI.CoopAndCoep:g=s.COI.getHeadersFromQuery($.url)),this.a.findSubstr(h)?d({path:h,headers:g}):this.b.has((0,M.$oc)(h).toLowerCase())?d({path:h}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${h} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${$.url})`),d({error:-3}))}m($){const d=f.URI.parse($.url),h=s.$mg.uriToFileUri(d);return(0,M.$hc)(h.fsPath)}createIPCObjectUrl(){let $;const d=f.URI.from({scheme:"vscode",path:(0,l.$og)()}),h=d.toString(),g=async()=>$;return y.$pU.handle(h,g),this.f.trace(`IPC Object URL: Registered new channel ${h}.`),{resource:d,update:v=>$=v,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${h}.`),y.$pU.removeHandler(h)}}}};e.$z$b=b,e.$z$b=b=Ee([ne(0,k.$_h),ne(1,c.$1k),ne(2,p.$lj)],b)}),define(oe[96],ae([0,1,8,3,2,68,12,111,6,41]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jp=e.$ip=e.$hp=void 0,e.$hp="__$__isNewStorageMarker",e.$ip="__$__targetStorageMarker",e.$jp=(0,f.$4h)("storageService");var y;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var k;(function(h){h[h.APPLICATION=-1]="APPLICATION",h[h.PROFILE=0]="PROFILE",h[h.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var p;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function c(h){const g=h.get(e.$ip);if(g)try{return JSON.parse(g)}catch{}return Object.create(null)}e.$kp=c;class b extends s.$Tc{static{this.a=60*1e3}constructor(g={flushInterval:b.a}){super(),this.m=g,this.b=this.B(new R.$Wd),this.c=this.B(new R.$Wd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Td),this.onWillSaveState=this.f.event,this.h=this.B(new P.$dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(g,v,u){return R.Event.filter(this.b.event,t=>t.scope===g&&(v===void 0||t.key===v),u)}n(){this.j.value=(0,P.$hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(g,v){const{key:u,external:t}=v;if(u===e.$ip){switch(g){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:g})}else this.b.fire({scope:g,key:u,target:this.J(g)[u],external:t})}w(g){this.f.fire({reason:g})}get(g,v,u){return this.P(v)?.get(g,u)}getBoolean(g,v,u){return this.P(v)?.getBoolean(g,u)}getNumber(g,v,u){return this.P(v)?.getNumber(g,u)}getObject(g,v,u){return this.P(v)?.getObject(g,u)}storeAll(g,v){this.y(()=>{for(const u of g)this.store(u.key,u.value,u.scope,u.target,v)})}store(g,v,u,t,o=!1){if((0,D.$Pf)(v)){this.remove(g,u,o);return}this.y(()=>{this.z(g,u,t),this.P(u)?.set(g,v,o)})}remove(g,v,u=!1){this.y(()=>{this.z(g,v,void 0),this.P(v)?.delete(g,u)})}y(g){this.b.pause(),this.c.pause();try{g()}finally{this.b.resume(),this.c.resume()}}keys(g,v){const u=[],t=this.J(g);for(const o of Object.keys(t))t[o]===v&&u.push(o);return u}z(g,v,u,t=!1){const o=this.J(v);typeof u=="number"?o[g]!==u&&(o[g]=u,this.P(v)?.set(e.$ip,JSON.stringify(o),t)):typeof o[g]=="number"&&(delete o[g],this.P(v)?.set(e.$ip,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(g){switch(g){case-1:return this.I;case 0:return this.G;default:return this.D}}L(g){const v=this.P(g);return v?c(v):Object.create(null)}isNew(g){return this.getBoolean(e.$hp,g)===!0}async flush(g=y.NONE){this.f.fire({reason:g});const v=this.P(-1),u=this.P(0),t=this.P(1);switch(g){case y.NONE:await P.Promises.settled([v?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await P.Promises.settled([v?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.P(-1)?.items??new Map,v=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return d(g,v,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(g){return await this.flush(),this.P(g)?.optimize()}async switch(g,v){return this.w(y.NONE),(0,l.$Zk)(g)?this.R(g,v):this.S(g,v)}M(g,v){return!(g.id===v.id||m(v)&&m(g))}N(g,v,u){this.y(()=>{const t=new Set;for(const[o,r]of g)t.add(o),v.get(o)!==r&&this.u(u,{key:o,external:!0});for(const[o]of v.items)t.has(o)||this.u(u,{key:o,external:!0})})}}e.$lp=b;function m(h){return h.isDefault||!!h.useDefaultFlags?.globalState}e.$mp=m;class $ extends b{constructor(){super(),this.U=this.B(new S.$fp(new S.$gp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$fp(new S.$gp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$fp(new S.$gp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(g=>this.u(1,g))),this.B(this.W.onDidChangeStorage(g=>this.u(0,g))),this.B(this.U.onDidChangeStorage(g=>this.u(-1,g)))}P(g){switch(g){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(g){return!1}}e.$np=$;async function d(h,g,v,u,t,o){const r=j=>{try{return JSON.parse(j)}catch{return j}},i=new Map,n=new Map;h.forEach((j,W)=>{i.set(W,j),n.set(W,r(j))});const a=new Map,w=new Map;g.forEach((j,W)=>{a.set(W,j),w.set(W,r(j))});const A=new Map,I=new Map;v.forEach((j,W)=>{A.set(W,j),I.set(W,r(j))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(i.forEach((j,W)=>{E.push({key:W,value:j})}),console.table(E),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const j=[];a.forEach((W,T)=>{j.push({key:T,value:W})}),console.table(j),console.groupEnd(),console.log(w)}console.group(`Storage: Workspace (path: ${o})`);const C=[];A.forEach((j,W)=>{C.push({key:W,value:j})}),console.table(C),console.groupEnd(),console.log(I)}e.$op=d}),define(oe[279],ae([0,1,23,8,3,2,9,73,7,21,111,161,5,96,28,30,13]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_9b=e.$$9b=e.$09b=e.$99b=void 0;class d extends M.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Td),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Td),this.onDidCloseStorage=this.c.event,this.f=this.B(new y.$fp(new y.$gp,{hint:y.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$oh,this.whenInit=this.h.p,this.j=y.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===y.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(c.$hp);i===void 0?r.set(c.$hp,!0):i&&r.set(c.$hp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=y.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===p.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Pd(!1);await this.w(),r.stop(),r.elapsed()>d.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,w])=>({key:a,length:w.length})),(a,w)=>w.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=y.StorageState.Closed,await this.f.close()}}class h extends d{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:$.Schemas.file}).fsPath,h.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new y.$fp(new k.$UU(this.path??k.$UU.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:y.StorageHint.STORAGE_IN_MEMORY})}}class g extends h{constructor(r,i,n,a){super(r,i,n,a)}}e.$99b=g;class v extends h{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(b.$vl,void 0)===void 0&&r.set(b.$vl,new Date().toUTCString());const n=r.get(b.$ul,void 0),a=new Date().toUTCString();r.set(b.$wl,typeof n>"u"?null:n),r.set(b.$ul,a)}}e.$09b=v;class u extends d{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id,u.y)}constructor(r,i,n,a,w){super(n,w),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new y.$fp(new k.$UU(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?y.StorageHint.STORAGE_IN_MEMORY:i?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:k.$UU.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,this.C.id),i=(0,D.$jc)(r,u.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,m.$bi)(this.C)?i={folder:this.C.uri.toString()}:(0,m.$gi)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$jc)(r,u.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$$9b=u;class t extends d{get path(){}async t(){return new y.$fp(new y.$gp,{hint:y.StorageHint.STORAGE_IN_MEMORY})}}e.$_9b=t}),define(oe[280],ae([0,1,3,2,96]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=void 0;class M extends R.$Tc{constructor(S,f,l){super(),this.b=S,this.c=f,this.f=l;const y=this.B(new R.$Uc);this.a=this.B(new P.$Td({onWillAddFirstListener:()=>y.value=this.g(),onDidRemoveLastListener:()=>y.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new R.$Sc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.h(f))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let y=f.get(l.profile.id);return y||f.set(l.profile.id,y={profile:l.profile,keys:[],storage:l.storage}),y.keys.push(l.key),f},100)(f=>this.j(f))),S}h(S){const f=S.includes(s.$ip)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(y=>y!==s.$ip),S.length){const y=(0,s.$kp)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map(k=>({key:k,scope:0,target:y[k]}))})}this.m(f,l)}j(S){const f=[],l=new Map;for(const[y,k]of S.entries()){k.keys.includes(s.$ip)&&f.push(k.profile);const p=k.keys.filter(c=>c!==s.$ip);if(p.length){const c=(0,s.$kp)(k.storage.storage);l.set(y,{profile:k.profile,changes:p.map(b=>({key:b,scope:0,target:c[b]}))})}}this.m(f,[...l.values()])}m(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,l){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$j$b=M}),define(oe[281],ae([0,1,7,37,16,5,34,40,41,12,121]),function(Q,e,P,R,s,M,D,S,f,l,y){"use strict";var k,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=e.$gO=void 0;let c=class extends f.$4k{static{k=this}static{this.a="profileAssociationsMigration"}constructor(d,h,g,v,u){super(g,v,h,u),this.U=d,this.W=g}O(){return this.U.getItem(k.b,[]).map(h=>({...h,location:(0,l.$Gf)(h.location)?this.w.extUri.joinPath(this.profilesHome,h.location):P.URI.revive(h.location)}))}Q(){const d=this.U.getItem(k.c,{});return this.U.getItem(k.a,!1)?d:this.N(d)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$gO=c,e.$gO=c=k=Ee([ne(0,D.$bO),ne(1,S.$Yk),ne(2,R.$_h),ne(3,s.$ok),ne(4,M.$lj)],c);let b=p=class extends c{constructor(d,h,g,v,u){super(d,h,g,v,u),this.$=d}P(d){d.length?this.$.setItem(p.b,d.map(h=>({...h,location:this.w.extUri.basename(h.location)}))):this.$.removeItem(p.b)}O(){const d=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(d),this.$.setItem("userDataProfilesMigration",!0)),d}R(d){d.emptyWindows||d.workspaces?this.$.setItem(p.c,d):this.$.removeItem(p.c)}Q(){const d="workspaceAndProfileInfo",h=this.$.getItem(d,void 0);if(h){this.$.removeItem(d);const v=h.reduce((u,{workspace:t,profile:o})=>(u[P.URI.revive(t).toString()]=P.URI.revive(o).toString(),u),{});this.$.setItem(p.c,{workspaces:v})}const g=super.Q();return this.$.getItem(p.a,!1)||(this.R(g),this.$.setItem(p.a,!0)),g}};e.$hO=b,e.$hO=b=p=Ee([ne(0,D.$cO),ne(1,S.$Yk),ne(2,R.$_h),ne(3,s.$ok),ne(4,M.$lj)],b);let m=class extends b{constructor(d,h,g,v){super(new y.$fO(0,h,v,g),d,h,g,v)}async init(){return await this.$.init(),super.init()}};e.$iO=m,e.$iO=m=Ee([ne(0,S.$Yk),ne(1,R.$_h),ne(2,s.$ok),ne(3,M.$lj)],m)}),define(oe[55],ae([0,1,37,16,6,5,40,41,281,34]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R9b=e.$Q9b=void 0,e.$Q9b=(0,s.$5h)(S.$1k);let y=class extends f.$hO{constructor(p,c,b,m,$){super(p,c,b,m,$)}getAssociatedEmptyWindows(){const p=[];for(const c of this.C.emptyWindows.keys())p.push({id:c});return p}};e.$R9b=y,e.$R9b=y=Ee([ne(0,l.$cO),ne(1,D.$Yk),ne(2,P.$_h),ne(3,R.$ok),ne(4,M.$lj)],y)}),define(oe[130],ae([0,1,19,7,30]),function(Q,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U9b=e.$T9b=e.$S9b=void 0;async function M(f,l,y){for(const p of f){const c=p.openedWorkspace;if((0,s.$gi)(c)){const b=await y(c);if(b){if(b.folders.some(m=>P.$wg.isEqualOrParent(l,m.uri)))return p}else if(P.$wg.isEqualOrParent(l,c.configPath))return p}}const k=f.filter(p=>(0,s.$bi)(p.openedWorkspace)&&P.$wg.isEqualOrParent(l,p.openedWorkspace.uri));if(k.length)return k.sort((p,c)=>-(p.openedWorkspace.uri.path.length-c.openedWorkspace.uri.path.length))[0]}e.$S9b=M;function D(f,l){for(const y of f)if((0,s.$gi)(y.openedWorkspace)&&P.$wg.isEqual(y.openedWorkspace.configPath,l)||(0,s.$bi)(y.openedWorkspace)&&P.$wg.isEqual(y.openedWorkspace.uri,l))return y}e.$T9b=D;function S(f,l){const y=k=>l.some(p=>P.$wg.isEqual(R.URI.file(p),R.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(p=>y(p)))return k}e.$U9b=S}),define(oe[97],ae([0,1,33,44,139,47,13,9,4,19,7,6,59,30]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$scb=e.$rcb=e.$qcb=e.$pcb=e.$ocb=e.$ncb=e.$mcb=e.$lcb=e.$kcb=e.$jcb=void 0,e.$jcb=(0,k.$4h)("workspacesService");function b(I){return I.hasOwnProperty("workspace")}e.$kcb=b;function m(I){return I.hasOwnProperty("folderUri")}e.$lcb=m;function $(I){return I.hasOwnProperty("fileUri")}e.$mcb=$;function d(I){return h(I)||g(I)}e.$ncb=d;function h(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function g(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function v(I,E,C,j,W){if(I.scheme!==j.scheme)return{name:C,uri:I.toString(!0)};let T=E?void 0:W.relativePath(j,I);if(T!==void 0)T.length===0?T=".":f.$i&&(T=u(T));else if(I.scheme===D.Schemas.file)T=I.fsPath,f.$i&&(T=u(T));else if(W.isEqualAuthority(I.authority,j.authority))T=I.path;else return{name:C,uri:I.toString(!0)};return{name:C,path:T}}e.$ocb=v;function u(I){return I=(0,M.$Mv)(I),(0,P.$3f)(I)||(I=(0,P.$Zf)(I)),I}function t(I,E,C){const j=[],W=new Set,T=C.dirname(E);for(const G of I){let K;if(h(G))G.path&&(K=C.resolvePath(T,G.path));else if(g(G))try{K=y.URI.parse(G.uri),K.path[0]!==S.$gc.sep&&(K=K.with({path:S.$gc.sep+K.path}))}catch(le){console.warn(le)}if(K){const le=C.getComparisonKey(K);if(!W.has(le)){W.add(le);const re=G.name||C.basenameOrAuthority(K);j.push(new c.$li({uri:K,name:re,index:j.length},G))}}}return j}e.$pcb=t;function o(I,E,C,j,W){const T=r(E,I),G=W.dirname(E),K=W.dirname(j),le=[];for(const Z of T.folders){const H=h(Z)?W.resolvePath(G,Z.path):y.URI.parse(Z.uri);let L;C?L=!1:L=!h(Z)||(0,S.$ic)(Z.path),le.push(v(H,L,Z.name,K,W))}const re={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=s.$5T(I,["folders"],le,re);let Y=s.$8T(I,ue);return(0,l.$Kg)(T.remoteAuthority,(0,p.$$k)(j))&&(Y=s.$8T(Y,s.$4T(Y,["remoteAuthority"],re))),Y}e.$qcb=o;function r(I,E){const C=R.$an(E);if(C&&Array.isArray(C.folders))C.folders=C.folders.filter(j=>d(j));else throw new Error(`${I} looks like an invalid workspace file.`);return C}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function w(I,E){const C={workspaces:[],files:[]};if(I){const j=function(T,G){for(let K=0;K<T.length;K++)try{G(T[K],K)}catch(le){E.warn(`Error restoring recent entry ${JSON.stringify(T[K])}: ${le.toString()}. Skip entry.`)}},W=I;Array.isArray(W.entries)&&j(W.entries,T=>{const G=T.label,K=T.remoteAuthority;i(T)?C.workspaces.push({label:G,remoteAuthority:K,workspace:{id:T.workspace.id,configPath:y.URI.parse(T.workspace.configPath)}}):n(T)?C.workspaces.push({label:G,remoteAuthority:K,folderUri:y.URI.parse(T.folderUri)}):a(T)&&C.files.push({label:G,remoteAuthority:K,fileUri:y.URI.parse(T.fileUri)})})}return C}e.$rcb=w;function A(I){const E={entries:[]};for(const C of I.workspaces)m(C)?E.entries.push({folderUri:C.folderUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority}):E.entries.push({workspace:{id:C.workspace.id,configPath:C.workspace.configPath.toString()},label:C.label,remoteAuthority:C.remoteAuthority});for(const C of I.files)E.entries.push({fileUri:C.fileUri.toString(),label:C.label,remoteAuthority:C.remoteAuthority});return E}e.$scb=A}),define(oe[98],ae([0,1,86,13,4,19]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=e.$X9b=e.$W9b=e.$V9b=void 0,e.$V9b=128/4;function D(l){function y(){let k=l.scheme===R.Schemas.file?(0,M.$tg)(l):l.toString();return s.$k||(k=k.toLowerCase()),(0,P.createHash)("md5").update(k).digest("hex")}return{id:y(),configPath:l}}e.$W9b=D;function S(l,y){function k(){if(l.scheme!==R.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!y)return;let c;return s.$k?c=y.ino:s.$j?c=y.birthtime.getTime():s.$i&&(typeof y.birthtimeMs=="number"?c=Math.floor(y.birthtimeMs):c=y.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(c?String(c):"").digest("hex")}const p=k();if(typeof p=="string")return{id:p,uri:l}}e.$X9b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Y9b=f}),define(oe[99],ae([0,1,86,87,26,282,18,14,3,2,9,4,32,42,109]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class m{traceSocketEvent(E,C){b.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,C)}constructor(E,C=""){this.f=!0,this.debugLabel=C,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=j=>{if(this.traceSocketEvent("error",{code:j?.code,message:j?.message}),j){if(j.code==="EPIPE")return;(0,S.$1)(j)}},this.socket.on("error",this.a),this.b=j=>{this.traceSocketEvent("close",{hadError:j}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const C=j=>{this.traceSocketEvent("read",j),E(D.$he.wrap(j))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(E){const C=j=>{E({type:0,hadError:j,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(E){const C=()=>{E()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,S.$1)(C)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const j=()=>{this.socket.off("close",j),this.socket.off("end",j),this.socket.off("error",j),this.socket.off("timeout",j),this.socket.off("drain",j),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",j),this.socket.on("end",j),this.socket.on("error",j),this.socket.on("timeout",j),this.socket.on("drain",j)})}}e.$Sh=m;var $;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})($||($={}));var d;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(d||(d={}));class h extends l.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,C){this.socket.traceSocketEvent(E,C)}constructor(E,C,j,W){super(),this.f=this.B(new f.$Td),this.g=this.B(new f.$Td),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:j?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new g(this,C,j,W,this.f,(T,G)=>this.m(T,G))),this.B(this.a.onError(T=>{console.error(T),(0,S.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new b.$Nh,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let C=0;for(;C<E.byteLength;)this.a.writeMessage(E.slice(C,Math.min(C+262144,E.byteLength)),{compressed:!0,opcode:2}),C+=262144}m(E,{compressed:C,opcode:j}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let W=2;E.byteLength<126?W+=0:E.byteLength<2**16?W+=2:W+=8;const T=D.$he.alloc(W),G=C?64:0,K=j&15;if(T.writeUInt8(128|G|K,0),E.byteLength<126)T.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){T.writeUInt8(126,1);let le=1;T.writeUInt8(E.byteLength>>>8&255,++le),T.writeUInt8(E.byteLength>>>0&255,++le)}else{T.writeUInt8(127,1);let le=1;T.writeUInt8(0,++le),T.writeUInt8(0,++le),T.writeUInt8(0,++le),T.writeUInt8(0,++le),T.writeUInt8(E.byteLength>>>24&255,++le),T.writeUInt8(E.byteLength>>>16&255,++le),T.writeUInt8(E.byteLength>>>8&255,++le),T.writeUInt8(E.byteLength>>>0&255,++le)}this.socket.write(D.$he.concat([T,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const C=this.b.peek(this.j.readLen),j=C.readUInt8(0),W=(j&128)>>>7,T=(j&64)>>>6,G=j&15,K=C.readUInt8(1),le=(K&128)>>>7,re=K&127;this.j.state=2,this.j.readLen=2+(le?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const C=this.b.read(this.j.readLen),j=C.readUInt8(1),W=(j&128)>>>7;let T=j&127,G=1;T===126?T=C.readUInt8(++G)*2**8+C.readUInt8(++G):T===127&&(T=C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*0+C.readUInt8(++G)*2**24+C.readUInt8(++G)*2**16+C.readUInt8(++G)*2**8+C.readUInt8(++G));let K=0;W&&(K=C.readUInt8(++G)*2**24+C.readUInt8(++G)*2**16+C.readUInt8(++G)*2**8+C.readUInt8(++G)),this.j.state=3,this.j.readLen=T,this.j.mask=K,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const C=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",C),t(C,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",C),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Th=h;class g extends l.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$he.alloc(0)}constructor(E,C,j,W,T,G){super(),this.n=E,this.r=T,this.s=G,this.a=this.B(new f.$Td),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Td),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Td),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new v(this.n,W,j,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(K=>this.a.fire(K))),this.B(this.f.onError(K=>this.a.fire(K)))):(this.b=null,this.f=null)}writeMessage(E,C){this.g.push({data:E,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:C}=this.g.shift();if(this.f&&C.compressed){const j=await this.w(this.f,E);this.s(j,C)}else this.s(E,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,C){return new Promise((j,W)=>{E.write(C),E.flush(T=>j(T))})}acceptFrame(E,C,j){this.h.push({data:E,isCompressed:C,isLastFrameOfMessage:j}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const C=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,C,j){return new Promise((W,T)=>{E.write(C),j&&E.write(D.$he.fromByteArray([0,0,255,255])),E.flush(G=>W(G))})}}class v extends l.$Tc{get recordedInflateBytes(){return this.j?D.$he.concat(this.f):D.$he.alloc(0)}constructor(E,C,j,W){super(),this.h=E,this.j=C,this.a=this.B(new f.$Td),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(W),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(D.$he.wrap(T))}),j&&(this.h.traceSocketEvent("zlibInflateInitialWrite",j.buffer),this.b.write(j.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const C=D.$he.concat(this.g);this.g.length=0,E(C)})}}class u extends l.$Tc{constructor(E,C){super(),this.g=E,this.a=this.B(new f.$Td),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",j=>{this.g.traceSocketEvent("zlibDeflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.g.traceSocketEvent("zlibDeflateData",j),this.f.push(D.$he.wrap(j))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let C=D.$he.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),E(C)})}}function t(I,E){if(E===0)return;const C=I.byteLength>>>2;for(let le=0;le<C;le++){const re=I.readUInt32BE(le*4);I.writeUInt32BE(re^E,le*4)}const j=C*4,W=I.byteLength-j,T=E>>>24&255,G=E>>>16&255,K=E>>>8&255;W>=1&&I.writeUInt8(I.readUInt8(j)^T,j),W>=2&&I.writeUInt8(I.readUInt8(j+1)^G,j+1),W>=3&&I.writeUInt8(I.readUInt8(j+2)^K,j+2)}e.$Uh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,p.$og)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Uh?e.$Uh:(0,s.tmpdir)(),C=(0,y.$jc)(E,`vscode-ipc-${I}.sock`);return n(C),C}e.$Vh=r;function i(I,E,C){const W=(0,P.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${C}-${E}-sock`;const T=C.substr(0,4),G=E.substr(0,6);let K;return process.platform!=="darwin"&&e.$Uh&&!process.env.VSCODE_PORTABLE?K=(0,y.$jc)(e.$Uh,`vscode-${W}-${T}-${G}.sock`):K=(0,y.$jc)(I,`${T}-${G}.sock`),n(K),K}e.$Wh=i;function n(I){const E=o[k.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends c.$Hh{static b(E){const C=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(C,j=>({protocol:new b.$Oh(new m(j,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(j,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Xh=a;function w(I){return new Promise((E,C)=>{const j=(0,R.createServer)();j.on("error",C),j.listen(I,()=>{j.removeListener("error",C),E(new a(j))})})}e.$Yh=w;function A(I,E){return new Promise((C,j)=>{const W=(0,R.createConnection)(I,()=>{W.removeListener("error",j),C(b.$Ph.fromSocket(new m(W,`ipc-client${E}`),E))});W.once("error",j)})}e.$Zh=A}),define(oe[24],ae([0,1,50,9,4,99,37,90,6]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A9b=e.$z9b=void 0,e.$z9b=(0,f.$5h)(D.$$h);class l extends S.$zm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$Wh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const k in process.env)if(k.endsWith("_VSCODE_SNAP_ORIG")){const p=k.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[k]?process.env[p]=process.env[k]:delete process.env[p]}}}restoreSnapExportedVariables(){if(s.$k)for(const k in this.d)process.env[k]=this.d[k],delete this.d[k]}}e.$A9b=l,Ee([P.$vh],l.prototype,"cachedLanguagesPath",null),Ee([P.$vh],l.prototype,"backupHome",null),Ee([P.$vh],l.prototype,"mainIPCHandle",null),Ee([P.$vh],l.prototype,"mainLockfile",null),Ee([P.$vh],l.prototype,"disableUpdates",null),Ee([P.$vh],l.prototype,"crossOriginIsolated",null),Ee([P.$vh],l.prototype,"codeCachePath",null),Ee([P.$vh],l.prototype,"useCodeCache",null)}),define(oe[283],ae([0,1,86,33,13,9,4,19,21,196,17,24,34,16,5,195,30,98]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$f0b=void 0;let g=class{static{h=this}static{this.a="backupWorkspaces"}constructor(u,t,o,r){this.j=u,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$wg,this.i={isEqual:(i,n)=>(0,R.$5f)(i,n,!D.$k)}}async initialize(){const u=this.m.getItem(h.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,l.$C9b)(u)),this.e=await this.v((0,l.$D9b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==c.$Nk.OFF}q(){return this.s()===c.$Nk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||c.$Nk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(r=>u.workspace.id===r.workspace.id)||(this.d.push(u),this.C());const o=(0,M.$jc)(this.c,u.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(u,t){if(await f.Promises.exists(u)&&await this.z(u),await f.Promises.exists(t))try{await f.Promises.rename(t,u,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,M.$jc)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.$jc)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,o=[];for(const r of u){const i=r.workspace;if(!(0,$.$gi)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(u){if(!Array.isArray(u))return[];const t=[],o=new Set;for(const r of u){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const a=(0,M.$jc)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],o=new Set;for(const r of u){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,M.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(u){try{await f.Promises.rm(u,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,d.$Y9b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,d.$Y9b)();return{backupFolder:u.id}}async z(u){const t=this.y(),o=(0,M.$jc)(this.c,t.backupFolder);try{await f.Promises.rename(u,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,l.$B9b)(u)?t=(0,M.$jc)(this.c,u.backupFolder):(0,m.$hcb)(u)?t=(0,M.$jc)(this.c,this.D(u)):t=(0,M.$jc)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await f.Promises.readdir(u);for(const o of t)try{if((await f.Promises.readdir((0,M.$jc)(u,o))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(h.a,u)}D(u){const t=u.folderUri;let o;return t.scheme===s.Schemas.file?o=D.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$f0b=g,e.$f0b=g=h=Ee([ne(0,k.$z9b),ne(1,y.$xi),ne(2,b.$lj),ne(3,p.$cO)],g)}),define(oe[20],ae([0,1,15,36,8,3,2,4,35,12,6,5,34,24]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$89b=e.LifecycleMainPhase=e.ShutdownReason=e.$79b=void 0,e.$79b=(0,y.$4h)("lifecycleMainService");var m;(function(h){h[h.QUIT=1]="QUIT",h[h.KILL=2]="KILL"})(m||(e.ShutdownReason=m={}));var $;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen",h[h.Eventually=4]="Eventually"})($||(e.LifecycleMainPhase=$={}));let d=class extends D.$Tc{static{b=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(g,v,u){super(),this.F=g,this.G=v,this.H=u,this.c=this.B(new M.$Td),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$Td),this.onWillShutdown=this.f.event,this.g=this.B(new M.$Td),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$Td),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(b.b),this.m&&this.G.removeItem(b.b)}J(){const g=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",g);const v=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",v),P.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",g),P.app.removeListener("window-all-closed",v),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(g){if(this.y)return this.y;const v=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:g,join(t,o){v.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(o.finally(()=>{v.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(g){if(g<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===g)return;this.S(`lifecycle (main): phase changed (value: ${g})`),this.n=g;const v=this.C.get(this.n);v&&(v.open(),this.C.delete(this.n))}async when(g){if(g<=this.n)return;let v=this.C.get(g);v||(v=new s.$3g,this.C.set(g,v)),await v.wait()}registerWindow(g){const v=new D.$Sc;this.t++,v.add(g.onWillLoad(t=>this.g.fire({window:g,workspace:t.workspace,reason:t.reason})));const u=(0,l.$Rf)(g.win);u.on("close",t=>{const o=g.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${g.id}`),t.preventDefault(),this.unload(g,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(g),g.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${g.id}`),this.t--,v.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}registerAuxWindow(g){const v=(0,l.$Rf)(g.win);v.on("close",u=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${g.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),u.preventDefault())}),v.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${g.id}`)})}async reload(g,v){await this.unload(g,3)||g.reload(v)}unload(g,v){const u=this.z.get(g.id);if(u)return u;const t=this.M(g,v).finally(()=>{this.z.delete(g.id)});return this.z.set(g.id,t),t}async M(g,v){if(!g.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${g.id}`);const u=this.j?2:v,t=await this.P(g,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${g.id})`),this.N(t)):(await this.Q(g,u),!1)}N(g){return g?(this.O(!0),this.j=!1,!0):!1}O(g){this.w&&(this.w(g),this.w=void 0,this.u=void 0)}P(g,v){return new Promise(u=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$pU.once(o,()=>{u(!1)}),R.$pU.once(r,()=>{u(!0)}),g.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:v})})}Q(g,v){return new Promise(u=>{const o=`vscode:reply${this.s++}`;R.$pU.once(o,()=>u()),g.send("vscode:onWillUnload",{replyChannel:o,reason:v})})}quit(g){return this.R(g).then(v=>{if(!v&&g)try{if(S.$i){const u=(0,f.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return v})}R(g){return this.S(`Lifecycle#quit() - begin (willRestart: ${g})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(g&&this.G.setItem(b.b,!0),this.u=new Promise(v=>{this.w=v,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(g){this.H.args["enable-smoke-test-driver"]?this.F.info(g):this.F.trace(g)}setRelaunchHandler(g){this.D=g}async relaunch(g){this.S("Lifecycle#relaunch()");const v=process.argv.slice(1);if(g?.addArgs&&v.push(...g.addArgs),g?.removeArgs)for(const o of g.removeArgs){const r=v.indexOf(o);r>=0&&v.splice(r,1)}const u=()=>{this.D?.handleRelaunch(g)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:v}))};P.app.once("quit",u),await this.quit(!0)&&P.app.removeListener("quit",u)}async kill(g){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$5g)(1e3),(async()=>{for(const v of P.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let u;v.webContents&&!v.webContents.isDestroyed()?u=new Promise(t=>v.once("closed",t)):u=Promise.resolve(),v.destroy(),await u}})()]),P.app.exit(g)}};e.$89b=d,e.$89b=d=b=Ee([ne(0,k.$lj),ne(1,p.$cO),ne(2,c.$z9b)],d)}),define(oe[284],ae([0,1,4,3,2,6,20]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C0b=e.$B0b=void 0,e.$B0b=(0,M.$4h)("keyboardLayoutMainService");let S=class extends s.$Tc{constructor(y){super(),this.a=this.B(new R.$Td),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,y.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const y=await new Promise((k,p)=>{Q(["native-keymap"],k,p)});this.c=f(y),P.$t||y.onDidChangeKeyboardLayout(()=>{this.c=f(y),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$C0b=S,e.$C0b=S=Ee([ne(0,D.$79b)],S);function f(l){const y=l.getKeyMap(),k=l.getCurrentKeyboardLayout();return{keyboardMapping:y,keyboardLayoutInfo:k}}}),define(oe[285],ae([0,1,246,8,18,14,12,17,37,94,5,52,245,282]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;let b=class extends k.$0o{constructor(h,g,v,u){super(u),this.m=h,this.n=g,this.r=v,this.s(),this.B(h.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const h=this.m.getValue("http");this.f=h?.proxy,this.g=!!h?.proxyStrictSSL,this.h=h?.proxyAuthorization}async request(h,g){const{f:v,g:u}=this;let t;try{t=await(0,l.$0l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$0)(i)))}const o={...process.env,...t},r=h.agent?h.agent:await(0,p.$br)(h.url||"",o,{proxyUrl:v,strictSSL:u});return h.agent=r,h.strictSSL=u,this.h&&(h.headers={...h.headers||{},"Proxy-Authorization":this.h}),this.c(h.isChromiumNetwork?"electron":"node",h,()=>$(h,g))}async resolveProxy(h){}async loadCertificates(){return(await new Promise((g,v)=>{Q(["@vscode/proxy-agent"],g,v)})).loadSystemCertificates({log:this.r})}};e.$cr=b,e.$cr=b=Ee([ne(0,S.$xi),ne(1,f.$_h),ne(2,y.$lj),ne(3,y.$mj)],b);async function m(d){return((0,P.parse)(d.url).protocol==="https:"?await new Promise((v,u)=>{Q(["https"],v,u)}):await new Promise((v,u)=>{Q(["http"],v,u)})).request}async function $(d,h){return R.Promises.withAsyncBody(async(g,v)=>{const u=(0,P.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await m(d),o={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,D.$Mf)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(o.auth=d.user+":"+d.password);const r=t(o,i=>{const n=(0,D.$Kf)(d.followRedirects)?d.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)$({...d,url:i.headers.location,followRedirects:n-1},h).then(g,v);else{let a=i;!d.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,c.createGunzip)())),g({res:i,stream:(0,s.$we)(a)})}});r.on("error",v),d.timeout&&r.setTimeout(d.timeout),d.isChromiumNetwork&&r.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&r.write(d.data),r.end(),h.onCancellationRequested(()=>{r.abort(),v(new M.$5)})})}e.$dr=$}),define(oe[286],ae([0,1,15,285]),function(Q,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E$b=void 0;function s(D){return P.net.request}class M extends R.$cr{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$E$b=M}),define(oe[82],ae([0,1,7,3,2,37,16,6,20,5,96,279,41,55,40,13]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d0b=e.$c0b=e.$b0b=e.$a0b=void 0,e.$a0b=(0,S.$4h)("storageMainService");let $=class extends s.$Tc{constructor(g,v,u,t,o,r){super(),this.c=g,this.f=v,this.g=u,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$Td),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(g=>{g.window.profile&&this.profileStorage(g.window.profile).init(),g.workspace&&this.workspaceStorage(g.workspace).init()})),this.B(this.h.onWillShutdown(g=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=g.reason,g.join("applicationStorage",this.applicationStorage.close());for(const[,v]of this.t)g.join("profileStorage",v.close());for(const[,v]of this.w)g.join("workspaceStorage",v.close())})),this.B(this.g.onWillCreateProfile(g=>{g.join((async()=>{await this.j.exists(g.profile.globalStorageHome)||await this.j.createFolder(g.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(g=>{const v=this.t.get(g.profile.id);v&&g.join(v.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const g=new k.$09b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(g.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),g}profileStorage(g){if((0,y.$mp)(g))return this.applicationStorage;let v=this.t.get(g.id);if(!v){this.c.trace(`StorageMainService: creating profile storage (${g.name})`),v=this.B(this.u(g)),this.t.set(g.id,v);const u=this.B(v.onDidChangeStorage(t=>this.b.fire({...t,storage:v,profile:g})));this.B(R.Event.once(v.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${g.name})`),this.t.delete(g.id),u.dispose()}))}return v}u(g){return this.a===2?new k.$_9b(this.c,this.j):new k.$99b(g,this.n(),this.c,this.j)}workspaceStorage(g){let v=this.w.get(g.id);return v||(this.c.trace(`StorageMainService: creating workspace storage (${g.id})`),v=this.B(this.y(g)),this.w.set(g.id,v),this.B(R.Event.once(v.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${g.id})`),this.w.delete(g.id)}))),v}y(g){return this.a===2?new k.$_9b(this.c,this.j):new k.$$9b(g,this.n(),this.c,this.f,this.j)}isUsed(g){const v=P.URI.file(g);for(const u of[this.applicationStorage,...this.t.values(),...this.w.values()])if(u.path&&this.m.extUri.isEqualOrParent(P.URI.file(u.path),v))return!0;return!1}};e.$b0b=$,e.$b0b=$=Ee([ne(0,l.$lj),ne(1,M.$$h),ne(2,c.$Q9b),ne(3,f.$79b),ne(4,D.$ok),ne(5,b.$Yk)],$),e.$c0b=(0,S.$4h)("applicationStorageMainService");let d=class extends y.$lp{constructor(g,v){super(),this.s=g,this.U=v,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(g){if(g===-1)return this.U.applicationStorage.storage}Q(g){if(g===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:m.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$d0b=d,e.$d0b=d=Ee([ne(0,p.$1k),ne(1,e.$a0b)],d)}),define(oe[287],ae([0,1,87,26,103,99,8,2,4,17,5,27,241,242,95,126,18]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=e.$B$b=e.$A$b=void 0;async function d(t,o,r,i,n){let a;for(let w=3;w&&(a?.dispose(),a=await new h(t,o,r,i,n).waitForReady(),!(n&&s.$rg[n]||!s.$rg[a.tunnelLocalPort]));w--);return a}class h extends S.$Tc{constructor(o,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=m.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new D.$3g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=w=>this.r(w),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,m.$xv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$sg)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,m.$vv)(this.tunnelRemoteHost)||(0,m.$xv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,p.$jl)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&o.write(a.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof M.$Sh?n.socket.destroy():n.end()}),n instanceof M.$Sh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write($.$he.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$A$b=h;let g=class extends m.$Av{constructor(o,r,i,n,a){super(r,a),this.u=o,this.v=i,this.w=n}isPortPrivileged(o){return(0,m.$yv)(o,this.l,f.OS,R.release())}s(o,r,i,n,a,w,A,I){const E=this.r(r,i);if(E)return++E.refcount,E.value;if((0,m.$sv)(o))return this.t(o,r,i,a,w,A,I);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const C={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},j=d(C,n,r,i,a);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(r,i,j),j}}};e.$B$b=g,e.$B$b=g=Ee([ne(0,c.$dl),ne(1,y.$lj),ne(2,b.$gl),ne(3,k.$Dj),ne(4,l.$xi)],g);let v=class extends g{constructor(o,r,i,n,a){super(o,r,i,n,a)}};e.$C$b=v,e.$C$b=v=Ee([ne(0,c.$dl),ne(1,y.$lj),ne(2,b.$gl),ne(3,k.$Dj),ne(4,l.$xi)],v);let u=class extends S.$Tc{constructor(o,r,i,n,a){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(o,r,i,n,a,w,A,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${w}.`),!this.a.has(o)){const C=new v(this.b,this.c,this.g,this.f,this.h);this.B(C),this.a.set(o,C),C.onTunnelClosed(async()=>{(await C.tunnels).length===0&&(C.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,a,w,A,I,E)}};e.$D$b=u,e.$D$b=u=Ee([ne(0,c.$dl),ne(1,y.$lj),ne(2,k.$Dj),ne(3,b.$gl),ne(4,l.$xi)],u)}),define(oe[100],ae([0,1,8,22,3,17,24,20,5,27,52,49]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=e.$Y0b=void 0;function p(b,m,$){return`${$.updateUrl}/api/update/${b}/${m}/${$.commit}`}e.$Y0b=p;let c=class{get state(){return this.b}d(m){this.j.info("update#setState",m.type),this.b=m,this.c.fire(m)}constructor(m,$,d,h,g,v){this.f=m,this.g=$,this.h=d,this.i=h,this.j=g,this.k=v,this.b=k.$nV.Uninitialized,this.c=new s.$Td,this.onStateChange=this.c.event,m.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(k.$nV.Disabled(0));return}if(this.h.disableUpdates){this.d(k.$nV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(k.$nV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const m=this.g.getValue("update.mode"),$=this.m(m);if(!$){this.d(k.$nV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s($),!this.a){this.d(k.$nV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const d=new URL(this.a);d.searchParams.set("prss","true"),this.a=d.toString()}if(this.d(k.$nV.Idle(this.q())),m==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,d=>this.j.error(d))}m(m){return m==="none"?void 0:this.k.quality}n(m=60*60*1e3){return(0,P.$5g)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(m){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(m)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(m){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch($){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error($);return}}async _applySpecificUpdate(m){}q(){return 1}r(){}};e.$Z0b=c,e.$Z0b=c=Ee([ne(0,S.$79b),ne(1,M.$xi),ne(2,D.$z9b),ne(3,y.$9o),ne(4,f.$lj),ne(5,l.$Dj)],c)}),define(oe[288],ae([0,1,15,50,3,45,2,17,24,20,5,27,52,28,49,100]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$10b=void 0;let $=class extends m.$Z0b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(h,g)=>g)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(h,g,v)=>({url:g,version:v,productVersion:v}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(h,g,v,u)=>({releaseNotes:g,version:v,productVersion:v,date:u}))}constructor(h,g,v,u,t,o,r){super(h,g,u,t,o,r),this.z=v,this.u=new D.$Sc,h.setRelaunchHandler(this)}handleRelaunch(h){return h?.addArgs||h?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(h){this.z.publicLog2("update:error",{messageHash:String((0,M.$Ri)(String(h)))}),this.j.error("UpdateService error:",h);const g=this.state.type==="checking for updates"&&this.state.explicit?h:void 0;this.d(b.$nV.Idle(1,g))}s(h){let g;this.k.darwinUniversalAssetId?g=this.k.darwinUniversalAssetId:g=process.arch==="x64"?"darwin":"darwin-arm64";const v=(0,m.$Y0b)(g,h,this.k);try{P.autoUpdater.setFeedURL({url:v})}catch(u){this.j.error("Failed to set update feed URL",u);return}return v}t(h){this.d(b.$nV.CheckingForUpdates(h)),P.autoUpdater.checkForUpdates()}E(h){this.state.type==="checking for updates"&&this.d(b.$nV.Downloading(h))}F(h){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:h.version}),this.d(b.$nV.Ready(h)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(b.$nV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$10b=$,Ee([R.$vh],$.prototype,"v",null),Ee([R.$vh],$.prototype,"w",null),Ee([R.$vh],$.prototype,"x",null),Ee([R.$vh],$.prototype,"y",null),e.$10b=$=Ee([ne(0,l.$79b),ne(1,S.$xi),ne(2,c.$sl),ne(3,f.$z9b),ne(4,p.$9o),ne(5,y.$lj),ne(6,k.$Dj)],$)}),define(oe[289],ae([0,1,48,46,8,3,9,24,20,5,28,49]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30b=void 0;let p=class{get state(){return this.a}d(m){this.g.info("update#setState",m.type),this.a=m,this.b.fire(m)}constructor(m,$,d){if(this.f=m,this.g=d,this.a=k.$nV.Uninitialized,this.b=new M.$Td,this.onStateChange=this.b.event,$.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(k.$nV.Idle(this.k())),this.h(30*1e3).then(void 0,h=>this.g.error(h))}h(m=60*60*1e3){return(0,s.$5g)(m).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(m){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(m)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(m){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(m=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(m){}};p=Ee([ne(0,f.$79b),ne(1,S.$z9b),ne(2,l.$lj)],p);let c=class extends p{constructor(m,$,d,h,g,v){super(d,h,g),this.o=m,this.p=$,this.q=v;const u=(0,R.watch)(D.$mc(this.o)),t=M.Event.fromNodeEventEmitter(u,"change",(n,a)=>a),o=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(o,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));d.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(k.$nV.CheckingForUpdates(!1)),this.u().then(m=>{m?this.d(k.$nV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$nV.Idle(2)))},m=>{this.g.error(m),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$nV.Idle(2,m.message||m))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const m=await new Promise((d,h)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(g,v)=>g?h(g):d(v))),$=D.$nc(m);return this.p!==$}isLatestVersion(){return this.u().then(void 0,m=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$30b=c,e.$30b=c=Ee([ne(2,f.$79b),ne(3,S.$z9b),ne(4,l.$lj),ne(5,y.$sl)],c)}),define(oe[29],ae([0,1,4,6,60,70,27,17,24,9,65,136]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P9b=e.$O9b=e.$N9b=e.OpenContext=e.$M9b=void 0,e.$M9b=(0,R.$4h)("windowsMainService");var p;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(p||(e.OpenContext=p={}));function c($,d,h){const g=$.get(M.$I9b),v=$.get(D.$Dj),u=$.get(S.$xi),t=$.get(f.$z9b),o=u.getValue("window"),r={backgroundColor:g.getBackgroundColor(),minWidth:s.$DC.WIDTH,minHeight:s.$DC.HEIGHT,title:v.nameLong,...h,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$MC)(d?.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...h?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if(d&&(r.x=d.x,r.y=d.y,r.width=d.width,r.height=d.height),P.$k?r.icon=(0,l.$jc)(t.appRoot,"resources/linux/code.png"):P.$i&&!t.isBuilt&&(r.icon=(0,l.$jc)(t.appRoot,"resources/win32/code_150x150.png")),P.$j&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),P.$j&&!(0,s.$LC)(u)&&(r.fullscreenable=!1),P.$j&&o?.nativeTabs===!0&&(r.tabbingIdentifier=v.nameShort),(0,s.$JC)(u)==="custom"&&(r.titleBarStyle="hidden",P.$j||(r.frame=!1),(0,s.$KC)(u))){const a=g.getWindowSplash()?.colorInfo.titleBarBackground??g.getBackgroundColor(),w=k.$ct.fromHex(a).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:a,symbolColor:w}}return r}e.$N9b=c;function b($){const d=$.get(e.$M9b),h=$.get(y.$K9b),g=d.getFocusedWindow()??h.getFocusedWindow();if(g)return g;const v=d.getLastActiveWindow(),u=h.getLastActiveWindow();return v&&u?v.lastFocusTime<u.lastFocusTime?u:v:v??u}e.$O9b=b;function m($){let d,h=Number.MIN_VALUE;for(const g of $)g.lastFocusTime>h&&(h=g.lastFocusTime,d=g);return d}e.$P9b=m}),define(oe[290],ae([0,1,15,22,3,45,2,32,116,5,82,29]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e0b=void 0;var p;(function(b){b[b.Initial=1]="Initial",b[b.StoredCredentialsUsed=2]="StoredCredentialsUsed",b[b.LoginDialogShown=3]="LoginDialogShown"})(p||(p={}));let c=class extends D.$Tc{constructor(m,$,d,h){super(),this.g=m,this.h=$,this.j=d,this.m=h,this.a="proxy-credentials://",this.b=void 0,this.c=p.Initial,this.f=void 0,this.n()}n(){const m=s.Event.fromNodeEventEmitter(P.app,"login",($,d,h,g,v)=>({event:$,webContents:d,req:h,authInfo:g,callback:v}));this.B(m(this.r,this))}async r({event:m,authInfo:$,req:d,callback:h}){if(!$.isProxy)return;if(!this.b&&this.c===p.LoginDialogShown&&d.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let g;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),g=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s($);try{g=await this.b}finally{this.b=void 0}}h(g?.username,g?.password)}async s(m){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const $=await this.t(m);if($)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),$;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(m){this.g.trace("auth#doResolveProxyCredentials - enter",m);const $=String((0,M.$Ri)({scheme:m.scheme,host:m.host,port:m.port}));let d,h;try{const t=this.m.get(this.a+$,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));d=o.username,h=o.password}}catch(t){this.g.error(t)}if(this.c!==p.StoredCredentialsUsed&&typeof d=="string"&&typeof h=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=p.StoredCredentialsUsed,{username:d,password:h};const g=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!g){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${g.id} to handle proxy login`);const v={authInfo:m,username:this.f?.username??d,password:this.f?.password??h,replyChannel:`vscode:proxyAuthResponse:${(0,S.$og)()}`};g.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,v),this.c=p.LoginDialogShown;const u=await new Promise(t=>{const o=async(r,i,n)=>{if(i===v.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${g.id}`),g.win?.webContents.off("ipc-message",o),n){const a={username:n.username,password:n.password};try{if(n.remember){const w=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+$,w,-1,1)}else this.m.remove(this.a+$,-1)}catch(w){this.g.error(w)}t({username:a.username,password:a.password})}else t(void 0)};g.win?.webContents.on("ipc-message",o)});return this.f=u,u}};e.$e0b=c,e.$e0b=c=Ee([ne(0,l.$lj),ne(1,k.$M9b),ne(2,f.$$U),ne(3,y.$c0b)],c)}),define(oe[291],ae([0,1,15,23,4,7,21,17,64,6,5,127,29]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=e.$E0b=e.ID=void 0,e.ID="launchMainService",e.$E0b=(0,l.$4h)(e.ID);let c=class{constructor(m,$,d,h){this.a=m,this.b=$,this.c=d,this.d=h}async start(m,$){this.a.trace("Received data from other instance: ",m,$),s.$j&&P.app.focus({steal:!0});const d=this.e(m);if(d.length){let h=Promise.resolve();if(this.b.getWindowCount()===0){const g=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));g&&(h=g.ready())}h.then(()=>{for(const{uri:g,originalUrl:v}of d)this.c.open(g,{originalUrl:v})})}else return this.f(m,$)}e(m){return m["open-url"]&&m._urls&&m._urls.length>0?(0,R.$Hb)(m._urls.map($=>{try{return{uri:M.URI.parse($),originalUrl:$}}catch{return null}})):[]}async f(m,$){const d=(0,f.$4l)($)?0:4;let h=[];const g=m.wait&&m.waitMarkerFilePath?M.URI.file(m.waitMarkerFilePath):void 0,v=m.remote||void 0,u={context:d,cli:m,userEnv:$,waitMarkerFileURI:g,remoteAuthority:v,forceProfile:m.profile,forceTempProfile:m["profile-temp"]};if(m.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(m.extensionDevelopmentPath,u);else if(!m._.length&&!m["folder-uri"]&&!m["file-uri"]){let t=!1;if(m["new-window"]||m["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(m["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)h=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,u),h=[o]):h=await this.b.open({...u,forceEmpty:!0})}}else h=await this.b.open({...u,forceNewWindow:m["new-window"],preferNewWindow:!m["reuse-window"]&&!m.wait,forceReuseWindow:m["reuse-window"],diffMode:m.diff,mergeMode:m.merge,addMode:m.add,noRecentEntry:!!m["skip-add-to-recently-opened"],gotoLineMode:m.goto});if(g&&h.length===1&&h[0])return Promise.race([h[0].whenClosedOrLoaded,(0,D.whenDeleted)(g.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$F0b=c,e.$F0b=c=Ee([ne(0,y.$lj),ne(1,p.$M9b),ne(2,k.$eV),ne(3,S.$xi)],c)}),define(oe[292],ae([0,1,2,20,55,30,8,29]),function(Q,e,P,R,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i$b=void 0;let f=class extends P.$Tc{constructor(y,k,p){super(),this.a=k,this.b=p,this.B(y.onWillLoadWindow(c=>{c.reason===2&&this.c(c.window)})),this.B(y.onBeforeCloseWindow(c=>this.c(c))),this.B(new D.$dh(()=>this.g(),30*1e3)).schedule()}async c(y){const k=this.f(y),p=this.a.getProfileForWorkspace(k);p?.isTransient&&(this.a.unsetWorkspace(k,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f(y){return y.openedWorkspace??(0,M.$fi)(y.backupPath,y.isExtensionDevelopmentHost)}g(){const y=this.a.getAssociatedEmptyWindows();if(y.length===0)return;const k=this.b.getWindows().map(p=>this.f(p));for(const p of y)k.some(c=>c.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$i$b=f,e.$i$b=f=Ee([ne(0,R.$79b),ne(1,s.$Q9b),ne(2,S.$M9b)],f)}),define(oe[61],ae([0,1,15,2,3,5,312,8,13,29,74,28,20,76,38,4,131]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$i0b=e.$h0b=void 0;function h(u){return typeof u.responseWindowId=="number"}let g=class extends R.$Tc{static{d=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(d.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++d.a),this.f=this.B(new s.$Td),this.onStdout=this.f.event,this.g=this.B(new s.$Td),this.onStderr=this.g.event,this.h=this.B(new s.$Td),this.onMessage=this.h.event,this.j=this.B(new s.$Td),this.onSpawn=this.j.event,this.m=this.B(new s.$Td),this.onExit=this.m.event,this.n=this.B(new s.$Td),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case y.default.Error:this.u.error(r);break;case y.default.Warning:this.u.warn(r);break;case y.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",y.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=f.$mg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],a=this.t.allowLoadingUnsignedLibraries,w=this.t.forceAllocationsToV8Sandbox,A="pipe",I=this.F(t);return this.z("creating new...",y.default.Info),this.r=P.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:w,stdio:A}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,b.$kn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,m.$i&&((0,$.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,$.getUNCHostAllowlist)().join("\\")),(0,c.$Ql)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&d.b.set(t.pid,{pid:t.pid,name:h(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",y.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,y.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,y.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",y.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",y.default.Info),this.r.kill()?(this.z("successfully killed the process",y.default.Info),this.H()):this.z("unable to kill the process",y.default.Warning)}H(){typeof this.s=="number"&&d.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",y.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$5g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,y.default.Info),this.kill()))}};e.$h0b=g,e.$h0b=g=d=Ee([ne(0,M.$lj),ne(1,k.$sl),ne(2,p.$79b)],g);let v=class extends g{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",y.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$i0b=v,e.$i0b=v=Ee([ne(0,M.$lj),ne(1,l.$M9b),ne(2,k.$sl),ne(3,p.$79b)],v)}),define(oe[293],ae([0,1,14,3,5,20,8,61,29,28]),function(Q,e,P,R,s,M,D,S,f,l){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$p0b=void 0;let k=class{static{y=this}static{this.a=0}constructor(c,b,m,$){this.d=c,this.f=b,this.g=m,this.h=$,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(c){const b=this.b.get(c);if(!b)throw new Error("Unknown extension host!");return b}onDynamicStdout(c){return this.i(c).onStdout}onDynamicStderr(c){return this.i(c).onStderr}onDynamicMessage(c){return this.i(c).onMessage}onDynamicExit(c){return this.i(c).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const c=String(++y.a),b=new S.$i0b(this.d,this.g,this.h,this.f);return this.b.set(c,b),b.onExit(({pid:m,code:$,signal:d})=>{this.d.info(`Extension host with pid ${m} exited with code: ${$}, signal: ${d}.`),setTimeout(()=>{b.dispose(),this.b.delete(c)}),setTimeout(()=>{try{process.kill(m,0),this.d.error(`Extension host with pid ${m} still exists, forcefully killing it...`),process.kill(m)}catch{}},1e3)}),{id:c}}async start(c,b){if(this.c)throw(0,P.$6)();const m=this.i(c);return m.start({...b,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:b.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:c}),{pid:await R.Event.toPromise(m.onSpawn)}}async enableInspectPort(c){if(this.c)throw(0,P.$6)();const b=this.b.get(c);return b?b.enableInspectPort():!1}async kill(c){if(this.c)throw(0,P.$6)();const b=this.b.get(c);b&&b.kill()}async _killAllNow(){for(const[,c]of this.b)c.kill()}async _waitForAllExit(c){const b=[];for(const[,m]of this.b)b.push(m.waitForExit(c));return D.Promises.settled(b).then(()=>{})}};e.$p0b=k,e.$p0b=k=y=Ee([ne(0,s.$lj),ne(1,M.$79b),ne(2,f.$M9b),ne(3,l.$sl)],k)}),define(oe[294],ae([0,1,36,8,2,24,20,5,41,39,69,61,53,90,12,247]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=void 0;let $=class extends s.$Tc{constructor(h,g,v,u,t,o,r,i){super(),this.c=h,this.f=g,this.g=v,this.h=u,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new R.$3g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$pU.on(m.$Q0b.request,(h,g)=>this.t(h,g,m.$Q0b.response)),P.$pU.on(m.$R0b.request,(h,g)=>this.t(h,g,m.$R0b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(h,g,v){this.m.trace(`[SharedProcess] onWindowConnection for: ${v}`),this.a.isOpen()||this.a.open(),await this.whenReady();const u=await this.connect(v);if(h.sender.isDestroyed())return u.close();h.sender.postMessage(v,g,[u])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(m.$P0b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const h=new R.$oh;this.b?this.b.once(m.$P0b.initDone,()=>h.complete()):P.$pU.once(m.$P0b.initDone,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const h=new R.$oh;this.b?this.b.once(m.$P0b.ipcReady,()=>h.complete()):P.$pU.once(m.$P0b.ipcReady,()=>h.complete()),await h.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new k.$h0b(this.m,p.$Bo,this.j));const h=(0,c.$Bm)(this.g.args,this.g.isBuilt);let g;h.port&&(g=["--nolazy"],h.break?g.push(`--inspect-brk=${h.port}`):g.push(`--inspect=${h.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:g})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(h){return await this.z,(0,b.$Rf)(this.b).connect(h)}};e.$S0b=$,e.$S0b=$=Ee([ne(2,M.$z9b),ne(3,f.$1k),ne(4,D.$79b),ne(5,S.$lj),ne(6,y.$29b),ne(7,l.$yn)],$)}),define(oe[295],ae([0,1,24,90,20,5,53,61,110,36,2,3,38,17,13]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s$b=void 0;let m=class extends y.$Tc{constructor(d,h,g,v,u){super(),this.f=d,this.g=h,this.h=g,this.j=v,this.m=u,this.a=void 0,this.b=new k.$Td,this.onRequestConnection=this.b.event,this.c=new k.$Td,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$pU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,y.$Rc)(()=>{l.$pU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$h0b(this.m,D.$Bo,this.j);const d=(0,R.$Am)(this.h.args,this.h.isBuilt),h=d.port?["--nolazy",`--inspect${d.break?"-brk":""}=${d.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:h,args:["--logsPath",this.h.logsHome.with({scheme:b.Schemas.file}).fsPath],env:this.n()});const g=this.a.connect(),v=new f.$xU(g,"ptyHost"),u=new y.$Sc;return u.add(v),u.add((0,y.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:v,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const d={...(0,p.$kn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},h=this.g.getValue("terminal.integrated.developer.ptyHost.latency");h&&typeof h=="number"&&(d.VSCODE_LATENCY=String(h));const g=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return g&&typeof g=="number"&&(d.VSCODE_STARTUP_DELAY=String(g)),this.h.restoreSnapExportedVariables(),d}r(d,h){this.b.fire();const g=this.a.connect();if(d.sender.isDestroyed()){g.close();return}d.sender.postMessage("vscode:createPtyHostMessageChannelResult",h,[g])}};e.$s$b=m,e.$s$b=m=Ee([ne(1,c.$xi),ne(2,P.$z9b),ne(3,s.$79b),ne(4,M.$lj)],m)}),define(oe[296],ae([0,1,2,6,5,29,61,28,45,3,8,20]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=e.$q$b=void 0,e.$q$b=(0,R.$4h)("utilityProcessWorker");let p=class extends P.$Tc{constructor(m,$,d,h){super(),this.b=m,this.c=$,this.f=d,this.g=h,this.a=new Map}async createWorker(m){const $=`window: ${m.reply.windowId}, moduleId: ${m.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${$})`);const d=this.h(m);this.a.has(d)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${$})`),this.disposeWorker(m));const h=new c(this.b,this.c,this.f,this.g,m);if(!h.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(d,h);const g=new y.$oh;return l.Event.once(h.onDidTerminate)(v=>{v.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${v.code}, signal: ${v.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${v.code}, signal: ${v.signal}`),this.a.delete(d),g.complete({reason:v})}),g.p}h(m){return(0,f.$Ri)({moduleId:m.process.moduleId,windowId:m.reply.windowId})}async disposeWorker(m){const $=this.h(m),d=this.a.get($);d&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${m.reply.windowId}, moduleId: ${m.process.moduleId})`),d.kill(),this.a.delete($))}};e.$r$b=p,e.$r$b=p=Ee([ne(0,s.$lj),ne(1,M.$M9b),ne(2,S.$sl),ne(3,k.$79b)],p);let c=class extends P.$Tc{constructor(m,$,d,h,g){super(),this.c=m,this.f=$,this.g=d,this.h=h,this.j=g,this.a=this.B(new l.$Td),this.onDidTerminate=this.a.event,this.b=new D.$i0b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(m=>this.a.fire({code:m.code,signal:m.signal}))),this.B(this.b.onCrash(m=>this.a.fire({code:m.code,signal:"ECRASH"})))}spawn(){const $=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:$,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};c=Ee([ne(0,s.$lj),ne(1,M.$M9b),ne(2,S.$sl),ne(3,k.$79b)],c)}),define(oe[297],ae([0,1,15,3,2,273,29]),function(Q,e,P,R,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$0b=void 0;let S=class extends s.$Tc{constructor(l){super(),this.b=l,this.a=this.B(new R.$Td),this.onFoundInFrame=this.a.event,this.B(new M.$00b)}async setIgnoreMenuShortcuts(l,y){let k;if(typeof l.windowId=="number"){const{windowId:p}=l,c=this.b.getWindowById(p);if(!c?.win)throw new Error(`Invalid windowId: ${p}`);k=c.win.webContents}else{const{webContentsId:p}=l;if(k=P.webContents.fromId(p),!k)throw new Error(`Invalid webContentsId: ${p}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(y)}async findInFrame(l,y,k,p){const b=this.c(l,y);if(typeof b.findInFrame=="function"){b.findInFrame(k,{findNext:p.findNext,forward:p.forward});const m=($,d)=>{d.finalUpdate&&(this.a.fire(d),b.removeListener("found-in-frame",m))};b.on("found-in-frame",m)}}async stopFindInFrame(l,y,k){const c=this.c(l,y);typeof c.stopFindInFrame=="function"&&c.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}c(l,y){const k=this.b.getWindowById(l.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${l}`);const p=k.win.webContents.mainFrame.framesInSubtree.find(c=>c.name===y);if(!p)throw new Error(`Unknown frame: ${y}`);return p}};e.$$0b=S,e.$$0b=S=Ee([ne(0,D.$M9b)],S)}),define(oe[298],ae([0,1,15,2,4,19,7,17,20,5,34,29,128,30]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$b$b=e.$a$b=e.$_0b=void 0;let m=class extends R.$Tc{static{b=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,o,r,i){super(),this.g=u,this.h=t,this.j=o,this.m=r,this.n=i,this.b=$(this.h.getItem(b.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const r=h(t);this.h.setItem(b.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,c.$gi)(u.openedWorkspace)&&o.workspace?.id===u.openedWorkspace.id,i=(0,c.$bi)(u.openedWorkspace)&&o.folderUri&&M.$wg.isEqual(o.folderUri,u.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,c.$gi)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,c.$bi)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const w=u.workspace;if((0,c.$gi)(w)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===w.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,c.$bi)(w)){const I=this.state.openedWindows.filter(E=>E.folderUri&&M.$wg.isEqual(E.folderUri,w.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(u.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===u.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const A=this.c||this.state.lastActiveWindow;if(!t&&A)return A.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const w=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(w)}!o&&t&&(o=P.screen.getDisplayMatching(t.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let i=(0,p.$y9b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const w=t.serializeWindowState();w.mode===3?i.mode=3:i=w,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===u.x||o.y===u.y);)u.x+=30,u.y+=30;return u}};e.$_0b=m,e.$_0b=m=b=Ee([ne(0,k.$M9b),ne(1,y.$cO),ne(2,f.$79b),ne(3,l.$lj),ne(4,S.$xi)],m);function $(v){const u={openedWindows:[]},t=v||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=d(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=d(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(o=>d(o))),u}e.$a$b=$;function d(v){const u={uiState:v.uiState};return v.backupPath&&(u.backupPath=v.backupPath),v.remoteAuthority&&(u.remoteAuthority=v.remoteAuthority),v.folder&&(u.folderUri=D.URI.parse(v.folder)),v.workspaceIdentifier&&(u.workspace={id:v.workspaceIdentifier.id,configPath:D.URI.parse(v.workspaceIdentifier.configURIPath)}),u}function h(v){return{lastActiveWindow:v.lastActiveWindow&&g(v.lastActiveWindow),lastPluginDevelopmentHostWindow:v.lastPluginDevelopmentHostWindow&&g(v.lastPluginDevelopmentHostWindow),openedWindows:v.openedWindows.map(u=>g(u))}}e.$b$b=h;function g(v){return{workspaceIdentifier:v.workspace&&{id:v.workspace.id,configURIPath:v.workspace.configPath.toString()},folder:v.folderUri&&v.folderUri.toString(),backupPath:v.backupPath,remoteAuthority:v.remoteAuthority,uiState:v.uiState}}}),define(oe[56],ae([0,1,15,3,44,2,13,9,19,21,194,66,54,24,6,5,55,130,30,97,98]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=e.$Z9b=void 0,e.$Z9b=(0,b.$4h)("workspacesManagementMainService");let u=class extends M.$Tc{constructor(o,r,i,n,a){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new R.$Td),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Td),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await l.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,f.$Fg)(this.c,r,h.$qi));for(const r of o){const i=(0,v.$W9b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>l.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,h.$ri)(o,this.g)||(0,h.$wi)(o)}t(o,r){try{const i=this.u(o,r),n=(0,v.$W9b)(o);return{id:n.id,configPath:n.configPath,folders:(0,g.$pcb)(i.folders,n.configPath,f.$wg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$an)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,g.$ncb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),a=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$mc)(a),{recursive:!0}),await l.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$Fg)(this.c,i),a=(0,f.$Fg)(n,h.$qi),w=[];for(const A of o)w.push((0,g.$ocb)(A.uri,!0,A.name,n,f.$wg));return{workspace:(0,v.$W9b)(a),storedWorkspace:{folders:w,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,v.$W9b)(o)}isUntitledWorkspace(o){return(0,h.$ri)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,f.$tg)(o.configPath);try{await l.Promises.rm((0,S.$mc)(r));const i=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const a=await this.C(o,(0,v.$W9b)(i));if(a)return this.b.fire({window:o,workspace:a.workspace}),a}async z(o,r,i){return i?(0,h.$gi)(o.openedWorkspace)&&f.$wg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,d.$T9b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,y.localize)(0,null)],message:(0,y.localize)(1,null,(0,f.$Cg)(i)),detail:(0,y.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,h.$gi)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$19b=u,e.$19b=u=Ee([ne(0,c.$z9b),ne(1,m.$lj),ne(2,$.$Q9b),ne(3,k.$E9b),ne(4,p.$F9b)],u)}),define(oe[132],ae([0,1,15,36,22,6,29,30,56,12,5,61]),function(Q,e,P,R,s,M,D,S,f,l,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l0b=e.$k0b=e.ID=void 0,e.ID="diagnosticsMainService",e.$k0b=(0,M.$4h)(e.ID);let p=class{constructor(b,m,$){this.a=b,this.b=m,this.c=$}async getRemoteDiagnostics(b){const m=this.a.getWindows();return(await Promise.all(m.map(async d=>{const h=d.remoteAuthority;if(!h)return;const g=`vscode:getDiagnosticInfoResponse${d.id}`,v={includeProcesses:b.includeProcesses,folders:b.includeWorkspaceMetadata?await this.f(d):void 0};return new Promise(u=>{d.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:g,args:v}),R.$pU.once(g,(t,o)=>{o||u({hostName:h,errorMessage:`Unable to resolve connection to '${h}'.`}),u(o)}),setTimeout(()=>{u({hostName:h,errorMessage:`Connection to '${h}' could not be established`})},5e3)})}))).filter(d=>!!d)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const b=[];for(const $ of P.BrowserWindow.getAllWindows()){const d=this.a.getWindowById($.id);d?b.push(await this.d(d)):b.push(this.e($))}const m=[];for(const{pid:$,name:d}of k.$h0b.getAll())m.push({pid:$,name:d});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:b,pidToNames:m,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(b){const m=await this.f(b),$=(0,l.$Rf)(b.win);return this.e($,m,b.remoteAuthority)}e(b,m=[],$){return{id:b.id,pid:b.webContents.getOSProcessId(),title:b.getTitle(),folderURIs:m,remoteAuthority:$}}async f(b){const m=[],$=b.openedWorkspace;if((0,S.$bi)($))m.push($.uri);else if((0,S.$gi)($)){const d=await this.b.resolveLocalWorkspace($.configPath);d&&d.folders.forEach(g=>{m.push(g.uri)})}return m}};e.$l0b=p,e.$l0b=p=Ee([ne(0,D.$M9b),ne(1,f.$Z9b),ne(2,y.$lj)],p)}),define(oe[71],ae([0,1,48,15,26,156,50,3,2,13,9,4,7,105,88,21,103,182,54,24,6,20,5,27,70,29,30,56,18,243,235,65,14]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z0b=e.$y0b=void 0,e.$y0b=(0,v.$4h)("nativeHostMainService");let j=class extends f.$Tc{constructor(T,G,K,le,re,ue,Y,Z,H,L){super(),this.a=T,this.b=G,this.c=K,this.f=le,this.g=re,this.h=ue,this.j=Y,this.m=Z,this.n=H,this.r=L,this.onDidOpenMainWindow=S.Event.map(this.a.onDidOpenWindow,U=>U.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:U,x:V,y:q})=>({windowId:U.id,x:V,y:q})),({windowId:U})=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidTriggerSystemContextMenu,({window:U,x:V,y:q})=>({windowId:U.id,x:V,y:q})),({windowId:U})=>!!this.b.getWindowById(U))),this.onDidMaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidMaximizeWindow,U=>U.id),U=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidMaximizeWindow,U=>U.id),U=>!!this.b.getWindowById(U))),this.onDidUnmaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidUnmaximizeWindow,U=>U.id),U=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidUnmaximizeWindow,U=>U.id),U=>!!this.b.getWindowById(U))),this.onDidChangeWindowFullScreen=S.Event.any(S.Event.map(this.a.onDidChangeFullScreen,U=>U.id),S.Event.map(this.b.onDidChangeFullScreen,U=>U.id)),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(U,V)=>V.id),U=>!!this.a.getWindowById(U)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),U=>!!U),U=>U.id),S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(U,V)=>V.id),U=>!!this.a.getWindowById(U))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(U,V)=>V),U=>(0,E.$L9b)(U.webContents)),U=>U.id)),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(U,V)=>V),U=>(0,E.$L9b)(U.webContents)),U=>U.id)),this.onDidResumeOS=S.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Td),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(U,V,q)=>q),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),S.Event.fromNodeEventEmitter(R.screen,"display-added"),S.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(T,G){const K=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,n.$fi)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),le=[];return G.includeAuxiliaryWindows&&le.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...K,...le]}async getWindowCount(T){return this.a.getWindowCount()}async getActiveWindowId(T){const G=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(G)return G.id}openWindow(T,G,K){return Array.isArray(G)?this.t(T,G,K):this.u(T,G)}async t(T,G,K=Object.create(null)){G.length>0&&await this.a.open({context:5,contextWindowId:T,urisToOpen:G,cli:this.g.args,forceNewWindow:K.forceNewWindow,forceReuseWindow:K.forceReuseWindow,preferNewWindow:K.preferNewWindow,diffMode:K.diffMode,mergeMode:K.mergeMode,addMode:K.addMode,gotoLineMode:K.gotoLineMode,noRecentEntry:K.noRecentEntry,waitMarkerFileURI:K.waitMarkerFileURI,remoteAuthority:K.remoteAuthority||void 0,forceProfile:K.forceProfile,forceTempProfile:K.forceTempProfile})}async u(T,G){await this.a.openEmptyWindow({context:5,contextWindowId:T},G)}async toggleFullScreen(T,G){this.D(G?.targetWindowId,T)?.toggleFullScreen()}async handleTitleDoubleClick(T,G){this.D(G?.targetWindowId,T)?.handleTitleDoubleClick()}async getCursorScreenPoint(T){const G=R.screen.getCursorScreenPoint(),K=R.screen.getDisplayNearestPoint(G);return{point:G,display:K.bounds}}async isMaximized(T,G){return this.D(G?.targetWindowId,T)?.win?.isMaximized()??!1}async maximizeWindow(T,G){this.D(G?.targetWindowId,T)?.win?.maximize()}async unmaximizeWindow(T,G){this.D(G?.targetWindowId,T)?.win?.unmaximize()}async minimizeWindow(T,G){this.D(G?.targetWindowId,T)?.win?.minimize()}async moveWindowTop(T,G){this.D(G?.targetWindowId,T)?.win?.moveTop()}async positionWindow(T,G,K){const le=this.D(K?.targetWindowId,T);if(le?.win){if(le.win.isFullScreen()){const re=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(le.win,"leave-full-screen")));le.win.setFullScreen(!1),await re}le.win.setBounds(G)}}async updateWindowControls(T,G){this.D(G?.targetWindowId,T)?.updateWindowControls(G)}async focusWindow(T,G){this.D(G?.targetWindowId,T)?.focus({force:G?.force??!1})}async setMinimumSize(T,G,K){const le=this.F(T);if(le?.win){const[re,ue]=le.win.getSize(),[Y,Z]=le.win.getMinimumSize(),[H,L]=[G??Y,K??Z],[U,V]=[Math.max(re,H),Math.max(ue,L)];(Y!==H||Z!==L)&&le.win.setMinimumSize(H,L),(re!==U||ue!==V)&&le.win.setSize(U,V)}}async saveWindowSplash(T,G){this.m.saveWindowSplash(T,G)}async installShellCommand(T){const{source:G,target:K}=await this.w();try{const{symbolicLink:le}=await m.SymlinkSupport.stat(G);if(le&&!le.dangling){const re=await(0,c.$kq)(G);if(K===re)return}await m.Promises.unlink(G)}catch(le){if(le.code!=="ENOENT")throw le}try{await m.Promises.symlink(K,G)}catch(le){if(le.code!=="EACCES"&&le.code!=="ENOENT")throw le;const{response:re}=await this.showMessageBox(T,{type:"info",message:(0,d.localize)(0,null,this.j.nameShort),buttons:[(0,d.localize)(1,null),(0,d.localize)(2,null)]});if(re===1)throw new C.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${K}' '${G}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ue)}catch{throw new Error((0,d.localize)(3,null,G))}}}async uninstallShellCommand(T){const{source:G}=await this.w();try{await m.Promises.unlink(G)}catch(K){switch(K.code){case"EACCES":{const{response:le}=await this.showMessageBox(T,{type:"info",message:(0,d.localize)(4,null,this.j.nameShort),buttons:[(0,d.localize)(5,null),(0,d.localize)(6,null)]});if(le===1)throw new C.$5;try{const re=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(re)}catch{throw new Error((0,d.localize)(7,null,G))}break}case"ENOENT":break;default:throw K}}}async w(){const T=(0,y.$kc)(this.g.appRoot,"bin","code"),G=`/usr/local/bin/${this.j.applicationName}`;if(!await m.Promises.exists(T))throw new Error((0,d.localize)(8,null,T));return{source:G,target:T}}async showMessageBox(T,G){const K=this.H(T);return this.c.showMessageBox(G,K?.win??void 0)}async showSaveDialog(T,G){const K=this.H(T);return this.c.showSaveDialog(G,K?.win??void 0)}async showOpenDialog(T,G){const K=this.H(T);return this.c.showOpenDialog(G,K?.win??void 0)}async pickFileFolderAndOpen(T,G){const K=await this.c.pickFileFolder(G);K&&await this.z(await Promise.all(K.map(async le=>await m.SymlinkSupport.existsDirectory(le)?{folderUri:p.URI.file(le)}:{fileUri:p.URI.file(le)})),G,T)}async pickFolderAndOpen(T,G){const K=await this.c.pickFolder(G);K&&await this.z(K.map(le=>({folderUri:p.URI.file(le)})),G,T)}async pickFileAndOpen(T,G){const K=await this.c.pickFile(G);K&&await this.z(K.map(le=>({fileUri:p.URI.file(le)})),G,T)}async pickWorkspaceAndOpen(T,G){const K=await this.c.pickWorkspace(G);K&&await this.z(K.map(le=>({workspaceUri:p.URI.file(le)})),G,T)}async z(T,G,K){await this.a.open({context:3,contextWindowId:K,cli:this.g.args,urisToOpen:T,forceNewWindow:G.forceNewWindow})}async showItemInFolder(T,G){R.shell.showItemInFolder(G)}async setRepresentedFilename(T,G,K){this.D(K?.targetWindowId,T)?.setRepresentedFilename(G)}async setDocumentEdited(T,G,K){this.D(K?.targetWindowId,T)?.setDocumentEdited(G)}async openExternal(T,G){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(G),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(T,G){return R.shell.trashItem(G)}async isAdmin(){let T;return k.$i?T=(await new Promise((G,K)=>{Q(["native-is-elevated"],G,K)}))():T=process.getuid?.()===0,T}async writeElevated(T,G,K,le){const re=await new Promise((ue,Y)=>{Q(["@vscode/sudo-prompt"],ue,Y)});return new Promise((ue,Y)=>{const Z=[`"${this.C}"`];le?.unlock&&Z.push("--file-chmod"),Z.push("--file-write",`"${G.fsPath}"`,`"${K.fsPath}"`);const H={name:this.j.nameLong.replace("-",""),icns:k.$j&&this.g.isBuilt?(0,y.$jc)((0,y.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(Z.join(" "),H,(L,U,V)=>{U&&this.h.trace(`[sudo-prompt] received stdout: ${U}`),V&&this.h.trace(`[sudo-prompt] received stderr: ${V}`),L?Y(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return k.$k||k.$i?!1:R.app.runningUnderARM64Translation}get C(){return k.$i?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.bat"):k.$k?this.g.isBuilt?(0,y.$jc)((0,y.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,y.$jc)(this.g.appRoot,"bin","code"):(0,y.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return b.$8m.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return k.$i&&(0,A.$w0b)()}async killProcess(T,G,K){process.kill(G,K)}async readClipboardText(T,G){return R.clipboard.readText(G)}async writeClipboardText(T,G,K){return R.clipboard.writeText(G,K)}async readClipboardFindText(T){return R.clipboard.readFindText()}async writeClipboardFindText(T,G){return R.clipboard.writeFindText(G)}async writeClipboardBuffer(T,G,K,le){return R.clipboard.writeBuffer(G,Buffer.from(K.buffer),le)}async readClipboardBuffer(T,G){return w.$he.wrap(R.clipboard.readBuffer(G))}async hasClipboard(T,G,K){return R.clipboard.has(G,K)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(T,G){this.F(T)?.updateTouchBar(G)}async notifyReady(T){this.F(T)?.setReady()}async relaunch(T,G){return this.f.relaunch(G)}async reload(T,G){const K=this.F(T);if(K){if((0,n.$gi)(K.openedWorkspace)){const le=K.openedWorkspace.configPath;if(le.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(le))?.transient)return this.openWindow(K.id,{forceReuseWindow:!0})}return this.f.reload(K,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(T,G){return this.D(G?.targetWindowId,T)?.win?.close()}async quit(T){const G=this.a.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&G.win?G.win.close():this.f.quit()}async exit(T,G){await this.f.kill(G)}async resolveProxy(T,G){return this.F(T)?.win?.webContents?.session?.resolveProxy(G)}async loadCertificates(T){return(await new Promise((K,le)=>{Q(["@vscode/proxy-agent"],K,le)})).loadSystemCertificates({log:this.h})}findFreePort(T,G,K,le,re=1){return(0,$.$qg)(G,K,le,re)}async openDevTools(T,G){this.H(T)?.win?.webContents.openDevTools(G)}async toggleDevTools(T){this.H(T)?.win?.webContents.toggleDevTools()}async profileRenderer(T,G,K){const le=this.F(T);if(!le||!le.win)throw new Error;return await new I.$x0b(le.win,G,this.h).inspect(K)}async windowsGetStringRegKey(T,G,K,le){if(!k.$i)return;const re=await new Promise((ue,Y)=>{Q(["@vscode/windows-registry"],ue,Y)});try{return re.GetStringRegKey(G,K,le)}catch{return}}D(T,G){return this.F(T)??this.G(T)??this.F(G)}F(T){if(typeof T=="number")return this.a.getWindowById(T)}G(T){if(typeof T=="number")return this.b.getWindowById(T)}H(T){let G=this.r.invokeFunction(i.$O9b);return G||(G=this.D(T)),G}};e.$z0b=j,Ee([D.$vh],j.prototype,"C",null),e.$z0b=j=Ee([ne(0,i.$M9b),ne(1,E.$K9b),ne(2,h.$F9b),ne(3,u.$79b),ne(4,g.$z9b),ne(5,t.$lj),ne(6,o.$Dj),ne(7,r.$I9b),ne(8,a.$Z9b),ne(9,v.$3h)],j)}),define(oe[299],ae([0,1,15,26,8,22,33,2,13,4,7,107,36,180,91,132,54,24,5,71,79,27,80,34,61,60,29]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$A0b=void 0;const w="issue.processExplorerWindowState";let A=class{static{a=this}static{this.a="#1E1E1E"}constructor(C,j,W,T,G,K,le,re,ue,Y,Z){this.g=C,this.h=j,this.i=W,this.j=T,this.k=G,this.l=K,this.m=le,this.n=re,this.o=ue,this.p=Y,this.q=Z,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){p.$pU.on("vscode:listProcesses",async C=>{const j=[];try{j.push({name:(0,c.localize)(0,null),rootProcess:await(0,k.$Tr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(T=>{(0,b.$Hm)(T)?j.push({name:T.hostName,rootProcess:T}):T.processes&&j.push({name:T.hostName,rootProcess:T.processes})})}catch(W){this.i.error(`Listing processes failed: ${W}`)}this.t(C,"vscode:listProcessesResponse",j)}),p.$pU.on("vscode:workbenchCommand",(C,j)=>{const{id:W,from:T,args:G}=j;let K;switch(T){case"processExplorer":K=this.f;break;default:throw new Error(`Unexpected command source: ${T}`)}K?.webContents.send("vscode:runAction",{id:W,from:T,args:G})}),p.$pU.on("vscode:closeProcessExplorer",C=>{this.d?.close()}),p.$pU.on("vscode:pidToNameRequest",async C=>{const j=await this.k.getMainDiagnostics(),W=[];for(const T of j.windows)W.push([T.pid,`window [${T.id}] (${T.title})`]);for(const{pid:T,name:G}of r.$h0b.getAll())W.push([T,G]);this.t(C,"vscode:pidToNameResponse",W)})}async openReporter(C){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const j=new S.$Sc,W=j.add(this.n.createIPCObjectUrl()),T=this.v(this.c,700,800);this.b=this.u(T,W,{backgroundColor:C.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:C.zoomLevel,alwaysOnTop:!1},"issue-reporter"),W.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:C,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:v.default}),this.b.loadURL(f.$mg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,j.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,j.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(C){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const j=new S.$Sc,W=j.add(this.n.createIPCObjectUrl()),T=this.p.getItem(w,void 0),G=I(T)?T:this.v(this.f,800,500);this.d=this.u(G,W,{backgroundColor:C.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:C.zoomLevel,alwaysOnTop:!0},"process-explorer"),W.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:C,product:v.default}),this.d.loadURL(f.$mg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,j.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,j.dispose())});const K=()=>{if(!this.d)return;const le=this.d.getSize(),re=this.d.getPosition();if(!le||!re)return;const ue={width:le[0],height:le[1],x:re[0],y:re[1]};this.p.setItem(w,ue)};this.d.on("moved",K),this.d.on("resized",K)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const C=await P.contentTracing.stopRecording(`${(0,D.$bg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,C),buttons:[(0,c.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,C)}async getSystemStatus(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(C,j)}async $getSystemInfo(){const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(C,j)}async $getPerformanceInfo(){try{const[C,j]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(C,j)}catch(C){throw this.i.warn("issueService#getPerformanceInfo ",C.message),C}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(C){this.i.error(C)}}async $showConfirmCloseDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);C===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:C}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return C===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const C=this.q.getWindowById(this.c.id);if(!C)throw new Error("Window not found");return C}async $getIssueReporterUri(C){const j=this.issueReporterWindowCheck(),W=`vscode:triggerIssueUriRequestHandlerResponse${j.id}`;return s.Promises.withAsyncBody(async(T,G)=>{const K=new M.$4d;j.sendWhenReady("vscode:triggerIssueUriRequestHandler",K.token,{replyChannel:W,extensionId:C}),p.$pU.once(W,(le,re)=>{T(y.URI.parse(re))});try{await(0,s.$5g)(5e3),K.cancel(),G(new Error("Timed out waiting for issue reporter URI"))}finally{p.$pU.removeHandler(W)}})}async $getIssueReporterData(C){const j=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataProviderResponse${j.id}`;return s.Promises.withAsyncBody(async T=>{const G=new M.$4d;j.sendWhenReady("vscode:triggerIssueDataProvider",G.token,{replyChannel:W,extensionId:C}),p.$pU.once(W,(K,le)=>{T(le)});try{await(0,s.$5g)(5e3),G.cancel(),T("Error: Extension timed out waiting for issue reporter data")}finally{p.$pU.removeHandler(W)}})}async $getIssueReporterTemplate(C){const j=this.issueReporterWindowCheck(),W=`vscode:triggerIssueDataTemplateResponse${j.id}`;return s.Promises.withAsyncBody(async T=>{const G=new M.$4d;j.sendWhenReady("vscode:triggerIssueDataTemplate",G.token,{replyChannel:W,extensionId:C}),p.$pU.once(W,(K,le)=>{T(le)});try{await(0,s.$5g)(5e3),G.cancel(),T("Error: Extension timed out waiting for issue reporter template")}finally{p.$pU.removeHandler(W)}})}async $getReporterStatus(C,j){const W=[!1,!1],T=this.issueReporterWindowCheck(),G="vscode:triggerReporterStatus",K=new M.$4d;return T.sendWhenReady(G,K.token,{replyChannel:G,extensionId:C,extensionName:j}),await(0,s.$Vg)(new Promise(re=>p.$pU.once("vscode:triggerReporterStatusResponse",(ue,Y)=>re(Y))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),K.cancel()})??W}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(C){C.isMinimized()&&C.restore(),C.focus()}t(C,j,...W){C.sender.isDestroyed()||C.sender.send(j,...W)}u(C,j,W,T){const G=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:C.width,height:C.height,minWidth:300,minHeight:200,x:C.x,y:C.y,title:W.title,backgroundColor:W.backgroundColor||a.a,webPreferences:{preload:f.$mg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${j.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$MC)(W.zoomLevel),sandbox:!0},alwaysOnTop:W.alwaysOnTop,experimentalDarkMode:!0});return G.setMenuBarVisibility(!1),G}v(C,j,W){let T;const G=P.screen.getAllDisplays();if(G.length===1)T=G[0];else{if(l.$j){const re=P.screen.getCursorScreenPoint();T=P.screen.getDisplayNearestPoint(re)}!T&&C&&(T=P.screen.getDisplayMatching(C.getBounds())),T||(T=P.screen.getPrimaryDisplay()||G[0])}const K=T.bounds,le={width:j,height:W,x:K.x+K.width/2-j/2,y:K.y+K.height/2-W/2};return K.width>0&&K.height>0&&(le.x<K.x&&(le.x=K.x),le.y<K.y&&(le.y=K.y),le.x>K.x+K.width&&(le.x=K.x),le.y>K.y+K.height&&(le.y=K.y),le.width>K.width&&(le.width=K.width),le.height>K.height&&(le.height=K.height)),le}};e.$A0b=A,e.$A0b=A=a=Ee([ne(1,d.$z9b),ne(2,h.$lj),ne(3,b.$Gm),ne(4,m.$k0b),ne(5,$.$F9b),ne(6,g.$y0b),ne(7,t.$H9b),ne(8,u.$Dj),ne(9,o.$cO),ne(10,n.$M9b)],A);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(oe[300],ae([0,1,22,17,24,20,5,71,27,52,28,49,100]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=void 0;let c=class extends p.$Z0b{constructor(m,$,d,h,g,v,u,t){super(m,$,h,g,v,t),this.e=d,this.u=u}s(m){return(0,p.$Y0b)(`linux-${process.arch}`,m,this.k)}t(m){this.a&&(this.d(k.$nV.CheckingForUpdates(m)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$cp).then($=>{!$||!$.url||!$.version||!$.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!m}),this.d(k.$nV.Idle(1))):this.d(k.$nV.AvailableForDownload($))}).then(void 0,$=>{this.j.error($);const d=m?$.message||$:void 0;this.d(k.$nV.Idle(1,d))}))}async o(m){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):m.update.url&&this.u.openExternal(void 0,m.update.url),this.d(k.$nV.Idle(1))}};e.$20b=c,e.$20b=c=Ee([ne(0,M.$79b),ne(1,R.$xi),ne(2,y.$sl),ne(3,s.$z9b),ne(4,l.$9o),ne(5,D.$lj),ne(6,S.$y0b),ne(7,f.$Dj)],c)}),define(oe[301],ae([0,1,48,46,26,8,22,50,45,9,7,144,21,17,24,16,20,5,71,27,52,28,49,100]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=void 0;async function r(w,A=1e3){for(;!w();)await(0,M.$5g)(A)}let i;function n(){return typeof i>"u"&&(i=R.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let a=class extends o.$Z0b{get cachePath(){const A=l.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return p.Promises.mkdir(A,{recursive:!0}).then(()=>A)}constructor(A,I,E,C,j,W,T,G,K){super(A,I,C,j,W,K),this.u=E,this.v=T,this.w=G,A.setRelaunchHandler(this)}handleRelaunch(A){return A?.addArgs||A?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$nV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(A){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$Y0b)(I,A,this.k)}t(A){this.a&&(this.d(t.$nV.CheckingForUpdates(A)),this.i.request({url:this.a},D.CancellationToken.None).then(v.$cp).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!A}),this.d(t.$nV.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$nV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$nV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>p.Promises.exists(C).then(j=>{if(j)return Promise.resolve(C);const W=`${C}.tmp`;return this.i.request({url:I.url},D.CancellationToken.None).then(T=>this.v.writeFile(y.URI.file(W),T.stream)).then(I.sha256hash?()=>(0,k.$kU)(W,I.sha256hash):()=>{}).then(()=>p.Promises.rename(W,C,!1)).then(()=>C)})).then(C=>{const j=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},j?this.k.target==="user"?this.p():this.d(t.$nV.Downloaded(I)):this.d(t.$nV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,f.$Ri)(String(I)))}),this.j.error(I);const E=A?I.message||I:void 0;this.d(t.$nV.Idle(n(),E))}))}async o(A){A.update.url&&this.w.openExternal(void 0,A.update.url),this.d(t.$nV.Idle(n()))}async B(A){const I=await this.cachePath;return l.$jc(I,`CodeSetup-${this.k.quality}-${A}.exe`)}async C(A=null){const I=A?W=>!new RegExp(`${this.k.quality}-${A}\\.exe$`).test(W):()=>!0,E=await this.cachePath,j=(await p.Promises.readdir(E)).filter(I).map(async W=>{try{await p.Promises.unlink(l.$jc(E,W))}catch{}});await Promise.all(j)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const A=this.state.update;this.d(t.$nV.Updating(A));const I=await this.cachePath;this.e.updateFilePath=l.$jc(I,`CodeSetup-${this.k.quality}-${A.version}.flag`),await p.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$nV.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,j=await new Promise((W,T)=>{Q(["@vscode/windows-mutex"],W,T)});r(()=>j.isActive(C)).then(()=>this.d(t.$nV.Ready(A)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(A){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$nV.Downloading(E)),this.e={packagePath:A},I?this.k.target==="user"?this.p():this.d(t.$nV.Downloaded(E)):this.d(t.$nV.Ready(E))}};e.$40b=a,Ee([S.$vh],a.prototype,"cachePath",null),e.$40b=a=Ee([ne(0,$.$79b),ne(1,c.$xi),ne(2,u.$sl),ne(3,b.$z9b),ne(4,v.$9o),ne(5,d.$lj),ne(6,m.$ok),ne(7,h.$y0b),ne(8,g.$Dj)],a)}),define(oe[133],ae([0,1,15,8,22,51,3,2,13,68,4,7,190,26,66,17,54,24,64,16,20,5,27,80,252,82,28,102,70,60,29,30,56,128,39,34,55,69,23,6]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C,j,W,T,G,K,le,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=e.$49b=void 0;var ue;(function(H){H[H.NONE=0]="NONE",H[H.NAVIGATING=1]="NAVIGATING",H[H.READY=2]="READY"})(ue||(ue={}));class Y extends S.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(D.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(D.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const U=(0,A.$JC)(this.r)==="custom";if(y.$j&&U&&L.setSheetOffset((0,y.$J)((0,c.release)())?28:22),U&&(y.$i&&(0,A.$KC)(this.r)||y.$j)){const V=this.s.getItem(Y.z);V&&this.updateWindowControls({height:V})}y.$i&&U&&L.hookWindowMessage(278,()=>{const[q,te]=L.getPosition(),he=P.screen.getCursorScreenPoint(),J=he.x-q,O=he.y-te;return(()=>!(J>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35)))()||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:J,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools()}constructor(L,U,V){super(),this.r=L,this.s=U,this.t=V,this.a=this.B(new D.$Td),this.onDidClose=this.a.event,this.b=this.B(new D.$Td),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Td),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Td),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Td),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new D.$Td),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.C=(0,A.$KC)(this.r),this.D=void 0,this.F=void 0}setRepresentedFilename(L){y.$j?this.win?.setRepresentedFilename(L):this.u=L}getRepresentedFilename(){return y.$j?this.win?.getRepresentedFilename():this.u}setDocumentEdited(L){y.$j&&this.win?.setDocumentEdited(L),this.w=L}isDocumentEdited(){return y.$j?!!this.win?.isDocumentEdited():!!this.w}focus(L){y.$j&&L?.force&&P.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(y.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.z="windowControlHeight"}updateWindowControls(L){const U=this.win;if(U){if(L.height&&this.s.setItem(Z.z,L.height),y.$i&&this.C)U.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(y.$j&&L.height!==void 0){const V=(L.height-15)/2;V?U.setWindowButtonPosition({x:V,y:V}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.G(!this.isFullScreen)}G(L){(0,A.$LC)(this.r)?this.H(L):this.J(L)}get isFullScreen(){if(y.$j&&typeof this.D=="boolean")return this.D;const L=this.win,U=L?.isFullScreen(),V=L?.isSimpleFullScreen();return!!(U||V)}H(L){const U=this.win;U?.isSimpleFullScreen()&&U?.setSimpleFullScreen(!1),this.I(L)}I(L){y.$j&&(this.D=L,this.F=new R.$oh,Promise.race([this.F.p,(0,R.$5g)(1e4)]).finally(()=>{this.D=void 0})),this.win?.setFullScreen(L)}J(L){const U=this.win;U?.isFullScreen()&&this.I(!1),U?.setSimpleFullScreen(L),U?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$49b=Y;let Z=class extends Y{get id(){return this.O}get backupPath(){return this.Q?.backupPath}get openedWorkspace(){return this.Q?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$fi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.Q?.remoteAuthority}get config(){return this.Q}get isExtensionDevelopmentHost(){return!!this.Q?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.Q?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.Q?.debugId}constructor(L,U,V,q,te,he,J,O,F,x,z,X,N,B,_,ce,se,$e,me,ye,Pe){super(x,ye,q),this.db=U,this.eb=V,this.fb=te,this.gb=he,this.hb=J,this.ib=O,this.jb=F,this.kb=z,this.lb=X,this.mb=N,this.nb=B,this.ob=_,this.pb=ce,this.qb=se,this.rb=$e,this.sb=me,this.L=this.B(new D.$Td),this.onWillLoad=this.L.event,this.M=this.B(new D.$Td),this.onDidSignalReady=this.M.event,this.N=this.B(new D.$Td),this.onDidDestroy=this.N.event,this.U=[],this.W=[],this.X=void 0,this.Y=void 0,this.Z=void 0,this.$=this.B(this.rb.createIPCObjectUrl()),this.bb=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.R=Le,this.db.trace("window#ctor: using window state",Le);const pe=this.R.mode===0||this.R.mode===3,ee=Pe.invokeFunction(I.$N9b,this.R,{show:!pe,webPreferences:{preload:f.$mg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.$.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(ee),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.O=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),ge=y.$j&&fe?.nativeTabs===!0;(y.$j||y.$i)&&ke&&(!ge||P.BrowserWindow.getAllWindows().length===1)&&[this.R.width,this.R.height,this.R.x,this.R.y].every(Ie=>typeof Ie=="number")&&this.m.setBounds({width:this.R.width,height:this.R.height,x:this.R.x,y:this.R.y}),pe&&((0,l.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.R.mode===3&&this.G(!0),this.m.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Lb(),this.ub()}setReady(){for(this.db.trace(`window#load: window reported ready (id: ${this.O})`),this.tb=2;this.U.length;)this.U.pop()(this);this.M.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.U.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function U(){V.dispose(),q.dispose(),L()}const V=this.onDidClose(()=>U()),q=this.onWillLoad(()=>U())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(U,V)=>this.xb(2,{...V})),this.m.webContents.on("did-fail-load",(U,V,q)=>this.xb(3,{reason:q,exitCode:V})),this.m.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.ab&&(this.Q=this.ab,this.ab=void 0)}),this.B(this.onDidMaximize(()=>{this.Q&&(this.Q.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.Q&&(this.Q.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.r.onDidChangeConfiguration(U=>this.Ab(U))),this.B(this.lb.onDidDeleteUntitledWorkspace(U=>this.zb(U)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(U,V)=>{const q=await this.wb();V({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$qp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,U){switch(L){case 2:this.db.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.db.error("CodeWindow: detected unresponsive");break;case 3:this.db.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:U?.reason,code:U?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,p.localize)(0,null),(0,p.localize)(1,null),(0,p.localize)(2,null)],message:(0,p.localize)(3,null),detail:(0,p.localize)(4,null),checkboxLabel:this.Q?.workspace?(0,p.localize)(5,null):void 0},this.m);if(V!==2){const te=V===0;await this.yb(te,q)}}else if(L===2){let V;U?V=(0,p.localize)(7,null,U.reason,U.exitCode??"<unknown>"):V=(0,p.localize)(6,null);const{response:q,checkboxChecked:te}=await this.ob.showMessageBox({type:"warning",buttons:[this.Q?.workspace?(0,p.localize)(8,null):(0,p.localize)(9,null),(0,p.localize)(10,null)],message:V,detail:this.Q?.workspace?(0,p.localize)(11,null):(0,p.localize)(12,null),checkboxLabel:this.Q?.workspace?(0,p.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,te)}break}}async yb(L,U){const V=this.Q?.workspace;if(U&&V)try{const q=this.jb.workspaceStorage(V);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.db.error(q)}this.N.fire();try{if(L&&this.Q){let q,te;(0,E.$bi)(V)?q={folderUri:V.uri}:(0,E.$gi)(V)?q={workspaceUri:V.configPath}:te=!0,(0,le.$Ob)(await this.sb.open({context:5,userEnv:this.Q.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:te,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.Q?.workspace?.id===L.id&&(this.Q.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const U=this.Hb();U!==this.S&&(this.S=U,this.Ib(U))}if(!L||L.affectsConfiguration("http.proxy")){let U=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.X||V!==this.Y)){this.X=U,this.Y=V;const q=U||"",te=V?`${V},<local>`:"<local>";this.db.trace(`Setting proxy to '${q}', bypassing '${te}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:te,pacScript:""})}}}addTabbedWindow(L){y.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,U=Object.create(null)){this.db.trace(`window#load: attempt to load window (id: ${this.O})`),this.isDocumentEdited()&&(!U.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,U),this.tb===0?this.Q=L:this.ab=L,this.tb=1,this.m.loadURL(f.$mg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.bb;this.bb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$dh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.L.fire({workspace:L.workspace,reason:U.isReload?3:V?2:1})}Bb(L,U){const V=(this.Q??this.ab)?.userEnv;if(V){const q=(0,h.$4l)(V)&&!(0,h.$4l)(L.userEnv),te=this.isExtensionDevelopmentHost;(q||te)&&(L.userEnv={...V,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(L["disable-extensions"]=U.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Kb(),L.isCustomZoomLevel=typeof this.Z=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.$.update(L)}async reload(L){const U=Object.assign({},this.Q);U.workspace=await this.Cb(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&L&&(U.verbose=L.verbose,U.debugId=L.debugId,U.extensionEnvironment=L.extensionEnvironment,U["inspect-extensions"]=L["inspect-extensions"],U["inspect-brk-extensions"]=L["inspect-brk-extensions"],U["extensions-dir"]=L["extensions-dir"]),U.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.fb.serialize(),U.continueOn=this.t.continueOn,U.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},U.logLevel=this.eb.getLogLevel(),U.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$gi)(L.workspace)){const U=L.workspace.configPath;if(U.scheme===f.Schemas.file&&!await this.hb.exists(U))return}else if((0,E.$bi)(L.workspace)){const U=L.workspace.uri;if(U.scheme===f.Schemas.file&&!await this.hb.exists(U))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,j.$y9b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,j.$y9b)();return{mode:3,display:V?V.id:void 0,width:this.R.width||q.width,height:this.R.height||q.height,x:this.R.x||0,y:this.R.y||0,zoomLevel:this.Z}}const L=Object.create(null);let U;if(!y.$j&&this.m.isMaximized()?U=0:U=1,U===0?L.mode=0:L.mode=1,U===1||U===0){let V;U===1?V=this.getBounds():V=this.m.getNormalBounds(),L.x=V.x,L.y=V.y,L.width=V.width,L.height=V.height}return L.zoomLevel=this.Z,L}Db(L){(0,l.mark)("code/willRestoreCodeWindowState");let U=!1;if(L){this.Z=L.zoomLevel;try{const V=P.screen.getAllDisplays();U=V.length>1,L=this.Eb(L,V)}catch(V){this.db.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,j.$y9b)(),U]}Eb(L,U){if(this.db.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.db.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.db.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const te=this.Fb(U[0]);if(te){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!te||(L.x<te.x&&(L.x=te.x),L.y<te.y&&(L.y=te.y))};this.db.trace("window#validateWindowState: 1 monitor working area",te),he(),L.width>te.width&&(L.width=te.width),L.height>te.height&&(L.height=te.height),L.x>te.x+te.width-128&&(L.x=te.x+te.width-L.width),L.y>te.y+te.height-128&&(L.y=te.y+te.height-L.height),he()}return L}if(L.display&&L.mode===3){const te=U.find(he=>he.id===L.display);if(te&&typeof te.bounds?.x=="number"&&typeof te.bounds?.y=="number"){this.db.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,j.$y9b)(3);return he.x=te.bounds.x,he.y=te.bounds.y,he}}let V,q;try{V=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),q=this.Fb(V)}catch{}if(V&&q&&L.x+L.width>q.x&&L.y+L.height>q.y&&L.x<q.x+q.width&&L.y<q.y+q.height)return this.db.trace("window#validateWindowState: multi-monitor working area",q),L}Fb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,U]=this.m.getPosition(),[V,q]=this.m.getSize();return{x:L,y:U,width:V,height:q}}G(L){super.G(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.S&&this.Ib(this.S,!1)}Hb(){let L=(0,A.$IC)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Ib(L,U=!0){y.$j||(L==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,p.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Jb(L)}):this.Jb(L))}Jb(L){const U=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.Z=L}Kb(){return typeof this.Z=="number"?this.Z:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,U,...V){this.isReady?this.send(L,...V):this.ready().then(()=>{U.isCancellationRequested||this.send(L,...V)})}send(L,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.db.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...U)}catch(V){this.db.warn(`Error sending IPC message to channel '${L}' of window ${this.O}: ${(0,M.$Oi)(V)}`)}}}updateTouchBar(L){y.$j&&this.W.forEach((U,V)=>{const q=L[V];U.segments=this.Nb(q)})}Lb(){if(y.$j){for(let L=0;L<10;L++){const U=this.Mb();this.W.push(U)}this.m.setTouchBar(new P.TouchBar({items:this.W}))}}Mb(L=[]){const U=this.Nb(L),V=new P.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[q].id,from:"touchbar"})}});return V}Nb(L=[]){return L.map(V=>{let q;V.icon&&!a.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===f.Schemas.file&&(q=P.nativeImage.createFromPath(k.URI.revive(V.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let te;return typeof V.title=="string"?te=V.title:te=V.title.value,{id:V.id,label:q?void 0:te,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$59b=Z,e.$59b=Z=Ee([ne(1,u.$lj),ne(2,K.$29b),ne(3,d.$z9b),ne(4,W.$yn),ne(5,G.$Q9b),ne(6,g.$ok),ne(7,i.$c0b),ne(8,i.$a0b),ne(9,m.$xi),ne(10,w.$I9b),ne(11,C.$Z9b),ne(12,b.$E9b),ne(13,n.$sl),ne(14,$.$F9b),ne(15,v.$79b),ne(16,t.$Dj),ne(17,o.$H9b),ne(18,I.$M9b),ne(19,T.$cO),ne(20,re.$3h)],Z)}),define(oe[302],ae([0,1,15,17,24,20,5,34,133]),function(Q,e,P,R,s,M,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$69b=void 0;let l=class extends f.$49b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(k,p,c,b,m,$){super(b,m,p),this.L=k,this.M=c,this.N=$,this.id=this.L.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.L.isDestroyed())return;const k=P.BrowserWindow.fromWebContents(this.L);k&&(this.M.trace("[aux window] Claimed browser window instance"),this.n(k),k.setMenu(null),this.N.registerAuxWindow(this))}};e.$69b=l,e.$69b=l=Ee([ne(1,s.$z9b),ne(2,D.$lj),ne(3,R.$xi),ne(4,S.$cO),ne(5,M.$79b)],l)}),define(oe[303],ae([0,1,15,3,2,13,36,302,6,5,29]),function(Q,e,P,R,s,M,D,S,f,l,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=void 0;let k=class extends s.$Tc{constructor(c,b){super(),this.h=c,this.j=b,this.a=this.B(new R.$Td),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$Td),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$Td),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$Td),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){P.app.on("browser-window-created",(c,b)=>{const m=this.getWindowById(b.id);m&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),m.tryClaimWindow())}),D.$pU.handle("vscode:registerAuxiliaryWindow",async(c,b)=>{const m=this.getWindowById(c.sender.id);return m&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),m.parentId=b),c.sender.id})}createWindow(){return this.h.invokeFunction(y.$N9b,void 0,{webPreferences:{preload:M.$mg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(c){const b=new s.$Sc,m=this.h.createInstance(S.$69b,c);this.g.set(m.id,m),b.add((0,s.$Rc)(()=>this.g.delete(m.id))),b.add(m.onDidMaximize(()=>this.a.fire(m))),b.add(m.onDidUnmaximize(()=>this.b.fire(m))),b.add(m.onDidEnterFullScreen(()=>this.c.fire(m))),b.add(m.onDidLeaveFullScreen(()=>this.c.fire(m))),b.add(m.onDidTriggerSystemContextMenu(({x:$,y:d})=>this.f.fire({window:m,x:$,y:d}))),R.Event.once(m.onDidClose)(()=>b.dispose())}getWindowById(c){return this.g.get(c)}getFocusedWindow(){const c=P.BrowserWindow.getFocusedWindow();if(c)return this.getWindowById(c.id)}getLastActiveWindow(){return(0,y.$P9b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$w$b=k,e.$w$b=k=Ee([ne(0,f.$3h),ne(1,l.$lj)],k)}),define(oe[83],ae([0,1,15,23,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,56,31,54]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$L0b=e.$K0b=void 0,e.$K0b=(0,b.$4h)("workspacesHistoryMainService");let r=class extends S.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,a,w,A,I){super(),this.f=n,this.g=a,this.h=w,this.j=A,this.m=I,this.c=this.B(new M.$Td),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$2g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],w=[];for(const I of n)if((0,h.$kcb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(a,I.workspace)&&a.push(I);else if((0,h.$lcb)(I))this.y(a,I.folderUri)||a.push(I);else{const E=this.z(w,I.fileUri),C=I.fileUri.scheme===f.Schemas.file&&o.G.indexOf((0,y.$Cg)(I.fileUri))>=0;!E&&!C&&(w.push(I),l.$i&&I.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const A=await this.r({workspaces:a,files:w});a=A.workspaces,w=A.files,a.length>o.a&&(a.length=o.a),w.length>o.a&&(w.length=o.a),await this.t({workspaces:a,files:w}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const a=E=>{const C=this.u(E);for(const j of n)if(y.$wg.isEqual(j,C))return!1;return!0},w=await this.getRecentlyOpened(),A=w.workspaces.filter(a),I=w.files.filter(a);(A.length!==w.workspaces.length||I.length!==w.files.length)&&(await this.t({files:I,workspaces:A}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:a}=await this.m.showMessageBox({type:"warning",buttons:[(0,c.localize)(0,null),(0,c.localize)(1,null)],message:(0,c.localize)(2,null),detail:(0,c.localize)(3,null),cancelId:1});if(a!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const a=new u.$Ac(I=>y.$wg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)a.set(this.u(I),I);const w=new u.$Ac(I=>y.$wg.getComparisonKey(I));if(n?.files)for(const I of n.files)w.set(this.u(I),I);const A=await this.s();for(const I of A.workspaces){const E=a.get(this.u(I));E?E.label=E.label??I.label:a.set(this.u(I),I)}for(const I of A.files){const E=w.get(this.u(I));E?E.label=E.label??I.label:w.set(this.u(I),I)}return{workspaces:[...a.values()],files:[...w.values()]}}async s(){await this.j.whenReady;let n;const a=this.j.get(o.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(w){this.f.error("Unexpected error parsing opened paths list",w)}return(0,h.$rcb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,h.$scb)(n)),-1,1)}u(n){return(0,h.$lcb)(n)?n.folderUri:(0,h.$mcb)(n)?n.fileUri:n.workspace.configPath}w(n,a){return!!n.find(w=>(0,h.$kcb)(w)&&w.workspace.id===a.id)}y(n,a){return!!n.find(w=>(0,h.$lcb)(w)&&y.$wg.isEqual(w.folderUri,a))}z(n,a){return!!n.find(w=>y.$wg.isEqual(w.fileUri,a))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,c.localize)(4,null),description:(0,c.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const I of P.app.getJumpListSettings().removedItems){const E=I.args;if(E){const C=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);C&&a.push(k.URI.parse(C[2]))}}await this.removeRecentlyOpened(a);let w=!1;const A=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,h.$kcb)(I)?I.workspace:I.folderUri,{title:C,description:j}=this.L(E,I.label);let W;return k.URI.isUri(E)?W=`--folder-uri "${E.toString()}"`:(w=!0,W=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:C.substr(0,255),description:j.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));A.length>0&&n.push({type:"custom",name:w?(0,c.localize)(6,null):(0,c.localize)(7,null),items:A})}n.push({type:"recent"});try{const a=P.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}L(n,a){if(a)return{title:(0,D.$Uv)(a).name,description:a};if(k.URI.isUri(n))return{title:(0,y.$Cg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,c.localize)(8,null),description:""};let w=(0,y.$Cg)(n.configPath);return w.endsWith(g.$ni)&&(w=w.substr(0,w.length-g.$ni.length-1)),{title:(0,c.localize)(9,null,w),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Mv)(n.fsPath):n.toString()}async N(){if(!l.$j)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let w=0;for(let I=0;I<n.workspaces.length&&w<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===f.Schemas.file){const C=(0,y.$tg)(E);await p.Promises.exists(C)&&(a.push(C),w++)}}const A=[];for(let I=0;I<n.files.length&&w<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===f.Schemas.file){const C=(0,y.$tg)(E);if(o.G.includes((0,y.$Cg)(E))||a.includes(C))continue;await p.Promises.exists(C)&&(A.push(C),w++)}}A.reverse().forEach(I=>P.app.addRecentDocument(I)),a.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$L0b=r,e.$L0b=r=o=Ee([ne(0,$.$lj),ne(1,v.$Z9b),ne(2,m.$79b),ne(3,d.$c0b),ne(4,t.$F9b)],r)}),define(oe[304],ae([0,1,15,8,22,47,4,7,181,65,17,24,20,5,231,71,27,34,28,49,60,29,83]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(w,A,I,E,C,j,W,T,G,K,le,re){this.n=w,this.o=A,this.p=I,this.q=E,this.r=C,this.s=j,this.t=W,this.u=T,this.v=G,this.w=K,this.x=le,this.y=re,this.m=Object.create(null),this.g=new R.$dh(()=>this.F(),0),this.h=new R.$dh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,v.$JC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const w=this.t.getItem(o.a);w&&(w.menus&&(this.k=w.menus),w.keybindings&&(this.l=w.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(j,W,T)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(j,W,T)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(j,W,T)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(j,W,T)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(j,W,T)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(T),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const w=this.x.youTubeUrl;w&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(w,"openYouTubeUrl"));const A=this.x.requestFeatureUrl;A&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(A,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const j=E.indexOf("?")>0?"&":"?";this.ab(`${E}${j}lang=${D.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const C=this.x.privacyStatementUrl;C&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(C,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(w=>this.G(w)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const w=this.o.getValue("window.enableMenuBarMnemonics");return typeof w!="boolean"?!0:w}get D(){if(!D.$j)return!1;const w=this.o.getValue("window.nativeTabs");return typeof w!="boolean"?!1:w}updateMenu(w,A){this.k=w.menus,this.l=w.keybindings,this.t.setItem(o.a,w),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(w){D.$j&&(w.oldCount===0&&w.newCount>0||w.oldCount>0&&w.newCount===0)&&(this.d=w.newCount===0,this.E())}H(){if(!D.$j)return;const w=P.BrowserWindow.getFocusedWindow();this.f=!w||!!this.y.getWindowById(w.id),this.E()}I(){const w=P.Menu.getApplicationMenu();if(w&&this.j.push(w),Object.keys(this.k).length===0){this.J(D.$j?new P.Menu:null);return}const A=new P.Menu;let I;if(D.$j){const C=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:C}),this.K(C),A.append(I)}if(D.$j&&!this.c){this.c=!0;const C=new P.Menu;C.append(new P.MenuItem({label:this.cb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(C)}if(this.M("File")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(1,null)),submenu:C});this.O(C,"File"),A.append(j)}if(this.M("Edit")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(2,null)),submenu:C});this.O(C,"Edit"),A.append(j)}if(this.M("Selection")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(3,null)),submenu:C});this.O(C,"Selection"),A.append(j)}if(this.M("View")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(4,null)),submenu:C});this.O(C,"View"),A.append(j)}if(this.M("Go")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(5,null)),submenu:C});this.O(C,"Go"),A.append(j)}if(this.M("Run")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(6,null)),submenu:C});this.O(C,"Run"),A.append(j)}if(this.M("Terminal")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(7,null)),submenu:C});this.O(C,"Terminal"),A.append(j)}let E;if(this.M("Window")){const C=new P.Menu;E=new P.MenuItem({label:this.cb(f.localize(8,null)),submenu:C,role:"window"}),this.U(C)}if(E&&A.append(E),this.M("Help")){const C=new P.Menu,j=new P.MenuItem({label:this.cb(f.localize(9,null)),submenu:C,role:"help"});this.O(C,"Help"),A.append(j)}A.items&&A.items.length>0?this.J(A):this.J(null),this.h.schedule()}J(w){if(P.Menu.setApplicationMenu(w),w)for(const A of this.y.getWindows())A.win?.setMenu(null)}K(w){const A=this.W(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const re=new P.Menu;this.O(re,"Preferences"),E=new P.MenuItem({label:this.cb(f.localize(11,null)),submenu:re})}const C=new P.Menu,j=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:C}),W=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),T=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),K=new P.MenuItem(this.$("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(re,ue,Y)=>{const Z=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||Z?.win?.isMinimized())&&await this.L(Y)&&this.w.quit(void 0)}})),le=[A];le.push(...I),E&&le.push(n(),E),le.push(n(),j,n(),W,T,G,n(),K),le.forEach(re=>w.append(re))}async L(w){if(this.p.getWindowCount()===0)return!0;const A=this.o.getValue("window.confirmBeforeClose");if(A==="always"||A==="keyboardOnly"&&this.S(w)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}M(w){if(!D.$j&&(0,v.$JC)(this.o)==="custom")return!1;switch(w){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[w];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[w]}}N(w,A){A.forEach(I=>{if((0,b.$H0b)(I))w.append(n());else if((0,b.$G0b)(I)){const E=new P.Menu,C=new P.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),w.append(C)}else(0,b.$I0b)(I)?w.append(this.Q(I)):(0,b.$J0b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(w),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?w.append(new P.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):w.append(this.W(I.label,I.id,!1,I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):w.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(w,A){this.k&&this.k[A]&&this.N(w,this.k[A].items)}P(w){const A=this.V();A.length&&(A.forEach(I=>w.append(I)),w.append(n()))}Q(w){const A=S.URI.revive(w.uri),I=w.id,E=I==="openRecentFile"?{fileUri:A}:I==="openRecentWorkspace"?{workspaceUri:A}:{folderUri:A};return new P.MenuItem(this.$(I,{label:w.label,click:async(C,j,W)=>{const T=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:T,gotoLineMode:!1,remoteAuthority:w.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([A])}},!1))}R(w){return!!(w&&(!D.$j&&(w.ctrlKey||w.shiftKey)||D.$j&&(w.metaKey||w.altKey)))}S(w){return!!(w.triggeredByAccelerator||w.altKey||w.ctrlKey||w.metaKey||w.shiftKey)}T(w,A,I){const E={label:this.cb(w),role:I,enabled:!0};return new P.MenuItem(this.Z(A,E))}U(w){const A=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),C=this.W(f.localize(23,null),"workbench.action.switchWindow"),j=[];this.D&&(j.push(n()),j.push(this.W(f.localize(24,null),"workbench.action.newWindowTab")),j.push(this.T(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),j.push(this.T(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),j.push(this.T(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),j.push(this.T(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[A,I,n(),C,...j,n(),E].forEach(W=>w.append(W))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(f.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(f.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(f.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(w,A,I,E){const C=this.cb(w),j=typeof A=="function"?A:(le,re,ue)=>{const Y=le?le.userSettingsLabel:null;let Z=A;Array.isArray(A)&&(Z=this.R(ue)?A[1]:A[0]),Y&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Y}):this.Y({type:"commandId",commandId:Z})},W=typeof I=="boolean"?I:this.p.getWindowCount()>0,T=typeof E=="boolean"?E:!1,G={label:C,click:j,enabled:W};T&&(G.type="checkbox",G.checked=T);let K;return typeof A=="string"?K=A:Array.isArray(A)&&(K=A[0]),D.$j&&(K==="editor.action.clipboardCutAction"?G.role="cut":K==="editor.action.clipboardCopyAction"?G.role="copy":K==="editor.action.clipboardPasteAction"&&(G.role="paste"),K==="undo"?G.click=this.X(j,{inDevTools:le=>le.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):K==="redo"?G.click=this.X(j,{inDevTools:le=>le.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):K==="editor.action.selectAll"&&(G.click=this.X(j,{inDevTools:le=>le.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(K,G))}X(w,A){return(I,E,C)=>{const j=P.BrowserWindow.getFocusedWindow();if(!j)return A.inNoWindow();if(j.webContents.isDevToolsFocused()&&j.webContents.devToolsWebContents)return A.inDevTools(j.webContents.devToolsWebContents);w(I,E||j,C)}}Y(w){let A=P.BrowserWindow.getFocusedWindow();if(A){const E=this.y.getWindowById(A.id);E&&(A=this.p.getWindowById(E.parentId)?.win??null)}if(!A){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(A=E.win)}const I=A?this.p.getWindowById(A.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",w),D.$j&&!this.q.isBuilt&&!I.isReady&&(w.type==="commandId"&&w.commandId==="workbench.action.toggleDevTools"||w.type!=="commandId"&&w.userSettingsLabel==="alt+cmd+i"))return!1;if(w.type==="commandId"){const E={id:w.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:w.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",w),!1}Z(w,A){const I=typeof w=="string"?this.l[w]:void 0;if(I?.label){if(I.isNative!==!1)A.accelerator=I.label,A.userSettingsLabel=I.userSettingsLabel;else if(typeof A.label=="string"){const E=A.label.indexOf("[");E>=0?A.label=`${A.label.substr(0,E)} [${I.label}]`:A.label=`${A.label} [${I.label}]`}}else A.accelerator=void 0;return A}$(w,A,I=!A.accelerator){I&&(A=this.Z(w,A));const E=A.click;return A.click=(C,j,W)=>{this.bb(w),E?.(C,j,W)},A}ab(w,A){this.w.openExternal(void 0,w),this.bb(A)}bb(w){this.r.publicLog2("workbenchActionExecuted",{id:w,from:r})}cb(w){return(0,M.$Rv)(w,!this.C)}};e.$M0b=i,e.$M0b=i=o=Ee([ne(0,g.$oV),ne(1,y.$xi),ne(2,u.$M9b),ne(3,k.$z9b),ne(4,h.$sl),ne(5,t.$K0b),ne(6,d.$cO),ne(7,p.$79b),ne(8,c.$lj),ne(9,m.$y0b),ne(10,$.$Dj),ne(11,l.$K9b)],i);function n(){return new P.MenuItem({type:"separator"})}}),define(oe[305],ae([0,1,6,20,5,304]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O0b=e.$N0b=void 0,e.$N0b=(0,P.$4h)("menubarMainService");let D=class{constructor(f,l,y){this.b=f,this.c=l,this.d=y,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$M0b)}async updateMenubar(f,l){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(l,f)}};e.$O0b=D,e.$O0b=D=Ee([ne(0,P.$3h),ne(1,R.$79b),ne(2,s.$lj)],D)}),define(oe[306],ae([0,1,15,21,131,26,23,22,3,33,47,2,13,9,68,4,35,19,12,7,191,66,17,54,24,16,6,20,5,79,80,59,34,60,133,29,130,298,30,98,83,56,70,39,55,69,65]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C,j,W,T,G,K,le,re,ue,Y,Z,H,L,U,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c$b=void 0;function q(J){return(0,le.$gi)(J?.workspace)}function te(J){return(0,le.$bi)(J?.workspace)}let he=class extends k.$Tc{constructor(O,F,x,z,X,N,B,_,ce,se,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge){super(),this.s=O,this.t=F,this.u=x,this.w=z,this.z=X,this.C=N,this.D=B,this.F=_,this.G=ce,this.H=se,this.I=$e,this.J=me,this.L=ye,this.M=Pe,this.N=Le,this.O=ke,this.P=pe,this.Q=ee,this.R=fe,this.S=ge,this.a=this.B(new f.$Td),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Td),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Td),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Td),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Td),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new f.$Td),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new f.$Td),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new f.$Td),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new K.$_0b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const F=new k.$Sc;if(F.add(f.Event.any(O.onDidClose,O.onDidDestroy)(()=>F.dispose())),O.config.extensionDevelopmentPath)for(const x of O.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(x));O.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,F){const x=this.F.args,z=F?.remoteAuthority||void 0,X=!0,N=F?.forceReuseWindow,B=!N;return this.open({...O,cli:x,forceEmpty:X,forceNewWindow:B,forceReuseWindow:N,remoteAuthority:z})}openExistingWindow(O,F){O.focus(),this.W(F,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const F=[],x=[],z=[],X=[],N=[];let B,_=0;const ce=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",ce);for(const Pe of ce)te(Pe)?O.addMode?F.push(Pe):x.push(Pe):q(Pe)?z.push(Pe):Pe.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),B.filesToOpenOrCreate.push(Pe)):Pe.backupPath?N.push({backupFolder:(0,c.$nc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):_++;O.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),O.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&O.waitMarkerFileURI&&(B.filesToWait={paths:(0,D.$Hb)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(X.push(...this.M.getUntitledWorkspaces()),z.push(...X),N.push(...this.I.getEmptyWindowBackups())):N.length=0;const{windows:se,filesOpenedInWindow:$e}=await this.X(O,z,x,N,_,B,F);if(this.w.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${x.length}, emptyToRestore: ${N.length}, emptyToOpen: ${_})`),se.length>1)if($e)$e.focus();else{const Pe=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Pe){const pe=se.filter(ee=>this.r.state.lastActiveWindow&&ee.backupPath===this.r.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=se.length-1;pe>=0;pe--){const ee=se[pe];if(!(ee.openedWorkspace&&X.some(fe=>ee.openedWorkspace&&fe.workspace.id===ee.openedWorkspace.id)||ee.backupPath&&N.some(fe=>ee.backupPath&&fe.backupFolder===(0,c.$nc)(ee.backupPath)))){ee.focus(),ke=!1;break}}ke&&se[se.length-1].focus()}const me=B&&B.filesToDiff.length>0,ye=B&&B.filesToMerge.length>0;if(!se.some(Pe=>Pe.isExtensionDevelopmentHost)&&!me&&!ye&&!O.noRecentEntry){const Pe=[];for(const Le of ce)q(Le)&&!Le.transient?Pe.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):te(Le)?Pe.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Pe.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(O,se),se}W(O,F){const x=O.waitMarkerFileURI;O.context===0&&x&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(x)}catch{}})()}async X(O,F,x,z,X,N,B){const _=[];let ce;function se(pe,ee){_.push(pe),ee&&(ce=pe,N=void 0)}let{openFolderInNewWindow:$e,openFilesInNewWindow:me}=this.ob(O);if(!O.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,ee=this.ub(pe);ee&&se(this.$(ee,B.map(fe=>fe.workspace.uri)))}const ye=x.length+F.length+z.length;if(N&&ye===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],ee=this.getWindows().filter(ge=>N&&(0,d.$Kg)(ge.remoteAuthority,N.remoteAuthority));let fe;pe?.fileUri&&!me&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,G.$S9b)(ee,pe.fileUri,async ge=>ge.configPath.scheme===p.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(ee))),fe?(0,le.$gi)(fe.openedWorkspace)?F.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,le.$bi)(fe.openedWorkspace)?x.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):se(this.Y(O,fe,N),!0):se(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Pe=(0,D.$Mb)(F,pe=>pe.workspace.id);if(Pe.length>0){const pe=(0,D.$Hb)(Pe.map(ee=>(0,G.$T9b)(this.getWindows(),ee.workspace.configPath)));if(pe.length>0){const ee=pe[0],fe=(0,d.$Kg)(N?.remoteAuthority,ee.remoteAuthority)?N:void 0;se(this.Y(O,ee,fe),!!fe),$e=!0}for(const ee of Pe){if(pe.some(Ie=>Ie.openedWorkspace&&Ie.openedWorkspace.id===ee.workspace.id))continue;const fe=ee.remoteAuthority,ge=(0,d.$Kg)(N?.remoteAuthority,fe)?N:void 0;se(await this.bb(O,ee,$e,ge),!!ge),$e=!0}}const Le=(0,D.$Mb)(x,pe=>d.$wg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(ee=>(0,G.$T9b)(this.getWindows(),ee.workspace.uri)));if(pe.length>0){const ee=pe[0],fe=(0,d.$Kg)(N?.remoteAuthority,ee.remoteAuthority)?N:void 0;se(this.Y(O,ee,fe),!!fe),$e=!0}for(const ee of Le){if(pe.some(Ie=>(0,le.$bi)(Ie.openedWorkspace)&&d.$wg.isEqual(Ie.openedWorkspace.uri,ee.workspace.uri)))continue;const fe=ee.remoteAuthority,ge=(0,d.$Kg)(N?.remoteAuthority,fe)?N:void 0;se(await this.bb(O,ee,$e,ge),!!ge),$e=!0}}const ke=(0,D.$Mb)(z,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const ee=pe.remoteAuthority,fe=(0,d.$Kg)(N?.remoteAuthority,ee)?N:void 0;se(await this.ab(O,!0,ee,fe,pe),!!fe),$e=!0}if(_.length===0||N){N&&!X&&X++;const pe=N?N.remoteAuthority:O.remoteAuthority;for(let ee=0;ee<X;ee++)se(await this.ab(O,$e,pe,N),!!N),$e=!0}return{windows:(0,D.$Mb)(_),filesOpenedInWindow:ce}}Y(O,F,x){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:x}),this.Z(F);const z={filesToOpenOrCreate:x?.filesToOpenOrCreate,filesToDiff:x?.filesToDiff,filesToMerge:x?.filesToMerge,filesToWait:x?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",S.CancellationToken.None,z),F}Z(O){let F=O;const x=P.BrowserWindow.getFocusedWindow();if(x&&x.id!==O.id){const z=this.S.getWindowById(x.id);z&&z.parentId===O.id&&(F=z)}F.focus()}$(O,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),O.focus();const x={foldersToAdd:F};return O.sendWhenReady("vscode:addFolders",S.CancellationToken.None,x),O}ab(O,F,x,z,X){this.w.trace("windowsManager#doOpenEmpty",{restore:!!X,remoteAuthority:x,filesToOpen:z,forceNewWindow:F});let N;return!F&&typeof O.contextWindowId=="number"&&(N=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:x,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:N,emptyWindowBackupInfo:X,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,F,x,z,X){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!x&&!X&&typeof O.contextWindowId=="number"&&(X=this.getWindowById(O.contextWindowId)),this.pb({workspace:F.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:x,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:X,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let F,x=!1,z=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(F=await this.db(O),x=!0):O.forceEmpty?F=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(F=await this.eb(O.cli),F.length===0&&F.push(Object.create(null)),x=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),z=!0),!O.addMode&&x){const X=F.filter(N=>te(N));if(X.length>1){const N=X[0].remoteAuthority;if(X.every(B=>(0,d.$Kg)(B.remoteAuthority,N))){const B=await this.M.createUntitledWorkspace(X.map(_=>({uri:_.workspace.uri})));F.push({workspace:B,remoteAuthority:N}),F=F.filter(_=>!te(_))}}}if(O.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const X=await this.gb();F.unshift(...X.filter(N=>q(N)||te(N)||N.backupPath))}return F}async db(O){const F={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},x=await Promise.all((0,D.$Hb)(O.urisToOpen||[]).map(async z=>{const X=await this.ib(z,F);if(X)return X.label=z.label,X;const N=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,v.localize)(0,null)],message:N.scheme===p.Schemas.file?(0,v.localize)(1,null):(0,v.localize)(2,null),detail:N.scheme===p.Schemas.file?(0,v.localize)(3,null,(0,y.$Lv)(N,{os:m.OS,tildify:this.F})):(0,v.localize)(4,null,N.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(x)}async eb(O){const F=[],x={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},z=O["folder-uri"];if(z){const B=await Promise.all(z.map(_=>{const ce=this.fb(_);if(ce)return this.ib({folderUri:ce},x)}));F.push(...(0,D.$Hb)(B))}const X=O["file-uri"];if(X){const B=await Promise.all(X.map(_=>{const ce=this.fb(_);if(ce)return this.ib((0,le.$wi)(_)?{workspaceUri:ce}:{fileUri:ce},x)}));F.push(...(0,D.$Hb)(B))}const N=await Promise.all(O._.map(B=>x.remoteAuthority?this.nb(B,x):this.lb(B,x)));return F.push(...(0,D.$Hb)(N)),F}fb(O){try{const F=g.URI.parse(O);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${O}, ${F.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];O!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const x=await Promise.all(F.map(async z=>{if(z.workspace){const X=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(X))return X}else if(z.folderUri){const X=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(te(X))return X}else if(O!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.$Hb)(x)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,F=Object.create(null)){const x=this.kb(O);return x.scheme===p.Schemas.file?((0,j.$HC)(O)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(x.fsPath,F)):this.jb(O,F)}jb(O,F){let x=this.kb(O);const z=(0,E.$$k)(x)||F.remoteAuthority;if(x=(0,d.$Mg)((0,d.$Gg)(x)),(0,j.$HC)(O)){if(F.gotoLineMode){const{path:X,line:N,column:B}=(0,l.$ag)(x.path);return{fileUri:x.with({path:X}),options:{selection:N?{startLineNumber:N,startColumn:B||1}:void 0},remoteAuthority:z}}return{fileUri:x,remoteAuthority:z}}else if((0,j.$FC)(O))return{workspace:(0,re.$W9b)(x),remoteAuthority:z};return{workspace:(0,re.$X9b)(x),remoteAuthority:z}}kb(O){return(0,j.$FC)(O)?O.workspaceUri:(0,j.$GC)(O)?O.folderUri:O.fileUri}async lb(O,F,x){let z,X;F.gotoLineMode&&({path:O,line:z,column:X}=(0,l.$ag)(O)),O=(0,l.$8f)((0,c.$hc)(O),(0,$.cwd)());try{const N=await R.Promises.stat(O);if(N.isFile()){if(!F.forceOpenWorkspaceAsFile){const B=await this.M.resolveLocalWorkspace(g.URI.file(O));if(B)return B.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:g.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:X||1}:void 0}}}else{if(N.isDirectory())return{workspace:(0,re.$X9b)(g.URI.file(O),N),type:i.FileType.Directory,exists:!0};if(!m.$i&&O==="/dev/null")return{fileUri:g.URI.file(O),type:i.FileType.File,exists:!0}}}catch(N){if(N.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!x)return this.mb(O,F);const B=g.URI.file(O);if(this.L.removeRecentlyOpened([B]),F.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}async mb(O,F){const x=g.URI.file(O),{response:z,checkboxChecked:X}=await this.O.showMessageBox({type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null),(0,v.localize)(7,null)],message:(0,v.localize)(8,null,x.authority),detail:(0,v.localize)(9,null,(0,y.$Lv)(x,{os:m.OS,tildify:this.F})),checkboxLabel:(0,v.localize)(10,null,x.authority),cancelId:1});if(z===0){if((0,s.addUNCHostToAllowlist)(x.authority),X){const N={channel:"vscode:configureAllowedUNCHost",args:x.authority};this.sendToFocused(N.channel,N.args),this.sendToOpeningWindow(N.channel,N.args)}return this.lb(O,F,!0)}if(z===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,F)}nb(O,F){const x=O.charCodeAt(0),z=F.remoteAuthority;let X,N;F.gotoLineMode&&({path:O,line:X,column:N}=(0,l.$ag)(O)),x!==47&&((0,l.$7f)(x)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.$Zf)(O)),O=`/${O}`);const B=g.URI.from({scheme:p.Schemas.vscodeRemote,authority:z,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,le.$wi)(O))return F.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:N||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,re.$W9b)(B),remoteAuthority:z};if(F.gotoLineMode||c.$gc.basename(O).indexOf(".")!==-1)return{fileUri:B,options:{selection:X?{startLineNumber:X,startColumn:N||1}:void 0},remoteAuthority:z}}return{workspace:(0,re.$X9b)(B),remoteAuthority:z}}ob(O){const F=this.J.getValue("window"),x=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let X=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(x==="on"||x==="off")&&(X=x==="on");let N=!1;return O.forceNewWindow||O.forceReuseWindow?N=!!O.forceNewWindow&&!O.forceReuseWindow:(m.$j?O.context===1&&(N=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!O.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(N=z==="on")),{openFolderInNewWindow:!!X,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(O,F){const x=(0,G.$U9b)(this.getWindows(),O);if(x)return this.H.reload(x,F.cli),x.focus(),[x];let z=F.cli["folder-uri"]||[],X=F.cli["file-uri"]||[],N=F.cli._;if(!N.length&&!z.length&&!X.length&&!F.cli.extensionTestsPath){const ce=this.r.state.lastPluginDevelopmentHostWindow,se=ce?.workspace??ce?.folderUri;se&&(g.URI.isUri(se)?se.scheme===p.Schemas.file?N=[se.fsPath]:z=[se.toString()]:se.configPath.scheme===p.Schemas.file?N=[(0,d.$tg)(se.configPath)]:X=[se.configPath.toString()])}let B=F.remoteAuthority;for(const ce of O)if(ce.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const se=g.URI.parse(ce),$e=(0,E.$$k)(se);$e&&(B?(0,d.$Kg)($e,B)||this.w.error("more than one extension development path authority"):B=$e)}N=N.filter(ce=>{const se=g.URI.file(ce);return(0,G.$T9b)(this.getWindows(),se)?!1:(0,d.$Kg)((0,E.$$k)(se),B)}),z=z.filter(ce=>{const se=this.fb(ce);return se&&(0,G.$T9b)(this.getWindows(),se)?!1:se?(0,d.$Kg)((0,E.$$k)(se),B):!1}),X=X.filter(ce=>{const se=this.fb(ce);return se&&(0,G.$T9b)(this.getWindows(),se)?!1:se?(0,d.$Kg)((0,E.$$k)(se),B):!1}),F.cli._=N,F.cli["folder-uri"]=z,F.cli["file-uri"]=X;const _={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!N.length&&!z.length&&!X.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:B,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(_)}async pb(O){const F=this.J.getValue("window"),x=this.getLastActiveWindow(),z=x?.profile??this.G.defaultProfile;let X;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(X=O.windowToUse||x,X&&X.focus());const N={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,c.$jc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:p.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:p.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:p.Schemas.file}).fsPath,product:A.default,isInitialStartup:O.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(X){const B=X.config;!N.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=B.extensionDevelopmentPath,N.extensionDevelopmentKind=B.extensionDevelopmentKind,N["enable-proposed-api"]=B["enable-proposed-api"],N.verbose=B.verbose,N["inspect-extensions"]=B["inspect-extensions"],N["inspect-brk-extensions"]=B["inspect-brk-extensions"],N.debugId=B.debugId,N.extensionEnvironment=B.extensionEnvironment,N["extensions-dir"]=B["extensions-dir"],N["disable-extensions"]=B["disable-extensions"]),N.loggers={global:N.loggers.global,window:B?.loggers.window??N.loggers.window}}else{const B=this.r.getNewWindowState(N);(0,b.mark)("code/willCreateCodeWindow");const _=X=this.N.createInstance(W.$59b,{state:B,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(_),this.n.set(_.id,_),this.a.fire(_),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ce=new k.$Sc;ce.add(_.onDidSignalReady(()=>this.b.fire(_))),ce.add(f.Event.once(_.onDidClose)(()=>this.sb(_,ce))),ce.add(f.Event.once(_.onDidDestroy)(()=>this.tb(_))),ce.add(_.onDidMaximize(()=>this.g.fire(_))),ce.add(_.onDidUnmaximize(()=>this.h.fire(_))),ce.add(_.onDidEnterFullScreen(()=>this.j.fire(_))),ce.add(_.onDidLeaveFullScreen(()=>this.j.fire(_))),ce.add(_.onDidTriggerSystemContextMenu(({x:$e,y:me})=>this.m.fire({window:_,x:$e,y:me})));const se=(0,h.$Rf)(_.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.H.reload(_)),this.H.registerWindow(_)}return N.windowId=X.id,X.isReady?this.H.unload(X,4).then(async B=>{B||await this.qb(X,N,O,z)}):await this.qb(X,N,O,z),X}async qb(O,F,x,z){if(F.extensionDevelopmentPath||((0,le.$gi)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,le.$bi)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:x.emptyWindowBackupInfo?.backupFolder??(0,re.$Y9b)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const X=F.workspace??(0,le.$fi)(F.backupPath,!1),N=this.rb(x,X,z),B=N instanceof Promise?await N:N;F.profiles.profile=B,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(X,B)}O.load(F)}rb(O,F,x){return O.forceProfile?this.G.profiles.find(z=>z.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??x}sb(O,F){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(F=>(0,d.$Kg)(F.remoteAuthority,O)))}vb(O){return(0,T.$P9b)(O)}sendToFocused(O,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,S.CancellationToken.None,...F)}sendToOpeningWindow(O,...F){this.B(f.Event.once(this.onDidSignalReadyWindow)(x=>{x.sendWhenReady(O,S.CancellationToken.None,...F)}))}sendToAll(O,F,x){for(const z of this.getWindows())x&&x.indexOf(z.id)>=0||z.sendWhenReady(O,S.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const F=P.BrowserWindow.fromWebContents(O);if(F)return this.getWindowById(F.id)}};e.$c$b=he,e.$c$b=he=Ee([ne(3,w.$lj),ne(4,U.$29b),ne(5,C.$cO),ne(6,H.$yn),ne(7,r.$z9b),ne(8,L.$Q9b),ne(9,a.$79b),ne(10,u.$E9b),ne(11,t.$xi),ne(12,ue.$K0b),ne(13,Y.$Z9b),ne(14,n.$3h),ne(15,o.$F9b),ne(16,i.$ok),ne(17,I.$H9b),ne(18,Z.$I9b),ne(19,V.$K9b)],he)}),define(oe[307],ae([0,1,66,29,83,56]),function(Q,e,P,R,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=void 0;let D=class{constructor(f,l,y,k){this.a=f,this.b=l,this.c=y,this.d=k,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const y=this.b.getWindowById(f);if(y)return this.a.enterWorkspace(y,this.b.getWindows(),l)}createUntitledWorkspace(f,l,y){return this.a.createUntitledWorkspace(l,y)}deleteUntitledWorkspace(f,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$e$b=D,e.$e$b=D=Ee([ne(0,M.$Z9b),ne(1,R.$M9b),ne(2,s.$K0b),ne(3,P.$E9b)],D)}),define(oe[308],ae([0,1,15,131,36,26,18,51,14,33,3,44,47,2,13,9,4,12,7,32,158,42,159,110,290,162,66,283,17,200,91,132,54,116,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,122,28,251,253,53,49,265,288,300,289,301,127,267,268,269,272,297,60,29,306,274,30,97,83,307,56,39,233,55,244,52,81,129,277,292,280,8,255,276,228,69,296,271,23,125,295,263,239,62,65,303]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C,j,W,T,G,K,le,re,ue,Y,Z,H,L,U,V,q,te,he,J,O,F,x,z,X,N,B,_,ce,se,$e,me,ye,Pe,Le,ke,pe,ee,fe,ge,Ie,Me,We,je,Ke,Be,He,Ve,ie,de,be,Se,ve,Re,Ue,qe,Qe,xe,Ze,Xe,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,Ct,ct,Dt,$t,lt,At,Rt,ut,Ot,ht,Mt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;let dt=class extends c.$Tc{static{ft=this}static{this.a={[b.Schemas.file]:"security.promptForLocalFileProtocolHandling",[b.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ce,De,Oe,we,Ae,Ne,ze,Je,Fe,Te,Ge,Ye){super(),this.g=Ce,this.h=De,this.j=Oe,this.m=we,this.n=Ae,this.s=Ne,this.t=ze,this.u=Je,this.w=Fe,this.y=Te,this.z=Ge,this.C=Ye,this.D(),this.F()}D(){const Ce=Fe=>Fe?.startsWith(`${b.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Fe,Te,Ge,Ye)=>Ce(Ye.requestingUrl)?Ge(De.has(Te)):Ge(!1)),P.session.defaultSession.setPermissionCheckHandler((Fe,Te,Ge,Ye)=>Ce(Ye.requestingUrl)?De.has(Te):!1);const Oe=new Set([b.Schemas.file,b.Schemas.vscodeFileResource,b.Schemas.vscodeRemoteResource,b.Schemas.vscodeManagedRemoteResource,"devtools"]),we=Fe=>{for(let Te=Fe;Te;Te=Te.parent)if(Te.url.startsWith(`${b.Schemas.vscodeWebview}://`))return!0;return!1},Ae=Fe=>Fe.resourceType==="xhr"||we(Fe.frame),Ne=Fe=>{const Te=Fe.frame;if(!Te||!this.b)return!1;const Ge=P.BrowserWindow.getAllWindows();for(const Ye of Ge)if(Te.processId===Ye.webContents.mainFrame.processId)return!0;return!1},ze=(Fe,Te)=>{if(Fe.path!=="/index.html")return!0;const Ge=Te.frame;if(!Ge||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ge.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Fe,Te)=>{const Ge=h.URI.parse(Fe.url);return Ge.scheme===b.Schemas.vscodeWebview&&!ze(Ge,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),Te({cancel:!0})):Ge.scheme===b.Schemas.vscodeFileResource&&!Ne(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),Te({cancel:!0})):Ge.path.endsWith(".svg")&&!Oe.has(Ge.scheme)?Te({cancel:!Ae(Fe)}):Te({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Te)=>{const Ge=Fe.responseHeaders,Ye=Ge["content-type"]||Ge["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=h.URI.parse(Fe.url);if(_e.path.endsWith(".svg")&&Oe.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Te({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(b.Schemas.vscodeRemoteResource)&&Ye.some(tt=>tt.toLowerCase().includes("image/svg")))return Te({cancel:!Ae(Fe)})}return Te({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Te)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=Fe.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Te({cancel:!1,responseHeaders:Ge})}return Te({cancel:!1})});const Je=P.session.defaultSession;typeof Je.setCodeCachePath=="function"&&this.s.codeCachePath&&Je.setCodeCachePath((0,m.$jc)(this.s.codeCachePath,"chrome")),$.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,f.$Z)(Oe)||(0,f.$1)(Oe)}),process.on("unhandledRejection",Oe=>(0,f.$1)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,v.$qU)(),P.app.on("accessibility-support-changed",(Oe,we)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",we)}),P.app.on("activate",async(Oe,we)=>{this.m.trace("app#activate"),we||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Oe,we)=>{(0,ht.$L9b)(we)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(we)),we.on("will-navigate",Ae=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ae.preventDefault()}),we.setWindowOpenHandler(Ae=>Ae.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ae.url}}`),this.f?.openExternal(void 0,Ae.url),{action:"deny"}))});let Ce=[],De;P.app.on("open-file",(Oe,we)=>{this.m.trace("app#open-file: ",we),Oe.preventDefault(),Ce.push((0,Ue.$wi)(we)?{workspaceUri:h.URI.file(we)}:{fileUri:h.URI.file(we)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],De=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$pU.handle("vscode:fetchShellEnv",Oe=>{const we=this.b?.getWindowByWebContents(Oe.sender);let Ae,Ne;return we?.config?(Ae=we.config,Ne={...process.env,...we.config.userEnv}):(Ae=this.s.args,Ne=process.env),this.X(Ae,Ne,!1)}),s.$pU.handle("vscode:writeNlsFile",(Oe,we,Ae)=>{const Ne=this.G([we]);if(!Ne||typeof Ae!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ne,D.$he.fromString(Ae))}),s.$pU.handle("vscode:readNlsFile",async(Oe,...we)=>{const Ae=this.G(we);if(!Ae)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ae)).value.toString()}),s.$pU.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$pU.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$pU.on("vscode:reloadWindow",Oe=>Oe.sender.reload()),s.$pU.handle("vscode:notifyZoomLevel",async(Oe,we)=>{const Ae=this.b?.getWindowById(Oe.sender.id);Ae&&Ae.notifyZoomLevel(we)})}G(Ce){let De;for(const Oe of Ce)typeof Oe=="string"&&(typeof De!="string"?De=Oe:De=(0,m.$jc)(De,Oe));if(!(typeof De!="string"||!(0,m.$ic)(De)||!(0,l.$6f)(De,this.s.cachedLanguagesPath,!$.$k)))return h.URI.file(De)}H(Ce){if(Ce){const De={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.m.error(Ce.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ce=this.z.win32AppUserModelId;$.$i&&Ce&&P.app.setAppUserModelId(Ce);try{$.$j&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Te){this.m.error(Te)}const De=new t.$wU;this.t.onWillShutdown(Te=>{Te.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,we]=await Promise.all([(0,gt.$m$b)(this.w,this.m),(0,gt.$n$b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ae,sharedProcessClient:Ne}=this.P(Oe,we),ze=await this.Q(Oe,we,Ae);this.B(ze.createInstance(r.$e0b)),this.B(ze.createInstance(Et.$i$b)),ze.invokeFunction(Te=>this.R(Te,De,Ne));const Je=await ze.invokeFunction(Te=>this.I(Te,De));this.J(De),this.t.phase=2,await ze.invokeFunction(Te=>this.S(Te,Je)),this.t.phase=3,this.U(),this.B(new at.$dh(()=>{this.B((0,at.$hh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ce,De){const Oe=this.b=Ce.get(Se.$M9b),we=Ce.get(Ke.$eV),Ae=this.f=Ce.get(N.$y0b),Ne=Ce.get(C.$F9b),ze=this;we.registerHandler({async handleURL(_e,tt){return ze.O(Oe,Ne,we,_e,tt)}});const Je=this.B(new Re.$d$b({onDidOpenMainWindow:Ae.onDidOpenMainWindow,onDidFocusMainWindow:Ae.onDidFocusMainWindow,getActiveWindowId:()=>Ae.getActiveWindowId(-1)})),Fe=new u.$Lh(_e=>Je.getActiveClientId().then(tt=>_e===tt)),Te=new Be.$70b(Fe,this.m),Ge=De.getChannel("urlHandler",Te);we.registerHandler(new Be.$60b(Ge));const Ye=await this.L(Oe,Ne);return this.B(new Ve.$80b(Ye?.urls,we,Oe,this.s,this.z,this.m)),Ye}J(Ce){const De=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$V(()=>Ce.getChannel(ut.$u$b,new ut.$v$b));P.protocol.registerBufferProtocol(b.Schemas.vscodeManagedRemoteResource,(we,Ae)=>{const Ne=h.URI.parse(we.url);if(!Ne.authority.startsWith("window:"))return Ae(De());Oe.value.call(ut.$t$b,[Ne]).then(ze=>Ae({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Ae({statusCode:500,data:String(ze)})})})}async L(Ce,De){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const we=global.getOpenUrls()||[];if(we.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",we),Oe.length+we.length===0)return;const Ae=[...Oe,...we].map(Je=>{try{return{uri:h.URI.parse(Je),originalUrl:Je}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Je);return}}),Ne=[],ze=[];for(const Je of Ae){if(!Je)continue;const Fe=this.N(Je.uri);if(Fe)if(await this.M(Fe,Ce,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Je.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Je.uri.toString(!0),Fe),Ne.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Je.uri.toString(!0)),ze.push(Je)}return{urls:ze,openables:Ne}}async M(Ce,De,Oe){let we,Ae;if((0,be.$FC)(Ce)?(we=Ce.workspaceUri,Ae=(0,i.localize)(0,null,we.scheme===b.Schemas.file?(0,p.$Lv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(0,be.$GC)(Ce)?(we=Ce.folderUri,Ae=(0,i.localize)(1,null,we.scheme===b.Schemas.file?(0,p.$Lv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)):(we=Ce.fileUri,Ae=(0,i.localize)(2,null,we.scheme===b.Schemas.file?(0,p.$Lv)(we,{os:$.OS,tildify:this.s}):we.toString(!0),this.z.nameShort)),we.scheme!==b.Schemas.file&&we.scheme!==b.Schemas.vscodeRemote||this.u.getValue(ft.a[we.scheme])===!1)return!1;const{response:ze,checkboxChecked:Je}=await Oe.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ae,detail:(0,i.localize)(5,null),checkboxLabel:we.scheme===b.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Je){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:we.scheme===b.Schemas.file?"local":"remote"};De.sendToFocused(Fe.channel,Fe.args),De.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}N(Ce){if(Ce.path){if(Ce.authority===b.Schemas.file){const De=h.URI.file(Ce.fsPath);return(0,Ue.$wi)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ce.authority===b.Schemas.vscodeRemote){const De=Ce.path.indexOf(m.$gc.sep,1);if(De!==-1){const Oe=Ce.path.substring(1,De),we=Ce.path.substring(De);let Ae=Ce.query;const Ne=new URLSearchParams(Ce.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),Ae=Ne.toString());const ze=h.URI.from({scheme:b.Schemas.vscodeRemote,authority:Oe,path:we,query:Ae,fragment:Ce.fragment});return(0,Ue.$wi)(we)?{workspaceUri:ze}:/:[\d]+$/.test(we)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ce,De,Oe,we,Ae){this.m.trace("app#handleProtocolUrl():",we.toString(!0),Ae),we.scheme===this.z.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:h.URI.parse(we.query).path,query:""}));let Ne=!1;const ze=new URLSearchParams(we.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),ze.delete("windowId"),we=we.with({query:ze.toString()}),Ne=!0):$.$j&&Ce.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne=!0);const Je=ze.get("continueOn");Je!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),ze.delete("continueOn"),we=we.with({query:ze.toString()}),this.s.continueOn=Je??void 0);const Fe=this.N(we);return Fe?await this.M(Fe,Ce,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,we.toString(!0)),(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:Ne,gotoLineMode:!0}))?.focus(),!0):Ne?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,$t.$Ob)(await Ce.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,_.$$k)(we)}))?.ready(),Oe.open(we,Ae)):(this.m.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Ae),!1)}P(Ce,De){const Oe=this.B(this.j.createInstance(ce.$S0b,Ce,De)),we=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ne=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$xU(Ne,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),we))(),sharedProcessClient:we}}async Q(Ce,De,Oe){const we=new te.$2h;switch(process.platform){case"win32":we.set(fe.$oV,new V.$1h(je.$40b));break;case"linux":$.$l?we.set(fe.$oV,new V.$1h(We.$30b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(fe.$oV,new V.$1h(Me.$20b));break;case"darwin":we.set(fe.$oV,new V.$1h(Ie.$10b));break}we.set(Se.$M9b,new V.$1h(ve.$c$b,[Ce,De,this.h],!1)),we.set(ht.$K9b,new V.$1h(Mt.$w$b,void 0,!1));const Ae=new C.$G9b(this.m,this.z);we.set(C.$F9b,Ae),we.set(F.$E0b,new V.$1h(F.$F0b,void 0,!1)),we.set(E.$k0b,new V.$1h(E.$l0b,void 0,!1)),we.set(I.$Gm,u.ProxyChannel.toService((0,u.$Jh)(Oe.then(Te=>Te.getChannel("diagnostics"))))),we.set(he.$jzb,new V.$1h(J.$A0b,[this.h])),we.set(j.$$U,new V.$1h(W.$m0b)),we.set(O.$B0b,new V.$1h(O.$C0b)),we.set(N.$y0b,new V.$1h(N.$z0b,void 0,!1)),we.set(ie.$90b,new V.$1h(de.$$0b)),we.set(X.$N0b,new V.$1h(X.$O0b)),we.set(le.$n0b,new V.$1h(re.$p0b)),we.set(ye.$a0b,new V.$1h(ye.$b0b)),we.set(ye.$c0b,new V.$1h(ye.$d0b));const Ne=new At.$s$b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Rt.$Mr(Ne,this.u,this.m,this.n);we.set(lt.$nr,ze),$.$i?we.set(ue.$q0b,new V.$1h(Y.$r0b)):$.$j?we.set(ue.$q0b,new V.$1h(Y.$s0b)):$.$k&&we.set(ue.$q0b,new V.$1h(Y.$t0b));const Je=new a.$f0b(this.s,this.u,this.m,this.w);we.set(n.$E9b,Je);const Fe=new Ze.$19b(this.s,this.m,this.C,Je,Ae);if(we.set(Ze.$Z9b,Fe),we.set(qe.$jcb,new V.$1h(xe.$e$b,void 0,!1)),we.set(Qe.$K0b,new V.$1h(Qe.$L0b,void 0,!1)),we.set(Ke.$eV,new V.$1h(He.$gV,void 0,!1)),(0,ee.$Ho)(this.z,this.s)){const Te=(0,ee.$Mo)(this.z,this.u),Ge=(0,u.$Jh)(Oe.then(rt=>rt.getChannel("telemetryAppender"))),Ye=new ke.$V0b(Ge),_e=(0,Pe.$xo)((0,M.release)(),(0,M.hostname)(),process.arch,this.z.commit,this.z.version,Ce,De,Te),tt=(0,ee.$No)(this.s),it={appenders:[Ye],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};we.set(Le.$sl,new V.$1h(pe.$er,[it],!1))}else we.set(Le.$sl,ee.$Bo);return we.set(yt.$Kp,new V.$1h(Pt.$jO,void 0,!0)),we.set(vt.$Op,new V.$1h(kt.$h$b,void 0,!0)),we.set(ct.$q$b,new V.$1h(ct.$r$b,void 0,!0)),await at.Promises.settled([Je.initialize(),Fe.initialize()]),this.j.createChild(we)}R(Ce,De,Oe){const we=this.B(new c.$Sc),Ae=u.ProxyChannel.fromService(Ce.get(F.$E0b),we,{disableMarshalling:!0});this.g.registerChannel("launch",Ae);const Ne=u.ProxyChannel.fromService(Ce.get(E.$k0b),we,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ne);const ze=new nt.$f$b(Ce.get(Xe.$yn));De.registerChannel("policy",ze),Oe.then(et=>et.registerChannel("policy",ze));const Je=this.y.getProvider(b.Schemas.file);(0,d.$Qf)(Je instanceof U.$qq);const Fe=new L.$u0b(Je,this.m,this.s);De.registerChannel(Z.$5N,Fe),Oe.then(et=>et.registerChannel(Z.$5N,Fe));const Te=u.ProxyChannel.fromService(Ce.get(st.$Q9b),we);De.registerChannel("userDataProfiles",Te),Oe.then(et=>et.registerChannel("userDataProfiles",Te));const Ge=new ot.$_q(Ce.get(pt.$9o));Oe.then(et=>et.registerChannel("request",Ge));const Ye=new ge.$W0b(Ce.get(fe.$oV));De.registerChannel("update",Ye);const _e=u.ProxyChannel.fromService(Ce.get(he.$jzb),we);De.registerChannel("issue",_e);const tt=u.ProxyChannel.fromService(Ce.get(j.$$U),we);De.registerChannel("encryption",tt);const it=u.ProxyChannel.fromService(Ce.get(se.$gl),we);De.registerChannel("sign",it);const rt=u.ProxyChannel.fromService(Ce.get(O.$B0b),we);De.registerChannel("keyboardLayout",rt),this.f=Ce.get(N.$y0b);const mt=u.ProxyChannel.fromService(this.f,we);De.registerChannel("nativeHost",mt),Oe.then(et=>et.registerChannel("nativeHost",mt));const jt=u.ProxyChannel.fromService(Ce.get(qe.$jcb),we);De.registerChannel("workspaces",jt);const Lt=u.ProxyChannel.fromService(Ce.get(X.$N0b),we);De.registerChannel("menubar",Lt);const Ft=u.ProxyChannel.fromService(Ce.get(Ke.$eV),we);De.registerChannel("url",Ft);const Tt=u.ProxyChannel.fromService(Ce.get(ie.$90b),we);De.registerChannel("webview",Tt);const wt=this.B(new me.$T0b(this.m,Ce.get(ye.$a0b)));De.registerChannel("storage",wt),Oe.then(et=>et.registerChannel("storage",wt));const Ut=this.B(new St.$j$b(Ce.get(ye.$a0b),Ce.get(st.$Q9b),this.m));Oe.then(et=>et.registerChannel("profileStorageListener",Ut));const Wt=u.ProxyChannel.fromService(Ce.get(lt.$nr),we);De.registerChannel(lt.TerminalIpcChannels.LocalPty,Wt);const Nt=u.ProxyChannel.fromService(Ce.get(ue.$q0b),we);De.registerChannel("externalTerminal",Nt);const bt=new It.$o$b(Ce.get(Ct.$29b));De.registerChannel("logger",bt),Oe.then(et=>et.registerChannel("logger",bt));const zt=new A.$g0b(Ce.get(Se.$M9b));De.registerChannel("extensionhostdebugservice",zt);const Bt=u.ProxyChannel.fromService(Ce.get(le.$n0b),we);De.registerChannel(le.$o0b,Bt);const qt=u.ProxyChannel.fromService(Ce.get(ct.$q$b),we);De.registerChannel(Dt.$p$b,qt)}async S(Ce,De){const Oe=this.b=Ce.get(Se.$M9b);this.c=Ce.get(ht.$K9b);const we=(0,G.$4l)(process.env)?0:4,Ae=this.s.args;if(De){if(De.openables.length>0)return Oe.open({context:we,cli:Ae,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const it of De.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Oe.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,ze=Ae._.length,Je=!!Ae["folder-uri"],Fe=!!Ae["file-uri"],Te=Ae["skip-add-to-recently-opened"]===!0,Ge=Ae.wait&&Ae.waitMarkerFilePath?h.URI.file(Ae.waitMarkerFilePath):void 0,Ye=Ae.remote||void 0,_e=Ae.profile,tt=Ae["profile-temp"];if(!ze&&!Je&&!Fe){if(Ae["new-window"]||_e||tt)return Oe.open({context:we,cli:Ae,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Te,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:tt});if(Ne.length)return Oe.open({context:1,cli:Ae,urisToOpen:Ne.map(it=>(0,Ue.$wi)(it)?{workspaceUri:h.URI.file(it)}:{fileUri:h.URI.file(it)}),noRecentEntry:Te,waitMarkerFileURI:Ge,initialStartup:!0})}return Oe.open({context:we,cli:Ae,forceNewWindow:Ae["new-window"]||!ze&&Ae["unity-launch"],diffMode:Ae.diff,mergeMode:Ae.merge,noRecentEntry:Te,waitMarkerFileURI:Ge,gotoLineMode:Ae.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),P.protocol.registerHttpProtocol(b.Schemas.vscodeRemoteResource,(Ce,De)=>{De({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.X(this.s.args,process.env,!0),this.Y(),$.$j&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ce=this.z.win32MutexName;if($.$i&&Ce)try{const De=await new Promise((we,Ae)=>{Q(["@vscode/windows-mutex"],we,Ae)}),Oe=new De.Mutex(Ce);y.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(De){this.m.error(De)}}async X(Ce,De,Oe){try{return await(0,K.$0l)(this.u,this.m,Ce,De)}catch(we){const Ae=(0,S.$Oi)(we);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ae):this.m.error(Ae)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,k.$in)(De)),Ae=(0,ee.$Jo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ae},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.$og)()}"`,"}"],ze=De.substring(0,De.length-2).concat(`,
`,Ne.join(`
`));await this.y.writeFile(this.s.argvResource,D.$he.fromString(ze))}else{const Ne=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ae},`);Ne!==De&&await this.y.writeFile(this.s.argvResource,D.$he.fromString(Ne))}}catch(Ce){this.m.error(Ce)}}};e.$x$b=dt,e.$x$b=dt=ft=Ee([ne(2,q.$3h),ne(3,z.$lj),ne(4,z.$mj),ne(5,T.$z9b),ne(6,x.$79b),ne(7,w.$xi),ne(8,$e.$cO),ne(9,H.$ok),ne(10,B.$Dj),ne(11,st.$Q9b)],dt)}),define(oe[313],ae([0,1,15,46,7,23,8,51,14,33,3,47,13,9,68,4,35,25,21,42,99,308,10,17,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,126,287,52,286,95,249,34,53,70,55,39,234,232,2,40,266,69,227,115,121,270,264]),function(Q,e,P,R,s,M,D,S,f,l,y,k,p,c,b,m,$,d,h,g,v,u,t,o,r,i,n,a,w,A,I,E,C,j,W,T,G,K,le,re,ue,Y,Z,H,L,U,V,q,te,he,J,O,F,x,z,X,N,B,_,ce,se,$e,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ye{main(){try{this.a()}catch(ke){console.error(ke.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(je=>console.error(je));const[ke,pe,ee,fe,ge,Ie,Me,We]=this.b();try{try{await this.d(ee,We,fe,ge,Me)}catch(je){throw this.f(ee,Me,je),je}await ke.invokeFunction(async je=>{const Ke=je.get(K.$lj),Be=je.get(T.$79b),He=je.get(A.$ok),Ve=je.get(K.$mj),ie=await this.e(Ke,ee,Be,ke,Me,!0);return h.Promises.writeFile(ee.mainLockfile,String(process.pid)).catch(de=>{Ke.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Ie.logger=Ve.createLogger("main",{name:(0,t.localize)(0,null)}),y.Event.once(Be.onWillShutdown)(de=>{He.dispose(),fe.dispose(),de.join("instanceLockfile",h.Promises.unlink(ee.mainLockfile).catch(()=>{}))}),ke.createInstance(u.$x$b,ie,pe).startup()})}catch(je){ke.invokeFunction(this.i,je)}}b(){const ke=new W.$2h,pe=new X.$Sc;process.once("exit",()=>pe.dispose());const ee={_serviceBrand:void 0,...le.default};ke.set(re.$Dj,ee);const fe=new n.$A9b(this.j(),ee),ge=this.c(fe);ke.set(n.$z9b,fe);const Ie=new _.$39b((0,K.$zj)(fe),fe.logsHome);ke.set(_.$29b,Ie);const Me=new G.$i7b(Ie.getLogLevel()),We=pe.add(new ce.$kO(Me,[new K.$sj(Ie.getLogLevel())]));ke.set(K.$lj,We);const je=new I.$4p(We);ke.set(A.$ok,je);const Ke=new E.$qq(We);je.registerProvider(p.Schemas.file,Ke);const Be=new B.$Qr(je);ke.set(N.$Yk,Be);const He=new $e.$fO(1,fe,We,je);ke.set(te.$bO,He),ke.set(te.$cO,He);const Ve=new O.$R9b(He,Be,fe,je,We);ke.set(O.$Q9b,Ve),je.registerProvider(p.Schemas.vscodeUserData,new me.$I$b(p.Schemas.file,Ke,p.Schemas.vscodeUserData,Ve,Be,We));const ie=m.$i&&ee.win32RegValueName?pe.add(new x.$G$b(We,ee.win32RegValueName)):fe.policyFile?pe.add(new z.$H$b(fe.policyFile,je,We)):new F.$An;ke.set(F.$yn,ie);const de=new r.$1n(Ve.defaultProfile.settingsResource,je,ie,We);return ke.set(o.$xi,de),ke.set(T.$79b,new C.$1h(T.$89b,void 0,!1)),ke.set(L.$9o,new C.$1h(U.$E$b,void 0,!0)),ke.set(J.$I9b,new C.$1h(J.$J9b)),ke.set(V.$gl,new C.$1h(q.$F$b,void 0,!1)),ke.set(Z.$qv,new C.$1h(H.$C$b)),ke.set(ue.$H9b,new Y.$z$b(fe,Ve,We)),[new j.$tq(ke,!0),ge,fe,de,He,Me,ee,Ve]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ee=>{const fe=process.env[ee];typeof fe=="string"&&(pe[ee]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,ee,fe,ge){await D.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:p.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:p.Schemas.file}).fsPath,ke.backupHome].map(Ie=>Ie?h.Promises.mkdir(Ie,{recursive:!0}):void 0)),fe.init(),ee.initialize()]),pe.init()}async e(ke,pe,ee,fe,ge,Ie){let Me;try{(0,b.mark)("code/willStartMainServer"),Me=await(0,v.$Yh)(pe.mainIPCHandle),(0,b.mark)("code/didStartMainServer"),y.Event.once(ee.onWillShutdown)(()=>Me.dispose())}catch(We){if(We.code!=="EADDRINUSE")throw this.f(pe,ge,We),We;let je;try{je=await(0,v.$Zh)(pe.mainIPCHandle,"main")}catch(Ve){if(!Ie||m.$i||Ve.code!=="ECONNREFUSED")throw Ve.code==="EPERM"&&this.g((0,t.localize)(1,null,ge.nameShort),(0,t.localize)(2,null),ge),Ve;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch(ie){throw ke.warn("Could not delete obsolete instance handle",ie),ie}return this.e(ke,pe,ee,fe,ge,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const Ve=`Running extension tests from the command line is currently only supported if no other instance of ${ge.nameShort} is running.`;throw ke.error(Ve),je.dispose(),new Error(Ve)}let Ke;!pe.args.wait&&!pe.args.status&&(Ke=setTimeout(()=>{this.g((0,t.localize)(3,null,ge.nameShort),(0,t.localize)(4,null),ge)},1e4));const Be=g.ProxyChannel.toService(je.getChannel("launch"),{disableMarshalling:!0}),He=g.ProxyChannel.toService(je.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const Ve=new i.$Xr(he.$Bo,ge),ie=await He.getMainDiagnostics(),de=await He.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),be=await Ve.getDiagnostics(ie,de);throw console.log(be),new f.$ab});throw m.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),je.dispose(),Ke&&clearTimeout(Ke),new f.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,ge.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Me}f(ke,pe,ee){if(ee.code==="EACCES"||ee.code==="EPERM"){const fe=(0,M.$Hb)([ke.userDataPath,ke.extensionsPath,v.$Uh]).map(ge=>(0,k.$Lv)(s.URI.file(ge),{os:m.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$Oi)(ee),fe.join(`
`)),pe)}}g(ke,pe,ee){P.dialog.showMessageBoxSync((0,se.$Zv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},ee).options)}async h(ke,pe){if(m.$i){const ee=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",ee);try{(await new Promise((fe,ge)=>{Q(["windows-foreground-love"],fe,ge)})).allowSetForegroundWindow(ee)}catch(fe){pe.error(fe)}}}i(ke,pe){const ee=ke.get(K.$lj),fe=ke.get(T.$79b);let ge=0;pe&&(pe.isExpected?pe.message&&ee.trace(pe.message):(ge=1,pe.stack?ee.error(pe.stack):ee.error(`Startup error: ${pe.toString()}`))),fe.kill(ge)}j(){const ke=this.k((0,a.$1l)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,w.$y$b)(ke.verbose);pe&&((0,a.$3l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const ee=(0,$.cwd)(),fe=ke.map(Me=>{let We=String(Me),je;pe&&(je=(0,l.$ag)(We),We=je.path),We&&(We=this.m(ee,We));const Ke=(0,l.$8f)(We,ee),Be=(0,c.$nc)(Ke);return Be&&!(0,l.$4f)(Be)?null:pe&&je?(je.path=Ke,this.n(je)):Ke}),ge=m.$i||m.$j,Ie=(0,M.$Mb)(fe,Me=>Me&&ge?Me.toLowerCase():Me||"");return(0,M.$Hb)(Ie)}m(ke,pe){return m.$i&&(pe=(0,d.$Se)(pe,'"')),pe=(0,d.$Qe)((0,d.$Qe)(pe," "),"	"),m.$i&&(pe=(0,c.$kc)(ke,pe),pe=(0,d.$Se)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new ye().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1cfc62d46e6b9dd217cd485d7d4591136f421d70/core/vs/code/electron-main/main.js.map
