/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/uuid","vs/base/common/strings","vs/base/common/objects","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(G){for(var e=[],L=0,D=G.length;L<D;L++)e[L]=te[G[L]];return e};define(te[70],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const j=new Map,N=new Map,A=new Map,b=new Map;function h(f,E){f.has(E.detail)||f.set(E.detail,-E.timestamp)}function c(f,E){const v=f.get(E.detail);v&&(v>=0||f.set(E.detail,v+E.timestamp))}let P=[];typeof G=="function"&&typeof G.getStats=="function"&&(P=G.getStats().slice(0).sort((f,E)=>f.timestamp-E.timestamp));for(const f of P)switch(f.type){case 10:h(j,f);break;case 11:case 12:c(j,f);break;case 21:h(N,f);break;case 22:c(N,f);break;case 33:h(A,f);break;case 34:c(A,f);break;case 31:h(b,f);break;case 32:c(b,f);break}let O=0;A.forEach(f=>O+=f);function g(f){const E=[];return f.forEach((v,d)=>E.push([d,v])),E}return{amdLoad:g(j),amdInvoke:g(N),nodeRequire:g(A),nodeEval:g(b),nodeRequireTotal:O}}static toMarkdownTable(j,N){let A="";const b=[];return j.forEach((h,c)=>{b[c]=h.length}),N.forEach(h=>{h.forEach((c,P)=>{typeof c>"u"&&(c=h[P]="-");const O=c.toString().length;b[P]=Math.max(O,b[P])})}),j.forEach((h,c)=>{A+=`| ${h+" ".repeat(b[c]-h.toString().length)} `}),A+=`|
`,j.forEach((h,c)=>{A+=`| ${"-".repeat(b[c])} `}),A+=`|
`,N.forEach(h=>{h.forEach((c,P)=>{typeof c<"u"&&(A+=`| ${c+" ".repeat(b[P]-c.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(te[52],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function L(A){return(b,h,c)=>{let P=null,O=null;if(typeof c.value=="function"?(P="value",O=c.value):typeof c.get=="function"&&(P="get",O=c.get),!O)throw new Error("not supported");c[P]=A(O,h)}}function D(A,b,h){let c=null,P=null;if(typeof h.value=="function"?(c="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",P=h.get),!P)throw new Error("not supported");const O=`$memoize$${b}`;h[c]=function(...g){return this.hasOwnProperty(O)||Object.defineProperty(this,O,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,g)}),this[O]}}e.$vh=D;function j(A,b,h){return L((c,P)=>{const O=`$debounce$${P}`,g=`$debounce$result$${P}`;return function(...f){this[g]||(this[g]=h?h():void 0),clearTimeout(this[O]),b&&(this[g]=b(this[g],...f),f=[this[g]]),this[O]=setTimeout(()=>{c.apply(this,f),this[g]=h?h():void 0},A)}})}e.$wh=j;function N(A,b,h){return L((c,P)=>{const O=`$throttle$timer$${P}`,g=`$throttle$result$${P}`,f=`$throttle$lastRun$${P}`,E=`$throttle$pending$${P}`;return function(...v){if(this[g]||(this[g]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[g]=b(this[g],...v)),this[E])return;const d=this[f]+A;d<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[g]]),this[g]=h?h():void 0):(this[E]=!0,this[O]=setTimeout(()=>{this[E]=!1,this[f]=Date.now(),c.apply(this,[this[g]]),this[g]=h?h():void 0},d-Date.now()))}})}e.$xh=N}),define(te[71],ne([0,1,9]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=D;function j(h,c="Unreachable"){throw new Error(c)}e.$6c=j;function N(h){if(!h)throw new L.$cb("Assertion Failed")}e.$7c=N;function A(h){if(!h()){debugger;h(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$8c=A;function b(h,c){let P=0;for(;P<h.length-1;){const O=h[P],g=h[P+1];if(!c(O,g))return!1;P++}return!0}e.$9c=b}),define(te[53],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var j;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(j||(e.ParseErrorCode=j={}));var N;(function(s){s.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(s,o=!1){let t=0;const i=s.length;let n="",r=0,l=16,S=0;function k(se){let ue=0,ce=0;for(;ue<se;){const oe=s.charCodeAt(t);if(oe>=48&&oe<=57)ce=ce*16+oe-48;else if(oe>=65&&oe<=70)ce=ce*16+oe-65+10;else if(oe>=97&&oe<=102)ce=ce*16+oe-97+10;else break;t++,ue++}return ue<se&&(ce=-1),ce}function w(se){t=se,n="",r=0,l=16,S=0}function R(){const se=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&c(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&c(s.charCodeAt(t)))for(t++;t<s.length&&c(s.charCodeAt(t));)t++;else return S=3,s.substring(se,t);let ue=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&c(s.charCodeAt(t))){for(t++;t<s.length&&c(s.charCodeAt(t));)t++;ue=t}else S=3;return s.substring(se,ue)}function H(){let se="",ue=t;for(;;){if(t>=i){se+=s.substring(ue,t),S=2;break}const ce=s.charCodeAt(t);if(ce===34){se+=s.substring(ue,t),t++;break}if(ce===92){if(se+=s.substring(ue,t),t++,t>=i){S=2;break}switch(s.charCodeAt(t++)){case 34:se+='"';break;case 92:se+="\\";break;case 47:se+="/";break;case 98:se+="\b";break;case 102:se+="\f";break;case 110:se+=`
`;break;case 114:se+="\r";break;case 116:se+="	";break;case 117:{const B=k(4);B>=0?se+=String.fromCharCode(B):S=4;break}default:S=5}ue=t;continue}if(ce>=0&&ce<=31)if(h(ce)){se+=s.substring(ue,t),S=2;break}else S=6;t++}return se}function ee(){if(n="",S=0,r=t,t>=i)return r=i,l=17;let se=s.charCodeAt(t);if(b(se)){do t++,n+=String.fromCharCode(se),se=s.charCodeAt(t);while(b(se));return l=15}if(h(se))return t++,n+=String.fromCharCode(se),se===13&&s.charCodeAt(t)===10&&(t++,n+=`
`),l=14;switch(se){case 123:return t++,l=1;case 125:return t++,l=2;case 91:return t++,l=3;case 93:return t++,l=4;case 58:return t++,l=6;case 44:return t++,l=5;case 34:return t++,n=H(),l=10;case 47:{const ue=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!h(s.charCodeAt(t));)t++;return n=s.substring(ue,t),l=12}if(s.charCodeAt(t+1)===42){t+=2;const ce=i-1;let oe=!1;for(;t<ce;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,oe=!0;break}t++}return oe||(t++,S=1),n=s.substring(ue,t),l=13}return n+=String.fromCharCode(se),t++,l=16}case 45:if(n+=String.fromCharCode(se),t++,t===i||!c(s.charCodeAt(t)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=R(),l=11;default:for(;t<i&&_(se);)t++,se=s.charCodeAt(t);if(r!==t){switch(n=s.substring(r,t),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(se),t++,l=16}}function _(se){if(b(se)||h(se))return!1;switch(se){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let se;do se=ee();while(se>=12&&se<=15);return se}return{setPosition:w,getPosition:()=>t,scan:o?re:ee,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>r,getTokenLength:()=>t-r,getTokenError:()=>S}}e.$$m=A;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function h(s){return s===10||s===13||s===8232||s===8233}function c(s){return s>=48&&s<=57}var P;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(P||(P={}));function O(s,o){const t=[],i=new Object;let n;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function S(k,w,R,H){r.value=k,r.offset=w,r.length=R,r.type=H,r.colonOffset=void 0,n=r}try{I(s,{onObjectBegin:(k,w)=>{if(o<=k)throw i;n=void 0,l=o>k,t.push("")},onObjectProperty:(k,w,R)=>{if(o<w||(S(k,w,R,"property"),t[t.length-1]=k,o<=w+R))throw i},onObjectEnd:(k,w)=>{if(o<=k)throw i;n=void 0,t.pop()},onArrayBegin:(k,w)=>{if(o<=k)throw i;n=void 0,t.push(0)},onArrayEnd:(k,w)=>{if(o<=k)throw i;n=void 0,t.pop()},onLiteralValue:(k,w,R)=>{if(o<w||(S(k,w,R,y(k)),o<=w+R))throw i},onSeparator:(k,w,R)=>{if(o<=w)throw i;if(k===":"&&n&&n.type==="property")n.colonOffset=w,l=!1,n=void 0;else if(k===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(l=!0,t[t.length-1]=""),n=void 0}}})}catch(k){if(k!==i)throw k}return{path:t,previousNode:n,isAtPropertyKey:l,matches:k=>{let w=0;for(let R=0;w<k.length&&R<t.length;R++)if(k[w]===t[R]||k[w]==="*")w++;else if(k[w]!=="**")return!1;return w===k.length}}}e.$_m=O;function g(s,o=[],t=N.DEFAULT){let i=null,n=[];const r=[];function l(k){Array.isArray(n)?n.push(k):i!==null&&(n[i]=k)}return I(s,{onObjectBegin:()=>{const k={};l(k),r.push(n),n=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{n=r.pop()},onArrayBegin:()=>{const k=[];l(k),r.push(n),n=k,i=null},onArrayEnd:()=>{n=r.pop()},onLiteralValue:l,onError:(k,w,R)=>{o.push({error:k,offset:w,length:R})}},t),n[0]}e.$an=g;function f(s,o=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function r(k){return i.children.push(k),k}I(s,{onObjectBegin:k=>{i=r({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,w,R)=>{i=r({type:"property",offset:w,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:w,length:R,parent:i})},onObjectEnd:(k,w)=>{i.length=k+w-i.offset,i=i.parent,n(k+w)},onArrayBegin:(k,w)=>{i=r({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,w)=>{i.length=k+w-i.offset,i=i.parent,n(k+w)},onLiteralValue:(k,w,R)=>{r({type:y(k),offset:w,length:R,parent:i,value:k}),n(w+R)},onSeparator:(k,w,R)=>{i.type==="property"&&(k===":"?i.colonOffset=w:k===","&&n(w))},onError:(k,w,R)=>{o.push({error:k,offset:w,length:R})}},t);const S=i.children[0];return S&&delete S.parent,S}e.$bn=f;function E(s,o){if(!s)return;let t=s;for(const i of o)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let n=!1;for(const r of t.children)if(Array.isArray(r.children)&&r.children[0].value===i){t=r.children[1],n=!0;break}if(!n)return}else{const n=i;if(t.type!=="array"||n<0||!Array.isArray(t.children)||n>=t.children.length)return;t=t.children[n]}return t}e.$cn=E;function v(s){if(!s.parent||!s.parent.children)return[];const o=v(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;o.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&o.push(t)}return o}e.$dn=v;function d(s){switch(s.type){case"array":return s.children.map(d);case"object":{const o=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(o[t.children[0].value]=d(i))}return o}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.$en=d;function u(s,o,t=!1){return o>=s.offset&&o<s.offset+s.length||t&&o===s.offset+s.length}e.$fn=u;function p(s,o,t=!1){if(u(s,o,t)){const i=s.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const r=p(i[n],o,t);if(r)return r}return s}}e.$gn=p;function I(s,o,t=N.DEFAULT){const i=A(s,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(Q){return Q?K=>Q(K,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=n(o.onObjectBegin),S=r(o.onObjectProperty),k=n(o.onObjectEnd),w=n(o.onArrayBegin),R=n(o.onArrayEnd),H=r(o.onLiteralValue),ee=r(o.onSeparator),_=n(o.onComment),re=r(o.onError),se=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function ce(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:se||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Q){case 12:case 13:se?oe(10):_();break;case 16:oe(1);break;case 15:case 14:break;default:return Q}}}function oe(Q,K=[],T=[]){if(re(Q),K.length+T.length>0){let z=i.getToken();for(;z!==17;){if(K.indexOf(z)!==-1){ce();break}else if(T.indexOf(z)!==-1)break;z=ce()}}}function B(Q){const K=i.getTokenValue();return Q?H(K):S(K),ce(),!0}function X(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(oe(2),Q=0)}catch{oe(2)}H(Q);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function M(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(B(!1),i.getToken()===6?(ee(":"),ce(),J()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function C(){l(),ce();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),ee(","),ce(),i.getToken()===2&&ue)break}else Q&&oe(6,[],[]);M()||oe(4,[],[2,5]),Q=!0}return k(),i.getToken()!==2?oe(7,[2],[]):ce(),!0}function V(){w(),ce();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),ee(","),ce(),i.getToken()===4&&ue)break}else Q&&oe(6,[],[]);J()||oe(4,[],[4,5]),Q=!0}return R(),i.getToken()!==4?oe(8,[4],[]):ce(),!0}function J(){switch(i.getToken()){case 3:return V();case 1:return C();case 10:return B(!0);default:return X()}}return ce(),i.getToken()===17?t.allowEmptyContent?!0:(oe(4,[],[]),!1):J()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$hn=I;function m(s,o){const t=A(s),i=[];let n,r=0,l;do switch(l=t.getPosition(),n=t.scan(),n){case 12:case 13:case 17:r!==l&&i.push(s.substring(r,l)),o!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,o)),r=t.getPosition();break}while(n!==17);return i.join("")}e.$in=m;function y(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.$jn=y}),define(te[72],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9l=e.$8l=e.$7l=e.rot=e.$5l=void 0;function L(b,h,c){return Math.min(Math.max(b,h),c)}e.$5l=L;function D(b,h){return(h+b%h)%h}e.rot=D;class j{constructor(){this.a=0}getNext(){return this.a++}}e.$7l=j;class N{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$8l=N;class A{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$9l=A}),function(){function G(j){const N=[];typeof j=="number"&&N.push("code/timeOrigin",j);function A(h){N.push(h,Date.now())}function b(){const h=[];for(let c=0;c<N.length;c+=2)h.push({name:N[c],startTime:N[c+1]});return h}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(j){performance.mark(j)},getMarks(){let j=performance.timeOrigin;typeof j!="number"&&(j=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(j)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(j+A.startTime)});return N}};if(typeof process=="object"){const j=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(j)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function L(j){return j.MonacoPerformanceMarks||(j.MonacoPerformanceMarks=e()),j.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:G)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function L(D){if(e[D])return e[D].exports;var j=e[D]={i:D,l:!1,exports:{}};return G[D].call(j.exports,j,j.exports,L),j.l=!0,j.exports}return L.m=G,L.c=e,L.d=function(D,j,N){L.o(D,j)||Object.defineProperty(D,j,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,j){if(1&j&&(D=L(D)),8&j||4&j&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&j&&typeof D!="string")for(var A in D)L.d(N,A,function(b){return D[b]}.bind(null,A));return N},L.n=function(D){var j=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(j,"a",j),j},L.o=function(D,j){return Object.prototype.hasOwnProperty.call(D,j)},L.p="",L(L.s=0)}([function(G,e,L){(function(D){var j;e=G.exports=T,j=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],h=e.src=[],c=0,P=c++;h[P]="0|[1-9]\\d*";var O=c++;h[O]="[0-9]+";var g=c++;h[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[P]+")\\.("+h[P]+")\\.("+h[P]+")";var E=c++;h[E]="("+h[O]+")\\.("+h[O]+")\\.("+h[O]+")";var v=c++;h[v]="(?:"+h[P]+"|"+h[g]+")";var d=c++;h[d]="(?:"+h[O]+"|"+h[g]+")";var u=c++;h[u]="(?:-("+h[v]+"(?:\\."+h[v]+")*))";var p=c++;h[p]="(?:-?("+h[d]+"(?:\\."+h[d]+")*))";var I=c++;h[I]="[0-9A-Za-z-]+";var m=c++;h[m]="(?:\\+("+h[I]+"(?:\\."+h[I]+")*))";var y=c++,s="v?"+h[f]+h[u]+"?"+h[m]+"?";h[y]="^"+s+"$";var o="[v=\\s]*"+h[E]+h[p]+"?"+h[m]+"?",t=c++;h[t]="^"+o+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[O]+"|x|X|\\*";var r=c++;h[r]=h[P]+"|x|X|\\*";var l=c++;h[l]="[v=\\s]*("+h[r]+")(?:\\.("+h[r]+")(?:\\.("+h[r]+")(?:"+h[u]+")?"+h[m]+"?)?)?";var S=c++;h[S]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[p]+")?"+h[m]+"?)?)?";var k=c++;h[k]="^"+h[i]+"\\s*"+h[l]+"$";var w=c++;h[w]="^"+h[i]+"\\s*"+h[S]+"$";var R=c++;h[R]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=c++;h[H]="(?:~>?)";var ee=c++;h[ee]="(\\s*)"+h[H]+"\\s+",b[ee]=new RegExp(h[ee],"g");var _=c++;h[_]="^"+h[H]+h[l]+"$";var re=c++;h[re]="^"+h[H]+h[S]+"$";var se=c++;h[se]="(?:\\^)";var ue=c++;h[ue]="(\\s*)"+h[se]+"\\s+",b[ue]=new RegExp(h[ue],"g");var ce=c++;h[ce]="^"+h[se]+h[l]+"$";var oe=c++;h[oe]="^"+h[se]+h[S]+"$";var B=c++;h[B]="^"+h[i]+"\\s*("+o+")$|^$";var X=c++;h[X]="^"+h[i]+"\\s*("+s+")$|^$";var M=c++;h[M]="(\\s*)"+h[i]+"\\s*("+o+"|"+h[l]+")",b[M]=new RegExp(h[M],"g");var C=c++;h[C]="^\\s*("+h[l]+")\\s+-\\s+("+h[l]+")\\s*$";var V=c++;h[V]="^\\s*("+h[S]+")\\s+-\\s+("+h[S]+")\\s*$";var J=c++;h[J]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)j(Q,h[Q]),b[Q]||(b[Q]=new RegExp(h[Q]));function K(q,Z){if(q instanceof T)return q;if(typeof q!="string"||q.length>N||!(Z?b[t]:b[y]).test(q))return null;try{return new T(q,Z)}catch{return null}}function T(q,Z){if(q instanceof T){if(q.loose===Z)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof T))return new T(q,Z);j("SemVer",q,Z),this.loose=Z;var x=q.trim().match(Z?b[t]:b[y]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ye=+$e;if(ye>=0&&ye<A)return ye}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(q,Z){var x=K(q,Z);return x?x.version:null},e.clean=function(q,Z){var x=K(q.trim().replace(/^[=v]+/,""),Z);return x?x.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(q){return j("SemVer.compare",this.version,this.loose,q),q instanceof T||(q=new T(q,this.loose)),this.compareMain(q)||this.comparePre(q)},T.prototype.compareMain=function(q){return q instanceof T||(q=new T(q,this.loose)),a(this.major,q.major)||a(this.minor,q.minor)||a(this.patch,q.patch)},T.prototype.comparePre=function(q){if(q instanceof T||(q=new T(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Z=0;do{var x=this.prerelease[Z],$e=q.prerelease[Z];if(j("prerelease compare",Z,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return a(x,$e)}while(++Z)},T.prototype.inc=function(q,Z){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Z),this.inc("pre",Z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Z),this.inc("pre",Z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Z&&(this.prerelease[0]===Z?isNaN(this.prerelease[1])&&(this.prerelease=[Z,0]):this.prerelease=[Z,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Z,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new T(q,x).inc(Z,$e).version}catch{return null}},e.diff=function(q,Z){if(Y(q,Z))return null;var x=K(q),$e=K(Z);if(x.prerelease.length||$e.prerelease.length){for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return"pre"+ye;return"prerelease"}for(var ye in x)if((ye==="major"||ye==="minor"||ye==="patch")&&x[ye]!==$e[ye])return ye},e.compareIdentifiers=a;var z=/^[0-9]+$/;function a(q,Z){var x=z.test(q),$e=z.test(Z);return x&&$e&&(q=+q,Z=+Z),x&&!$e?-1:$e&&!x?1:q<Z?-1:q>Z?1:0}function $(q,Z,x){return new T(q,x).compare(new T(Z,x))}function F(q,Z,x){return $(q,Z,x)>0}function U(q,Z,x){return $(q,Z,x)<0}function Y(q,Z,x){return $(q,Z,x)===0}function W(q,Z,x){return $(q,Z,x)!==0}function le(q,Z,x){return $(q,Z,x)>=0}function ae(q,Z,x){return $(q,Z,x)<=0}function me(q,Z,x,$e){var ye;switch(Z){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),ye=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),ye=q!==x;break;case"":case"=":case"==":ye=Y(q,x,$e);break;case"!=":ye=W(q,x,$e);break;case">":ye=F(q,x,$e);break;case">=":ye=le(q,x,$e);break;case"<":ye=U(q,x,$e);break;case"<=":ye=ae(q,x,$e);break;default:throw new TypeError("Invalid operator: "+Z)}return ye}function de(q,Z){if(q instanceof de){if(q.loose===Z)return q;q=q.value}if(!(this instanceof de))return new de(q,Z);j("comparator",q,Z),this.loose=Z,this.parse(q),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,j("comp",this)}e.rcompareIdentifiers=function(q,Z){return a(Z,q)},e.major=function(q,Z){return new T(q,Z).major},e.minor=function(q,Z){return new T(q,Z).minor},e.patch=function(q,Z){return new T(q,Z).patch},e.compare=$,e.compareLoose=function(q,Z){return $(q,Z,!0)},e.rcompare=function(q,Z,x){return $(Z,q,x)},e.sort=function(q,Z){return q.sort(function(x,$e){return e.compare(x,$e,Z)})},e.rsort=function(q,Z){return q.sort(function(x,$e){return e.rcompare(x,$e,Z)})},e.gt=F,e.lt=U,e.eq=Y,e.neq=W,e.gte=le,e.lte=ae,e.cmp=me,e.Comparator=de;var ge={};function fe(q,Z){if(q instanceof fe)return q.loose===Z?q:new fe(q.raw,Z);if(q instanceof de)return new fe(q.value,Z);if(!(this instanceof fe))return new fe(q,Z);if(this.loose=Z,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function he(q){return!q||q.toLowerCase()==="x"||q==="*"}function we(q,Z,x,$e,ye,je,Pe,Le,Ie,Ae,Ce,Oe,De){return((Z=he(x)?"":he($e)?">="+x+".0.0":he(ye)?">="+x+"."+$e+".0":">="+Z)+" "+(Le=he(Ie)?"":he(Ae)?"<"+(+Ie+1)+".0.0":he(Ce)?"<"+Ie+"."+(+Ae+1)+".0":Oe?"<="+Ie+"."+Ae+"."+Ce+"-"+Oe:"<="+Le)).trim()}function be(q,Z){for(var x=0;x<q.length;x++)if(!q[x].test(Z))return!1;if(Z.prerelease.length){for(x=0;x<q.length;x++)if(j(q[x].semver),q[x].semver!==ge&&q[x].semver.prerelease.length>0){var $e=q[x].semver;if($e.major===Z.major&&$e.minor===Z.minor&&$e.patch===Z.patch)return!0}return!1}return!0}function ke(q,Z,x){try{Z=new fe(Z,x)}catch{return!1}return Z.test(q)}function Te(q,Z,x,$e){var ye,je,Pe,Le,Ie;switch(q=new T(q,$e),Z=new fe(Z,$e),x){case">":ye=F,je=ae,Pe=U,Le=">",Ie=">=";break;case"<":ye=U,je=le,Pe=F,Le="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(q,Z,$e))return!1;for(var Ae=0;Ae<Z.set.length;++Ae){var Ce=Z.set[Ae],Oe=null,De=null;if(Ce.forEach(function(Fe){Fe.semver===ge&&(Fe=new de(">=0.0.0")),Oe=Oe||Fe,De=De||Fe,ye(Fe.semver,Oe.semver,$e)?Oe=Fe:Pe(Fe.semver,De.semver,$e)&&(De=Fe)}),Oe.operator===Le||Oe.operator===Ie||(!De.operator||De.operator===Le)&&je(q,De.semver)||De.operator===Ie&&Pe(q,De.semver))return!1}return!0}de.prototype.parse=function(q){var Z=this.loose?b[B]:b[X],x=q.match(Z);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new T(x[2],this.loose):this.semver=ge},de.prototype.toString=function(){return this.value},de.prototype.test=function(q){return j("Comparator.test",q,this.loose),this.semver===ge||(typeof q=="string"&&(q=new T(q,this.loose)),me(q,this.operator,this.semver,this.loose))},de.prototype.intersects=function(q,Z){if(!(q instanceof de))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new fe(q.value,Z),ke(this.value,x,Z);if(q.operator==="")return x=new fe(this.value,Z),ke(q.semver,x,Z);var $e=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),je=this.semver.version===q.semver.version,Pe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Le=me(this.semver,"<",q.semver,Z)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Ie=me(this.semver,">",q.semver,Z)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return $e||ye||je&&Pe||Le||Ie},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(q){var Z=this.loose;q=q.trim(),j("range",q,Z);var x=Z?b[V]:b[C];q=q.replace(x,we),j("hyphen replace",q),q=q.replace(b[M],"$1$2$3"),j("comparator trim",q,b[M]),q=(q=(q=q.replace(b[ee],"$1~")).replace(b[ue],"$1^")).split(/\s+/).join(" ");var $e=Z?b[B]:b[X],ye=q.split(" ").map(function(je){return function(Pe,Le){return j("comp",Pe),Pe=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,De){j("caret",Oe,De);var Fe=De?b[oe]:b[ce];return Oe.replace(Fe,function(Ne,ve,Ee,Se,Re){var ze;return j("caret",Oe,Ne,ve,Ee,Se,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Se)?ze=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":Re?(j("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Se+Re+" <"+ve+"."+Ee+"."+(+Se+1):">="+ve+"."+Ee+"."+Se+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Se+Re+" <"+(+ve+1)+".0.0"):(j("no pr"),ze=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Se+" <"+ve+"."+Ee+"."+(+Se+1):">="+ve+"."+Ee+"."+Se+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Se+" <"+(+ve+1)+".0.0"),j("caret return",ze),ze})}(Ce,Ae)}).join(" ")}(Pe,Le),j("caret",Pe),Pe=function(Ie,Ae){return Ie.trim().split(/\s+/).map(function(Ce){return function(Oe,De){var Fe=De?b[re]:b[_];return Oe.replace(Fe,function(Ne,ve,Ee,Se,Re){var ze;return j("tilde",Oe,Ne,ve,Ee,Se,Re),he(ve)?ze="":he(Ee)?ze=">="+ve+".0.0 <"+(+ve+1)+".0.0":he(Se)?ze=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":Re?(j("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),ze=">="+ve+"."+Ee+"."+Se+Re+" <"+ve+"."+(+Ee+1)+".0"):ze=">="+ve+"."+Ee+"."+Se+" <"+ve+"."+(+Ee+1)+".0",j("tilde return",ze),ze})}(Ce,Ae)}).join(" ")}(Pe,Le),j("tildes",Pe),Pe=function(Ie,Ae){return j("replaceXRanges",Ie,Ae),Ie.split(/\s+/).map(function(Ce){return function(Oe,De){Oe=Oe.trim();var Fe=De?b[w]:b[k];return Oe.replace(Fe,function(Ne,ve,Ee,Se,Re,ze){j("xRange",Oe,Ne,ve,Ee,Se,Re,ze);var Be=he(Ee),Ue=Be||he(Se),Me=Ue||he(Re);return ve==="="&&Me&&(ve=""),Be?Ne=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Me?(Ue&&(Se=0),Me&&(Re=0),ve===">"?(ve=">=",Ue?(Ee=+Ee+1,Se=0,Re=0):Me&&(Se=+Se+1,Re=0)):ve==="<="&&(ve="<",Ue?Ee=+Ee+1:Se=+Se+1),Ne=ve+Ee+"."+Se+"."+Re):Ue?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Me&&(Ne=">="+Ee+"."+Se+".0 <"+Ee+"."+(+Se+1)+".0"),j("xRange return",Ne),Ne})}(Ce,Ae)}).join(" ")}(Pe,Le),j("xrange",Pe),Pe=function(Ie,Ae){return j("replaceStars",Ie,Ae),Ie.trim().replace(b[J],"")}(Pe,Le),j("stars",Pe),Pe}(je,Z)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(je){return!!je.match($e)})),ye=ye.map(function(je){return new de(je,Z)})},fe.prototype.intersects=function(q,Z){if(!(q instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return q.set.some(function(ye){return ye.every(function(je){return $e.intersects(je,Z)})})})})},e.toComparators=function(q,Z){return new fe(q,Z).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new T(q,this.loose));for(var Z=0;Z<this.set.length;Z++)if(be(this.set[Z],q))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(q,Z,x){var $e=null,ye=null;try{var je=new fe(Z,x)}catch{return null}return q.forEach(function(Pe){je.test(Pe)&&($e&&ye.compare(Pe)!==-1||(ye=new T($e=Pe,x)))}),$e},e.minSatisfying=function(q,Z,x){var $e=null,ye=null;try{var je=new fe(Z,x)}catch{return null}return q.forEach(function(Pe){je.test(Pe)&&($e&&ye.compare(Pe)!==1||(ye=new T($e=Pe,x)))}),$e},e.validRange=function(q,Z){try{return new fe(q,Z).range||"*"}catch{return null}},e.ltr=function(q,Z,x){return Te(q,Z,"<",x)},e.gtr=function(q,Z,x){return Te(q,Z,">",x)},e.outside=Te,e.prerelease=function(q,Z){var x=K(q,Z);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,Z,x){return q=new fe(q,x),Z=new fe(Z,x),q.intersects(Z)},e.coerce=function(q){if(q instanceof T)return q;if(typeof q!="string")return null;var Z=q.match(b[R]);return Z==null?null:K((Z[1]||"0")+"."+(Z[2]||"0")+"."+(Z[3]||"0"))}}).call(this,L(1))},function(G,e){var L,D,j=G.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(d){if(L===setTimeout)return setTimeout(d,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout(d,0);try{return L(d,0)}catch{try{return L.call(null,d,0)}catch{return L.call(this,d,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var h,c=[],P=!1,O=-1;function g(){P&&h&&(P=!1,h.length?c=h.concat(c):O=-1,c.length&&f())}function f(){if(!P){var d=b(g);P=!0;for(var u=c.length;u;){for(h=c,c=[];++O<u;)h&&h[O].run();O=-1,u=c.length}h=null,P=!1,function(p){if(D===clearTimeout)return clearTimeout(p);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(p);try{D(p)}catch{try{return D.call(null,p)}catch{return D.call(this,p)}}}(d)}}function E(d,u){this.fun=d,this.array=u}function v(){}j.nextTick=function(d){var u=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)u[p-1]=arguments[p];c.push(new E(d,u)),c.length!==1||P||b(f)},E.prototype.run=function(){this.fun.apply(null,this.array)},j.title="browser",j.browser=!0,j.env={},j.argv=[],j.version="",j.versions={},j.on=v,j.addListener=v,j.once=v,j.off=v,j.removeListener=v,j.removeAllListeners=v,j.emit=v,j.prependListener=v,j.prependOnceListener=v,j.listeners=function(d){return[]},j.binding=function(d){throw new Error("process.binding is not supported")},j.cwd=function(){return"/"},j.chdir=function(d){throw new Error("process.chdir is not supported")},j.umask=function(){return 0}}])}),define(te[73],ne([0,1]),function(G,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;class D{constructor(b,h,c){this.level=b,this.key=h,this.value=c,this.forward=[]}}const j=void 0;class N{constructor(b,h=2**16){this.comparator=b,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new D(this.c,j,j)}get size(){return this.f}clear(){this.e=new D(this.c,j,j),this.f=0}has(b){return!!N.g(this,b,this.comparator)}get(b){return N.g(this,b,this.comparator)?.value}set(b,h){return N.h(this,b,h,this.comparator)&&(this.f+=1),this}delete(b){const h=N.k(this,b,this.comparator);return h&&(this.f-=1),h}forEach(b,h){let c=this.e.forward[0];for(;c;)b.call(h,c.value,c.key,this),c=c.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",h=this.e.forward[0];for(;h;)b+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return b}static g(b,h,c){let P=b.e;for(let O=b.d-1;O>=0;O--)for(;P.forward[O]&&c(P.forward[O].key,h)<0;)P=P.forward[O];if(P=P.forward[0],P&&c(P.key,h)===0)return P}static h(b,h,c,P){const O=[];let g=b.e;for(let f=b.d-1;f>=0;f--){for(;g.forward[f]&&P(g.forward[f].key,h)<0;)g=g.forward[f];O[f]=g}if(g=g.forward[0],g&&P(g.key,h)===0)return g.value=c,!1;{const f=N.j(b);if(f>b.d){for(let E=b.d;E<f;E++)O[E]=b.e;b.d=f}g=new D(f,h,c);for(let E=0;E<f;E++)g.forward[E]=O[E].forward[E],O[E].forward[E]=g;return!0}}static j(b,h=.5){let c=1;for(;Math.random()<h&&c<b.c;)c+=1;return c}static k(b,h,c){const P=[];let O=b.e;for(let g=b.d-1;g>=0;g--){for(;O.forward[g]&&c(O.forward[g].key,h)<0;)O=O.forward[g];P[g]=O}if(O=O.forward[0],!O||c(O.key,h)!==0)return!1;for(let g=0;g<b.d&&P[g].forward[g]===O;g++)P[g].forward[g]=O.forward[g];for(;b.d>0&&b.e.forward[b.d-1]===j;)b.d-=1;return!0}}e.$Pr=N}),define(te[45],ne([0,1,9,2]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;function j(m){const y=m;return y?typeof y.read=="function":!1}e.$5d=j;function N(m){const y=m;return y?[y.on,y.pause,y.resume,y.destroy].every(s=>typeof s=="function"):!1}e.$6d=N;function A(m){const y=m;return y?N(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.$7d=A;function b(m,y){return new h(m,y)}e.$8d=b;class h{constructor(y,s){this.e=y,this.f=s,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(s=>this.d.push(s))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(s=>s(y))}h(y){this.c.error.length===0?(0,L.$1)(y):this.c.error.slice(0).forEach(s=>s(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,s){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(s),this.resume();break;case"end":this.c.end.push(s),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(s),this.a.flowing&&this.k();break}}removeListener(y,s){if(this.a.destroyed)return;let o;switch(y){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const t=o.indexOf(s);t>=0&&o.splice(t,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const s=[...this.d];this.d.length=0,s.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(m,y){const s=[];let o;for(;(o=m.read())!==null;)s.push(o);return y(s)}e.$9d=c;function P(m,y,s){const o=[];let t;for(;(t=m.read())!==null&&o.length<s;)o.push(t);return t===null&&o.length>0?y(o):{read:()=>{if(o.length>0)return o.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return m.read()}}}e.$0d=P;function O(m,y){return new Promise((s,o)=>{const t=[];g(m,{onData:i=>{y&&t.push(i)},onError:i=>{y?o(i):s(void 0)},onEnd:()=>{s(y?y(t):void 0)}})})}e.$$d=O;function g(m,y,s){m.on("error",o=>{s?.isCancellationRequested||y.onError(o)}),m.on("end",()=>{s?.isCancellationRequested||y.onEnd()}),m.on("data",o=>{s?.isCancellationRequested||y.onData(o)})}e.$_d=g;function f(m,y){return new Promise((s,o)=>{const t=new D.$Sc,i=[],n=S=>{if(i.push(S),i.length>y)return t.dispose(),m.pause(),s({stream:m,buffer:i,ended:!1})},r=S=>(t.dispose(),o(S)),l=()=>(t.dispose(),s({stream:m,buffer:i,ended:!0}));t.add((0,D.$Rc)(()=>m.removeListener("error",r))),m.on("error",r),t.add((0,D.$Rc)(()=>m.removeListener("end",l))),m.on("end",l),t.add((0,D.$Rc)(()=>m.removeListener("data",n))),m.on("data",n)})}e.$ae=f;function E(m,y){const s=b(y);return s.end(m),s}e.$be=E;function v(){const m=b(()=>{throw new Error("not supported")});return m.end(),m}e.$ce=v;function d(m){let y=!1;return{read:()=>y?null:(y=!0,m)}}e.$de=d;function u(m,y,s){const o=b(s);return g(m,{onData:t=>o.write(y.data(t)),onError:t=>o.error(y.error?y.error(t):t),onEnd:()=>o.end()}),o}e.$ee=u;function p(m,y,s){let o=!1;return{read:()=>{const t=y.read();return o?t:(o=!0,t!==null?s([m,t]):m)}}}e.$fe=p;function I(m,y,s){let o=!1;const t=b(s);return g(y,{onData:i=>o?t.write(i):(o=!0,t.write(s([m,i]))),onError:i=>t.error(i),onEnd:()=>{o||(o=!0,t.write(m)),t.end()}}),t}e.$ge=I}),define(te[14],ne([0,1,164,45]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=void 0;const j=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,b;class h{static alloc(R){return j?new h(Buffer.allocUnsafe(R)):new h(new Uint8Array(R))}static wrap(R){return j&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new h(R)}static fromString(R,H){return!(H?.dontUseNodeBuffer||!1)&&j?new h(Buffer.from(R)):(A||(A=new TextEncoder),new h(A.encode(R)))}static fromByteArray(R){const H=h.alloc(R.length);for(let ee=0,_=R.length;ee<_;ee++)H.buffer[ee]=R[ee];return H}static concat(R,H){if(typeof H>"u"){H=0;for(let re=0,se=R.length;re<se;re++)H+=R[re].byteLength}const ee=h.alloc(H);let _=0;for(let re=0,se=R.length;re<se;re++){const ue=R[re];ee.set(ue,_),_+=ue.byteLength}return ee}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=h.alloc(this.byteLength);return R.set(this),R}toString(){return j?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(R,H){return new h(this.buffer.subarray(R,H))}set(R,H){if(R instanceof h)this.buffer.set(R.buffer,H);else if(R instanceof Uint8Array)this.buffer.set(R,H);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),H);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return g(this.buffer,R)}writeUInt32BE(R,H){f(this.buffer,R,H)}readUInt32LE(R){return E(this.buffer,R)}writeUInt32LE(R,H){v(this.buffer,R,H)}readUInt8(R){return d(this.buffer,R)}writeUInt8(R,H){u(this.buffer,R,H)}indexOf(R,H=0){return c(this.buffer,R instanceof h?R.buffer:R,H)}}e.$he=h;function c(w,R,H=0){const ee=R.byteLength,_=w.byteLength;if(ee===0)return 0;if(ee===1)return w.indexOf(R[0]);if(ee>_-H)return-1;const re=N.value;re.fill(R.length);for(let oe=0;oe<R.length;oe++)re[R[oe]]=R.length-oe-1;let se=H+R.length-1,ue=se,ce=-1;for(;se<_;)if(w[se]===R[ue]){if(ue===0){ce=se;break}se--,ue--}else se+=Math.max(R.length-ue,re[w[se]]),ue=R.length-1;return ce}e.$ie=c;function P(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0}e.$je=P;function O(w,R,H){w[H+0]=R&255,R=R>>>8,w[H+1]=R&255}e.$ke=O;function g(w,R){return w[R]*2**24+w[R+1]*2**16+w[R+2]*2**8+w[R+3]}e.$le=g;function f(w,R,H){w[H+3]=R,R=R>>>8,w[H+2]=R,R=R>>>8,w[H+1]=R,R=R>>>8,w[H]=R}e.$me=f;function E(w,R){return w[R+0]<<0>>>0|w[R+1]<<8>>>0|w[R+2]<<16>>>0|w[R+3]<<24>>>0}e.$ne=E;function v(w,R,H){w[H+0]=R&255,R=R>>>8,w[H+1]=R&255,R=R>>>8,w[H+2]=R&255,R=R>>>8,w[H+3]=R&255}e.$oe=v;function d(w,R){return w[R]}e.$pe=d;function u(w,R,H){w[H]=R}e.$qe=u;function p(w){return D.$9d(w,R=>h.concat(R))}e.$re=p;function I(w){return D.$de(w)}e.$se=I;function m(w){return D.$$d(w,R=>h.concat(R))}e.$te=m;async function y(w){return w.ended?h.concat(w.buffer):h.concat([...w.buffer,await m(w.stream)])}e.$ue=y;function s(w){return D.$be(w,R=>h.concat(R))}e.$ve=s;function o(w){return D.$ee(w,{data:R=>typeof R=="string"?h.fromString(R):h.wrap(R)},R=>h.concat(R))}e.$we=o;function t(w){return D.$8d(R=>h.concat(R),w)}e.$xe=t;function i(w,R){return D.$fe(w,R,H=>h.concat(H))}e.$ye=i;function n(w,R){return D.$ge(w,R,H=>h.concat(H))}e.$ze=n;function r(w){let R=0,H=0,ee=0;const _=new Uint8Array(Math.floor(w.length/4*3)),re=ue=>{switch(H){case 3:_[ee++]=R|ue,H=0;break;case 2:_[ee++]=R|ue>>>2,R=ue<<6,H=3;break;case 1:_[ee++]=R|ue>>>4,R=ue<<4,H=2;break;default:R=ue<<2,H=1}};for(let ue=0;ue<w.length;ue++){const ce=w.charCodeAt(ue);if(ce>=65&&ce<=90)re(ce-65);else if(ce>=97&&ce<=122)re(ce-97+26);else if(ce>=48&&ce<=57)re(ce-48+52);else if(ce===43||ce===45)re(62);else if(ce===47||ce===95)re(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${w[ue]}`)}}const se=ee;for(;H>0;)re(0);return h.wrap(_).slice(0,se)}e.$Ae=r;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:w},R=!0,H=!1){const ee=H?S:l;let _="";const re=w.byteLength%3;let se=0;for(;se<w.byteLength-re;se+=3){const ue=w[se+0],ce=w[se+1],oe=w[se+2];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[(ce<<2|oe>>>6)&63],_+=ee[oe&63]}if(re===1){const ue=w[se+0];_+=ee[ue>>>2],_+=ee[ue<<4&63],R&&(_+="==")}else if(re===2){const ue=w[se+0],ce=w[se+1];_+=ee[ue>>>2],_+=ee[(ue<<4|ce>>>4)&63],_+=ee[ce<<2&63],R&&(_+="=")}return _}e.$Be=k}),define(te[41],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=void 0;function D(u){return j(u,0)}e.$Ri=D;function j(u,p){switch(typeof u){case"object":return u===null?N(349,p):Array.isArray(u)?h(u,p):c(u,p);case"string":return b(u,p);case"boolean":return A(u,p);case"number":return N(u,p);case"undefined":return N(937,p);default:return N(617,p)}}e.$Si=j;function N(u,p){return(p<<5)-p+u|0}e.$Ti=N;function A(u,p){return N(u?433:863,p)}function b(u,p){p=N(149417,p);for(let I=0,m=u.length;I<m;I++)p=N(u.charCodeAt(I),p);return p}e.$Ui=b;function h(u,p){return p=N(104579,p),u.reduce((I,m)=>j(m,I),p)}function c(u,p){return p=N(181387,p),Object.keys(u).sort().reduce((I,m)=>(I=b(m,I),j(u[m],I)),p)}class P{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=j(p,this.g),this.g}}e.$Vi=P;var O;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(O||(O={}));function g(u,p,I=32){const m=I-p,y=~((1<<m)-1);return(u<<p|(y&u)>>>m)>>>0}function f(u,p=0,I=u.byteLength,m=0){for(let y=0;y<I;y++)u[p+y]=m}function E(u,p,I="0"){for(;u.length<p;)u=I+u;return u}function v(u,p=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(I=>I.toString(16).padStart(2,"0")).join(""):E((u>>>0).toString(16),p/4)}e.$Wi=v;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const I=p.length;if(I===0)return;const m=this.p;let y=this.r,s=this.u,o,t;for(s!==0?(o=s,t=-1,s=0):(o=p.charCodeAt(0),t=0);;){let i=o;if(L.$bf(o))if(t+1<I){const n=p.charCodeAt(t+1);L.$cf(n)?(t++,i=L.$df(o,n)):i=65533}else{s=o;break}else L.$cf(o)&&(i=65533);if(y=this.w(m,y,i),t++,t<I)o=p.charCodeAt(t);else break}this.r=y,this.u=s}w(p,I,m){return m<128?p[I++]=m:m<2048?(p[I++]=192|(m&1984)>>>6,p[I++]=128|(m&63)>>>0):m<65536?(p[I++]=224|(m&61440)>>>12,p[I++]=128|(m&4032)>>>6,p[I++]=128|(m&63)>>>0):(p[I++]=240|(m&1835008)>>>18,p[I++]=128|(m&258048)>>>12,p[I++]=128|(m&4032)>>>6,p[I++]=128|(m&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=d.g,I=this.q;for(let l=0;l<64;l+=4)p.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)p.setUint32(l,g(p.getUint32(l-12,!1)^p.getUint32(l-32,!1)^p.getUint32(l-56,!1)^p.getUint32(l-64,!1),1),!1);let m=this.h,y=this.l,s=this.m,o=this.n,t=this.o,i,n,r;for(let l=0;l<80;l++)l<20?(i=y&s|~y&o,n=1518500249):l<40?(i=y^s^o,n=1859775393):l<60?(i=y&s|y&o|s&o,n=2400959708):(i=y^s^o,n=3395469782),r=g(m,5)+i+t+n+p.getUint32(l*4,!1)&4294967295,t=o,o=s,s=g(y,30),y=m,m=r;this.h=this.h+m&4294967295,this.l=this.l+y&4294967295,this.m=this.m+s&4294967295,this.n=this.n+o&4294967295,this.o=this.o+t&4294967295}}e.$Xi=d}),define(te[54],ne([0,1,29]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(j){j[j.Ignore=0]="Ignore",j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(D||(D={})),function(j){const N="error",A="warning",b="warn",h="info",c="ignore";function P(g){return g?L.$0e(N,g)?j.Error:L.$0e(A,g)||L.$0e(b,g)?j.Warning:L.$0e(h,g)?j.Info:j.Ignore:j.Ignore}j.fromValue=P;function O(g){switch(g){case j.Error:return N;case j.Warning:return A;case j.Info:return h;default:return c}}j.toString=O}(D||(D={})),e.default=D}),define(te[30],ne([0,1,3]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=void 0;function D(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([I,m])=>{p[I]=m&&typeof m=="object"?D(m):m}),p}e.$kn=D;function j(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const I=p.shift();Object.freeze(I);for(const m in I)if(N.call(I,m)){const y=I[m];typeof y=="object"&&!Object.isFrozen(y)&&!(0,L.$Jf)(y)&&p.push(y)}}return u}e.$ln=j;const N=Object.prototype.hasOwnProperty;function A(u,p){return b(u,p,new Set)}e.$mn=A;function b(u,p,I){if((0,L.$Pf)(u))return u;const m=p(u);if(typeof m<"u")return m;if(Array.isArray(u)){const y=[];for(const s of u)y.push(b(s,p,I));return y}if((0,L.$If)(u)){if(I.has(u))throw new Error("Cannot clone recursive data-structure");I.add(u);const y={};for(const s in u)N.call(u,s)&&(y[s]=b(u[s],p,I));return I.delete(u),y}return u}function h(u,p,I=!0){return(0,L.$If)(u)?((0,L.$If)(p)&&Object.keys(p).forEach(m=>{m in u?I&&((0,L.$If)(u[m])&&(0,L.$If)(p[m])?h(u[m],p[m],I):u[m]=p[m]):u[m]=p[m]}),u):p}e.$nn=h;function c(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let I,m;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(I=0;I<u.length;I++)if(!c(u[I],p[I]))return!1}else{const y=[];for(m in u)y.push(m);y.sort();const s=[];for(m in p)s.push(m);if(s.sort(),!c(y,s))return!1;for(I=0;I<y.length;I++)if(!c(u[y[I]],p[y[I]]))return!1}return!0}e.$on=c;function P(u){const p=new Set;return JSON.stringify(u,(I,m)=>{if((0,L.$If)(m)||Array.isArray(m)){if(p.has(m))return"[Circular]";p.add(m)}return m})}e.$pn=P;function O(u,p){const I=Object.create(null);return!u||!p||Object.keys(p).forEach(y=>{const s=u[y],o=p[y];c(s,o)||(I[y]=o)}),I}e.$qn=O;function g(u,p){const I=p.toLowerCase(),m=Object.keys(u).find(y=>y.toLowerCase()===I);return m?u[m]:u[p]}e.$rn=g;function f(u,p){const I=Object.create(null);for(const[m,y]of Object.entries(u))p(m,y)&&(I[m]=y);return I}e.$sn=f;function E(u){let p=[];for(;Object.prototype!==u;)p=p.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return p}e.$tn=E;function v(u){const p=[];for(const I of E(u))typeof u[I]=="function"&&p.push(I);return p}e.$un=v;function d(u,p){const I=y=>function(){const s=Array.prototype.slice.call(arguments,0);return p(y,s)},m={};for(const y of u)m[y]=I(y);return m}e.$vn=d}),define(te[28],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(j){return L.test(j)}e.$ng=D,e.$og=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let j;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?j=crypto.getRandomValues.bind(crypto):j=function(b){for(let h=0;h<b.length;h++)b[h]=Math.floor(Math.random()*256);return b};const N=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){j(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let h=0,c="";return c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+="-",c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c+=A[N[h++]],c}}()}),define(te[74],ne([0,1,33]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function j(A){const b=A.replace(/\-/g,":").toLowerCase();return!D.has(b)}function N(){const A=(0,L.networkInterfaces)();for(const b in A){const h=A[b];if(h){for(const{mac:c}of h)if(j(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$7m=N}),define(te[75],ne([7,5]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[76],ne([0,1,75]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0;const D=60,j=D*60,N=j*24,A=N*7,b=N*30,h=N*365;function c(O,g,f,E){typeof O!="number"&&(O=O.getTime());const v=Math.round((new Date().getTime()-O)/1e3);if(v<-30)return(0,L.localize)(0,null,c(new Date().getTime()+v*1e3,!1));if(!E&&v<30)return(0,L.localize)(1,null);let d;return v<D?(d=v,g?d===1?f?(0,L.localize)(2,null,d):(0,L.localize)(3,null,d):f?(0,L.localize)(4,null,d):(0,L.localize)(5,null,d):d===1?f?(0,L.localize)(6,null,d):(0,L.localize)(7,null,d):f?(0,L.localize)(8,null,d):(0,L.localize)(9,null,d)):v<j?(d=Math.floor(v/D),g?d===1?f?(0,L.localize)(10,null,d):(0,L.localize)(11,null,d):f?(0,L.localize)(12,null,d):(0,L.localize)(13,null,d):d===1?f?(0,L.localize)(14,null,d):(0,L.localize)(15,null,d):f?(0,L.localize)(16,null,d):(0,L.localize)(17,null,d)):v<N?(d=Math.floor(v/j),g?d===1?f?(0,L.localize)(18,null,d):(0,L.localize)(19,null,d):f?(0,L.localize)(20,null,d):(0,L.localize)(21,null,d):d===1?f?(0,L.localize)(22,null,d):(0,L.localize)(23,null,d):f?(0,L.localize)(24,null,d):(0,L.localize)(25,null,d)):v<A?(d=Math.floor(v/N),g?d===1?(0,L.localize)(26,null,d):(0,L.localize)(27,null,d):d===1?(0,L.localize)(28,null,d):(0,L.localize)(29,null,d)):v<b?(d=Math.floor(v/A),g?d===1?f?(0,L.localize)(30,null,d):(0,L.localize)(31,null,d):f?(0,L.localize)(32,null,d):(0,L.localize)(33,null,d):d===1?f?(0,L.localize)(34,null,d):(0,L.localize)(35,null,d):f?(0,L.localize)(36,null,d):(0,L.localize)(37,null,d)):v<h?(d=Math.floor(v/b),g?d===1?f?(0,L.localize)(38,null,d):(0,L.localize)(39,null,d):f?(0,L.localize)(40,null,d):(0,L.localize)(41,null,d):d===1?f?(0,L.localize)(42,null,d):(0,L.localize)(43,null,d):f?(0,L.localize)(44,null,d):(0,L.localize)(45,null,d)):(d=Math.floor(v/h),g?d===1?f?(0,L.localize)(46,null,d):(0,L.localize)(47,null,d):f?(0,L.localize)(48,null,d):(0,L.localize)(49,null,d):d===1?f?(0,L.localize)(50,null,d):(0,L.localize)(51,null,d):f?(0,L.localize)(52,null,d):(0,L.localize)(53,null,d))}e.$tm=c;function P(O){return O.getFullYear()+"-"+String(O.getMonth()+1).padStart(2,"0")+"-"+String(O.getDate()).padStart(2,"0")+"T"+String(O.getHours()).padStart(2,"0")+":"+String(O.getMinutes()).padStart(2,"0")+":"+String(O.getSeconds()).padStart(2,"0")+"."+(O.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$um=P}),define(te[77],ne([7,5]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[34],ne([0,1,19,3,77]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=void 0;function N(O,g){return g&&(O.stack||O.stacktrace)?j.localize(0,null,b(O),A(O.stack)||A(O.stacktrace)):b(O)}function A(O){return Array.isArray(O)?O.join(`
`):O}function b(O){return O.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${O.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof O.code=="string"&&typeof O.errno=="number"&&typeof O.syscall=="string"?j.localize(1,null,O.message):O.message||j.localize(2,null)}function h(O=null,g=!1){if(!O)return j.localize(3,null);if(Array.isArray(O)){const f=L.$Hb(O),E=h(f[0],g);return f.length>1?j.localize(4,null,E,f.length):E}if(D.$Gf(O))return O;if(O.detail){const f=O.detail;if(f.error)return N(f.error,g);if(f.exception)return N(f.exception,g)}return O.stack?N(O,g):O.message?O.message:j.localize(5,null)}e.$Oi=h;function c(O){const g=O;return g instanceof Error&&Array.isArray(g.actions)}e.$Pi=c;function P(O,g){let f;return typeof O=="string"?f=new Error(O):f=O,f.actions=g,f}e.$Qi=P}),define(te[78],ne([7,5]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[79],ne([0,1,78]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function D(j){switch(j){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Mp=D}),define(te[55],ne([0,1,13]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0;var D;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(D||(e.Source=D={}));var j;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function N(b,...h){const c=h.reduce((g,f)=>(g[f]=!0,g),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(g=>!c[g]).forEach(g=>{for(let f=0;f<P.length;f++)if(g.search(P[f])!==-1){delete b[g];break}})}e.$Pl=N;function A(b){b&&(delete b.DEBUG,L.$j&&delete b.DYLD_LIBRARY_PATH,L.$k&&delete b.LD_PRELOAD)}e.$Ql=A}),define(te[80],ne([0,1,11]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$dq=e.$cq=e.$bq=void 0;function D(c){const P=c;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$bq=D;function j(c){const P=[];let O;try{const g=JSON.parse(c.arguments),f=g[g.length-1];f&&f.__$stack&&(g.pop(),O=f.__$stack),P.push(...g)}catch{P.push("Unable to log remote console arguments",c.arguments)}return{args:P,stack:O}}e.$cq=j;function N(c){if(typeof c!="string")return N(j(c).stack);const P=c;if(P){const O=A(P),g=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(O||"");if(g&&g.length===4)return{uri:L.URI.file(g[1]),line:Number(g[2]),column:Number(g[3])}}}e.$dq=N;function A(c){if(!c)return c;const P=c.indexOf(`
`);return P===-1?c:c.substring(0,P)}function b(c,P){const{args:O,stack:g}=j(c),f=typeof O[0]=="string"&&O.length===1;let E=A(g);E&&(E=`(${E.trim()})`);let v=[];if(typeof O[0]=="string"?E&&f?v=[`%c[${P}] %c${O[0]} %c${E}`,h("blue"),h(""),h("grey")]:v=[`%c[${P}] %c${O[0]}`,h("blue"),h(""),...O.slice(1)]:v=[`%c[${P}]%`,h("blue"),...O],E&&!f&&v.push(E),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,v)}e.log=b;function h(c){return`color: ${c}`}}),define(te[46],ne([0,1,14,11]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function j(h){return JSON.stringify(h,A)}e.$yh=j;function N(h){let c=JSON.parse(h);return c=b(c),c}e.$zh=N;function A(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function b(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return D.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof L.$he||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=b(h[P],c+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=b(h[P],c+1))}return h}e.$Ah=b}),define(te[81],ne([0,1,70,15,13,11]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=void 0;class A{constructor(g,f,E){this.id=g,this.dependencies=f,this.callback=E}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(g,f,E)=>{typeof g!="string"&&(E=f,f=g,g=null),(typeof f!="object"||!Array.isArray(f))&&(E=f,f=null),this.c.push(new A(g,f,E))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){if(g.startsWith(window.location.origin)||g.startsWith("vscode-file://vscode-app"))return g;throw new Error(`[trusted_script_src] Invalid script url: ${g}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(g){return g}})))}async load(g){this.g();const f=await(this.a?this.i(g):this.b?this.h(g):this.j(g));if(!f)throw new Error(`Did not receive a define call from script ${g}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${g}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(g){return new Promise((f,E)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const d=()=>{v.removeEventListener("load",u),v.removeEventListener("error",p)},u=I=>{d(),f(this.c.pop())},p=I=>{d(),E(I)};v.addEventListener("load",u),v.addEventListener("error",p),this.f&&(g=this.f.createScriptURL(g)),v.setAttribute("src",g),window.document.getElementsByTagName("head")[0].appendChild(v)})}i(g){return new Promise((f,E)=>{try{this.f&&(g=this.f.createScriptURL(g)),importScripts(g),f(this.c.pop())}catch(v){E(v)}})}async j(g){try{const f=globalThis._VSCODE_NODE_MODULES.fs,E=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,d=N.URI.parse(g).fsPath,u=f.readFileSync(d).toString(),p=v.wrap(u.replace(/^#!.*/,""));return new E.Script(p).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const h=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function P(O,g,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[O]&&(O=c[O]);const E=`${O}/${g}`;if(h.has(E))return h.get(E);let v;if(/^\w[\w\d+.-]*:\/\//.test(E))v=E;else{const I=`${f&&!j.$o?D.$jg:D.$ig}/${E}`;v=D.$mg.asBrowserUri(I).toString(!0)}const d=b.INSTANCE.load(v);return h.set(E,d),d}else return await new Promise((E,v)=>{G([O],E,v)})}e.$8C=P}),define(te[82],ne([0,1,33,47,28,74,13]),function(G,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=new class{c(g){return this.a||(this.a=D.$0h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(g)}value(){if(this.b===void 0){let g=0,f=0;const E=(0,L.networkInterfaces)();for(const v in E){const d=E[v];if(d)for(const{mac:u,internal:p}of d)p||(f+=1,this.c(u.toUpperCase())&&(g+=1))}this.b=f>0?g/f:0}return this.b}};let b;async function h(g){return b||(b=(async()=>await c(g)||j.$og())()),b}e.$9m=h;async function c(g){try{const f=await new Promise((v,d)=>{G(["crypto"],v,d)}),E=(0,N.$7m)();return f.createHash("sha256").update(E,"utf8").digest("hex")}catch(f){g(f);return}}const P="Software\\Microsoft\\SQMClient";async function O(g){if(A.$i){const f=await new Promise((E,v)=>{G(["@vscode/windows-registry"],E,v)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",P,"MachineId")||""}catch(E){return g(E),""}}return""}e.$0m=O}),define(te[83],ne([0,1,33,16,24]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var h;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class O{constructor(y,s,o){this.exePath=y,this.displayName=s,this.a=o}async exists(){return this.a===void 0&&(this.a=await j.SymlinkSupport.existsFile(this.exePath)),this.a}}function g({useAlternateBitness:m=!1}={}){return m?c===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:m=!1,findPreview:y=!1}={}){const s=g({useAlternateBitness:m});if(!s)return null;const o=D.$jc(s,"PowerShell");if(!await j.SymlinkSupport.existsDirectory(o))return null;let t=-1,i=null;for(const l of await j.Promises.readdir(o)){let S=-1;if(y){const w=l.indexOf("-");if(w<0)continue;const R=l.substring(0,w);if(!N.test(R)||l.substring(w+1)!=="preview")continue;S=parseInt(R,10)}else{if(!N.test(l))continue;S=parseInt(l,10)}if(S<=t)continue;const k=D.$jc(o,l,"pwsh.exe");await j.SymlinkSupport.existsFile(k)&&(i=k,t=S)}if(!i)return null;const n=s.includes("x86")?" (x86)":"",r=y?" Preview":"";return new O(i,`PowerShell${r}${n}`,!0)}async function E({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const y=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await j.SymlinkSupport.existsDirectory(y))return null;const{pwshMsixDirRegex:s,pwshMsixName:o}=m?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await j.Promises.readdir(y))if(s.test(t)){const i=D.$jc(y,t,"pwsh.exe");return new O(i,o)}return null}function v(){const m=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new O(m,".NET Core PowerShell Global Tool")}function d(){const m=D.$jc(process.env.windir,c===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new O(m,"Windows PowerShell",!0)}async function*u(){let m=await f();m&&(yield m),m=await f({useAlternateBitness:!0}),m&&(yield m),m=await E(),m&&(yield m),m=v(),m&&(yield m),m=await f({findPreview:!0}),m&&(yield m),m=await E({findPreview:!0}),m&&(yield m),m=await f({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=d(),m&&(yield m)}async function*p(){for await(const m of u())await m.exists()&&(yield m)}e.$Nl=p;async function I(){for await(const m of p())return m;return null}e.$Ol=I}),define(te[56],ne([0,1,16,13,35,55,3,24]),function(G,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function h(O=j.env){return O.comspec||"cmd.exe"}e.$Rl=h;function c(O){let g=[],f=!1;const E=function(v){if(f){g.push(v);return}(!O.send(v,u=>{if(u&&console.error(u),f=!1,g.length>0){const p=g.slice(0);g=[],p.forEach(I=>E(I))}})||D.$i)&&(f=!0)};return{send:E}}e.$Sl=c;var P;(function(O){async function g(f,E,v){if(L.$ic(f))return f;if(E===void 0&&(E=j.cwd()),L.$mc(f)!=="."||(v===void 0&&A.$Gf(j.env.PATH)&&(v=j.env.PATH.split(L.$tc)),v===void 0||v.length===0))return L.$jc(E,f);async function u(p){if(await b.Promises.exists(p)){let I;try{I=await b.Promises.stat(p)}catch(m){m.message.startsWith("EACCES")&&(I=await b.Promises.lstat(p))}return I?!I.isDirectory():!1}return!1}for(const p of v){let I;if(L.$ic(p)?I=L.$jc(p,f):I=L.$jc(E,p,f),await u(I))return I;let m=I+".com";if(await u(m)||(m=I+".exe",await u(m)))return m}return L.$jc(E,f)}O.findExecutable=g})(P||(e.win32=P={}))}),define(te[84],ne([0,1,33,13,83,56]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=void 0;async function A(O,g){return O===1?D.$i?P():N.$Rl(g):h(O,g)}e.$Tl=A;let b=null;function h(O,g){if(D.$k&&O===2||D.$j&&O===3)return"/bin/bash";if(!b){let f;if(D.$i)f="/bin/bash";else{if(f=g.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}b=f}return b}let c=null;async function P(){return c||(c=(await(0,j.$Ol)()).exePath),c}});var pe=this&&this.__decorate||function(G,e,L,D){var j=arguments.length,N=j<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(G,e,L,D);else for(var b=G.length-1;b>=0;b--)(A=G[b])&&(N=(j<3?A(N):j>3?A(e,L,N):A(e,L))||N);return j>3&&N&&Object.defineProperty(e,L,N),N};define(te[57],ne([0,1,19,8,14,20,52,9,4,2,46,29,3]),function(G,e,L,D,j,N,A,b,h,c,P,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.ProxyChannel=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.RequestInitiator=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f||(f={}));function E(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(v||(v={}));function d(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(u||(u={}));function p(M){let C=0;for(let V=0;;V+=7){const J=M.read(1);if(C|=(J.buffer[0]&127)<<V,!(J.buffer[0]&128))return C}}const I=t(0);function m(M,C){if(C===0){M.write(I);return}let V=0;for(let Q=C;Q!==0;Q=Q>>>7)V++;const J=j.$he.alloc(V);for(let Q=0;C!==0;Q++)J.buffer[Q]=C&127,C=C>>>7,C>0&&(J.buffer[Q]|=128);M.write(J)}class y{constructor(C){this.b=C,this.a=0}read(C){const V=this.b.slice(this.a,this.a+C);return this.a+=V.byteLength,V}}e.$Bh=y;class s{constructor(){this.a=[]}get buffer(){return j.$he.concat(this.a)}write(C){this.a.push(C)}}e.$Ch=s;var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(o||(o={}));function t(M){const C=j.$he.alloc(1);return C.writeUInt8(M,0),C}const i={Undefined:t(o.Undefined),String:t(o.String),Buffer:t(o.Buffer),VSBuffer:t(o.VSBuffer),Array:t(o.Array),Object:t(o.Object),Uint:t(o.Int)},n=typeof Buffer<"u";function r(M,C){if(typeof C>"u")M.write(i.Undefined);else if(typeof C=="string"){const V=j.$he.fromString(C);M.write(i.String),m(M,V.byteLength),M.write(V)}else if(n&&Buffer.isBuffer(C)){const V=j.$he.wrap(C);M.write(i.Buffer),m(M,V.byteLength),M.write(V)}else if(C instanceof j.$he)M.write(i.VSBuffer),m(M,C.byteLength),M.write(C);else if(Array.isArray(C)){M.write(i.Array),m(M,C.length);for(const V of C)r(M,V)}else if(typeof C=="number"&&(C|0)===C)M.write(i.Uint),m(M,C);else{const V=j.$he.fromString(JSON.stringify(C));M.write(i.Object),m(M,V.byteLength),M.write(V)}}e.$Dh=r;function l(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(p(M)).toString();case o.Buffer:return M.read(p(M)).buffer;case o.VSBuffer:return M.read(p(M));case o.Array:{const V=p(M),J=[];for(let Q=0;Q<V;Q++)J.push(l(M));return J}case o.Object:return JSON.parse(M.read(p(M)).toString());case o.Int:return p(M)}}e.$Eh=l;class S{constructor(C,V,J=null,Q=1e3){this.h=C,this.j=V,this.k=J,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(C,V){this.b.set(C,V),setTimeout(()=>this.w(C),0)}m(C){switch(C.type){case 200:{const V=this.o([C.type]);this.k?.logOutgoing(V,0,1,d(C.type));return}case 201:case 202:case 204:case 203:{const V=this.o([C.type,C.id],C.data);this.k?.logOutgoing(V,C.id,1,d(C.type),C.data);return}}}o(C,V=void 0){const J=new s;return r(J,C),r(J,V),this.p(J.buffer)}p(C){try{return this.h.send(C),C.byteLength}catch{return 0}}q(C){const V=new y(C),J=l(V),Q=l(V),K=J[0];switch(K){case 100:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Q),this.s({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 102:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}: ${J[2]}.${J[3]}`,Q),this.t({type:K,id:J[1],channelName:J[2],name:J[3],arg:Q});case 101:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]});case 103:return this.k?.logIncoming(C.byteLength,J[1],1,`${E(K)}`),this.u({type:K,id:J[1]})}}s(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const J=new N.$4d;let Q;try{Q=V.call(this.j,C.name,C.arg,J.token)}catch(z){Q=Promise.reject(z)}const K=C.id;Q.then(z=>{this.m({id:K,data:z,type:201})},z=>{z instanceof Error?this.m({id:K,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:K,data:z,type:203})}).finally(()=>{T.dispose(),this.d.delete(C.id)});const T=(0,c.$Rc)(()=>J.cancel());this.d.set(C.id,T)}t(C){const V=this.b.get(C.channelName);if(!V){this.v(C);return}const J=C.id,K=V.listen(this.j,C.name,C.arg)(T=>this.m({id:J,data:T,type:204}));this.d.set(C.id,K)}u(C){const V=this.d.get(C.id);V&&(V.dispose(),this.d.delete(C.id))}v(C){let V=this.g.get(C.channelName);V||(V=[],this.g.set(C.channelName,V));const J=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.m({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:C,timeoutTimer:J})}w(C){const V=this.g.get(C);if(V){for(const J of V)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(C)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Fh=S;var k;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class w{constructor(C,V=null){this.l=C,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=V}getChannel(C){const V=this;return{call(J,Q,K){return V.a?Promise.reject(new b.$5):V.m(C,J,Q,K)},listen(J,Q){return V.a?h.Event.None:V.o(C,J,Q)}}}m(C,V,J,Q=N.CancellationToken.None){const K=this.g++,z={id:K,type:100,channelName:C,name:V,arg:J};if(Q.isCancellationRequested)return Promise.reject(new b.$5);let a;return new Promise((F,U)=>{if(Q.isCancellationRequested)return U(new b.$5);const Y=()=>{const me=de=>{switch(de.type){case 201:this.f.delete(K),F(de.data);break;case 202:{this.f.delete(K);const ge=new Error(de.data.message);ge.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ge.name=de.data.name,U(ge);break}case 203:this.f.delete(K),U(de.data);break}};this.f.set(K,me),this.p(z)};let W=null;this.b===u.Idle?Y():(W=(0,D.$Rg)(me=>this.u()),W.then(()=>{W=null,Y()}));const le=()=>{W?(W.cancel(),W=null):this.p({id:K,type:101}),U(new b.$5)},ae=Q.onCancellationRequested(le);a=(0,c.$Qc)((0,c.$Rc)(le),ae),this.d.add(a)}).finally(()=>{a.dispose(),this.d.delete(a)})}o(C,V,J){const Q=this.g++,T={id:Q,type:102,channelName:C,name:V,arg:J};let z=null;const a=new h.$Td({onWillAddFirstListener:()=>{z=(0,D.$Rg)(F=>this.u()),z.then(()=>{z=null,this.d.add(a),this.p(T)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(a),this.p({id:Q,type:103}))}}),$=F=>a.fire(F.data);return this.f.set(Q,$),a.event}p(C){switch(C.type){case 100:case 102:{const V=this.q([C.type,C.id,C.channelName,C.name],C.arg);this.j?.logOutgoing(V,C.id,0,`${E(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const V=this.q([C.type,C.id]);this.j?.logOutgoing(V,C.id,0,E(C.type));return}}}q(C,V=void 0){const J=new s;return r(J,C),r(J,V),this.r(J.buffer)}r(C){try{return this.l.send(C),C.byteLength}catch{return 0}}s(C){const V=new y(C),J=l(V),Q=l(V),K=J[0];switch(K){case 200:return this.j?.logIncoming(C.byteLength,0,0,d(K)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(C.byteLength,J[1],0,d(K),Q),this.t({type:J[0],id:J[1],data:Q})}}t(C){if(C.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(C.id)?.(C)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=w,pe([A.$vh],w.prototype,"onDidInitializePromise",null);class R{get connections(){const C=[];return this.f.forEach(V=>C.push(V)),C}constructor(C){this.a=new Map,this.f=new Set,this.g=new h.$Td,this.onDidAddConnection=this.g.event,this.h=new h.$Td,this.onDidRemoveConnection=this.h.event,this.j=new c.$Sc,this.j.add(C(({protocol:V,onDidClientDisconnect:J})=>{const Q=h.Event.once(V.onMessage);this.j.add(Q(K=>{const T=new y(K),z=l(T),a=new S(V,z),$=new w(V);this.a.forEach((U,Y)=>a.registerChannel(Y,U));const F={channelServer:a,channelClient:$,ctx:z};this.f.add(F),this.g.fire(F),this.j.add(J(()=>{a.dispose(),$.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(C,V){const J=this;return{call(Q,K,T){let z;if((0,g.$Uf)(V)){const $=(0,L.$4b)(J.connections.filter(V));z=$?Promise.resolve($):h.Event.toPromise(h.Event.filter(J.onDidAddConnection,V))}else z=V.routeCall(J,Q,K);const a=z.then($=>$.channelClient.getChannel(C));return ee(a).call(Q,K,T)},listen(Q,K){if((0,g.$Uf)(V))return J.k(C,V,Q,K);const T=V.routeEvent(J,Q,K).then(z=>z.channelClient.getChannel(C));return ee(T).listen(Q,K)}}}k(C,V,J,Q){const K=this;let T;const z=new h.$Td({onWillAddFirstListener:()=>{T=new c.$Sc;const a=new h.$Zd,$=new Map,F=Y=>{const le=Y.channelClient.getChannel(C).listen(J,Q),ae=a.add(le);$.set(Y,ae)},U=Y=>{const W=$.get(Y);W&&(W.dispose(),$.delete(Y))};K.connections.filter(V).forEach(F),h.Event.filter(K.onDidAddConnection,V)(F,void 0,T),K.onDidRemoveConnection(U,void 0,T),a.event(z.fire,z,T),T.add(a)},onDidRemoveLastListener:()=>{T?.dispose(),T=void 0}});return z.event}registerChannel(C,V){this.a.set(C,V);for(const J of this.f)J.channelServer.registerChannel(C,V)}dispose(){this.j.dispose();for(const C of this.f)C.channelClient.dispose(),C.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Hh=R;class H{constructor(C,V,J=null){const Q=new s;r(Q,V),C.send(Q.buffer),this.a=new w(C,J),this.d=new S(C,V,J)}getChannel(C){return this.a.getChannel(C)}registerChannel(C,V){this.d.registerChannel(C,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ih=H;function ee(M){return{call(C,V,J){return M.then(Q=>Q.call(C,V,J))},listen(C,V){const J=new h.$3d;return M.then(Q=>J.input=Q.listen(C,V)),J.event}}}e.$Jh=ee;function _(M){let C=!1;return{call(V,J,Q){return C?M.call(V,J,Q):(0,D.$5g)(0).then(()=>C=!0).then(()=>M.call(V,J,Q))},listen(V,J){if(C)return M.listen(V,J);const Q=new h.$3d;return(0,D.$5g)(0).then(()=>C=!0).then(()=>Q.input=M.listen(V,J)),Q.event}}}e.$Kh=_;class re{constructor(C){this.a=C}routeCall(C){return this.b(C)}routeEvent(C){return this.b(C)}async b(C){for(const V of C.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await h.Event.toPromise(C.onDidAddConnection),await this.b(C)}}e.$Lh=re;var se;(function(M){function C(K,T,z){const a=K,$=z&&z.disableMarshalling,F=new Map;for(const U in a)J(U)&&F.set(U,h.Event.buffer(a[U],!0,void 0,T));return new class{listen(U,Y,W){const le=F.get(Y);if(le)return le;if(Q(Y)){const ae=a[Y];if(typeof ae=="function")return ae.call(a,W)}throw new b.$bb(`Event not found: ${Y}`)}call(U,Y,W){const le=a[Y];if(typeof le=="function"){if(!$&&Array.isArray(W))for(let me=0;me<W.length;me++)W[me]=(0,P.$Ah)(W[me]);let ae=le.apply(a,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new b.$bb(`Method not found: ${Y}`)}}}M.fromService=C;function V(K,T){const z=T&&T.disableMarshalling;return new Proxy({},{get(a,$){if(typeof $=="string")return T?.properties?.has($)?T.properties.get($):Q($)?function(F){return K.listen($,F)}:J($)?K.listen($):async function(...F){let U;T&&!(0,g.$Pf)(T.context)?U=[T.context,...F]:U=F;const Y=await K.call($,U);return z?Y:(0,P.$Ah)(Y)};throw new b.$bb(`Property not found: ${String($)}`)}})}M.toService=V;function J(K){return K[0]==="o"&&K[1]==="n"&&O.$9e(K.charCodeAt(2))}function Q(K){return/^onDynamic/.test(K)&&O.$9e(K.charCodeAt(9))}})(se||(e.ProxyChannel=se={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const C=M.toString();if(C!=="[object Object]")return C}return M}function oe(M){return Array.isArray(M)?M.map(ce):ce(M)}function B(M,C,V,J,Q,K,T){T=oe(T);const z=ue[Q],a=z[J%z.length];let $=[`%c[${M}]%c[${String(C).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${a}`];/\($/.test(K)?($=$.concat(T),$.push(")")):$.push(T),console.log.apply(console,$)}class X{constructor(C,V){this.d=C,this.f=V,this.a=0,this.b=0}logOutgoing(C,V,J,Q,K){this.b+=C,B(this.d,this.b,C,V,J,Q,K)}logIncoming(C,V,J,Q,K){this.a+=C,B(this.f,this.a,C,V,J,Q,K)}}e.$Mh=X}),define(te[85],ne([0,1,58,8,14,20,80,9,4,2,30,56,55,57]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class E extends f.$Fh{constructor(u){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",p=>j.$he.wrap(Buffer.from(p,"base64")))},u),process.once("disconnect",()=>this.dispose())}}e.$fq=E;class v{constructor(u,p){this.i=u,this.j=p,this.c=new Set,this.g=new Map,this.h=new h.$Td,this.onDidProcessExit=this.h.event;const I=p&&p.timeout?p.timeout:6e4;this.b=new D.$1g(I),this.d=null,this.f=null}getChannel(u){const p=this;return{call(I,m,y){return p.k(u,I,m,y)},listen(I,m){return p.l(u,I,m)}}}k(u,p,I,m=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(b.$6());this.b.cancel();const y=this.n(u),s=(0,D.$Rg)(i=>y.call(p,I,i)),o=m.onCancellationRequested(()=>s.cancel()),t=(0,c.$Rc)(()=>s.cancel());return this.c.add(t),s.finally(()=>{o.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),s}l(u,p,I){if(!this.b)return h.Event.None;this.b.cancel();let m;const y=new h.$Td({onWillAddFirstListener:()=>{m=this.n(u).listen(p,I)(y.fire,y),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return y.event}get m(){if(!this.f){const u=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,P.$kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,g.$Ql)(p.env),this.d=(0,L.fork)(this.i,u,p);const I=new h.$Td;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,A.$bq)(n)){(0,A.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(j.$he.wrap(Buffer.from(n,"base64")))});const y=this.j.useQueue?(0,O.$Sl)(this.d):this.d,s=n=>this.d&&this.d.connected&&y.send(n.buffer.toString("base64")),o=I.event,t={send:s,onMessage:o};this.f=new f.$Gh(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,r)=>{process.removeListener("exit",i),this.c.forEach(l=>(0,c.$Oc)(l)),this.c.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:r})})}return this.f}n(u){let p=this.g.get(u);return p||(p=this.m.getChannel(u),this.g.set(u,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gq=v}),define(te[86],ne([0,1,8,4,2,46,3]),function(G,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.StorageState=e.$ep=e.StorageHint=void 0;var b;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",g[g.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function h(g){const f=g;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$ep=h;var c;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(c||(e.StorageState=c={}));class P extends j.$Tc{static{this.a=100}constructor(f,E=Object.create(null)){super(),this.r=f,this.s=E,this.b=this.B(new D.$Wd),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new L.$2g(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((E,v)=>this.w(v,E)),f.deleted?.forEach(E=>this.w(E,void 0))}finally{this.b.resume()}}w(f,E){if(this.c===c.Closed)return;let v=!1;(0,A.$Pf)(E)?v=this.f.delete(f):this.f.get(f)!==E&&(this.f.set(f,E),v=!0),v&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,E){const v=this.f.get(f);return(0,A.$Pf)(v)?E:v}getBoolean(f,E){const v=this.get(f);return(0,A.$Pf)(v)?E:v==="true"}getNumber(f,E){const v=this.get(f);return(0,A.$Pf)(v)?E:parseInt(v,10)}getObject(f,E){const v=this.get(f);return(0,A.$Pf)(v)?E:(0,N.$zh)(v)}async set(f,E,v=!1){if(this.c===c.Closed)return;if((0,A.$Pf)(E))return this.delete(f,v);const d=(0,A.$If)(E)||Array.isArray(E)?(0,N.$yh)(E):String(E);if(this.f.get(f)!==d)return this.f.set(f,d),this.j.set(f,d),this.h.delete(f),this.b.fire({key:f,external:v}),this.D()}async delete(f,E=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:E}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$fp=P;class O{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((E,v)=>this.a.set(v,E)),f.delete?.forEach(E=>this.a.delete(E))}async optimize(){}async close(){}}e.$gp=O}),define(te[87],ne([7,5]),function(G,e){return G.create("vs/base/node/zip",e)}),define(te[48],ne([0,1,88,8,16,3,24,87]),function(G,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.zip=e.$Bp=e.$Ap=void 0,e.$Ap="end of central directory record signature not found";const h=new RegExp(e.$Ap);class c extends Error{constructor(y,s){let o=s.message;switch(y){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=y,this.cause=s}}e.$Bp=c;function P(m){const y=m.externalFileAttributes>>16||33188;return[448,56,7].map(s=>y&s).reduce((s,o)=>s+o,y&61440)}function O(m){if(m instanceof c)return m;let y;return h.test(m.message)&&(y="CorruptZip"),new c(y,m)}function g(m,y,s,o,t,i){const n=j.$mc(y),r=j.$jc(o,n);if(!r.startsWith(o))return Promise.reject(new Error(b.localize(0,null,y)));const l=j.$jc(o,y);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((k,w)=>{if(!i.isCancellationRequested)try{S=(0,L.createWriteStream)(l,{mode:s}),S.once("close",()=>k()),S.once("error",w),m.once("error",w),m.pipe(S)}catch(R){w(R)}}))}function f(m,y,s,o){let t=(0,D.$Rg)(()=>Promise.resolve()),i=0;const n=o.onCancellationRequested(()=>{t.cancel(),m.close()});return new Promise((r,l)=>{const S=new D.$Yg,k=w=>{w.isCancellationRequested||(i++,m.readEntry())};m.once("error",l),m.once("close",()=>t.then(()=>{o.isCancellationRequested||m.entryCount===i?r():l(new c("Incomplete",new Error(b.localize(1,null,i,m.entryCount))))},l)),m.readEntry(),m.on("entry",w=>{if(o.isCancellationRequested)return;if(!s.sourcePathRegex.test(w.fileName)){k(o);return}const R=w.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(R)){const _=j.$jc(y,R);t=(0,D.$Rg)(re=>A.Promises.mkdir(_,{recursive:!0}).then(()=>k(re)).then(void 0,l));return}const H=v(m,w),ee=P(w);t=(0,D.$Rg)(_=>S.queue(()=>H.then(re=>g(re,R,ee,y,s,_).then(()=>k(_)))).then(null,l))})}).finally(()=>n.dispose())}async function E(m,y=!1){const{open:s}=await new Promise((o,t)=>{G(["yauzl"],o,t)});return new Promise((o,t)=>{s(m,y?{lazyEntries:!0}:void 0,(i,n)=>{i?t(O(i)):o((0,N.$Rf)(n))})})}function v(m,y){return new Promise((s,o)=>{m.openReadStream(y,(t,i)=>{t?o(O(t)):s((0,N.$Rf)(i))})})}async function d(m,y){const{ZipFile:s}=await new Promise((o,t)=>{G(["yazl"],o,t)});return new Promise((o,t)=>{const i=new s;y.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const n=(0,L.createWriteStream)(m);i.outputStream.pipe(n),i.outputStream.once("error",t),n.once("error",t),n.once("finish",()=>o(m))})}e.zip=d;function u(m,y,s={},o){const t=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let i=E(m,!0);return s.overwrite&&(i=i.then(n=>A.Promises.rm(y).then(()=>n))),i.then(n=>f(n,y,{sourcePathRegex:t},o))}e.$Dp=u;function p(m,y){return E(m).then(s=>new Promise((o,t)=>{s.on("entry",i=>{i.fileName===y&&v(s,i).then(n=>o(n),n=>t(n))}),s.once("close",()=>t(new Error(b.localize(2,null,y))))}))}function I(m,y){return p(m,y).then(s=>new Promise((o,t)=>{const i=[];s.once("error",t),s.on("data",n=>i.push(n)),s.on("end",()=>o(Buffer.concat(i)))}))}e.$Ep=I}),define(te[89],ne([7,5]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[90],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[91],ne([7,5]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[92],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[93],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[94],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(te[95],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[96],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[97],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[98],ne([7,5]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[99],ne([7,5]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[100],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[101],ne([7,5]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[102],ne([7,5]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[103],ne([7,5]),function(G,e){return G.create("vs/platform/languagePacks/common/languagePacks",e)}),define(te[104],ne([7,5]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[105],ne([7,5]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[106],ne([7,5]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[107],ne([7,5]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[108],ne([7,5]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[109],ne([0,1,9,91]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.TokenType=void 0;var j;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(j||(e.TokenType=j={}));function N(...c){switch(c.length){case 1:return(0,D.localize)(0,null,c[0]);case 2:return(0,D.localize)(1,null,c[0],c[1]);case 3:return(0,D.localize)(2,null,c[0],c[1],c[2]);default:return}}const A=(0,D.localize)(3,null),b=(0,D.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const O=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:O})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const O=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:O})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const O=this.d,g=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:g};this.g.push({offset:O,lexeme:g,additionalInfo:P}),this.f.push(f)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const O=this.c.substring(this.d,this.e),g=h.b.get(O);g?this.k(g):this.f.push({type:17,lexeme:O,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,O=!1,g=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(b);return}const E=this.c.charCodeAt(P);if(O)O=!1;else if(E===47&&!g){P++;break}else E===91?g=!0:E===92?O=!0:E===93&&(g=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Yi=h}),define(te[110],ne([0,1,76,52,15,16,35,17,11]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$vm=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,N.$mc)(j.$mg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,b.$Fg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:j.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$Fg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$Fg)(h.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$Fg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$Fg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$Fg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,N.$jc)(f,"argv.json")):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.$kc)(f):(0,N.$hc)((0,N.$jc)(j.$mg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,N.$kc)(f)):h.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.$kc)(f);const E=A.env.VSCODE_EXTENSIONS;if(E)return E;const v=A.env.VSCODE_PORTABLE;return v?(0,N.$jc)(v,"extensions"):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(E=>/^[^:/?#]+?:\/\//.test(E)?h.URI.parse(E):h.URI.file((0,N.$hc)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,N.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$vm.test(f))}get extensionLogLevel(){const f=[];for(const E of this.args.log||[]){const v=e.$vm.exec(E);v&&v[1]&&v[2]&&f.push([v[1],v[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,b.$Fg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?h.URI.file((0,N.$jc)(f,"policy.json")):(0,b.$Fg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,E,v){this.a=f,this.b=E,this.c=v,this.editSessionId=this.args.editSessionId}}e.$wm=c,pe([D.$vh],c.prototype,"appRoot",null),pe([D.$vh],c.prototype,"userHome",null),pe([D.$vh],c.prototype,"userDataPath",null),pe([D.$vh],c.prototype,"appSettingsHome",null),pe([D.$vh],c.prototype,"tmpDir",null),pe([D.$vh],c.prototype,"cacheHome",null),pe([D.$vh],c.prototype,"stateResource",null),pe([D.$vh],c.prototype,"userRoamingDataHome",null),pe([D.$vh],c.prototype,"userDataSyncHome",null),pe([D.$vh],c.prototype,"sync",null),pe([D.$vh],c.prototype,"machineSettingsResource",null),pe([D.$vh],c.prototype,"workspaceStorageHome",null),pe([D.$vh],c.prototype,"localHistoryHome",null),pe([D.$vh],c.prototype,"keyboardLayoutResource",null),pe([D.$vh],c.prototype,"argvResource",null),pe([D.$vh],c.prototype,"isExtensionDevelopment",null),pe([D.$vh],c.prototype,"untitledWorkspacesHome",null),pe([D.$vh],c.prototype,"builtinExtensionsPath",null),pe([D.$vh],c.prototype,"extensionsPath",null),pe([D.$vh],c.prototype,"extensionDevelopmentLocationURI",null),pe([D.$vh],c.prototype,"extensionDevelopmentKind",null),pe([D.$vh],c.prototype,"extensionTestsLocationURI",null),pe([D.$vh],c.prototype,"debugExtensionHost",null),pe([D.$vh],c.prototype,"logLevel",null),pe([D.$vh],c.prototype,"extensionLogLevel",null),pe([D.$vh],c.prototype,"serviceMachineIdResource",null),pe([D.$vh],c.prototype,"disableTelemetry",null),pe([D.$vh],c.prototype,"disableWorkspaceTrust",null),pe([D.$vh],c.prototype,"useInMemorySecretStorage",null),pe([D.$vh],c.prototype,"policyFile",null);function P(g,f){return O(g["inspect-extensions"],g["inspect-brk-extensions"],5870,f,g.debugId,g.extensionEnvironment)}e.$xm=P;function O(g,f,E,v,d,u){const I=Number(f||g)||(v?null:E),m=I?!!f:!1;let y;if(u)try{y=JSON.parse(u)}catch{}return{port:I,break:m,debugId:d,env:y}}e.$ym=O}),function(){"use strict";function G(e,L,D){function j(A,b){const h=N(A,b),c=[h];return e.isAbsolute(h)||c.unshift(D),e.resolve(...c)}function N(A,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const P=A["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const O=process.env.USERPROFILE;if(typeof O!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(O,"AppData","Roaming")}break;case"darwin":c=e.join(L.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:j}}if(typeof define=="function")define(te[111],ne([165,33,35]),function(e,L,D){return G(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=G(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[112],ne([0,1,33,110,111]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=void 0;class N extends D.$wm{constructor(c,P){super(c,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,j.getUserDataPath)(c,P.nameShort)},P)}}e.$zm=N;function A(h,c){return(0,D.$ym)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$Am=A;function b(h,c){return(0,D.$ym)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$Bm=b}),define(te[113],ne([0,1,3,95]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;function j(A,b,h,c){try{N(A,b,h,c)}catch(P){A.error(P?.message??P)}return b}e.$Np=j;function N(A,b,h,c){const P=(O,g,f)=>{const E=O[g];if((0,L.$Gf)(E)){const v=E,d=v.length;if(d>1&&v[0]==="%"&&v[d-1]==="%"){const u=v.substr(1,d-2);let p=h[u];p===void 0&&c&&(p=c[u]);const I=typeof p=="string"?p:p?.message,m=c?.[u],y=typeof m=="string"?m:m?.message;if(!I){y||A.warn(`[${b.name}]: ${(0,D.localize)(0,null,u)}`);return}if(f&&(g==="title"||g==="category")&&y&&y!==I){const s={value:I,original:y};O[g]=s}else O[g]=I}}else if((0,L.$If)(E))for(const v in E)E.hasOwnProperty(v)&&(v==="commands"?P(E,v,!0):P(E,v,f));else if(Array.isArray(E))for(let v=0;v<E.length;v++)P(E,v,f)};for(const O in b)b.hasOwnProperty(O)&&P(b,O)}}),define(te[114],ne([0,1,48,98]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;function j(N){return(0,L.$Ep)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$Vp=j}),define(te[49],ne([0,1,17,54,99,42]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function h(u){return u=u.trim(),u==="*"||A.test(u)}e.$2o=h;function c(u){if(!h(u))return null;if(u=u.trim(),u==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=u.match(A);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.$3o=c;function P(u){if(!u)return null;const p=u.majorBase,I=u.majorMustEqual,m=u.minorBase;let y=u.minorMustEqual;const s=u.patchBase;let o=u.patchMustEqual;u.hasCaret&&(p===0||(y=!1),o=!1);let t=0;if(u.preRelease){const i=b.exec(u.preRelease);if(i){const[,n,r,l]=i;t=Date.UTC(Number(n),Number(r)-1,Number(l))}}return{majorBase:p,majorMustEqual:I,minorBase:m,minorMustEqual:y,patchBase:s,patchMustEqual:o,isMinimum:u.hasGreaterEquals,notBefore:t}}e.$4o=P;function O(u,p,I){let m;typeof u=="string"?m=P(c(u)):m=u;let y;p instanceof Date?y=p.getTime():typeof p=="string"&&(y=new Date(p).getTime());let s;if(typeof I=="string"?s=P(c(I)):s=I,!m||!s)return!1;const o=m.majorBase,t=m.minorBase,i=m.patchBase;let n=s.majorBase,r=s.minorBase,l=s.patchBase;const S=s.notBefore;let k=s.majorMustEqual,w=s.minorMustEqual,R=s.patchMustEqual;return s.isMinimum?o>n?!0:o<n?!1:t>r?!0:t<r||y&&y<S?!1:i>=l:(o===1&&n===0&&(!k||!w||!R)&&(n=1,r=0,l=0,k=!0,w=!1,R=!1),o<n?!1:o>n?!k:t<r?!1:t>r?!w:i<l?!1:i>l?!R:!(y&&y<S))}e.$5o=O;function g(u,p,I,m,y){const s=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return s.push([D.default.Error,j.localize(0,null)]),s;if(typeof m.name!="string")return s.push([D.default.Error,j.localize(1,null,"name")]),s;if(typeof m.version!="string")return s.push([D.default.Error,j.localize(2,null,"version")]),s;if(!m.engines)return s.push([D.default.Error,j.localize(3,null,"engines")]),s;if(typeof m.engines.vscode!="string")return s.push([D.default.Error,j.localize(4,null,"engines.vscode")]),s;if(typeof m.extensionDependencies<"u"&&!d(m.extensionDependencies))return s.push([D.default.Error,j.localize(5,null,"extensionDependencies")]),s;if(typeof m.activationEvents<"u"){if(!d(m.activationEvents))return s.push([D.default.Error,j.localize(6,null,"activationEvents")]),s;if(typeof m.main>"u"&&typeof m.browser>"u")return s.push([D.default.Error,j.localize(7,null,"activationEvents","main","browser")]),s}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&s.push([D.default.Warning,j.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return s.push([D.default.Error,j.localize(9,null,"main")]),s;{const i=(0,L.$Fg)(I,m.main);(0,L.$zg)(i,I)||s.push([D.default.Warning,j.localize(10,null,i.path,I.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return s.push([D.default.Error,j.localize(11,null,"browser")]),s;{const i=(0,L.$Fg)(I,m.browser);(0,L.$zg)(i,I)||s.push([D.default.Warning,j.localize(12,null,i.path,I.path)])}}if(!N.valid(m.version))return s.push([D.default.Error,j.localize(13,null)]),s;const o=[];if(!f(u,p,m,y,o))for(const i of o)s.push([D.default.Error,i]);return s}e.$6o=g;function f(u,p,I,m,y){return m||typeof I.main>"u"&&typeof I.browser>"u"?!0:v(u,p,I.engines.vscode,y)}e.$7o=f;function E(u,p,I){return u==="*"||v(p,I,u)}e.$8o=E;function v(u,p,I,m=[]){const y=P(c(I));if(!y)return m.push(j.localize(14,null,I)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return m.push(j.localize(15,null,I)),!1}else if(!y.majorMustEqual)return m.push(j.localize(16,null,I)),!1;return O(u,p,y)?!0:(m.push(j.localize(17,null,u,I)),!1)}function d(u){if(!Array.isArray(u))return!1;for(let p=0,I=u.length;p<I;p++)if(typeof u[p]!="string")return!1;return!0}}),define(te[115],ne([0,1,14,28]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function j(N,A,b){let h=b&&b.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const P=(await A.readFile(N.serviceMachineIdResource)).value.toString();h=(0,D.$ng)(P)?P:null}catch{h=null}if(!h){h=(0,D.$og)();try{await A.writeFile(N.serviceMachineIdResource,L.$he.fromString(h))}catch{}}return b?.store("storage.serviceMachineId",h,-1,1),h}e.$pp=j}),define(te[50],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class L{constructor(j,N=[],A=!1){this.ctor=j,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$1h=L}),define(te[116],ne([0,1,50]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.InstantiationType=void 0;const D=[];var j;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(j||(e.InstantiationType=j={}));function N(b,h,c){h instanceof L.$1h||(h=new L.$1h(h,[],!!c)),D.push([b,h])}e.$Nr=N;function A(){return D}e.$Or=A}),define(te[117],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$rq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const b=this.lookupOrInsertNode(N),h=this.lookupOrInsertNode(A);b.outgoing.set(h.key,h),h.incoming.set(b.key,b)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const b of this.a.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let b=this.a.get(A);return b||(b=new L(A,N),this.a.set(A,b)),b}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,b]of this.a)N.push(`${A}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const b=new Set([N]),h=this.c(A,b);if(h)return h}}c(N,A){for(const[b,h]of N.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const c=this.c(h,A);if(c)return c;A.delete(b)}}}e.$sq=D}),define(te[25],ne([0,1,3,11,10]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.ConfigurationTarget=e.$zi=e.$yi=e.$xi=void 0,e.$xi=(0,j.$4h)("configurationService");function N(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof D.URI)}e.$yi=N;function A(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof D.URI)}e.$zi=A;var b;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function h(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ai=h;function c(u){return u.applicationValue!==void 0||u.userValue!==void 0||u.userLocalValue!==void 0||u.userRemoteValue!==void 0||u.workspaceValue!==void 0||u.workspaceFolderValue!==void 0}e.$Bi=c;function P(u,p){const I=Object.create(null);for(const m in u)O(I,m,u[m],p);return I}e.$Ci=P;function O(u,p,I,m){const y=p.split("."),s=y.pop();let o=u;for(let t=0;t<y.length;t++){const i=y[t];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${p} as ${y.slice(0,t+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[s]=I}catch{m(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}else m(`Ignoring ${p} as ${y.join(".")} is ${JSON.stringify(o)}`)}e.$Di=O;function g(u,p){const I=p.split(".");f(u,I)}e.$Ei=g;function f(u,p){const I=p.shift();if(p.length===0){delete u[I];return}if(Object.keys(u).indexOf(I)!==-1){const m=u[I];typeof m=="object"&&!Array.isArray(m)&&(f(m,p),Object.keys(m).length===0&&delete u[I])}}function E(u,p,I){function m(o,t){let i=o;for(const n of t){if(typeof i!="object"||i===null)return;i=i[n]}return i}const y=p.split("."),s=m(u,y);return typeof s>"u"?I:s}e.$Fi=E;function v(u,p,I){Object.keys(p).forEach(m=>{m!=="__proto__"&&(m in u?L.$If(u[m])&&L.$If(p[m])?v(u[m],p[m],I):I&&(u[m]=p[m]):u[m]=p[m])})}e.$Gi=v;function d(u){return u.replace(/[\[\]]/g,"")}e.$Hi=d}),define(te[118],ne([0,1,13,29,109,10,90,9]),function(G,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.ContextKeyExprType=e.$Zi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",L.$j),h.set("isLinux",L.$k),h.set("isWindows",L.$i),h.set("isWeb",L.$o),h.set("isMacNative",L.$j&&!L.$o),h.set("isEdge",L.$H),h.set("isFirefox",L.$F),h.set("isChrome",L.$E),h.set("isSafari",L.$G);function c(z,a){if(h.get(z)!==void 0)throw(0,b.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(z,a)}e.$Zi=c;const P=Object.prototype.hasOwnProperty;var O;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(O||(e.ContextKeyExprType=O={}));const g={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),E=(0,A.localize)(1,null),v=(0,A.localize)(2,null),d=(0,A.localize)(3,null),u=(0,A.localize)(4,null),p=(0,A.localize)(5,null),I=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class y{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(a=g){this.k=a,this.d=new j.$Yi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(a){if(a===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:E});return}this.f=this.d.reset(a).scan(),this.g=0,this.h=[];try{const $=this.l();if(!this.E()){const F=this.D(),U=F.type===17?p:void 0;throw this.h.push({message:u,offset:F.offset,lexeme:j.$Yi.getLexeme(F),additionalInfo:U}),y.c}return $}catch($){if($!==y.c)throw $;return}}l(){return this.m()}m(){const a=[this.o()];for(;this.y(16);){const $=this.o();a.push($)}return a.length===1?a[0]:s.or(...a)}o(){const a=[this.s()];for(;this.y(15);){const $=this.s();a.push($)}return a.length===1?a[0]:s.and(...a)}s(){if(this.y(2)){const a=this.D();switch(a.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const $=this.l();return this.A(1,d),$?.negate()}case 17:return this.z(),H.create(a.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",a)}}return this.t()}t(){const a=this.D();switch(a.type){case 11:return this.z(),s.true();case 12:return this.z(),s.false();case 0:{this.z();const $=this.l();return this.A(1,d),$}case 17:{const $=a.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Y=U.lexeme,W=Y.lastIndexOf("/"),le=W===Y.length-1?void 0:this.w(Y.substring(W+1));let ae;try{ae=new RegExp(Y.substring(1,W),le)}catch{throw this.B("REGEX",U)}return ce.create($,ae)}switch(U.type){case 10:case 19:{const Y=[U.lexeme];this.z();let W=this.D(),le=0;for(let fe=0;fe<U.lexeme.length;fe++)U.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:le++;break;case 1:le--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?le++:U.lexeme.charCodeAt(fe)===41&&le--}if(le<0)break;Y.push(j.$Yi.getLexeme(W)),this.z(),W=this.D()}const ae=Y.join(""),me=ae.lastIndexOf("/"),de=me===ae.length-1?void 0:this.w(ae.substring(me+1));let ge;try{ge=new RegExp(ae.substring(1,me),de)}catch{throw this.B("REGEX",U)}return s.regex($,ge)}case 18:{const Y=U.lexeme;this.z();let W=null;if(!(0,D.$He)(Y)){const le=Y.indexOf("/"),ae=Y.lastIndexOf("/");if(le!==ae&&le>=0){const me=Y.slice(le+1,ae),de=Y[ae+1]==="i"?"i":"";try{W=new RegExp(me,de)}catch{throw this.B("REGEX",U)}}}if(W===null)throw this.B("REGEX",U);return ce.create($,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const U=this.u();return s.notIn($,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return s.equals($,U);switch(U){case"true":return s.has($);case"false":return s.not($);default:return s.equals($,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return s.notEquals($,U);switch(U){case"true":return s.not($);case"false":return s.has($);default:return s.notEquals($,U)}}case 5:return this.z(),se.create($,this.u());case 6:return this.z(),ue.create($,this.u());case 7:return this.z(),_.create($,this.u());case 8:return this.z(),re.create($,this.u());case 13:return this.z(),s.in($,this.u());default:return s.has($)}}case 20:throw this.h.push({message:I,offset:a.offset,lexeme:"",additionalInfo:m}),y.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const a=this.D();switch(a.type){case 17:case 18:return this.z(),a.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(a){return a.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(a){return this.C(a)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(a,$){if(this.C(a))return this.z();throw this.B($,this.D())}B(a,$,F){const U=(0,A.localize)(8,null,a,j.$Yi.getLexeme($)),Y=$.offset,W=j.$Yi.getLexeme($);return this.h.push({message:U,offset:Y,lexeme:W,additionalInfo:F}),y.c}C(a){return this.D().type===a}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$1i=y;class s{static false(){return n.INSTANCE}static true(){return r.INSTANCE}static has(a){return l.create(a)}static equals(a,$){return S.create(a,$)}static notEquals(a,$){return R.create(a,$)}static regex(a,$){return ce.create(a,$)}static in(a,$){return k.create(a,$)}static notIn(a,$){return w.create(a,$)}static not(a){return H.create(a)}static and(...a){return X.create(a,null,!0)}static or(...a){return M.create(a,null,!0)}static greater(a,$){return _.create(a,$)}static greaterEquals(a,$){return re.create(a,$)}static smaller(a,$){return se.create(a,$)}static smallerEquals(a,$){return ue.create(a,$)}static{this.c=new y({regexParsingWithErrorRecovery:!1})}static deserialize(a){return a==null?void 0:this.c.parse(a)}}e.$2i=s;function o(z){const a=new y({regexParsingWithErrorRecovery:!1});return z.map($=>(a.parse($),a.lexingErrors.length>0?a.lexingErrors.map(F=>({errorMessage:F.additionalInfo?(0,A.localize)(9,null,F.additionalInfo):(0,A.localize)(10,null),offset:F.offset,length:F.lexeme.length})):a.parsingErrors.length>0?a.parsingErrors.map(F=>({errorMessage:F.additionalInfo?`${F.message}. ${F.additionalInfo}`:F.message,offset:F.offset,length:F.lexeme.length})):[]))}e.$3i=o;function t(z,a){const $=z?z.substituteConstants():void 0,F=a?a.substituteConstants():void 0;return!$&&!F?!0:!$||!F?!1:$.equals(F)}e.$4i=t;function i(z,a){return z.cmp(a)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return r.INSTANCE}}e.$5i=n;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}substituteConstants(){return this}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return n.INSTANCE}}e.$6i=r;class l{static create(a,$=null){const F=h.get(a);return typeof F=="boolean"?F?r.INSTANCE:n.INSTANCE:new l(a,$)}constructor(a,$){this.key=a,this.c=$,this.type=2}cmp(a){return a.type!==this.type?this.type-a.type:V(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}substituteConstants(){const a=h.get(this.key);return typeof a=="boolean"?a?r.INSTANCE:n.INSTANCE:this}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$7i=l;class S{static create(a,$,F=null){if(typeof $=="boolean")return $?l.create(a,F):H.create(a,F);const U=h.get(a);return typeof U=="boolean"?$===(U?"true":"false")?r.INSTANCE:n.INSTANCE:new S(a,$,F)}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=4}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const $=a?"true":"false";return this.d===$?r.INSTANCE:n.INSTANCE}return this}evaluate(a){return a.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(a){return a.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$8i=S;class k{static create(a,$){return new k(a,$)}constructor(a,$){this.d=a,this.f=$,this.type=10,this.c=null}cmp(a){return a.type!==this.type?this.type-a.type:J(this.d,this.f,a.d,a.f)}equals(a){return a.type===this.type?this.d===a.d&&this.f===a.f:!1}substituteConstants(){return this}evaluate(a){const $=a.getValue(this.f),F=a.getValue(this.d);return Array.isArray($)?$.includes(F):typeof F=="string"&&typeof $=="object"&&$!==null?P.call($,F):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(a){return a.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$9i=k;class w{static create(a,$){return new w(a,$)}constructor(a,$){this.d=a,this.f=$,this.type=11,this.c=k.create(a,$)}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(a){return a.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$0i=w;class R{static create(a,$,F=null){if(typeof $=="boolean")return $?H.create(a,F):l.create(a,F);const U=h.get(a);return typeof U=="boolean"?$===(U?"true":"false")?n.INSTANCE:r.INSTANCE:new R(a,$,F)}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=5}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){const a=h.get(this.c);if(typeof a=="boolean"){const $=a?"true":"false";return this.d===$?n.INSTANCE:r.INSTANCE}return this}evaluate(a){return a.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(a){return a.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$$i=R;class H{static create(a,$=null){const F=h.get(a);return typeof F=="boolean"?F?n.INSTANCE:r.INSTANCE:new H(a,$)}constructor(a,$){this.c=a,this.d=$,this.type=3}cmp(a){return a.type!==this.type?this.type-a.type:V(this.c,a.c)}equals(a){return a.type===this.type?this.c===a.c:!1}substituteConstants(){const a=h.get(this.c);return typeof a=="boolean"?a?n.INSTANCE:r.INSTANCE:this}evaluate(a){return!a.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(a){return a.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$_i=H;function ee(z,a){if(typeof z=="string"){const $=parseFloat(z);isNaN($)||(z=$)}return typeof z=="string"||typeof z=="number"?a(z):n.INSTANCE}class _{static create(a,$,F=null){return ee($,U=>new _(a,U,F))}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=12}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$aj=_;class re{static create(a,$,F=null){return ee($,U=>new re(a,U,F))}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=13}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(a){return a.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.$bj=re;class se{static create(a,$,F=null){return ee($,U=>new se(a,U,F))}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=14}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$cj=se;class ue{static create(a,$,F=null){return ee($,U=>new ue(a,U,F))}constructor(a,$,F){this.c=a,this.d=$,this.f=F,this.type=15}cmp(a){return a.type!==this.type?this.type-a.type:J(this.c,this.d,a.c,a.d)}equals(a){return a.type===this.type?this.c===a.c&&this.d===a.d:!1}substituteConstants(){return this}evaluate(a){return typeof this.d=="string"?!1:parseFloat(a.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(a){return a.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$dj=ue;class ce{static create(a,$){return new ce(a,$)}constructor(a,$){this.d=a,this.f=$,this.type=7,this.c=null}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.d<a.d)return-1;if(this.d>a.d)return 1;const $=this.f?this.f.source:"",F=a.f?a.f.source:"";return $<F?-1:$>F?1:0}equals(a){if(a.type===this.type){const $=this.f?this.f.source:"",F=a.f?a.f.source:"";return this.d===a.d&&$===F}return!1}substituteConstants(){return this}evaluate(a){const $=a.getValue(this.d);return this.f?this.f.test($):!1}serialize(){const a=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${a}`}keys(){return[this.d]}map(a){return a.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$ej=ce;class oe{static create(a){return new oe(a)}constructor(a){this.c=a,this.type=8}cmp(a){return a.type!==this.type?this.type-a.type:this.c.cmp(a.c)}equals(a){return a.type===this.type?this.c.equals(a.c):!1}substituteConstants(){return this}evaluate(a){return!this.c.evaluate(a)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(a){return new oe(this.c.map(a))}negate(){return this.c}}e.$fj=oe;function B(z){let a=null;for(let $=0,F=z.length;$<F;$++){const U=z[$].substituteConstants();if(z[$]!==U&&a===null){a=[];for(let Y=0;Y<$;Y++)a[Y]=z[Y]}a!==null&&(a[$]=U)}return a===null?z:a}class X{static create(a,$,F){return X.d(a,$,F)}constructor(a,$){this.expr=a,this.c=$,this.type=6}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let $=0,F=this.expr.length;$<F;$++){const U=i(this.expr[$],a.expr[$]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let $=0,F=this.expr.length;$<F;$++)if(!this.expr[$].equals(a.expr[$]))return!1;return!0}return!1}substituteConstants(){const a=B(this.expr);return a===this.expr?this:X.create(a,this.c,!1)}evaluate(a){for(let $=0,F=this.expr.length;$<F;$++)if(!this.expr[$].evaluate(a))return!1;return!0}static d(a,$,F){const U=[];let Y=!1;for(const W of a)if(W){if(W.type===1){Y=!0;continue}if(W.type===0)return n.INSTANCE;if(W.type===6){U.push(...W.expr);continue}U.push(W)}if(U.length===0&&Y)return r.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(i);for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];for(;U.length>1;){const W=U[U.length-1];if(W.type!==9)break;U.pop();const le=U.pop(),ae=U.length===0,me=M.create(W.expr.map(de=>X.create([de,le],null,F)),null,ae);me&&(U.push(me),U.sort(i))}if(U.length===1)return U[0];if(F){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return n.INSTANCE;if(U.length===1)return U[0]}return new X(U,$)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(const $ of this.expr)a.push(...$.keys());return a}map(a){return new X(this.expr.map($=>$.map(a)),null)}negate(){if(!this.c){const a=[];for(const $ of this.expr)a.push($.negate());this.c=M.create(a,this,!0)}return this.c}}e.$gj=X;class M{static create(a,$,F){return M.d(a,$,F)}constructor(a,$){this.expr=a,this.c=$,this.type=9}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let $=0,F=this.expr.length;$<F;$++){const U=i(this.expr[$],a.expr[$]);if(U!==0)return U}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let $=0,F=this.expr.length;$<F;$++)if(!this.expr[$].equals(a.expr[$]))return!1;return!0}return!1}substituteConstants(){const a=B(this.expr);return a===this.expr?this:M.create(a,this.c,!1)}evaluate(a){for(let $=0,F=this.expr.length;$<F;$++)if(this.expr[$].evaluate(a))return!0;return!1}static d(a,$,F){let U=[],Y=!1;if(a){for(let W=0,le=a.length;W<le;W++){const ae=a[W];if(ae){if(ae.type===0){Y=!0;continue}if(ae.type===1)return r.INSTANCE;if(ae.type===9){U=U.concat(ae.expr);continue}U.push(ae)}}if(U.length===0&&Y)return n.INSTANCE;U.sort(i)}if(U.length!==0){if(U.length===1)return U[0];for(let W=1;W<U.length;W++)U[W-1].equals(U[W])&&(U.splice(W,1),W--);if(U.length===1)return U[0];if(F){for(let W=0;W<U.length;W++)for(let le=W+1;le<U.length;le++)if(U[W].negate().equals(U[le]))return r.INSTANCE;if(U.length===1)return U[0]}return new M(U,$)}}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(const $ of this.expr)a.push(...$.keys());return a}map(a){return new M(this.expr.map($=>$.map(a)),null)}negate(){if(!this.c){const a=[];for(const $ of this.expr)a.push($.negate());for(;a.length>1;){const $=a.shift(),F=a.shift(),U=[];for(const Y of T($))for(const W of T(F))U.push(X.create([Y,W],null,!1));a.unshift(M.create(U,null,!1))}this.c=M.create(a,this,!0)}return this.c}}e.$hj=M;class C extends l{static{this.d=[]}static all(){return C.d.values()}constructor(a,$,F){super(a,null),this.f=$,typeof F=="object"?C.d.push({...F,key:a}):F!==!0&&C.d.push({key:a,description:F,type:$!=null?typeof $:void 0})}bindTo(a){return a.createKey(this.key,this.f)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(a){return S.create(this.key,a)}notEqualsTo(a){return R.create(this.key,a)}}e.$ij=C,e.$jj=(0,N.$4h)("contextKeyService");function V(z,a){return z<a?-1:z>a?1:0}function J(z,a,$,F){return z<$?-1:z>$?1:a<F?-1:a>F?1:0}function Q(z,a){if(z.type===0||a.type===1)return!0;if(z.type===9)return a.type===9?K(z.expr,a.expr):!1;if(a.type===9){for(const $ of a.expr)if(Q(z,$))return!0;return!1}if(z.type===6){if(a.type===6)return K(a.expr,z.expr);for(const $ of z.expr)if(Q($,a))return!0;return!1}return z.equals(a)}e.$kj=Q;function K(z,a){let $=0,F=0;for(;$<z.length&&F<a.length;){const U=z[$].cmp(a[F]);if(U<0)return!1;U===0&&$++,F++}return $===z.length}function T(z){return z.type===9?z.expr:[z]}}),define(te[59],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=void 0,e.$5n=(0,L.$4h)("downloadService")}),define(te[18],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=void 0,e.$$h=(0,L.$4h)("environmentService"),e.$_h=(0,L.$5h)(e.$$h)}),define(te[21],ne([0,1,93,10]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$no=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0,e.$bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$co=new RegExp(e.$bo),e.$do="__web_extension",e.$eo="skipWalkthrough",e.$fo="extensionsSync",e.$go="dependecyOrPackExtensionInstall";function j(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ho=j;function N(u){switch(u){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$io=N;function A(u,p){switch(u){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$jo=A;function b(u,p){return p==="web"&&!u.includes("web")}e.$ko=b;function h(u,p,I){return b(p,I)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===I}e.$lo=h;function c(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$mo=c;var P;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(P||(e.SortBy=P={}));var O;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(O||(e.SortOrder=O={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var f;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$no=(0,D.$4h)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var v;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(v||(e.ExtensionSignaturetErrorCode=v={}));class d extends Error{constructor(p,I){super(p),this.code=I,this.name=I}}e.$oo=d,e.$po=(0,D.$4h)("extensionManagementService"),e.$qo="extensionsIdentifiers/disabled",e.$ro="extensionsIdentifiers/enabled",e.$so=(0,D.$4h)("IGlobalExtensionEnablementService"),e.$to=(0,D.$4h)("IExtensionTipsService"),e.$uo=(0,L.localize)(0,null),e.$vo={value:e.$uo,original:"Extensions"},e.$wo=(0,L.localize2)(1,"Preferences")}),define(te[60],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=void 0,e.$up=(0,L.$4h)("IExtensionSignatureVerificationService");class D{b(){return this.a||(this.a=new Promise((N,A)=>G(["node-vsce-sign"],async b=>N(b),A))),this.a}async verify(N,A,b){let h;try{h=await this.b()}catch{return!1}return h.verify(N,A,b)}}e.$vp=D}),define(te[61],ne([0,1,14,9,101,12]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;async function A(P,O,g,f,E,v){let d;try{await b(P,O,g,f,E,v)}catch(u){d=u}finally{d&&E.errorTransformer&&(d=E.errorTransformer(d)),typeof d<"u"&&g.error(d),g.end()}}e.$3p=A;async function b(P,O,g,f,E,v){h(v);const d=await P.open(O,{create:!1});try{h(v);let u=0,p=0,I=E&&typeof E.length=="number"?E.length:void 0,m=L.$he.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),y=E&&typeof E.position=="number"?E.position:0,s=0;do p=await P.read(d,y,m.buffer,s,m.byteLength-s),y+=p,s+=p,u+=p,typeof I=="number"&&(I-=p),s===m.byteLength&&(await g.write(f(m)),m=L.$he.alloc(Math.min(E.bufferSize,typeof I=="number"?I:E.bufferSize)),s=0);while(p>0&&(typeof I!="number"||I>0)&&h(v)&&c(u,E));if(s>0){let o=s;typeof I=="number"&&(o=Math.min(s,I)),g.write(f(m.slice(0,o)))}}catch(u){throw(0,N.$Ck)(u)}finally{await P.close(d)}}function h(P){if(P.isCancellationRequested)throw(0,D.$6)();return!0}function c(P,O){if(typeof O?.limits?.size=="number"&&P>O.limits.size)throw(0,N.$Bk)((0,j.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[119],ne([0,1,4,166,2,13,167]),function(G,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class b extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Td),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Td),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(c){const P=this.j(c),O=P.filter(f=>{const E=this.c.get(f.path);return E?!(0,D.$Oj)(E.request.excludes,f.excludes)||!(0,D.$Oj)(E.request.includes,f.includes):!0}),g=Array.from(this.c.values()).filter(({request:f})=>!P.find(E=>E.path===f.path&&(0,D.$Oj)(E.excludes,f.excludes)&&(0,D.$Oj)(E.includes,f.includes))).map(({request:f})=>f.path);O.length&&this.m(`Request to start watching: ${O.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),g.length&&this.m(`Request to stop watching: ${g.join(",")}`);for(const f of g)this.h(f);for(const f of O)this.g(f)}g(c){const P=new A.$mq(c,g=>this.a.fire(g),g=>this.b.fire(g),this.f),O={request:c,instance:P};this.c.set(c.path,O)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const P=this.c.get(c);P&&(this.c.delete(c),P.instance.dispose())}j(c){const P=new Map;for(const O of c){const g=N.$k?O.path:O.path.toLowerCase();let f=P.get(O.correlationId);f||(f=new Map,P.set(O.correlationId,f)),f.set(g,O)}return Array.from(P.values()).map(O=>Array.from(O.values())).flat()}async setVerboseLogging(c){this.f=c;for(const[,P]of this.c)P.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,P){return P?`[File Watcher (node.js)] ${c} (path: ${P.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$oq=b}),define(te[120],ne([0,1,62,119]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;class j extends L.$7p{constructor(A,b,h){super(A,b,h),this.s()}r(A){return A.add(new D.$oq)}}e.$pq=j}),define(te[121],ne([0,1,15,57,85,62]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class A extends N.$8p{constructor(h,c,P){super(h,c,P),this.s()}r(h){const c=h.add(new j.$gq(L.$mg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:P,signal:O})=>this.t(`terminated by itself with code ${P}, signal: ${O}`))),D.ProxyChannel.toService((0,D.$Kh)(c.getChannel("watcher")))}}e.$hq=A}),define(te[63],ne([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class L{constructor(...j){this.a=new Map;for(const[N,A]of j)this.set(N,A)}set(j,N){const A=this.a.get(j);return this.a.set(j,N),A}has(j){return this.a.has(j)}get(j){return this.a.get(j)}}e.$2h=L}),define(te[122],ne([0,1,8,9,2,50,117,10,63,168]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0;const P=!1;class O extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class g{constructor(d=new h.$2h,u=!1,p,I=P){this.f=d,this.g=u,this.h=p,this.i=I,this.o=new Set,this.f.set(b.$3h,this),this._globalGraph=I?p?._globalGraph??new A.$sq(m=>m):void 0}createChild(d){return new g(d,this.g,this,this.i)}invokeFunction(d,...u){const p=E.traceInvocation(this.i,d);let I=!1;try{return d({get:y=>{if(I)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const s=this.m(y,p);if(!s)throw new Error(`[invokeFunction] unknown service '${y}'`);return s}},...u)}finally{I=!0,p.stop()}}createInstance(d,...u){let p,I;return d instanceof N.$1h?(p=E.traceCreation(this.i,d.ctor),I=this.j(d.ctor,d.staticArguments.concat(u),p)):(p=E.traceCreation(this.i,d),I=this.j(d,u,p)),p.stop(),I}j(d,u=[],p){const I=b._util.getServiceDependencies(d).sort((s,o)=>s.index-o.index),m=[];for(const s of I){const o=this.m(s.id,p);o||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${s.id}.`,!1),m.push(o)}const y=I.length>0?I[0].index:u.length;if(u.length!==y){console.trace(`[createInstance] First service dependency of ${d.name} at position ${y+1} conflicts with ${u.length} static arguments`);const s=y-u.length;s>0?u=u.concat(new Array(s)):u=u.slice(0,y)}return Reflect.construct(d,u.concat(m))}k(d,u){if(this.f.get(d)instanceof N.$1h)this.f.set(d,u);else if(this.h)this.h.k(d,u);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const u=this.f.get(d);return!u&&this.h?this.h.l(d):u}m(d,u){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const p=this.l(d);return p instanceof N.$1h?this.q(d,p,u.branch(d,!0)):(u.branch(d,!1),p)}q(d,u,p){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,u,p)}finally{this.o.delete(d)}}r(d,u,p){const I=new A.$sq(s=>s.id.toString());let m=0;const y=[{id:d,desc:u,_trace:p}];for(;y.length;){const s=y.pop();if(I.lookupOrInsertNode(s),m++>1e3)throw new O(I);for(const o of b._util.getServiceDependencies(s.desc.ctor)){const t=this.l(o.id);if(t||this.u(`[createInstance] ${d} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(s.id),String(o.id)),t instanceof N.$1h){const i={id:o.id,desc:t,_trace:s._trace.branch(o.id,!0)};I.insertEdge(s,i),y.push(i)}}}for(;;){const s=I.roots();if(s.length===0){if(!I.isEmpty())throw new O(I);break}for(const{data:o}of s){if(this.l(o.id)instanceof N.$1h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}I.removeNode(o)}}return this.l(d)}s(d,u,p=[],I,m){if(this.f.get(d)instanceof N.$1h)return this.t(d,u,p,I,m);if(this.h)return this.h.s(d,u,p,I,m);throw new Error(`illegalState - creating UNKNOWN service instance ${u.name}`)}t(d,u,p=[],I,m){if(I){const y=new g(void 0,this.g,this,this.i);y.c=String(d);const s=new Map,o=new L.$kh(()=>{const t=y.j(u,p,m);for(const[i,n]of s){const r=t[i];if(typeof r=="function")for(const l of n)r.apply(t,l)}return s.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let l=s.get(i);return l||(l=new c.$4c,s.set(i,l)),(k,w,R)=>{const H=l.push([k,w,R]);return(0,j.$Rc)(H)}}if(i in t)return t[i];const n=o.value;let r=n[i];return typeof r!="function"||(r=r.bind(n),t[i]=r),r},set(t,i,n){return o.value[i]=n,!0},getPrototypeOf(t){return u.prototype}})}else return this.j(u,p,m)}u(d,u){if(u&&console.warn(d),this.g)throw new Error(d)}}e.$tq=g;var f;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(f||(f={}));class E{static{this.all=new Set}static{this.c=new class extends E{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,u){return d?new E(2,u.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):E.c}static traceCreation(d,u){return d?new E(1,u.name):E.c}static{this.f=0}constructor(d,u){this.type=d,this.name=u,this.g=Date.now(),this.h=[]}branch(d,u){const p=new E(3,d.toString());return this.h.push([d,u,p]),p}stop(){const d=Date.now()-this.g;E.f+=d;let u=!1;function p(m,y){const s=[],o=new Array(m+1).join("	");for(const[t,i,n]of y.h)if(i&&n){u=!0,s.push(`${o}CREATES -> ${t}`);const r=p(m+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${t}`);return s.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E.f.toFixed(2)}ms)`];(d>2||u)&&E.all.add(I.join(`
`))}}e.$uq=E});var ie=this&&this.__param||function(G,e){return function(L,D){e(L,D,G)}};define(te[64],ne([0,1,20,2,13,103,21,10]),function(G,e,L,D,j,N,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=void 0;function h(P){return P.tags.find(O=>O.startsWith("lp-"))?.split("lp-")[1]}e.$8q=h,e.$9q=(0,b.$4h)("languagePackService");let c=class extends D.$Tc{constructor(O){super(),this.c=O}async getAvailableLanguages(){const O=new L.$4d;setTimeout(()=>O.cancel(),1e3);let g;try{g=await this.c.query({text:'category:"language packs"',pageSize:20},O.token)}catch{return[]}const E=g.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(d=>d.startsWith("lp-"))).map(v=>{const d=v.properties.localizedLanguages?.[0],u=h(v);return{...this.f(u,d,v),extensionId:v.identifier.id,galleryExtension:v}});return E.push(this.f("en","English")),E}f(O,g,f){const E=g??O;let v;if(E!==O&&(v=`(${O})`),O.toLowerCase()===j.$w.toLowerCase()&&(v??="",v+=(0,N.localize)(0,null)),f?.installCount){v??="";const d=f.installCount;let u;d>1e6?u=`${Math.floor(d/1e5)/10}M`:d>1e3?u=`${Math.floor(d/1e3)}K`:u=String(d),v+=` $(cloud-download) ${u}`}return{id:O,label:E,description:v}}};e.$0q=c,e.$0q=c=pe([ie(0,A.$no)],c)}),define(te[6],ne([0,1,34,4,41,2,31,13,17,3,11,118,10]),function(G,e,L,D,j,N,A,b,h,c,P,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.log=e.$oj=e.LogLevel=e.$nj=e.$mj=e.$lj=void 0,e.$lj=(0,g.$4h)("logService"),e.$mj=(0,g.$4h)("loggerService");function f(){return new Date().toISOString()}function E(k){return(0,c.$Kf)(k)}e.$nj=E;var v;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$oj=v.Info;function d(k,w,R){switch(w){case v.Trace:k.trace(R);break;case v.Debug:k.debug(R);break;case v.Info:k.info(R);break;case v.Warning:k.warn(R);break;case v.Error:k.error(R);break;case v.Off:break;default:throw new Error(`Invalid log level ${w}`)}}e.log=d;function u(k,w=!1){let R="";for(let H=0;H<k.length;H++){let ee=k[H];if(ee instanceof Error&&(ee=(0,L.$Oi)(ee,w)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}R+=(H>0?" ":"")+ee}return R}class p extends N.$Tc{constructor(){super(...arguments),this.b=e.$oj,this.c=this.B(new D.$Td),this.onDidChangeLogLevel=this.c.event}setLevel(w){this.b!==w&&(this.b=w,this.c.fire(this.b))}getLevel(){return this.b}f(w){return this.b!==v.Off&&this.b<=w}}e.$qj=p;class I extends p{constructor(w){super(),this.h=w}f(w){return this.h||super.f(w)}trace(w,...R){this.f(v.Trace)&&this.g(v.Trace,u([w,...R],!0))}debug(w,...R){this.f(v.Debug)&&this.g(v.Debug,u([w,...R]))}info(w,...R){this.f(v.Info)&&this.g(v.Info,u([w,...R]))}warn(w,...R){this.f(v.Warning)&&this.g(v.Warning,u([w,...R]))}error(w,...R){if(this.f(v.Error))if(w instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=w.stack,this.g(v.Error,u(H))}else this.g(v.Error,u([w,...R]))}flush(){}}e.$rj=I;class m extends p{constructor(w=e.$oj){super(),this.setLevel(w),this.g=!b.$i}trace(w,...R){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}debug(w,...R){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}info(w,...R){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,w,...R):console.log(`[main ${f()}]`,w,...R))}warn(w,...R){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,w,...R):console.warn(`[main ${f()}]`,w,...R))}error(w,...R){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,w,...R):console.error(`[main ${f()}]`,w,...R))}flush(){}}e.$sj=m;class y extends p{constructor(w=e.$oj,R=!0){super(),this.g=R,this.setLevel(w)}trace(w,...R){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",w,...R):console.log(w,...R))}debug(w,...R){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",w,...R):console.log(w,...R))}info(w,...R){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",w,...R):console.log(w,...R))}warn(w,...R){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",w,...R):console.log(w,...R))}error(w,...R){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",w,...R):console.error(w,...R))}flush(){}}e.$tj=y;class s extends p{constructor(w,R=e.$oj){super(),this.g=w,this.setLevel(R)}trace(w,...R){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(w),...R])}debug(w,...R){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(w),...R])}info(w,...R){this.f(v.Info)&&this.g.log(v.Info,[this.h(w),...R])}warn(w,...R){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(w),...R])}error(w,...R){this.f(v.Error)&&this.g.log(v.Error,[this.h(w),...R])}h(w){return typeof w=="string"?w:(0,L.$Oi)(w,this.f(v.Trace))}flush(){}}e.$uj=s;class o extends p{constructor(w){super(),this.g=w,w.length&&this.setLevel(w[0].getLevel())}setLevel(w){for(const R of this.g)R.setLevel(w);super.setLevel(w)}trace(w,...R){for(const H of this.g)H.trace(w,...R)}debug(w,...R){for(const H of this.g)H.debug(w,...R)}info(w,...R){for(const H of this.g)H.info(w,...R)}warn(w,...R){for(const H of this.g)H.warn(w,...R)}error(w,...R){for(const H of this.g)H.error(w,...R)}flush(){for(const w of this.g)w.flush()}dispose(){for(const w of this.g)w.dispose();super.dispose()}}e.$vj=o;class t extends N.$Tc{constructor(w,R,H){if(super(),this.h=w,this.j=R,this.b=new A.$Ac,this.c=this.B(new D.$Td),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Td),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Td),this.onDidChangeVisibility=this.g.event,H)for(const ee of H)this.b.set(ee.resource,{logger:void 0,info:ee})}m(w){return(0,c.$Gf)(w)?[...this.b.values()].find(R=>R.info.id===w):this.b.get(w)}getLogger(w){return this.m(w)?.logger}createLogger(w,R){const H=this.n(w),ee=(0,c.$Gf)(w)?w:R?.id??(0,j.$Ri)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const re=R?.logLevel==="always"?v.Trace:R?.logLevel;_||(_=this.s(H,re??this.getLogLevel(H)??this.h,{...R,id:ee}));const se={logger:_,info:{resource:H,id:ee,logLevel:re,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(se.info),this.b.set(H,se),_}n(w){return(0,c.$Gf)(w)?(0,h.$Fg)(this.j,`${w}.log`):w}setLogLevel(w,R){if(P.URI.isUri(w)){const H=w,ee=R,_=this.b.get(H);_&&ee!==_.info.logLevel&&(_.info.logLevel=ee===this.h?void 0:ee,_.logger?.setLevel(ee),this.b.set(_.info.resource,_),this.f.fire([H,ee]))}else{this.h=w;for(const[H,ee]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(w,R){const H=this.m(w);H&&R!==!H.info.hidden&&(H.info.hidden=!R,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,R]))}getLogLevel(w){let R;return w&&(R=this.b.get(w)?.info.logLevel),R??this.h}registerLogger(w){const R=this.b.get(w.resource);R?R.info.hidden!==w.hidden&&this.setVisibility(w.resource,!w.hidden):(this.b.set(w.resource,{info:w,logger:void 0}),this.c.fire({added:[w],removed:[]}))}deregisterLogger(w){const R=this.b.get(w);R&&(R.logger&&R.logger.dispose(),this.b.delete(w),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const w of this.b.values())yield w.info}getRegisteredLogger(w){return this.b.get(w)?.info}dispose(){this.b.forEach(w=>w.logger?.dispose()),this.b.clear(),super.dispose()}}e.$wj=t;class i{constructor(){this.onDidChangeLogLevel=new D.$Td().event}setLevel(w){}getLevel(){return v.Info}trace(w,...R){}debug(w,...R){}info(w,...R){}warn(w,...R){}error(w,...R){}critical(w,...R){}dispose(){}flush(){}}e.$xj=i;class n extends i{}e.$yj=n;function r(k){if(k.verbose)return v.Trace;if(typeof k.logLevel=="string"){const w=S(k.logLevel.toLowerCase());if(w!==void 0)return w}return e.$oj}e.$zj=r;function l(k){switch(k){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$Aj=l;function S(k){switch(k){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$Bj=S,e.$Cj=new O.$ij("logLevel",l(v.Info))}),define(te[123],ne([0,1,19,8,9,4,2,16,62,6]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class P extends A.$Tc{constructor(g,f){super(),this.a=g,this.b=f,this.c=this.B(new N.$Td),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Td),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$2g(0)),this.w=[],this.y=this.B(new D.$2g(0))}watch(g,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(g,f):this.z(g,f)}n(g,f){const E={path:this.H(g),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},v=(0,L.$Ub)(this.j,E);return this.r(),(0,A.$Rc)(()=>{v(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(g=>(0,j.$1)(g))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$9p)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const g=this.b?.watcher?.recursive?.usePolling;if(g===!0)for(const f of this.j)(0,h.$5p)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(g))for(const f of this.j)(0,h.$5p)(f)&&g.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(g,f){const E={path:this.H(g),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},v=(0,L.$Ub)(this.w,E);return this.C(),(0,A.$Rc)(()=>{v(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(g=>(0,j.$1)(g))}D(){return this.u||(this.u=this.B(this.F(g=>this.c.fire((0,h.$9p)(g)),g=>this.G(g),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(g){g.type==="error"&&this.g.fire(g.message),this.a[g.type](g.message)}H(g){return(0,b.$hc)(g.fsPath)}}e.$aq=P}),define(te[124],ne([0,1,19,8,14,20,4,41,65,2,47,15,125,17,45,100,12,61,6,9]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;let y=class extends c.$Tc{static{m=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new A.$Td),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Td),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Td),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Td),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Td),this.Y=this.B(new A.$Td),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Td),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ah)}registerProvider(o,t){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,g.mark)(`code/registerFilesystem/${o}`);const i=new c.$Sc;return this.h.set(o,t),this.c.fire({added:!0,scheme:o,provider:t}),i.add(t.onDidChangeFile(n=>{const r=new d.$Hk(n,!this.S(t));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:o}))),(0,c.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:t}),this.h.delete(o),(0,c.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const t=[];this.f.fire({scheme:o,join(i){t.push(i)}}),!this.h.has(o)&&await D.Promises.settled(t)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,t){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return h.Iterable.map(this.h,([o,t])=>({scheme:o,capabilities:t.capabilities}))}async j(o){if(!(0,f.$Jg)(o))throw new d.$Jk((0,v.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const t=this.h.get(o.scheme);if(!t){const i=new I.$bb;throw i.message=(0,v.localize)(1,null,o.toString()),i}return t}async m(o){const t=await this.j(o);if((0,d.$uk)(t)||(0,d.$rk)(t)||(0,d.$vk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const t=await this.j(o);if((0,d.$uk)(t)||(0,d.$rk)(t))return t;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,t){try{return await this.s(o,t)}catch(i){throw(0,d.$Ek)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$Jk((0,v.localize)(2,null,this.sb(o)),1):(0,d.$Ck)(i)}}async s(o,t){const i=await this.j(o),n=this.S(i),r=t?.resolveTo,l=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,k=await i.stat(o);let w;return this.t(i,o,k,void 0,!!S,(R,H)=>(w||(w=P.$0h.forUris(()=>!n),w.set(o,!0),r&&w.fill(!0,r)),w.get(R.resource)||w.findSuperstr(R.resource.with({query:null,fragment:null}))?!0:R.isDirectory&&l?H===1:!1))}async t(o,t,i,n,r,l){const{providerExtUri:S}=this.R(o),k={resource:t,name:S.basename(t),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$Uk)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&l(k,n)){try{const w=await o.readdir(t),R=await D.Promises.settled(w.map(async([H,ee])=>{try{const _=S.joinPath(t,H),re=r?await o.stat(_):{type:ee};return await this.t(o,_,re,w.length,r,l)}catch(_){return this.b.trace(_),null}}));k.children=(0,L.$Hb)(R)}catch(w){this.b.trace(w),k.children=[]}return k}return k}async resolveAll(o){return D.Promises.settled(o.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const t=await this.j(o),i=await t.stat(o);return this.t(t,o,i,void 0,!0,()=>!1)}async exists(o){const t=await this.j(o);try{return!!await t.stat(o)}catch{return!1}}async canCreateFile(o,t){try{await this.u(o,t)}catch(i){return i}return!0}async u(o,t){if(!t?.overwrite&&await this.exists(o))throw new d.$Jk((0,v.localize)(3,null,this.sb(o)),3,t)}async createFile(o,t=j.$he.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,t);return this.r.fire(new d.$Gk(o,0,n)),n}async writeFile(o,t,i){const n=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(n);let l=i;if((0,d.$xk)(n)&&!l?.atomic){const S=n.enforceAtomicWriteFile?.(o);S&&(l={...i,atomic:S})}try{await this.w(n,o,l)||await this.U(n,r.dirname(o));let k;if((0,d.$rk)(n)&&!(t instanceof j.$he))if((0,E.$6d)(t)){const w=await(0,E.$ae)(t,3);w.ended?k=j.$he.concat(w.buffer):k=w}else k=(0,E.$0d)(t,w=>j.$he.concat(w),3);else k=t;!(0,d.$uk)(n)||(0,d.$rk)(n)&&k instanceof j.$he||(0,d.$rk)(n)&&(0,d.$xk)(n)&&l?.atomic?await this.hb(n,o,l,k):await this.db(n,o,l,k instanceof j.$he?(0,j.$se)(k):k),this.r.fire(new d.$Gk(o,4))}catch(S){throw new d.$Jk((0,v.localize)(4,null,this.sb(o),(0,d.$Ck)(S).toString()),(0,d.$Fk)(S),l)}return this.resolve(o,{resolveMetadata:!0})}async w(o,t,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,v.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,v.localize)(6,null,this.sb(t)));if(!(o.capabilities&2))throw new Error((0,v.localize)(7,null,this.sb(t)));if(n)throw new Error((0,v.localize)(8,null,this.sb(t)))}let l;try{l=await o.stat(t)}catch{return}if(l.type&d.FileType.Directory)throw new d.$Jk((0,v.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,l),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$Tk&&typeof l.mtime=="number"&&typeof l.size=="number"&&i.mtime<l.mtime&&i.etag!==(0,d.$Uk)({mtime:i.mtime,size:l.size}))throw new d.$Jk((0,v.localize)(10,null),3,i);return l}async readFile(o,t,i){const n=await this.m(o);return t?.atomic?this.z(n,o,t,i):this.C(n,o,t,i)}async z(o,t,i,n){return new Promise((r,l)=>{this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{try{const S=await this.C(o,t,i,n);r(S)}catch(S){l(S)}})})}async C(o,t,i,n){const r=await this.D(o,t,{...i,preferUnbuffered:!0},n);return{...r,value:await(0,j.$te)(r.value)}}async readFileStream(o,t,i){const n=await this.m(o);return this.D(n,o,t,i)}async D(o,t,i,n){const r=new N.$4d(n);let l=i;(0,d.$wk)(o)&&o.enforceAtomicReadFile?.(t)&&(l={...i,atomic:!0});const S=this.J(t,l).then(w=>w,w=>{throw r.dispose(!0),w});let k;try{return typeof l?.etag=="string"&&l.etag!==d.$Tk&&await S,l?.atomic&&(0,d.$wk)(o)||!((0,d.$uk)(o)||(0,d.$vk)(o))||(0,d.$rk)(o)&&l?.preferUnbuffered?k=this.I(o,t,l):(0,d.$vk)(o)?k=this.G(o,t,r.token,l):k=this.H(o,t,r.token,l),k.on("end",()=>r.dispose()),k.on("error",()=>r.dispose()),{...await S,value:k}}catch(w){throw k&&await(0,E.$$d)(k),this.F(w,t,l)}}F(o,t,i){const n=(0,v.localize)(11,null,this.sb(t),(0,d.$Ck)(o).toString());return o instanceof d.$Lk?new d.$Lk(n,o.stat,i):o instanceof d.$Kk?new d.$Kk(n,o.fileOperationResult,o.size,o.options):new d.$Jk(n,(0,d.$Fk)(o),i)}G(o,t,i,n=Object.create(null)){const r=o.readFileStream(t,n,i);return(0,E.$ee)(r,{data:l=>l instanceof j.$he?l:j.$he.wrap(l),error:l=>this.F(l,t,n)},l=>j.$he.concat(l))}H(o,t,i,n=Object.create(null)){const r=(0,j.$xe)();return(0,u.$3p)(o,t,r,l=>l,{...n,bufferSize:this.a,errorTransformer:l=>this.F(l,t,n)},i),r}I(o,t,i){const n=(0,E.$8d)(r=>j.$he.concat(r));return(async()=>{try{let r;i?.atomic&&(0,d.$wk)(o)?r=await o.readFile(t,{atomic:!0}):r=await o.readFile(t),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(t,r.byteLength,i),n.end(j.$he.wrap(r))}catch(r){n.error(r),n.end()}})(),n}async J(o,t){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new d.$Jk((0,v.localize)(12,null,this.sb(o)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.$Tk&&t.etag===i.etag)throw new d.$Lk((0,v.localize)(13,null),i,t);return this.L(o,i.size,t),i}L(o,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new d.$Kk((0,v.localize)(14,null,this.sb(o)),7,t,i)}async canMove(o,t,i){return this.M(o,t,"move",i)}async canCopy(o,t,i){return this.M(o,t,"copy",i)}async M(o,t,i,n){if(o.toString()!==t.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),l=this.qb(await this.n(t),t);await this.Q(r,o,l,t,i,n)}catch(r){return r}return!0}async move(o,t,i){const n=this.qb(await this.n(o),o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,l==="move"?2:3,S)),S}async copy(o,t,i){const n=await this.m(o),r=this.qb(await this.n(t),t),l=await this.N(n,o,r,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,l==="copy"?3:2,S)),S}async N(o,t,i,n,r,l){if(t.toString()===n.toString())return r;const{exists:S,isSameResourceWithDifferentPathCase:k}=await this.Q(o,t,i,n,r,l);if(S&&!k&&l&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),r==="copy"){if(o===i&&(0,d.$sk)(o))await o.copy(t,n,{overwrite:l});else{const w=await this.resolve(t);w.isDirectory?await this.P(o,w,i,n):await this.O(o,t,i,n)}return r}else return o===i?(await o.rename(t,n,{overwrite:l}),r):(await this.N(o,t,i,n,"copy",l),await this.del(t,{recursive:!0}),"copy")}async O(o,t,i,n){if((0,d.$uk)(o)&&(0,d.$uk)(i))return this.jb(o,t,i,n);if((0,d.$uk)(o)&&(0,d.$rk)(i))return this.pb(o,t,i,n);if((0,d.$rk)(o)&&(0,d.$uk)(i))return this.nb(o,t,i,n);if((0,d.$rk)(o)&&(0,d.$rk)(i))return this.lb(o,t,i,n)}async P(o,t,i,n){await i.mkdir(n),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async r=>{const l=this.R(i).providerExtUri.joinPath(n,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,l):this.O(o,r.resource,i,l)}))}async Q(o,t,i,n,r,l){let S=!1;if(o===i){const{providerExtUri:w,isPathCaseSensitive:R}=this.R(o);if(R||(S=w.isEqual(t,n)),S&&r==="copy")throw new Error((0,v.localize)(15,null,this.sb(t),this.sb(n)));if(!S&&w.isEqualOrParent(n,t))throw new Error((0,v.localize)(16,null,this.sb(t),this.sb(n)))}const k=await this.exists(n);if(k&&!S){if(!l)throw new d.$Jk((0,v.localize)(17,null,this.sb(t),this.sb(n)),4);if(o===i){const{providerExtUri:w}=this.R(o);if(w.isEqualOrParent(t,n))throw new Error((0,v.localize)(18,null,this.sb(t),this.sb(n)))}}return{exists:k,isSameResourceWithDifferentPathCase:S}}R(o){const t=this.S(o);return{providerExtUri:t?f.$vg:f.$xg,isPathCaseSensitive:t}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const t=this.qb(await this.j(o),o);await this.U(t,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new d.$Gk(o,0,i)),i}async U(o,t){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(t,n.dirname(t));)try{if(!((await o.stat(t)).type&d.FileType.Directory))throw new Error((0,v.localize)(19,null,this.sb(t)));break}catch(r){if((0,d.$Ek)(r)!==d.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(n.basename(t)),t=n.dirname(t)}for(let r=i.length-1;r>=0;r--){t=n.joinPath(t,i[r]);try{await o.mkdir(t)}catch(l){if((0,d.$Ek)(l)!==d.FileSystemProviderErrorCode.FileExists)throw l}}}async canDelete(o,t){try{await this.W(o,t)}catch(i){return i}return!0}async W(o,t){const i=this.qb(await this.j(o),o),n=!!t?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,v.localize)(20,null,this.sb(o)));const r=t?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,v.localize)(21,null,this.sb(o)));if(n&&r)throw new Error((0,v.localize)(22,null,this.sb(o)));let l;try{l=await i.stat(o)}catch{}if(l)this.rb(o,l);else throw new d.$Jk((0,v.localize)(23,null,this.sb(o)),1);if(!!!t?.recursive){const k=await this.resolve(o);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,v.localize)(24,null,this.sb(o)))}return i}async del(o,t){const i=await this.W(o,t);let n=t;if((0,d.$yk)(i)&&!n?.atomic){const k=i.enforceAtomicDelete?.(o);k&&(n={...t,atomic:k})}const r=!!n?.useTrash,l=!!n?.recursive,S=n?.atomic??!1;await i.delete(o,{recursive:l,useTrash:r,atomic:S}),this.r.fire(new d.$Gk(o,1))}async cloneFile(o,t){const i=await this.j(o),n=this.qb(await this.n(t),t);if(i===n&&this.R(i).providerExtUri.isEqual(o,t))return;if(i===n&&(0,d.$tk)(i))return i.cloneFile(o,t);await this.U(n,this.R(n).providerExtUri.dirname(t));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===n&&(0,d.$sk)(i)?r.queue(()=>i.copy(o,t,{overwrite:!0})):r.queue(()=>this.O(i,o,n,t))}static{this.ab=0}createWatcher(o,t){return this.watch(o,{...t,correlationId:m.ab++})}watch(o,t={recursive:!1,excludes:[]}){const i=new c.$Sc;let n=!1,r=()=>{n=!0};i.add((0,c.$Rc)(()=>r())),(async()=>{try{const S=await this.bb(o,t);n?(0,c.$Oc)(S):r=()=>(0,c.$Oc)(S)}catch(S){this.b.error(S)}})();const l=t.correlationId;if(typeof l=="number"){const S=i.add(new A.$Td);return i.add(this.X.event(w=>{w.correlates(l)&&S.fire(w)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(o,t){const i=await this.j(o),n=(0,b.$Ri)([this.R(i).providerExtUri.getComparisonKey(o),t]);let r=this.$.get(n);return r||(r={count:0,disposable:i.watch(o,t)},this.$.set(n,r)),r.count+=1,(0,c.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,c.$Oc)(r.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,c.$Oc)(o.disposable);this.$.clear()}async db(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,E.$6d)(n)||(0,E.$7d)(n)?await this.eb(o,r,n):await this.fb(o,r,n)}catch(l){throw(0,d.$Ck)(l)}finally{await o.close(r)}})}async eb(o,t,i){let n=0,r;if((0,E.$7d)(i)){if(i.buffer.length>0){const l=j.$he.concat(i.buffer);await this.gb(o,t,l,l.byteLength,n,0),n+=l.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((l,S)=>{(0,E.$_d)(r,{onData:async k=>{r.pause();try{await this.gb(o,t,k,k.byteLength,n,0)}catch(w){return S(w)}n+=k.byteLength,setTimeout(()=>r.resume())},onError:k=>S(k),onEnd:()=>l()})})}async fb(o,t,i){let n=0,r;for(;(r=i.read())!==null;)await this.gb(o,t,r,r.byteLength,n,0),n+=r.byteLength}async gb(o,t,i,n,r,l){let S=0;for(;S<n;){const k=await o.write(t,r+S,i.buffer,l+S,n-S);S+=k}}async hb(o,t,i,n){return this.cb.queueFor(t,this.R(o).providerExtUri).queue(()=>this.ib(o,t,i,n))}async ib(o,t,i,n){let r;n instanceof j.$he?r=n:(0,E.$6d)(n)?r=await(0,j.$te)(n):(0,E.$7d)(n)?r=await(0,j.$ue)(n):r=(0,j.$re)(n),await o.writeFile(t,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.kb(o,t,i,n))}async kb(o,t,i,n){let r,l;try{r=await o.open(t,{create:!1}),l=await i.open(n,{create:!0,unlock:!1});const S=j.$he.alloc(this.a);let k=0,w=0,R=0;do R=await o.read(r,k,S.buffer,w,S.byteLength-w),await this.gb(i,l,S,R,k,w),k+=R,w+=R,w===S.byteLength&&(w=0);while(R>0)}catch(S){throw(0,d.$Ck)(S)}finally{await D.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof l=="number"?i.close(l):Promise.resolve()])}}async lb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.mb(o,t,i,n))}async mb(o,t,i,n){return i.writeFile(n,await o.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,t,i,n){return this.cb.queueFor(n,this.R(i).providerExtUri).queue(()=>this.ob(o,t,i,n))}async ob(o,t,i,n){const r=await i.open(n,{create:!0,unlock:!1});try{const l=await o.readFile(t);await this.gb(i,r,j.$he.wrap(l),l.byteLength,0,0)}catch(l){throw(0,d.$Ck)(l)}finally{await i.close(r)}}async pb(o,t,i,n){const r=await(0,j.$te)(this.H(o,t,N.CancellationToken.None));await this.hb(i,n,void 0,r)}qb(o,t){if(o.capabilities&2048)throw new d.$Jk((0,v.localize)(25,null,this.sb(t)),6);return o}rb(o,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.$Jk((0,v.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===O.Schemas.file?o.fsPath:o.toString(!0)}};e.$4p=y,e.$4p=y=m=pe([ie(0,p.$lj)],y)}),define(te[126],ne([0,1,88,169,8,31,14,4,170,2,16,13,17,45,24,102,12,61,123,34,121,120]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(o){console.error(`Error enabling graceful-fs: ${(0,I.$Oi)(o)}`)}})();class s extends p.$aq{static{this.I=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=b.Event.None,this.N=new N.$Ac(n=>g.$wg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,O.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:i,symbolicLink:n}=await E.SymlinkSupport.stat(this.H(t));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await E.Promises.readdir(this.H(t),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async r=>{try{let l;r.isSymbolicLink()?l=(await this.stat((0,g.$Fg)(t,r.name))).type:l=this.M(r),n.push([r.name,l])}catch(l){this.a.trace(l)}})),n}catch(i){throw this.fb(i)}}M(t,i){let n;return i?.dangling?n=d.FileType.Unknown:t.isFile()?n=d.FileType.File:t.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async O(t){const i=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const r=new j.$3g;return this.N.set(t,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(t)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(t,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),n=await this.O(t));const r=this.H(t);return await E.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{n?.dispose()}}P(t){s.I&&this.a.trace(t)}readFileStream(t,i,n){const r=(0,f.$8d)(l=>A.$he.concat(l.map(S=>A.$he.wrap(S))).buffer);return(0,u.$3p)(this,t,r,l=>l.buffer,{...i,bufferSize:256*1024},n),r}async writeFile(t,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,g.$Fg)((0,g.$Eg)(t),`${(0,g.$Cg)(t)}${n.atomic.postfix}`),i,n):this.S(t,i,n)}async Q(t){try{const i=this.H(t),{symbolicLink:n}=await E.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(t,i,n,r){const l=new c.$Sc;try{l.add(await this.O(t)),l.add(await this.O(i)),await this.S(i,n,r,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{l.dispose()}}async S(t,i,n,r){let l;try{const S=this.H(t);if(!n.create||!n.overwrite){if(await E.Promises.exists(S)){if(!n.overwrite)throw(0,d.$Bk)((0,v.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$Bk)((0,v.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:n.unlock},r),await this.write(l,0,i,0,i.byteLength)}catch(S){throw await this.gb(t,S)}finally{typeof l=="number"&&await this.close(l)}}static{this.Y=!0}static configureFlushOnWrite(t){s.Y=t}async open(t,i,n){const r=this.H(t);let l;(0,d.$pk)(i)&&!n&&(l=await this.O(t));let S;try{if((0,d.$pk)(i)&&i.unlock)try{const{stat:w}=await E.SymlinkSupport.stat(r);w.mode&128||await E.Promises.chmod(r,w.mode|128)}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}let k;if((0,d.$pk)(i)){if(O.$i)try{await E.Promises.truncate(r,0),k="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}k||(k="w")}else k="r";S=await E.Promises.open(r,k)}catch(k){throw l?.dispose(),(0,d.$pk)(i)?await this.gb(t,k):this.fb(k)}if(this.U.set(S,0),(0,d.$pk)(i)&&this.X.set(S,t),l){const k=this.W.get(S);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${r})`),this.W.set(S,l),k&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${r})`),k.dispose())}return S}async close(t){const i=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&s.Y)try{await E.Promises.fdatasync(t)}catch(n){s.configureFlushOnWrite(!1),this.a.error(n)}return await E.Promises.close(t)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(t)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,n,r,l){const S=this.Z(t,i);let k=null;try{k=(await E.Promises.read(t,n,r,l,S)).bytesRead}catch(w){throw this.fb(w)}finally{this.$(t,S,k)}return k}Z(t,i){return i===this.U.get(t)?null:i}$(t,i,n){const r=this.U.get(t);typeof r=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(t,r+n):this.U.delete(t)))}async write(t,i,n,r,l){return(0,j.$lh)(()=>this.ab(t,i,n,r,l),100,3)}async ab(t,i,n,r,l){const S=this.Z(t,i);let k=null;try{k=(await E.Promises.write(t,n,r,l,S)).bytesWritten}catch(w){throw await this.gb(this.X.get(t),w)}finally{this.$(t,S,k)}return k}async mkdir(t){try{await E.Promises.mkdir(this.H(t))}catch(i){throw this.fb(i)}}async delete(t,i){try{const n=this.H(t);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,P.$jc)((0,P.$mc)(n),`${(0,P.$nc)(n)}${i.atomic.postfix}`)),await E.Promises.rm(n,E.RimRafMode.MOVE,r)}else try{await E.Promises.unlink(n)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let l=!1;try{const{stat:S,symbolicLink:k}=await E.SymlinkSupport.stat(n);l=S.isDirectory()&&!k}catch{}if(l)await E.Promises.rmdir(n);else throw r}else throw r}}catch(n){throw this.fb(n)}}async rename(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"move",n.overwrite),await E.Promises.rename(r,l)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(2,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(l)),S.toString()))),this.fb(S)}}async copy(t,i,n){const r=this.H(t),l=this.H(i);if(r!==l)try{await this.bb(t,i,"copy",n.overwrite),await E.Promises.copy(r,l,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,v.localize)(3,null,(0,P.$nc)(r),(0,P.$nc)((0,P.$mc)(l)),S.toString()))),this.fb(S)}}async bb(t,i,n,r){const l=this.H(t),S=this.H(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,h.$5f)(l,S,!0)),k){if(n==="copy")throw(0,d.$Bk)((0,v.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const R=await this.L(t);if(!R)throw(0,d.$Bk)((0,v.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(i);if(H){if(!r)throw(0,d.$Bk)((0,v.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);R.type&d.FileType.File&&H.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.cb(t,i,!1)}async cb(t,i,n){const r=this.H(t),l=this.H(i),S=!!(this.capabilities&1024);if((0,h.$5f)(r,l,!S))return;const k=new c.$Sc;try{k.add(await this.O(t)),k.add(await this.O(i)),n&&await E.Promises.mkdir((0,P.$mc)(l),{recursive:!0}),await E.Promises.copyFile(r,l)}catch(w){if(w.code==="ENOENT"&&!n)return this.cb(t,i,!0);throw this.fb(w)}finally{k.dispose()}}t(t,i,n){return new m.$hq(r=>t(r),r=>i(r),n)}F(t,i,n){return new y.$pq(r=>t(r),r=>i(r),n)}fb(t){if(t instanceof d.$Ak)return t;let i=t,n;switch(t.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$Bk)(i,n)}async gb(t,i){let n=this.fb(i);if(t&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await E.SymlinkSupport.stat(this.H(t));r.mode&128||(n=(0,d.$Bk)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return n}}e.$qq=s}),define(te[127],ne([0,1,2,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=void 0;class j extends L.$Tc{constructor(A,b=[]){super(),this.a=new D.$vj([A,...b]),this.B(A.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...b){this.a.trace(A,...b)}debug(A,...b){this.a.debug(A,...b)}info(A,...b){this.a.info(A,...b)}warn(A,...b){this.a.warn(A,...b)}error(A,...b){this.a.error(A,...b)}flush(){this.a.flush()}}e.$kO=j}),define(te[128],ne([0,1,12,6]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_N=void 0;var j;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(j||(j={}));async function N(c,P,O,g,f){try{const E=await new Promise((d,u)=>{G(["@vscode/spdlog"],d,u)});E.setFlushOn(j.Trace);const v=await E.createAsyncRotatingLogger(c,P,O,g);return f?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(E){console.error(E)}return null}function A(c,P,O){switch(P){case D.LogLevel.Trace:c.trace(O);break;case D.LogLevel.Debug:c.debug(O);break;case D.LogLevel.Info:c.info(O);break;case D.LogLevel.Warning:c.warn(O);break;case D.LogLevel.Error:c.error(O);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function b(c,P){switch(P){case D.LogLevel.Trace:c.setLevel(j.Trace);break;case D.LogLevel.Debug:c.setLevel(j.Debug);break;case D.LogLevel.Info:c.setLevel(j.Info);break;case D.LogLevel.Warning:c.setLevel(j.Warning);break;case D.LogLevel.Error:c.setLevel(j.Error);break;case D.LogLevel.Off:c.setLevel(j.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends D.$rj{constructor(P,O,g,f,E){super(),this.m=[],this.setLevel(E),this.n=this.s(P,O,g,f),this.B(this.onDidChangeLogLevel(v=>{this.r&&b(this.r,v)}))}async s(P,O,g,f){const E=g?6:1,v=30/E*L.$Wk.MB,d=await N(P,O,v,E,f);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:u,message:p}of this.m)A(this.r,u,p);this.m=[]}}g(P,O){this.r?A(this.r,P,O):this.getLevel()<=P&&this.m.push({level:P,message:O})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$_N=h}),define(te[129],ne([0,1,28,6,128]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aO=void 0;class N extends D.$wj{s(b,h,c){return new j.$_N((0,L.$og)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$aO=N}),define(te[38],ne([0,1,4,65,2,10]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0,e.$yn=(0,N.$4h)("policy");class A extends j.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Td),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const P=Object.keys(this.f).length;return this.f={...c,...this.f},P!==Object.keys(this.f).length&&await this.j(c),D.Iterable.reduce(this.g.entries(),(O,[g,f])=>({...O,[g]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(c,[P,O])=>({...c,[P]:{definition:O,value:this.g.get(P)}}),{})}}e.$zn=A;class b{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$An=b}),define(te[130],ne([0,1,8,4,65,3,12,6,38]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;function c(O,g){const f=[];for(const E of new Set(j.Iterable.concat(O.keys(),g.keys())))O.get(E)!==g.get(E)&&f.push(E);return f}let P=class extends h.$zn{constructor(g,f,E){super(),this.m=g,this.n=f,this.s=E,this.c=this.B(new L.$2g(500));const v=D.Event.filter(f.onDidFilesChange,d=>d.affects(g));this.B(f.watch(g)),this.B(v(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const g=new Map;try{const f=await this.n.readFile(this.m),E=JSON.parse(f.value.toString());if(!(0,N.$If)(E))throw new Error("Policy file isn't a JSON object");for(const v of Object.keys(E))this.f[v]&&g.set(v,E[v])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return g}async w(){const g=await this.u(),f=c(this.g,g);this.g=g,f.length>0&&this.h.fire(f)}};e.$H$b=P,e.$H$b=P=pe([ie(1,A.$ok),ie(2,b.$lj)],P)}),define(te[131],ne([0,1,38,8,2,6]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=void 0;let A=class extends L.$zn{constructor(h,c){super(),this.m=h,this.n=c,this.a=new D.$Xg,this.b=this.B(new j.$Uc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:c}=await new Promise((P,O)=>{G(["@vscode/policy-watcher"],P,O)});await this.a.queue(()=>new Promise((P,O)=>{try{this.b.value=c(this.n,h,g=>{this.t(g),P()})}catch(g){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",g),O(g)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const c in h){const P=h[c];P===void 0?this.g.delete(c):this.g.set(c,P)}this.h.fire(Object.keys(h))}};e.$G$b=A,e.$G$b=A=pe([ie(0,N.$lj)],A)}),define(te[32],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=void 0,e.$Dj=(0,L.$4h)("productService"),e.$Ej="vscode://schemas/vscode-product"}),define(te[36],ne([0,1,71,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0;class j{constructor(){this.a=new Map}add(A,b){L.ok(D.$Gf(A)),L.ok(D.$If(b)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,b)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$wn=new j}),define(te[132],ne([0,1,4,36]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0,e.$xn={JSONContribution:"base.contributions.json"};function j(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class N{constructor(){this.b=new L.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[j(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$wn.add(e.$xn.JSONContribution,A)}),define(te[43],ne([0,1,19,4,3,89,25,132,36]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.ConfigurationScope=e.$Bn=e.EditPresentationTypes=void 0;var c;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$Bn={Configuration:"base.contributions.configuration"};var P;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn={properties:{},patternProperties:{}},e.$In="vscode://schemas/settings/resourceLanguage",e.$Jn="vscode://schemas/settings/configurationDefaults";const O=h.$wn.as(b.$xn.JSONContribution);class g{constructor(){this.h=new Set,this.i=new D.$Td,this.onDidSchemaChange=this.i.event,this.j=new D.$Td,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},O.registerSchema(e.$In,this.g),this.v()}registerConfiguration(s,o=!0){this.registerConfigurations([s],o)}registerConfigurations(s,o=!0){const t=new Set;this.n(s,o,t),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(s){const o=new Set;this.o(s,o),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:s,remove:o}){const t=new Set;this.o(o,t),this.n(s,!1,t),O.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(s){const o=new Set;this.k(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(s,o){const t=[];for(const{overrides:i,source:n}of s)for(const r in i)if(o.add(r),e.$Ln.test(r)){const l=this.a.get(r),S=l?.valuesSources??new Map;if(n)for(const H of Object.keys(i[r]))S.set(H,n);const k={...l?.value||{},...i[r]};this.a.set(r,{source:n,value:k,valuesSources:S});const w=(0,A.$Hi)(r),R={type:"object",default:k,description:N.localize(1,null,w),$ref:e.$In,defaultDefaultValue:k,source:j.$Gf(n)?void 0:n,defaultValueSource:n};t.push(...v(r)),this.d[r]=R,this.b.properties[r]=R}else{this.a.set(r,{value:i[r],source:n});const l=this.d[r];l&&(this.w(r,l),this.r(r,l))}this.m(t)}deregisterDefaultConfigurations(s){const o=new Set;this.l(s,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(s,o){for(const{overrides:t,source:i}of s)for(const n in t){const r=this.a.get(n),l=j.$Gf(i)?i:i?.id,S=j.$Gf(r?.source)?r?.source:r?.source?.id;if(l===S)if(o.add(n),this.a.delete(n),e.$Ln.test(n))delete this.d[n],delete this.b.properties[n];else{const k=this.d[n];k&&(this.w(n,k),this.r(n,k))}}this.u()}deltaConfiguration(s){let o=!1;const t=new Set;s.removedDefaults&&(this.l(s.removedDefaults,t),o=!0),s.addedDefaults&&(this.k(s.addedDefaults,t),o=!0),s.removedConfigurations&&this.o(s.removedConfigurations,t),s.addedConfigurations&&this.n(s.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...s){this.i.fire()}registerOverrideIdentifiers(s){this.m(s),this.i.fire()}m(s){for(const o of s)this.h.add(o);this.u()}n(s,o,t){s.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(s,o){const t=i=>{if(i.properties)for(const n in i.properties){o.add(n);const r=this.d[n];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>t(n))};for(const i of s){t(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(s,o=!0,t,i,n=3,r){n=j.$Pf(s.scope)?n:s.scope;const l=s.properties;if(l)for(const k in l){const w=l[k];if(o&&I(k,w)){delete l[k];continue}if(w.source=t,w.defaultDefaultValue=l[k].default,this.w(k,w),e.$Ln.test(k)?w.scope=void 0:(w.scope=j.$Pf(w.scope)?n:w.scope,w.restricted=j.$Pf(w.restricted)?!!i?.includes(k):w.restricted),l[k].hasOwnProperty("included")&&!l[k].included){this.f[k]=l[k],delete l[k];continue}else this.d[k]=l[k],l[k].policy?.name&&this.e.set(l[k].policy.name,k);!l[k].deprecationMessage&&l[k].markdownDeprecationMessage&&(l[k].deprecationMessage=l[k].markdownDeprecationMessage),r.add(k)}const S=s.allOf;if(S)for(const k of S)this.p(k,o,t,i,n,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(s){const o=t=>{const i=t.properties;if(i)for(const r in i)this.r(r,i[r]);t.allOf?.forEach(o)};o(s)}r(s,o){switch(e.$Cn.properties[s]=o,o.scope){case 1:e.$Dn.properties[s]=o;break;case 2:e.$En.properties[s]=o;break;case 6:e.$Fn.properties[s]=o;break;case 3:e.$Gn.properties[s]=o;break;case 4:e.$Hn.properties[s]=o;break;case 5:e.$Hn.properties[s]=o,this.g.properties[s]=o;break}}s(s,o){switch(delete e.$Cn.properties[s],o.scope){case 1:delete e.$Dn.properties[s];break;case 2:delete e.$En.properties[s];break;case 6:delete e.$Fn.properties[s];break;case 3:delete e.$Gn.properties[s];break;case 4:case 5:delete e.$Hn.properties[s],delete this.g.properties[s];break}}u(){for(const s of this.h.values()){const o=`[${s}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$In};this.w(o,t),e.$Cn.properties[o]=t,e.$Dn.properties[o]=t,e.$En.properties[o]=t,e.$Fn.properties[o]=t,e.$Gn.properties[o]=t,e.$Hn.properties[o]=t}}v(){const s={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$In};e.$Cn.patternProperties[e.$Kn]=s,e.$Dn.patternProperties[e.$Kn]=s,e.$En.patternProperties[e.$Kn]=s,e.$Fn.patternProperties[e.$Kn]=s,e.$Gn.patternProperties[e.$Kn]=s,e.$Hn.patternProperties[e.$Kn]=s,this.i.fire()}w(s,o){const t=this.a.get(s);let i=t?.value,n=t?.source;j.$Nf(i)&&(i=o.defaultDefaultValue,n=void 0),j.$Nf(i)&&(i=u(o.type)),o.default=i,o.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",E=new RegExp(f,"g");e.$Kn=`^(${f})+$`,e.$Ln=new RegExp(e.$Kn);function v(y){const s=[];if(e.$Ln.test(y)){let o=E.exec(y);for(;o?.length;){const t=o[1].trim();t&&s.push(t),o=E.exec(y)}}return(0,L.$Mb)(s)}e.$Mn=v;function d(y){return y.reduce((s,o)=>`${s}[${o}]`,"")}e.$Nn=d;function u(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$On=u;const p=new g;h.$wn.add(e.$Bn.Configuration,p);function I(y,s){return y.trim()?e.$Ln.test(y)?N.localize(7,null,y):p.getConfigurationProperties()[y]!==void 0?N.localize(8,null,y):s.policy?.name&&p.getPolicyConfigurations().get(s.policy?.name)!==void 0?N.localize(9,null,y,s.policy?.name,p.getPolicyConfigurations().get(s.policy?.name)):null:N.localize(6,null)}e.$Pn=I;function m(){const y=[],s=p.getConfigurationProperties();for(const o of Object.keys(s))y.push([o,s[o].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.$Qn=m}),define(te[66],ne([0,1,19,4,53,2,31,30,3,11,25,43,36]),function(G,e,L,D,j,N,A,b,h,c,P,O,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=void 0;function f(o){return Object.isFrozen(o)?o:b.$ln(o)}class E{constructor(t={},i=[],n=[],r){this.b=t,this.c=i,this.d=n,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof E)return i;const n=new v("");return n.parseRaw(i),n.configurationModel});this.f=t.reduce((i,n)=>n===i?n:i.merge(n),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,P.$Fi)(this.contents,t):this.contents}inspect(t,i){const n=this.rawConfiguration.getValue(t),r=i?this.rawConfiguration.getOverrideValue(t,i):void 0,l=i?this.rawConfiguration.override(i).getValue(t):n;return{value:n,override:r,merged:l}}getOverrideValue(t,i){const n=this.i(i);return n?t?(0,P.$Fi)(n,t):n:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const n of this.overrides)n.identifiers.includes(t)&&i.push(...n.keys);return L.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return L.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=b.$kn(this.contents),n=b.$kn(this.overrides),r=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const S of t)if(l.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.h(i,S.contents);for(const k of S.overrides){const[w]=n.filter(R=>L.$ub(R.identifiers,k.identifiers));w?(this.h(w.contents,k.contents),w.keys.push(...k.keys),w.keys=L.$Mb(w.keys)):n.push(b.$kn(k))}for(const k of S.keys)r.indexOf(k)===-1&&r.push(k)}return new E(i,r,n,l.every(S=>S instanceof E)?void 0:l)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const r of L.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r];const S=i[r];S&&(typeof l=="object"&&typeof S=="object"?(l=b.$kn(l),this.h(l,S)):l=S),n[r]=l}return new E(n,this.keys,this.overrides)}h(t,i){for(const n of Object.keys(i)){if(n in t&&h.$If(t[n])&&h.$If(i[n])){this.h(t[n],i[n]);continue}t[n]=b.$kn(i[n])}}i(t){let i=null,n=null;const r=l=>{l&&(n?this.h(n,l):n=b.$kn(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===t?i=l.contents:l.identifiers.includes(t)&&r(l.contents);return r(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,P.$Ei)(this.contents,t),O.$Ln.test(t)&&this.overrides.splice(this.overrides.findIndex(n=>L.$ub(n.identifiers,(0,O.$Mn)(t))),1))}j(t,i,n){(0,P.$Di)(this.contents,t,i,r=>console.error(r)),n=n||this.keys.indexOf(t)===-1,n&&this.keys.push(t),O.$Ln.test(t)&&this.overrides.push({identifiers:(0,O.$Mn)(t),keys:Object.keys(this.contents[t]),contents:(0,P.$Ci)(this.contents[t],r=>console.error(r))})}}e.$Rn=E;class v{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new E}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!h.$Pf(t)){const n=this.g(t);this.parseRaw(n,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:n,keys:r,overrides:l,restricted:S,hasExcludedProperties:k}=this.h(t,i);this.b=new E(n,r,l,k?[t]:void 0),this.c=S||[]}g(t){let i={},n=null,r=[];const l=[],S=[];function k(R){Array.isArray(r)?r.push(R):n!==null&&(r[n]=R)}const w={onObjectBegin:()=>{const R={};k(R),l.push(r),r=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{const R=[];k(R),l.push(r),r=R,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:k,onError:(R,H,ee)=>{S.push({error:R,offset:H,length:ee})}};if(t)try{j.$hn(t,w),i=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this.f}: ${R}`),this.d=[R]}return i}h(t,i){const n=g.$wn.as(O.$Bn.Configuration).getConfigurationProperties(),r=this.i(t,n,!0,i);t=r.raw;const l=(0,P.$Ci)(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`)),S=Object.keys(t),k=this.j(t,w=>console.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:l,keys:S,overrides:k,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(t,i,n,r){let l=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:l};const S={},k=[];for(const w in t)if(O.$Ln.test(w)&&n){const R=this.i(t[w],i,!1,r);S[w]=R.raw,l=l||R.hasExcludedProperties,k.push(...R.restricted)}else{const R=i[w],H=R?typeof R.scope<"u"?R.scope:3:void 0;R?.restricted&&k.push(w),!r.exclude?.includes(w)&&(r.include?.includes(w)||(H===void 0||r.scopes===void 0||r.scopes.includes(H))&&!(r.skipRestricted&&R?.restricted))?S[w]=t[w]:l=!0}return{raw:S,restricted:k,hasExcludedProperties:l}}j(t,i){const n=[];for(const r of Object.keys(t))if(O.$Ln.test(r)){const l={};for(const S in t[r])l[S]=t[r][S];n.push({identifiers:(0,O.$Mn)(r),keys:Object.keys(l),contents:(0,P.$Ci)(l,i)})}return n}}e.$Sn=v;class d extends N.$Tc{constructor(t,i,n,r){super(),this.c=t,this.f=i,this.g=r,this.b=this.B(new D.$Td),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new E}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Tn=d;class u{constructor(t,i,n,r,l,S,k,w,R,H,ee,_,re){this.a=t,this.b=i,this.c=n,this.overrideIdentifiers=r,this.d=l,this.f=S,this.g=k,this.h=w,this.i=R,this.j=H,this.k=ee,this.l=_,this.m=re}get value(){return f(this.c)}n(t,i,n){const r=t.inspect(i,n);return{get value(){return f(r.value)},get override(){return f(r.override)},get merged(){return f(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(t,i,n,r,l=new E,S=new E,k=new A.$Ac,w=new E,R=new A.$Ac){this.c=t,this.d=i,this.f=n,this.g=r,this.h=l,this.i=S,this.j=k,this.l=w,this.m=R,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,i,n){return this.p(t,i,n).getValue(t)}updateValue(t,i,n={}){let r;n.resource?(r=this.m.get(n.resource),r||(r=new E,this.m.set(n.resource,r))):r=this.l,i===void 0?r.removeValue(t):r.setValue(t,i),n.resource||(this.a=null)}inspect(t,i,n){const r=this.p(t,i,n),l=this.t(i.resource,n),S=i.resource?this.m.get(i.resource)||this.l:this.l,k=new Set;for(const w of r.overrides)for(const R of w.identifiers)r.getOverrideValue(t,R)!==void 0&&k.add(R);return new u(t,i,r.getValue(t),k.size?[...k]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,S)}keys(t){const i=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=[];if(!i){const{added:r,updated:l,removed:S}=y(this.c,t);i=[...r,...l,...S]}for(const r of i)for(const l of(0,O.$Mn)(r)){const S=this.c.getKeysForOverrideIdentifier(l),k=t.getKeysForOverrideIdentifier(l),w=[...k.filter(R=>S.indexOf(R)===-1),...S.filter(R=>k.indexOf(R)===-1),...S.filter(R=>!b.$on(this.c.override(l).getValue(R),t.override(l).getValue(R)))];n.push([l,w])}return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:n,removed:r}=y(this.d,t),l=[...i,...n,...r];return l.length&&this.updatePolicyConfiguration(t),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.applicationConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:l}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.localUserConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:l}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.remoteUserConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:l}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:r,overrides:l}=y(this.workspaceConfiguration,t),S=[...i,...n,...r];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:l}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:r,updated:l,removed:S,overrides:k}=y(n,i),w=[...r,...l,...S];return(w.length||!n)&&this.updateFolderConfiguration(t,i),{keys:w,overrides:k}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:r,removed:l,overrides:S}=y(i,void 0);return{keys:[...n,...r,...l],overrides:S}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,i,n){let r=this.q(i,n);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(r=r.merge(this.d)),r}q({resource:t},i){let n=this.r();if(i&&t){const r=i.getFolder(t);r&&(n=this.s(r.uri)||n);const l=this.m.get(t);l&&(n=n.merge(l))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let i=this.b.get(t);if(!i){const n=this.r(),r=this.j.get(t);r?(i=n.merge(r),this.b.set(t,i)):i=n}return i}t(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:n,overrides:r,keys:l}=this.j.get(i);return t.push([i,{contents:n,overrides:r,keys:l}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(n=>t.add(n))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>t.add(n))),[...t.values()]}v(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r))),[...i.values()]}static parse(t){const i=this.w(t.defaults),n=this.w(t.policy),r=this.w(t.application),l=this.w(t.user),S=this.w(t.workspace),k=t.folders.reduce((w,R)=>(w.set(c.URI.revive(R[0]),this.w(R[1])),w),new A.$Ac);return new p(i,n,r,l,new E,S,k,new E,new A.$Ac)}static w(t){return new E(t.contents,t.keys,t.overrides)}}e.$Un=p;function I(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const t=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>t.add(l)),r.overrides.forEach(([l,S])=>{const k=(0,A.$xc)(i,l,new Set);S.forEach(w=>k.add(w))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...t.values()],overrides:n}}e.$Vn=I;class m{constructor(t,i,n,r){this.change=t,this.f=i,this.g=n,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of t.keys)this.affectedKeys.add(l);for(const[,l]of t.overrides)for(const S of l)this.affectedKeys.add(S);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(t,i){const n=this.a+t,r=this.d.indexOf(n);if(r<0)return!1;const l=r+n.length;if(l>=this.d.length)return!1;const S=this.d.charCodeAt(l);if(S!==this.b&&S!==this.c)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,w=this.g.getValue(t,i,this.h);return!b.$on(k,w)}return!0}}e.$Wn=m;function y(o,t){const{added:i,removed:n,updated:r}=s(t?.rawConfiguration,o?.rawConfiguration),l=[],S=o?.getAllOverrideIdentifiers()||[],k=t?.getAllOverrideIdentifiers()||[];if(t){const w=k.filter(R=>!S.includes(R));for(const R of w)l.push([R,t.getKeysForOverrideIdentifier(R)])}if(o){const w=S.filter(R=>!k.includes(R));for(const R of w)l.push([R,o.getKeysForOverrideIdentifier(R)])}if(t&&o){for(const w of S)if(k.includes(w)){const R=s({contents:o.getOverrideValue(void 0,w)||{},keys:o.getKeysForOverrideIdentifier(w)},{contents:t.getOverrideValue(void 0,w)||{},keys:t.getKeysForOverrideIdentifier(w)});l.push([w,[...R.added,...R.removed,...R.updated]])}}return{added:i,removed:n,updated:r,overrides:l}}function s(o,t){const i=o?t?o.keys.filter(l=>t.keys.indexOf(l)===-1):[...o.keys]:[],n=t?o?t.keys.filter(l=>o.keys.indexOf(l)===-1):[...t.keys]:[],r=[];if(o&&t){for(const l of t.keys)if(o.keys.indexOf(l)!==-1){const S=(0,P.$Fi)(t.contents,l),k=(0,P.$Fi)(o.contents,l);b.$on(S,k)||r.push(l)}}return{added:i,removed:n,updated:r}}}),define(te[133],ne([0,1,19,4,2,30,3,66,43,6,38,36]),function(G,e,L,D,j,N,A,b,h,c,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=e.$Yn=e.$Xn=void 0;class g extends j.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(O.$wn.as(h.$Bn.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:u})=>this.c(Array.from(d),u))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,u){this.h(d,O.$wn.as(h.$Bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new b.$Rn;const d=O.$wn.as(h.$Bn.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,u){const p=this.f();for(const I of d){const m=p[I],y=u[I];m!==void 0?this.b.addValue(I,m):y?this.b.addValue(I,y.default):this.b.removeValue(I)}}}e.$Xn=g;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new b.$Rn}async initialize(){return this.configurationModel}}e.$Yn=f;let E=class extends j.$Tc{get configurationModel(){return this.b}constructor(d,u,p){super(),this.c=d,this.f=u,this.g=p,this.a=this.B(new D.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new b.$Rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const u={},p=[],I=O.$wn.as(h.$Bn.Configuration).getConfigurationProperties();for(const m of d){const y=I[m];if(!y){p.push(m);continue}if(y.policy){if(y.type!=="string"&&y.type!=="number"){this.g.warn(`Policy ${y.policy.name} has unsupported type ${y.type}`);continue}p.push(m),u[y.policy.name]={type:y.type}}}return(0,A.$Tf)(u)||await this.f.updatePolicyDefinitions(u),p}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const u=O.$wn.as(h.$Bn.Configuration).getPolicyConfigurations(),p=(0,L.$Hb)(d.map(I=>u.get(I)));this.m(p,!0)}m(d,u){this.g.trace("PolicyConfiguration#update",d);const p=O.$wn.as(h.$Bn.Configuration).getConfigurationProperties(),I=[],m=this.b.isEmpty();for(const y of d){const s=p[y]?.policy?.name;if(s){const o=this.f.getPolicyValue(s);(m?o!==void 0:!(0,N.$on)(this.b.getValue(y),o))&&I.push([y,o])}else this.b.getValue(y)!==void 0&&I.push([y,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const y=this.b;this.b=new b.$Rn;for(const s of y.keys)this.b.setValue(s,y.getValue(s));for(const[s,o]of I)o===void 0?this.b.removeValue(s):this.b.setValue(s,o);u&&this.a.fire(this.b)}}};e.$Zn=E,e.$Zn=E=pe([ie(1,P.$yn),ie(2,c.$lj)],E)}),define(te[134],ne([0,1,8,4,2,17,25,66,133,38]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class P extends j.$Tc{constructor(g,f,E,v){super(),this.j=g,this.h=this.B(new D.$Td),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$Xn),this.c=E instanceof c.$An?new h.$Yn:this.B(new h.$Zn(this.b,E,v)),this.f=this.B(new b.$Tn(this.j,{},N.$wg,f)),this.a=new b.$Un(this.b.configurationModel,this.c.configurationModel,new b.$Rn,new b.$Rn),this.g=this.B(new L.$dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:u})=>this.n(d,u))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[g,f,E]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$Un(g,f,new b.$Rn,E)}getConfigurationData(){return this.a.toData()}getValue(g,f){const E=typeof g=="string"?g:void 0,v=(0,A.$yi)(g)?g:(0,A.$yi)(f)?f:{};return this.a.getValue(E,v,void 0)}updateValue(g,f,E,v){return Promise.reject(new Error("not supported"))}inspect(g){return this.a.inspect(g,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const g=await this.f.loadConfiguration();this.m(g)}m(g){const f=this.a.toData(),E=this.a.compareAndUpdateLocalUserConfiguration(g);this.s(E,f,2)}n(g,f){const E=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(g,f);this.s(v,E,7)}r(g){const f=this.a.toData(),E=this.a.compareAndUpdatePolicyConfiguration(g);this.s(E,f,7)}s(g,f,E){const v=new b.$Wn(g,{data:f},this.a);v.source=E,v.sourceConfig=this.t(E),this.h.fire(v)}t(g){switch(g){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$1n=P}),define(te[67],ne([0,1,15]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0;function D(c){return c.scheme===L.Schemas.vscodeRemote?c.authority:void 0}e.$$k=D;function j(c){if(!c)return;const P=c.indexOf("+");return P<0?c:c.substr(0,P)}e.$_k=j;function N(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$al=N;function A(c){const{host:P,port:O}=h(c);if(typeof O>"u")throw new Error(`Invalid remote authority: ${c}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:P,port:O}}e.$bl=A;function b(c,P){let{host:O,port:g}=h(c);return typeof g>"u"&&(g=P),{host:O,port:g}}e.$cl=b;function h(c){const P=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const O=c.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const g=c.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:c,port:void 0}}}),define(te[37],ne([0,1,29,10,67]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.TargetPlatform=e.ExtensionType=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm="extensions.user.cache",e.$em="extensions.builtin.cache",e.$fm="undefined_publisher",e.$gm=["ui","workspace","web"];function N(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$hm=N,e.$im=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var b;(function(v){v.WIN32_X64="win32-x64",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class h{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,u){if(typeof d>"u"||d===null)return typeof u>"u"||u===null;if(typeof u>"u"||u===null)return!1;if(typeof d=="string"||typeof u=="string"){const p=typeof d=="string"?d:d.value,I=typeof u=="string"?u:u.value;return L.$0e(p,I)}return d._lower===u._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$jm=h;class c{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const u of d)this.add(u)}add(d){this.c.add(h.toKey(d))}delete(d){return this.c.delete(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}}e.$km=c;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(h.toKey(d))}get(d){return this.c.get(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}set(d,u){this.c.set(h.toKey(d),u)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$lm=P;function O(v){return g(v)}e.$mm=O;function g(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$nm=g;function f(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$om=f;function E(v,d){if(d){const u=`onResolveRemoteAuthority:${(0,j.$_k)(d)}`;return!!v.activationEvents?.includes(u)}return!1}e.$pm=E,e.$qm=(0,D.$4h)("IBuiltinExtensionsScannerService")}),define(te[135],ne([0,1,2,37,12]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class N extends L.$Tc{constructor(b,h,c,P,O){super(),this.a=b,this.b=h,this.c=c,this.f=O,this.B(P.onDidInstallExtensions(g=>this.g(g))),this.B(P.onDidUninstallExtension(g=>this.h(g)))}g(b){for(const h of b)h.local&&this.invalidate(h.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const h of this.a.profiles)this.c.extUri.isEqual(h.extensionsResource,b)&&await this.j(h);else await this.j(this.a.defaultProfile)}async j(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,D.$dm))}catch(h){(0,j.$Fk)(h)!==1&&this.f.error(h)}}}e.$Wp=N}),define(te[44],ne([0,1,14,9,2,104,43,10,6,36]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$9o=(0,b.$4h)("requestService");class P{constructor(y){this.b=y}toJSON(){if(!this.a){const y=Object.create(null);for(const s in this.b)s.toLowerCase()==="authorization"||s.toLowerCase()==="proxy-authorization"?y[s]="*****":y[s]=this.b[s];this.a=y}return this.a}}class O extends j.$Tc{constructor(y){super(),this.b=0,this.a=y.createLogger("network",{name:(0,N.localize)(0,null),when:h.$Cj.isEqualTo((0,h.$Aj)(h.LogLevel.Trace)).serialize()})}async c(y,s,o){const t=`${y} #${++this.b}: ${s.url}`;this.a.trace(`${t} - begin`,s.type,new P(s.headers??{}));try{const i=await o();return this.a.trace(`${t} - end`,s.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,s.type,(0,D.$0)(i)),i}}}e.$0o=O;function g(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$$o=g;function f(m){return m.res.statusCode===204}e.$_o=f;async function E(m){return f(m)?null:(await(0,L.$te)(m.stream)).toString()}e.$ap=E;async function v(m){if(!g(m))throw new Error("Server returned "+m.res.statusCode);return E(m)}e.$bp=v;async function d(m){if(!g(m))throw new Error("Server returned "+m.res.statusCode);if(f(m))return null;const s=(await(0,L.$te)(m.stream)).toString();try{return JSON.parse(s)}catch(o){throw o.message+=`:
`+s,o}}e.$cp=d;function u(m){I(m)}e.$dp=u;let p;function I(m){const y=c.$wn.as(A.$Bn.Configuration),s=p;p={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},y.updateConfigurations({add:[p],remove:s?[s]:[]})}I(1)}),define(te[136],ne([0,1,20,15,12,44]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;let A=class{constructor(h,c){this.a=h,this.b=c}async download(h,c,P=L.CancellationToken.None){if(h.scheme===D.Schemas.file||h.scheme===D.Schemas.vscodeRemote){await this.b.copy(h,c);return}const O={type:"GET",url:h.toString(!0)},g=await this.a.request(O,P);if(g.res.statusCode===200)await this.b.writeFile(c,g.stream);else{const f=await(0,N.$bp)(g);throw new Error(`Expected 200, got back ${g.res.statusCode} instead.

${f}`)}}};e.$zO=A,e.$zO=A=pe([ie(0,N.$9o),ie(1,j.$ok)],A)}),define(te[137],ne([0,1,138,3]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function j(A,b){return A.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:A.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function N(A,b,h={}){const c=(0,L.parse)(A),P=h.proxyUrl||j(c,b);if(!P)return null;const O=(0,L.parse)(P);if(!/^https?:$/.test(O.protocol||""))return null;const g={host:O.hostname||"",port:(O.port?+O.port:0)||(O.protocol==="https"?443:80),auth:O.auth,rejectUnauthorized:(0,D.$Mf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,E)=>{G(["http-proxy-agent"],f,E)})).HttpProxyAgent(P,g):new(await new Promise((f,E)=>{G(["https-proxy-agent"],f,E)})).HttpsProxyAgent(P,g)}e.$br=N}),define(te[139],ne([0,1,58,16,105,20,34,9,13,28,84,171,8,72]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0l=void 0;let E;async function v(u,p,I,m){return I["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,O.$4l)(m)&&!I["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,O.$4l)(m)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),E||(E=g.Promises.withAsyncBody(async(y,s)=>{const o=new N.$4d;let t=1e4;const i=u.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,f.$5l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),s(new Error((0,j.localize)(0,null)))},t);try{y(await d(p,o.token))}catch(r){!(0,b.$4)(r)&&!o.token.isCancellationRequested?s(new Error((0,j.localize)(1,null,(0,A.$Oi)(r)))):y({})}finally{clearTimeout(n),o.dispose()}})),E)}e.$0l=v;async function d(u,p){const I=process.env.ELECTRON_RUN_AS_NODE;u.trace("getUnixShellEnvironment#runAsNode",I);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;u.trace("getUnixShellEnvironment#noAttach",m);const y=(0,c.$og)().replace(/-/g,"").substr(0,12),s=new RegExp(y+"({.*})"+y),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};u.trace("getUnixShellEnvironment#env",o);const t=await(0,P.$Tl)(h.OS,o);return u.trace("getUnixShellEnvironment#shell",t),new Promise((i,n)=>{if(p.isCancellationRequested)return n(new b.$5);const r=(0,D.$nc)(t);let l,S;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' ${k} -p '''${y}'' + JSON.stringify(process.env) + ''${y}'''`,S=["-Login","-Command"]):r==="nu"?(l=`^'${process.execPath}' ${k} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,S=["-i","-l","-c"]):r==="xonsh"?(l=`import os, json; print("${y}", json.dumps(dict(os.environ)), "${y}")`,S=["-i","-l","-c"]):(l=`'${process.execPath}' ${k} -p '"${y}" + JSON.stringify(process.env) + "${y}"'`,r==="tcsh"||r==="csh"?S=["-ic"]:S=["-i","-l","-c"]),u.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),l);const w=(0,L.spawn)(t,[...S,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(w.kill(),n(new b.$5))),w.on("error",ee=>{u.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Oi)(ee)),n(ee)});const R=[];w.stdout.on("data",ee=>R.push(ee));const H=[];w.stderr.on("data",ee=>H.push(ee)),w.on("close",(ee,_)=>{const re=Buffer.concat(R).toString("utf8");u.trace("getUnixShellEnvironment#raw",re);const se=Buffer.concat(H).toString("utf8");if(se.trim()&&u.trace("getUnixShellEnvironment#stderr",se),ee||_)return n(new Error((0,j.localize)(2,null,ee,_)));const ue=s.exec(re),ce=ue?ue[1]:"{}";try{const oe=JSON.parse(ce);I?oe.ELECTRON_RUN_AS_NODE=I:delete oe.ELECTRON_RUN_AS_NODE,m?oe.ELECTRON_NO_ATTACH_CONSOLE=m:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,u.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){u.error("getUnixShellEnvironment#errorCaught",(0,A.$Oi)(oe)),n(oe)}})})}}),define(te[140],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cO=e.$bO=void 0,e.$bO=(0,L.$4h)("stateReadService"),e.$cO=(0,L.$4h)("stateService")}),define(te[68],ne([0,1,8,14,2,3,18,12,6]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fO=e.$eO=e.$dO=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class P extends j.$Tc{constructor(E,v,d,u){super(),this.h=E,this.j=v,this.m=d,this.n=u,this.a=Object.create(null),this.b="",this.c=this.B(new L.$2g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(E){E.fileOperationResult!==1&&this.m.error(E)}}getItem(E,v){const d=this.a[E];return(0,N.$Pf)(d)?v:d}setItem(E,v){this.setItems([{key:E,data:v}])}setItems(E){let v=!1;for(const{key:d,data:u}of E)this.a[d]!==u&&((0,N.$Pf)(u)?(0,N.$Nf)(this.a[d])||(this.a[d]=void 0,v=!0):(this.a[d]=u,v=!0));v&&this.s()}removeItem(E){(0,N.$Nf)(this.a[E])||(this.a[E]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const E=JSON.stringify(this.a,null,4);if(E!==this.b)try{await this.n.writeFile(this.h,D.$he.fromString(E),{atomic:{postfix:".vsctmp"}}),this.b=E}catch(v){this.m.error(v)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$dO=P;let O=class extends j.$Tc{constructor(E,v,d,u){super(),this.a=this.B(new P(v.stateResource,E,d,u))}async init(){await this.a.init()}getItem(E,v){return this.a.getItem(E,v)}};e.$eO=O,e.$eO=O=pe([ie(1,A.$$h),ie(2,h.$lj),ie(3,b.$ok)],O);class g extends O{setItem(E,v){this.a.setItem(E,v)}setItems(E){this.a.setItems(E)}removeItem(E){this.a.removeItem(E)}close(){return this.a.close()}}e.$fO=g}),define(te[69],ne([0,1,13,35,28]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=void 0;function N(h){if(L.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function A(h,c,P,O,g,f,E,v,d){const u=Object.create(null);u["common.machineId"]=f,u["common.sqmId"]=E,u.sessionID=(0,j.$og)()+Date.now(),u.commitHash=O,u.version=g,u["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,L.$h)(L.$u),u["common.nodePlatform"]=D.$dc,u["common.nodeArch"]=P,u["common.product"]=d||"desktop",v&&(u["common.msftInternal"]=v);let p=0;const I=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-I,enumerable:!0},"common.sequence":{get:()=>p++,enumerable:!0}}),L.$l&&(u["common.snap"]="true");const m=N(c);return m&&(u["common.platformDetail"]=m),u}e.$xo=A;function b(h){const c=D.env.USERDNSDOMAIN;if(!c)return!1;const P=c.toLowerCase();return h.some(O=>P===O)}e.$yo=b}),define(te[26],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=void 0,e.$sl=(0,L.$4h)("telemetryService"),e.$tl=(0,L.$4h)("customEndpointTelemetryService"),e.$ul="telemetry.currentSessionDate",e.$vl="telemetry.firstSessionDate",e.$wl="telemetry.lastSessionDate",e.$xl="telemetry.machineId",e.$yl="telemetry.sqmId",e.$zl="telemetry",e.$Al="telemetry.telemetryLevel",e.$Bl="telemetry.enableCrashReporter",e.$Cl="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var j;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(j||(e.TelemetryConfiguration=j={}))}),define(te[39],ne([0,1,30,3,4,25,67,69,26]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$zo=c;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ao=P,e.$Bo=new P;class O{async publicLog(n,r,l){}async publicLogError(n,r,l){}}e.$Co=O,e.$Do="telemetry",e.$Eo="extensionTelemetryLog",e.$Fo={log:()=>null,flush:()=>Promise.resolve(null)};function g(i,n){return j.Event.debounce(n.onDidChangeConfiguration,(l,S)=>{const k=l?new Set([...l.affectedKeys,...S.affectedKeys]):S.affectedKeys;return{...S,affectedKeys:k}},1e3,!0)(l=>{l.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,N.$Ai)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$Go=g;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry)}e.$Ho=f;function E(i,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Io=E;function v(i){const n=i.getValue(h.$Al),r=i.getValue(h.$Bl);if(i.getValue(h.$Cl)===!1||r===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Jo=v;function d(i){const n={},r={},l={};I(i,l);for(let S in l){S=S.length>150?S.substr(S.length-149):S;const k=l[S];typeof k=="number"?r[S]=k:typeof k=="boolean"?r[S]=k?1:0:typeof k=="string"?(k.length>8192&&console.warn(`Telemetry property: ${S} has been trimmed to 8192, the original length is ${k.length}`),n[S]=k.substring(0,8191)):typeof k<"u"&&k!==null&&(n[S]=k)}return{properties:n,measurements:r}}e.$Ko=d;const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(i){if(!i)return"none";const n=(0,A.$_k)(i);return u.has(n)?n:"other"}e.$Lo=p;function I(i,n,r=0,l){if(i)for(const S of Object.getOwnPropertyNames(i)){const k=i[S],w=l?l+S:S;Array.isArray(k)?n[w]=(0,L.$pn)(k):k instanceof Date?n[w]=k.toISOString():(0,D.$If)(k)?r<2?I(k,n,r+1,w+"."):n[w]=(0,L.$pn)(k):n[w]=k}}function m(i,n){const r=i.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$yo)(r)||l}e.$Mo=m;function y(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$No=y;function s(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const l=[];for(const R of n)for(;;){const H=R.exec(i);if(!H)break;l.push([H.index,R.lastIndex])}const S=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,k=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let w=0;for(r="";;){const R=k.exec(i);if(!R)break;const H=l.some(([ee,_])=>R.index<_&&ee<k.lastIndex);!S.test(R[0])&&!H&&(r+=i.substring(w,R.index)+"<REDACTED: user-file-path>",w=k.lastIndex)}return w<i.length&&(r+=i.substr(w)),r}function o(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of n)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function t(i,n){return(0,L.$mn)(i,r=>{if(r instanceof c||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let l=r.replaceAll("%20"," ");l=s(l,n);for(const S of n)l=l.replace(S,"");return l=o(l),l}})}e.$Oo=t}),define(te[27],ne([0,1,29,21,37,13,11,9,35,39]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;function P(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,L.$5e)(t.id,i.id)===0}e.$Po=P;const O=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(i){const n=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new g(i.identifier,n,r)}static parse(i){const n=O.exec(i);return n&&n[1]&&n[2]?new g({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,r="undefined"){this.version=n,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof g?P(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Qo=g;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function E(t){const i=f.exec(t);return i&&i[1]?[d(i[1]),i[2]]:[d(t),void 0]}e.$Ro=E;function v(t,i){return`${t}.${i}`}e.$So=v;function d(t){return t.toLowerCase()}e.$To=d;function u(t,i){return d(v(t??j.$fm,i))}e.$Uo=u;function p(t,i){const n=[],r=l=>{for(const S of n)if(S.some(k=>P(i(k),i(l))))return S;return null};for(const l of t){const S=r(l);S?S.push(l):n.push([l])}return n}e.$Vo=p;function I(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$Wo=I;function m(t){return{id:new c.$zo(t.identifier.id),name:new c.$zo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Xo=m,e.$Yo=new j.$jm("pprice.better-merge");function y(t,i){const n=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const l=r.shift();if(l&&n.every(S=>!P(S.identifier,{id:l}))){const S=t.filter(k=>P(k.identifier,{id:l}));S.length===1&&(n.push(S[0]),r.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$Zo=y;async function s(t,i){if(!N.$k)return!1;let n;try{n=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){i.debug("Error while getting the os-release file.",(0,b.$0)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(t,i){const n=await s(t,i),r=(0,D.$jo)(n?"alpine":N.$u,h.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$1o=o}),define(te[141],ne([0,1,20,9,15,17,42,11,94,21,27,37]),function(G,e,L,D,j,N,A,b,h,c,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wp=void 0;const g=v=>(0,h.localize)(0,null,v),f=(0,h.localize)(1,null,"ms-dotnettools.csharp");let E=class{constructor(d,u,p){this.a=d,this.b=u,this.d=p}get f(){}async listExtensions(d,u,p){let I=await this.b.getInstalled(1,p);const m=O.$im.map(s=>s.toLowerCase());if(u&&u!==""){if(m.indexOf(u.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}I=I.filter(s=>s.manifest.categories?s.manifest.categories.map(t=>t.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){this.a.info("Possible Categories: "),m.forEach(s=>{this.a.info(s)});return}this.f&&this.a.info((0,h.localize)(2,null,this.f)),I=I.sort((s,o)=>s.identifier.id.localeCompare(o.identifier.id));let y;for(const s of I)y!==s.identifier.id&&(y=s.identifier.id,this.a.info(d?`${y}@${s.manifest.version}`:y))}async installExtensions(d,u,p,I){const m=[];try{const y=[];d.length&&this.a.info(this.f?(0,h.localize)(3,null,this.f):(0,h.localize)(4,null));const s=[];let o=[];const t=(n,r,l)=>{o.push({id:n,version:r!=="prerelease"?r:void 0,installOptions:{...p,isBuiltin:l,installPreReleaseVersion:r==="prerelease"||p.installPreReleaseVersion}})};for(const n of d)if(n instanceof b.URI)s.push({vsix:n,installOptions:p});else{const[r,l]=(0,P.$Ro)(n);t(r,l,!1)}for(const n of u)if(n instanceof b.URI)s.push({vsix:n,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,l]=(0,P.$Ro)(n);t(r,l,!0)}const i=await this.b.getInstalled(1,p.profileLocation);if(s.length&&await Promise.all(s.map(async({vsix:n,installOptions:r})=>{try{const l=await this.g(n,r,I,i);l&&y.push(l)}catch(l){this.a.error(l),m.push(n.toString())}})),o.length&&(o=o.filter(({id:n,version:r})=>{const l=i.find(S=>(0,P.$Po)(S.identifier,{id:n}));if(l){if(!I&&(!r||r==="prerelease"&&l.preRelease))return this.a.info((0,h.localize)(5,null,n,l.manifest.version,n)),!1;if(r&&l.manifest.version===r)return this.a.info((0,h.localize)(6,null,`${n}@${r}`)),!1}return!0}),o.length)){const n=await this.h(o);await Promise.all(o.map(async r=>{const l=n.get(r.id.toLowerCase());if(l)try{const S=await this.j(r,l,i);S&&y.push(S)}catch(S){this.a.error(S.message||S.stack||S),m.push(r.id)}else this.a.error(`${g(r.version?`${r.id}@${r.version}`:r.id)}
${f}`),m.push(r.id)}))}}catch(y){throw this.a.error((0,h.localize)(7,null,(0,D.$0)(y))),y}if(m.length)throw new Error((0,h.localize)(8,null,m.join(", ")))}async g(d,u,p,I){const m=await this.b.getManifest(d);if(!m)throw new Error("Invalid vsix");if(await this.l(m,p,u.profileLocation,I))try{return await this.b.install(d,u),this.a.info((0,h.localize)(9,null,(0,N.$Cg)(d))),m}catch(s){if((0,D.$4)(s))return this.a.info((0,h.localize)(10,null,(0,N.$Cg)(d))),null;throw s}return null}async h(d){const u=new Map,p=d.some(y=>y.installOptions.installPreReleaseVersion),I=await this.b.getTargetPlatform(),m=[];for(const y of d)c.$co.test(y.id)&&m.push({...y,preRelease:p});if(m.length){const y=await this.d.getExtensions(m,{targetPlatform:I},L.CancellationToken.None);for(const s of y)u.set(s.identifier.id.toLowerCase(),s)}return u}async j({id:d,version:u,installOptions:p},I,m){const y=await this.d.getManifest(I,L.CancellationToken.None);if(y&&!this.k(y))return null;const s=m.find(o=>(0,P.$Po)(o.identifier,I.identifier));if(s){if(I.version===s.manifest.version)return this.a.info((0,h.localize)(11,null,u?`${d}@${u}`:d)),null;this.a.info((0,h.localize)(12,null,d,I.version))}try{p.isBuiltin?this.a.info(u?(0,h.localize)(13,null,d,u):(0,h.localize)(14,null,d)):this.a.info(u?(0,h.localize)(15,null,d,u):(0,h.localize)(16,null,d));const o=await this.b.installFromGallery(I,{...p,installGivenVersion:!!u});return this.a.info((0,h.localize)(17,null,d,o.manifest.version)),y}catch(o){if((0,D.$4)(o))return this.a.info((0,h.localize)(18,null,d)),null;throw o}}k(d){return!0}async l(d,u,p,I){if(!u){const m={id:(0,P.$Uo)(d.publisher,d.name)},y=I.find(s=>(0,P.$Po)(m,s.identifier)&&(0,A.gt)(s.manifest.version,d.version));if(y)return this.a.info((0,h.localize)(19,null,y.identifier.id,y.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,u,p){const I=async y=>{if(y instanceof b.URI){const s=await this.b.getManifest(y);return(0,P.$So)(s.publisher,s.name)}return y},m=[];for(const y of d){const s=await I(y),t=(await this.b.getInstalled(void 0,p)).filter(i=>(0,P.$Po)(i.identifier,{id:s}));if(!t.length)throw new Error(`${this.m(s)}
${f}`);if(t.some(i=>i.type===0)){this.a.info((0,h.localize)(20,null,s));return}if(!u&&t.some(i=>i.isBuiltin)){this.a.info((0,h.localize)(21,null,s));return}this.a.info((0,h.localize)(22,null,s));for(const i of t)await this.b.uninstall(i,{profileLocation:p}),m.push(i);this.f?this.a.info((0,h.localize)(23,null,s,this.f)):this.a.info((0,h.localize)(24,null,s))}}async locateExtension(d){const u=await this.b.getInstalled();d.forEach(p=>{u.forEach(I=>{if(I.identifier.id===p&&I.location.scheme===j.Schemas.file){this.a.info(I.location.fsPath);return}})})}m(d){return this.f?(0,h.localize)(25,null,d,this.f):(0,h.localize)(26,null,d)}};e.$wp=E,e.$wp=E=pe([ie(1,c.$po),ie(2,c.$no)],E)}),define(te[142],ne([0,1,8,9,2,15,17,42,3,28,24,48,25,18,21,27,60,12,6]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let m=class extends j.$Tc{static{I=this}static{this.c=".sigzip"}constructor(s,o,t,i,n,r){super(),this.h=o,this.j=t,this.m=i,this.n=n,this.r=r,this.extensionsDownloadDir=s.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(s,o,t){await this.g;const i=(0,A.$Fg)(this.extensionsDownloadDir,this.z(s));try{await this.w(s,i,r=>this.j.download(s,r,o))}catch(r){throw new E.$oo(r.message,E.ExtensionManagementErrorCode.Download)}let n=!1;if(t&&this.t(s)){const r=await this.u(s);try{n=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===p.LogLevel.Trace)}catch(l){const S=l;if(n=S.code,S.output&&this.r.trace(`Extension signature verification details for ${s.identifier.id} ${s.version}:
${S.output}`),n===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(k){this.r.error(k)}throw new E.$oo(O.$Ap,E.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(l){this.r.error(l)}}}return n===!0?this.r.info(`Extension signature is verified: ${s.identifier.id}`):n===!1?this.r.info(`Extension signature verification is not done: ${s.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${n}': ${s.identifier.id}`),{location:i,verificationStatus:n}}t(s){if(!s.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,h.$Mf)(o)?o:!0}async u(s){await this.g;const o=(0,A.$Fg)(this.extensionsDownloadDir,`${this.z(s)}${I.c}`);return await this.w(s,o,t=>this.j.downloadSignatureArchive(s,t)),o}async w(s,o,t){if(await this.h.exists(o))return;if(o.scheme!==N.Schemas.file){await t(o);return}const i=(0,A.$Fg)(this.extensionsDownloadDir,`.${(0,c.$og)()}`);await this.h.exists(i)||await t(i);try{await P.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",s.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(s){await this.g,await this.h.del(s)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const s=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(s.children){const o=[],t=[],i=[];for(const l of s.children)if(l.name.endsWith(I.c))i.push(l.resource);else{const S=v.$Qo.parse(l.name);S&&t.push([S,l])}const n=(0,v.$Vo)(t,([l])=>l),r=[];for(const l of n)l.sort((S,k)=>b.rcompare(S[0].version,k[0].version)),o.push(...l.slice(1).map(S=>S[1].resource)),r.push(l[0][1]);r.sort((l,S)=>l.mtime-S.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(l=>l.resource)),o.push(...i),await L.Promises.settled(o.map(l=>(this.r.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(s){this.r.error(s)}}z(s){return this.f?v.$Qo.create(s).toString().toLowerCase():(0,c.$og)()}};e.$Tp=m,e.$Tp=m=I=pe([ie(0,f.$_h),ie(1,u.$ok),ie(2,E.$no),ie(3,g.$xi),ie(4,d.$up),ie(5,p.$lj)],m)}),define(te[143],ne([0,1,4,2,31,27,37]),function(G,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class b extends D.$Tc{constructor(c,P,O,g,f,E,v){super(),this.f=c,this.g=P,this.h=O,this.j=g,this.m=f,this.n=E,this.r=v,this.a=this.B(new L.$Td),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,d=>v.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(P=>(this.c.set(P.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(P.extensionsResource)),this.n.watch(P.extensionsResource))),this.G(P.extensionsResource))))}catch(P){throw this.r.error(P),P}}async w(c){for(const P of c.extensions)this.I(this.L(P.identifier,P.version),c.profileLocation)}async y(c){for(const P of c.extensions){const O=this.L(P.identifier,P.version);c.error?this.J(O,c.profileLocation):this.I(O,c.profileLocation)}}async z(c){for(const P of c.extensions)this.J(this.L(P.identifier,P.version),c.profileLocation)}async C(c){const P=[],O=[];for(const g of c.extensions){const f=this.L(g.identifier,g.version);c.error?this.I(f,c.profileLocation):(this.J(f,c.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",g.identifier.id,g.version),O.push(this.f.scanInstalledExtensionAtLocation(g.location).then(E=>{E?P.push(E):this.r.info("Extension not found at the location",g.location.toString())},E=>this.r.error(E)))))}try{await Promise.all(O),P.length&&await this.H(P)}catch(g){this.r.error(g)}}D(c){for(const P of this.h.profiles)c.contains(P.extensionsResource,0,1)&&this.F(P.extensionsResource)}async F(c){const P=[],O=[],g=await this.j.scanProfileExtensions(c),f=new Set,E=new Set;for(const[v,d]of this.b)d.has(c)&&E.add(v);for(const v of g){const d=this.L(v.identifier,v.version);f.add(d),E.has(d)||(P.push(v.identifier),this.I(d,c))}for(const v of E)if(!f.has(v)){const d=this.M(v);d&&(O.push(d.identifier),this.J(v,c))}(P.length||O.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:c}:void 0,removed:O.length?{extensions:O,profileLocation:c}:void 0})}async G(c){const P=await this.j.scanProfileExtensions(c);for(const O of P)this.I(this.L(O.identifier,O.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(O=>!this.b.has(this.L(O.identifier,O.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,P){let O=this.b.get(c);O||this.b.set(c,O=new j.$Bc(g=>this.m.extUri.getComparisonKey(g))),O.add(P)}J(c,P){const O=this.b.get(c);O&&O.delete(P),O?.size||this.b.delete(c)}L(c,P){return`${A.$jm.toKey(c.id)}@${P}`}M(c){const[P,O]=(0,N.$Ro)(c);return O?{identifier:{id:P},version:O}:void 0}}e.$Xp=b}),define(te[144],ne([0,1,115,39]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;async function j(N,A,b,h,c,P,O){const g={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$Ho)(A,b)&&(0,D.$Jo)(h)===3){const f=await(0,L.$pp)(b,c,P);g["X-Market-User-Id"]=f,g["VSCode-SessionId"]=O.machineId||f}return g}e.$qp=j}),define(te[145],ne([0,1,172,19,8,2,15,16,24,18,21,27,6,64,11]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let v=class extends f.$0q{constructor(I,m,y,s){super(y),this.h=I,this.j=s,this.g=this.B(new d(m,s)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(I,m){const s=(await this.g.getLanguagePacks())[m];if(!s){this.j.warn(`No language pack found for ${m}`);return}const o=s.translations[I];return o?E.URI.file(o):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),m=Object.keys(I).map(y=>{const s=I[y];return{...this.f(y,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((y,s)=>y.label.localeCompare(s.label)),m}async m(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",I.identifier.id),await this.update())}async n(I){const m=await this.g.getLanguagePacks();Object.keys(m).some(y=>m[y]&&m[y].extensions.some(s=>(0,O.$Po)(s.extensionIdentifier,I.identifier)))&&(this.j.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),y=await this.g.update(m);return!(0,D.$ub)(Object.keys(I),Object.keys(y))}};e.$$q=v,e.$$q=v=pe([ie(0,P.$po),ie(1,c.$_h),ie(2,P.$no),ie(3,g.$lj)],v);let d=class extends N.$Tc{constructor(I,m){super(),this.j=m,this.c={},this.f=(0,b.$jc)(I.userDataPath,"languagepacks.json"),this.g=new j.$$g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.s(m=>{Object.keys(m).forEach(y=>delete m[y]),this.m(m,...I)}).then(()=>this.c)}m(I,...m){for(const y of m)y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&this.n(I,y);Object.keys(I).forEach(y=>this.r(I[y]))}n(I,m){const y=m.identifier,s=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const o of s)if(m.location.scheme===A.Schemas.file&&u(o)){let t=I[o.languageId];t||(t={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},I[o.languageId]=t);const i=t.extensions.filter(n=>(0,O.$Po)(n.extensionIdentifier,y))[0];i?i.version=m.manifest.version:t.extensions.push({extensionIdentifier:y,version:m.manifest.version});for(const n of o.translations)t.translations[n.id]=(0,b.$jc)(m.location.fsPath,n.path)}}r(I){if(I){const m=(0,L.createHash)("md5");for(const y of I.extensions)m.update(y.extensionIdentifier.uuid||y.extensionIdentifier.id).update(y.version);I.hash=m.digest("hex")}}s(I=()=>null){return this.g.queue(()=>{let m=null;return h.Promises.readFile(this.f,"utf8").then(void 0,y=>y.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(y)).then(y=>{try{return JSON.parse(y)}catch{return{}}}).then(y=>(m=I(y),y)).then(y=>{for(const o of Object.keys(y))y[o]||delete y[o];this.c=y,this.h=!0;const s=JSON.stringify(this.c);return this.j.debug("Writing language packs",s),h.Promises.writeFile(this.f,s)}).then(()=>m,y=>this.j.error(y))})}};d=pe([ie(0,c.$_h),ie(1,g.$lj)],d);function u(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const I of p.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(te[146],ne([0,1,81,9,30,39]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function h(P,O,g){const f=await(0,L.$8C)("@microsoft/1ds-core-js","dist/ms.core.js"),E=await(0,L.$8C)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new f.AppInsightsCore,d=new E.PostChannel,u={instrumentationKey:P,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(g){u.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:g};u.extensionConfig[d.identifier]=p}return v.initialize(u,[]),v.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',O&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),v}class c{constructor(O,g,f,E,v){this.e=O,this.f=g,this.g=f,this.h=v,this.c=A,this.d=b,this.g||(this.g={}),typeof E=="function"?this.a=E():this.a=E,this.b=null}i(O){if(this.a){if(typeof this.a!="string"){O(this.a);return}this.b||(this.b=h(this.a,this.e,this.h)),this.b.then(g=>{O(g)},g=>{(0,D.$1)(g),console.error(g)})}}log(O,g){if(!this.a)return;g=(0,j.$nn)(g,this.g),g=(0,N.$Ko)(g);const f=this.f+"/"+O;try{this.i(E=>{E.pluginVersionString=g?.properties.version??"Unknown",E.track({name:f,baseData:{name:f,properties:g?.properties,measurements:g?.measurements}})})}catch{}}flush(){return this.a?new Promise(O=>{this.i(g=>{g.unload(!0,()=>{this.a=void 0,O(void 0)})})}):Promise.resolve(void 0)}}e.$0N=c}),define(te[147],ne([0,1,2,30,13,29,106,25,43,148,32,36,26,39]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;let E=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(u,p,I){this.k=p,this.l=I,this.d={},this.i=new L.$Sc,this.j=[],this.b=u.appenders,this.c=u.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=u.piiPaths||[],this.g=3,this.h=!!u.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,N.$Me)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Me)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(g.$Al)||m.affectsConfiguration(g.$Cl)||m.affectsConfiguration(g.$Bl))&&this.m()}))}setExperimentProperty(u,p){this.d[u]=p}m(){let u=(0,f.$Jo)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const I=p.usage?3:p.error?2:0;u=Math.min(u,I)}this.g=u}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(u,p,I){this.g<p||(I=(0,D.$nn)(I,this.d),I=(0,f.$Oo)(I,this.j),I=(0,D.$nn)(I,this.c),this.b.forEach(m=>m.log(u,I)))}publicLog(u,p){this.n(u,3,p)}publicLog2(u,p){this.publicLog(u,p)}publicLogError(u,p){this.h&&this.n(u,2,p)}publicLogError2(u,p){this.publicLogError(u,p)}};e.$er=E,e.$er=E=pe([ie(1,b.$xi),ie(2,P.$Dj)],E);function v(){const d=(0,A.localize)(0,null,c.default.nameLong),u=c.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=j.$o?"":(0,A.localize)(3,null),I=(0,A.localize)(4,null),m=(0,A.localize)(5,null),y=(0,A.localize)(6,null),s=(0,A.localize)(7,null),o=`
|       | ${I} | ${m} | ${y} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${d} ${u} ${p}

&nbsp;

${s}
${o}

&nbsp;

${t}
`}O.$wn.as(h.$Bn.Configuration).registerConfiguration({id:g.$zl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[g.$Al]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),O.$wn.as(h.$Bn.Configuration).registerConfiguration({id:g.$zl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[g.$Cl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,A.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,A.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${g.$Al}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[149],ne([0,1,14,20,173,146]),function(G,e,L,D,j,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;async function A(P,O){const g=await O.request(P,D.CancellationToken.None),f=(await(0,L.$te)(g.stream)).toString(),E=g.res.statusCode??200;return{headers:g.res.headers,statusCode:E,responseData:f}}async function b(P){const O={method:P.type,headers:P.headers};return new Promise((f,E)=>{const v=j.request(P.url??"",O,d=>{d.on("data",function(u){f({headers:d.headers,statusCode:d.statusCode??200,responseData:u.toString()})}),d.on("error",function(u){E(u)})});v.write(P.data,d=>{d&&E(d)}),v.end()})}async function h(P,O,g){const f=typeof O.data=="string"?O.data:new TextDecoder().decode(O.data),E={type:"POST",headers:{...O.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(O.data).toString()},url:O.urlString,data:f};try{const v=P?await A(E,P):await b(E);g(v.statusCode,v.headers,v.responseData)}catch{g(0,{})}}class c extends N.$0N{constructor(O,g,f,E,v){const d={sendPOST:(u,p)=>{h(O,u,p)}};super(g,f,E,v,d)}}e.$$N=c}),define(te[150],ne([0,1,16,24]),function(G,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;async function j(N,A){const b=Object.create(null),h=(P,O)=>{const g=JSON.parse(P);b[O]=g};if(A){const P=[],O=await D.Promises.readdir(A);for(const f of O)try{(await D.Promises.stat((0,L.$jc)(A,f))).isDirectory()&&P.push(f)}catch{}const g=[];for(const f of P)(await D.Promises.readdir((0,L.$jc)(A,f))).filter(v=>v==="telemetry.json").length===1&&g.push(f);for(const f of g){const E=(await D.Promises.readFile((0,L.$jc)(A,f,"telemetry.json"))).toString();h(E,f)}}let c=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return h(c,"vscode-core"),c=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),h(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$5$b=j}),define(te[151],ne([0,1,13,82,26]),function(G,e,L,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l$b=e.$k$b=void 0;async function N(b,h){let c=b.getItem(j.$xl);return(typeof c!="string"||L.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,D.$9m)(h.error.bind(h))),c}e.$k$b=N;async function A(b,h){let c=b.getItem(j.$yl);return typeof c!="string"&&(c=await(0,D.$0m)(h.error.bind(h))),c}e.$l$b=A}),define(te[22],ne([0,1,10]),function(G,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=void 0,e.$Yk=(0,L.$4h)("IUriIdentityService")}),define(te[152],ne([0,1,22,116,12,17,73,4,2]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;class c{static{this._clock=0}constructor(g){this.uri=g,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let P=class{constructor(g){this.g=g,this.c=new h.$Sc,this.f=2**16;const f=new Map,E=v=>{let d=f.get(v.scheme);return d===void 0&&(d=g.hasProvider(v)&&!this.g.hasCapability(v,1024),f.set(v.scheme,d)),d};this.c.add(b.Event.any(g.onDidChangeFileSystemProviderRegistrations,g.onDidChangeFileSystemProviderCapabilities)(v=>{f.delete(v.scheme)})),this.extUri=new N.$ug(E),this.d=new A.$Pr((v,d)=>this.extUri.compare(v,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(g){this.g.hasProvider(g)&&(g=(0,N.$Gg)(g));const f=this.d.get(g);return f?f.touch().uri.with({fragment:g.fragment}):(this.d.set(g,new c(g)),this.h(),g)}h(){if(this.d.size<this.f)return;const g=[...this.d.entries()].sort((E,v)=>E[1].time<v[1].time?1:E[1].time>v[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let E=0;E<f;E++)this.d.set(g[E][0],g[E][1].touch())}};e.$Qr=P,e.$Qr=P=pe([ie(0,j.$ok)],P),(0,D.$Nr)(L.$Yk,P,1)}),define(te[153],ne([0,1,4,2,12,47,31]),function(G,e,L,D,j,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class b extends D.$Tc{constructor(c,P,O,g,f,E){super(),this.f=c,this.g=P,this.h=O,this.j=g,this.m=f,this.n=E,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Td),this.onDidChangeFile=this.a.event,this.b=N.$0h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(v=>this.m.extUri.getComparisonKey(this.t(v))),this.r(),this.B(g.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(v=>this.s(v)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,P){return this.g.open(this.t(c),P)}close(c){return this.g.close(c)}read(c,P,O,g,f){return this.g.read(c,P,O,g,f)}write(c,P,O,g,f){return this.g.write(c,P,O,g,f)}watch(c,P){this.b.set(c,c);const O=this.g.watch(this.t(c),P);return(0,D.$Rc)(()=>{this.b.delete(c),O.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,P,O){return this.g.rename(this.t(c),this.t(P),O)}readFile(c,P){return this.g.readFile(this.t(c),P)}readFileStream(c,P,O){return this.g.readFileStream(this.t(c),P,O)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,P,O){return this.g.writeFile(this.t(c),P,O)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,P){return this.g.delete(this.t(c),P)}copy(c,P,O){if((0,j.$sk)(this.g))return this.g.copy(this.t(c),this.t(P),O);throw new Error("copy not supported")}cloneFile(c,P){if((0,j.$tk)(this.g))return this.g.cloneFile(this.t(c),this.t(P));throw new Error("clone not supported")}s(c){const P=[];for(const O of c){if(O.resource.scheme!==this.f)continue;const g=this.u(O.resource);this.b.findSubstr(g)&&P.push({resource:g,type:O.type,cId:O.cId})}P.length&&(this.n.debug("User data changed"),this.a.fire(P))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$I$b=b}),define(te[154],ne([0,1,108,16,47,17,11,10,15]),function(G,e,L,D,j,N,A,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.WorkbenchState=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0,e.$ai=(0,b.$4h)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.uri)}e.$bi=c;function P(i){return typeof i?.id=="string"&&!c(i)&&!g(i)}e.$ci=P,e.$di={id:"ext-dev"},e.$ei={id:"empty-window"};function O(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:n?e.$di:e.$ei;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$fi=O;function g(i){const n=i;return typeof n?.id=="string"&&A.URI.isUri(n.configPath)}e.$gi=g;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:A.URI.revive(n.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:A.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$hi=f;var E;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(E||(e.WorkbenchState=E={}));function v(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ii=v;function d(i){const n=i;return!!(n&&typeof n=="object"&&A.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$ji=d;class u{constructor(n,r,l,S,k){this.h=n,this.j=l,this.k=S,this.l=k,this.c=j.$0h.forUris(this.l,()=>!0),this.folders=r}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=j.$0h.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ki=u;class p{constructor(n,r){this.raw=r,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,N.$Fg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$li=p;function I(i){return new p({uri:i,index:0,name:(0,N.$Bg)(i)},{uri:i.toString()})}e.$mi=I,e.$ni="code-workspace",e.$oi=`.${e.$ni}`,e.$pi=[{name:(0,L.localize)(0,null),extensions:[e.$ni]}],e.$qi="workspace.json";function m(i,n){return N.$wg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ri=m;function y(i){let n;return A.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$si=y,e.$ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function s(i){return i.id===e.$ti}e.$ui=s;function o(i,n){return!m(i,n)&&!y(i)}e.$vi=o;function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$Dg)(i))===e.$oi}e.$wi=t}),define(te[23],ne([0,1,41,4,2,17,11,107,18,12,10,6,154,31,22,8,28,29,3]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.ProfileResourceType=void 0;var I;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&A.URI.isUri(n.location)&&A.URI.isUri(n.globalStorageHome)&&A.URI.isUri(n.settingsResource)&&A.URI.isUri(n.keybindingsResource)&&A.URI.isUri(n.tasksResource)&&A.URI.isUri(n.snippetsHome)&&A.URI.isUri(n.extensionsResource))}e.$Zk=m,e.$1k=(0,P.$4h)("IUserDataProfilesService");function y(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:n}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$2k=y;function s(i,n,r,l,S,k){return{id:i,name:n,location:r,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:k&&S?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$Fg)(r,"globalStorage"),settingsResource:k&&S?.useDefaultFlags?.settings?k.settingsResource:(0,N.$Fg)(r,"settings.json"),keybindingsResource:k&&S?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$Fg)(r,"keybindings.json"),tasksResource:k&&S?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$Fg)(r,"tasks.json"),snippetsHome:k&&S?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$Fg)(r,"snippets"),extensionsResource:k&&S?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$Fg)(r,"extensions.json"),cacheHome:(0,N.$Fg)(l,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}e.$3k=s;let o=class extends j.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,r,l,S){super(),this.t=n,this.u=r,this.w=l,this.y=S,this.f=!0,this.h=this.B(new D.$Td),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Td),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Td),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Td),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Fg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Fg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),r=[n];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,p.$Gf)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}r.push(s((0,N.$Cg)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},n))}}catch(k){this.y.error(k)}const l=new f.$Ac,S=new Map;if(r.length)try{const k=this.Q();if(k.workspaces)for(const[w,R]of Object.entries(k.workspaces)){const H=A.URI.parse(w),ee=r.find(_=>_.id===R);ee&&l.set(H,ee)}if(k.emptyWindows)for(const[w,R]of Object.entries(k.emptyWindows)){const H=r.find(ee=>ee.id===R);H&&S.set(w,H)}}catch(k){this.y.error(k)}this.z={profiles:r,workspaces:l,emptyWindows:S}}return this.z}D(){const n=s("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const r="Temp",l=new RegExp(`${(0,u.$Me)(r)}\\s(\\d+)`);let S=0;for(const w of this.profiles){const R=l.exec(w.name),H=R?parseInt(R[1]):0;S=H>S?H:S}const k=`${r} ${S+1}`;return this.createProfile((0,L.$Ri)((0,d.$og)()).toString(16),k,{transient:!0},n)}async createNamedProfile(n,r,l){return this.createProfile((0,L.$Ri)((0,d.$og)()).toString(16),n,r,l)}async createProfile(n,r,l,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(n,r,l);return S&&await this.setProfileForWorkspace(S,k),k}async F(n,r,l){if(!(0,p.$Gf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(r);return S||(S=(async()=>{try{const k=this.profiles.find(H=>H.name===r||H.id===n);if(k)return k;const w=s(n,r,(0,N.$Fg)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.u.createFolder(w.location);const R=[];return this.j.fire({profile:w,join(H){R.push(H)}}),await v.Promises.settled(R),this.I([w],[],[]),w}finally{this.r.delete(r)}})(),this.r.set(r,S)),S}async updateProfile(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(S=>S.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=s(l.id,r.name??l.name,l.location,this.g,{shortName:r.shortName??l.shortName,icon:r.icon===null?void 0:r.icon??l.icon,transient:r.transient??l.isTransient,useDefaultFlags:r.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.I([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(S=>S.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.m.fire({profile:r,join(S){l.push(S)}});try{await Promise.allSettled(l)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(S){(0,c.$Fk)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(S=>S.id===r.id);if(!l)throw new Error(`Profile '${r.name}' does not exist`);this.L(n,l)}unsetWorkspace(n,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(r=>r.isDirectory&&this.profiles.every(l=>!this.w.extUri.isEqual(l.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(n.map(r=>this.removeProfile(r)))}getProfileForWorkspace(n){const r=this.G(n);return A.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(n){return(0,g.$bi)(n)?n.uri:(0,g.$gi)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,n.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,n.location)))}I(n,r,l){const S=[...this.profiles,...n],k=[];this.s.profiles=[];for(let w of S)w.isDefault||r.some(R=>w.id===R.id)||(w=l.find(R=>w.id===R.id)??w,w.isTransient?this.s.profiles.push(w):k.push({location:w.location,name:w.name,shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags}));this.P(k),this.z=void 0,this.J(n,r,l)}J(n,r,l){this.h.fire({added:n,removed:r,updated:l,all:this.profiles})}L(n,r,l){l=r?.isTransient?!0:l,l||this.L(n,void 0,!0);const S=this.G(n),k=l?this.s:this.C;A.URI.isUri(S)?(k.workspaces.delete(S),r&&k.workspaces.set(S,r)):(k.emptyWindows.delete(S),r&&k.emptyWindows.set(S,r)),l||this.M()}M(){const n={};for(const[l,S]of this.C.workspaces.entries())n[l.toString()]=S.id;const r={};for(const[l,S]of this.C.emptyWindows.entries())r[l.toString()]=S.id;this.R({workspaces:n,emptyWindows:r}),this.z=void 0}N(n){const r={},l=this.D();if(n.workspaces)for(const[k,w]of Object.entries(n.workspaces)){const R=A.URI.parse(w);r[k]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}const S={};if(n.emptyWindows)for(const[k,w]of Object.entries(n.emptyWindows)){const R=A.URI.parse(w);S[k]=this.w.extUri.isEqual(R,l.location)?l.id:this.w.extUri.basename(R)}return{workspaces:r,emptyWindows:S}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$4k=o,e.$4k=o=pe([ie(0,h.$$h),ie(1,c.$ok),ie(2,E.$Yk),ie(3,O.$lj)],o);class t extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$5k=t}),define(te[155],ne([0,1,19,8,20,9,4,2,13,3,11,92,21,27,37,6,32,26,22,23]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;let m=class extends b.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(n,r,l,S,k,w){super(),this.z=n,this.C=r,this.D=l,this.F=S,this.G=k,this.H=w,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Td),this.s=this.B(new A.$Td),this.t=this.B(new A.$Td),this.u=this.B(new A.$Td),this.w=this.B(new A.$Td),this.y=[],this.B((0,b.$Rc)(()=>{this.j.forEach(({task:R})=>R.cancel()),this.m.forEach(R=>R.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(n){const r=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,g.$lo)(l,n.allTargetPlatforms,r))}async installFromGallery(n,r={}){try{const S=(await this.installGalleryExtensions([{extension:n,options:r}])).find(({identifier:k})=>(0,f.$Po)(k,n.identifier));if(S?.local)return S?.local;throw S?.error?S.error:s(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw s(l)}}async installGalleryExtensions(n){if(!this.z.isEnabled())throw new g.$oo(O.localize(0,null),g.ExtensionManagementErrorCode.Internal);const r=[],l=[];await Promise.allSettled(n.map(async({extension:S,options:k})=>{try{const w=await this.O(S,!!k?.installGivenVersion,!!k?.installPreReleaseVersion);l.push({...w,options:k})}catch(w){r.push({identifier:S.identifier,operation:2,source:S,error:w})}})),l.length&&r.push(...await this.I(l));for(const S of r)S.error&&(this.F.error("Failed to install extension.",S.identifier.id),this.F.error(S.error),S.source&&!P.URI.isUri(S.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,f.$Xo)(S.source),error:S.error}));return r}async uninstall(n,r={}){return this.F.trace("ExtensionManagementService#uninstall",n.identifier.id),this.Q(n,r)}async toggleAppliationScope(n,r){if((0,E.$mm)(n.manifest)||n.isBuiltin)return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(l=await this.ab(n,this.H.defaultProfile.extensionsResource,r));for(const S of this.H.profiles){const k=(await this.getInstalled(1,S.extensionsResource)).find(w=>(0,f.$Po)(w.identifier,n.identifier));k?this.w.fire(k):this.u.fire({identifier:n.identifier,profileLocation:S.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(n,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.X(),this.h=n),this.g}registerParticipant(n){this.y.push(n)}async I(n){const r=[];return await Promise.allSettled(n.map(async l=>{try{const S=await this.J(l,(k,w)=>n.some(R=>(0,f.$To)(w.identifier.id)===(0,f.$Uo)(R.manifest.publisher,R.manifest.name))?!1:this.L(k,w));r.push(...S)}catch(S){r.push({identifier:{id:(0,f.$Uo)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:S})}})),this.s.fire(r),r}async J({manifest:n,extension:r,options:l},S){const k=l.isApplicationScoped||l.isBuiltin||(0,E.$mm)(n),w={...l,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:k,profileLocation:k?this.H.defaultProfile.extensionsResource:l.profileLocation??this.Y()},R=ue=>`${f.$Qo.create(ue).toString()}${w.profileLocation?`-${w.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const ue=this.j.get(R(r));if(ue)return this.F.info("Extensions is already requested to install",r.identifier.id),await ue.task.waitUntilTaskIsFinished(),[]}const H=[],ee=[],_=[],re=this.Z(n,r,w);P.URI.isUri(r)||this.j.set(R(r),{task:re,waitingTasks:[]}),this.n.fire({identifier:re.identifier,source:r,profileLocation:w.profileLocation}),this.F.info("Installing extension:",re.identifier.id),H.push({task:re,manifest:n});let se=!1;try{if(w.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",re.identifier.id);else try{const ce=await this.N(re.identifier,n,!!w.installOnlyNewlyAddedFromExtensionPack,!!w.installPreReleaseVersion,w.profileLocation),oe=await this.getInstalled(void 0,w.profileLocation),B={...w,donotIncludePackAndDependencies:!0,context:{...w.context,[g.$go]:!0}};for(const{gallery:X,manifest:M}of(0,L.$Mb)(ce,({gallery:C})=>C.identifier.id)){se=se||!!M.extensionDependencies?.some(J=>(0,f.$Po)({id:J},re.identifier));const C=R(X),V=this.j.get(C);if(V){if(S(re,V.task)){const J=V.task.identifier;this.F.info("Waiting for already requested installing extension",J.id,re.identifier.id),V.waitingTasks.push(re),ee.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Q=>Q.some(K=>(0,f.$Po)(K.identifier,J)))).then(Q=>{if(this.F.info("Finished waiting for already requested installing extension",J.id,re.identifier.id),!Q.find(T=>(0,f.$Po)(T.identifier,J))?.local)throw new Error(`Extension ${J.id} is not installed`)}))}}else if(!oe.some(({identifier:J})=>(0,f.$Po)(J,X.identifier))){const J=this.Z(M,X,B);this.j.set(C,{task:J,waitingTasks:[re]}),this.n.fire({identifier:J.identifier,source:X,profileLocation:w.profileLocation}),this.F.info("Installing extension:",J.identifier.id,re.identifier.id),H.push({task:J,manifest:M})}}}catch(ce){if(P.URI.isUri(re.source))(0,L.$Lb)(n.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",re.identifier.id,ce.message),(0,L.$Lb)(n.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",re.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",re.identifier.id),ce}const ue=H.reduce((ce,{task:oe,manifest:B})=>(ce.set(oe.identifier.id.toLowerCase(),{task:oe,manifest:B}),ce),new Map);for(;ue.size;){let ce;const oe=[...ue.values()].filter(({manifest:B})=>!B.extensionDependencies?.some(X=>ue.has(X.toLowerCase())));oe.length?ce=ue.size===1?oe:oe.filter(({task:B})=>!(B===re&&!se)):(this.F.info("Found extensions with circular dependencies",oe.map(({task:B})=>B.identifier.id)),ce=[...ue.values()]),await this.M(ce.map(async({task:B})=>{const X=new Date().getTime();try{const M=await B.run();if(await this.M(this.y.map(C=>C.postInstall(M,B.source,w,j.CancellationToken.None))),!P.URI.isUri(B.source)){const C=B.operation===3,V=C?void 0:(new Date().getTime()-B.source.lastUpdated)/1e3;if(o(this.C,C?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Xo)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-X,durationSinceUpdate:V}),h.$o&&B.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}_.push({local:M,identifier:B.identifier,operation:B.operation,source:B.source,context:B.options.context,profileLocation:B.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw P.URI.isUri(B.source)||o(this.C,B.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$Xo)(B.source),verificationStatus:B.verificationStatus,duration:new Date().getTime()-X,error:M}),this.F.error("Error while installing the extension:",B.identifier.id),M}finally{ue.delete(B.identifier.id.toLowerCase())}}))}return ee.length&&await this.M(ee),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(ue){if(H.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:oe})=>this.$(oe,{versionOnly:!0,profileLocation:w.profileLocation}).run()));for(let oe=0;oe<ce.length;oe++){const B=ce[oe],{identifier:X}=_[oe];B.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",X.id):this.F.warn("Rollback: Error while uninstalling extension",X.id,(0,N.$0)(B.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,N.$0)(ce),_.map(({identifier:oe})=>oe.id))}return H.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:w.context,profileLocation:w.profileLocation,error:ue}))}finally{for(const{task:ue}of H)ue.source&&!P.URI.isUri(ue.source)&&this.j.delete(R(ue.source))}}L(n,r){for(const[,{task:l,waitingTasks:S}]of this.j.entries())if(l===n&&(S.includes(r)||S.some(k=>this.L(k,r)))||l===r&&S[0]&&!this.L(n,S[0]))return!1;return!0}async M(n){const r=[],l=[],S=await Promise.allSettled(n);for(const k of S)k.status==="fulfilled"?r.push(k.value):l.push(k.reason);if(l.length)throw y(l);return r}async N(n,r,l,S,k){if(!this.z.isEnabled())return[];const w=await this.getInstalled(void 0,k),R=[],H=[],ee=async(_,re)=>{R.push(_);const se=re.extensionDependencies||[],ue=[...se];if(re.extensionPack){const ce=l?w.find(oe=>(0,f.$Po)(oe.identifier,_)):void 0;for(const oe of re.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(B=>(0,f.$Po)({id:B},{id:oe}))||ue.every(B=>!(0,f.$Po)({id:B},{id:oe}))&&ue.push(oe)}if(ue.length){const ce=ue.filter(oe=>R.every(B=>!(0,f.$Po)(B,{id:oe})));if(ce.length){const oe=await this.z.getExtensions(ce.map(B=>({id:B,preRelease:S})),j.CancellationToken.None);for(const B of oe){if(R.find(C=>(0,f.$Po)(C,B.identifier)))continue;const X=se.some(C=>(0,f.$Po)({id:C},B.identifier));let M;try{M=await this.O(B,!1,S)}catch(C){if(X)throw C;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,N.$0)(C));continue}H.push({gallery:M.extension,manifest:M.manifest}),await ee(M.extension.identifier,M.manifest)}}}};return await ee(n,r),H}async O(n,r,l){let S;const k=await this.getExtensionsControlManifest();if(k.malicious.some(H=>(0,f.$Po)(n.identifier,H)))throw new g.$oo(O.localize(1,null,n.identifier.id),g.ExtensionManagementErrorCode.Malicious);const w=k.deprecated[n.identifier.id.toLowerCase()];if(w?.extension?.autoMigrate){if(this.F.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${w.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:w.extension.id,preRelease:w.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},j.CancellationToken.None))[0],!S)throw new g.$oo(O.localize(2,null,n.identifier.id,w.extension.id),g.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const H=await this.getTargetPlatform();throw new g.$oo(O.localize(3,null,n.identifier.id,this.G.nameLong,(0,g.$ho)(H)),g.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(S=await this.P(n,r,l),!S)throw!l&&n.properties.isPreReleaseVersion&&(await this.z.getExtensions([n.identifier],j.CancellationToken.None))[0]?new g.$oo(O.localize(4,null,n.displayName??n.identifier.id),g.ExtensionManagementErrorCode.ReleaseVersionNotFound):new g.$oo(O.localize(5,null,n.identifier.id,this.G.nameLong,this.G.version),g.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",S.identifier.id);const R=await this.z.getManifest(S,j.CancellationToken.None);if(R===null)throw new g.$oo(`Missing manifest for extension ${S.identifier.id}`,g.ExtensionManagementErrorCode.Invalid);if(R.version!==S.version)throw new g.$oo(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,g.ExtensionManagementErrorCode.Invalid);return{extension:S,manifest:R}}async P(n,r,l){const S=await this.getTargetPlatform();let k=null;return!r&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(k=(await this.z.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:S,compatible:!0},j.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(n,l,S)&&(k=n),k||(r?k=(await this.z.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:S,compatible:!0},j.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(n,l,S)),k}async Q(n,r){const l={...r,profileLocation:n.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},S=_=>`${_.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,k=this.m.get(S(n.identifier));if(k)return this.F.info("Extensions is already requested to uninstall",n.identifier.id),k.waitUntilTaskIsFinished();const w=_=>{const re=this.$(_,l);return this.m.set(S(re.extension.identifier),re),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped}),re},R=(_,re)=>{re?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString(),re.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,re.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$Wo)(_),error:re}),this.u.fire({identifier:_.identifier,error:re?.code,profileLocation:l.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],ee=[];try{H.push(w(n));const _=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const re=this.U(n,_);for(const se of re)this.m.has(S(se.identifier))?this.F.info("Extensions is already requested to uninstall",se.identifier.id):H.push(w(se))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.R(H.map(re=>re.extension),_,n),await this.M(H.map(async re=>{try{if(await re.run(),await this.M(this.y.map(se=>se.postUninstall(re.extension,l,j.CancellationToken.None))),re.extension.identifier.uuid)try{await this.z.reportStatistic(re.extension.manifest.publisher,re.extension.manifest.name,re.extension.manifest.version,"uninstall")}catch{}R(re.extension)}catch(se){const ue=se instanceof g.$oo?se:new g.$oo((0,N.$0)(se),g.ExtensionManagementErrorCode.Internal);throw R(re.extension,ue),ue}finally{ee.push(re)}}))}catch(_){const re=_ instanceof g.$oo?_:new g.$oo((0,N.$0)(_),g.ExtensionManagementErrorCode.Internal);for(const se of H){try{se.cancel()}catch{}ee.includes(se)||R(se.extension,re)}throw re}finally{for(const _ of H)this.m.delete(S(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(n,r,l){for(const S of n){const k=this.W(S,r);if(k.length){const w=k.filter(R=>!n.some(H=>(0,f.$Po)(H.identifier,R.identifier)));if(w.length)throw new Error(this.S(S,w,l))}}}S(n,r,l){return l===n?r.length===1?O.localize(6,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(7,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(8,null,l.manifest.displayName||l.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?O.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?O.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):O.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(n,r,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const S=n.manifest.extensionPack?n.manifest.extensionPack:[];if(S.length){const k=r.filter(R=>!R.isBuiltin&&S.some(H=>(0,f.$Po)({id:H},R.identifier))),w=[];for(const R of k)w.push(...this.U(R,r,l));return[...k,...w]}return[]}W(n,r){return r.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(S=>(0,f.$Po)({id:S},n.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const n=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Fp=m,e.$Fp=m=pe([ie(0,g.$no),ie(1,u.$sl),ie(2,p.$Yk),ie(3,v.$lj),ie(4,d.$Dj),ie(5,I.$1k)],m);function y(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((r,l)=>new Error(`${r.message}${r.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$Gp=y;function s(i){if(i instanceof g.$oo)return i;const n=new g.$oo(i.message,g.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}e.$Hp=s;function o(i,n,{extensionData:r,verificationStatus:l,duration:S,error:k,durationSinceUpdate:w}){let R,H;(0,c.$Of)(l)&&(l===!0?l="Verified":(l===!1||(R=g.ExtensionManagementErrorCode.Signature,H=l),l="Unverified")),k&&(k instanceof g.$oo?(R=k.code,k.code===g.ExtensionManagementErrorCode.Signature&&(H=k.message)):R=g.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...r,verificationStatus:l,success:!k,duration:S,errorcode:R,errorcodeDetail:H,durationSinceUpdate:w})}class t{constructor(){this.d=new D.$3g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Rg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Rg)(n=>new Promise((r,l)=>{const S=n.onCancellationRequested(()=>{S.dispose(),l(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$Ip=t}),define(te[40],ne([0,1,8,14,2,4,31,11,21,27,12,10,6,23,22,3,9,26]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class I extends Error{constructor(t,i){super(t),this.code=i}}e.$Jp=I,e.$Kp=(0,O.$4h)("IExtensionsProfileScannerService");let m=class extends j.$Tc{constructor(t,i,n,r,l,S){super(),this.j=t,this.m=i,this.n=n,this.r=r,this.s=l,this.t=S,this.b=this.B(new N.$Td),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Td),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Td),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Td),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i){const n=[],r=[];try{return await this.u(i,l=>{const S=[];for(const k of l)t.some(([w])=>(0,c.$Po)(w.identifier,k.identifier)&&w.manifest.version!==k.version)?n.push(k):S.push(k);for(const[k,w]of t){const R=S.findIndex(ee=>(0,c.$Po)(ee.identifier,k.identifier)&&ee.version===k.manifest.version),H={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:w};R===-1?(r.push(H),S.push(H)):S.splice(R,1,H)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),S}),r.length&&this.c.fire({extensions:r,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),r}catch(l){throw r.length&&this.c.fire({extensions:r,error:l,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async updateMetadata(t,i){const n=[];return await this.u(i,r=>{const l=[];for(const S of r){const k=t.find(([w])=>(0,c.$Po)(w.identifier,S.identifier)&&w.manifest.version===S.version);k&&(S.metadata={...S.metadata,...k[1]},n.push(S)),l.push(S)}return l}),n}async removeExtensionFromProfile(t,i){const n=[];try{await this.u(i,r=>{const l=[];for(const S of r)(0,c.$Po)(S.identifier,t.identifier)?n.push(S):l.push(S);return n.length&&this.f.fire({extensions:n,profileLocation:i}),l}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(r){throw n.length&&this.g.fire({extensions:n,error:r,profileLocation:i}),r}}async u(t,i,n){return this.F(t).queue(async()=>{let r=[],l;try{const S=await this.m.readFile(t);l=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,P.$Fk)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(l=await this.D()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.w(t);let S=!1;for(const k of l){y(k)||this.w(t);let w;if((0,v.$Gf)(k.relativeLocation)&&k.relativeLocation)w=this.z(k.relativeLocation);else if((0,v.$Gf)(k.location))w=this.z(k.location),S=!0,k.relativeLocation=k.location,k.location=w.toJSON();else{w=b.URI.revive(k.location);const R=this.y(w);R&&(S=!0,k.relativeLocation=R)}r.push({identifier:k.identifier,location:w,version:k.version,metadata:k.metadata})}S&&await this.m.writeFile(t,D.$he.fromString(JSON.stringify(l)))}if(i){r=i(r);const S=r.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(t,D.$he.fromString(JSON.stringify(S)))}return r})}w(t){const i=new I(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(t)).value.toString()}catch(l){if((0,P.$Fk)(l)===1)return;throw l}this.t.info("Migrating extensions from old default profile location",t.toString());let r;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(S=>y(S))?r=l:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.t.error(l)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$he.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(l){if((0,P.$Fk)(l)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw l}try{await this.m.del(t)}catch(l){(0,P.$Fk)(l)!==1&&this.t.error(l)}try{await this.m.del(i)}catch(l){(0,P.$Fk)(l)!==1&&this.t.error(l)}return r})()),this.C}F(t){let i=this.h.get(t);return i||(i=new L.$$g,this.h.set(t,i)),i}};e.$Lp=m,e.$Lp=m=pe([ie(1,P.$ok),ie(2,f.$1k),ie(3,E.$Yk),ie(4,u.$sl),ie(5,g.$lj)],m);function y(o){return(0,v.$If)(o)&&(0,h.$mo)(o.identifier)&&(s(o.location)||(0,v.$Gf)(o.location)&&o.location)&&((0,v.$Nf)(o.relativeLocation)||(0,v.$Gf)(o.relativeLocation))&&o.version&&(0,v.$Gf)(o.version)}function s(o){return o?(0,v.$Gf)(o.path)&&(0,v.$Gf)(o.scheme):!1}}),define(te[51],ne([0,1,19,8,30,14,9,53,79,2,15,16,13,17,42,54,3,11,96,18,27,37,49,12,10,6,32,4,46,40,23,22,113]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I,m,y,s,o,t,i,n,r,l,S,k,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.Translations=void 0;var H;(function(oe){function B(X,M){if(X===M)return!0;const C=Object.keys(X),V=new Set;for(const J of Object.keys(M))V.add(J);if(C.length!==V.size)return!1;for(const J of C){if(X[J]!==M[J])return!1;V.delete(J)}return V.size===0}oe.equals=B})(H||(e.Translations=H={})),e.$Op=(0,t.$4h)("IExtensionsScannerService");let ee=class extends c.$Tc{constructor(B,X,M,C,V,J,Q,K,T,z,a,$){super(),this.systemExtensionsLocation=B,this.userExtensionsLocation=X,this.r=M,this.s=C,this.t=V,this.u=J,this.w=Q,this.y=K,this.z=T,this.C=z,this.D=a,this.F=$,this.g=this.B(new r.$Td),this.onDidChangeCache=this.g.event,this.h=(0,f.$Fg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(se,this.s,this.h)),this.m=this.B(this.F.createInstance(se,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$1o)(this.w,this.y)),this.G}async scanAllExtensions(B,X,M){const[C,V]=await Promise.all([this.scanSystemExtensions(B),this.scanUserExtensions(X)]),J=M?await this.scanExtensionsUnderDevelopment(B,[...C,...V]):[];return this.L(C,V,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(B){const X=[];X.push(this.M(!!B.useCache,B.language)),X.push(this.N(B.language,!!B.checkControlFile));const[M,C]=await Promise.all(X);return this.J([...M,...C],0,B,!1)}async scanUserExtensions(B){const X=B.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",X);const M=this.D.extUri.isEqual(B.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,C=await this.P(X,!!B.profileLocation,1,!B.includeUninstalled,B.language,!0,M),V=B.useCache&&!C.devMode&&C.excludeObsolete?this.m:this.n;let J;try{J=await V.scanExtensions(C)}catch(Q){if(Q instanceof S.$Jp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),J=await V.scanExtensions(C);else throw Q}return J=await this.J(J,1,B,!0),this.y.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(B,X){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(C=>C.scheme===P.Schemas.file).map(async C=>{const V=await this.P(C,!1,1,!0,B.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(V)).map(Q=>(Q.type=X.find(K=>(0,m.$Po)(K.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,V)))}))).flat();return this.J(M,"development",B,!0)}return[]}async scanExistingExtension(B,X,M){const C=await this.P(B,!1,X,!0,M.language,!0,void 0),V=await this.n.scanExtension(C);return!V||!M.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(B,X,M){const C=await this.P(B,!1,X,!0,M.language,!0,void 0),V=await this.n.scanOneOrMultipleExtensions(C);return this.J(V,X,M,!0)}async scanMetadata(B){const X=(0,f.$Fg)(B,"package.json"),M=(await this.w.readFile(X)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(B,X){const M=(0,f.$Fg)(B,"package.json"),C=(await this.w.readFile(M)).value.toString(),V=JSON.parse(C);X.isMachineScoped===!1&&delete X.isMachineScoped,X.isBuiltin===!1&&delete X.isBuiltin,V.__metadata={...V.__metadata,...X},await this.w.writeFile((0,f.$Fg)(B,"package.json"),N.$he.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(B){if(B instanceof S.$Jp&&B.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw B}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const B=await this.scanUserExtensions({includeInvalid:!0});if(B.length)await this.u.addExtensionsToProfile(B.map(X=>[X,X.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$he.fromString(JSON.stringify([])))}catch(X){(0,o.$Fk)(X)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(X))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(B){this.y.error(B)}finally{this.H=void 0}})()),this.H}async J(B,X,M,C){return M.includeAllVersions||(B=this.L(X===0?B:void 0,X===1?B:void 0,X==="development"?B:void 0,await this.getTargetPlatform(),C)),M.includeInvalid||(B=B.filter(V=>V.isValid)),B.sort((V,J)=>{const Q=O.$nc(V.location.fsPath),K=O.$nc(J.location.fsPath);return Q<K?-1:Q>K?1:0})}L(B,X,M,C,V){const J=(K,T,z)=>{if(K.isValid&&!T.isValid)return!1;if(K.isValid===T.isValid){if(V&&E.gt(K.manifest.version,T.manifest.version))return this.y.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(E.eq(K.manifest.version,T.manifest.version)){if(K.type===0)return this.y.debug(`Skipping extension ${T.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===C)return this.y.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${K.location.path} with ${T.location.path}.`):this.y.debug(`Overwriting user extension ${K.location.path} with ${T.location.path}.`),!0},Q=new y.$lm;return B?.forEach(K=>{const T=Q.get(K.identifier.id);(!T||J(T,K,!1))&&Q.set(K.identifier.id,K)}),X?.forEach(K=>{const T=Q.get(K.identifier.id);if(!T&&B&&K.type===0){this.y.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!T||J(T,K,!1))&&Q.set(K.identifier.id,K)}),M?.forEach(K=>{const T=Q.get(K.identifier.id);(!T||J(T,K,!0))&&Q.set(K.identifier.id,K),Q.set(K.identifier.id,K)}),[...Q.values()]}async M(B,X){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),V=await(B&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",V.length),V}async N(B,X){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const C=X?await this.O():{},V=[],J=u.URI.file(O.$hc(O.$jc(P.$mg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of M){const T=C[K.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":V.push((0,f.$Fg)(J,K.name));break;default:V.push(u.URI.file(T));break}}const Q=await Promise.all(V.map(async K=>this.n.scanExtension(await this.P(K,!1,0,!0,B,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,L.$Hb)(Q)}async O(){try{const B=await this.w.readFile(this.r);return JSON.parse(B.value.toString())}catch{return{}}}async P(B,X,M,C,V,J,Q){const K=await this.f(V??g.$w),T=await this.Q(B),z=X&&!this.D.extUri.isEqual(B,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,a=z?await this.Q(z):void 0;return new _(B,T,z,a,X,Q,M,C,J,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,V,K)}async Q(B){try{const X=await this.w.stat(B);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$Pp=ee,e.$Pp=ee=pe([ie(4,k.$1k),ie(5,S.$Kp),ie(6,o.$ok),ie(7,i.$lj),ie(8,I.$$h),ie(9,n.$Dj),ie(10,w.$Yk),ie(11,t.$3h)],ee);class _{constructor(B,X,M,C,V,J,Q,K,T,z,a,$,F,U,Y){this.location=B,this.mtime=X,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=C,this.profile=V,this.profileScanOptions=J,this.type=Q,this.excludeObsolete=K,this.validate=T,this.productVersion=z,this.productDate=a,this.productCommit=$,this.devMode=F,this.language=U,this.translations=Y}static createNlsConfiguration(B){return{language:B.language,pseudo:B.language==="pseudo",devMode:B.devMode,translations:B.translations}}static equals(B,X){return(0,f.$yg)(B.location,X.location)&&B.mtime===X.mtime&&(0,f.$yg)(B.applicationExtensionslocation,X.applicationExtensionslocation)&&B.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&B.profile===X.profile&&j.$on(B.profileScanOptions,X.profileScanOptions)&&B.type===X.type&&B.excludeObsolete===X.excludeObsolete&&B.validate===X.validate&&B.productVersion===X.productVersion&&B.productDate===X.productDate&&B.productCommit===X.productCommit&&B.devMode===X.devMode&&B.language===X.language&&H.equals(B.translations,X.translations)}}e.$Qp=_;let re=class extends c.$Tc{constructor(B,X,M,C,V){super(),this.f=B,this.g=X,this.h=M,this.j=C,this.m=V}async scanExtensions(B){const X=B.profile?await this.r(B):await this.n(B);let M={};if(B.excludeObsolete&&B.type===1)try{const C=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(C)}catch{}return(0,d.$Tf)(M)?X:X.filter(C=>!M[m.$Qo.create(C).toString()])}async n(B){const X=await this.j.resolve(B.location);if(!X.children?.length)return[];const M=await Promise.all(X.children.map(async C=>{if(!C.isDirectory||B.type===1&&(0,f.$Cg)(C.resource).indexOf(".")===0)return null;const V=new _(C.resource,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(V)}));return(0,L.$Hb)(M).sort((C,V)=>C.location.path<V.location.path?-1:1)}async r(B){let X=await this.s(B.location,()=>!0,B);if(B.applicationExtensionslocation&&!this.h.extUri.isEqual(B.location,B.applicationExtensionslocation)){X=X.filter(C=>!C.metadata?.isApplicationScoped);const M=await this.s(B.applicationExtensionslocation,C=>!!C.metadata?.isBuiltin||!!C.metadata?.isApplicationScoped,B);X.push(...M)}return X}async s(B,X,M){const C=await this.g.scanProfileExtensions(B,M.profileScanOptions);if(!C.length)return[];const V=await Promise.all(C.map(async J=>{if(X(J)){const Q=new _(J.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Q,J.metadata)}return null}));return(0,L.$Hb)(V)}async scanOneOrMultipleExtensions(B){try{if(await this.j.exists((0,f.$Fg)(B.location,"package.json"))){const X=await this.scanExtension(B);return X?[X]:[]}else return await this.scanExtensions(B)}catch(X){return this.m.error(`Error scanning extensions at ${B.location.path}:`,(0,A.$0)(X)),[]}}async scanExtension(B,X){try{let M=await this.scanExtensionManifest(B.location);if(M){M.publisher||(M.publisher=y.$fm),X=X??M.__metadata,delete M.__metadata;const C=(0,m.$Uo)(M.publisher,M.name),V=X?.id?{id:C,uuid:X.id}:{id:C},J=X?.isSystem?0:B.type,Q=J===0||!!X?.isBuiltin;M=await this.t(B.location,M,_.createNlsConfiguration(B));const K={type:J,identifier:V,manifest:M,location:B.location,isBuiltin:Q,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return B.validate?this.validate(K,B):K}}catch(M){B.type!==0&&this.m.error(M)}return null}validate(B,X){let M=!0;const C=(0,s.$6o)(X.productVersion,X.productDate,X.location,B.manifest,B.isBuiltin);for(const[V,J]of C)V===v.default.Error&&(M=!1,this.m.error(this.z(X.location,J)));return B.isValid=M,B.validations=C,B}async scanExtensionManifest(B){const X=(0,f.$Fg)(B,"package.json");let M;try{M=(await this.j.readFile(X)).value.toString()}catch(V){return(0,o.$Fk)(V)!==1&&this.m.error(this.z(B,(0,p.localize)(0,null,X.path,V.message))),null}let C;try{C=JSON.parse(M)}catch{const J=[];(0,b.$an)(M,J);for(const Q of J)this.m.error(this.z(B,(0,p.localize)(1,null,X.path,Q.offset,Q.length,(0,h.$Mp)(Q.error))));return null}return(0,b.$jn)(C)!=="object"?(this.m.error(this.z(B,(0,p.localize)(2,null,X.path))),null):C}async t(B,X,M){const C=await this.u(B,X,M);if(C)try{const V=[],J=await this.w(C.default,V);if(V.length>0)return V.forEach(K=>{this.m.error(this.z(B,(0,p.localize)(3,null,C.default?.path,(0,h.$Mp)(K.error))))}),X;if((0,b.$jn)(C)!=="object")return this.m.error(this.z(B,(0,p.localize)(4,null,C.default?.path))),X;const Q=C.values||Object.create(null);return(0,R.$Np)(this.m,X,Q,J)}catch{}return X}async u(B,X,M){const C=(0,f.$Fg)(B,"package.nls.json"),V=(T,z)=>{z.forEach(a=>{this.m.error(this.z(B,(0,p.localize)(5,null,T?.path,(0,h.$Mp)(a.error))))})},J=T=>{this.m.error(this.z(B,(0,p.localize)(6,null,T?.path)))},Q=`${X.publisher}.${X.name}`,K=M.translations[Q];if(K)try{const T=u.URI.file(K),z=(await this.j.readFile(T)).value.toString(),a=[],$=(0,b.$an)(z,a);return a.length>0?(V(T,a),{values:void 0,default:C}):(0,b.$jn)($)!=="object"?(J(T),{values:void 0,default:C}):{values:$.contents?$.contents.package:void 0,default:C}}catch{return{values:void 0,default:C}}else{if(!await this.j.exists(C))return;let z;try{z=await this.y(B,M)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const a=(await this.j.readFile(z.localized)).value.toString(),$=[],F=(0,b.$an)(a,$);return $.length>0?(V(z.localized,$),{values:void 0,default:z.original}):(0,b.$jn)(F)!=="object"?(J(z.localized),{values:void 0,default:z.original}):{values:F,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(B,X){if(B)try{const M=(await this.j.readFile(B)).value.toString();return(0,b.$an)(M,X)}catch{}}y(B,X){return new Promise((M,C)=>{const V=J=>{const Q=(0,f.$Fg)(B,`package.nls.${J}.json`);this.j.exists(Q).then(K=>{K&&M({localized:Q,original:(0,f.$Fg)(B,"package.nls.json")});const T=J.lastIndexOf("-");T===-1?M({localized:(0,f.$Fg)(B,"package.nls.json"),original:null}):(J=J.substring(0,T),V(J))})};if(X.devMode||X.pseudo||!X.language)return M({localized:(0,f.$Fg)(B,"package.nls.json"),original:null});V(X.language)})}z(B,X){return`[${B.path}]: ${X}`}};re=pe([ie(1,S.$Kp),ie(2,w.$Yk),ie(3,o.$ok),ie(4,i.$lj)],re);let se=class extends re{constructor(B,X,M,C,V,J,Q){super(X,C,V,J,Q),this.G=B,this.H=M,this.D=this.B(new D.$2g(3e3)),this.F=this.B(new r.$Td),this.onDidChangeCache=this.F.event}async scanExtensions(B){const X=this.M(B),M=await this.I(X);if(this.C=B,M&&M.input&&_.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",B.location.toString()),this.D.trigger(()=>this.L()),M.result.map(V=>(V.location=u.URI.revive(V.location),V));const C=await super.scanExtensions(B);return await this.J(X,{input:B,result:C}),C}async I(B){try{const X=await this.j.readFile(B),M=JSON.parse(X.value.toString());return{result:M.result,input:(0,l.$Ah)(M.input)}}catch(X){this.m.debug("Error while reading the extension cache file:",B.path,(0,A.$0)(X))}return null}async J(B,X){try{await this.j.writeFile(B,N.$he.fromString(JSON.stringify(X)))}catch(M){this.m.debug("Error while writing the extension cache file:",B.path,(0,A.$0)(M))}}async L(){if(!this.C)return;const B=this.M(this.C),X=await this.I(B);if(!X)return;const M=X.result,C=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!j.$on(C,M))try{this.m.info("Invalidating Cache",M,C),await this.j.del(B),this.F.fire()}catch(V){this.m.error(V)}}M(B){const X=this.N(B);return this.h.extUri.joinPath(X.cacheHome,B.type===0?y.$em:y.$dm)}N(B){return B.type===0?this.H.defaultProfile:B.profile?this.h.extUri.isEqual(B.location,this.G.extensionsResource)?this.G:this.H.profiles.find(X=>this.h.extUri.isEqual(B.location,X.extensionsResource))??this.G:this.H.defaultProfile}};se=pe([ie(2,k.$1k),ie(3,S.$Kp),ie(4,w.$Yk),ie(5,o.$ok),ie(6,i.$lj)],se);function ue(oe,B){const X=(0,m.$So)(oe.manifest.publisher,oe.manifest.name);return{id:X,identifier:new y.$jm(X),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:B,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$Rp=ue;class ce extends ee{constructor(B,X,M,C,V,J,Q,K,T,z,a,$){super(B,X,(0,f.$Fg)(M,".vscode-oss-dev","extensions","control.json"),C,V,J,Q,K,T,z,a,$),this.R=(async()=>{if(g.$z)try{const F=await this.w.readFile(u.URI.file(g.$z));return JSON.parse(F.value.toString())}catch{}return Object.create(null)})()}f(B){return this.R}}e.$Sp=ce}),define(te[156],ne([0,1,58,8,34,4,2,15,16,24,6,23]),function(G,e,L,D,j,N,A,b,h,c,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;let g=class extends A.$Tc{constructor(E,v){super(),this.b=E,this.f=v,this.a=new D.$0g(5)}async postUninstall(E){const v=this.g(E,"uninstall");v&&(this.f.info(E.identifier.id,E.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,E),this.f.info("Finished running post uninstall script",E.identifier.id,E.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",E.identifier.id,E.manifest.version),this.f.error(d)}}));try{await c.Promises.rm(this.m(E))}catch(d){this.f.error("Error while removing extension storage path",E.identifier.id),this.f.error(d)}}g(E,v){const d=`vscode:${v}`;if(E.location.scheme===b.Schemas.file&&E.manifest&&E.manifest.scripts&&typeof E.manifest.scripts[d]=="string"){const u=E.manifest.scripts[d].split(" ");return u.length<2||u[0]!=="node"||!u[1]?(this.f.warn(E.identifier.id,E.manifest.version,`${d} should be a node script`),null):{script:(0,h.$jc)(E.location.fsPath,u[1]),args:u.slice(2)||[]}}return null}h(E,v,d,u,p){return new Promise((I,m)=>{const y=this.j(E,v,d,p);let s;const o=t=>{s&&(clearTimeout(s),s=null),t?m(t):I(void 0)};y.on("error",t=>{o((0,j.$Oi)(t)||"Unknown")}),y.on("exit",(t,i)=>{o(t?`post-${v} process exited with code ${t}`:void 0)}),u&&(s=setTimeout(()=>{s=null,y.kill(),m("timed out")},5e3))})}j(E,v,d,u){const p={silent:!0,execArgv:void 0},I=(0,L.fork)(E,[`--type=extension-post-${v}`,...d],p);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const m=N.Event.fromNodeEventEmitter(I.stdout,"data"),y=N.Event.fromNodeEventEmitter(I.stderr,"data");m(t=>this.f.info(u.identifier.id,u.manifest.version,`post-${v}`,t)),y(t=>this.f.error(u.identifier.id,u.manifest.version,`post-${v}`,t));const s=N.Event.any(N.Event.map(m,t=>({data:`%c${t}`,format:[""]})),N.Event.map(y,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(u.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),I}m(E){return(0,h.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,E.identifier.id.toLowerCase())}};e.$Up=g,e.$Up=g=pe([ie(0,O.$1k),ie(1,P.$lj)],g)}),define(te[157],ne([0,1,8,14,20,34,9,4,41,2,31,15,16,17,42,3,11,28,24,48,97,59,18,155,21,27,40,51,142,156,114,135,143,49,12,10,6,32,26,22,23]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I,m,y,s,o,t,i,n,r,l,S,k,w,R,H,ee,_,re,se,ue,ce,oe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=void 0,e.$Yp=(0,_.$5h)(t.$po);const B=".vsctmp";let X=class extends o.$Fp{constructor(T,z,a,$,F,U,Y,W,le,ae,me,de){super(T,z,me,a,ae,de),this.fb=F,this.gb=U,this.hb=Y,this.ib=le,this.eb=new Map,this.rb=new P.$Bc;const ge=this.B(W.createInstance(S.$Up));this.bb=this.B(W.createInstance(M,he=>ge.postUninstall(he))),this.cb=this.B(new w.$Wp(de,le,me,this,this.F)),this.db=this.B(W.createInstance(l.$Tp));const fe=this.B(new R.$Xp(this,this.fb,de,U,me,le,a));this.B(fe.onDidChangeExtensionsByAnotherSource(he=>this.qb(he))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$1o)(this.ib,this.F)),this.jb}async zip(T){this.F.trace("ExtensionManagementService#zip",T.identifier.id);const z=await this.pb(T),a=await(0,I.zip)((0,f.$Fg)(this.db.extensionsDownloadDir,(0,u.$og)()).fsPath,z);return d.URI.file(a)}async unzip(T){return this.F.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:z,cleanup:a}=await this.lb(T),$=g.$kc(z.fsPath);try{return await(0,k.$Vp)($)}finally{await a()}}getInstalled(T,z=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(T??null,z)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(T){return this.bb.scanUserExtensionAtLocation(T)}async install(T,z={}){this.F.trace("ExtensionManagementService#install",T.toString());const{location:a,cleanup:$}=await this.lb(T);try{const F=await(0,k.$Vp)(g.$kc(a.fsPath)),U=(0,i.$Uo)(F.publisher,F.name);if(F.engines&&F.engines.vscode&&!(0,H.$8o)(F.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,U,this.G.version));const W=(await this.I([{manifest:F,extension:a,options:z}])).find(({identifier:le})=>(0,i.$Po)(le,{id:U}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$Hp)(new Error(`Unknown error while installing extension ${U}`))}finally{await $()}}async installFromLocation(T,z){this.F.trace("ExtensionManagementService#installFromLocation",T.toString());const a=await this.bb.scanUserExtensionAtLocation(T);if(!a)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.ub([[a,void 0]],z),this.F.info("Successfully installed extension",a.identifier.id,z.toString()),a}async installExtensionsFromProfile(T,z,a){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",T,z.toString(),a.toString());const $=(await this.bb.scanExtensions(1,z)).filter(F=>T.some(U=>(0,i.$Po)(U,F.identifier)));if($.length){const F=await Promise.all($.map(U=>this.bb.scanMetadata(U,z)));await this.ub($.map((U,Y)=>[U,F[Y]]),a),this.F.info("Successfully installed extensions",$.map(U=>U.identifier.id),a.toString())}return $}async updateMetadata(T,z,a=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",T.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),T=await this.bb.updateMetadata(T,z,a),this.cb.invalidate(a),this.w.fire(T),T}async reinstallFromGallery(T){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const z=await this.getTargetPlatform(),[a]=await this.z.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:z,compatible:!0},j.CancellationToken.None);if(!a)throw new Error(m.localize(2,null));await this.bb.setUninstalled(T);try{await this.bb.removeUninstalledExtension(T)}catch($){throw new Error(m.localize(3,null,(0,N.$Oi)($)))}return this.installFromGallery(a)}ab(T,z,a,$){return this.bb.copyExtension(T,z,a,$)}copyExtensions(T,z){return this.bb.copyExtensions(T,z)}markAsUninstalled(...T){return this.bb.setUninstalled(...T)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(T){this.F.error(T)}}async download(T,z,a){const{location:$}=await this.db.download(T,z,!a);return $}async lb(T){if(T.scheme===O.Schemas.file)return{location:T,async cleanup(){}};this.F.trace("Downloading extension from",T.toString());const z=(0,f.$Fg)(this.db.extensionsDownloadDir,(0,u.$og)());return await this.hb.download(T,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.ib.del(z)}catch($){this.F.error($)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(T,z,a){if(d.URI.isUri(z))return new J(T,z,a,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const $=i.$Qo.create(z).toString();let F=this.eb.get($);return F||(this.eb.set($,F=new V(T,z,a,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),F.waitUntilTaskIsFinished().finally(()=>this.eb.delete($))),F}$(T,z){return new Q(T,z.profileLocation,this.gb)}async pb(T){const z=async $=>{let F=await p.Promises.readdir($);F=F.map(W=>g.$jc($,W));const U=await Promise.all(F.map(W=>p.Promises.stat(W)));let Y=Promise.resolve([]);return U.forEach((W,le)=>{const ae=F[le];W.isFile()&&(Y=Y.then(me=>[...me,ae])),W.isDirectory()&&(Y=Y.then(me=>z(ae).then(de=>[...me,...de])))}),Y};return(await z(T.location.fsPath)).map($=>({path:`extension/${g.$lc(T.location.fsPath,$)}`,localPath:$}))}async qb({added:T,removed:z}){if(z){const a=T&&this.D.extUri.isEqual(z.profileLocation,T.profileLocation)?z.extensions.filter($=>T.extensions.every(F=>!(0,i.$Po)(F,$))):z.extensions;for(const $ of a)this.F.info("Extensions removed from another source",$.id,z.profileLocation.toString()),this.u.fire({identifier:$,profileLocation:z.profileLocation})}if(T){const $=(await this.bb.scanExtensions(1,T.profileLocation)).filter(F=>T.extensions.some(U=>(0,i.$Po)(U,F.identifier)));this.s.fire($.map(F=>(this.F.info("Extensions added from another source",F.identifier.id,T.profileLocation.toString()),{identifier:F.identifier,local:F,profileLocation:T.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(z=>this.rb.add(z)));const T=await this.ib.resolve(this.fb.userExtensionsLocation);for(const z of T.children??[])z.isDirectory&&this.rb.add(z.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(z=>this.tb(z)))}async tb(T){if(!T.affects(this.fb.userExtensionsLocation,1))return;const z=[];for(const a of T.rawAdded){if(this.rb.has(a)||!this.D.extUri.isEqual(this.D.extUri.dirname(a),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(a,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(a).startsWith(".")||!(await this.ib.stat(a)).isDirectory)continue;const $=await this.bb.scanUserExtensionAtLocation(a);$&&$.installedTimestamp===void 0&&(this.rb.add(a),z.push($))}z.length&&(await this.ub(z.map(a=>[a,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(a=>a.identifier.id)))}async ub(T,z){const a=T.map($=>$[0]);await this.vb(a),await this.gb.addExtensionsToProfile(T,z),this.s.fire(a.map($=>({local:$,identifier:$.identifier,operation:1,profileLocation:z})))}async vb(T){const z=await this.bb.getUninstalledExtensions();for(const a of T){const $=i.$Qo.create(a);z[$.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",$.id),await this.bb.setInstalled($),this.F.info("Removed the extension from uninstalled list:",$.id))}}};e.$Zp=X,e.$Zp=X=pe([ie(0,t.$no),ie(1,ue.$sl),ie(2,re.$lj),ie(3,s.$_h),ie(4,r.$Op),ie(5,n.$Kp),ie(6,y.$5n),ie(7,_.$3h),ie(8,ee.$ok),ie(9,se.$Dj),ie(10,ce.$Yk),ie(11,oe.$1k)],X);let M=class extends c.$Tc{constructor(T,z,a,$,F,U){super(),this.j=T,this.m=z,this.n=a,this.s=$,this.t=F,this.u=U,this.h=this.B(new b.$Td),this.onExtract=this.h.event,this.c=(0,f.$Fg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$$g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(T,z){const a={includeInvalid:!0,profileLocation:z};let $=[];return T===null||T===0?$.push(...await this.n.scanAllExtensions({includeInvalid:!0},a,!1)):T===1&&$.push(...await this.n.scanUserExtensions(a)),$=T!==null?$.filter(F=>F.type===T):$,Promise.all($.map(F=>this.F(F)))}async scanAllUserExtensions(T){const z=await this.n.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(z.map(a=>this.F(a)))}async scanUserExtensionAtLocation(T){try{const z=await this.n.scanExistingExtension(T,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(T,z,a,$,F){const U=T.toString(),Y=d.URI.file(g.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,u.$og)()}`)),W=d.URI.file(g.$jc(this.n.userExtensionsLocation.fsPath,U));let le=await this.m.exists(W);if(le&&$){try{await this.y(T.id,W,"removeExisting")}catch{throw new t.$oo(m.localize(4,null,W.fsPath,T.id),t.ExtensionManagementErrorCode.Delete)}le=!1}if(!le)try{try{this.u.trace(`Started extracting the extension from ${z} to ${W.fsPath}`),await(0,I.$Dp)(z,Y.fsPath,{sourcePath:"extension",overwrite:!0},F),this.u.info(`Extracted extension to ${W}:`,T.id)}catch(ae){let me=t.ExtensionManagementErrorCode.Extract;throw ae instanceof I.$Bp&&(ae.type==="CorruptZip"?me=t.ExtensionManagementErrorCode.CorruptZip:ae.type==="Incomplete"&&(me=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$oo(ae.message,me)}await this.n.updateMetadata(Y,a);try{this.u.trace(`Started renaming the extension from ${Y.fsPath} to ${W.fsPath}`),await this.C(Y.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,Y),ae}this.h.fire(W)}catch(ae){try{await this.m.del(Y,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(T,z){return z?(await this.w(T,z))?.metadata:this.n.scanMetadata(T.location)}async w(T,z){return(await this.s.scanProfileExtensions(z)).find($=>(0,i.$Po)($.identifier,T.identifier))}async updateMetadata(T,z,a){return a?await this.s.updateMetadata([[T,z]],a):await this.n.updateMetadata(T.location,z),this.D(T.location,T.type,a)}getUninstalledExtensions(){return this.z()}async setUninstalled(...T){const z=T.map(a=>i.$Qo.create(a));await this.z(a=>z.forEach($=>{a[$.toString()]=!0,this.u.info("Marked extension as uninstalled",$.toString())}))}async setInstalled(T){await this.z(z=>delete z[T.toString()])}async removeExtension(T,z){if(this.t.extUri.isEqualOrParent(T.location,this.n.userExtensionsLocation))return this.y(T.identifier.id,T.location,z)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.z(z=>delete z[i.$Qo.create(T).toString()])}async copyExtension(T,z,a,$){const F=await this.w(T,z),U=await this.w(T,a);return $={...F?.metadata,...$},U?await this.s.updateMetadata([[T,{...U.metadata,...$}]],a):await this.s.addExtensionsToProfile([[T,$]],a),this.D(T.location,T.type,a)}async copyExtensions(T,z){const a=await this.scanExtensions(1,T),$=await Promise.all(a.filter(F=>!F.isApplicationScoped).map(async F=>[F,await this.scanMetadata(F,T)]));await this.s.addExtensionsToProfile($,z)}async y(T,z,a){this.u.trace(`Deleting ${a} extension from disk`,T,z.fsPath);const $=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,h.$Ri)((0,u.$og)()).toString(16)}${B}`);await this.C(z.fsPath,$.fsPath),await this.m.del($,{recursive:!0}),this.u.info(`Deleted ${a} extension from disk`,T,z.fsPath)}async z(T){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch($){if((0,ee.$Fk)($)!==1)throw $}let a={};if(z)try{a=JSON.parse(z)}catch{}return T&&(T(a),Object.keys(a).length?await this.m.writeFile(this.c,D.$he.fromString(JSON.stringify(a))):await this.m.del(this.c)),a})}async C(T,z){try{await p.Promises.rename(T,z,2*60*1e3)}catch(a){throw new t.$oo(a.message||m.localize(5,null,T,z),a.code||t.ExtensionManagementErrorCode.Rename)}}async D(T,z,a){if(a){const F=(await this.n.scanUserExtensions({profileLocation:a})).find(U=>this.t.extUri.isEqual(U.location,T));if(F)return this.F(F)}else{const $=await this.n.scanExistingExtension(T,z,{includeInvalid:!0});if($)return this.F($)}throw new Error(m.localize(6,null,T.path))}async F(T){const z=await this.m.resolve(T.location);let a,$;return z.children&&(a=z.children.find(({name:F})=>/^readme(\.txt|\.md|)$/i.test(F))?.resource,$=z.children.find(({name:F})=>/^changelog(\.txt|\.md|)$/i.test(F))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:a,changelogUrl:$,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated,pinned:!!T.metadata?.pinned}}async G(){const T=await this.getUninstalledExtensions();if(Object.keys(T).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(T));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),a=new Set;for(const F of z)T[i.$Qo.create(F).toString()]||a.add(F.identifier.id.toLowerCase());try{const F=(0,i.$Vo)(z,U=>U.identifier);await L.Promises.settled(F.map(async U=>{const Y=U.sort((W,le)=>E.rcompare(W.manifest.version,le.manifest.version))[0];a.has(Y.identifier.id.toLowerCase())||await this.j(await this.F(Y))}))}catch(F){this.u.error(F)}const $=z.filter(F=>F.metadata&&T[i.$Qo.create(F).toString()]);await Promise.allSettled($.map(F=>this.removeUninstalledExtension(F)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let T;try{T=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,ee.$Fk)(z)!==1&&this.u.error(z);return}if(T?.children)try{await Promise.allSettled(T.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(B))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(a){(0,ee.$Fk)(a)!==1&&this.u.error(a)}}}))}catch{}}};e.$1p=M,e.$1p=M=pe([ie(1,ee.$ok),ie(2,r.$Op),ie(3,n.$Kp),ie(4,ce.$Yk),ie(5,re.$lj)],M);class C extends o.$Ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,v.$Nf)(this.options.operation)?this.l:this.options.operation}constructor(T,z,a,$,F,U,Y,W,le){super(),this.identifier=T,this.source=z,this.options=a,this.m=$,this.n=F,this.o=U,this.p=Y,this.q=W,this.s=le,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(T){const[z,a]=await this.x(T);return this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[z,a]],this.j),z}async u({zipPath:T,key:z,metadata:a},$,F){let U=await this.v(z);return U||(this.s.trace("Extracting extension...",z.id),U=await this.m.extractUserExtension(z,T,a,$,F),this.s.info("Extracting extension completed.",z.id)),U}async v(T){return await this.w(T)?(this.s.trace("Removing the extension from uninstalled list:",T.id),await this.m.setInstalled(T),this.s.info("Removed the extension from uninstalled list:",T.id),(await this.m.scanAllUserExtensions(!0)).find($=>i.$Qo.create($).equals(T))):void 0}async w(T){return!!(await this.m.getUninstalledExtensions())[T.toString()]}}class V extends C{constructor(T,z,a,$,F,U,Y,W,le,ae){super(z.identifier,z,a,F,U,Y,W,le,ae),this.y=z,this.z=$}async x(T){const a=(await this.m.scanExtensions(null,this.options.profileLocation)).find(Y=>(0,i.$Po)(Y.identifier,this.y.identifier));a&&(this.l=3);const $={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||a?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||a?.isMachineScoped,isBuiltin:this.options.isBuiltin||a?.isBuiltin,isSystem:a?.type===0?!0:void 0,updated:!!a,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??a?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,v.$Mf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:a?.preRelease)};if(a?.manifest.version===this.y.version)return[await this.m.updateMetadata(a,$),$];const{location:F,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(F.fsPath),[await this.u({zipPath:F.fsPath,key:i.$Qo.create(this.y),metadata:$},!1,T),$]}catch(Y){try{await this.z.delete(F)}catch(W){this.s.warn("Error while deleting the downloaded file",F.toString(),(0,A.$0)(W))}throw Y}}async B(T){try{await(0,k.$Vp)(T)}catch(z){throw new t.$oo((0,o.$Gp)(z).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$2p=V;class J extends C{constructor(T,z,a,$,F,U,Y,W,le,ae){super({id:(0,i.$Uo)(T.publisher,T.name)},z,a,F,U,Y,W,le,ae),this.y=T,this.z=z,this.A=$}async h(T){const z=await super.h(T);return this.D(z,T),z}async x(T){const z=new i.$Qo(this.identifier,this.y.version),$=(await this.m.scanExtensions(1,this.options.profileLocation)).find(Y=>(0,i.$Po)(this.identifier,Y.identifier)),F={isApplicationScoped:this.options.isApplicationScoped||$?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||$?.isMachineScoped,isBuiltin:this.options.isBuiltin||$?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??$?.pinned};if($)if(this.l=3,z.equals(new i.$Qo($.identifier,$.manifest.version)))try{await this.m.removeExtension($,"existing")}catch{throw new Error(m.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&E.gt($.manifest.version,this.y.version)&&await this.m.setUninstalled($);else{const Y=await this.v(z);if(Y)try{await this.m.removeExtension(Y,"existing")}catch{throw new Error(m.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:g.$kc(this.z.fsPath),key:z,metadata:F},!0,T),F]}async D(T,z){try{let[a]=await this.A.getExtensions([{id:T.identifier.id,version:T.manifest.version}],z);if(a||([a]=await this.A.getExtensions([{id:T.identifier.id}],z)),a){const $={id:a.identifier.uuid,publisherDisplayName:a.publisherDisplayName,publisherId:a.publisherId,isPreReleaseVersion:a.properties.isPreReleaseVersion,preRelease:a.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(T,$,this.options.profileLocation)}}catch{}}}class Q extends o.$Ip{constructor(T,z,a){super(),this.extension=T,this.j=z,this.k=a}async h(T){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(te[158],ne([0,1,6,23,22,26,40,12,18,11]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let P=class extends A.$Lp{constructor(g,f,E,v,d,u){super(c.URI.file(g.extensionsPath),f,E,v,d,u)}};e.$jO=P,e.$jO=P=pe([ie(0,h.$_h),ie(1,b.$ok),ie(2,D.$1k),ie(3,j.$Yk),ie(4,N.$sl),ie(5,L.$lj)],P)}),define(te[159],ne([0,1,11,18,40,51,12,10,6,32,22,23]),function(G,e,L,D,j,N,A,b,h,c,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;let g=class extends N.$Sp{constructor(E,v,d,u,p,I,m,y){super(L.URI.file(p.builtinExtensionsPath),L.URI.file(p.extensionsPath),p.userHome,E.defaultProfile,E,v,d,u,p,I,m,y)}};e.$h$b=g,e.$h$b=g=pe([ie(0,O.$1k),ie(1,j.$Kp),ie(2,A.$ok),ie(3,h.$lj),ie(4,D.$_h),ie(5,c.$Dj),ie(6,P.$Yk),ie(7,b.$3h)],g)}),define(te[160],ne([0,1,8,4,2,125,3,86,10,23]),function(G,e,L,D,j,N,A,b,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jp=e.$ip=e.$hp=void 0,e.$hp="__$__isNewStorageMarker",e.$ip="__$__targetStorageMarker",e.$jp=(0,h.$4h)("storageService");var P;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var O;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(O||(e.StorageScope=O={}));var g;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})(g||(e.StorageTarget=g={}));function f(p){const I=p.get(e.$ip);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$kp=f;class E extends j.$Tc{static{this.a=60*1e3}constructor(I={flushInterval:E.a}){super(),this.m=I,this.b=this.B(new D.$Wd),this.c=this.B(new D.$Wd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Td),this.onWillSaveState=this.f.event,this.h=this.B(new L.$dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new j.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(I,m,y){return D.Event.filter(this.b.event,s=>s.scope===I&&(m===void 0||s.key===m),y)}n(){this.j.value=(0,L.$hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,j.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(I,m){const{key:y,external:s}=m;if(y===e.$ip){switch(I){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:y,target:this.J(I)[y],external:s})}w(I){this.f.fire({reason:I})}get(I,m,y){return this.P(m)?.get(I,y)}getBoolean(I,m,y){return this.P(m)?.getBoolean(I,y)}getNumber(I,m,y){return this.P(m)?.getNumber(I,y)}getObject(I,m,y){return this.P(m)?.getObject(I,y)}storeAll(I,m){this.y(()=>{for(const y of I)this.store(y.key,y.value,y.scope,y.target,m)})}store(I,m,y,s,o=!1){if((0,A.$Pf)(m)){this.remove(I,y,o);return}this.y(()=>{this.z(I,y,s),this.P(y)?.set(I,m,o)})}remove(I,m,y=!1){this.y(()=>{this.z(I,m,void 0),this.P(m)?.delete(I,y)})}y(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,m){const y=[],s=this.J(I);for(const o of Object.keys(s))s[o]===m&&y.push(o);return y}z(I,m,y,s=!1){const o=this.J(m);typeof y=="number"?o[I]!==y&&(o[I]=y,this.P(m)?.set(e.$ip,JSON.stringify(o),s)):typeof o[I]=="number"&&(delete o[I],this.P(m)?.set(e.$ip,JSON.stringify(o),s))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(I){switch(I){case-1:return this.I;case 0:return this.G;default:return this.D}}L(I){const m=this.P(I);return m?f(m):Object.create(null)}isNew(I){return this.getBoolean(e.$hp,I)===!0}async flush(I=P.NONE){this.f.fire({reason:I});const m=this.P(-1),y=this.P(0),s=this.P(1);switch(I){case P.NONE:await L.Promises.settled([m?.whenFlushed()??Promise.resolve(),y?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await L.Promises.settled([m?.flush(0)??Promise.resolve(),y?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,y=this.P(1)?.items??new Map;return u(I,m,y,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(I){return await this.flush(),this.P(I)?.optimize()}async switch(I,m){return this.w(P.NONE),(0,c.$Zk)(I)?this.R(I,m):this.S(I,m)}M(I,m){return!(I.id===m.id||v(m)&&v(I))}N(I,m,y){this.y(()=>{const s=new Set;for(const[o,t]of I)s.add(o),m.get(o)!==t&&this.u(y,{key:o,external:!0});for(const[o]of m.items)s.has(o)||this.u(y,{key:o,external:!0})})}}e.$lp=E;function v(p){return p.isDefault||!!p.useDefaultFlags?.globalState}e.$mp=v;class d extends E{constructor(){super(),this.U=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$fp(new b.$gp,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(I=>this.u(1,I))),this.B(this.W.onDidChangeStorage(I=>this.u(0,I))),this.B(this.U.onDidChangeStorage(I=>this.u(-1,I)))}P(I){switch(I){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(I){return!1}}e.$np=d;async function u(p,I,m,y,s,o){const t=H=>{try{return JSON.parse(H)}catch{return H}},i=new Map,n=new Map;p.forEach((H,ee)=>{i.set(ee,H),n.set(ee,t(H))});const r=new Map,l=new Map;I.forEach((H,ee)=>{r.set(ee,H),l.set(ee,t(H))});const S=new Map,k=new Map;m.forEach((H,ee)=>{S.set(ee,H),k.set(ee,t(H))}),console.group(y!==s?`Storage: Application (path: ${y})`:`Storage: Application & Profile (path: ${y}, default profile)`);const w=[];if(i.forEach((H,ee)=>{w.push({key:ee,value:H})}),console.table(w),console.groupEnd(),console.log(n),y!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const H=[];r.forEach((ee,_)=>{H.push({key:_,value:ee})}),console.table(H),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${o})`);const R=[];S.forEach((H,ee)=>{R.push({key:ee,value:H})}),console.table(R),console.groupEnd(),console.log(k)}e.$op=u}),define(te[161],ne([0,1,19,20,9,13,35,3,11,25,18,21,27,49,12,6,32,44,144,160,26,174]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=void 0;const s=N.$o?"web":(0,O.$jo)(N.$u,A.$ec),o="X-Market-Search-Activity-Id";var t;(function(a){a[a.None=0]="None",a[a.IncludeVersions=1]="IncludeVersions",a[a.IncludeFiles=2]="IncludeFiles",a[a.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",a[a.IncludeSharedAccounts=8]="IncludeSharedAccounts",a[a.IncludeVersionProperties=16]="IncludeVersionProperties",a[a.ExcludeNonValidated=32]="ExcludeNonValidated",a[a.IncludeInstallationTargets=64]="IncludeInstallationTargets",a[a.IncludeAssetUri=128]="IncludeAssetUri",a[a.IncludeStatistics=256]="IncludeStatistics",a[a.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",a[a.Unpublished=4096]="Unpublished",a[a.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...a){return String(a.reduce(($,F)=>$|F,0))}var n;(function(a){a[a.Tag=1]="Tag",a[a.ExtensionId=4]="ExtensionId",a[a.Category=5]="Category",a[a.ExtensionName=7]="ExtensionName",a[a.Target=8]="Target",a[a.Featured=9]="Featured",a[a.SearchText=10]="SearchText",a[a.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},l={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class w{constructor($=k){this.d=$}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage($,F=this.d.pageSize){return new w({...this.d,pageNumber:$,pageSize:F})}withFilter($,...F){const U=[...this.d.criteria,...F.length?F.map(Y=>({filterType:$,value:Y})):[{filterType:$}]];return new w({...this.d,criteria:U})}withSortBy($){return new w({...this.d,sortBy:$})}withSortOrder($){return new w({...this.d,sortOrder:$})}withFlags(...$){return new w({...this.d,flags:$.reduce((F,U)=>F|U,0)})}withAssetTypes(...$){return new w({...this.d,assetTypes:$})}withSource($){return new w({...this.d,source:$})}get raw(){const{criteria:$,pageNumber:F,pageSize:U,sortBy:Y,sortOrder:W,flags:le,assetTypes:ae}=this.d;return{filters:[{criteria:$,pageNumber:F,pageSize:U,sortBy:Y,sortOrder:W}],assetTypes:ae,flags:le}}get searchText(){const $=this.d.criteria.filter(F=>F.filterType===n.SearchText)[0];return $&&$.value?$.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map($=>String($.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function R(a,$){const F=(a||[]).filter(U=>U.statisticName===$)[0];return F?F.value:0}function H(a){const $="Microsoft.VisualStudio.Code.Translation.";return a.files.filter(U=>U.assetType.indexOf($)===0).reduce((U,Y)=>{const W=re(a,Y.assetType);return W&&U.push([Y.assetType.substring($.length),W]),U},[])}function ee(a){if(a.properties){const $=a.properties.filter(Y=>Y.key===r.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),U=$.filter(Y=>F.test(Y.value))[0];return U?{uri:U.value,fallbackUri:U.value}:null}return re(a,r.Repository)}function _(a){return{uri:`${a.fallbackAssetUri}/${r.VSIX}?redirect=true${a.targetPlatform?`&targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${r.VSIX}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}}function re(a,$){return a.files.filter(U=>U.assetType===$)[0]?{uri:`${a.assetUri}/${$}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`,fallbackUri:`${a.fallbackAssetUri}/${$}${a.targetPlatform?`?targetPlatform=${a.targetPlatform}`:""}`}:null}function se(a,$){const F=a.properties?a.properties.filter(Y=>Y.key===$):[],U=F.length>0&&F[0].value;return U?U.split(",").map(Y=>(0,g.$To)(Y)):[]}function ue(a){const $=a.properties?a.properties.filter(F=>F.key===l.Engine):[];return $.length>0&&$[0].value||""}function ce(a){const $=a.properties?a.properties.filter(F=>F.key===l.PreRelease):[];return $.length>0&&$[0].value==="true"}function oe(a){const $=a.properties?a.properties.filter(U=>U.key===l.LocalizedLanguages):[],F=$.length>0&&$[0].value||"";return F?F.split(","):[]}function B(a){return a.properties?.find($=>$.key===l.SponsorLink)?.value}function X(a){return a.indexOf("preview")!==-1}function M(a){return a.targetPlatform?(0,O.$io)(a.targetPlatform):"undefined"}function C(a){const $=(0,L.$Mb)(a.versions.map(M)),F=!!a.tags?.includes(O.$do),U=$.indexOf("web");return F?U===-1&&$.push("web"):U!==-1&&$.splice(U,1),$}function V(a,$){for(let F=0;F<a.length;F++){const U=a[F];if(U.version===a[F-1]?.version){let Y=F;if(M(U)===$)for(;Y>0&&a[Y-1].version===U.version;)Y--;Y!==F&&(a.splice(F,1),a.splice(Y,0,U))}}return a}e.$rp=V;function J(a,$,F){a.telemetryData={index:$,querySource:F,queryActivityId:a.queryContext?.[o]}}function Q(a,$,F,U){const Y=a.versions[0],W={manifest:re($,r.Manifest),readme:re($,r.Details),changelog:re($,r.Changelog),license:re($,r.License),repository:ee($),download:_($),icon:re($,r.Icon),signature:re($,r.Signature),coreTranslations:H($)};return{identifier:{id:(0,g.$Uo)(a.publisher.publisherName,a.extensionName),uuid:a.extensionId},name:a.extensionName,version:$.version,displayName:a.displayName,publisherId:a.publisher.publisherId,publisher:a.publisher.publisherName,publisherDisplayName:a.publisher.displayName,publisherDomain:a.publisher.domain?{link:a.publisher.domain,verified:!!a.publisher.isDomainVerified}:void 0,publisherSponsorLink:B(Y),description:a.shortDescription||"",installCount:R(a.statistics,"install"),rating:R(a.statistics,"averagerating"),ratingCount:R(a.statistics,"ratingcount"),categories:a.categories||[],tags:a.tags||[],releaseDate:Date.parse(a.releaseDate),lastUpdated:Date.parse(a.lastUpdated),allTargetPlatforms:F,assets:W,properties:{dependencies:se($,l.Dependency),extensionPack:se($,l.ExtensionPack),engine:ue($),localizedLanguages:oe($),targetPlatform:M($),isPreReleaseVersion:ce($)},hasPreReleaseVersion:ce(Y),hasReleaseVersion:!0,preview:X(a.flags),isSigned:!!W.signature,queryContext:U}}let K=class{constructor($,F,U,Y,W,le,ae,me){this.k=F,this.l=U,this.n=Y,this.o=W,this.q=le,this.u=ae,this.w=me;const de=ae.extensionsGallery,ge=de?.servicePPEUrl&&me.getValue("_extensionsGallery.enablePPE");this.d=ge?de.servicePPEUrl:de?.serviceUrl,this.g=ge?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,p.$qp)(ae.version,ae,this.n,this.w,this.q,$,this.o)}x($=""){return`${this.d}${$}`}isEnabled(){return!!this.d}async getExtensions($,F,U){const Y=D.CancellationToken.isCancellationToken(F)?{}:F,W=D.CancellationToken.isCancellationToken(F)?F:U,le=[],ae=[],me=[],de=[];let ge=!0;for(const we of $){we.uuid?ae.push(we.uuid):le.push(we.id);const be=!!(we.version||we.preRelease);me.push({id:we.id,uuid:we.uuid,includePreRelease:be}),we.version&&de.push({id:we.id,uuid:we.uuid,version:we.version}),ge=ge&&!!we.hasPreRelease&&!be}if(!ae.length&&!le.length)return[];let fe=new w().withPage(1,$.length);ae.length&&(fe=fe.withFilter(n.ExtensionId,...ae)),le.length&&(fe=fe.withFilter(n.ExtensionName,...le)),(Y.queryAllVersions||ge)&&(fe=fe.withFlags(fe.flags,t.IncludeVersions)),Y.source&&(fe=fe.withSource(Y.source));const{extensions:he}=await this.z(fe,{targetPlatform:Y.targetPlatform??s,includePreRelease:me,versions:de,compatible:!!Y.compatible},W);return Y.source&&he.forEach((we,be)=>J(we,be,Y.source)),he}async getCompatibleExtension($,F,U){if((0,O.$ko)($.allTargetPlatforms,U))return null;if(await this.isExtensionCompatible($,F,U))return $;const Y=new w().withFlags(t.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,$.identifier.uuid),{extensions:W}=await this.z(Y,{targetPlatform:U,compatible:!0,includePreRelease:F},D.CancellationToken.None);return W[0]||null}async isExtensionCompatible($,F,U){if(!(0,O.$lo)($.properties.targetPlatform,$.allTargetPlatforms,U)||!F&&$.properties.isPreReleaseVersion)return!1;let Y=$.properties.engine;if(!Y){const W=await this.getManifest($,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");Y=W.engines.vscode}return(0,f.$8o)(Y,this.u.version,this.u.date)}async y($,F,U,Y,W){if(!(0,O.$lo)(M($),Y,W)||F!=="any"&&ce($)!==(F==="prerelease"))return!1;if(U)try{const le=await this.E($);if(!(0,f.$8o)(le,this.u.version,this.u.date))return!1}catch(le){return this.l.error(`Error while getting the engine for the version ${$.version}.`,(0,j.$0)(le)),!1}return!0}async query($,F){let U=$.text||"";const Y=$.pageSize??50;let W=new w().withPage(1,Y);U?(U=U.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Category,he||fe),"")),U=U.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,fe,he)=>(W=W.withFilter(n.Tag,he||fe),"")),U=U.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(n.Featured),"")),U=U.trim(),U&&(U=U.length<200?U:U.substring(0,200),W=W.withFilter(n.SearchText,U)),W=W.withSortBy(0)):$.ids?W=W.withFilter(n.ExtensionId,...$.ids):$.names?W=W.withFilter(n.ExtensionName,...$.names):W=W.withSortBy(4),typeof $.sortBy=="number"&&(W=W.withSortBy($.sortBy)),typeof $.sortOrder=="number"&&(W=W.withSortOrder($.sortOrder)),$.source&&(W=W.withSource($.source));const le=async(ge,fe)=>{const{extensions:he,total:we}=await this.z(ge,{targetPlatform:s,compatible:!1,includePreRelease:!!$.includePreRelease},fe);return he.forEach((be,ke)=>J(be,(ge.pageNumber-1)*ge.pageSize+ke,$.source)),{extensions:he,total:we}},{extensions:ae,total:me}=await le(W,F),de=async(ge,fe)=>{if(fe.isCancellationRequested)throw new j.$5;const{extensions:he}=await le(W.withPage(ge+1),fe);return he};return{firstPage:ae,total:me,pageSize:W.pageSize,getPage:de}}async z($,F,U){const Y=$.flags;$.flags&t.IncludeLatestVersionOnly&&$.flags&t.IncludeVersions&&($=$.withFlags($.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!($.flags&t.IncludeLatestVersionOnly)&&!($.flags&t.IncludeVersions)&&($=$.withFlags($.flags,t.IncludeLatestVersionOnly)),F.versions?.length&&($=$.withFlags($.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),$=$.withFlags($.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:W,total:le,context:ae}=await this.B($,U);if(!($.flags&t.IncludeLatestVersionOnly)){const fe=[];for(const he of W){const we=await this.A(he,F,ae);we&&fe.push(we)}return{extensions:fe,total:le}}const de=[],ge=new Map;for(let fe=0;fe<W.length;fe++){const he=W[fe],we={id:(0,g.$Uo)(he.publisher.publisherName,he.extensionName),uuid:he.extensionId},be=(0,b.$Mf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(Te=>(0,g.$Po)(Te,we))?.includePreRelease;if(F.compatible&&(0,O.$ko)(C(he),F.targetPlatform))continue;const ke=await this.A(he,F,ae);!ke||ke.properties.isPreReleaseVersion&&(!be||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==F.targetPlatform&&ke.hasPreReleaseVersion?ge.set(he.extensionId,fe):de.push([fe,ke])}if(ge.size){const fe=new y.$Pd,he=new w().withFlags(Y&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,ge.size).withFilter(n.ExtensionId,...ge.keys()),{extensions:we}=await this.z(he,F,U);this.o.publicLog2("galleryService:additionalQuery",{duration:fe.elapsed(),count:ge.size});for(const be of we){const ke=ge.get(be.identifier.uuid);de.push([ke,be])}}return{extensions:de.sort((fe,he)=>fe[0]-he[0]).map(([,fe])=>fe),total:le}}async A($,F,U){const Y={id:(0,g.$Uo)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},W=F.versions?.find(de=>(0,g.$Po)(de,Y))?.version,le=(0,b.$Mf)(F.includePreRelease)?F.includePreRelease:!!F.includePreRelease.find(de=>(0,g.$Po)(de,Y))?.includePreRelease,ae=C($),me=V($.versions,F.targetPlatform);if(F.compatible&&(0,O.$ko)(ae,F.targetPlatform))return null;for(let de=0;de<me.length;de++){const ge=me[de];if(!(W&&ge.version!==W)){if(await this.y(ge,le?"any":"release",F.compatible,ae,F.targetPlatform))return Q($,ge,ae,U);if(W&&ge.version===W)return null}}return W||F.compatible?null:Q($,$.versions[0],ae)}async B($,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");$=$.withFlags($.flags,t.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(t.Unpublished));const U=await this.j,Y=JSON.stringify($.raw),W={...U,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Y.length)},le=new y.$Pd;let ae,me,de=0;try{if(ae=await this.k.request({type:"POST",url:this.g&&$.criteria.some(fe=>fe.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:Y,headers:W},F),ae.res.statusCode&&ae.res.statusCode>=400&&ae.res.statusCode<500)return{galleryExtensions:[],total:de};const ge=await(0,u.$cp)(ae);if(ge){const fe=ge.results[0],he=fe.extensions,we=fe.resultMetadata&&fe.resultMetadata.filter(be=>be.metadataType==="ResultCount")[0];return de=we&&we.metadataItems.filter(be=>be.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:de,context:{[o]:ae.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch(ge){throw me=ge,ge}finally{this.o.publicLog2("galleryService:query",{...$.telemetryData,requestBodySize:String(Y.length),duration:le.elapsed(),success:!!ae&&(0,u.$$o)(ae),responseBodySize:ae?.res.headers["Content-Length"],statusCode:ae?String(ae.res.statusCode):void 0,errorCode:me?(0,j.$4)(me)?"canceled":(0,j.$0)(me).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(de)})}}async reportStatistic($,F,U,Y){if(!this.isEnabled())return;const W=N.$o?this.x(`/itemName/${$}.${F}/version/${U}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${$}/extensions/${F}/${U}/stats?statType=${Y}`),le=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",me={...await this.j,Accept:le};try{await this.k.request({type:"POST",url:W,headers:me},D.CancellationToken.None)}catch{}}async download($,F,U){this.l.trace("ExtensionGalleryService#download",$.identifier.id);const Y=(0,g.$Xo)($),W=new Date().getTime(),le=fe=>this.o.publicLog("galleryService:downloadVSIX",{...Y,duration:fe}),ae=U===2?"install":U===3?"update":"",me=ae?{uri:`${$.assets.download.uri}${h.URI.parse($.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${$.assets.download.fallbackUri}${h.URI.parse($.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:$.assets.download,de=$.queryContext?.[o]?{[o]:$.queryContext[o]}:void 0,ge=await this.D(me,de?{headers:de}:void 0);await this.q.writeFile(F,ge.stream),le(new Date().getTime()-W)}async downloadSignatureArchive($,F){if(!$.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",$.identifier.id);const U=await this.D($.assets.signature);await this.q.writeFile(F,U.stream)}async getReadme($,F){if($.assets.readme){const U=await this.D($.assets.readme,{},F);return await(0,u.$bp)(U)||""}return""}async getManifest($,F){if($.assets.manifest){const U=await this.D($.assets.manifest,{},F),Y=await(0,u.$bp)(U);return Y?JSON.parse(Y):null}return null}async C($,F){const U=re($,r.Manifest);if(!U)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},W=await this.D(U,{headers:Y});return await(0,u.$cp)(W)}async getCoreTranslation($,F){const U=$.assets.coreTranslations.filter(Y=>Y[0]===F.toUpperCase())[0];if(U){const Y=await this.D(U[1]),W=await(0,u.$bp)(Y);return W?JSON.parse(W):null}return null}async getChangelog($,F){if($.assets.changelog){const U=await this.D($.assets.changelog,{},F);return await(0,u.$bp)(U)||""}return""}async getAllCompatibleVersions($,F,U){let Y=new w().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);$.identifier.uuid?Y=Y.withFilter(n.ExtensionId,$.identifier.uuid):Y=Y.withFilter(n.ExtensionName,$.identifier.id);const{galleryExtensions:W}=await this.B(Y,D.CancellationToken.None);if(!W.length)return[];const le=C(W[0]);if((0,O.$ko)(le,U))return[];const ae=[];await Promise.all(W[0].versions.map(async ge=>{try{await this.y(ge,F?"any":"release",!0,le,U)&&ae.push(ge)}catch{}}));const me=[],de=new Set;for(const ge of V(ae,U))de.has(ge.version)||(de.add(ge.version),me.push({version:ge.version,date:ge.lastUpdated,isPreReleaseVersion:ce(ge)}));return me}async D($,F={},U=D.CancellationToken.None){const Y=await this.j,W={type:"GET"},le={...Y,...F.headers||{}};F={...F,...W,headers:le};const ae=$.uri,me=$.fallbackUri,de={...F,url:ae};try{const ge=await this.k.request(de,U);if(ge.res.statusCode===200)return ge;const fe=await(0,u.$bp)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${fe}`)}catch(ge){if((0,j.$4)(ge))throw ge;const fe=(0,j.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{url:ae,message:fe});const he={...F,url:me};return this.k.request(he,U)}}async E($){let F=ue($);if(!F){const U=await this.C($,D.CancellationToken.None);if(!U)throw new Error("Manifest was not found");F=U.engines.vscode}return F}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const $=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if($.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,u.$cp)($),U=[],Y={},W=[];if(F){for(const le of F.malicious)U.push({id:le});if(F.migrateToPreRelease)for(const[le,ae]of Object.entries(F.migrateToPreRelease))(!ae.engine||(0,f.$8o)(ae.engine,this.u.version,this.u.date))&&(Y[le.toLowerCase()]={disallowInstall:!0,extension:{id:ae.id,displayName:ae.displayName,autoMigrate:{storage:!!ae.migrateStorage},preRelease:!0}});if(F.deprecated)for(const[le,ae]of Object.entries(F.deprecated))ae&&(Y[le.toLowerCase()]=(0,b.$Mf)(ae)?{}:ae);if(F.search)for(const le of F.search)W.push(le)}return{malicious:U,deprecated:Y,search:W}}};K=pe([ie(1,u.$9o),ie(2,v.$lj),ie(3,P.$$h),ie(4,m.$sl),ie(5,E.$ok),ie(6,d.$Dj),ie(7,c.$xi)],K);let T=class extends K{constructor($,F,U,Y,W,le,ae,me){super($,F,U,Y,W,le,ae,me)}};e.$sp=T,e.$sp=T=pe([ie(0,I.$jp),ie(1,u.$9o),ie(2,v.$lj),ie(3,P.$$h),ie(4,m.$sl),ie(5,E.$ok),ie(6,d.$Dj),ie(7,c.$xi)],T);let z=class extends K{constructor($,F,U,Y,W,le,ae){super(void 0,$,F,U,Y,W,le,ae)}};e.$tp=z,e.$tp=z=pe([ie(0,u.$9o),ie(1,v.$lj),ie(2,P.$$h),ie(3,m.$sl),ie(4,E.$ok),ie(5,d.$Dj),ie(6,c.$xi)],z)}),define(te[162],ne([0,1,11,18,12,6,140,22,23,3,68]),function(G,e,L,D,j,N,A,b,h,c,P){"use strict";var O,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$iO=e.$hO=e.$gO=void 0;let f=class extends h.$4k{static{O=this}static{this.a="profileAssociationsMigration"}constructor(u,p,I,m,y){super(I,m,p,y),this.U=u,this.W=I}O(){return this.U.getItem(O.b,[]).map(p=>({...p,location:(0,c.$Gf)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):L.URI.revive(p.location)}))}Q(){const u=this.U.getItem(O.c,{});return this.U.getItem(O.a,!1)?u:this.N(u)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$gO=f,e.$gO=f=O=pe([ie(0,A.$bO),ie(1,b.$Yk),ie(2,D.$_h),ie(3,j.$ok),ie(4,N.$lj)],f);let E=g=class extends f{constructor(u,p,I,m,y){super(u,p,I,m,y),this.$=u}P(u){u.length?this.$.setItem(g.b,u.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem(g.b)}O(){const u=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(u),this.$.setItem("userDataProfilesMigration",!0)),u}R(u){u.emptyWindows||u.workspaces?this.$.setItem(g.c,u):this.$.removeItem(g.c)}Q(){const u="workspaceAndProfileInfo",p=this.$.getItem(u,void 0);if(p){this.$.removeItem(u);const m=p.reduce((y,{workspace:s,profile:o})=>(y[L.URI.revive(s).toString()]=L.URI.revive(o).toString(),y),{});this.$.setItem(g.c,{workspaces:m})}const I=super.Q();return this.$.getItem(g.a,!1)||(this.R(I),this.$.setItem(g.a,!0)),I}};e.$hO=E,e.$hO=E=g=pe([ie(0,A.$cO),ie(1,b.$Yk),ie(2,D.$_h),ie(3,j.$ok),ie(4,N.$lj)],E);let v=class extends E{constructor(u,p,I,m){super(new P.$fO(0,p,m,I),u,p,I,m)}async init(){return await this.$.init(),super.init()}};e.$iO=v,e.$iO=v=pe([ie(0,b.$Yk),ie(1,D.$_h),ie(2,j.$ok),ie(3,N.$lj)],v)}),define(te[163],ne([0,1,138,8,14,9,3,25,18,139,6,44,137,175]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;let E=class extends O.$0o{constructor(p,I,m,y){super(y),this.m=p,this.n=I,this.r=m,this.s(),this.B(p.onDidChangeConfiguration(s=>{s.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,I){const{f:m,g:y}=this;let s;try{s=await(0,c.$0l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const o={...process.env,...s},t=p.agent?p.agent:await(0,g.$br)(p.url||"",o,{proxyUrl:m,strictSSL:y});return p.agent=t,p.strictSSL=y,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>d(p,I))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((I,m)=>{G(["@vscode/proxy-agent"],I,m)})).loadSystemCertificates({log:this.r})}};e.$cr=E,e.$cr=E=pe([ie(0,b.$xi),ie(1,h.$_h),ie(2,P.$lj),ie(3,P.$mj)],E);async function v(u){return((0,L.parse)(u.url).protocol==="https:"?await new Promise((m,y)=>{G(["https"],m,y)}):await new Promise((m,y)=>{G(["http"],m,y)})).request}async function d(u,p){return D.Promises.withAsyncBody(async(I,m)=>{const y=(0,L.parse)(u.url),s=u.getRawRequest?u.getRawRequest(u):await v(u),o={hostname:y.hostname,port:y.port?parseInt(y.port):y.protocol==="https:"?443:80,protocol:y.protocol,path:y.path,method:u.type||"GET",headers:u.headers,agent:u.agent,rejectUnauthorized:(0,A.$Mf)(u.strictSSL)?u.strictSSL:!0};u.user&&u.password&&(o.auth=u.user+":"+u.password);const t=s(o,i=>{const n=(0,A.$Kf)(u.followRedirects)?u.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...u,url:i.headers.location,followRedirects:n-1},p).then(I,m);else{let r=i;!u.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,f.createGunzip)())),I({res:i,stream:(0,j.$we)(r)})}});t.on("error",m),u.timeout&&t.setTimeout(u.timeout),u.isChromiumNetwork&&t.removeHeader("Content-Length"),u.data&&typeof u.data=="string"&&t.write(u.data),t.end(),p.onCancellationRequested(()=>{t.abort(),m(new N.$5)})})}e.$dr=d}),define(te[176],ne([0,1,33,8,34,9,2,15,16,13,35,11,24,25,134,59,136,18,112,161,21,60,141,40,51,157,159,12,124,126,50,122,63,64,145,6,130,38,131,148,32,44,163,68,69,26,147,39,149,150,22,152,23,162,151,158,127,129,5,153]),function(G,e,L,D,j,N,A,b,h,c,P,O,g,f,E,v,d,u,p,I,m,y,s,o,t,i,n,r,l,S,k,w,R,H,ee,_,re,se,ue,ce,oe,B,X,M,C,V,J,Q,K,T,z,a,$,F,U,Y,W,le,ae,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class de extends A.$Tc{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,we]=await this.f();return he.invokeFunction(async be=>{const ke=be.get(_.$lj),Te=be.get(r.$ok),q=be.get(u.$_h),Z=be.get($.$1k);ke.info("CLI main",this.b),this.g(ke),await this.h(q,Te,Z,he),await Promise.all(we.map(x=>{(0,D.$Vg)(x.flush(),1e3)}))})}async f(){const he=new R.$2h,we={_serviceBrand:void 0,...ce.default};he.set(oe.$Dj,we);const be=new p.$zm(this.b,we);he.set(u.$_h,be),await Promise.all([be.appSettingsHome.with({scheme:b.Schemas.file}).fsPath,be.extensionsPath].map(Ne=>Ne?g.Promises.mkdir(Ne,{recursive:!0}):void 0));const ke=new le.$aO((0,_.$zj)(be),be.logsHome);he.set(_.$mj,ke);const Te=this.B(ke.createLogger("cli",{name:(0,ae.localize)(0,null)})),q=[];ke.getLogLevel()===_.LogLevel.Trace&&q.push(new _.$tj(ke.getLogLevel()));const Z=this.B(new W.$kO(Te,q));he.set(_.$lj,Z);const x=this.B(new l.$4p(Z));he.set(r.$ok,x);const $e=this.B(new S.$qq(Z));x.registerProvider(b.Schemas.file,$e);const ye=new a.$Qr(x);he.set(z.$Yk,ye);const je=new M.$eO(1,be,Z,x),Pe=new F.$gO(je,ye,be,x,Z);he.set($.$1k,Pe),x.registerProvider(b.Schemas.vscodeUserData,new me.$I$b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Pe,ye,Z));const Le=c.$i&&we.win32RegValueName?this.B(new ue.$G$b(Z,we.win32RegValueName)):be.policyFile?this.B(new re.$H$b(be.policyFile,x,Z)):new se.$An;he.set(se.$yn,Le);const Ie=this.B(new E.$1n(Pe.defaultProfile.settingsResource,x,Le,Z));he.set(f.$xi,Ie),await Promise.all([je.init(),Ie.initialize()]);let Ae;try{Ae=await(0,U.$k$b)(je,Z)}catch(Ne){Ne.code!=="ENOENT"&&Z.error(Ne)}const Ce=await(0,U.$l$b)(je,Z);Pe.init(),he.set(z.$Yk,new a.$Qr(x));const Oe=new X.$cr(Ie,be,Z,ke);he.set(B.$9o,Oe),he.set(v.$5n,new k.$1h(d.$zO,void 0,!0)),he.set(o.$Kp,new k.$1h(Y.$jO,void 0,!0)),he.set(t.$Op,new k.$1h(n.$h$b,void 0,!0)),he.set(y.$up,new k.$1h(y.$vp,void 0,!0)),he.set(i.$Yp,new k.$1h(i.$Zp,void 0,!0)),he.set(m.$no,new k.$1h(I.$tp,void 0,!0)),he.set(H.$9q,new k.$1h(ee.$$q,void 0,!1));const De=[],Fe=(0,Q.$Mo)(we,Ie);if((0,Q.$Ho)(we,be)){we.aiConfig&&we.aiConfig.ariaKey&&De.push(new K.$$N(Oe,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const Ne={appenders:De,sendErrorTelemetry:!1,commonProperties:(0,C.$xo)((0,L.release)(),(0,L.hostname)(),process.arch,we.commit,we.version,Ae,Ce,Fe),piiPaths:(0,Q.$No)(be)};he.set(V.$sl,new k.$1h(J.$er,[Ne],!1))}else he.set(V.$sl,Q.$Bo);return[new w.$tq(he),De]}g(he){(0,N.setUnexpectedErrorHandler)(we=>{const be=(0,j.$Oi)(we,!0);be&&he.error(`[uncaught exception in CLI]: ${be}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async h(he,we,be,ke){let Te;if(he.args.profile&&(Te=be.profiles.find(Z=>Z.name===he.args.profile),!Te))throw new Error(`Profile '${he.args.profile}' not found.`);const q=(Te??be.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(s.$wp,new _.$tj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,q);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Z={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:q};return ke.createInstance(s.$wp,new _.$tj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Z,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(s.$wp,new _.$tj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,q);if(this.b["locate-extension"])return ke.createInstance(s.$wp,new _.$tj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.$5$b)(he.appRoot,he.extensionsPath))}}j(he){return he.map(we=>/\.vsix$/i.test(we)?O.URI.file((0,h.$ic)(we)?we:(0,h.$jc)((0,P.cwd)(),we)):we)}}async function ge(fe){const he=new de(fe);try{await he.run()}finally{he.dispose()}}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1cfc62d46e6b9dd217cd485d7d4591136f421d70/core/vs/code/node/cliProcessMain.js.map
