/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/platform/environment/common/environment","vs/base/common/buffer","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/arrays","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=le[ne[D]];return e};define(le[123],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const A=new Map,j=new Map,O=new Map,R=new Map;function k(c,$){c.has($.detail)||c.set($.detail,-$.timestamp)}function g(c,$){const y=c.get($.detail);y&&(y>=0||c.set($.detail,y+$.timestamp))}let C=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(C=ne.getStats().slice(0).sort((c,$)=>c.timestamp-$.timestamp));for(const c of C)switch(c.type){case 10:k(A,c);break;case 11:case 12:g(A,c);break;case 21:k(j,c);break;case 22:g(j,c);break;case 33:k(O,c);break;case 34:g(O,c);break;case 31:k(R,c);break;case 32:g(R,c);break}let S=0;O.forEach(c=>S+=c);function d(c){const $=[];return c.forEach((y,b)=>$.push([b,y])),$}return{amdLoad:d(A),amdInvoke:d(j),nodeRequire:d(O),nodeEval:d(R),nodeRequireTotal:S}}static toMarkdownTable(A,j){let O="";const R=[];return A.forEach((k,g)=>{R[g]=k.length}),j.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;R[C]=Math.max(S,R[C])})}),A.forEach((k,g)=>{O+=`| ${k+" ".repeat(R[g]-k.toString().length)} `}),O+=`|
`,A.forEach((k,g)=>{O+=`| ${"-".repeat(R[g])} `}),O+=`|
`,j.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(O+=`| ${g+" ".repeat(R[C]-g.toString().length)} `)}),O+=`|
`}),O}}e.$U=D}),define(le[124],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function D(y,b,l){const f=N(y,b);if(f!==-1)return y[f]}e.$fb=D;function N(y,b,l=y.length-1){for(let f=l;f>=0;f--){const m=y[f];if(b(m))return f}return-1}e.$gb=N;function A(y,b){const l=j(y,b);return l===-1?void 0:y[l]}e.$hb=A;function j(y,b,l=0,f=y.length){let m=l,h=f;for(;m<h;){const E=Math.floor((m+h)/2);b(y[E])?m=E+1:h=E}return m-1}e.$ib=j;function O(y,b){const l=R(y,b);return l===y.length?void 0:y[l]}e.$jb=O;function R(y,b,l=0,f=y.length){let m=l,h=f;for(;m<h;){const E=Math.floor((m+h)/2);b(y[E])?h=E:m=E+1}return m}e.$kb=R;function k(y,b,l=0,f=y.length){const m=R(y,b,l,f);return m===y.length?-1:m}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(b){this.e=b,this.c=0}findLastMonotonous(b){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!b(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=b}const l=j(this.e,b,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$mb=g;function C(y,b){if(y.length===0)return;let l=y[0];for(let f=1;f<y.length;f++){const m=y[f];b(m,l)>0&&(l=m)}return l}e.$nb=C;function S(y,b){if(y.length===0)return;let l=y[0];for(let f=1;f<y.length;f++){const m=y[f];b(m,l)>=0&&(l=m)}return l}e.$ob=S;function d(y,b){return C(y,(l,f)=>-b(l,f))}e.$pb=d;function c(y,b){if(y.length===0)return-1;let l=0;for(let f=1;f<y.length;f++){const m=y[f];b(m,y[l])>0&&(l=f)}return l}e.$qb=c;function $(y,b){for(const l of y){const f=b(l);if(f!==void 0)return f}}e.$rb=$}),define(le[125],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function D(O,R){const k=Object.create(null);for(const g of O){const C=R(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$K=D;function N(O,R){const k=[],g=[];for(const C of O)R.has(C)||k.push(C);for(const C of R)O.has(C)||g.push(C);return{removed:k,added:g}}e.$L=N;function A(O,R){const k=[],g=[];for(const[C,S]of O)R.has(C)||k.push(S);for(const[C,S]of R)O.has(C)||g.push(S);return{removed:k,added:g}}e.$M=A;function j(O,R){const k=new Set;for(const g of R)O.has(g)&&k.add(g);return k}e.$N=j}),define(le[84],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=void 0;function D(O){return(R,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=O(S,k)}}function N(O,R,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${R}`;k[g]=function(...d){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,d)}),this[S]}}e.$vh=N;function A(O,R,k){return D((g,C)=>{const S=`$debounce$${C}`,d=`$debounce$result$${C}`;return function(...c){this[d]||(this[d]=k?k():void 0),clearTimeout(this[S]),R&&(this[d]=R(this[d],...c),c=[this[d]]),this[S]=setTimeout(()=>{g.apply(this,c),this[d]=k?k():void 0},O)}})}e.$wh=A;function j(O,R,k){return D((g,C)=>{const S=`$throttle$timer$${C}`,d=`$throttle$result$${C}`,c=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...y){if(this[d]||(this[d]=k?k():void 0),(this[c]===null||this[c]===void 0)&&(this[c]=-Number.MAX_VALUE),R&&(this[d]=R(this[d],...y)),this[$])return;const b=this[c]+O;b<=Date.now()?(this[c]=Date.now(),g.apply(this,[this[d]]),this[d]=k?k():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[c]=Date.now(),g.apply(this,[this[d]]),this[d]=k?k():void 0},b-Date.now()))}})}e.$xh=j}),define(le[7],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class D{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?m.isErrorNoTelemetry(n)?new m(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(o=>{o(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=D,e.$X=new D;function N(E){e.$X.setUnexpectedErrorHandler(E)}e.setUnexpectedErrorHandler=N;function A(E){if(!E||typeof E!="object")return!1;const n=E;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}e.$Z=A;function j(E){g(E)||e.$X.onUnexpectedError(E)}e.$1=j;function O(E){g(E)||e.$X.onUnexpectedExternalError(E)}e.$2=O;function R(E){if(E instanceof Error){const{name:n,message:o}=E,s=E.stacktrace||E.stack;return{$isError:!0,name:n,message:o,stack:s,noTelemetry:m.isErrorNoTelemetry(E)}}return E}e.$3=R;const k="Canceled";function g(E){return E instanceof C?!0:E instanceof Error&&E.name===k&&E.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const E=new Error(k);return E.name=E.message,E}e.$6=S;function d(E){return E?new Error(`Illegal argument: ${E}`):new Error("Illegal argument")}e.$7=d;function c(E){return E?new Error(`Illegal state: ${E}`):new Error("Illegal state")}e.$8=c;class $ extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function y(E){return E?E.message?E.message:E.stack?E.stack.split(`
`)[0]:String(E):"Error"}e.$0=y;class b extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=b;class l extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=l;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class m extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof m)return n;const o=new m;return o.message=n.message,o.stack=n.stack,o}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=m;class h extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,h.prototype)}}e.$cb=h}),define(le[18],he([0,1,7,124]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function A(q,ee=0){return q[q.length-(1+ee)]}e.$sb=A;function j(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.$tb=j;function O(q,ee,W=(Y,ie)=>Y===ie){if(q===ee)return!0;if(!q||!ee||q.length!==ee.length)return!1;for(let Y=0,ie=q.length;Y<ie;Y++)if(!W(q[Y],ee[Y]))return!1;return!0}e.$ub=O;function R(q,ee){const W=q.length-1;ee<W&&(q[ee]=q[W]),q.pop()}e.$vb=R;function k(q,ee,W){return g(q.length,Y=>W(q[Y],ee))}e.$wb=k;function g(q,ee){let W=0,Y=q-1;for(;W<=Y;){const ie=(W+Y)/2|0,ce=ee(ie);if(ce<0)W=ie+1;else if(ce>0)Y=ie-1;else return ie}return-(W+1)}e.$xb=g;function C(q,ee,W){if(q=q|0,q>=ee.length)throw new TypeError("invalid index");const Y=ee[Math.floor(ee.length*Math.random())],ie=[],ce=[],ae=[];for(const fe of ee){const de=W(fe,Y);de<0?ie.push(fe):de>0?ce.push(fe):ae.push(fe)}return q<ie.length?C(q,ie,W):q<ie.length+ae.length?ae[0]:C(q-(ie.length+ae.length),ce,W)}e.$yb=C;function S(q,ee){const W=[];let Y;for(const ie of q.slice(0).sort(ee))!Y||ee(Y[0],ie)!==0?(Y=[ie],W.push(Y)):Y.push(ie);return W}e.$zb=S;function*d(q,ee){let W,Y;for(const ie of q)Y!==void 0&&ee(Y,ie)?W.push(ie):(W&&(yield W),W=[ie]),Y=ie;W&&(yield W)}e.$Ab=d;function c(q,ee){for(let W=0;W<=q.length;W++)ee(W===0?void 0:q[W-1],W===q.length?void 0:q[W])}e.$Bb=c;function $(q,ee){for(let W=0;W<q.length;W++)ee(W===0?void 0:q[W-1],q[W],W+1===q.length?void 0:q[W+1])}e.$Cb=$;function y(q,ee,W){const Y=[];function ie(fe,de,we){if(de===0&&we.length===0)return;const Ee=Y[Y.length-1];Ee&&Ee.start+Ee.deleteCount===fe?(Ee.deleteCount+=de,Ee.toInsert.push(...we)):Y.push({start:fe,deleteCount:de,toInsert:we})}let ce=0,ae=0;for(;;){if(ce===q.length){ie(ce,0,ee.slice(ae));break}if(ae===ee.length){ie(ce,q.length-ce,[]);break}const fe=q[ce],de=ee[ae],we=W(fe,de);we===0?(ce+=1,ae+=1):we<0?(ie(ce,1,[]),ce+=1):we>0&&(ie(ce,0,[de]),ae+=1)}return Y}e.$Db=y;function b(q,ee,W){const Y=y(q,ee,W),ie=[],ce=[];for(const ae of Y)ie.push(...q.slice(ae.start,ae.start+ae.deleteCount)),ce.push(...ae.toInsert);return{removed:ie,added:ce}}e.$Eb=b;function l(q,ee,W){if(W===0)return[];const Y=q.slice(0,W).sort(ee);return m(q,ee,Y,W,q.length),Y}e.top=l;function f(q,ee,W,Y,ie){return W===0?Promise.resolve([]):new Promise((ce,ae)=>{(async()=>{const fe=q.length,de=q.slice(0,W).sort(ee);for(let we=W,Ee=Math.min(W+Y,fe);we<fe;we=Ee,Ee=Math.min(Ee+Y,fe)){if(we>W&&await new Promise(Re=>setTimeout(Re)),ie&&ie.isCancellationRequested)throw new D.$5;m(q,ee,de,we,Ee)}return de})().then(ce,ae)})}e.$Gb=f;function m(q,ee,W,Y,ie){for(const ce=W.length;Y<ie;Y++){const ae=q[Y];if(ee(ae,W[ce-1])<0){W.pop();const fe=(0,N.$kb)(W,de=>ee(ae,de)<0);W.splice(fe,0,ae)}}}function h(q){return q.filter(ee=>!!ee)}e.$Hb=h;function E(q){let ee=0;for(let W=0;W<q.length;W++)q[W]&&(q[ee]=q[W],ee+=1);q.length=ee}e.$Ib=E;function n(q,ee,W){q.splice(W,0,q.splice(ee,1)[0])}e.$Jb=n;function o(q){return!Array.isArray(q)||q.length===0}e.$Kb=o;function s(q){return Array.isArray(q)&&q.length>0}e.$Lb=s;function i(q,ee=W=>W){const W=new Set;return q.filter(Y=>{const ie=ee(Y);return W.has(ie)?!1:(W.add(ie),!0)})}e.$Mb=i;function t(q){const ee=new Set;return W=>{const Y=q(W);return ee.has(Y)?!1:(ee.add(Y),!0)}}e.$Nb=t;function r(q,ee){return q.length>0?q[0]:ee}e.$Ob=r;function a(q,ee){return q.length>0?q[q.length-1]:ee}e.$Pb=a;function v(q,ee,W=(Y,ie)=>Y===ie){let Y=0;for(let ie=0,ce=Math.min(q.length,ee.length);ie<ce&&W(q[ie],ee[ie]);ie++)Y++;return Y}e.$Qb=v;function w(q){return[].concat(...q)}e.$Rb=w;function u(q,ee){let W=typeof ee=="number"?q:0;typeof ee=="number"?W=q:(W=0,ee=q);const Y=[];if(W<=ee)for(let ie=W;ie<ee;ie++)Y.push(ie);else for(let ie=W;ie>ee;ie--)Y.push(ie);return Y}e.$Sb=u;function p(q,ee,W){return q.reduce((Y,ie)=>(Y[ee(ie)]=W?W(ie):ie,Y),Object.create(null))}e.$Tb=p;function I(q,ee){return q.push(ee),()=>T(q,ee)}e.$Ub=I;function T(q,ee){const W=q.indexOf(ee);if(W>-1)return q.splice(W,1),ee}e.$Vb=T;function F(q,ee,W){const Y=q.slice(0,ee),ie=q.slice(ee);return Y.concat(W,ie)}e.$Wb=F;function M(q,ee){let W;if(typeof ee=="number"){let Y=ee;W=()=>{const ie=Math.sin(Y++)*179426549;return ie-Math.floor(ie)}}else W=Math.random;for(let Y=q.length-1;Y>0;Y-=1){const ie=Math.floor(W()*(Y+1)),ce=q[Y];q[Y]=q[ie],q[ie]=ce}}e.$Xb=M;function z(q,ee){const W=q.indexOf(ee);W>-1&&(q.splice(W,1),q.unshift(ee))}e.$Yb=z;function Z(q,ee){const W=q.indexOf(ee);W>-1&&(q.splice(W,1),q.push(ee))}e.$Zb=Z;function J(q,ee){for(const W of ee)q.push(W)}e.$1b=J;function x(q,ee){return Array.isArray(q)?q.map(ee):ee(q)}e.$2b=x;function G(q){return Array.isArray(q)?q:[q]}e.$3b=G;function Q(q){return q[Math.floor(Math.random()*q.length)]}e.$4b=Q;function V(q,ee,W){const Y=te(q,ee),ie=q.length,ce=W.length;q.length=ie+ce;for(let ae=ie-1;ae>=Y;ae--)q[ae+ce]=q[ae];for(let ae=0;ae<ce;ae++)q[ae+Y]=W[ae]}e.$5b=V;function B(q,ee,W,Y){const ie=te(q,ee);let ce=q.splice(ie,W);return ce===void 0&&(ce=[]),V(q,ie,Y),ce}e.$6b=B;function te(q,ee){return ee<0?Math.max(ee+q.length,0):Math.min(ee,q.length)}var se;(function(q){function ee(ce){return ce<0}q.isLessThan=ee;function W(ce){return ce<=0}q.isLessThanOrEqual=W;function Y(ce){return ce>0}q.isGreaterThan=Y;function ie(ce){return ce===0}q.isNeitherLessOrGreaterThan=ie,q.greaterThan=1,q.lessThan=-1,q.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function _(q,ee){return(W,Y)=>ee(q(W),q(Y))}e.$7b=_;function oe(...q){return(ee,W)=>{for(const Y of q){const ie=Y(ee,W);if(!se.isNeitherLessOrGreaterThan(ie))return ie}return se.neitherLessOrGreaterThan}}e.$8b=oe;const K=(q,ee)=>q-ee;e.$9b=K;const U=(q,ee)=>(0,e.$9b)(q?1:0,ee?1:0);e.$0b=U;function P(q){return(ee,W)=>-q(ee,W)}e.$$b=P;class L{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let W=this.c;for(;W<this.g.length&&ee(this.g[W]);)W++;const Y=W===this.c?null:this.g.slice(this.c,W);return this.c=W,Y}takeFromEndWhile(ee){let W=this.d;for(;W>=0&&ee(this.g[W]);)W--;const Y=W===this.d?null:this.g.slice(W+1,this.d+1);return this.d=W,Y}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const W=this.g.slice(this.c,this.c+ee);return this.c+=ee,W}}e.$_b=L;class H{static{this.empty=new H(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(W=>(ee(W),!0))}toArray(){const ee=[];return this.iterate(W=>(ee.push(W),!0)),ee}filter(ee){return new H(W=>this.iterate(Y=>ee(Y)?W(Y):!0))}map(ee){return new H(W=>this.iterate(Y=>W(ee(Y))))}some(ee){let W=!1;return this.iterate(Y=>(W=ee(Y),!W)),W}findFirst(ee){let W;return this.iterate(Y=>ee(Y)?(W=Y,!1):!0),W}findLast(ee){let W;return this.iterate(Y=>(ee(Y)&&(W=Y),!0)),W}findLastMaxBy(ee){let W,Y=!0;return this.iterate(ie=>((Y||se.isGreaterThan(ee(ie,W)))&&(Y=!1,W=ie),!0)),W}}e.$ac=H}),define(le[126],he([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function N(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=N;function A(k,g="Unreachable"){throw new Error(g)}e.$6c=A;function j(k){if(!k)throw new D.$cb("Assertion Failed")}e.$7c=j;function O(k){if(!k()){debugger;k(),(0,D.$1)(new D.$cb("Assertion Failed"))}}e.$8c=O;function R(k,g){let C=0;for(;C<k.length-1;){const S=k[C],d=k[C+1];if(!g(S,d))return!1;C++}return!0}e.$9c=R}),define(le[85],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function D(N,A){const j=this;let O=!1,R;return function(){if(O)return R;if(O=!0,A)try{R=N.apply(j,arguments)}finally{A()}else R=N.apply(j,arguments);return R}}e.$db=D}),define(le[61],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function A(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}N.is=A;const j=Object.freeze([]);function O(){return j}N.empty=O;function*R(n){yield n}N.single=R;function k(n){return A(n)?n:R(n)}N.wrap=k;function g(n){return n||j}N.from=g;function*C(n){for(let o=n.length-1;o>=0;o--)yield n[o]}N.reverse=C;function S(n){return!n||n[Symbol.iterator]().next().done===!0}N.isEmpty=S;function d(n){return n[Symbol.iterator]().next().value}N.first=d;function c(n,o){for(const s of n)if(o(s))return!0;return!1}N.some=c;function $(n,o){for(const s of n)if(o(s))return s}N.find=$;function*y(n,o){for(const s of n)o(s)&&(yield s)}N.filter=y;function*b(n,o){let s=0;for(const i of n)yield o(i,s++)}N.map=b;function*l(...n){for(const o of n)yield*o}N.concat=l;function f(n,o,s){let i=s;for(const t of n)i=o(i,t);return i}N.reduce=f;function*m(n,o,s=n.length){for(o<0&&(o+=n.length),s<0?s+=n.length:s>n.length&&(s=n.length);o<s;o++)yield n[o]}N.slice=m;function h(n,o=Number.POSITIVE_INFINITY){const s=[];if(o===0)return[s,n];const i=n[Symbol.iterator]();for(let t=0;t<o;t++){const r=i.next();if(r.done)return[s,N.empty()];s.push(r.value)}return[s,{[Symbol.iterator](){return i}}]}N.consume=h;async function E(n){const o=[];for await(const s of n)o.push(s);return Promise.resolve(o)}N.asyncToArray=E})(D||(e.Iterable=D={}))}),define(le[35],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var A;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(A||(e.ParseErrorCode=A={}));var j;(function(n){n.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function O(n,o=!1){let s=0;const i=n.length;let t="",r=0,a=16,v=0;function w(z){let Z=0,J=0;for(;Z<z;){const x=n.charCodeAt(s);if(x>=48&&x<=57)J=J*16+x-48;else if(x>=65&&x<=70)J=J*16+x-65+10;else if(x>=97&&x<=102)J=J*16+x-97+10;else break;s++,Z++}return Z<z&&(J=-1),J}function u(z){s=z,t="",r=0,a=16,v=0}function p(){const z=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return v=3,n.substring(z,s);let Z=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;Z=s}else v=3;return n.substring(z,Z)}function I(){let z="",Z=s;for(;;){if(s>=i){z+=n.substring(Z,s),v=2;break}const J=n.charCodeAt(s);if(J===34){z+=n.substring(Z,s),s++;break}if(J===92){if(z+=n.substring(Z,s),s++,s>=i){v=2;break}switch(n.charCodeAt(s++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const G=w(4);G>=0?z+=String.fromCharCode(G):v=4;break}default:v=5}Z=s;continue}if(J>=0&&J<=31)if(k(J)){z+=n.substring(Z,s),v=2;break}else v=6;s++}return z}function T(){if(t="",v=0,r=s,s>=i)return r=i,a=17;let z=n.charCodeAt(s);if(R(z)){do s++,t+=String.fromCharCode(z),z=n.charCodeAt(s);while(R(z));return a=15}if(k(z))return s++,t+=String.fromCharCode(z),z===13&&n.charCodeAt(s)===10&&(s++,t+=`
`),a=14;switch(z){case 123:return s++,a=1;case 125:return s++,a=2;case 91:return s++,a=3;case 93:return s++,a=4;case 58:return s++,a=6;case 44:return s++,a=5;case 34:return s++,t=I(),a=10;case 47:{const Z=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<i&&!k(n.charCodeAt(s));)s++;return t=n.substring(Z,s),a=12}if(n.charCodeAt(s+1)===42){s+=2;const J=i-1;let x=!1;for(;s<J;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,x=!0;break}s++}return x||(s++,v=1),t=n.substring(Z,s),a=13}return t+=String.fromCharCode(z),s++,a=16}case 45:if(t+=String.fromCharCode(z),s++,s===i||!g(n.charCodeAt(s)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;s<i&&F(z);)s++,z=n.charCodeAt(s);if(r!==s){switch(t=n.substring(r,s),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(z),s++,a=16}}function F(z){if(R(z)||k(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let z;do z=T();while(z>=12&&z<=15);return z}return{setPosition:u,getPosition:()=>s,scan:o?M:T,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>s-r,getTokenError:()=>v}}e.$$m=O;function R(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function k(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var C;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(C||(C={}));function S(n,o){const s=[],i=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function v(w,u,p,I){r.value=w,r.offset=u,r.length=p,r.type=I,r.colonOffset=void 0,t=r}try{m(n,{onObjectBegin:(w,u)=>{if(o<=w)throw i;t=void 0,a=o>w,s.push("")},onObjectProperty:(w,u,p)=>{if(o<u||(v(w,u,p,"property"),s[s.length-1]=w,o<=u+p))throw i},onObjectEnd:(w,u)=>{if(o<=w)throw i;t=void 0,s.pop()},onArrayBegin:(w,u)=>{if(o<=w)throw i;t=void 0,s.push(0)},onArrayEnd:(w,u)=>{if(o<=w)throw i;t=void 0,s.pop()},onLiteralValue:(w,u,p)=>{if(o<u||(v(w,u,p,E(w)),o<=u+p))throw i},onSeparator:(w,u,p)=>{if(o<=u)throw i;if(w===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(w===","){const I=s[s.length-1];typeof I=="number"?s[s.length-1]=I+1:(a=!0,s[s.length-1]=""),t=void 0}}})}catch(w){if(w!==i)throw w}return{path:s,previousNode:t,isAtPropertyKey:a,matches:w=>{let u=0;for(let p=0;u<w.length&&p<s.length;p++)if(w[u]===s[p]||w[u]==="*")u++;else if(w[u]!=="**")return!1;return u===w.length}}}e.$_m=S;function d(n,o=[],s=j.DEFAULT){let i=null,t=[];const r=[];function a(w){Array.isArray(t)?t.push(w):i!==null&&(t[i]=w)}return m(n,{onObjectBegin:()=>{const w={};a(w),r.push(t),t=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const w=[];a(w),r.push(t),t=w,i=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(w,u,p)=>{o.push({error:w,offset:u,length:p})}},s),t[0]}e.$an=d;function c(n,o=[],s=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function r(w){return i.children.push(w),w}m(n,{onObjectBegin:w=>{i=r({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,u,p)=>{i=r({type:"property",offset:u,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:u,length:p,parent:i})},onObjectEnd:(w,u)=>{i.length=w+u-i.offset,i=i.parent,t(w+u)},onArrayBegin:(w,u)=>{i=r({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,u)=>{i.length=w+u-i.offset,i=i.parent,t(w+u)},onLiteralValue:(w,u,p)=>{r({type:E(w),offset:u,length:p,parent:i,value:w}),t(u+p)},onSeparator:(w,u,p)=>{i.type==="property"&&(w===":"?i.colonOffset=u:w===","&&t(u))},onError:(w,u,p)=>{o.push({error:w,offset:u,length:p})}},s);const v=i.children[0];return v&&delete v.parent,v}e.$bn=c;function $(n,o){if(!n)return;let s=n;for(const i of o)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let t=!1;for(const r of s.children)if(Array.isArray(r.children)&&r.children[0].value===i){s=r.children[1],t=!0;break}if(!t)return}else{const t=i;if(s.type!=="array"||t<0||!Array.isArray(s.children)||t>=s.children.length)return;s=s.children[t]}return s}e.$cn=$;function y(n){if(!n.parent||!n.parent.children)return[];const o=y(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;o.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&o.push(s)}return o}e.$dn=y;function b(n){switch(n.type){case"array":return n.children.map(b);case"object":{const o=Object.create(null);for(const s of n.children){const i=s.children[1];i&&(o[s.children[0].value]=b(i))}return o}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.$en=b;function l(n,o,s=!1){return o>=n.offset&&o<n.offset+n.length||s&&o===n.offset+n.length}e.$fn=l;function f(n,o,s=!1){if(l(n,o,s)){const i=n.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=o;t++){const r=f(i[t],o,s);if(r)return r}return n}}e.$gn=f;function m(n,o,s=j.DEFAULT){const i=O(n,!1);function t(_){return _?()=>_(i.getTokenOffset(),i.getTokenLength()):()=>!0}function r(_){return _?oe=>_(oe,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),v=r(o.onObjectProperty),w=t(o.onObjectEnd),u=t(o.onArrayBegin),p=t(o.onArrayEnd),I=r(o.onLiteralValue),T=r(o.onSeparator),F=t(o.onComment),M=r(o.onError),z=s&&s.disallowComments,Z=s&&s.allowTrailingComma;function J(){for(;;){const _=i.scan();switch(i.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(_){case 12:case 13:z?x(10):F();break;case 16:x(1);break;case 15:case 14:break;default:return _}}}function x(_,oe=[],K=[]){if(M(_),oe.length+K.length>0){let U=i.getToken();for(;U!==17;){if(oe.indexOf(U)!==-1){J();break}else if(K.indexOf(U)!==-1)break;U=J()}}}function G(_){const oe=i.getTokenValue();return _?I(oe):v(oe),J(),!0}function Q(){switch(i.getToken()){case 11:{let _=0;try{_=JSON.parse(i.getTokenValue()),typeof _!="number"&&(x(2),_=0)}catch{x(2)}I(_);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return J(),!0}function V(){return i.getToken()!==10?(x(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(T(":"),J(),se()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function B(){a(),J();let _=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),J(),i.getToken()===2&&Z)break}else _&&x(6,[],[]);V()||x(4,[],[2,5]),_=!0}return w(),i.getToken()!==2?x(7,[2],[]):J(),!0}function te(){u(),J();let _=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(_||x(4,[],[]),T(","),J(),i.getToken()===4&&Z)break}else _&&x(6,[],[]);se()||x(4,[],[4,5]),_=!0}return p(),i.getToken()!==4?x(8,[4],[]):J(),!0}function se(){switch(i.getToken()){case 3:return te();case 1:return B();case 10:return G(!0);default:return Q()}}return J(),i.getToken()===17?s.allowEmptyContent?!0:(x(4,[],[]),!1):se()?(i.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$hn=m;function h(n,o){const s=O(n),i=[];let t,r=0,a;do switch(a=s.getPosition(),t=s.scan(),t){case 12:case 13:case 17:r!==a&&i.push(n.substring(r,a)),o!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,o)),r=s.getPosition();break}while(t!==17);return i.join("")}e.$in=h;function E(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.$jn=E}),define(le[42],he([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3T=e.$2T=e.$1T=e.$ZT=void 0;function N(g,C,S){let d,c,$,y,b;if(C){for(y=C.offset,b=y+C.length,$=y;$>0&&!k(g,$-1);)$--;let a=b;for(;a<g.length&&!k(g,a);)a++;c=g.substring($,a),d=O(c,S)}else c=g,d=0,$=0,y=0,b=g.length;const l=R(S,g);let f=!1,m=0,h;S.insertSpaces?h=j(" ",S.tabSize||4):h="	";const E=(0,D.$$m)(c,!1);let n=!1;function o(){return l+j(h,d+m)}function s(){let a=E.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=E.scan();return n=a===16||E.getTokenError()!==0,a}const i=[];function t(a,v,w){!n&&v<b&&w>y&&g.substring(v,w)!==a&&i.push({offset:v,length:w-v,content:a})}let r=s();if(r!==17){const a=E.getTokenOffset()+$,v=j(h,d);t(v,$,a)}for(;r!==17;){let a=E.getTokenOffset()+E.getTokenLength()+$,v=s(),w="";for(;!f&&(v===12||v===13);){const p=E.getTokenOffset()+$;t(" ",a,p),a=E.getTokenOffset()+E.getTokenLength()+$,w=v===12?o():"",v=s()}if(v===2)r!==1&&(m--,w=o());else if(v===4)r!==3&&(m--,w=o());else{switch(r){case 3:case 1:m++,w=o();break;case 5:case 12:w=o();break;case 13:f?w=o():w=" ";break;case 6:w=" ";break;case 10:if(v===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?w=" ":v!==5&&v!==17&&(n=!0);break;case 16:n=!0;break}f&&(v===12||v===13)&&(w=o())}const u=E.getTokenOffset()+$;t(w,a,u),r=v}return i}e.$ZT=N;function A(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$1T=A;function j(g,C){let S="";for(let d=0;d<C;d++)S+=g;return S}function O(g,C){let S=0,d=0;const c=C.tabSize||4;for(;S<g.length;){const $=g.charAt(S);if($===" ")d++;else if($==="	")d+=c;else break;S++}return Math.floor(d/c)}function R(g,C){for(let S=0;S<C.length;S++){const d=C.charAt(S);if(d==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(d===`
`)return`
`}return g&&g.eol||`
`}e.$2T=R;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$3T=k}),define(le[86],he([0,1,35,42]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8T=e.$7T=e.$6T=e.$5T=e.$4T=void 0;function A(g,C,S){return j(g,C,void 0,S)}e.$4T=A;function j(g,C,S,d,c){const $=C.slice(),y=[],b=(0,D.$bn)(g,y);let l,f;for(;$.length>0&&(f=$.pop(),l=(0,D.$cn)(b,$),l===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(l)if(l.type==="object"&&typeof f=="string"&&Array.isArray(l.children)){const m=(0,D.$cn)(l,[f]);if(m!==void 0)if(S===void 0){if(!m.parent)throw new Error("Malformed AST");const h=l.children.indexOf(m.parent);let E,n=m.parent.offset+m.parent.length;if(h>0){const o=l.children[h-1];E=o.offset+o.length}else E=l.offset+1,l.children.length>1&&(n=l.children[1].offset);return O(g,{offset:E,length:n-E,content:""},d)}else return O(g,{offset:m.offset,length:m.length,content:JSON.stringify(S)},d);else{if(S===void 0)return[];const h=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,E=c?c(l.children.map(o=>o.children[0].value)):l.children.length;let n;if(E>0){const o=l.children[E-1];n={offset:o.offset+o.length,length:0,content:","+h}}else l.children.length===0?n={offset:l.offset+1,length:0,content:h}:n={offset:l.offset+1,length:0,content:h+","};return O(g,n,d)}}else if(l.type==="array"&&typeof f=="number"&&Array.isArray(l.children))if(S!==void 0){const m=`${JSON.stringify(S)}`;let h;if(l.children.length===0||f===0)h={offset:l.offset+1,length:0,content:l.children.length===0?m:m+","};else{const E=f===-1||f>l.children.length?l.children.length:f,n=l.children[E-1];h={offset:n.offset+n.length,length:0,content:","+m}}return O(g,h,d)}else{const m=f,h=l.children[m];let E;if(l.children.length===1)E={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===m){const n=l.children[m-1],o=n.offset+n.length,s=l.offset+l.length;E={offset:o,length:s-2-o,content:""}}else E={offset:h.offset,length:l.children[m+1].offset-h.offset,content:""};return O(g,E,d)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${l.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return O(g,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(S)},d)}}e.$5T=j;function O(g,C,S){let d=R(g,C),c=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;c>0&&!(0,N.$3T)(d,c-1);)c--;for(;$<d.length&&!(0,N.$3T)(d,$);)$++}const y=(0,N.$ZT)(d,{offset:c,length:$-c},S);for(let l=y.length-1;l>=0;l--){const f=y[l];d=R(d,f),c=Math.min(c,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const b=g.length-(d.length-$)-c;return[{offset:c,length:b,content:d.substring(c,$)}]}e.$6T=O;function R(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$7T=R;function k(g,C){const S=C.slice(0).sort((c,$)=>{const y=c.offset-$.offset;return y===0?c.length-$.length:y});let d=g.length;for(let c=S.length-1;c>=0;c--){const $=S[c];if($.offset+$.length<=d)g=R(g,$);else throw new Error("Overlapping edit");d=$.offset}return g}e.$8T=k}),define(le[52],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(le[87],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(j){this.element=j,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let j=this.a;for(;j!==D.Undefined;){const O=j.next;j.prev=D.Undefined,j.next=D.Undefined,j=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,O){const R=new D(j);if(this.a===D.Undefined)this.a=R,this.b=R;else if(O){const g=this.b;this.b=R,R.prev=g,g.next=R}else{const g=this.a;this.a=R,R.next=g,g.prev=R}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(R))}}shift(){if(this.a!==D.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==D.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==D.Undefined&&j.next!==D.Undefined){const O=j.prev;O.next=j.next,j.next.prev=O}else j.prev===D.Undefined&&j.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):j.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):j.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==D.Undefined;)yield j.element,j=j.next}}e.$4c=N}),define(le[34],he([0,1]),function(ne,e){"use strict";var D,N,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j(m,h,E){let n=m.get(h);return n===void 0&&(n=E,m.set(h,n)),n}e.$xc=j;function O(m){const h=[];return m.forEach((E,n)=>{h.push(`${n} => ${E}`)}),`Map(${m.size}) {${h.join(", ")}}`}e.$yc=O;function R(m){const h=[];return m.forEach(E=>{h.push(E)}),`Set(${m.size}) {${h.join(", ")}}`}e.$zc=R;class k{constructor(h,E){this.uri=h,this.value=E}}function g(m){return Array.isArray(m)}class C{static{this.c=h=>h.toString()}constructor(h,E){if(this[D]="ResourceMap",h instanceof C)this.d=new Map(h.d),this.e=E??C.c;else if(g(h)){this.d=new Map,this.e=E??C.c;for(const[n,o]of h)this.set(n,o)}else this.d=new Map,this.e=h??C.c}set(h,E){return this.d.set(this.e(h),new k(h,E)),this}get(h){return this.d.get(this.e(h))?.value}has(h){return this.d.has(this.e(h))}get size(){return this.d.size}clear(){this.d.clear()}delete(h){return this.d.delete(this.e(h))}forEach(h,E){typeof E<"u"&&(h=h.bind(E));for(const[n,o]of this.d)h(o.value,o.uri,this)}*values(){for(const h of this.d.values())yield h.value}*keys(){for(const h of this.d.values())yield h.uri}*entries(){for(const h of this.d.values())yield[h.uri,h.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,h]of this.d)yield[h.uri,h.value]}}e.$Ac=C;class S{constructor(h,E){this[N]="ResourceSet",!h||typeof h=="function"?this.c=new C(h):(this.c=new C(E),h.forEach(this.add,this))}get size(){return this.c.size}add(h){return this.c.set(h,h),this}clear(){this.c.clear()}delete(h){return this.c.delete(h)}forEach(h,E){this.c.forEach((n,o)=>h.call(E,o,o,this))}has(h){return this.c.has(h)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var d;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class c{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(h){return this.c.has(h)}get(h,E=0){const n=this.c.get(h);if(n)return E!==0&&this.l(n,E),n.value}set(h,E,n=0){let o=this.c.get(h);if(o)o.value=E,n!==0&&this.l(o,n);else{switch(o={key:h,value:E,next:void 0,previous:void 0},n){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(h,o),this.f++}return this}delete(h){return!!this.remove(h)}remove(h){const E=this.c.get(h);if(E)return this.c.delete(h),this.k(E),this.f--,E.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const h=this.d;return this.c.delete(h.key),this.k(h),this.f--,h.value}forEach(h,E){const n=this.g;let o=this.d;for(;o;){if(E?h.bind(E)(o.value,o.key,this):h(o.value,o.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const h=this,E=this.g;let n=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==E)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.key,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return o}values(){const h=this,E=this.g;let n=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==E)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:n.value,done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return o}entries(){const h=this,E=this.g;let n=this.d;const o={[Symbol.iterator](){return o},next(){if(h.g!==E)throw new Error("LinkedMap got modified during iteration.");if(n){const s={value:[n.key,n.value],done:!1};return n=n.next,s}else return{value:void 0,done:!0}}};return o}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(h){if(h>=this.size)return;if(h===0){this.clear();return}let E=this.d,n=this.size;for(;E&&n>h;)this.c.delete(E.key),E=E.next,n--;this.d=E,this.f=n,E&&(E.previous=void 0),this.g++}i(h){if(!this.d&&!this.e)this.e=h;else if(this.d)h.next=this.d,this.d.previous=h;else throw new Error("Invalid list");this.d=h,this.g++}j(h){if(!this.d&&!this.e)this.d=h;else if(this.e)h.previous=this.e,this.e.next=h;else throw new Error("Invalid list");this.e=h,this.g++}k(h){if(h===this.d&&h===this.e)this.d=void 0,this.e=void 0;else if(h===this.d){if(!h.next)throw new Error("Invalid list");h.next.previous=void 0,this.d=h.next}else if(h===this.e){if(!h.previous)throw new Error("Invalid list");h.previous.next=void 0,this.e=h.previous}else{const E=h.next,n=h.previous;if(!E||!n)throw new Error("Invalid list");E.previous=n,n.next=E}h.next=void 0,h.previous=void 0,this.g++}l(h,E){if(!this.d||!this.e)throw new Error("Invalid list");if(!(E!==1&&E!==2)){if(E===1){if(h===this.d)return;const n=h.next,o=h.previous;h===this.e?(o.next=void 0,this.e=o):(n.previous=o,o.next=n),h.previous=void 0,h.next=this.d,this.d.previous=h,this.d=h,this.g++}else if(E===2){if(h===this.e)return;const n=h.next,o=h.previous;h===this.d?(n.previous=void 0,this.d=n):(n.previous=o,o.next=n),h.next=void 0,h.previous=this.e,this.e.next=h,this.e=h,this.g++}}}toJSON(){const h=[];return this.forEach((E,n)=>{h.push([n,E])}),h}fromJSON(h){this.clear();for(const[E,n]of h)this.set(E,n)}}e.$Cc=c;class $ extends c{constructor(h,E=1){super(),this.m=h,this.n=Math.min(Math.max(0,E),1)}get limit(){return this.m}set limit(h){this.m=h,this.o()}get ratio(){return this.n}set ratio(h){this.n=Math.min(Math.max(0,h),1),this.o()}get(h,E=2){return super.get(h,E)}peek(h){return super.get(h,0)}set(h,E){return super.set(h,E,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class y{constructor(){this.c=new Map}add(h){return this.c.set(h,(this.c.get(h)||0)+1),this}delete(h){let E=this.c.get(h)||0;return E===0?!1:(E--,E===0?this.c.delete(h):this.c.set(h,E),!0)}has(h){return this.c.has(h)}}e.$Ec=y;class b{constructor(h){if(this.c=new Map,this.d=new Map,h)for(const[E,n]of h)this.set(E,n)}clear(){this.c.clear(),this.d.clear()}set(h,E){this.c.set(h,E),this.d.set(E,h)}get(h){return this.c.get(h)}getKey(h){return this.d.get(h)}delete(h){const E=this.c.get(h);return E===void 0?!1:(this.c.delete(h),this.d.delete(E),!0)}forEach(h,E){this.c.forEach((n,o)=>{h.call(E,n,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=b;class l{constructor(){this.c=new Map}add(h,E){let n=this.c.get(h);n||(n=new Set,this.c.set(h,n)),n.add(E)}delete(h,E){const n=this.c.get(h);n&&(n.delete(E),n.size===0&&this.c.delete(h))}forEach(h,E){const n=this.c.get(h);n&&n.forEach(E)}get(h){const E=this.c.get(h);return E||new Set}}e.$Gc=l;function f(m,h){if(m===h)return!0;if(m.size!==h.size)return!1;for(const[E,n]of m)if(!h.has(E)||h.get(E)!==n)return!1;for(const[E]of h)if(!m.has(E))return!1;return!0}e.$Hc=f}),define(le[2],he([0,1,18,125,34,85,61]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const R=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(I){let T=this.b.get(I);return T||(T={parent:null,source:null,isSingleton:!1,value:I,idx:g.a++},this.b.set(I,T)),T}trackDisposable(I){const T=this.c(I);T.source||(T.source=new Error().stack)}setParent(I,T){const F=this.c(I);F.parent=T}markAsDisposed(I){this.b.delete(I)}markAsSingleton(I){this.c(I).isSingleton=!0}f(I,T){const F=T.get(I);if(F)return F;const M=I.parent?this.f(this.c(I.parent),T):I;return T.set(I,M),M}getTrackedDisposables(){const I=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,I).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(I=10,T){let F;if(T)F=T;else{const x=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,x).isSingleton);if(G.length===0)return;const Q=new Set(G.map(V=>V.value));if(F=G.filter(V=>!(V.parent&&Q.has(V.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function M(x){function G(V,B){for(;V.length>0&&B.some(te=>typeof te=="string"?te===V[0]:V[0].match(te));)V.shift()}const Q=x.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const z=new A.$Gc;for(const x of F){const G=M(x);for(let Q=0;Q<=G.length;Q++)z.add(G.slice(0,Q).join(`
`),x)}F.sort((0,D.$7b)(x=>x.idx,D.$9b));let Z="",J=0;for(const x of F.slice(0,I)){J++;const G=M(x),Q=[];for(let V=0;V<G.length;V++){let B=G[V];B=`(shared with ${z.get(G.slice(0,V+1).join(`
`)).size}/${F.length} leaks) at ${B}`;const se=z.get(G.slice(0,V).join(`
`)),_=(0,N.$K)([...se].map(oe=>M(oe)[V]),oe=>oe);delete _[G[V]];for(const[oe,K]of Object.entries(_))Q.unshift(`    - stacktraces of ${K.length} other leaks continue with ${oe}`);Q.unshift(B)}Z+=`


==================== Leaking disposable ${J}/${F.length}: ${x.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>I&&(Z+=`


... and ${F.length-I} more leaking disposables

`),{leaks:F,details:Z}}}e.$Ic=g;function C(p){k=p}if(e.$Jc=C,R){const p="__is_disposable_tracked__";C(new class{trackDisposable(I){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{I[p]||console.log(T)},3e3)}setParent(I,T){if(I&&I!==n.None)try{I[p]=!0}catch{}}markAsDisposed(I){if(I&&I!==n.None)try{I[p]=!0}catch{}}markAsSingleton(I){}})}function S(p){return k?.trackDisposable(p),p}e.$Kc=S;function d(p){k?.markAsDisposed(p)}e.$Lc=d;function c(p,I){k?.setParent(p,I)}function $(p,I){if(k)for(const T of p)k.setParent(T,I)}function y(p){return k?.markAsSingleton(p),p}e.$Mc=y;function b(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Nc=b;function l(p){if(O.Iterable.is(p)){const I=[];for(const T of p)if(T)try{T.dispose()}catch(F){I.push(F)}if(I.length===1)throw I[0];if(I.length>1)throw new AggregateError(I,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Oc=l;function f(p){for(const I of p)b(I)&&I.dispose();return[]}e.$Pc=f;function m(...p){const I=h(()=>l(p));return $(p,I),I}e.$Qc=m;function h(p){const I=S({dispose:(0,j.$db)(()=>{d(I),p()})});return I}e.$Rc=h;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(I){if(!I)return I;if(I===this)throw new Error("Cannot register a disposable on itself!");return c(I,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(I),I}delete(I){if(I){if(I===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(I),I.dispose()}}deleteAndLeak(I){I&&this.f.has(I)&&(this.f.delete(I),c(I,null))}}e.$Sc=E;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,S(this),c(this.q,this)}dispose(){d(this),this.q.dispose()}B(I){if(I===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(I)}}e.$Tc=n;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(I){this.b||I===this.a||(this.a?.dispose(),I&&c(I,this),this.a=I)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const I=this.a;return this.a=void 0,I&&c(I,null),I}}e.$Uc=o;class s{constructor(I){this.a=new o,this.b=!1,this.a.value=I}get value(){return this.a.value}set value(I){this.b||I===this.a.value||(this.a.value=I)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class i{constructor(I){this.b=I,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(I){let T=I;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,d(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(I,...T){let F=this.a.get(I);F||(F={counter:0,object:this.b(I,...T)},this.a.set(I,F));const{object:M}=F,z=(0,j.$db)(()=>{--F.counter===0&&(this.c(I,F.object),this.a.delete(I))});return F.counter++,{object:M,dispose:z}}}e.$Yc=r;class a{constructor(I){this.a=I}async acquire(I,...T){const F=this.a.acquire(I,...T);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(M){throw F.dispose(),M}}}e.$Zc=a;class v{constructor(I){this.object=I}dispose(){}}e.$1c=v;function w(p){const I=new E;try{p(I)}finally{I.dispose()}}e.$2c=w;class u{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(I){return this.a.has(I)}get size(){return this.a.size}get(I){return this.a.get(I)}set(I,T,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(I)?.dispose(),this.a.set(I,T)}deleteAndDispose(I){this.a.get(I)?.dispose(),this.a.delete(I)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=u}),define(le[88],he([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=void 0;const N=new D.$Dc(1e4);function A(g){return k(g,"NFC",N)}e.$El=A;const j=new D.$Dc(1e4);function O(g){return k(g,"NFD",j)}e.$Fl=O;const R=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const d=S.get(g);if(d)return d;let c;return R.test(g)?c=g.normalize(C):c=g,S.set(g,c),c}e.$Gl=function(){const g=/[\u0300-\u036f]/g;return function(C){return O(C).replace(g,"")}}()}),function(){function ne(A){const j=[];typeof A=="number"&&j.push("code/timeOrigin",A);function O(k){j.push(k,Date.now())}function R(){const k=[];for(let g=0;g<j.length;g+=2)k.push({name:j[g],startTime:j[g+1]});return k}return{mark:O,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(A){performance.mark(A)},getMarks(){let A=performance.timeOrigin;typeof A!="number"&&(A=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(A)}];for(const O of performance.getEntriesByType("mark"))j.push({name:O.name,startTime:Math.round(A+O.startTime)});return j}};if(typeof process=="object"){const A=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(A)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(A){return A.MonacoPerformanceMarks||(A.MonacoPerformanceMarks=e()),A.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var A=e[N]={i:N,l:!1,exports:{}};return ne[N].call(A.exports,A,A.exports,D),A.l=!0,A.exports}return D.m=ne,D.c=e,D.d=function(N,A,j){D.o(N,A)||Object.defineProperty(N,A,{enumerable:!0,get:j})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,A){if(1&A&&(N=D(N)),8&A||4&A&&typeof N=="object"&&N&&N.__esModule)return N;var j=Object.create(null);if(D.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:N}),2&A&&typeof N!="string")for(var O in N)D.d(j,O,function(R){return N[R]}.bind(null,O));return j},D.n=function(N){var A=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(A,"a",A),A},D.o=function(N,A){return Object.prototype.hasOwnProperty.call(N,A)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var A;e=ne.exports=K,A=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var d=g++;k[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var c=g++;k[c]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var $=g++;k[$]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var y=g++;k[y]="(?:"+k[C]+"|"+k[d]+")";var b=g++;k[b]="(?:"+k[S]+"|"+k[d]+")";var l=g++;k[l]="(?:-("+k[y]+"(?:\\."+k[y]+")*))";var f=g++;k[f]="(?:-?("+k[b]+"(?:\\."+k[b]+")*))";var m=g++;k[m]="[0-9A-Za-z-]+";var h=g++;k[h]="(?:\\+("+k[m]+"(?:\\."+k[m]+")*))";var E=g++,n="v?"+k[c]+k[l]+"?"+k[h]+"?";k[E]="^"+n+"$";var o="[v=\\s]*"+k[$]+k[f]+"?"+k[h]+"?",s=g++;k[s]="^"+o+"$";var i=g++;k[i]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[l]+")?"+k[h]+"?)?)?";var v=g++;k[v]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[f]+")?"+k[h]+"?)?)?";var w=g++;k[w]="^"+k[i]+"\\s*"+k[a]+"$";var u=g++;k[u]="^"+k[i]+"\\s*"+k[v]+"$";var p=g++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=g++;k[I]="(?:~>?)";var T=g++;k[T]="(\\s*)"+k[I]+"\\s+",R[T]=new RegExp(k[T],"g");var F=g++;k[F]="^"+k[I]+k[a]+"$";var M=g++;k[M]="^"+k[I]+k[v]+"$";var z=g++;k[z]="(?:\\^)";var Z=g++;k[Z]="(\\s*)"+k[z]+"\\s+",R[Z]=new RegExp(k[Z],"g");var J=g++;k[J]="^"+k[z]+k[a]+"$";var x=g++;k[x]="^"+k[z]+k[v]+"$";var G=g++;k[G]="^"+k[i]+"\\s*("+o+")$|^$";var Q=g++;k[Q]="^"+k[i]+"\\s*("+n+")$|^$";var V=g++;k[V]="(\\s*)"+k[i]+"\\s*("+o+"|"+k[a]+")",R[V]=new RegExp(k[V],"g");var B=g++;k[B]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var te=g++;k[te]="^\\s*("+k[v]+")\\s+-\\s+("+k[v]+")\\s*$";var se=g++;k[se]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)A(_,k[_]),R[_]||(R[_]=new RegExp(k[_]));function oe(ue,ge){if(ue instanceof K)return ue;if(typeof ue!="string"||ue.length>j||!(ge?R[s]:R[E]).test(ue))return null;try{return new K(ue,ge)}catch{return null}}function K(ue,ge){if(ue instanceof K){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof K))return new K(ue,ge);A("SemVer",ue,ge),this.loose=ge;var me=ue.trim().match(ge?R[s]:R[E]);if(!me)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+me[1],this.minor=+me[2],this.patch=+me[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");me[4]?this.prerelease=me[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Ce=+Pe;if(Ce>=0&&Ce<O)return Ce}return Pe}):this.prerelease=[],this.build=me[5]?me[5].split("."):[],this.format()}e.parse=oe,e.valid=function(ue,ge){var me=oe(ue,ge);return me?me.version:null},e.clean=function(ue,ge){var me=oe(ue.trim().replace(/^[=v]+/,""),ge);return me?me.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ue){return A("SemVer.compare",this.version,this.loose,ue),ue instanceof K||(ue=new K(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},K.prototype.compareMain=function(ue){return ue instanceof K||(ue=new K(ue,this.loose)),P(this.major,ue.major)||P(this.minor,ue.minor)||P(this.patch,ue.patch)},K.prototype.comparePre=function(ue){if(ue instanceof K||(ue=new K(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var me=this.prerelease[ge],Pe=ue.prerelease[ge];if(A("prerelease compare",ge,me,Pe),me===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(me===void 0)return-1;if(me!==Pe)return P(me,Pe)}while(++ge)},K.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var me=this.prerelease.length;--me>=0;)typeof this.prerelease[me]=="number"&&(this.prerelease[me]++,me=-2);me===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,me,Pe){typeof me=="string"&&(Pe=me,me=void 0);try{return new K(ue,me).inc(ge,Pe).version}catch{return null}},e.diff=function(ue,ge){if(ee(ue,ge))return null;var me=oe(ue),Pe=oe(ge);if(me.prerelease.length||Pe.prerelease.length){for(var Ce in me)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&me[Ce]!==Pe[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in me)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&me[Ce]!==Pe[Ce])return Ce},e.compareIdentifiers=P;var U=/^[0-9]+$/;function P(ue,ge){var me=U.test(ue),Pe=U.test(ge);return me&&Pe&&(ue=+ue,ge=+ge),me&&!Pe?-1:Pe&&!me?1:ue<ge?-1:ue>ge?1:0}function L(ue,ge,me){return new K(ue,me).compare(new K(ge,me))}function H(ue,ge,me){return L(ue,ge,me)>0}function q(ue,ge,me){return L(ue,ge,me)<0}function ee(ue,ge,me){return L(ue,ge,me)===0}function W(ue,ge,me){return L(ue,ge,me)!==0}function Y(ue,ge,me){return L(ue,ge,me)>=0}function ie(ue,ge,me){return L(ue,ge,me)<=0}function ce(ue,ge,me,Pe){var Ce;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof me=="object"&&(me=me.version),Ce=ue===me;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof me=="object"&&(me=me.version),Ce=ue!==me;break;case"":case"=":case"==":Ce=ee(ue,me,Pe);break;case"!=":Ce=W(ue,me,Pe);break;case">":Ce=H(ue,me,Pe);break;case">=":Ce=Y(ue,me,Pe);break;case"<":Ce=q(ue,me,Pe);break;case"<=":Ce=ie(ue,me,Pe);break;default:throw new TypeError("Invalid operator: "+ge)}return Ce}function ae(ue,ge){if(ue instanceof ae){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ae))return new ae(ue,ge);A("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,A("comp",this)}e.rcompareIdentifiers=function(ue,ge){return P(ge,ue)},e.major=function(ue,ge){return new K(ue,ge).major},e.minor=function(ue,ge){return new K(ue,ge).minor},e.patch=function(ue,ge){return new K(ue,ge).patch},e.compare=L,e.compareLoose=function(ue,ge){return L(ue,ge,!0)},e.rcompare=function(ue,ge,me){return L(ge,ue,me)},e.sort=function(ue,ge){return ue.sort(function(me,Pe){return e.compare(me,Pe,ge)})},e.rsort=function(ue,ge){return ue.sort(function(me,Pe){return e.rcompare(me,Pe,ge)})},e.gt=H,e.lt=q,e.eq=ee,e.neq=W,e.gte=Y,e.lte=ie,e.cmp=ce,e.Comparator=ae;var fe={};function de(ue,ge){if(ue instanceof de)return ue.loose===ge?ue:new de(ue.raw,ge);if(ue instanceof ae)return new de(ue.value,ge);if(!(this instanceof de))return new de(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(me){return this.parseRange(me.trim())},this).filter(function(me){return me.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function we(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,me,Pe,Ce,Me,De,ze,Te,Fe,qe,re,$e){return((ge=we(me)?"":we(Pe)?">="+me+".0.0":we(Ce)?">="+me+"."+Pe+".0":">="+ge)+" "+(ze=we(Te)?"":we(Fe)?"<"+(+Te+1)+".0.0":we(qe)?"<"+Te+"."+(+Fe+1)+".0":re?"<="+Te+"."+Fe+"."+qe+"-"+re:"<="+ze)).trim()}function Re(ue,ge){for(var me=0;me<ue.length;me++)if(!ue[me].test(ge))return!1;if(ge.prerelease.length){for(me=0;me<ue.length;me++)if(A(ue[me].semver),ue[me].semver!==fe&&ue[me].semver.prerelease.length>0){var Pe=ue[me].semver;if(Pe.major===ge.major&&Pe.minor===ge.minor&&Pe.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,me){try{ge=new de(ge,me)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,me,Pe){var Ce,Me,De,ze,Te;switch(ue=new K(ue,Pe),ge=new de(ge,Pe),me){case">":Ce=H,Me=ie,De=q,ze=">",Te=">=";break;case"<":Ce=q,Me=Y,De=H,ze="<",Te="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Pe))return!1;for(var Fe=0;Fe<ge.set.length;++Fe){var qe=ge.set[Fe],re=null,$e=null;if(qe.forEach(function(be){be.semver===fe&&(be=new ae(">=0.0.0")),re=re||be,$e=$e||be,Ce(be.semver,re.semver,Pe)?re=be:De(be.semver,$e.semver,Pe)&&($e=be)}),re.operator===ze||re.operator===Te||(!$e.operator||$e.operator===ze)&&Me(ue,$e.semver)||$e.operator===Te&&De(ue,$e.semver))return!1}return!0}ae.prototype.parse=function(ue){var ge=this.loose?R[G]:R[Q],me=ue.match(ge);if(!me)throw new TypeError("Invalid comparator: "+ue);this.operator=me[1],this.operator==="="&&(this.operator=""),me[2]?this.semver=new K(me[2],this.loose):this.semver=fe},ae.prototype.toString=function(){return this.value},ae.prototype.test=function(ue){return A("Comparator.test",ue,this.loose),this.semver===fe||(typeof ue=="string"&&(ue=new K(ue,this.loose)),ce(ue,this.operator,this.semver,this.loose))},ae.prototype.intersects=function(ue,ge){if(!(ue instanceof ae))throw new TypeError("a Comparator is required");var me;if(this.operator==="")return me=new de(ue.value,ge),Oe(this.value,me,ge);if(ue.operator==="")return me=new de(this.value,ge),Oe(ue.semver,me,ge);var Pe=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Me=this.semver.version===ue.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),ze=ce(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Te=ce(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Pe||Ce||Me&&De||ze||Te},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),A("range",ue,ge);var me=ge?R[te]:R[B];ue=ue.replace(me,Ee),A("hyphen replace",ue),ue=ue.replace(R[V],"$1$2$3"),A("comparator trim",ue,R[V]),ue=(ue=(ue=ue.replace(R[T],"$1~")).replace(R[Z],"$1^")).split(/\s+/).join(" ");var Pe=ge?R[G]:R[Q],Ce=ue.split(" ").map(function(Me){return function(De,ze){return A("comp",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(qe){return function(re,$e){A("caret",re,$e);var be=$e?R[x]:R[J];return re.replace(be,function(ve,pe,ke,Ie,Ae){var Le;return A("caret",re,ve,pe,ke,Ie,Ae),we(pe)?Le="":we(ke)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":we(Ie)?Le=pe==="0"?">="+pe+"."+ke+".0 <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+".0 <"+(+pe+1)+".0.0":Ae?(A("replaceCaret pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Le=pe==="0"?ke==="0"?">="+pe+"."+ke+"."+Ie+Ae+" <"+pe+"."+ke+"."+(+Ie+1):">="+pe+"."+ke+"."+Ie+Ae+" <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+"."+Ie+Ae+" <"+(+pe+1)+".0.0"):(A("no pr"),Le=pe==="0"?ke==="0"?">="+pe+"."+ke+"."+Ie+" <"+pe+"."+ke+"."+(+Ie+1):">="+pe+"."+ke+"."+Ie+" <"+pe+"."+(+ke+1)+".0":">="+pe+"."+ke+"."+Ie+" <"+(+pe+1)+".0.0"),A("caret return",Le),Le})}(qe,Fe)}).join(" ")}(De,ze),A("caret",De),De=function(Te,Fe){return Te.trim().split(/\s+/).map(function(qe){return function(re,$e){var be=$e?R[M]:R[F];return re.replace(be,function(ve,pe,ke,Ie,Ae){var Le;return A("tilde",re,ve,pe,ke,Ie,Ae),we(pe)?Le="":we(ke)?Le=">="+pe+".0.0 <"+(+pe+1)+".0.0":we(Ie)?Le=">="+pe+"."+ke+".0 <"+pe+"."+(+ke+1)+".0":Ae?(A("replaceTilde pr",Ae),Ae.charAt(0)!=="-"&&(Ae="-"+Ae),Le=">="+pe+"."+ke+"."+Ie+Ae+" <"+pe+"."+(+ke+1)+".0"):Le=">="+pe+"."+ke+"."+Ie+" <"+pe+"."+(+ke+1)+".0",A("tilde return",Le),Le})}(qe,Fe)}).join(" ")}(De,ze),A("tildes",De),De=function(Te,Fe){return A("replaceXRanges",Te,Fe),Te.split(/\s+/).map(function(qe){return function(re,$e){re=re.trim();var be=$e?R[u]:R[w];return re.replace(be,function(ve,pe,ke,Ie,Ae,Le){A("xRange",re,ve,pe,ke,Ie,Ae,Le);var Ge=we(ke),Ue=Ge||we(Ie),Be=Ue||we(Ae);return pe==="="&&Be&&(pe=""),Ge?ve=pe===">"||pe==="<"?"<0.0.0":"*":pe&&Be?(Ue&&(Ie=0),Be&&(Ae=0),pe===">"?(pe=">=",Ue?(ke=+ke+1,Ie=0,Ae=0):Be&&(Ie=+Ie+1,Ae=0)):pe==="<="&&(pe="<",Ue?ke=+ke+1:Ie=+Ie+1),ve=pe+ke+"."+Ie+"."+Ae):Ue?ve=">="+ke+".0.0 <"+(+ke+1)+".0.0":Be&&(ve=">="+ke+"."+Ie+".0 <"+ke+"."+(+Ie+1)+".0"),A("xRange return",ve),ve})}(qe,Fe)}).join(" ")}(De,ze),A("xrange",De),De=function(Te,Fe){return A("replaceStars",Te,Fe),Te.trim().replace(R[se],"")}(De,ze),A("stars",De),De}(Me,ge)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(Me){return!!Me.match(Pe)})),Ce=Ce.map(function(Me){return new ae(Me,ge)})},de.prototype.intersects=function(ue,ge){if(!(ue instanceof de))throw new TypeError("a Range is required");return this.set.some(function(me){return me.every(function(Pe){return ue.set.some(function(Ce){return Ce.every(function(Me){return Pe.intersects(Me,ge)})})})})},e.toComparators=function(ue,ge){return new de(ue,ge).set.map(function(me){return me.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},de.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new K(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,me){var Pe=null,Ce=null;try{var Me=new de(ge,me)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Ce.compare(De)!==-1||(Ce=new K(Pe=De,me)))}),Pe},e.minSatisfying=function(ue,ge,me){var Pe=null,Ce=null;try{var Me=new de(ge,me)}catch{return null}return ue.forEach(function(De){Me.test(De)&&(Pe&&Ce.compare(De)!==1||(Ce=new K(Pe=De,me)))}),Pe},e.validRange=function(ue,ge){try{return new de(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,me){return Ne(ue,ge,"<",me)},e.gtr=function(ue,ge,me){return Ne(ue,ge,">",me)},e.outside=Ne,e.prerelease=function(ue,ge){var me=oe(ue,ge);return me&&me.prerelease.length?me.prerelease:null},e.intersects=function(ue,ge,me){return ue=new de(ue,me),ge=new de(ge,me),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof K)return ue;if(typeof ue!="string")return null;var ge=ue.match(R[p]);return ge==null?null:oe((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,A=ne.exports={};function j(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function R(b){if(D===setTimeout)return setTimeout(b,0);if((D===j||!D)&&setTimeout)return D=setTimeout,setTimeout(b,0);try{return D(b,0)}catch{try{return D.call(null,b,0)}catch{return D.call(this,b,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:j}catch{D=j}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var k,g=[],C=!1,S=-1;function d(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&c())}function c(){if(!C){var b=R(d);C=!0;for(var l=g.length;l;){for(k=g,g=[];++S<l;)k&&k[S].run();S=-1,l=g.length}k=null,C=!1,function(f){if(N===clearTimeout)return clearTimeout(f);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(f);try{N(f)}catch{try{return N.call(null,f)}catch{return N.call(this,f)}}}(b)}}function $(b,l){this.fun=b,this.array=l}function y(){}A.nextTick=function(b){var l=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)l[f-1]=arguments[f];g.push(new $(b,l)),g.length!==1||C||R(c)},$.prototype.run=function(){this.fun.apply(null,this.array)},A.title="browser",A.browser=!0,A.env={},A.argv=[],A.version="",A.versions={},A.on=y,A.addListener=y,A.once=y,A.off=y,A.removeListener=y,A.removeAllListeners=y,A.emit=y,A.prependListener=y,A.prependOnceListener=y,A.listeners=function(b){return[]},A.binding=function(b){throw new Error("process.binding is not supported")},A.cwd=function(){return"/"},A.chdir=function(b){throw new Error("process.chdir is not supported")},A.umask=function(){return 0}}])}),define(le[127],he([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pr=void 0;class N{constructor(R,k,g){this.level=R,this.key=k,this.value=g,this.forward=[]}}const A=void 0;class j{constructor(R,k=2**16){this.comparator=R,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new N(this.c,A,A)}get size(){return this.f}clear(){this.e=new N(this.c,A,A),this.f=0}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,k){return j.h(this,R,k,this.comparator)&&(this.f+=1),this}delete(R){const k=j.k(this,R,this.comparator);return k&&(this.f-=1),k}forEach(R,k){let g=this.e.forward[0];for(;g;)R.call(k,g.value,g.key,this),g=g.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",k=this.e.forward[0];for(;k;)R+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return R}static g(R,k,g){let C=R.e;for(let S=R.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(R,k,g,C){const S=[];let d=R.e;for(let c=R.d-1;c>=0;c--){for(;d.forward[c]&&C(d.forward[c].key,k)<0;)d=d.forward[c];S[c]=d}if(d=d.forward[0],d&&C(d.key,k)===0)return d.value=g,!1;{const c=j.j(R);if(c>R.d){for(let $=R.d;$<c;$++)S[$]=R.e;R.d=c}d=new N(c,k,g);for(let $=0;$<c;$++)d.forward[$]=S[$].forward[$],S[$].forward[$]=d;return!0}}static j(R,k=.5){let g=1;for(;Math.random()<k&&g<R.c;)g+=1;return g}static k(R,k,g){const C=[];let S=R.e;for(let d=R.d-1;d>=0;d--){for(;S.forward[d]&&g(S.forward[d].key,k)<0;)S=S.forward[d];C[d]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let d=0;d<R.d&&C[d].forward[d]===S;d++)C[d].forward[d]=S.forward[d];for(;R.d>0&&R.e.forward[R.d-1]===A;)R.d-=1;return!0}}e.$Pr=j}),define(le[62],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(j){return new N(j)}constructor(j){this.c=D&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Pd=N}),define(le[3],he([0,1,7,85,2,87,62]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.Event=void 0;const R=!1,k=!1;var g;(function(w){w.None=()=>A.$Tc.None;function u(ce){if(k){const{onDidAddListener:ae}=ce,fe=$.create();let de=0;ce.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),fe.print()),ae?.()}}}function p(ce,ae){return Q(ce,()=>{},0,void 0,!0,void 0,ae)}w.defer=p;function I(ce){return(ae,fe=null,de)=>{let we=!1,Ee;return Ee=ce(Re=>{if(!we)return Ee?Ee.dispose():we=!0,ae.call(fe,Re)},null,de),we&&Ee.dispose(),Ee}}w.once=I;function T(ce,ae,fe){return x((de,we=null,Ee)=>ce(Re=>de.call(we,ae(Re)),null,Ee),fe)}w.map=T;function F(ce,ae,fe){return x((de,we=null,Ee)=>ce(Re=>{ae(Re),de.call(we,Re)},null,Ee),fe)}w.forEach=F;function M(ce,ae,fe){return x((de,we=null,Ee)=>ce(Re=>ae(Re)&&de.call(we,Re),null,Ee),fe)}w.filter=M;function z(ce){return ce}w.signal=z;function Z(...ce){return(ae,fe=null,de)=>{const we=(0,A.$Qc)(...ce.map(Ee=>Ee(Re=>ae.call(fe,Re))));return G(we,de)}}w.any=Z;function J(ce,ae,fe,de){let we=fe;return T(ce,Ee=>(we=ae(we,Ee),we),de)}w.reduce=J;function x(ce,ae){let fe;const de={onWillAddFirstListener(){fe=ce(we.fire,we)},onDidRemoveLastListener(){fe?.dispose()}};ae||u(de);const we=new m(de);return ae?.add(we),we.event}function G(ce,ae){return ae instanceof Array?ae.push(ce):ae&&ae.add(ce),ce}function Q(ce,ae,fe=100,de=!1,we=!1,Ee,Re){let Oe,Ne,ue,ge=0,me;const Pe={leakWarningThreshold:Ee,onWillAddFirstListener(){Oe=ce(Me=>{ge++,Ne=ae(Ne,Me),de&&!ue&&(Ce.fire(Ne),Ne=void 0),me=()=>{const De=Ne;Ne=void 0,ue=void 0,(!de||ge>1)&&Ce.fire(De),ge=0},typeof fe=="number"?(clearTimeout(ue),ue=setTimeout(me,fe)):ue===void 0&&(ue=0,queueMicrotask(me))})},onWillRemoveListener(){we&&ge>0&&me?.()},onDidRemoveLastListener(){me=void 0,Oe.dispose()}};Re||u(Pe);const Ce=new m(Pe);return Re?.add(Ce),Ce.event}w.debounce=Q;function V(ce,ae=0,fe){return w.debounce(ce,(de,we)=>de?(de.push(we),de):[we],ae,void 0,!0,void 0,fe)}w.accumulate=V;function B(ce,ae=(de,we)=>de===we,fe){let de=!0,we;return M(ce,Ee=>{const Re=de||!ae(Ee,we);return de=!1,we=Ee,Re},fe)}w.latch=B;function te(ce,ae,fe){return[w.filter(ce,ae,fe),w.filter(ce,de=>!ae(de),fe)]}w.split=te;function se(ce,ae=!1,fe=[],de){let we=fe.slice(),Ee=ce(Ne=>{we?we.push(Ne):Oe.fire(Ne)});de&&de.add(Ee);const Re=()=>{we?.forEach(Ne=>Oe.fire(Ne)),we=null},Oe=new m({onWillAddFirstListener(){Ee||(Ee=ce(Ne=>Oe.fire(Ne)),de&&de.add(Ee))},onDidAddFirstListener(){we&&(ae?setTimeout(Re):Re())},onDidRemoveLastListener(){Ee&&Ee.dispose(),Ee=null}});return de&&de.add(Oe),Oe.event}w.buffer=se;function _(ce,ae){return(de,we,Ee)=>{const Re=ae(new K);return ce(function(Oe){const Ne=Re.evaluate(Oe);Ne!==oe&&de.call(we,Ne)},void 0,Ee)}}w.chain=_;const oe=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(ae){return this.f.push(ae),this}forEach(ae){return this.f.push(fe=>(ae(fe),fe)),this}filter(ae){return this.f.push(fe=>ae(fe)?fe:oe),this}reduce(ae,fe){let de=fe;return this.f.push(we=>(de=ae(de,we),de)),this}latch(ae=(fe,de)=>fe===de){let fe=!0,de;return this.f.push(we=>{const Ee=fe||!ae(we,de);return fe=!1,de=we,Ee?we:oe}),this}evaluate(ae){for(const fe of this.f)if(ae=fe(ae),ae===oe)break;return ae}}function U(ce,ae,fe=de=>de){const de=(...Oe)=>Re.fire(fe(...Oe)),we=()=>ce.on(ae,de),Ee=()=>ce.removeListener(ae,de),Re=new m({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Re.event}w.fromNodeEventEmitter=U;function P(ce,ae,fe=de=>de){const de=(...Oe)=>Re.fire(fe(...Oe)),we=()=>ce.addEventListener(ae,de),Ee=()=>ce.removeEventListener(ae,de),Re=new m({onWillAddFirstListener:we,onDidRemoveLastListener:Ee});return Re.event}w.fromDOMEventEmitter=P;function L(ce){return new Promise(ae=>I(ce)(ae))}w.toPromise=L;function H(ce){const ae=new m;return ce.then(fe=>{ae.fire(fe)},()=>{ae.fire(void 0)}).finally(()=>{ae.dispose()}),ae.event}w.fromPromise=H;function q(ce,ae,fe){return ae(fe),ce(de=>ae(de))}w.runAndSubscribe=q;function ee(ce,ae){let fe=null;function de(Ee){fe?.dispose(),fe=new A.$Sc,ae(Ee,fe)}de(void 0);const we=ce(Ee=>de(Ee));return(0,A.$Rc)(()=>{we.dispose(),fe?.dispose()})}w.runAndSubscribeWithStore=ee;class W{constructor(ae,fe){this._observable=ae,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ae.addObserver(this)},onDidRemoveLastListener:()=>{ae.removeObserver(this)}};fe||u(de),this.emitter=new m(de),fe&&fe.add(this.emitter)}beginUpdate(ae){this.f++}handlePossibleChange(ae){}handleChange(ae,fe){this.g=!0}endUpdate(ae){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Y(ce,ae){return new W(ce,ae).emitter.event}w.fromObservable=Y;function ie(ce){return(ae,fe,de)=>{let we=0,Ee=!1;const Re={beginUpdate(){we++},endUpdate(){we--,we===0&&(ce.reportChanges(),Ee&&(Ee=!1,ae.call(fe)))},handlePossibleChange(){},handleChange(){Ee=!0}};ce.addObserver(Re),ce.reportChanges();const Oe={dispose(){ce.removeObserver(Re)}};return de instanceof A.$Sc?de.add(Oe):Array.isArray(de)&&de.push(Oe),Oe}}w.fromObservableLight=ie})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new O.$Pd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$Rd=C;let S=-1;function d(w){const u=S;return S=w,{dispose(){S=u}}}e.$Sd=d;class c{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const I=this.threshold;if(I<=0||p<I)return;this.f||(this.f=new Map);const T=this.f.get(u.value)||0;if(this.f.set(u.value,T+1),this.g-=1,this.g<=0){this.g=I*.5;let F,M=0;for(const[z,Z]of this.f)(!F||M<Z)&&(F=z,M=Z);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${M}):`),console.warn(F)}return()=>{const F=this.f.get(u.value)||0;this.f.set(u.value,F-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class b{constructor(u){this.value=u,this.id=y++}}const l=2,f=(w,u)=>{if(w instanceof b)u(w);else for(let p=0;p<w.length;p++){const I=w[p];I&&u(I)}};class m{constructor(u){this.w=0,this.f=u,this.g=S>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(R){const u=this.t;queueMicrotask(()=>{f(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,I)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),A.$Tc.None;if(this.m)return A.$Tc.None;p&&(u=u.bind(p));const T=new b(u);let F,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=$.create(),F=this.g.check(T.stack,this.w+1)),R&&(T.stack=M??$.create()),this.t?this.t instanceof b?(this.u??=new E,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const z=(0,A.$Rc)(()=>{F?.(),this.x(T)});return I instanceof A.$Sc?I.add(z):Array.isArray(I)&&I.push(z),z},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,I=p.indexOf(u);if(I===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[I]=void 0;const T=this.u.current===this;if(this.w*l<=p.length){let F=0;for(let M=0;M<p.length;M++)p[M]?p[F++]=p[M]:T&&(this.u.end--,F<this.u.i&&this.u.i--);p.length=F}}y(u,p){if(!u)return;const I=this.f?.onListenerError||D.$1;if(!I){u.value(p);return}try{u.value(p)}catch(T){I(T)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Td=m;const h=()=>new E;e.$Ud=h;class E{constructor(){this.i=-1,this.end=0}enqueue(u,p,I){this.i=0,this.end=I,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends m{async fireAsync(u,p,I){if(this.t)for(this.h||(this.h=new j.$4c),f(this.t,T=>this.h.push([T.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[T,F]=this.h.shift(),M=[],z={...F,token:p,waitUntil:Z=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");I&&(Z=I(Z,T)),M.push(Z)}};try{T(z)}catch(Z){(0,D.$1)(Z);continue}Object.freeze(M),await Promise.allSettled(M).then(Z=>{for(const J of Z)J.status==="rejected"&&(0,D.$1)(J.reason)})}}}e.$Vd=n;class o extends m{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new j.$4c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$Wd=o;class s extends o{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$Xd=s;class i extends m{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$Yd=i;class t{constructor(){this.g=!1,this.h=[],this.f=new m({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const I=()=>{this.g&&this.o(p);const T=this.h.indexOf(p);this.h.splice(T,1)};return(0,A.$Rc)((0,N.$db)(I))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$Zd=t;class r{constructor(u,p,I,T){this.f=new A.$Sc;const F=this.f.add(new t),M=this.f.add(new A.$3c);function z(Z){M.set(Z,F.add(T(Z)))}for(const Z of u)z(Z);this.f.add(p(Z=>{z(Z)})),this.f.add(I(Z=>{M.deleteAndDispose(Z)})),this.event=F.event}dispose(){this.f.dispose()}}e.$1d=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,I,T)=>u(F=>{const M=this.f[this.f.length-1];M?M.push(()=>p.call(I,F)):p.call(I,F)},void 0,T)}bufferEvents(u){const p=[];this.f.push(p);const I=u();return this.f.pop(),p.forEach(T=>T()),I}}e.$2d=a;class v{constructor(){this.f=!1,this.g=g.None,this.h=A.$Tc.None,this.j=new m({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$3d=v}),define(le[26],he([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.CancellationToken=void 0;const N=Object.freeze(function(R,k){const g=setTimeout(R.bind(k),0);return{dispose(){clearTimeout(g)}}});var A;(function(R){function k(g){return g===R.None||g===R.Cancelled||g instanceof j?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}R.isCancellationToken=k,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(A||(e.CancellationToken=A={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Td),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=A.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=A.None}}e.$4d=O}),define(le[128],he([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=void 0;class N{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new D.$4d,k=this.b(R.token);return this.a={promise:k,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$Ce=N;class A{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const k=JSON.stringify(R);return this.b!==k&&(this.b=k,this.a=this.c(R)),this.a}}e.$De=A;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const k=this.b(R);return this.a.set(R,k),k}}e.$Ee=j}),define(le[46],he([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;function A(h){const E=h;return E?typeof E.read=="function":!1}e.$5d=A;function j(h){const E=h;return E?[E.on,E.pause,E.resume,E.destroy].every(n=>typeof n=="function"):!1}e.$6d=j;function O(h){const E=h;return E?j(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.$7d=O;function R(h,E){return new k(h,E)}e.$8d=R;class k{constructor(E,n){this.e=E,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(E){if(!this.a.destroyed){if(this.a.flowing)this.g(E);else if(this.b.data.push(E),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(E){this.a.destroyed||(this.a.flowing?this.h(E):this.b.error.push(E))}end(E){this.a.destroyed||(typeof E<"u"&&this.write(E),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(E){this.c.data.slice(0).forEach(n=>n(E))}h(E){this.c.error.length===0?(0,D.$1)(E):this.c.error.slice(0).forEach(n=>n(E))}i(){this.c.end.slice(0).forEach(E=>E())}on(E,n){if(!this.a.destroyed)switch(E){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(E,n){if(this.a.destroyed)return;let o;switch(E){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const s=o.indexOf(n);s>=0&&o.splice(s,1)}}j(){if(this.b.data.length>0){const E=this.e(this.b.data);this.g(E),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const E of this.b.error)this.h(E);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(h,E){const n=[];let o;for(;(o=h.read())!==null;)n.push(o);return E(n)}e.$9d=g;function C(h,E,n){const o=[];let s;for(;(s=h.read())!==null&&o.length<n;)o.push(s);return s===null&&o.length>0?E(o):{read:()=>{if(o.length>0)return o.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return h.read()}}}e.$0d=C;function S(h,E){return new Promise((n,o)=>{const s=[];d(h,{onData:i=>{E&&s.push(i)},onError:i=>{E?o(i):n(void 0)},onEnd:()=>{n(E?E(s):void 0)}})})}e.$$d=S;function d(h,E,n){h.on("error",o=>{n?.isCancellationRequested||E.onError(o)}),h.on("end",()=>{n?.isCancellationRequested||E.onEnd()}),h.on("data",o=>{n?.isCancellationRequested||E.onData(o)})}e.$_d=d;function c(h,E){return new Promise((n,o)=>{const s=new N.$Sc,i=[],t=v=>{if(i.push(v),i.length>E)return s.dispose(),h.pause(),n({stream:h,buffer:i,ended:!1})},r=v=>(s.dispose(),o(v)),a=()=>(s.dispose(),n({stream:h,buffer:i,ended:!0}));s.add((0,N.$Rc)(()=>h.removeListener("error",r))),h.on("error",r),s.add((0,N.$Rc)(()=>h.removeListener("end",a))),h.on("end",a),s.add((0,N.$Rc)(()=>h.removeListener("data",t))),h.on("data",t)})}e.$ae=c;function $(h,E){const n=R(E);return n.end(h),n}e.$be=$;function y(){const h=R(()=>{throw new Error("not supported")});return h.end(),h}e.$ce=y;function b(h){let E=!1;return{read:()=>E?null:(E=!0,h)}}e.$de=b;function l(h,E,n){const o=R(n);return d(h,{onData:s=>o.write(E.data(s)),onError:s=>o.error(E.error?E.error(s):s),onEnd:()=>o.end()}),o}e.$ee=l;function f(h,E,n){let o=!1;return{read:()=>{const s=E.read();return o?s:(o=!0,s!==null?n([h,s]):h)}}}e.$fe=f;function m(h,E,n){let o=!1;const s=R(n);return d(E,{onData:i=>o?s.write(i):(o=!0,s.write(n([h,i]))),onError:i=>s.error(i),onEnd:()=>{o||(o=!0,s.write(h)),s.end()}}),s}e.$ge=m}),define(le[15],he([0,1,52,46]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=void 0;const A=typeof Buffer<"u",j=new D.$V(()=>new Uint8Array(256));let O,R;class k{static alloc(p){return A?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return A&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,I){return!(I?.dontUseNodeBuffer||!1)&&A?new k(Buffer.from(p)):(O||(O=new TextEncoder),new k(O.encode(p)))}static fromByteArray(p){const I=k.alloc(p.length);for(let T=0,F=p.length;T<F;T++)I.buffer[T]=p[T];return I}static concat(p,I){if(typeof I>"u"){I=0;for(let M=0,z=p.length;M<z;M++)I+=p[M].byteLength}const T=k.alloc(I);let F=0;for(let M=0,z=p.length;M<z;M++){const Z=p[M];T.set(Z,F),F+=Z.byteLength}return T}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return A?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(p,I){return new k(this.buffer.subarray(p,I))}set(p,I){if(p instanceof k)this.buffer.set(p.buffer,I);else if(p instanceof Uint8Array)this.buffer.set(p,I);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),I);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return d(this.buffer,p)}writeUInt32BE(p,I){c(this.buffer,p,I)}readUInt32LE(p){return $(this.buffer,p)}writeUInt32LE(p,I){y(this.buffer,p,I)}readUInt8(p){return b(this.buffer,p)}writeUInt8(p,I){l(this.buffer,p,I)}indexOf(p,I=0){return g(this.buffer,p instanceof k?p.buffer:p,I)}}e.$he=k;function g(u,p,I=0){const T=p.byteLength,F=u.byteLength;if(T===0)return 0;if(T===1)return u.indexOf(p[0]);if(T>F-I)return-1;const M=j.value;M.fill(p.length);for(let x=0;x<p.length;x++)M[p[x]]=p.length-x-1;let z=I+p.length-1,Z=z,J=-1;for(;z<F;)if(u[z]===p[Z]){if(Z===0){J=z;break}z--,Z--}else z+=Math.max(p.length-Z,M[u[z]]),Z=p.length-1;return J}e.$ie=g;function C(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$je=C;function S(u,p,I){u[I+0]=p&255,p=p>>>8,u[I+1]=p&255}e.$ke=S;function d(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$le=d;function c(u,p,I){u[I+3]=p,p=p>>>8,u[I+2]=p,p=p>>>8,u[I+1]=p,p=p>>>8,u[I]=p}e.$me=c;function $(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$ne=$;function y(u,p,I){u[I+0]=p&255,p=p>>>8,u[I+1]=p&255,p=p>>>8,u[I+2]=p&255,p=p>>>8,u[I+3]=p&255}e.$oe=y;function b(u,p){return u[p]}e.$pe=b;function l(u,p,I){u[I]=p}e.$qe=l;function f(u){return N.$9d(u,p=>k.concat(p))}e.$re=f;function m(u){return N.$de(u)}e.$se=m;function h(u){return N.$$d(u,p=>k.concat(p))}e.$te=h;async function E(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await h(u.stream)])}e.$ue=E;function n(u){return N.$be(u,p=>k.concat(p))}e.$ve=n;function o(u){return N.$ee(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$we=o;function s(u){return N.$8d(p=>k.concat(p),u)}e.$xe=s;function i(u,p){return N.$fe(u,p,I=>k.concat(I))}e.$ye=i;function t(u,p){return N.$ge(u,p,I=>k.concat(I))}e.$ze=t;function r(u){let p=0,I=0,T=0;const F=new Uint8Array(Math.floor(u.length/4*3)),M=Z=>{switch(I){case 3:F[T++]=p|Z,I=0;break;case 2:F[T++]=p|Z>>>2,p=Z<<6,I=3;break;case 1:F[T++]=p|Z>>>4,p=Z<<4,I=2;break;default:p=Z<<2,I=1}};for(let Z=0;Z<u.length;Z++){const J=u.charCodeAt(Z);if(J>=65&&J<=90)M(J-65);else if(J>=97&&J<=122)M(J-97+26);else if(J>=48&&J<=57)M(J-48+52);else if(J===43||J===45)M(62);else if(J===47||J===95)M(63);else{if(J===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Z]}`)}}const z=T;for(;I>0;)M(0);return k.wrap(F).slice(0,z)}e.$Ae=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:u},p=!0,I=!1){const T=I?v:a;let F="";const M=u.byteLength%3;let z=0;for(;z<u.byteLength-M;z+=3){const Z=u[z+0],J=u[z+1],x=u[z+2];F+=T[Z>>>2],F+=T[(Z<<4|J>>>4)&63],F+=T[(J<<2|x>>>6)&63],F+=T[x&63]}if(M===1){const Z=u[z+0];F+=T[Z>>>2],F+=T[Z<<4&63],p&&(F+="==")}else if(M===2){const Z=u[z+0],J=u[z+1];F+=T[Z>>>2],F+=T[(Z<<4|J>>>4)&63],F+=T[J<<2&63],p&&(F+="=")}return F}e.$Be=w}),define(le[27],he([0,1,128,52]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ff=e.$Ef=e.$Df=e.$Cf=e.GraphemeBreakType=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=void 0;function A(re){return!re||typeof re!="string"?!0:re.trim().length===0}e.$He=A;const j=/{(\d+)}/g;function O(re,...$e){return $e.length===0?re:re.replace(j,function(be,ve){const pe=parseInt(ve,10);return isNaN(pe)||pe<0||pe>=$e.length?be:$e[pe]})}e.$Ie=O;const R=/{([^}]+)}/g;function k(re,$e){return Object.keys($e).length===0?re:re.replace(R,(be,ve)=>$e[ve]??be)}e.$Je=k;function g(re){return re.replace(/[<>"'&]/g,$e=>{switch($e){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return $e})}e.$Ke=g;function C(re){return re.replace(/[<>&]/g,function($e){switch($e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return $e}})}e.$Le=C;function S(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Me=S;function d(re,$e){let be=0;const ve=$e.charCodeAt(0);for(let pe=re.length-1;pe>=0;pe--)re.charCodeAt(pe)===ve&&be++;return be}e.$Ne=d;function c(re,$e,be="\u2026"){return re.length<=$e?re:`${re.substr(0,$e)}${be}`}e.$Oe=c;function $(re,$e,be="\u2026"){if(re.length<=$e)return re;const ve=Math.ceil($e/2)-be.length/2,pe=Math.floor($e/2)-be.length/2;return`${re.substr(0,ve)}${be}${re.substr(re.length-pe)}`}e.$Pe=$;function y(re,$e=" "){const be=b(re,$e);return l(be,$e)}e.$Qe=y;function b(re,$e){if(!re||!$e)return re;const be=$e.length;if(be===0||re.length===0)return re;let ve=0;for(;re.indexOf($e,ve)===ve;)ve=ve+be;return re.substring(ve)}e.$Re=b;function l(re,$e){if(!re||!$e)return re;const be=$e.length,ve=re.length;if(be===0||ve===0)return re;let pe=ve,ke=-1;for(;ke=re.lastIndexOf($e,pe-1),!(ke===-1||ke+be!==pe);){if(ke===0)return"";pe=ke}return re.substring(0,pe)}e.$Se=l;function f(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Te=f;function m(re){return re.replace(/\*/g,"")}e.$Ue=m;function h(re,$e,be={}){if(!re)throw new Error("Cannot create regex from empty string");$e||(re=S(re)),be.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ve="";return be.global&&(ve+="g"),be.matchCase||(ve+="i"),be.multiline&&(ve+="m"),be.unicode&&(ve+="u"),new RegExp(re,ve)}e.$Ve=h;function E(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}e.$We=E;function n(re){return re.split(/\r\n|\r|\n/)}e.$Xe=n;function o(re){for(let $e=0,be=re.length;$e<be;$e++){const ve=re.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}e.$Ye=o;function s(re,$e=0,be=re.length){for(let ve=$e;ve<be;ve++){const pe=re.charCodeAt(ve);if(pe!==32&&pe!==9)return re.substring($e,ve)}return re.substring($e,be)}e.$Ze=s;function i(re,$e=re.length-1){for(let be=$e;be>=0;be--){const ve=re.charCodeAt(be);if(ve!==32&&ve!==9)return be}return-1}e.$1e=i;function t(re,$e,be){const ve=[];let pe=0;for(const ke of re.matchAll($e)){if(ve.push(re.slice(pe,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");pe=ke.index+ke[0].length,ve.push(be(ke[0],...ke.slice(1),ke.index,re,ke.groups))}return ve.push(re.slice(pe)),Promise.all(ve).then(ke=>ke.join(""))}e.$2e=t;function r(re,$e){return re<$e?-1:re>$e?1:0}e.$3e=r;function a(re,$e,be=0,ve=re.length,pe=0,ke=$e.length){for(;be<ve&&pe<ke;be++,pe++){const Le=re.charCodeAt(be),Ge=$e.charCodeAt(pe);if(Le<Ge)return-1;if(Le>Ge)return 1}const Ie=ve-be,Ae=ke-pe;return Ie<Ae?-1:Ie>Ae?1:0}e.$4e=a;function v(re,$e){return w(re,$e,0,re.length,0,$e.length)}e.$5e=v;function w(re,$e,be=0,ve=re.length,pe=0,ke=$e.length){for(;be<ve&&pe<ke;be++,pe++){let Le=re.charCodeAt(be),Ge=$e.charCodeAt(pe);if(Le===Ge)continue;if(Le>=128||Ge>=128)return a(re.toLowerCase(),$e.toLowerCase(),be,ve,pe,ke);p(Le)&&(Le-=32),p(Ge)&&(Ge-=32);const Ue=Le-Ge;if(Ue!==0)return Ue}const Ie=ve-be,Ae=ke-pe;return Ie<Ae?-1:Ie>Ae?1:0}e.$6e=w;function u(re){return re>=48&&re<=57}e.$7e=u;function p(re){return re>=97&&re<=122}e.$8e=p;function I(re){return re>=65&&re<=90}e.$9e=I;function T(re,$e){return re.length===$e.length&&w(re,$e)===0}e.$0e=T;function F(re,$e){const be=$e.length;return $e.length>re.length?!1:w(re,$e,0,be)===0}e.$$e=F;function M(re,$e){const be=Math.min(re.length,$e.length);let ve;for(ve=0;ve<be;ve++)if(re.charCodeAt(ve)!==$e.charCodeAt(ve))return ve;return be}e.$_e=M;function z(re,$e){const be=Math.min(re.length,$e.length);let ve;const pe=re.length-1,ke=$e.length-1;for(ve=0;ve<be;ve++)if(re.charCodeAt(pe-ve)!==$e.charCodeAt(ke-ve))return ve;return be}e.$af=z;function Z(re){return 55296<=re&&re<=56319}e.$bf=Z;function J(re){return 56320<=re&&re<=57343}e.$cf=J;function x(re,$e){return(re-55296<<10)+($e-56320)+65536}e.$df=x;function G(re,$e,be){const ve=re.charCodeAt(be);if(Z(ve)&&be+1<$e){const pe=re.charCodeAt(be+1);if(J(pe))return x(ve,pe)}return ve}e.$ef=G;function Q(re,$e){const be=re.charCodeAt($e-1);if(J(be)&&$e>1){const ve=re.charCodeAt($e-2);if(Z(ve))return x(ve,be)}return be}class V{get offset(){return this.e}constructor($e,be=0){this.c=$e,this.d=$e.length,this.e=be}setOffset($e){this.e=$e}prevCodePoint(){const $e=Q(this.c,this.e);return this.e-=$e>=65536?2:1,$e}nextCodePoint(){const $e=G(this.c,this.d,this.e);return this.e+=$e>=65536?2:1,$e}eol(){return this.e>=this.d}}e.$ff=V;class B{get offset(){return this.c.offset}constructor($e,be=0){this.c=new V($e,be)}nextGraphemeLength(){const $e=Pe.getInstance(),be=this.c,ve=be.offset;let pe=$e.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const ke=be.offset,Ie=$e.getGraphemeBreakType(be.nextCodePoint());if(ge(pe,Ie)){be.setOffset(ke);break}pe=Ie}return be.offset-ve}prevGraphemeLength(){const $e=Pe.getInstance(),be=this.c,ve=be.offset;let pe=$e.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const ke=be.offset,Ie=$e.getGraphemeBreakType(be.prevCodePoint());if(ge(Ie,pe)){be.setOffset(ke);break}pe=Ie}return ve-be.offset}eol(){return this.c.eol()}}e.$gf=B;function te(re,$e){return new B(re,$e).nextGraphemeLength()}e.$hf=te;function se(re,$e){return new B(re,$e).prevGraphemeLength()}e.$if=se;function _(re,$e){$e>0&&J(re.charCodeAt($e))&&$e--;const be=$e+te(re,$e);return[be-se(re,be),be]}e.$jf=_;function oe(re){const $e=new B(re);let be=0;for(;!$e.eol();)be++,$e.nextGraphemeLength();return be}e.$kf=oe;let K;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function P(re){return K||(K=U()),K.test(re)}e.$lf=P;const L=/^[\t\n\r\x20-\x7E]*$/;function H(re){return L.test(re)}e.$mf=H,e.$nf=/[\u2028\u2029]/;function q(re){return e.$nf.test(re)}e.$of=q;function ee(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}e.$pf=ee;function W(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}e.$qf=W;function Y(re,$e,be=""){const ve=re.trimStart();if(ve.length<$e)return ve;const pe=/\b/g;let ke=0;for(;pe.test(ve)&&!(ve.length-pe.lastIndex<$e);)ke=pe.lastIndex,pe.lastIndex+=1;return ke===0?ve:be+ve.substring(ke).trimStart()}e.$rf=Y;const ie=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ce=/\x1b\].*?\x07/g;function ae(re){return re&&(re=re.replace(ie,"").replace(ce,"")),re}e.$sf=ae,e.$tf=String.fromCharCode(65279);function fe(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}e.$uf=fe;function de(re){return fe(re)?re.substr(1):re}e.$vf=de;function we(re,$e){if(!re||!$e||re.length<$e.length)return!1;const be=$e.length,ve=re.toLowerCase();let pe=0,ke=-1;for(;pe<be;){const Ie=ve.indexOf($e[pe],ke+1);if(Ie<0)return!1;ke=Ie,pe++}return!0}e.$wf=we;function Ee(re,$e=!1){return re?($e&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}e.$xf=Ee;function Re(re){return re.charAt(0).toUpperCase()+re.slice(1)}e.$yf=Re;function Oe(re,$e=1){if($e===0)return"";let be=-1;do be=re.indexOf(`
`,be+1),$e--;while($e>0&&be>=0);return be===-1?re:(re[be-1]==="\r"&&be--,re.substr(0,be))}e.$zf=Oe;function Ne(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}e.$Af=Ne;function ue(re){return Pe.getInstance().getGraphemeBreakType(re)}e.$Bf=ue;function ge(re,$e){return re===0?$e!==5&&$e!==7:re===2&&$e===3?!1:re===4||re===2||re===3||$e===4||$e===2||$e===3?!0:!(re===8&&($e===8||$e===9||$e===11||$e===12)||(re===11||re===9)&&($e===9||$e===10)||(re===12||re===10)&&$e===10||$e===5||$e===13||$e===7||re===1||re===13&&$e===14||re===6&&$e===6)}var me;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(me||(e.GraphemeBreakType=me={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Ce()}getGraphemeBreakType($e){if($e<32)return $e===10?3:$e===13?2:4;if($e<127)return 0;const be=this.d,ve=be.length/3;let pe=1;for(;pe<=ve;)if($e<be[3*pe])pe=2*pe;else if($e>be[3*pe+1])pe=2*pe+1;else return be[3*pe+2];return 0}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(re,$e){if(re===0)return 0;const be=De(re,$e);if(be!==void 0)return be;const ve=new V($e,re);return ve.prevCodePoint(),ve.offset}e.$Cf=Me;function De(re,$e){const be=new V($e,re);let ve=be.prevCodePoint();for(;ze(ve)||ve===65039||ve===8419;){if(be.offset===0)return;ve=be.prevCodePoint()}if(!W(ve))return;let pe=be.offset;return pe>0&&be.prevCodePoint()===8205&&(pe=be.offset),pe}function ze(re){return 127995<=re&&re<=127999}var Te;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Te||(Te={})),e.$Df="\xA0";class Fe{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$De($e=>{function be(Ue){const Be=new Map;for(let We=0;We<Ue.length;We+=2)Be.set(Ue[We],Ue[We+1]);return Be}function ve(Ue,Be){const We=new Map(Ue);for(const[Xe,tt]of Be)We.set(Xe,tt);return We}function pe(Ue,Be){if(!Ue)return Be;const We=new Map;for(const[Xe,tt]of Ue)Be.has(Xe)&&We.set(Xe,tt);return We}const ke=this.c.value;let Ie=$e.filter(Ue=>!Ue.startsWith("_")&&Ue in ke);Ie.length===0&&(Ie=["_default"]);let Ae;for(const Ue of Ie){const Be=be(ke[Ue]);Ae=pe(Ae,Be)}const Le=be(ke._common),Ge=ve(Le,Ae);return new Fe(Ge)})}static getInstance($e){return Fe.d.get(Array.from($e))}static{this.e=new N.$V(()=>Object.keys(Fe.c.value).filter($e=>!$e.startsWith("_")))}static getLocales(){return Fe.e.value}constructor($e){this.f=$e}isAmbiguous($e){return this.f.has($e)}getPrimaryConfusable($e){return this.f.get($e)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Ef=Fe;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter($e){return qe.e().has($e)}static get codePoints(){return qe.e()}}e.$Ff=qe}),define(le[53],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=void 0;function N(l){return A(l,0)}e.$Ri=N;function A(l,f){switch(typeof l){case"object":return l===null?j(349,f):Array.isArray(l)?k(l,f):g(l,f);case"string":return R(l,f);case"boolean":return O(l,f);case"number":return j(l,f);case"undefined":return j(937,f);default:return j(617,f)}}e.$Si=A;function j(l,f){return(f<<5)-f+l|0}e.$Ti=j;function O(l,f){return j(l?433:863,f)}function R(l,f){f=j(149417,f);for(let m=0,h=l.length;m<h;m++)f=j(l.charCodeAt(m),f);return f}e.$Ui=R;function k(l,f){return f=j(104579,f),l.reduce((m,h)=>A(h,m),f)}function g(l,f){return f=j(181387,f),Object.keys(l).sort().reduce((m,h)=>(m=R(h,m),A(l[h],m)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=A(f,this.g),this.g}}e.$Vi=C;var S;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function d(l,f,m=32){const h=m-f,E=~((1<<h)-1);return(l<<f|(E&l)>>>h)>>>0}function c(l,f=0,m=l.byteLength,h=0){for(let E=0;E<m;E++)l[f+E]=h}function $(l,f,m="0"){for(;l.length<f;)l=m+l;return l}function y(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(m=>m.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),f/4)}e.$Wi=y;class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const m=f.length;if(m===0)return;const h=this.p;let E=this.r,n=this.u,o,s;for(n!==0?(o=n,s=-1,n=0):(o=f.charCodeAt(0),s=0);;){let i=o;if(D.$bf(o))if(s+1<m){const t=f.charCodeAt(s+1);D.$cf(t)?(s++,i=D.$df(o,t)):i=65533}else{n=o;break}else D.$cf(o)&&(i=65533);if(E=this.w(h,E,i),s++,s<m)o=f.charCodeAt(s);else break}this.r=E,this.u=n}w(f,m,h){return h<128?f[m++]=h:h<2048?(f[m++]=192|(h&1984)>>>6,f[m++]=128|(h&63)>>>0):h<65536?(f[m++]=224|(h&61440)>>>12,f[m++]=128|(h&4032)>>>6,f[m++]=128|(h&63)>>>0):(f[m++]=240|(h&1835008)>>>18,f[m++]=128|(h&258048)>>>12,f[m++]=128|(h&4032)>>>6,f[m++]=128|(h&63)>>>0),m>=64&&(this.y(),m-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,c(this.p,this.r),this.r>56&&(this.y(),c(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=b.g,m=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,m.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,d(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let h=this.h,E=this.l,n=this.m,o=this.n,s=this.o,i,t,r;for(let a=0;a<80;a++)a<20?(i=E&n|~E&o,t=1518500249):a<40?(i=E^n^o,t=1859775393):a<60?(i=E&n|E&o|n&o,t=2400959708):(i=E^n^o,t=3395469782),r=d(h,5)+i+s+t+f.getUint32(a*4,!1)&4294967295,s=o,o=n,n=d(E,30),E=h,h=r;this.h=this.h+h&4294967295,this.l=this.l+E&4294967295,this.m=this.m+n&4294967295,this.n=this.n+o&4294967295,this.o=this.o+s&4294967295}}e.$Xi=b}),define(le[89],he([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(A){A[A.Ignore=0]="Ignore",A[A.Info=1]="Info",A[A.Warning=2]="Warning",A[A.Error=3]="Error"})(N||(N={})),function(A){const j="error",O="warning",R="warn",k="info",g="ignore";function C(d){return d?D.$0e(j,d)?A.Error:D.$0e(O,d)||D.$0e(R,d)?A.Warning:D.$0e(k,d)?A.Info:A.Ignore:A.Ignore}A.fromValue=C;function S(d){switch(d){case A.Error:return j;case A.Warning:return O;case A.Info:return k;default:return g}}A.toString=S}(N||(N={})),e.default=N}),define(le[129],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=void 0,e.$Qd=Symbol("MicrotaskDelay")}),define(le[47],he([0,1,18,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=void 0;class A{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const $=c.charCodeAt(0),y=this.b.charCodeAt(this.c);return $-y}value(){return this.b[this.c]}}e.$6h=A;class j{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,N.$4e)(c,this.b,0,c.length,this.c,this.d):(0,N.$6e)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$7h=j;class O{constructor(c=!0,$=!0){this.f=c,this.g=$}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let $=c.length-1;$>=0;$--,this.c--){const y=this.b.charCodeAt($);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,N.$4e)(c,this.b,0,c.length,this.d,this.e):(0,N.$6e)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$8h=O;var R;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(R||(R={}));class k{constructor(c,$){this.f=c,this.g=$,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(3)),this.g(c)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===1)return(0,N.$5e)(c,this.c.scheme);if(this.d[this.e]===2)return(0,N.$5e)(c,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(c);if(this.d[this.e]===4)return(0,N.$3e)(c,this.c.query);if(this.d[this.e]===5)return(0,N.$3e)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$9h=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(C||(C={}));class S{static forUris(c=()=>!1,$=()=>!1){return new S(new k(c,$))}static forPaths(c=!1){return new S(new O(void 0,!c))}static forStrings(){return new S(new A)}static forConfigKeys(){return new S(new j)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,$){if($){const y=$.slice(0);(0,D.$Xb)(y);for(const b of y)this.set(b,c)}else{const y=c.slice(0);(0,D.$Xb)(y);for(const b of y)this.set(b[0],b[1])}}set(c,$){const y=this.b.reset(c);let b;this.c||(this.c=new g,this.c.segment=y.value());const l=[];for(b=this.c;;){const m=y.cmp(b.segment);if(m>0)b.left||(b.left=new g,b.left.segment=y.value()),l.push([-1,b]),b=b.left;else if(m<0)b.right||(b.right=new g,b.right.segment=y.value()),l.push([1,b]),b=b.right;else if(y.hasNext())y.next(),b.mid||(b.mid=new g,b.mid.segment=y.value()),l.push([0,b]),b=b.mid;else break}const f=b.value;b.value=$,b.key=c;for(let m=l.length-1;m>=0;m--){const h=l[m][1];h.updateHeight();const E=h.balanceFactor();if(E<-1||E>1){const n=l[m][0],o=l[m+1][0];if(n===1&&o===1)l[m][1]=h.rotateLeft();else if(n===-1&&o===-1)l[m][1]=h.rotateRight();else if(n===1&&o===-1)h.right=l[m+1][1]=l[m+1][1].rotateRight(),l[m][1]=h.rotateLeft();else if(n===-1&&o===1)h.left=l[m+1][1]=l[m+1][1].rotateLeft(),l[m][1]=h.rotateRight();else throw new Error;if(m>0)switch(l[m-1][0]){case-1:l[m-1][1].left=l[m][1];break;case 1:l[m-1][1].right=l[m][1];break;case 0:l[m-1][1].mid=l[m][1];break}else this.c=l[0][1]}}return f}get(c){return this.d(c)?.value}d(c){const $=this.b.reset(c);let y=this.c;for(;y;){const b=$.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if($.hasNext())$.next(),y=y.mid;else break}return y}has(c){const $=this.d(c);return!($?.value===void 0&&$?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,$){const y=this.b.reset(c),b=[];let l=this.c;for(;l;){const f=y.cmp(l.segment);if(f>0)b.push([-1,l]),l=l.left;else if(f<0)b.push([1,l]),l=l.right;else if(y.hasNext())y.next(),b.push([0,l]),l=l.mid;else break}if(l){if($?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const f=this.f(l.right);if(f.key){const{key:m,value:h,segment:E}=f;this.e(f.key,!1),l.key=m,l.value=h,l.segment=E}}else{const f=l.left??l.right;if(b.length>0){const[m,h]=b[b.length-1];switch(m){case-1:h.left=f;break;case 0:h.mid=f;break;case 1:h.right=f;break}}else this.c=f}for(let f=b.length-1;f>=0;f--){const m=b[f][1];m.updateHeight();const h=m.balanceFactor();if(h>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),b[f][1]=m.rotateLeft()):h<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),b[f][1]=m.rotateRight()),f>0)switch(b[f-1][0]){case-1:b[f-1][1].left=b[f][1];break;case 1:b[f-1][1].right=b[f][1];break;case 0:b[f-1][1].mid=b[f][1];break}else this.c=b[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const $=this.b.reset(c);let y=this.c,b;for(;y;){const l=$.cmp(y.segment);if(l>0)y=y.left;else if(l<0)y=y.right;else if($.hasNext())$.next(),b=y.value||b,y=y.mid;else break}return y&&y.value||b}findSuperstr(c){return this.g(c,!1)}g(c,$){const y=this.b.reset(c);let b=this.c;for(;b;){const l=y.cmp(b.segment);if(l>0)b=b.left;else if(l<0)b=b.right;else if(y.hasNext())y.next(),b=b.mid;else return b.mid?this.h(b.mid):$?b.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[$,y]of this)c(y,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const $=[];return this.j(c,$),$[Symbol.iterator]()}j(c,$){c&&(c.left&&this.j(c.left,$),c.value&&$.push([c.key,c.value]),c.mid&&this.j(c.mid,$),c.right&&this.j(c.right,$))}_isBalanced(){const c=$=>{if(!$)return!0;const y=$.balanceFactor();return y<-1||y>1?!1:c($.left)&&c($.right)};return c(this.c)}}e.$0h=S}),define(le[12],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=void 0;function D(E){return typeof E=="string"}e.$Gf=D;function N(E){return Array.isArray(E)&&E.every(n=>D(n))}e.$Hf=N;function A(E){return typeof E=="object"&&E!==null&&!Array.isArray(E)&&!(E instanceof RegExp)&&!(E instanceof Date)}e.$If=A;function j(E){const n=Object.getPrototypeOf(Uint8Array);return typeof E=="object"&&E instanceof n}e.$Jf=j;function O(E){return typeof E=="number"&&!isNaN(E)}e.$Kf=O;function R(E){return!!E&&typeof E[Symbol.iterator]=="function"}e.$Lf=R;function k(E){return E===!0||E===!1}e.$Mf=k;function g(E){return typeof E>"u"}e.$Nf=g;function C(E){return!S(E)}e.$Of=C;function S(E){return g(E)||E===null}e.$Pf=S;function d(E,n){if(!E)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$Qf=d;function c(E){if(S(E))throw new Error("Assertion Failed: argument is undefined or null");return E}e.$Rf=c;function $(...E){const n=[];for(let o=0;o<E.length;o++){const s=E[o];if(S(s))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);n.push(s)}return n}e.$Sf=$;const y=Object.prototype.hasOwnProperty;function b(E){if(!A(E))return!1;for(const n in E)if(y.call(E,n))return!1;return!0}e.$Tf=b;function l(E){return typeof E=="function"}e.$Uf=l;function f(...E){return E.length>0&&E.every(l)}e.$Vf=f;function m(E,n){const o=Math.min(E.length,n.length);for(let s=0;s<o;s++)h(E[s],n[s])}e.$Wf=m;function h(E,n){if(D(n)){if(typeof E!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(E instanceof n)return}catch{}if(!S(E)&&E.constructor===n||n.length===1&&n.call(void 0,E)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Xf=h}),define(le[30],he([0,1,12]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=void 0;function N(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const f=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([m,h])=>{f[m]=h&&typeof h=="object"?N(h):h}),f}e.$kn=N;function A(l){if(!l||typeof l!="object")return l;const f=[l];for(;f.length>0;){const m=f.shift();Object.freeze(m);for(const h in m)if(j.call(m,h)){const E=m[h];typeof E=="object"&&!Object.isFrozen(E)&&!(0,D.$Jf)(E)&&f.push(E)}}return l}e.$ln=A;const j=Object.prototype.hasOwnProperty;function O(l,f){return R(l,f,new Set)}e.$mn=O;function R(l,f,m){if((0,D.$Pf)(l))return l;const h=f(l);if(typeof h<"u")return h;if(Array.isArray(l)){const E=[];for(const n of l)E.push(R(n,f,m));return E}if((0,D.$If)(l)){if(m.has(l))throw new Error("Cannot clone recursive data-structure");m.add(l);const E={};for(const n in l)j.call(l,n)&&(E[n]=R(l[n],f,m));return m.delete(l),E}return l}function k(l,f,m=!0){return(0,D.$If)(l)?((0,D.$If)(f)&&Object.keys(f).forEach(h=>{h in l?m&&((0,D.$If)(l[h])&&(0,D.$If)(f[h])?k(l[h],f[h],m):l[h]=f[h]):l[h]=f[h]}),l):f}e.$nn=k;function g(l,f){if(l===f)return!0;if(l==null||f===null||f===void 0||typeof l!=typeof f||typeof l!="object"||Array.isArray(l)!==Array.isArray(f))return!1;let m,h;if(Array.isArray(l)){if(l.length!==f.length)return!1;for(m=0;m<l.length;m++)if(!g(l[m],f[m]))return!1}else{const E=[];for(h in l)E.push(h);E.sort();const n=[];for(h in f)n.push(h);if(n.sort(),!g(E,n))return!1;for(m=0;m<E.length;m++)if(!g(l[E[m]],f[E[m]]))return!1}return!0}e.$on=g;function C(l){const f=new Set;return JSON.stringify(l,(m,h)=>{if((0,D.$If)(h)||Array.isArray(h)){if(f.has(h))return"[Circular]";f.add(h)}return h})}e.$pn=C;function S(l,f){const m=Object.create(null);return!l||!f||Object.keys(f).forEach(E=>{const n=l[E],o=f[E];g(n,o)||(m[E]=o)}),m}e.$qn=S;function d(l,f){const m=f.toLowerCase(),h=Object.keys(l).find(E=>E.toLowerCase()===m);return h?l[h]:l[f]}e.$rn=d;function c(l,f){const m=Object.create(null);for(const[h,E]of Object.entries(l))f(h,E)&&(m[h]=E);return m}e.$sn=c;function $(l){let f=[];for(;Object.prototype!==l;)f=f.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return f}e.$tn=$;function y(l){const f=[];for(const m of $(l))typeof l[m]=="function"&&f.push(m);return f}e.$un=y;function b(l,f){const m=E=>function(){const n=Array.prototype.slice.call(arguments,0);return f(E,n)},h={};for(const E of l)h[E]=m(E);return h}e.$vn=b}),define(le[32],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(A){return D.test(A)}e.$ng=N,e.$og=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(R){for(let k=0;k<R.length;k++)R[k]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),O=[];for(let R=0;R<256;R++)O.push(R.toString(16).padStart(2,"0"));return function(){A(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let k=0,g="";return g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+="-",g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g+=O[j[k++]],g}}()}),define(le[130],he([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function A(O){const R=O.replace(/\-/g,":").toLowerCase();return!N.has(R)}function j(){const O=(0,D.networkInterfaces)();for(const R in O){const k=O[R];if(k){for(const{mac:g}of k)if(A(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$7m=j}),define(le[131],he([0,1,267,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lU=void 0;class A extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const R=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(O,R,k){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,N.$ie)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(O){this.a&&this.push(this.a),O()}}e.$lU=A}),define(le[132],he([0,1,63]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.$rg=e.$qg=void 0;function N(R,k,g,C=1){let S=!1;return new Promise(d=>{const c=setTimeout(()=>{if(!S)return S=!0,d(0)},g);A(R,k,C,$=>{if(!S)return S=!0,clearTimeout(c),d($)})})}e.$qg=N;function A(R,k,g,C){if(k===0)return C(0);const S=new D.Socket;S.once("connect",()=>(O(S),A(R+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",d=>(O(S),d.code!=="ECONNREFUSED"?A(R+g,k-1,g,C):C(R))),S.connect(R,"127.0.0.1")}e.$rg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,k,g,C="127.0.0.1"){let S=!1,d,c=1;const $=D.createServer({pauseOnConnect:!0});function y(b,l){S||(S=!0,$.removeAllListeners(),$.close(),d&&clearTimeout(d),l(b))}return new Promise(b=>{d=setTimeout(()=>{y(0,b)},g),$.on("listening",()=>{y(R,b)}),$.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&c<k?(R++,c++,$.listen(R,C)):y(0,b)}),$.on("close",()=>{y(0,b)}),$.listen(R,C)})}e.$sg=j;function O(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(k){console.error(k)}}}),define(le[133],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BU=void 0;function D(N){return!!N.parentPort}e.$BU=D}),define(le[134],he([13,9]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(le[64],he([0,1,134]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0;const N=60,A=N*60,j=A*24,O=j*7,R=j*30,k=j*365;function g(S,d,c,$){typeof S!="number"&&(S=S.getTime());const y=Math.round((new Date().getTime()-S)/1e3);if(y<-30)return(0,D.localize)(0,null,g(new Date().getTime()+y*1e3,!1));if(!$&&y<30)return(0,D.localize)(1,null);let b;return y<N?(b=y,d?b===1?c?(0,D.localize)(2,null,b):(0,D.localize)(3,null,b):c?(0,D.localize)(4,null,b):(0,D.localize)(5,null,b):b===1?c?(0,D.localize)(6,null,b):(0,D.localize)(7,null,b):c?(0,D.localize)(8,null,b):(0,D.localize)(9,null,b)):y<A?(b=Math.floor(y/N),d?b===1?c?(0,D.localize)(10,null,b):(0,D.localize)(11,null,b):c?(0,D.localize)(12,null,b):(0,D.localize)(13,null,b):b===1?c?(0,D.localize)(14,null,b):(0,D.localize)(15,null,b):c?(0,D.localize)(16,null,b):(0,D.localize)(17,null,b)):y<j?(b=Math.floor(y/A),d?b===1?c?(0,D.localize)(18,null,b):(0,D.localize)(19,null,b):c?(0,D.localize)(20,null,b):(0,D.localize)(21,null,b):b===1?c?(0,D.localize)(22,null,b):(0,D.localize)(23,null,b):c?(0,D.localize)(24,null,b):(0,D.localize)(25,null,b)):y<O?(b=Math.floor(y/j),d?b===1?(0,D.localize)(26,null,b):(0,D.localize)(27,null,b):b===1?(0,D.localize)(28,null,b):(0,D.localize)(29,null,b)):y<R?(b=Math.floor(y/O),d?b===1?c?(0,D.localize)(30,null,b):(0,D.localize)(31,null,b):c?(0,D.localize)(32,null,b):(0,D.localize)(33,null,b):b===1?c?(0,D.localize)(34,null,b):(0,D.localize)(35,null,b):c?(0,D.localize)(36,null,b):(0,D.localize)(37,null,b)):y<k?(b=Math.floor(y/R),d?b===1?c?(0,D.localize)(38,null,b):(0,D.localize)(39,null,b):c?(0,D.localize)(40,null,b):(0,D.localize)(41,null,b):b===1?c?(0,D.localize)(42,null,b):(0,D.localize)(43,null,b):c?(0,D.localize)(44,null,b):(0,D.localize)(45,null,b)):(b=Math.floor(y/k),d?b===1?c?(0,D.localize)(46,null,b):(0,D.localize)(47,null,b):c?(0,D.localize)(48,null,b):(0,D.localize)(49,null,b):b===1?c?(0,D.localize)(50,null,b):(0,D.localize)(51,null,b):c?(0,D.localize)(52,null,b):(0,D.localize)(53,null,b))}e.$tm=g;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$um=C}),define(le[135],he([13,9]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,18,12,135]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qi=e.$Pi=e.$Oi=void 0;function j(S,d){return d&&(S.stack||S.stacktrace)?A.localize(0,null,R(S),O(S.stack)||O(S.stacktrace)):R(S)}function O(S){return Array.isArray(S)?S.join(`
`):S}function R(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?A.localize(1,null,S.message):S.message||A.localize(2,null)}function k(S=null,d=!1){if(!S)return A.localize(3,null);if(Array.isArray(S)){const c=D.$Hb(S),$=k(c[0],d);return c.length>1?A.localize(4,null,$,c.length):$}if(N.$Gf(S))return S;if(S.detail){const c=S.detail;if(c.error)return j(c.error,d);if(c.exception)return j(c.exception,d)}return S.stack?j(S,d):S.message?S.message:A.localize(5,null)}e.$Oi=k;function g(S){const d=S;return d instanceof Error&&Array.isArray(d.actions)}e.$Pi=g;function C(S,d){let c;return typeof S=="string"?c=new Error(S):c=S,c.actions=d,c}e.$Qi=C}),define(le[136],he([13,9]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(le[137],he([0,1,136]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;function N(A){switch(A){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.$Mp=N}),define(le[138],he([13,9]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(le[5],he([0,1,138]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,A=!1,j=!1,O=!1,R=!1,k=!1,g=!1,C=!1,S=!1,d=!1,c,$=e.$g,y=e.$g,b,l;const f=globalThis;let m;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?m=f.vscode.process:typeof process<"u"&&(m=process);const h=typeof m?.versions?.electron=="string",E=h&&m?.type==="renderer";if(typeof m=="object"){N=m.platform==="win32",A=m.platform==="darwin",j=m.platform==="linux",O=j&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,g=h,S=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,c=e.$g,$=e.$g;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),I=p.availableLanguages["*"];c=p.locale,y=p.osLocale,$=I||e.$g,b=p._translationsConfigFile}catch{}R=!0}else typeof navigator=="object"&&!E?(l=navigator.userAgent,N=l.indexOf("Windows")>=0,A=l.indexOf("Macintosh")>=0,C=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,d=l?.indexOf("Mobi")>=0,k=!0,c=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,$=c,y=navigator.language):console.error("Unable to resolve platform.");var n;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(n||(e.Platform=n={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let s=0;A?s=1:N?s=3:j&&(s=2),e.$i=N,e.$j=A,e.$k=j,e.$l=O,e.$m=R,e.$n=g,e.$o=k,e.$p=k&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=C,e.$s=d,e.$t=S,e.$u=s,e.$v=l,e.$w=$;var i;(function(u){function p(){return e.$w}u.value=p;function I(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}u.isDefaultVariant=I;function T(){return e.$w==="en"}u.isDefault=T})(i||(e.Language=i={})),e.$x=c,e.$y=y,e.$z=b,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const u=[];f.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let T=0,F=u.length;T<F;T++){const M=u[T];if(M.id===I.data.vscodeScheduleAsyncWork){u.splice(T,1),M.callback();return}}});let p=0;return I=>{const T=++p;u.push({id:T,callback:I}),f.postMessage({vscodeScheduleAsyncWork:T},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=A||C?2:N?1:3;let r=!0,a=!1;function v(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.$D=v,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function w(u){return parseFloat(u)>=20}e.$J=w}),define(le[37],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const j=A.process;N={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(le[16],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,A=97,j=90,O=122,R=46,k=47,g=92,C=58,S=63;class d extends Error{constructor(o,s,i){let t;typeof s=="string"&&s.indexOf("not ")===0?(t="must not be",s=s.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${s}`;a+=`. Received type ${typeof i}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function c(n,o){if(n===null||typeof n!="object")throw new d(o,"Object",n)}function $(n,o){if(typeof n!="string")throw new d(o,"string",n)}const y=D.$dc==="win32";function b(n){return n===k||n===g}function l(n){return n===k}function f(n){return n>=N&&n<=j||n>=A&&n<=O}function m(n,o,s,i){let t="",r=0,a=-1,v=0,w=0;for(let u=0;u<=n.length;++u){if(u<n.length)w=n.charCodeAt(u);else{if(i(w))break;w=k}if(i(w)){if(!(a===u-1||v===1))if(v===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==R||t.charCodeAt(t.length-2)!==R){if(t.length>2){const p=t.lastIndexOf(s);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(s)),a=u,v=0;continue}else if(t.length!==0){t="",r=0,a=u,v=0;continue}}o&&(t+=t.length>0?`${s}..`:"..",r=2)}else t.length>0?t+=`${s}${n.slice(a+1,u)}`:t=n.slice(a+1,u),r=u-a-1;a=u,v=0}else w===R&&v!==-1?++v:v=-1}return t}function h(n,o){c(o,"pathObject");const s=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return s?s===o.root?`${s}${i}`:`${s}${n}${i}`:i}e.$fc={resolve(...n){let o="",s="",i=!1;for(let t=n.length-1;t>=-1;t--){let r;if(t>=0){if(r=n[t],$(r,"path"),r.length===0)continue}else o.length===0?r=D.cwd():(r=D.env[`=${o}`]||D.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let v=0,w="",u=!1;const p=r.charCodeAt(0);if(a===1)b(p)&&(v=1,u=!0);else if(b(p))if(u=!0,b(r.charCodeAt(1))){let I=2,T=I;for(;I<a&&!b(r.charCodeAt(I));)I++;if(I<a&&I!==T){const F=r.slice(T,I);for(T=I;I<a&&b(r.charCodeAt(I));)I++;if(I<a&&I!==T){for(T=I;I<a&&!b(r.charCodeAt(I));)I++;(I===a||I!==T)&&(w=`\\\\${F}\\${r.slice(T,I)}`,v=I)}}}else v=1;else f(p)&&r.charCodeAt(1)===C&&(w=r.slice(0,2),v=2,a>2&&b(r.charCodeAt(2))&&(u=!0,v=3));if(w.length>0)if(o.length>0){if(w.toLowerCase()!==o.toLowerCase())continue}else o=w;if(i){if(o.length>0)break}else if(s=`${r.slice(v)}\\${s}`,i=u,u&&o.length>0)break}return s=m(s,!i,"\\",b),i?`${o}\\${s}`:`${o}${s}`||"."},normalize(n){$(n,"path");const o=n.length;if(o===0)return".";let s=0,i,t=!1;const r=n.charCodeAt(0);if(o===1)return l(r)?"\\":n;if(b(r))if(t=!0,b(n.charCodeAt(1))){let v=2,w=v;for(;v<o&&!b(n.charCodeAt(v));)v++;if(v<o&&v!==w){const u=n.slice(w,v);for(w=v;v<o&&b(n.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!b(n.charCodeAt(v));)v++;if(v===o)return`\\\\${u}\\${n.slice(w)}\\`;v!==w&&(i=`\\\\${u}\\${n.slice(w,v)}`,s=v)}}}else s=1;else f(r)&&n.charCodeAt(1)===C&&(i=n.slice(0,2),s=2,o>2&&b(n.charCodeAt(2))&&(t=!0,s=3));let a=s<o?m(n.slice(s),!t,"\\",b):"";return a.length===0&&!t&&(a="."),a.length>0&&b(n.charCodeAt(o-1))&&(a+="\\"),i===void 0?t?`\\${a}`:a:t?`${i}\\${a}`:`${i}${a}`},isAbsolute(n){$(n,"path");const o=n.length;if(o===0)return!1;const s=n.charCodeAt(0);return b(s)||o>2&&f(s)&&n.charCodeAt(1)===C&&b(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let o,s;for(let r=0;r<n.length;++r){const a=n[r];$(a,"path"),a.length>0&&(o===void 0?o=s=a:o+=`\\${a}`)}if(o===void 0)return".";let i=!0,t=0;if(typeof s=="string"&&b(s.charCodeAt(0))){++t;const r=s.length;r>1&&b(s.charCodeAt(1))&&(++t,r>2&&(b(s.charCodeAt(2))?++t:i=!1))}if(i){for(;t<o.length&&b(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(n,o){if($(n,"from"),$(o,"to"),n===o)return"";const s=e.$fc.resolve(n),i=e.$fc.resolve(o);if(s===i||(n=s.toLowerCase(),o=i.toLowerCase(),n===o))return"";let t=0;for(;t<n.length&&n.charCodeAt(t)===g;)t++;let r=n.length;for(;r-1>t&&n.charCodeAt(r-1)===g;)r--;const a=r-t;let v=0;for(;v<o.length&&o.charCodeAt(v)===g;)v++;let w=o.length;for(;w-1>v&&o.charCodeAt(w-1)===g;)w--;const u=w-v,p=a<u?a:u;let I=-1,T=0;for(;T<p;T++){const M=n.charCodeAt(t+T);if(M!==o.charCodeAt(v+T))break;M===g&&(I=T)}if(T!==p){if(I===-1)return i}else{if(u>p){if(o.charCodeAt(v+T)===g)return i.slice(v+T+1);if(T===2)return i.slice(v+T)}a>p&&(n.charCodeAt(t+T)===g?I=T:T===2&&(I=3)),I===-1&&(I=0)}let F="";for(T=t+I+1;T<=r;++T)(T===r||n.charCodeAt(T)===g)&&(F+=F.length===0?"..":"\\..");return v+=I,F.length>0?`${F}${i.slice(v,w)}`:(i.charCodeAt(v)===g&&++v,i.slice(v,w))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const o=e.$fc.resolve(n);if(o.length<=2)return n;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const s=o.charCodeAt(2);if(s!==S&&s!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return n},dirname(n){$(n,"path");const o=n.length;if(o===0)return".";let s=-1,i=0;const t=n.charCodeAt(0);if(o===1)return b(t)?n:".";if(b(t)){if(s=i=1,b(n.charCodeAt(1))){let v=2,w=v;for(;v<o&&!b(n.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&b(n.charCodeAt(v));)v++;if(v<o&&v!==w){for(w=v;v<o&&!b(n.charCodeAt(v));)v++;if(v===o)return n;v!==w&&(s=i=v+1)}}}}else f(t)&&n.charCodeAt(1)===C&&(s=o>2&&b(n.charCodeAt(2))?3:2,i=s);let r=-1,a=!0;for(let v=o-1;v>=i;--v)if(b(n.charCodeAt(v))){if(!a){r=v;break}}else a=!1;if(r===-1){if(s===-1)return".";r=s}return n.slice(0,r)},basename(n,o){o!==void 0&&$(o,"ext"),$(n,"path");let s=0,i=-1,t=!0,r;if(n.length>=2&&f(n.charCodeAt(0))&&n.charCodeAt(1)===C&&(s=2),o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let a=o.length-1,v=-1;for(r=n.length-1;r>=s;--r){const w=n.charCodeAt(r);if(b(w)){if(!t){s=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return s===i?i=v:i===-1&&(i=n.length),n.slice(s,i)}for(r=n.length-1;r>=s;--r)if(b(n.charCodeAt(r))){if(!t){s=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":n.slice(s,i)},extname(n){$(n,"path");let o=0,s=-1,i=0,t=-1,r=!0,a=0;n.length>=2&&n.charCodeAt(1)===C&&f(n.charCodeAt(0))&&(o=i=2);for(let v=n.length-1;v>=o;--v){const w=n.charCodeAt(v);if(b(w)){if(!r){i=v+1;break}continue}t===-1&&(r=!1,t=v+1),w===R?s===-1?s=v:a!==1&&(a=1):s!==-1&&(a=-1)}return s===-1||t===-1||a===0||a===1&&s===t-1&&s===i+1?"":n.slice(s,t)},format:h.bind(null,"\\"),parse(n){$(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.length;let i=0,t=n.charCodeAt(0);if(s===1)return b(t)?(o.root=o.dir=n,o):(o.base=o.name=n,o);if(b(t)){if(i=1,b(n.charCodeAt(1))){let I=2,T=I;for(;I<s&&!b(n.charCodeAt(I));)I++;if(I<s&&I!==T){for(T=I;I<s&&b(n.charCodeAt(I));)I++;if(I<s&&I!==T){for(T=I;I<s&&!b(n.charCodeAt(I));)I++;I===s?i=I:I!==T&&(i=I+1)}}}}else if(f(t)&&n.charCodeAt(1)===C){if(s<=2)return o.root=o.dir=n,o;if(i=2,b(n.charCodeAt(2))){if(s===3)return o.root=o.dir=n,o;i=3}}i>0&&(o.root=n.slice(0,i));let r=-1,a=i,v=-1,w=!0,u=n.length-1,p=0;for(;u>=i;--u){if(t=n.charCodeAt(u),b(t)){if(!w){a=u+1;break}continue}v===-1&&(w=!1,v=u+1),t===R?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return v!==-1&&(r===-1||p===0||p===1&&r===v-1&&r===a+1?o.base=o.name=n.slice(a,v):(o.name=n.slice(a,r),o.base=n.slice(a,v),o.ext=n.slice(r,v))),a>0&&a!==i?o.dir=n.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const E=(()=>{if(y){const n=/\\/g;return()=>{const o=D.cwd().replace(n,"/");return o.slice(o.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...n){let o="",s=!1;for(let i=n.length-1;i>=-1&&!s;i--){const t=i>=0?n[i]:E();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,s=t.charCodeAt(0)===k)}return o=m(o,!s,"/",l),s?`/${o}`:o.length>0?o:"."},normalize(n){if($(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===k,s=n.charCodeAt(n.length-1)===k;return n=m(n,!o,"/",l),n.length===0?o?"/":s?"./":".":(s&&(n+="/"),o?`/${n}`:n)},isAbsolute(n){return $(n,"path"),n.length>0&&n.charCodeAt(0)===k},join(...n){if(n.length===0)return".";let o;for(let s=0;s<n.length;++s){const i=n[s];$(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(n,o){if($(n,"from"),$(o,"to"),n===o||(n=e.$gc.resolve(n),o=e.$gc.resolve(o),n===o))return"";const s=1,i=n.length,t=i-s,r=1,a=o.length-r,v=t<a?t:a;let w=-1,u=0;for(;u<v;u++){const I=n.charCodeAt(s+u);if(I!==o.charCodeAt(r+u))break;I===k&&(w=u)}if(u===v)if(a>v){if(o.charCodeAt(r+u)===k)return o.slice(r+u+1);if(u===0)return o.slice(r+u)}else t>v&&(n.charCodeAt(s+u)===k?w=u:u===0&&(w=0));let p="";for(u=s+w+1;u<=i;++u)(u===i||n.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+w)}`},toNamespacedPath(n){return n},dirname(n){if($(n,"path"),n.length===0)return".";const o=n.charCodeAt(0)===k;let s=-1,i=!0;for(let t=n.length-1;t>=1;--t)if(n.charCodeAt(t)===k){if(!i){s=t;break}}else i=!1;return s===-1?o?"/":".":o&&s===1?"//":n.slice(0,s)},basename(n,o){o!==void 0&&$(o,"ext"),$(n,"path");let s=0,i=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=n.length){if(o===n)return"";let a=o.length-1,v=-1;for(r=n.length-1;r>=0;--r){const w=n.charCodeAt(r);if(w===k){if(!t){s=r+1;break}}else v===-1&&(t=!1,v=r+1),a>=0&&(w===o.charCodeAt(a)?--a===-1&&(i=r):(a=-1,i=v))}return s===i?i=v:i===-1&&(i=n.length),n.slice(s,i)}for(r=n.length-1;r>=0;--r)if(n.charCodeAt(r)===k){if(!t){s=r+1;break}}else i===-1&&(t=!1,i=r+1);return i===-1?"":n.slice(s,i)},extname(n){$(n,"path");let o=-1,s=0,i=-1,t=!0,r=0;for(let a=n.length-1;a>=0;--a){const v=n.charCodeAt(a);if(v===k){if(!t){s=a+1;break}continue}i===-1&&(t=!1,i=a+1),v===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||i===-1||r===0||r===1&&o===i-1&&o===s+1?"":n.slice(o,i)},format:h.bind(null,"/"),parse(n){$(n,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return o;const s=n.charCodeAt(0)===k;let i;s?(o.root="/",i=1):i=0;let t=-1,r=0,a=-1,v=!0,w=n.length-1,u=0;for(;w>=i;--w){const p=n.charCodeAt(w);if(p===k){if(!v){r=w+1;break}continue}a===-1&&(v=!1,a=w+1),p===R?t===-1?t=w:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&s?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?o.base=o.name=n.slice(p,a):(o.name=n.slice(p,t),o.base=n.slice(p,a),o.ext=n.slice(t,a))}return r>0?o.dir=n.slice(0,r-1):s&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(le[48],he([0,1,16,5,27,12]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=void 0;function O(r){return r===47||r===92}e.$Yf=O;function R(r){return r.replace(/[\\/]/g,D.$gc.sep)}e.$Zf=R;function k(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$1f=k;function g(r,a=D.$gc.sep){if(!r)return"";const v=r.length,w=r.charCodeAt(0);if(O(w)){if(O(r.charCodeAt(1))&&!O(r.charCodeAt(2))){let p=3;const I=p;for(;p<v&&!O(r.charCodeAt(p));p++);if(I!==p&&!O(r.charCodeAt(p+1))){for(p+=1;p<v;p++)if(O(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(l(w)&&r.charCodeAt(1)===58)return O(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<v;u++)if(O(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$2f=g;function C(r){if(!N.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let v=2;const w=v;for(;v<r.length&&(a=r.charCodeAt(v),a!==92);v++);return!(w===v||(a=r.charCodeAt(v+1),isNaN(a)||a===92))}e.$3f=C;const S=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=N.$i){const v=a?S:d;return!(!r||r.length===0||/^\s+$/.test(r)||(v.lastIndex=0,v.test(r))||a&&c.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$4f=$;function y(r,a,v){const w=r===a;return!v||w?w:!r||!a?!1:(0,A.$0e)(r,a)}e.$5f=y;function b(r,a,v,w=D.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(v){if(!(0,A.$$e)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===w&&p--,r.charAt(p)===w}return a.charAt(a.length-1)!==w&&(a+=w),r.indexOf(a)===0}e.$6f=b;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$7f=l;function f(r,a){return N.$i&&r.endsWith(":")&&(r+=D.sep),(0,D.$ic)(r)||(r=(0,D.$jc)(a,r)),r=(0,D.$hc)(r),N.$i?(r=(0,A.$Se)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,A.$Se)(r,D.sep),r||(r=D.sep)),r}e.$8f=f;function m(r){const a=(0,D.$hc)(r);return N.$i?r.length>3?!1:h(a)&&(r.length===2||a.charCodeAt(2)===92):a===D.$gc.sep}e.$9f=m;function h(r,a=N.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$0f=h;function E(r,a=N.$i){return h(r,a)?r[0]:void 0}e.$$f=E;function n(r,a,v){return a.length>r.length?-1:r===a?0:(v&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$_f=n;function o(r){const a=r.split(":");let v,w,u;for(const p of a){const I=Number(p);(0,j.$Kf)(I)?w===void 0?w=I:u===void 0&&(u=I):v=v?[v,p].join(":"):p}if(!v)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:v,line:w!==void 0?w:void 0,column:u!==void 0?u:w!==void 0?1:void 0}}e.$ag=o;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,v=8){let w="";for(let p=0;p<v;p++){let I;p===0&&N.$i&&!a&&(v===3||v===4)?I=i:I=s,w+=I.charAt(Math.floor(Math.random()*I.length))}let u;return a?u=`${a}-${w}`:u=w,r?(0,D.$jc)(r,u):u}e.$bg=t}),define(le[139],he([0,1,16]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.$8r=e.$7r=void 0,e.$7r=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},A={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(C){const S=(0,D.$oc)(C),d=N[S.toLowerCase()];return d!==void 0?d:O(C)}e.$8r=j;function O(C){const S=(0,D.$oc)(C);return A[S.toLowerCase()]}e.$9r=O;function R(C){for(const S in A)if(A[S]===C)return S}e.$0r=R;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const d=k.exec(C);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:S?void 0:C}e.$$r=g}),define(le[90],he([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=e.TerminateResponseCode=e.Source=void 0;var N;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(N||(e.Source=N={}));var A;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(A||(e.TerminateResponseCode=A={}));function j(R,...k){const g=k.reduce((d,c)=>(d[c]=!0,d),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(d=>!g[d]).forEach(d=>{for(let c=0;c<C.length;c++)if(d.search(C[c])!==-1){delete R[d];break}})}e.$Pl=j;function O(R){R&&(delete R.DEBUG,D.$j&&delete R.DYLD_LIBRARY_PATH,D.$k&&delete R.LD_PRELOAD)}e.$Ql=O}),define(le[10],he([0,1,16,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const A=/^\w[\w\d+.-]*$/,j=/^\//,O=/^\/\//;function R(i,t){if(!i.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!A.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(i,t){return!i&&!t?"file":i}function g(i,t){switch(i){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(t){return t instanceof c?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,v,w,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=v||C,this.fragment=w||C,R(this,u))}get fsPath(){return h(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:v,query:w,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),v===void 0?v=this.path:v===null&&(v=C),w===void 0?w=this.query:w===null&&(w=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&a===this.authority&&v===this.path&&w===this.query&&u===this.fragment?this:new b(r,a,v,w,u)}static parse(t,r=!1){const a=d.exec(t);return a?new b(a[2]||C,s(a[4]||C),s(a[5]||C),s(a[7]||C),s(a[9]||C),r):new b(C,C,C,C,C)}static file(t){let r=C;if(N.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new b("file",r,t,C,C)}static from(t,r){return new b(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&t.scheme==="file"?a=c.file(D.$fc.join(h(t,!0),...r)).path:a=D.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return E(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof c)return t;{const r=new b(t);return r._formatted=t.external??null,r._fsPath=t._sep===y?t.fsPath??null:null,r}}else return t}}e.URI=c;function $(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=$;const y=N.$i?1:void 0;class b extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(t=!1){return t?E(this,!0):(this._formatted||(this._formatted=E(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=y),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(i,t,r){let a,v=-1;for(let w=0;w<i.length;w++){const u=i.charCodeAt(w);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a!==void 0&&(a+=i.charAt(w));else{a===void 0&&(a=i.substr(0,w));const p=l[u];p!==void 0?(v!==-1&&(a+=encodeURIComponent(i.substring(v,w)),v=-1),a+=p):v===-1&&(v=w)}}return v!==-1&&(a+=encodeURIComponent(i.substring(v))),a!==void 0?a:i}function m(i){let t;for(let r=0;r<i.length;r++){const a=i.charCodeAt(r);a===35||a===63?(t===void 0&&(t=i.substr(0,r)),t+=l[a]):t!==void 0&&(t+=i[r])}return t!==void 0?t:i}function h(i,t){let r;return i.authority&&i.path.length>1&&i.scheme==="file"?r=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?t?r=i.path.substr(1):r=i.path[1].toLowerCase()+i.path.substr(2):r=i.path,N.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=h;function E(i,t){const r=t?m:f;let a="",{scheme:v,authority:w,path:u,query:p,fragment:I}=i;if(v&&(a+=v,a+=":"),(w||v==="file")&&(a+=S,a+=S),w){let T=w.indexOf("@");if(T!==-1){const F=w.substr(0,T);w=w.substr(T+1),T=F.lastIndexOf(":"),T===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,T),!1,!1),a+=":",a+=r(F.substr(T+1),!1,!0)),a+="@"}w=w.toLowerCase(),T=w.lastIndexOf(":"),T===-1?a+=r(w,!1,!0):(a+=r(w.substr(0,T),!1,!0),a+=w.substr(T))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const T=u.charCodeAt(1);T>=65&&T<=90&&(u=`/${String.fromCharCode(T+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const T=u.charCodeAt(0);T>=65&&T<=90&&(u=`${String.fromCharCode(T+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),I&&(a+="#",a+=t?I:f(I,!1,!1)),a}function n(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+n(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(o)?i.replace(o,t=>n(t)):i}}),define(le[140],he([0,1,10]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$dq=e.$cq=e.$bq=void 0;function N(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$bq=N;function A(g){const C=[];let S;try{const d=JSON.parse(g.arguments),c=d[d.length-1];c&&c.__$stack&&(d.pop(),S=c.__$stack),C.push(...d)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$cq=A;function j(g){if(typeof g!="string")return j(A(g).stack);const C=g;if(C){const S=O(C),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(d&&d.length===4)return{uri:D.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.$dq=j;function O(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function R(g,C){const{args:S,stack:d}=A(g),c=typeof S[0]=="string"&&S.length===1;let $=O(d);$&&($=`(${$.trim()})`);let y=[];if(typeof S[0]=="string"?$&&c?y=[`%c[${C}] %c${S[0]} %c${$}`,k("blue"),k(""),k("grey")]:y=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:y=[`%c[${C}]%`,k("blue"),...S],$&&!c&&y.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,y)}e.log=R;function k(g){return`color: ${g}`}}),define(le[65],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ah=e.$zh=e.$yh=void 0;function A(k){return JSON.stringify(k,O)}e.$yh=A;function j(k){let g=JSON.parse(k);return g=R(g),g}e.$zh=j;function O(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function R(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return N.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof D.$he||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=R(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=R(k[C],g+1))}return k}e.$Ah=R}),define(le[23],he([0,1,7,5,27,10]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.Schemas=void 0;var O;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={}));function R(d,c){return j.URI.isUri(d)?(0,A.$0e)(d.scheme,c):(0,A.$$e)(d,c+":")}e.$cg=R;function k(d,...c){return c.some($=>R(d,$))}e.$dg=k,e.$eg="vscode-tkn",e.$fg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${O.vscodeRemoteResource}`}set(c,$,y){this.a[c]=$,this.b[c]=y}setConnectionToken(c,$){this.c[c]=$}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(m){return D.$1(m),c}const $=c.authority;let y=this.a[$];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const b=this.b[$],l=this.c[$];let f=`path=${encodeURIComponent(c.path)}`;return typeof l=="string"&&(f+=`&${e.$fg}=${encodeURIComponent(l)}`),j.URI.from({scheme:N.$o?this.d:O.vscodeRemoteResource,authority:`${y}:${b}`,path:this.f,query:f})}}e.$gg=new g,e.$hg="vs/../../extensions",e.$ig="vs/../../node_modules",e.$jg="vs/../../node_modules.asar",e.$kg="vs/../../node_modules.asar.unpacked",e.$lg="vscode-app";class C{static{this.a=e.$lg}asBrowserUri(c){const $=this.b(c,ne);return this.uriToBrowserUri($)}uriToBrowserUri(c){return c.scheme===O.vscodeRemote?e.$gg.rewrite(c):c.scheme===O.file&&(N.$m||N.$q===`${O.vscodeFileResource}://${C.a}`)?c.with({scheme:O.vscodeFileResource,authority:c.authority||C.a,query:null,fragment:null}):c}asFileUri(c){const $=this.b(c,ne);return this.uriToFileUri($)}uriToFileUri(c){return c.scheme===O.vscodeFileResource?c.with({scheme:O.file,authority:c.authority!==C.a?c.authority:null,query:null,fragment:null}):c}b(c,$){return j.URI.isUri(c)?c:j.URI.parse($.toUrl(c))}}e.$mg=new C;var S;(function(d){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(c.get("3"));const $="vscode-coi";function y(l){let f;typeof l=="string"?f=new URL(l).searchParams:l instanceof URL?f=l.searchParams:j.URI.isUri(l)&&(f=new URL(l.toString(!0)).searchParams);const m=f?.get($);if(m)return c.get(m)}d.getHeadersFromQuery=y;function b(l,f,m){if(!globalThis.crossOriginIsolated)return;const h=f&&m?"3":m?"2":"1";l instanceof URLSearchParams?l.set($,h):l[$]=h}d.addSearchParam=b})(S||(e.COI=S={}))}),define(le[141],he([0,1,123,23,5,10]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8C=void 0;class O{constructor(d,c,$){this.id=d,this.dependencies=c,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(d,c,$)=>{typeof d!="string"&&($=c,c=d,d=null),(typeof c!="object"||!Array.isArray(c))&&($=c,c=null),this.c.push(new O(d,c,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){if(d.startsWith(window.location.origin)||d.startsWith("vscode-file://vscode-app"))return d;throw new Error(`[trusted_script_src] Invalid script url: ${d}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(d){return d}})))}async load(d){this.g();const c=await(this.a?this.i(d):this.b?this.h(d):this.j(d));if(!c)throw new Error(`Did not receive a define call from script ${d}`);if(Array.isArray(c.dependencies)&&c.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${d}. The dependencies are: ${c.dependencies.join(", ")}`);return typeof c.callback=="function"?c.callback([]):c.callback}h(d){return new Promise((c,$)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const b=()=>{y.removeEventListener("load",l),y.removeEventListener("error",f)},l=m=>{b(),c(this.c.pop())},f=m=>{b(),$(m)};y.addEventListener("load",l),y.addEventListener("error",f),this.f&&(d=this.f.createScriptURL(d)),y.setAttribute("src",d),window.document.getElementsByTagName("head")[0].appendChild(y)})}i(d){return new Promise((c,$)=>{try{this.f&&(d=this.f.createScriptURL(d)),importScripts(d),c(this.c.pop())}catch(y){$(y)}})}async j(d){try{const c=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,b=j.URI.parse(d).fsPath,l=c.readFileSync(b).toString(),f=y.wrap(l.replace(/^#!.*/,""));return new $.Script(f).runInThisContext().apply(),this.c.pop()}catch(c){throw c}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,d,c){if(D.$T){c===void 0&&(c=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const $=`${S}/${d}`;if(k.has($))return k.get($);let y;if(/^\w[\w\d+.-]*:\/\//.test($))y=$;else{const m=`${c&&!A.$o?N.$jg:N.$ig}/${$}`;y=N.$mg.asBrowserUri(m).toString(!0)}const b=R.INSTANCE.load(y);return k.set($,b),b}else return await new Promise(($,y)=>{ne([S],$,y)})}e.$8C=C}),define(le[19],he([0,1,48,23,16,5,27,10]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pg=e.DataUri=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function k(c){return(0,R.$wc)(c,!0)}e.$tg=k;class g{constructor($){this.a=$}compare($,y,b=!1){return $===y?0:(0,O.$3e)(this.getComparisonKey($,b),this.getComparisonKey(y,b))}isEqual($,y,b=!1){return $===y?!0:!$||!y?!1:this.getComparisonKey($,b)===this.getComparisonKey(y,b)}getComparisonKey($,y=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,y,b=!1){if($.scheme===y.scheme){if($.scheme===N.Schemas.file)return D.$6f(k($),k(y),this.a($))&&$.query===y.query&&(b||$.fragment===y.fragment);if((0,e.$Kg)($.authority,y.authority))return D.$6f($.path,y.path,this.a($),"/")&&$.query===y.query&&(b||$.fragment===y.fragment)}return!1}joinPath($,...y){return R.URI.joinPath($,...y)}basenameOrAuthority($){return(0,e.$Cg)($)||$.authority}basename($){return A.$gc.basename($.path)}extname($){return A.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let y;return $.scheme===N.Schemas.file?y=R.URI.file(A.$mc(k($))).path:(y=A.$gc.dirname($.path),$.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),y="/")),$.with({path:y})}normalizePath($){if(!$.path.length)return $;let y;return $.scheme===N.Schemas.file?y=R.URI.file(A.$hc(k($))).path:y=A.$gc.normalize($.path),$.with({path:y})}relativePath($,y){if($.scheme!==y.scheme||!(0,e.$Kg)($.authority,y.authority))return;if($.scheme===N.Schemas.file){const f=A.$lc(k($),k(y));return j.$i?D.$Zf(f):f}let b=$.path||"/";const l=y.path||"/";if(this.a($)){let f=0;for(const m=Math.min(b.length,l.length);f<m&&!(b.charCodeAt(f)!==l.charCodeAt(f)&&b.charAt(f).toLowerCase()!==l.charAt(f).toLowerCase());f++);b=l.substr(0,f)+b.substr(f)}return A.$gc.relative(b,l)}resolvePath($,y){if($.scheme===N.Schemas.file){const b=R.URI.file(A.$kc(k($),y));return $.with({authority:b.authority,path:b.path})}return y=D.$1f(y),$.with({path:A.$gc.resolve($.path,y)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,y){return $===y||$!==void 0&&y!==void 0&&(0,O.$0e)($,y)}hasTrailingPathSeparator($,y=A.sep){if($.scheme===N.Schemas.file){const b=k($);return b.length>D.$2f(b).length&&b[b.length-1]===y}else{const b=$.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,y=A.sep){return(0,e.$Lg)($,y)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,y=A.sep){let b=!1;if($.scheme===N.Schemas.file){const l=k($);b=l!==void 0&&l.length===D.$2f(l).length&&l[l.length-1]===y}else{y="/";const l=$.path;b=l.length===1&&l.charCodeAt(l.length-1)===47}return!b&&!(0,e.$Lg)($,y)?$.with({path:$.path+"/"}):$}}e.$ug=g,e.$vg=new g(()=>!1),e.$wg=new g(c=>c.scheme===N.Schemas.file?!j.$k:!0),e.$xg=new g(c=>!0),e.$yg=e.$vg.isEqual.bind(e.$vg),e.$zg=e.$vg.isEqualOrParent.bind(e.$vg),e.$Ag=e.$vg.getComparisonKey.bind(e.$vg),e.$Bg=e.$vg.basenameOrAuthority.bind(e.$vg),e.$Cg=e.$vg.basename.bind(e.$vg),e.$Dg=e.$vg.extname.bind(e.$vg),e.$Eg=e.$vg.dirname.bind(e.$vg),e.$Fg=e.$vg.joinPath.bind(e.$vg),e.$Gg=e.$vg.normalizePath.bind(e.$vg),e.$Hg=e.$vg.relativePath.bind(e.$vg),e.$Ig=e.$vg.resolvePath.bind(e.$vg),e.$Jg=e.$vg.isAbsolutePath.bind(e.$vg),e.$Kg=e.$vg.isEqualAuthority.bind(e.$vg),e.$Lg=e.$vg.hasTrailingPathSeparator.bind(e.$vg),e.$Mg=e.$vg.removeTrailingPathSeparator.bind(e.$vg),e.$Ng=e.$vg.addTrailingPathSeparator.bind(e.$vg);function C(c,$){const y=[];for(let b=0;b<c.length;b++){const l=$(c[b]);c.some((f,m)=>m===b?!1:(0,e.$zg)(l,$(f)))||y.push(c[b])}return y}e.$Og=C;var S;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function $(y){const b=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(m=>{const[h,E]=m.split(":");h&&E&&b.set(h,E)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&b.set(c.META_DATA_MIME,f),b}c.parseMetaData=$})(S||(e.DataUri=S={}));function d(c,$,y){if($){let b=c.path;return b&&b[0]!==A.$gc.sep&&(b=A.$gc.sep+b),c.with({scheme:y,authority:$,path:b})}return c.with({scheme:y})}e.$Pg=d}),define(le[6],he([0,1,26,7,3,2,19,5,129,52]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.Promises=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=void 0;function C(W){return!!W&&typeof W.then=="function"}e.$Qg=C;function S(W){const Y=new D.$4d,ie=W(Y.token),ce=new Promise((ae,fe)=>{const de=Y.token.onCancellationRequested(()=>{de.dispose(),fe(new N.$5)});Promise.resolve(ie).then(we=>{de.dispose(),Y.dispose(),ae(we)},we=>{de.dispose(),Y.dispose(),fe(we)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ae,fe){return ce.then(ae,fe)}catch(ae){return this.then(void 0,ae)}finally(ae){return ce.finally(ae)}}}e.$Rg=S;function d(W,Y,ie){return new Promise((ce,ae)=>{const fe=Y.onCancellationRequested(()=>{fe.dispose(),ce(ie)});W.then(ce,ae).finally(()=>fe.dispose())})}e.$Sg=d;function c(W,Y){return new Promise((ie,ce)=>{const ae=Y.onCancellationRequested(()=>{ae.dispose(),ce(new N.$5)});W.then(ie,ce).finally(()=>ae.dispose())})}e.$Tg=c;async function $(W){let Y=-1;const ie=W.map((ce,ae)=>ce.then(fe=>(Y=ae,fe)));try{return await Promise.race(ie)}finally{W.forEach((ce,ae)=>{ae!==Y&&ce.cancel()})}}e.$Ug=$;function y(W,Y,ie){let ce;const ae=setTimeout(()=>{ce?.(void 0),ie?.()},Y);return Promise.race([W.finally(()=>clearTimeout(ae)),new Promise(fe=>ce=fe)])}e.$Vg=y;function b(W){return new Promise((Y,ie)=>{const ce=W();C(ce)?ce.then(Y,ie):Y(ce)})}e.$Wg=b;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const ie=()=>{if(this.b=null,this.f)return;const ce=this.queue(this.d);return this.d=null,ce};this.b=new Promise(ce=>{this.a.then(ie,ie).then(ce)})}return new Promise((ie,ce)=>{this.b.then(ie,ce)})}return this.a=Y(),new Promise((ie,ce)=>{this.a.then(ae=>{this.a=null,ie(ae)},ae=>{this.a=null,ce(ae)})})}dispose(){this.f=!0}}e.$Xg=l;class f{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$Yg=f;class m{constructor(){this.a=new Map}queue(Y,ie){const ae=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(ie).finally(()=>{this.a.get(Y)===ae&&this.a.delete(Y)});return this.a.set(Y,ae),ae}}e.$Zg=m;const h=(W,Y)=>{let ie=!0;const ce=setTimeout(()=>{ie=!1,Y()},W);return{isTriggered:()=>ie,dispose:()=>{clearTimeout(ce),ie=!1}}},E=W=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,W())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class n{constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,ie=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ae,fe)=>{this.d=ae,this.f=fe}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const ce=()=>{this.a=null,this.d?.(null)};return this.a=ie===k.$Qd?E(ce):h(ie,ce),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$1g=n;class o{constructor(Y){this.a=new n(Y),this.b=new l}trigger(Y,ie){return this.a.trigger(()=>this.b.queue(Y),ie)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$2g=o;class s{constructor(){this.a=!1,this.b=new Promise((Y,ie)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$3g=s;class i extends s{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$4g=i;function t(W,Y){return Y?new Promise((ie,ce)=>{const ae=setTimeout(()=>{fe.dispose(),ie()},W),fe=Y.onCancellationRequested(()=>{clearTimeout(ae),fe.dispose(),ce(new N.$5)})}):S(ie=>t(W,ie))}e.$5g=t;function r(W,Y=0,ie){const ce=setTimeout(()=>{W(),ie&&ae.dispose()},Y),ae=(0,j.$Rc)(()=>{clearTimeout(ce),ie?.deleteAndLeak(ae)});return ie?.add(ae),ae}e.$6g=r;function a(W){const Y=[];let ie=0;const ce=W.length;function ae(){return ie<ce?W[ie++]():null}function fe(de){de!=null&&Y.push(de);const we=ae();return we?we.then(fe):Promise.resolve(Y)}return Promise.resolve(null).then(fe)}e.$7g=a;function v(W,Y=ce=>!!ce,ie=null){let ce=0;const ae=W.length,fe=()=>{if(ce>=ae)return Promise.resolve(ie);const de=W[ce++];return Promise.resolve(de()).then(Ee=>Y(Ee)?Promise.resolve(Ee):fe())};return fe()}e.$8g=v;function w(W,Y=ce=>!!ce,ie=null){if(W.length===0)return Promise.resolve(ie);let ce=W.length;const ae=()=>{ce=-1;for(const fe of W)fe.cancel?.()};return new Promise((fe,de)=>{for(const we of W)we.then(Ee=>{--ce>=0&&Y(Ee)?(ae(),fe(Ee)):ce===0&&fe(ie)}).catch(Ee=>{--ce>=0&&(ae(),de(Ee))})})}e.$9g=w;class u{constructor(Y){this.a=0,this.d=Y,this.f=[],this.b=0,this.g=new A.$Td}get onDrained(){return this.g.event}get size(){return this.a}queue(Y){return this.a++,new Promise((ie,ce)=>{this.f.push({factory:Y,c:ie,e:ce}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const Y=this.f.shift();this.b++;const ie=Y.factory();ie.then(Y.c,Y.e),ie.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$0g=u;class p extends u{constructor(){super(1)}}e.$$g=p;class I{constructor(){this.a=new B,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$_g=I;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new _;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueFor(Y,ie=O.$vg){const ce=ie.getComparisonKey(Y);let ae=this.a.get(ce);if(!ae){ae=new p;const fe=this.f++,de=A.Event.once(ae.onDrained)(()=>{ae?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set(fe,de),this.a.set(ce,ae)}return ae}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ah=T;class F{constructor(Y,ie){this.a=-1,typeof Y=="function"&&typeof ie=="number"&&this.setIfNotSet(Y,ie)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,ie){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},ie)}setIfNotSet(Y,ie){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},ie))}}e.$bh=F;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,ie,ce=globalThis){this.cancel();const ae=ce.setInterval(()=>{Y()},ie);this.d=(0,j.$Rc)(()=>{ce.clearInterval(ae),this.d=void 0})}dispose(){this.cancel()}}e.$ch=M;class z{constructor(Y,ie){this.b=-1,this.a=Y,this.d=ie,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$dh=z;class Z{constructor(Y,ie){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.a=Y,this.b=ie,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$eh=Z;class J extends z{constructor(Y,ie){super(Y,ie),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$fh=J;class x extends j.$Tc{constructor(Y,ie){super(),this.g=Y,this.h=ie,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ie of Y)this.a.push(ie);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new z(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$gh=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$ih=(W,Y)=>{(0,R.$B)(()=>{if(ie)return;const ce=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ce-Date.now())}}))});let ie=!1;return{dispose(){ie||(ie=!0)}}}:e.$ih=(W,Y,ie)=>{const ce=W.requestIdleCallback(Y,typeof ie=="number"?{timeout:ie}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,W.cancelIdleCallback(ce))}}},e.$hh=W=>(0,e.$ih)(globalThis,W)}();class G{constructor(Y,ie){this.g=!1,this.d=()=>{try{this.j=ie()}catch(ce){this.l=ce}finally{this.g=!0}},this.f=(0,e.$ih)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$jh=G;class Q extends G{constructor(Y){super(globalThis,Y)}}e.$kh=Q;async function V(W,Y,ie){let ce;for(let ae=0;ae<ie;ae++)try{return await W()}catch(fe){ce=fe,await t(Y)}throw ce}e.$lh=V;class B{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,ie,ce){return this.a={taskId:Y,cancel:()=>ce?.(),promise:ie},ie.then(()=>this.d(Y),()=>this.d(Y)),ie}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{let ie,ce;const ae=new Promise((fe,de)=>{ie=fe,ce=de});this.b={run:Y,promise:ae,promiseResolve:ie,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$mh=B;class te{constructor(Y,ie=()=>Date.now()){this.d=Y,this.f=ie,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$nh=te;var se;(function(W){W[W.Resolved=0]="Resolved",W[W.Rejected=1]="Rejected"})(se||(se={}));class _{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Y,ie)=>{this.a=Y,this.b=ie})}complete(Y){return new Promise(ie=>{this.a(Y),this.d={outcome:0,value:Y},ie()})}error(Y){return new Promise(ie=>{this.b(Y),this.d={outcome:1,value:Y},ie()})}cancel(){return this.error(new N.$5)}}e.$oh=_;var oe;(function(W){async function Y(ce){let ae;const fe=await Promise.all(ce.map(de=>de.then(we=>we,we=>{ae||(ae=we)})));if(typeof ae<"u")throw ae;return fe}W.settled=Y;function ie(ce){return new Promise(async(ae,fe)=>{try{await ce(ae,fe)}catch(de){fe(de)}})}W.withAsyncBody=ie})(oe||(e.Promises=oe={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(ie=>(this.a=ie,this.d=!0,ie),ie=>{throw this.b=ie,this.d=!0,ie})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$ph=K;class U{constructor(Y){this.b=Y,this.a=new g.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$qh=U;var P;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(P||(P={}));class L{static fromArray(Y){return new L(ie=>{ie.emitMany(Y)})}static fromPromise(Y){return new L(async ie=>{ie.emitMany(await Y)})}static fromPromises(Y){return new L(async ie=>{await Promise.all(Y.map(async ce=>ie.emitOne(await ce)))})}static merge(Y){return new L(async ie=>{await Promise.all(Y.map(async ce=>{for await(const ae of ce)ie.emitOne(ae)}))})}static{this.EMPTY=L.fromArray([])}constructor(Y){this.a=0,this.b=[],this.d=null,this.f=new A.$Td,queueMicrotask(async()=>{const ie={emitOne:ce=>this.g(ce),emitMany:ce=>this.h(ce),reject:ce=>this.k(ce)};try{await Promise.resolve(Y(ie)),this.j()}catch(ce){this.k(ce)}finally{ie.emitOne=void 0,ie.emitMany=void 0,ie.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await A.Event.toPromise(this.f.event)}while(!0)}}}static map(Y,ie){return new L(async ce=>{for await(const ae of Y)ce.emitOne(ie(ae))})}map(Y){return L.map(this,Y)}static filter(Y,ie){return new L(async ce=>{for await(const ae of Y)ie(ae)&&ce.emitOne(ae)})}filter(Y){return L.filter(this,Y)}static coalesce(Y){return L.filter(Y,ie=>!!ie)}coalesce(){return L.coalesce(this)}static async toPromise(Y){const ie=[];for await(const ce of Y)ie.push(ce);return ie}toPromise(){return L.toPromise(this)}g(Y){this.a===0&&(this.b.push(Y),this.f.fire())}h(Y){this.a===0&&(this.b=this.b.concat(Y),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(Y){this.a===0&&(this.a=2,this.d=Y,this.f.fire())}}e.$rh=L;class H extends L{constructor(Y,ie){super(ie),this.l=Y}cancel(){this.l.cancel()}}e.$sh=H;function q(W){const Y=new D.$4d,ie=W(Y.token);return new H(Y,async ce=>{const ae=Y.token.onCancellationRequested(()=>{ae.dispose(),Y.dispose(),ce.reject(new N.$5)});try{for await(const fe of ie){if(Y.token.isCancellationRequested)return;ce.emitOne(fe)}ae.dispose(),Y.dispose()}catch(fe){ae.dispose(),Y.dispose(),ce.reject(fe)}})}e.$th=q;class ee{constructor(){this.a=new _,this.b=new L(ce=>{if(Y){ce.reject(Y);return}return ie&&ce.emitMany(ie),this.d=ae=>ce.reject(ae),this.f=ae=>ce.emitOne(ae),this.a.p});let Y,ie;this.f=ce=>{ie||(ie=[]),ie.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$uh=ee}),define(le[91],he([0,1,18,6,48,34,16,5,27]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=void 0;function g(){return Object.create(null)}e.$Fj=g,e.$Gj="**",e.$Hj="/";const C="[/\\\\]",S="[^/\\\\]",d=/\//g;function c(Q,V){switch(Q){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${V?`|${C}${S}+`:""})*?`}}function $(Q,V){if(!Q)return[];const B=[];let te=!1,se=!1,_="";for(const oe of Q){switch(oe){case V:if(!te&&!se){B.push(_),_="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":se=!0;break;case"]":se=!1;break}_+=oe}return _&&B.push(_),B}e.$Ij=$;function y(Q){if(!Q)return"";let V="";const B=$(Q,e.$Hj);if(B.every(te=>te===e.$Gj))V=".*";else{let te=!1;B.forEach((se,_)=>{if(se===e.$Gj){if(te)return;V+=c(2,_===B.length-1)}else{let oe=!1,K="",U=!1,P="";for(const L of se){if(L!=="}"&&oe){K+=L;continue}if(U&&(L!=="]"||!P)){let H;L==="-"?H=L:(L==="^"||L==="!")&&!P?H="^":L===e.$Hj?H="":H=(0,k.$Me)(L),P+=H;continue}switch(L){case"{":oe=!0;continue;case"[":U=!0;continue;case"}":{const q=`(?:${$(K,",").map(ee=>y(ee)).join("|")})`;V+=q,oe=!1,K="";break}case"]":{V+="["+P+"]",U=!1,P="";break}case"?":V+=S;continue;case"*":V+=c(1);continue;default:V+=(0,k.$Me)(L)}}_<B.length-1&&(B[_+1]!==e.$Gj||_+2<B.length)&&(V+=C)}te=se===e.$Gj})}return V}const b=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,E=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new j.$Dc(1e4),o=function(){return!1},s=function(){return null};function i(Q,V){if(!Q)return s;let B;typeof Q!="string"?B=Q.pattern:B=Q,B=B.trim();const te=`${B}_${!!V.trimForExclusions}`;let se=n.get(te);if(se)return t(se,Q);let _;return b.test(B)?se=a(B.substr(4),B):(_=l.exec(r(B,V)))?se=v(_[1],B):(V.trimForExclusions?m:f).test(B)?se=w(B,V):(_=h.exec(r(B,V)))?se=u(_[1].substr(1),B,!0):(_=E.exec(r(B,V)))?se=u(_[1],B,!1):se=p(B),n.set(te,se),t(se,Q)}function t(Q,V){if(typeof V=="string")return Q;const B=function(te,se){return(0,A.$6f)(te,V.base,!R.$k)?Q((0,k.$Re)(te.substr(V.base.length),O.sep),se):null};return B.allBasenames=Q.allBasenames,B.allPaths=Q.allPaths,B.basenames=Q.basenames,B.patterns=Q.patterns,B}function r(Q,V){return V.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function a(Q,V){return function(B,te){return typeof B=="string"&&B.endsWith(Q)?V:null}}function v(Q,V){const B=`/${Q}`,te=`\\${Q}`,se=function(oe,K){return typeof oe!="string"?null:K?K===Q?V:null:oe===Q||oe.endsWith(B)||oe.endsWith(te)?V:null},_=[Q];return se.basenames=_,se.patterns=[V],se.allBasenames=_,se}function w(Q,V){const B=x(Q.slice(1,-1).split(",").map(K=>i(K,V)).filter(K=>K!==s),Q),te=B.length;if(!te)return s;if(te===1)return B[0];const se=function(K,U){for(let P=0,L=B.length;P<L;P++)if(B[P](K,U))return Q;return null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const oe=B.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return oe.length&&(se.allPaths=oe),se}function u(Q,V,B){const te=O.sep===O.$gc.sep,se=te?Q:Q.replace(d,O.sep),_=O.sep+se,oe=O.$gc.sep+Q;let K;return B?K=function(U,P){return typeof U=="string"&&(U===se||U.endsWith(_)||!te&&(U===Q||U.endsWith(oe)))?V:null}:K=function(U,P){return typeof U=="string"&&(U===se||!te&&U===Q)?V:null},K.allPaths=[(B?"*/":"./")+Q],K}function p(Q){try{const V=new RegExp(`^${y(Q)}$`);return function(B){return V.lastIndex=0,typeof B=="string"&&V.test(B)?Q:null}}catch{return s}}function I(Q,V,B){return!Q||typeof V!="string"?!1:T(Q)(V,void 0,B)}e.$Jj=I;function T(Q,V={}){if(!Q)return o;if(typeof Q=="string"||F(Q)){const B=i(Q,V);if(B===s)return o;const te=function(se,_){return!!B(se,_)};return B.allBasenames&&(te.allBasenames=B.allBasenames),B.allPaths&&(te.allPaths=B.allPaths),te}return Z(Q,V)}e.$Kj=T;function F(Q){const V=Q;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Lj=F;function M(Q){return Q.allBasenames||[]}e.$Mj=M;function z(Q){return Q.allPaths||[]}e.$Nj=z;function Z(Q,V){const B=x(Object.getOwnPropertyNames(Q).map(K=>J(K,Q[K],V)).filter(K=>K!==s)),te=B.length;if(!te)return s;if(!B.some(K=>!!K.requiresSiblings)){if(te===1)return B[0];const K=function(L,H){let q;for(let ee=0,W=B.length;ee<W;ee++){const Y=B[ee](L,H);if(typeof Y=="string")return Y;(0,N.$Qg)(Y)&&(q||(q=[]),q.push(Y))}return q?(async()=>{for(const ee of q){const W=await ee;if(typeof W=="string")return W}return null})():null},U=B.find(L=>!!L.allBasenames);U&&(K.allBasenames=U.allBasenames);const P=B.reduce((L,H)=>H.allPaths?L.concat(H.allPaths):L,[]);return P.length&&(K.allPaths=P),K}const se=function(K,U,P){let L,H;for(let q=0,ee=B.length;q<ee;q++){const W=B[q];W.requiresSiblings&&P&&(U||(U=(0,O.$nc)(K)),L||(L=U.substr(0,U.length-(0,O.$oc)(K).length)));const Y=W(K,U,L,P);if(typeof Y=="string")return Y;(0,N.$Qg)(Y)&&(H||(H=[]),H.push(Y))}return H?(async()=>{for(const q of H){const ee=await q;if(typeof ee=="string")return ee}return null})():null},_=B.find(K=>!!K.allBasenames);_&&(se.allBasenames=_.allBasenames);const oe=B.reduce((K,U)=>U.allPaths?K.concat(U.allPaths):K,[]);return oe.length&&(se.allPaths=oe),se}function J(Q,V,B){if(V===!1)return s;const te=i(Q,B);if(te===s)return s;if(typeof V=="boolean")return te;if(V){const se=V.when;if(typeof se=="string"){const _=(oe,K,U,P)=>{if(!P||!te(oe,K))return null;const L=se.replace("$(basename)",()=>U),H=P(L);return(0,N.$Qg)(H)?H.then(q=>q?Q:null):H?Q:null};return _.requiresSiblings=!0,_}}return te}function x(Q,V){const B=Q.filter(K=>!!K.basenames);if(B.length<2)return Q;const te=B.reduce((K,U)=>{const P=U.basenames;return P?K.concat(P):K},[]);let se;if(V){se=[];for(let K=0,U=te.length;K<U;K++)se.push(V)}else se=B.reduce((K,U)=>{const P=U.patterns;return P?K.concat(P):K},[]);const _=function(K,U){if(typeof K!="string")return null;if(!U){let L;for(L=K.length;L>0;L--){const H=K.charCodeAt(L-1);if(H===47||H===92)break}U=K.substr(L)}const P=te.indexOf(U);return P!==-1?se[P]:null};_.basenames=te,_.patterns=se,_.allBasenames=te;const oe=Q.filter(K=>!K.basenames);return oe.push(_),oe}function G(Q,V){return(0,D.$ub)(Q,V,(B,te)=>typeof B=="string"&&typeof te=="string"?B===te:typeof B!="string"&&typeof te!="string"?B.base===te.base&&B.pattern===te.pattern:!1)}e.$Oj=G}),define(le[92],he([0,1,15,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=void 0;function A(S){return S.toJSON()}class j{constructor(d){this.a=d}transformIncoming(d){const c=this.a.transformIncoming(d);return c===d?d:A(N.URI.from(c))}transformOutgoing(d){const c=this.a.transformOutgoing(d);return c===d?d:A(N.URI.from(c))}transformOutgoingURI(d){const c=this.a.transformOutgoing(d);return c===d?d:N.URI.from(c)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$2m=j,e.$3m=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function O(S,d,c){if(!S||c>200)return null;if(typeof S=="object"){if(S instanceof N.URI)return d.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const y=O(S[$],d,c+1);y!==null&&(S[$]=y)}}return null}function R(S,d){const c=O(S,d,0);return c===null?S:c}e.$4m=R;function k(S,d,c,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return c?N.URI.revive(d.transformIncoming(S)):d.transformIncoming(S);if(S instanceof D.$he)return null;for(const y in S)if(Object.hasOwnProperty.call(S,y)){const b=k(S[y],d,c,$+1);b!==null&&(S[y]=b)}}return null}function g(S,d){const c=k(S,d,!1,0);return c===null?S:c}e.$5m=g;function C(S,d){const c=k(S,d,!0,0);return c===null?S:c}e.$6m=C}),define(le[142],he([0,1,36,47,32,130,5]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=void 0,e.$8m=new class{c(d){return this.a||(this.a=N.$0h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,c=0;const $=(0,D.networkInterfaces)();for(const y in $){const b=$[y];if(b)for(const{mac:l,internal:f}of b)f||(c+=1,this.c(l.toUpperCase())&&(d+=1))}this.b=c>0?d/c:0}return this.b}};let R;async function k(d){return R||(R=(async()=>await g(d)||A.$og())()),R}e.$9m=k;async function g(d){try{const c=await new Promise((y,b)=>{ne(["crypto"],y,b)}),$=(0,j.$7m)();return c.createHash("sha256").update($,"utf8").digest("hex")}catch(c){d(c);return}}const C="Software\\Microsoft\\SQMClient";async function S(d){if(O.$i){const c=await new Promise(($,y)=>{ne(["@vscode/windows-registry"],$,y)});try{return c.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return d($),""}}return""}e.$0m=S}),define(le[31],he([0,1,54,36,268,6,48,88,16,5,19,10]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var d;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function c(J,x=d.UNLINK,G){if((0,O.$9f)(J))throw new Error("rimraf - will refuse to recursively delete root");return x===d.UNLINK?y(J):$(J,G)}async function $(J,x=(0,O.$bg)((0,N.tmpdir)())){try{try{await D.promises.rename(J,x)}catch(G){return G.code==="ENOENT"?void 0:y(J)}y(x).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function y(J){return(0,A.promisify)(D.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function b(J){if((0,O.$9f)(J))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=b;async function l(J,x){return h(await(x?f(J):(0,A.promisify)(D.readdir)(J)))}async function f(J){try{return await(0,A.promisify)(D.readdir)(J,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const x=[],G=await l(J);for(const Q of G){let V=!1,B=!1,te=!1;try{const se=await e.Promises.lstat((0,k.$jc)(J,Q));V=se.isFile(),B=se.isDirectory(),te=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}x.push({name:Q,isFile:()=>V,isDirectory:()=>B,isSymbolicLink:()=>te})}return x}function m(J){return h(D.readdirSync(J))}e.readdirSync=m;function h(J){return J.map(x=>typeof x=="string"?g.$j?(0,R.$El)(x):x:(x.name=g.$j?(0,R.$El)(x.name):x.name,x))}async function E(J){const x=await l(J),G=[];for(const Q of x)await o.existsDirectory((0,k.$jc)(J,Q))&&G.push(Q);return G}function n(J,x=1e3){return new Promise(G=>{let Q=!1;const V=setInterval(()=>{Q||(Q=!0,D.access(J,B=>{Q=!1,B&&(clearInterval(V),G(void 0))}))},x)})}e.whenDeleted=n;var o;(function(J){async function x(V){let B;try{if(B=await e.Promises.lstat(V),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(g.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw se}throw te}}J.stat=x;async function G(V){try{const{stat:B,symbolicLink:te}=await J.stat(V);return B.isFile()&&te?.dangling!==!0}catch{}return!1}J.existsFile=G;async function Q(V){try{const{stat:B,symbolicLink:te}=await J.stat(V);return B.isDirectory()&&te?.dangling!==!0}catch{}return!1}J.existsDirectory=Q})(o||(e.SymlinkSupport=o={}));const s=new j.$ah;function i(J,x,G){return s.queueFor(S.URI.file(J),C.$wg).queue(()=>{const Q=w(G);return new Promise((V,B)=>a(J,x,Q,te=>te?B(te):V()))})}let t=!0;function r(J){t=J}e.configureFlushOnWrite=r;function a(J,x,G,Q){if(!t)return D.writeFile(J,x,{mode:G.mode,flag:G.flag},Q);D.open(J,G.flag,G.mode,(V,B)=>{if(V)return Q(V);D.writeFile(B,x,te=>{if(te)return D.close(B,()=>Q(te));D.fdatasync(B,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),r(!1)),D.close(B,_=>Q(_))))})})}function v(J,x,G){const Q=w(G);if(!t)return D.writeFileSync(J,x,{mode:Q.mode,flag:Q.flag});const V=D.openSync(J,Q.flag,Q.mode);try{D.writeFileSync(V,x);try{D.fdatasyncSync(V)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),r(!1)}}finally{D.closeSync(V)}}e.writeFileSync=v;function w(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function u(J,x,G=6e4){if(J!==x)try{g.$i&&typeof G=="number"?await p(J,x,Date.now(),G):await(0,A.promisify)(D.rename)(J,x)}catch(Q){if(J.toLowerCase()!==x.toLowerCase()&&Q.code==="EXDEV"||J.endsWith("."))await I(J,x,{preserveSymlinks:!1}),await c(J,d.MOVE);else throw Q}}async function p(J,x,G,Q,V=0){try{return await(0,A.promisify)(D.rename)(J,x)}catch(B){if(B.code!=="EACCES"&&B.code!=="EPERM"&&B.code!=="EBUSY")throw B;if(Date.now()-G>=Q)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${B}`),B;if(V===0){let te=!1;try{const{stat:se}=await o.stat(x);se.isFile()||(te=!0)}catch{}if(te)throw B}return await(0,j.$5g)(Math.min(100,V*10)),p(J,x,G,Q,V+1)}}async function I(J,x,G){return F(J,x,{root:{source:J,target:x},options:G,handledSourcePaths:new Set})}const T=511;async function F(J,x,G){if(G.handledSourcePaths.has(J))return;G.handledSourcePaths.add(J);const{stat:Q,symbolicLink:V}=await o.stat(J);if(V){if(G.options.preserveSymlinks)try{return await Z(J,x,G)}catch{}if(V.dangling)return}return Q.isDirectory()?M(J,x,Q.mode&T,G):z(J,x,Q.mode&T)}async function M(J,x,G,Q){await e.Promises.mkdir(x,{recursive:!0,mode:G});const V=await l(J);for(const B of V)await F((0,k.$jc)(J,B),(0,k.$jc)(x,B),Q)}async function z(J,x,G){await e.Promises.copyFile(J,x),await e.Promises.chmod(x,G)}async function Z(J,x,G){let Q=await e.Promises.readlink(J);(0,O.$6f)(Q,G.root.source,!g.$k)&&(Q=(0,k.$jc)(G.root.target,Q.substr(G.root.source.length+1))),await e.Promises.symlink(Q,x)}e.Promises=new class{get access(){return(0,A.promisify)(D.access)}get stat(){return(0,A.promisify)(D.stat)}get lstat(){return(0,A.promisify)(D.lstat)}get utimes(){return(0,A.promisify)(D.utimes)}get read(){return(J,x,G,Q,V)=>new Promise((B,te)=>{D.read(J,x,G,Q,V,(se,_,oe)=>se?te(se):B({bytesRead:_,buffer:oe}))})}get readFile(){return(0,A.promisify)(D.readFile)}get write(){return(J,x,G,Q,V)=>new Promise((B,te)=>{D.write(J,x,G,Q,V,(se,_,oe)=>se?te(se):B({bytesWritten:_,buffer:oe}))})}get appendFile(){return(0,A.promisify)(D.appendFile)}get fdatasync(){return(0,A.promisify)(D.fdatasync)}get truncate(){return(0,A.promisify)(D.truncate)}get copyFile(){return(0,A.promisify)(D.copyFile)}get open(){return(0,A.promisify)(D.open)}get close(){return(0,A.promisify)(D.close)}get symlink(){return(0,A.promisify)(D.symlink)}get readlink(){return(0,A.promisify)(D.readlink)}get chmod(){return(0,A.promisify)(D.chmod)}get mkdir(){return(0,A.promisify)(D.mkdir)}get unlink(){return(0,A.promisify)(D.unlink)}get rmdir(){return(0,A.promisify)(D.rmdir)}get realpath(){return(0,A.promisify)(D.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return E}get writeFile(){return i}get rm(){return c}get rename(){return u}get copy(){return I}}}),define(le[143],he([0,1,54,16,5,27,31]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=e.$jq=e.$iq=void 0;function R(d){if(A.$k)return d;const c=(0,N.$mc)(d);if(d===c)return d;const $=((0,N.$nc)(d)||d).toLowerCase();try{const b=(0,O.readdirSync)(c).filter(l=>l.toLowerCase()===$);if(b.length===1){const l=R(c);if(l)return(0,N.$jc)(l,b[0])}else if(b.length>1){const l=b.indexOf($);if(l>=0){const f=R(c);if(f)return(0,N.$jc)(f,b[l])}}}catch{}return null}e.$iq=R;async function k(d){if(A.$k)return d;const c=(0,N.$mc)(d);if(d===c)return d;const $=((0,N.$nc)(d)||d).toLowerCase();try{const b=(await O.Promises.readdir(c)).filter(l=>l.toLowerCase()===$);if(b.length===1){const l=await k(c);if(l)return(0,N.$jc)(l,b[0])}else if(b.length>1){const l=b.indexOf($);if(l>=0){const f=await k(c);if(f)return(0,N.$jc)(f,b[l])}}}catch{}return null}e.$jq=k;async function g(d){try{return await O.Promises.realpath(d)}catch{const $=S(d);return await O.Promises.access($,D.constants.R_OK),$}}e.$kq=g;function C(d){try{return D.realpathSync(d)}catch{const $=S(d);return D.accessSync($,D.constants.R_OK),$}}e.$lq=C;function S(d){return(0,j.$Se)((0,N.$hc)(d),N.sep)}}),define(le[144],he([0,1,16,5,37,90,12,31]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function k(S=A.env){return S.comspec||"cmd.exe"}e.$Rl=k;function g(S){let d=[],c=!1;const $=function(y){if(c){d.push(y);return}(!S.send(y,l=>{if(l&&console.error(l),c=!1,d.length>0){const f=d.slice(0);d=[],f.forEach(m=>$(m))}})||N.$i)&&(c=!0)};return{send:$}}e.$Sl=g;var C;(function(S){async function d(c,$,y){if(D.$ic(c))return c;if($===void 0&&($=A.cwd()),D.$mc(c)!=="."||(y===void 0&&O.$Gf(A.env.PATH)&&(y=A.env.PATH.split(D.$tc)),y===void 0||y.length===0))return D.$jc($,c);async function l(f){if(await R.Promises.exists(f)){let m;try{m=await R.Promises.stat(f)}catch(h){h.message.startsWith("EACCES")&&(m=await R.Promises.lstat(f))}return m?!m.isDirectory():!1}return!1}for(const f of y){let m;if(D.$ic(f)?m=D.$jc(f,c):m=D.$jc($,f,c),await l(m))return m;let h=m+".com";if(await l(h)||(h=m+".exe",await l(h)))return h}return D.$jc($,c)}S.findExecutable=d})(C||(e.win32=C={}))}),define(le[145],he([0,1,66,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;function A(O){return new Promise((R,k)=>{let g;const C=new Map;function S(c,$,y,b,l){const f=C.get($);if(c===O||f){const m={name:d(y),cmd:y,pid:c,ppid:$,load:b,mem:l};C.set(c,m),c===O&&(g=m),f&&(f.children||(f.children=[]),f.children.push(m),f.children.length>1&&(f.children=f.children.sort((h,E)=>h.pid-E.pid)))}}function d(c){const $=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,b=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,m=/--type=([a-zA-Z-]+)/;if(b.exec(c))return"electron-crash-reporter";if(l.exec(c))return"winpty-agent";if(f.exec(c))return"conpty-agent";let h=m.exec(c);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?$.exec(c)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const E=/[a-zA-Z-]+\.js/g;let n="";do h=E.exec(c),h&&(n+=h+" ");while(h);return n&&c.indexOf("node ")<0&&c.indexOf("node.exe")<0?`electron-nodejs (${n})`:y.exec(c)?`electron-nodejs (${c})`:c}if(process.platform==="win32"){const c=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,y)=>{ne(["@vscode/windows-process-tree"],$,y)}).then($=>{$.getProcessList(O,y=>{if(!y){k(new Error(`Root process ${O} not found`));return}$.getProcessCpuUsage(y,b=>{const l=new Map;b.forEach(f=>{const m=c(f.commandLine||"");l.set(f.pid,{name:d(m),cmd:m,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=l.get(O),g?(l.forEach(f=>{const m=l.get(f.ppid);m&&(m.children||(m.children=[]),m.children.push(f))}),l.forEach(f=>{f.children&&(f.children=f.children.sort((m,h)=>m.pid-h.pid))}),R(g)):k(new Error(`Root process ${O} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let c=function(){let $=[g];const y=[];for(;$.length;){const l=$.shift();l&&(y.push(l.pid),l.children&&($=$.concat(l.children)))}let b=JSON.stringify(N.$mg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);b+=" "+y.join(" "),(0,D.exec)(b,{},(l,f,m)=>{if(l||m)k(l||new Error(m.toString()));else{const h=f.toString().split(`
`);for(let E=0;E<y.length;E++){const n=C.get(y[E]);n.load=parseFloat(h[E])}if(!g){k(new Error(`Root process ${O} not found`));return}R(g)}})};(0,D.exec)("which ps",{},($,y,b)=>{if($||b)if(process.platform!=="linux")k($||new Error(b.toString()));else{const l=JSON.stringify(N.$mg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(l,{},(f,m,h)=>{f||h?k(f||new Error(h.toString())):(j(m,S),c())})}else{const l=y.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${l} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,h,E)=>{m||E&&!E.includes("screen size is bogus")?k(m||new Error(E.toString())):(j(h,S),process.platform==="linux"?c():g?R(g):k(new Error(`Root process ${O} not found`)))})}})}})}e.$Tr=A;function j(O,R){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=O.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&R(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var ye=this&&this.__decorate||function(ne,e,D,N){var A=arguments.length,j=A<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(ne,e,D,N);else for(var R=ne.length-1;R>=0;R--)(O=ne[R])&&(j=(A<3?O(j):A>3?O(e,D,j):O(e,D))||j);return A>3&&j&&Object.defineProperty(e,D,j),j};define(le[40],he([0,1,18,6,15,26,84,7,3,2,65,27,12]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.ProxyChannel=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.RequestInitiator=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=void 0;var c;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(c||(c={}));function $(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y||(y={}));function b(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(l||(l={}));function f(V){let B=0;for(let te=0;;te+=7){const se=V.read(1);if(B|=(se.buffer[0]&127)<<te,!(se.buffer[0]&128))return B}}const m=s(0);function h(V,B){if(B===0){V.write(m);return}let te=0;for(let _=B;_!==0;_=_>>>7)te++;const se=A.$he.alloc(te);for(let _=0;B!==0;_++)se.buffer[_]=B&127,B=B>>>7,B>0&&(se.buffer[_]|=128);V.write(se)}class E{constructor(B){this.b=B,this.a=0}read(B){const te=this.b.slice(this.a,this.a+B);return this.a+=te.byteLength,te}}e.$Bh=E;class n{constructor(){this.a=[]}get buffer(){return A.$he.concat(this.a)}write(B){this.a.push(B)}}e.$Ch=n;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function s(V){const B=A.$he.alloc(1);return B.writeUInt8(V,0),B}const i={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object),Uint:s(o.Int)},t=typeof Buffer<"u";function r(V,B){if(typeof B>"u")V.write(i.Undefined);else if(typeof B=="string"){const te=A.$he.fromString(B);V.write(i.String),h(V,te.byteLength),V.write(te)}else if(t&&Buffer.isBuffer(B)){const te=A.$he.wrap(B);V.write(i.Buffer),h(V,te.byteLength),V.write(te)}else if(B instanceof A.$he)V.write(i.VSBuffer),h(V,B.byteLength),V.write(B);else if(Array.isArray(B)){V.write(i.Array),h(V,B.length);for(const te of B)r(V,te)}else if(typeof B=="number"&&(B|0)===B)V.write(i.Uint),h(V,B);else{const te=A.$he.fromString(JSON.stringify(B));V.write(i.Object),h(V,te.byteLength),V.write(te)}}e.$Dh=r;function a(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(f(V)).toString();case o.Buffer:return V.read(f(V)).buffer;case o.VSBuffer:return V.read(f(V));case o.Array:{const te=f(V),se=[];for(let _=0;_<te;_++)se.push(a(V));return se}case o.Object:return JSON.parse(V.read(f(V)).toString());case o.Int:return f(V)}}e.$Eh=a;class v{constructor(B,te,se=null,_=1e3){this.h=B,this.j=te,this.k=se,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(oe=>this.q(oe)),this.m({type:200})}registerChannel(B,te){this.b.set(B,te),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const te=this.o([B.type]);this.k?.logOutgoing(te,0,1,b(B.type));return}case 201:case 202:case 204:case 203:{const te=this.o([B.type,B.id],B.data);this.k?.logOutgoing(te,B.id,1,b(B.type),B.data);return}}}o(B,te=void 0){const se=new n;return r(se,B),r(se,te),this.p(se.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const te=new E(B),se=a(te),_=a(te),oe=se[0];switch(oe){case 100:return this.k?.logIncoming(B.byteLength,se[1],1,`${$(oe)}: ${se[2]}.${se[3]}`,_),this.s({type:oe,id:se[1],channelName:se[2],name:se[3],arg:_});case 102:return this.k?.logIncoming(B.byteLength,se[1],1,`${$(oe)}: ${se[2]}.${se[3]}`,_),this.t({type:oe,id:se[1],channelName:se[2],name:se[3],arg:_});case 101:return this.k?.logIncoming(B.byteLength,se[1],1,`${$(oe)}`),this.u({type:oe,id:se[1]});case 103:return this.k?.logIncoming(B.byteLength,se[1],1,`${$(oe)}`),this.u({type:oe,id:se[1]})}}s(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=new j.$4d;let _;try{_=te.call(this.j,B.name,B.arg,se.token)}catch(U){_=Promise.reject(U)}const oe=B.id;_.then(U=>{this.m({id:oe,data:U,type:201})},U=>{U instanceof Error?this.m({id:oe,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:oe,data:U,type:203})}).finally(()=>{K.dispose(),this.d.delete(B.id)});const K=(0,g.$Rc)(()=>se.cancel());this.d.set(B.id,K)}t(B){const te=this.b.get(B.channelName);if(!te){this.v(B);return}const se=B.id,oe=te.listen(this.j,B.name,B.arg)(K=>this.m({id:se,data:K,type:204}));this.d.set(B.id,oe)}u(B){const te=this.d.get(B.id);te&&(te.dispose(),this.d.delete(B.id))}v(B){let te=this.g.get(B.channelName);te||(te=[],this.g.set(B.channelName,te));const se=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:B,timeoutTimer:se})}w(B){const te=this.g.get(B);if(te){for(const se of te)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Fh=v;var w;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class u{constructor(B,te=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Td,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=te}getChannel(B){const te=this;return{call(se,_,oe){return te.a?Promise.reject(new R.$5):te.m(B,se,_,oe)},listen(se,_){return te.a?k.Event.None:te.o(B,se,_)}}}m(B,te,se,_=j.CancellationToken.None){const oe=this.g++,U={id:oe,type:100,channelName:B,name:te,arg:se};if(_.isCancellationRequested)return Promise.reject(new R.$5);let P;return new Promise((H,q)=>{if(_.isCancellationRequested)return q(new R.$5);const ee=()=>{const ce=ae=>{switch(ae.type){case 201:this.f.delete(oe),H(ae.data);break;case 202:{this.f.delete(oe);const fe=new Error(ae.data.message);fe.stack=Array.isArray(ae.data.stack)?ae.data.stack.join(`
`):ae.data.stack,fe.name=ae.data.name,q(fe);break}case 203:this.f.delete(oe),q(ae.data);break}};this.f.set(oe,ce),this.p(U)};let W=null;this.b===l.Idle?ee():(W=(0,N.$Rg)(ce=>this.u()),W.then(()=>{W=null,ee()}));const Y=()=>{W?(W.cancel(),W=null):this.p({id:oe,type:101}),q(new R.$5)},ie=_.onCancellationRequested(Y);P=(0,g.$Qc)((0,g.$Rc)(Y),ie),this.d.add(P)}).finally(()=>{P.dispose(),this.d.delete(P)})}o(B,te,se){const _=this.g++,K={id:_,type:102,channelName:B,name:te,arg:se};let U=null;const P=new k.$Td({onWillAddFirstListener:()=>{U=(0,N.$Rg)(H=>this.u()),U.then(()=>{U=null,this.d.add(P),this.p(K)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(P),this.p({id:_,type:103}))}}),L=H=>P.fire(H.data);return this.f.set(_,L),P.event}p(B){switch(B.type){case 100:case 102:{const te=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(te,B.id,0,`${$(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const te=this.q([B.type,B.id]);this.j?.logOutgoing(te,B.id,0,$(B.type));return}}}q(B,te=void 0){const se=new n;return r(se,B),r(se,te),this.r(se.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const te=new E(B),se=a(te),_=a(te),oe=se[0];switch(oe){case 200:return this.j?.logIncoming(B.byteLength,0,0,b(oe)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,se[1],0,b(oe),_),this.t({type:se[0],id:se[1],data:_})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Gh=u,ye([O.$vh],u.prototype,"onDidInitializePromise",null);class p{get connections(){const B=[];return this.f.forEach(te=>B.push(te)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new k.$Td,this.onDidAddConnection=this.g.event,this.h=new k.$Td,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(B(({protocol:te,onDidClientDisconnect:se})=>{const _=k.Event.once(te.onMessage);this.j.add(_(oe=>{const K=new E(oe),U=a(K),P=new v(te,U),L=new u(te);this.a.forEach((q,ee)=>P.registerChannel(ee,q));const H={channelServer:P,channelClient:L,ctx:U};this.f.add(H),this.g.fire(H),this.j.add(se(()=>{P.dispose(),L.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(B,te){const se=this;return{call(_,oe,K){let U;if((0,d.$Uf)(te)){const L=(0,D.$4b)(se.connections.filter(te));U=L?Promise.resolve(L):k.Event.toPromise(k.Event.filter(se.onDidAddConnection,te))}else U=te.routeCall(se,_,oe);const P=U.then(L=>L.channelClient.getChannel(B));return T(P).call(_,oe,K)},listen(_,oe){if((0,d.$Uf)(te))return se.k(B,te,_,oe);const K=te.routeEvent(se,_,oe).then(U=>U.channelClient.getChannel(B));return T(K).listen(_,oe)}}}k(B,te,se,_){const oe=this;let K;const U=new k.$Td({onWillAddFirstListener:()=>{K=new g.$Sc;const P=new k.$Zd,L=new Map,H=ee=>{const Y=ee.channelClient.getChannel(B).listen(se,_),ie=P.add(Y);L.set(ee,ie)},q=ee=>{const W=L.get(ee);W&&(W.dispose(),L.delete(ee))};oe.connections.filter(te).forEach(H),k.Event.filter(oe.onDidAddConnection,te)(H,void 0,K),oe.onDidRemoveConnection(q,void 0,K),P.event(U.fire,U,K),K.add(P)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return U.event}registerChannel(B,te){this.a.set(B,te);for(const se of this.f)se.channelServer.registerChannel(B,te)}dispose(){this.j.dispose();for(const B of this.f)B.channelClient.dispose(),B.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Hh=p;class I{constructor(B,te,se=null){const _=new n;r(_,te),B.send(_.buffer),this.a=new u(B,se),this.d=new v(B,te,se)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,te){this.d.registerChannel(B,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Ih=I;function T(V){return{call(B,te,se){return V.then(_=>_.call(B,te,se))},listen(B,te){const se=new k.$3d;return V.then(_=>se.input=_.listen(B,te)),se.event}}}e.$Jh=T;function F(V){let B=!1;return{call(te,se,_){return B?V.call(te,se,_):(0,N.$5g)(0).then(()=>B=!0).then(()=>V.call(te,se,_))},listen(te,se){if(B)return V.listen(te,se);const _=new k.$3d;return(0,N.$5g)(0).then(()=>B=!0).then(()=>_.input=V.listen(te,se)),_.event}}}e.$Kh=F;class M{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const te of B.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await k.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$Lh=M;var z;(function(V){function B(oe,K,U){const P=oe,L=U&&U.disableMarshalling,H=new Map;for(const q in P)se(q)&&H.set(q,k.Event.buffer(P[q],!0,void 0,K));return new class{listen(q,ee,W){const Y=H.get(ee);if(Y)return Y;if(_(ee)){const ie=P[ee];if(typeof ie=="function")return ie.call(P,W)}throw new R.$bb(`Event not found: ${ee}`)}call(q,ee,W){const Y=P[ee];if(typeof Y=="function"){if(!L&&Array.isArray(W))for(let ce=0;ce<W.length;ce++)W[ce]=(0,C.$Ah)(W[ce]);let ie=Y.apply(P,W);return ie instanceof Promise||(ie=Promise.resolve(ie)),ie}throw new R.$bb(`Method not found: ${ee}`)}}}V.fromService=B;function te(oe,K){const U=K&&K.disableMarshalling;return new Proxy({},{get(P,L){if(typeof L=="string")return K?.properties?.has(L)?K.properties.get(L):_(L)?function(H){return oe.listen(L,H)}:se(L)?oe.listen(L):async function(...H){let q;K&&!(0,d.$Pf)(K.context)?q=[K.context,...H]:q=H;const ee=await oe.call(L,q);return U?ee:(0,C.$Ah)(ee)};throw new R.$bb(`Property not found: ${String(L)}`)}})}V.toService=te;function se(oe){return oe[0]==="o"&&oe[1]==="n"&&S.$9e(oe.charCodeAt(2))}function _(oe){return/^onDynamic/.test(oe)&&S.$9e(oe.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const B=V.toString();if(B!=="[object Object]")return B}return V}function x(V){return Array.isArray(V)?V.map(J):J(V)}function G(V,B,te,se,_,oe,K){K=x(K);const U=Z[_],P=U[se%U.length];let L=[`%c[${V}]%c[${String(B).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${oe}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(oe)?(L=L.concat(K),L.push(")")):L.push(K),console.log.apply(console,L)}class Q{constructor(B,te){this.d=B,this.f=te,this.a=0,this.b=0}logOutgoing(B,te,se,_,oe){this.b+=B,G(this.d,this.b,B,te,se,_,oe)}logIncoming(B,te,se,_,oe){this.a+=B,G(this.f,this.a,B,te,se,_,oe)}}e.$Mh=Q}),define(le[67],he([0,1,15,3,2,40]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.ProtocolConstants=e.$Nh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var R;(function(i){i.enableDiagnostics=!1,i.records=[];const t=new WeakMap;let r=0;function a(w,u){if(!t.has(w)){const p=String(++r);t.set(w,p)}return t.get(w)}function v(w,u,p,I){if(!i.enableDiagnostics)return;const T=a(w,u);if(I instanceof D.$he||I instanceof Uint8Array||I instanceof ArrayBuffer||ArrayBuffer.isView(I)){const F=D.$he.alloc(I.byteLength);F.set(I),i.records.push({timestamp:Date.now(),id:T,label:u,type:p,buff:F})}else i.records.push({timestamp:Date.now(),id:T,label:u,type:p,data:I})}i.traceSocketEvent=v})(R||(e.SocketDiagnostics=R={}));var k;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=D.$he.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=D.$he.alloc(t);let v=0,w=0;for(;t>0;){const u=this.a[w];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,v),v+=t,r&&(this.a[w]=u.slice(t),this.b-=t),t-=t}else a.set(u,v),v+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):w++,t-=u.byteLength}return a}}e.$Nh=S;var d;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(d||(d={}));function c(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class y{constructor(t,r,a,v){this.type=t,this.id=r,this.ack=a,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class b extends A.$Tc{constructor(t){super(),this.f=this.B(new N.$Td),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:c(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,v=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new y(a,v,w,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=D.$he.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:c(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=D.$he.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends A.$Tc{constructor(t){super(),this.f=new N.$Td,this.onMessage=this.f.event,this.g=new N.$Td,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new l(this.a)),this.c=this.B(new b(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new y(1,0,0,t))}}e.$Oh=f;class m extends j.$Ih{static fromSocket(t,r){return new m(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Ph=m;class h{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Td({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Qh=h;class E{constructor(t){this.data=t,this.next=null}}class n{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new E(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let v=0;v<o.a;v++)t-this.c[v]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new h,this.onControlMessage=this.u.event,this.v=new h,this.onMessage=this.v.event,this.w=new h,this.onDidDispose=this.w.event,this.x=new h,this.onSocketClose=this.x.event,this.y=new h,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new n,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new A.$Sc,this.o=t.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new y(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new y(7,0,0,C());this.p.write(t)}sendResume(){const t=new y(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new A.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new b(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new y(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,v=r.length;a<v;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new y(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new y(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,v=Date.now()-this.n;if(r>=2e4&&a>=2e4&&v>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const w=Math.max(2e4-r,2e4-a,2e4-v,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new y(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new y(9,0,this.h,C());this.p.write(t)}}e.$Rh=s}),define(le[93],he([0,1,66,6,15,26,140,7,3,2,30,144,90,40]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=e.$fq=void 0;class $ extends c.$Fh{constructor(l){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",f=>A.$he.wrap(Buffer.from(f,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$fq=$;class y{constructor(l,f){this.i=l,this.j=f,this.c=new Set,this.g=new Map,this.h=new k.$Td,this.onDidProcessExit=this.h.event;const m=f&&f.timeout?f.timeout:6e4;this.b=new N.$1g(m),this.d=null,this.f=null}getChannel(l){const f=this;return{call(m,h,E){return f.k(l,m,h,E)},listen(m,h){return f.l(l,m,h)}}}k(l,f,m,h=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const E=this.n(l),n=(0,N.$Rg)(i=>E.call(f,m,i)),o=h.onCancellationRequested(()=>n.cancel()),s=(0,g.$Rc)(()=>n.cancel());return this.c.add(s),n.finally(()=>{o.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(l,f,m){if(!this.b)return k.Event.None;this.b.cancel();let h;const E=new k.$Td({onWillAddFirstListener:()=>{h=this.n(l).listen(f,m)(E.fire,E),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return E.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$kn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,d.$Ql)(f.env),this.d=(0,D.fork)(this.i,l,f);const m=new k.$Td;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,O.$bq)(t)){(0,O.log)(t,`IPC Library: ${this.j.serverName}`);return}m.fire(A.$he.wrap(Buffer.from(t,"base64")))});const E=this.j.useQueue?(0,S.$Sl)(this.d):this.d,n=t=>this.d&&this.d.connected&&E.send(t.buffer.toString("base64")),o=m.event,s={send:n,onMessage:o};this.f=new c.$Gh(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",i),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(l){let f=this.g.get(l);return f||(f=this.m.getChannel(l),this.g.set(l,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$gq=y}),define(le[146],he([0,1,133,15,40,3,12,18]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DU=e.$CU=void 0;class k{constructor(d){this.a=d,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",c=>c.data?N.$he.wrap(c.data):N.$he.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class g extends A.$Hh{static b(d){(0,O.$Qf)((0,D.$BU)(process),"Electron Utility Process");const c=new j.$Td;return process.parentPort.on("message",$=>{if(d?.handledClientConnection($))return;const y=(0,R.$Ob)($.ports);y&&c.fire(y)}),j.Event.map(c.event,$=>({protocol:new k($),onDidClientDisconnect:j.Event.fromNodeEventEmitter($,"close")}))}constructor(d){super(g.b(d))}}e.$CU=g;function C(S,d,c){const $=y=>{y.data===d&&(S.removeListener("message",$),c())};S.on("message",$)}e.$DU=C}),define(le[68],he([0,1,6,3,2,65,12]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.StorageState=e.$ep=e.StorageHint=void 0;var R;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(d){const c=d;return c?.changed instanceof Map||c?.deleted instanceof Set}e.$ep=k;var g;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends A.$Tc{static{this.a=100}constructor(c,$=Object.create(null)){super(),this.r=c,this.s=$,this.b=this.B(new N.$Wd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new D.$2g(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(c=>this.u(c)))}u(c){this.b.pause();try{c.changed?.forEach(($,y)=>this.w(y,$)),c.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(c,$){if(this.c===g.Closed)return;let y=!1;(0,O.$Pf)($)?y=this.f.delete(c):this.f.get(c)!==$&&(this.f.set(c,$),y=!0),y&&this.b.fire({key:c,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(c,$){const y=this.f.get(c);return(0,O.$Pf)(y)?$:y}getBoolean(c,$){const y=this.get(c);return(0,O.$Pf)(y)?$:y==="true"}getNumber(c,$){const y=this.get(c);return(0,O.$Pf)(y)?$:parseInt(y,10)}getObject(c,$){const y=this.get(c);return(0,O.$Pf)(y)?$:(0,j.$zh)(y)}async set(c,$,y=!1){if(this.c===g.Closed)return;if((0,O.$Pf)($))return this.delete(c,y);const b=(0,O.$If)($)||Array.isArray($)?(0,j.$yh)($):String($);if(this.f.get(c)!==b)return this.f.set(c,b),this.j.set(c,b),this.h.delete(c),this.b.fire({key:c,external:y}),this.D()}async delete(c,$=!1){if(!(this.c===g.Closed||!this.f.delete(c)))return this.h.has(c)||this.h.add(c),this.j.delete(c),this.b.fire({key:c,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const c={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(c).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(c){if(this.z)return this.D(c)}async D(c){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),c)}async whenFlushed(){if(this.z)return new Promise(c=>this.n.push(c))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$fp=C;class S{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(c){c.insert?.forEach(($,y)=>this.a.set(y,$)),c.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$gp=S}),define(le[147],he([13,9]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(le[69],he([0,1,54,6,16,12,31,147]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.zip=e.$Bp=e.$Ap=void 0,e.$Ap="end of central directory record signature not found";const k=new RegExp(e.$Ap);class g extends Error{constructor(E,n){let o=n.message;switch(E){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=E,this.cause=n}}e.$Bp=g;function C(h){const E=h.externalFileAttributes>>16||33188;return[448,56,7].map(n=>E&n).reduce((n,o)=>n+o,E&61440)}function S(h){if(h instanceof g)return h;let E;return k.test(h.message)&&(E="CorruptZip"),new g(E,h)}function d(h,E,n,o,s,i){const t=A.$mc(E),r=A.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(R.localize(0,null,E)));const a=A.$jc(o,E);let v;return i.onCancellationRequested(()=>{v?.destroy()}),Promise.resolve(O.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((w,u)=>{if(!i.isCancellationRequested)try{v=(0,D.createWriteStream)(a,{mode:n}),v.once("close",()=>w()),v.once("error",u),h.once("error",u),h.pipe(v)}catch(p){u(p)}}))}function c(h,E,n,o){let s=(0,N.$Rg)(()=>Promise.resolve()),i=0;const t=o.onCancellationRequested(()=>{s.cancel(),h.close()});return new Promise((r,a)=>{const v=new N.$Yg,w=u=>{u.isCancellationRequested||(i++,h.readEntry())};h.once("error",a),h.once("close",()=>s.then(()=>{o.isCancellationRequested||h.entryCount===i?r():a(new g("Incomplete",new Error(R.localize(1,null,i,h.entryCount))))},a)),h.readEntry(),h.on("entry",u=>{if(o.isCancellationRequested)return;if(!n.sourcePathRegex.test(u.fileName)){w(o);return}const p=u.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(p)){const F=A.$jc(E,p);s=(0,N.$Rg)(M=>O.Promises.mkdir(F,{recursive:!0}).then(()=>w(M)).then(void 0,a));return}const I=y(h,u),T=C(u);s=(0,N.$Rg)(F=>v.queue(()=>I.then(M=>d(M,p,T,E,n,F).then(()=>w(F)))).then(null,a))})}).finally(()=>t.dispose())}async function $(h,E=!1){const{open:n}=await new Promise((o,s)=>{ne(["yauzl"],o,s)});return new Promise((o,s)=>{n(h,E?{lazyEntries:!0}:void 0,(i,t)=>{i?s(S(i)):o((0,j.$Rf)(t))})})}function y(h,E){return new Promise((n,o)=>{h.openReadStream(E,(s,i)=>{s?o(S(s)):n((0,j.$Rf)(i))})})}async function b(h,E){const{ZipFile:n}=await new Promise((o,s)=>{ne(["yazl"],o,s)});return new Promise((o,s)=>{const i=new n;E.forEach(r=>{r.contents?i.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&i.addFile(r.localPath,r.path)}),i.end();const t=(0,D.createWriteStream)(h);i.outputStream.pipe(t),i.outputStream.once("error",s),t.once("error",s),t.once("finish",()=>o(h))})}e.zip=b;function l(h,E,n={},o){const s=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=$(h,!0);return n.overwrite&&(i=i.then(t=>O.Promises.rm(E).then(()=>t))),i.then(t=>c(t,E,{sourcePathRegex:s},o))}e.$Dp=l;function f(h,E){return $(h).then(n=>new Promise((o,s)=>{n.on("entry",i=>{i.fileName===E&&y(n,i).then(t=>o(t),t=>s(t))}),n.once("close",()=>s(new Error(R.localize(2,null,E))))}))}function m(h,E){return f(h,E).then(n=>new Promise((o,s)=>{const i=[];n.once("error",s),n.on("data",t=>i.push(t)),n.on("end",()=>o(Buffer.concat(i)))}))}e.$Ep=m}),define(le[148],he([13,9]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[149],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(le[150],he([13,9]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(le[151],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[152],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[153],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[154],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[155],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[156],he([13,9]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[157],he([13,9]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[158],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(le[159],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(le[160],he([13,9]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(le[161],he([13,9]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[162],he([13,9]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[163],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[164],he([13,9]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[165],he([13,9]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(le[166],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[167],he([13,9]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[168],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[169],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[170],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[171],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[172],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[173],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[174],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[175],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[176],he([13,9]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[177],he([13,9]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(le[178],he([0,1,7,150]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.TokenType=void 0;var A;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(A||(e.TokenType=A={}));function j(...g){switch(g.length){case 1:return(0,N.localize)(0,null,g[0]);case 2:return(0,N.localize)(1,null,g[0],g[1]);case 3:return(0,N.localize)(2,null,g[0],g[1],g[2]);default:return}}const O=(0,N.localize)(3,null),R=(0,N.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,d=this.c.substring(this.d,this.e),c={type:19,offset:this.d,lexeme:d};this.g.push({offset:S,lexeme:d,additionalInfo:C}),this.f.push(c)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),d=k.b.get(S);d?this.k(d):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,d=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(R);return}const $=this.c.charCodeAt(C);if(S)S=!1;else if($===47&&!d){C++;break}else $===91?d=!0:$===92?S=!0:$===93&&(d=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const c=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:c,offset:this.d})}r(){return this.e>=this.c.length}}e.$Yi=k}),define(le[179],he([0,1,64,84,23,16,37,19,10]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=e.$wm=e.$vm=void 0,e.$vm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,j.$mc)(A.$mg.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,R.$Fg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:A.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$Fg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const c=(0,D.$um)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",c)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$Fg)(k.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$Fg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$Fg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$Fg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,j.$jc)(c,"argv.json")):(0,R.$Fg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const c=this.args["builtin-extensions-dir"];return c?(0,j.$kc)(c):(0,j.$hc)((0,j.$jc)(A.$mg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const c=this.args["extensions-download-dir"];return c?k.URI.file((0,j.$kc)(c)):k.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const c=this.args["extensions-dir"];if(c)return(0,j.$kc)(c);const $=O.env.VSCODE_EXTENSIONS;if($)return $;const y=O.env.VSCODE_PORTABLE;return y?(0,j.$jc)(y,"extensions"):(0,R.$Fg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const c=this.args.extensionDevelopmentPath;if(Array.isArray(c))return c.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,j.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const c=this.args.extensionTestsPath;if(c)return/^[^:/?#]+?:\/\//.test(c)?k.URI.parse(c):k.URI.file((0,j.$hc)(c))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const c=this.args["disable-extension"];if(c){if(typeof c=="string")return[c];if(Array.isArray(c)&&c.length>0)return c}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(c=>!e.$vm.test(c))}get extensionLogLevel(){const c=[];for(const $ of this.args.log||[]){const y=e.$vm.exec($);y&&y[1]&&y[2]&&c.push([y[1],y[2]])}return c.length?c:void 0}get serviceMachineIdResource(){return(0,R.$Fg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const c=O.env.VSCODE_PORTABLE;return c?k.URI.file((0,j.$jc)(c,"policy.json")):(0,R.$Fg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(c){this.args.continueOn=c}get args(){return this.a}constructor(c,$,y){this.a=c,this.b=$,this.c=y,this.editSessionId=this.args.editSessionId}}e.$wm=g,ye([N.$vh],g.prototype,"appRoot",null),ye([N.$vh],g.prototype,"userHome",null),ye([N.$vh],g.prototype,"userDataPath",null),ye([N.$vh],g.prototype,"appSettingsHome",null),ye([N.$vh],g.prototype,"tmpDir",null),ye([N.$vh],g.prototype,"cacheHome",null),ye([N.$vh],g.prototype,"stateResource",null),ye([N.$vh],g.prototype,"userRoamingDataHome",null),ye([N.$vh],g.prototype,"userDataSyncHome",null),ye([N.$vh],g.prototype,"sync",null),ye([N.$vh],g.prototype,"machineSettingsResource",null),ye([N.$vh],g.prototype,"workspaceStorageHome",null),ye([N.$vh],g.prototype,"localHistoryHome",null),ye([N.$vh],g.prototype,"keyboardLayoutResource",null),ye([N.$vh],g.prototype,"argvResource",null),ye([N.$vh],g.prototype,"isExtensionDevelopment",null),ye([N.$vh],g.prototype,"untitledWorkspacesHome",null),ye([N.$vh],g.prototype,"builtinExtensionsPath",null),ye([N.$vh],g.prototype,"extensionsPath",null),ye([N.$vh],g.prototype,"extensionDevelopmentLocationURI",null),ye([N.$vh],g.prototype,"extensionDevelopmentKind",null),ye([N.$vh],g.prototype,"extensionTestsLocationURI",null),ye([N.$vh],g.prototype,"debugExtensionHost",null),ye([N.$vh],g.prototype,"logLevel",null),ye([N.$vh],g.prototype,"extensionLogLevel",null),ye([N.$vh],g.prototype,"serviceMachineIdResource",null),ye([N.$vh],g.prototype,"disableTelemetry",null),ye([N.$vh],g.prototype,"disableWorkspaceTrust",null),ye([N.$vh],g.prototype,"useInMemorySecretStorage",null),ye([N.$vh],g.prototype,"policyFile",null);function C(d,c){return S(d["inspect-extensions"],d["inspect-brk-extensions"],5870,c,d.debugId,d.extensionEnvironment)}e.$xm=C;function S(d,c,$,y,b,l){const m=Number(c||d)||(y?null:$),h=m?!!c:!1;let E;if(l)try{E=JSON.parse(l)}catch{}return{port:m,break:h,debugId:b,env:E}}e.$ym=S}),function(){"use strict";function ne(e,D,N){function A(O,R){const k=j(O,R),g=[k];return e.isAbsolute(k)||g.unshift(N),e.resolve(...g)}function j(O,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,R);const C=O["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(D.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,R)}return{getUserDataPath:A}}if(typeof define=="function")define(le[180],he([269,36,37]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[181],he([0,1,36,179,180]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=e.$zm=void 0;class j extends N.$wm{constructor(g,C){super(g,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,A.getUserDataPath)(g,C.nameShort)},C)}}e.$zm=j;function O(k,g){return(0,N.$ym)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Am=O;function R(k,g){return(0,N.$ym)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Bm=R}),define(le[182],he([0,1,12,153]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;function A(O,R,k,g){try{j(O,R,k,g)}catch(C){O.error(C?.message??C)}return R}e.$Np=A;function j(O,R,k,g){const C=(S,d,c)=>{const $=S[d];if((0,D.$Gf)($)){const y=$,b=y.length;if(b>1&&y[0]==="%"&&y[b-1]==="%"){const l=y.substr(1,b-2);let f=k[l];f===void 0&&g&&(f=g[l]);const m=typeof f=="string"?f:f?.message,h=g?.[l],E=typeof h=="string"?h:h?.message;if(!m){E||O.warn(`[${R.name}]: ${(0,N.localize)(0,null,l)}`);return}if(c&&(d==="title"||d==="category")&&E&&E!==m){const n={value:m,original:E};S[d]=n}else S[d]=m}}else if((0,D.$If)($))for(const y in $)$.hasOwnProperty(y)&&(y==="commands"?C($,y,!0):C($,y,c));else if(Array.isArray($))for(let y=0;y<$.length;y++)C($,y,c)};for(const S in R)R.hasOwnProperty(S)&&C(R,S)}}),define(le[183],he([0,1,69,156]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vp=void 0;function A(j){return(0,D.$Ep)(j,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.$Vp=A}),define(le[184],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=e.$C_b=void 0;class D{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$C_b=D;class N{constructor(j){this.a=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,R){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${O}`)}}e.$D_b=N}),define(le[70],he([0,1,19,89,157,55]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function k(l){return l=l.trim(),l==="*"||O.test(l)}e.$2o=k;function g(l){if(!k(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=l.match(O);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$3o=g;function C(l){if(!l)return null;const f=l.majorBase,m=l.majorMustEqual,h=l.minorBase;let E=l.minorMustEqual;const n=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(f===0||(E=!1),o=!1);let s=0;if(l.preRelease){const i=R.exec(l.preRelease);if(i){const[,t,r,a]=i;s=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:m,minorBase:h,minorMustEqual:E,patchBase:n,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:s}}e.$4o=C;function S(l,f,m){let h;typeof l=="string"?h=C(g(l)):h=l;let E;f instanceof Date?E=f.getTime():typeof f=="string"&&(E=new Date(f).getTime());let n;if(typeof m=="string"?n=C(g(m)):n=m,!h||!n)return!1;const o=h.majorBase,s=h.minorBase,i=h.patchBase;let t=n.majorBase,r=n.minorBase,a=n.patchBase;const v=n.notBefore;let w=n.majorMustEqual,u=n.minorMustEqual,p=n.patchMustEqual;return n.isMinimum?o>t?!0:o<t?!1:s>r?!0:s<r||E&&E<v?!1:i>=a:(o===1&&t===0&&(!w||!u||!p)&&(t=1,r=0,a=0,w=!0,u=!1,p=!1),o<t?!1:o>t?!w:s<r?!1:s>r?!u:i<a?!1:i>a?!p:!(E&&E<v))}e.$5o=S;function d(l,f,m,h,E){const n=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return n.push([N.default.Error,A.localize(0,null)]),n;if(typeof h.name!="string")return n.push([N.default.Error,A.localize(1,null,"name")]),n;if(typeof h.version!="string")return n.push([N.default.Error,A.localize(2,null,"version")]),n;if(!h.engines)return n.push([N.default.Error,A.localize(3,null,"engines")]),n;if(typeof h.engines.vscode!="string")return n.push([N.default.Error,A.localize(4,null,"engines.vscode")]),n;if(typeof h.extensionDependencies<"u"&&!b(h.extensionDependencies))return n.push([N.default.Error,A.localize(5,null,"extensionDependencies")]),n;if(typeof h.activationEvents<"u"){if(!b(h.activationEvents))return n.push([N.default.Error,A.localize(6,null,"activationEvents")]),n;if(typeof h.main>"u"&&typeof h.browser>"u")return n.push([N.default.Error,A.localize(7,null,"activationEvents","main","browser")]),n}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&n.push([N.default.Warning,A.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return n.push([N.default.Error,A.localize(9,null,"main")]),n;{const i=(0,D.$Fg)(m,h.main);(0,D.$zg)(i,m)||n.push([N.default.Warning,A.localize(10,null,i.path,m.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return n.push([N.default.Error,A.localize(11,null,"browser")]),n;{const i=(0,D.$Fg)(m,h.browser);(0,D.$zg)(i,m)||n.push([N.default.Warning,A.localize(12,null,i.path,m.path)])}}if(!j.valid(h.version))return n.push([N.default.Error,A.localize(13,null)]),n;const o=[];if(!c(l,f,h,E,o))for(const i of o)n.push([N.default.Error,i]);return n}e.$6o=d;function c(l,f,m,h,E){return h||typeof m.main>"u"&&typeof m.browser>"u"?!0:y(l,f,m.engines.vscode,E)}e.$7o=c;function $(l,f,m){return l==="*"||y(f,m,l)}e.$8o=$;function y(l,f,m,h=[]){const E=C(g(m));if(!E)return h.push(A.localize(14,null,m)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return h.push(A.localize(15,null,m)),!1}else if(!E.majorMustEqual)return h.push(A.localize(16,null,m)),!1;return S(l,f,E)?!0:(h.push(A.localize(17,null,l,m)),!1)}function b(l){if(!Array.isArray(l))return!1;for(let f=0,m=l.length;f<m;f++)if(typeof l[f]!="string")return!1;return!0}}),define(le[43],he([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function A(j,O,R){let k=R&&R.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await O.readFile(j.serviceMachineIdResource)).value.toString();k=(0,N.$ng)(C)?C:null}catch{k=null}if(!k){k=(0,N.$og)();try{await O.writeFile(j.serviceMachineIdResource,D.$he.fromString(k))}catch{}}return R?.store("storage.serviceMachineId",k,-1,1),k}e.$pp=A}),define(le[71],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=void 0;class D{constructor(A,j=[],O=!1){this.ctor=A,this.staticArguments=j,this.supportsDelayedInstantiation=O}}e.$1h=D}),define(le[185],he([0,1,71]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Or=e.$Nr=e.InstantiationType=void 0;const N=[];var A;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(A||(e.InstantiationType=A={}));function j(R,k,g){k instanceof D.$1h||(k=new D.$1h(k,[],!!g)),N.push([R,k])}e.$Nr=j;function O(){return N}e.$Or=O}),define(le[186],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=e.$rq=void 0;class D{constructor(j,O){this.key=j,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$rq=D;class N{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const O of this.a.values())O.outgoing.size===0&&j.push(O);return j}insertEdge(j,O){const R=this.lookupOrInsertNode(j),k=this.lookupOrInsertNode(O);R.outgoing.set(k.key,k),k.incoming.set(R.key,R)}removeNode(j){const O=this.b(j);this.a.delete(O);for(const R of this.a.values())R.outgoing.delete(O),R.incoming.delete(O)}lookupOrInsertNode(j){const O=this.b(j);let R=this.a.get(O);return R||(R=new D(O,j),this.a.set(O,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[O,R]of this.a)j.push(`${O}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,O]of this.a){const R=new Set([j]),k=this.c(O,R);if(k)return k}}c(j,O){for(const[R,k]of j.outgoing){if(O.has(R))return[...O,R].join(" -> ");O.add(R);const g=this.c(k,O);if(g)return g;O.delete(R)}}}e.$sq=N}),define(le[4],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=e.$4h=e.$3h=e._util=void 0;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function R(k){return k[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=R})(D||(e._util=D={})),e.$3h=A("instantiationService");function N(O,R,k){R[D.DI_TARGET]===R?R[D.DI_DEPENDENCIES].push({id:O,index:k}):(R[D.DI_DEPENDENCIES]=[{id:O,index:k}],R[D.DI_TARGET]=R)}function A(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const R=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(R,k,C)};return R.toString=()=>O,D.serviceIds.set(O,R),R}e.$4h=A;function j(O){return O}e.$5h=j}),define(le[187],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0,e.$_$b=(0,D.$4h)("checksumService")}),define(le[20],he([0,1,12,10,4]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.ConfigurationTarget=e.$zi=e.$yi=e.$xi=void 0,e.$xi=(0,A.$4h)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof N.URI)}e.$yi=j;function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof N.URI)}e.$zi=O;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function k(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ai=k;function g(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Bi=g;function C(l,f){const m=Object.create(null);for(const h in l)S(m,h,l[h],f);return m}e.$Ci=C;function S(l,f,m,h){const E=f.split("."),n=E.pop();let o=l;for(let s=0;s<E.length;s++){const i=E[s];let t=o[i];switch(typeof t){case"undefined":t=o[i]=Object.create(null);break;case"object":break;default:h(`Ignoring ${f} as ${E.slice(0,s+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[n]=m}catch{h(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}else h(`Ignoring ${f} as ${E.join(".")} is ${JSON.stringify(o)}`)}e.$Di=S;function d(l,f){const m=f.split(".");c(l,m)}e.$Ei=d;function c(l,f){const m=f.shift();if(f.length===0){delete l[m];return}if(Object.keys(l).indexOf(m)!==-1){const h=l[m];typeof h=="object"&&!Array.isArray(h)&&(c(h,f),Object.keys(h).length===0&&delete l[m])}}function $(l,f,m){function h(o,s){let i=o;for(const t of s){if(typeof i!="object"||i===null)return;i=i[t]}return i}const E=f.split("."),n=h(l,E);return typeof n>"u"?m:n}e.$Fi=$;function y(l,f,m){Object.keys(f).forEach(h=>{h!=="__proto__"&&(h in l?D.$If(l[h])&&D.$If(f[h])?y(l[h],f[h],m):m&&(l[h]=f[h]):l[h]=f[h])})}e.$Gi=y;function b(l){return l.replace(/[\[\]]/g,"")}e.$Hi=b}),define(le[94],he([0,1,5,27,178,4,149,7]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.ContextKeyExprType=e.$Zi=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",D.$j),k.set("isLinux",D.$k),k.set("isWindows",D.$i),k.set("isWeb",D.$o),k.set("isMacNative",D.$j&&!D.$o),k.set("isEdge",D.$H),k.set("isFirefox",D.$F),k.set("isChrome",D.$E),k.set("isSafari",D.$G);function g(U,P){if(k.get(U)!==void 0)throw(0,R.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(U,P)}e.$Zi=g;const C=Object.prototype.hasOwnProperty;var S;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const d={regexParsingWithErrorRecovery:!0},c=(0,O.localize)(0,null),$=(0,O.localize)(1,null),y=(0,O.localize)(2,null),b=(0,O.localize)(3,null),l=(0,O.localize)(4,null),f=(0,O.localize)(5,null),m=(0,O.localize)(6,null),h=(0,O.localize)(7,null);class E{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=d){this.k=P,this.d=new A.$Yi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:c,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const L=this.l();if(!this.E()){const H=this.D(),q=H.type===17?f:void 0;throw this.h.push({message:l,offset:H.offset,lexeme:A.$Yi.getLexeme(H),additionalInfo:q}),E.c}return L}catch(L){if(L!==E.c)throw L;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const L=this.o();P.push(L)}return P.length===1?P[0]:n.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const L=this.s();P.push(L)}return P.length===1?P[0]:n.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const L=this.l();return this.A(1,b),L?.negate()}case 17:return this.z(),I.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const L=this.l();return this.A(1,b),L}case 17:{const L=P.lexeme;if(this.z(),this.y(9)){const q=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),q.type!==10)throw this.B("REGEX",q);const ee=q.lexeme,W=ee.lastIndexOf("/"),Y=W===ee.length-1?void 0:this.w(ee.substring(W+1));let ie;try{ie=new RegExp(ee.substring(1,W),Y)}catch{throw this.B("REGEX",q)}return J.create(L,ie)}switch(q.type){case 10:case 19:{const ee=[q.lexeme];this.z();let W=this.D(),Y=0;for(let de=0;de<q.lexeme.length;de++)q.lexeme.charCodeAt(de)===40?Y++:q.lexeme.charCodeAt(de)===41&&Y--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let de=0;de<W.lexeme.length;de++)W.lexeme.charCodeAt(de)===40?Y++:q.lexeme.charCodeAt(de)===41&&Y--}if(Y<0)break;ee.push(A.$Yi.getLexeme(W)),this.z(),W=this.D()}const ie=ee.join(""),ce=ie.lastIndexOf("/"),ae=ce===ie.length-1?void 0:this.w(ie.substring(ce+1));let fe;try{fe=new RegExp(ie.substring(1,ce),ae)}catch{throw this.B("REGEX",q)}return n.regex(L,fe)}case 18:{const ee=q.lexeme;this.z();let W=null;if(!(0,N.$He)(ee)){const Y=ee.indexOf("/"),ie=ee.lastIndexOf("/");if(Y!==ie&&Y>=0){const ce=ee.slice(Y+1,ie),ae=ee[ie+1]==="i"?"i":"";try{W=new RegExp(ce,ae)}catch{throw this.B("REGEX",q)}}}if(W===null)throw this.B("REGEX",q);return J.create(L,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const q=this.u();return n.notIn(L,q)}switch(this.D().type){case 3:{this.z();const q=this.u();if(this.x().type===18)return n.equals(L,q);switch(q){case"true":return n.has(L);case"false":return n.not(L);default:return n.equals(L,q)}}case 4:{this.z();const q=this.u();if(this.x().type===18)return n.notEquals(L,q);switch(q){case"true":return n.not(L);case"false":return n.has(L);default:return n.notEquals(L,q)}}case 5:return this.z(),z.create(L,this.u());case 6:return this.z(),Z.create(L,this.u());case 7:return this.z(),F.create(L,this.u());case 8:return this.z(),M.create(L,this.u());case 13:return this.z(),n.in(L,this.u());default:return n.has(L)}}case 20:throw this.h.push({message:m,offset:P.offset,lexeme:"",additionalInfo:h}),E.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,L){if(this.C(P))return this.z();throw this.B(L,this.D())}B(P,L,H){const q=(0,O.localize)(8,null,P,A.$Yi.getLexeme(L)),ee=L.offset,W=A.$Yi.getLexeme(L);return this.h.push({message:q,offset:ee,lexeme:W,additionalInfo:H}),E.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$1i=E;class n{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(P){return a.create(P)}static equals(P,L){return v.create(P,L)}static notEquals(P,L){return p.create(P,L)}static regex(P,L){return J.create(P,L)}static in(P,L){return w.create(P,L)}static notIn(P,L){return u.create(P,L)}static not(P){return I.create(P)}static and(...P){return Q.create(P,null,!0)}static or(...P){return V.create(P,null,!0)}static greater(P,L){return F.create(P,L)}static greaterEquals(P,L){return M.create(P,L)}static smaller(P,L){return z.create(P,L)}static smallerEquals(P,L){return Z.create(P,L)}static{this.c=new E({regexParsingWithErrorRecovery:!1})}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.$2i=n;function o(U){const P=new E({regexParsingWithErrorRecovery:!1});return U.map(L=>(P.parse(L),P.lexingErrors.length>0?P.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,O.localize)(9,null,H.additionalInfo):(0,O.localize)(10,null),offset:H.offset,length:H.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.$3i=o;function s(U,P){const L=U?U.substituteConstants():void 0,H=P?P.substituteConstants():void 0;return!L&&!H?!0:!L||!H?!1:L.equals(H)}e.$4i=s;function i(U,P){return U.cmp(P)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return r.INSTANCE}}e.$5i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return t.INSTANCE}}e.$6i=r;class a{static create(P,L=null){const H=k.get(P);return typeof H=="boolean"?H?r.INSTANCE:t.INSTANCE:new a(P,L)}constructor(P,L){this.key=P,this.c=L,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:te(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=k.get(this.key);return typeof P=="boolean"?P?r.INSTANCE:t.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$7i=a;class v{static create(P,L,H=null){if(typeof L=="boolean")return L?a.create(P,H):I.create(P,H);const q=k.get(P);return typeof q=="boolean"?L===(q?"true":"false")?r.INSTANCE:t.INSTANCE:new v(P,L,H)}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const L=P?"true":"false";return this.d===L?r.INSTANCE:t.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$8i=v;class w{static create(P,L){return new w(P,L)}constructor(P,L){this.d=P,this.f=L,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:se(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const L=P.getValue(this.f),H=P.getValue(this.d);return Array.isArray(L)?L.includes(H):typeof H=="string"&&typeof L=="object"&&L!==null?C.call(L,H):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$9i=w;class u{static create(P,L){return new u(P,L)}constructor(P,L){this.d=P,this.f=L,this.type=11,this.c=w.create(P,L)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$0i=u;class p{static create(P,L,H=null){if(typeof L=="boolean")return L?I.create(P,H):a.create(P,H);const q=k.get(P);return typeof q=="boolean"?L===(q?"true":"false")?t.INSTANCE:r.INSTANCE:new p(P,L,H)}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=k.get(this.c);if(typeof P=="boolean"){const L=P?"true":"false";return this.d===L?t.INSTANCE:r.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=v.create(this.c,this.d,this)),this.f}}e.$$i=p;class I{static create(P,L=null){const H=k.get(P);return typeof H=="boolean"?H?t.INSTANCE:r.INSTANCE:new I(P,L)}constructor(P,L){this.c=P,this.d=L,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:te(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=k.get(this.c);return typeof P=="boolean"?P?t.INSTANCE:r.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$_i=I;function T(U,P){if(typeof U=="string"){const L=parseFloat(U);isNaN(L)||(U=L)}return typeof U=="string"||typeof U=="number"?P(U):t.INSTANCE}class F{static create(P,L,H=null){return T(L,q=>new F(P,q,H))}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$aj=F;class M{static create(P,L,H=null){return T(L,q=>new M(P,q,H))}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$bj=M;class z{static create(P,L,H=null){return T(L,q=>new z(P,q,H))}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$cj=z;class Z{static create(P,L,H=null){return T(L,q=>new Z(P,q,H))}constructor(P,L,H){this.c=P,this.d=L,this.f=H,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:se(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$dj=Z;class J{static create(P,L){return new J(P,L)}constructor(P,L){this.d=P,this.f=L,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const L=this.f?this.f.source:"",H=P.f?P.f.source:"";return L<H?-1:L>H?1:0}equals(P){if(P.type===this.type){const L=this.f?this.f.source:"",H=P.f?P.f.source:"";return this.d===P.d&&L===H}return!1}substituteConstants(){return this}evaluate(P){const L=P.getValue(this.d);return this.f?this.f.test(L):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$ej=J;class x{static create(P){return new x(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new x(this.c.map(P))}negate(){return this.c}}e.$fj=x;function G(U){let P=null;for(let L=0,H=U.length;L<H;L++){const q=U[L].substituteConstants();if(U[L]!==q&&P===null){P=[];for(let ee=0;ee<L;ee++)P[ee]=U[ee]}P!==null&&(P[L]=q)}return P===null?U:P}class Q{static create(P,L,H){return Q.d(P,L,H)}constructor(P,L){this.expr=P,this.c=L,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let L=0,H=this.expr.length;L<H;L++){const q=i(this.expr[L],P.expr[L]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let L=0,H=this.expr.length;L<H;L++)if(!this.expr[L].equals(P.expr[L]))return!1;return!0}return!1}substituteConstants(){const P=G(this.expr);return P===this.expr?this:Q.create(P,this.c,!1)}evaluate(P){for(let L=0,H=this.expr.length;L<H;L++)if(!this.expr[L].evaluate(P))return!1;return!0}static d(P,L,H){const q=[];let ee=!1;for(const W of P)if(W){if(W.type===1){ee=!0;continue}if(W.type===0)return t.INSTANCE;if(W.type===6){q.push(...W.expr);continue}q.push(W)}if(q.length===0&&ee)return r.INSTANCE;if(q.length!==0){if(q.length===1)return q[0];q.sort(i);for(let W=1;W<q.length;W++)q[W-1].equals(q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0];for(;q.length>1;){const W=q[q.length-1];if(W.type!==9)break;q.pop();const Y=q.pop(),ie=q.length===0,ce=V.create(W.expr.map(ae=>Q.create([ae,Y],null,H)),null,ie);ce&&(q.push(ce),q.sort(i))}if(q.length===1)return q[0];if(H){for(let W=0;W<q.length;W++)for(let Y=W+1;Y<q.length;Y++)if(q[W].negate().equals(q[Y]))return t.INSTANCE;if(q.length===1)return q[0]}return new Q(q,L)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const L of this.expr)P.push(...L.keys());return P}map(P){return new Q(this.expr.map(L=>L.map(P)),null)}negate(){if(!this.c){const P=[];for(const L of this.expr)P.push(L.negate());this.c=V.create(P,this,!0)}return this.c}}e.$gj=Q;class V{static create(P,L,H){return V.d(P,L,H)}constructor(P,L){this.expr=P,this.c=L,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let L=0,H=this.expr.length;L<H;L++){const q=i(this.expr[L],P.expr[L]);if(q!==0)return q}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let L=0,H=this.expr.length;L<H;L++)if(!this.expr[L].equals(P.expr[L]))return!1;return!0}return!1}substituteConstants(){const P=G(this.expr);return P===this.expr?this:V.create(P,this.c,!1)}evaluate(P){for(let L=0,H=this.expr.length;L<H;L++)if(this.expr[L].evaluate(P))return!0;return!1}static d(P,L,H){let q=[],ee=!1;if(P){for(let W=0,Y=P.length;W<Y;W++){const ie=P[W];if(ie){if(ie.type===0){ee=!0;continue}if(ie.type===1)return r.INSTANCE;if(ie.type===9){q=q.concat(ie.expr);continue}q.push(ie)}}if(q.length===0&&ee)return t.INSTANCE;q.sort(i)}if(q.length!==0){if(q.length===1)return q[0];for(let W=1;W<q.length;W++)q[W-1].equals(q[W])&&(q.splice(W,1),W--);if(q.length===1)return q[0];if(H){for(let W=0;W<q.length;W++)for(let Y=W+1;Y<q.length;Y++)if(q[W].negate().equals(q[Y]))return r.INSTANCE;if(q.length===1)return q[0]}return new V(q,L)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const L of this.expr)P.push(...L.keys());return P}map(P){return new V(this.expr.map(L=>L.map(P)),null)}negate(){if(!this.c){const P=[];for(const L of this.expr)P.push(L.negate());for(;P.length>1;){const L=P.shift(),H=P.shift(),q=[];for(const ee of K(L))for(const W of K(H))q.push(Q.create([ee,W],null,!1));P.unshift(V.create(q,null,!1))}this.c=V.create(P,this,!0)}return this.c}}e.$hj=V;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(P,L,H){super(P,null),this.f=L,typeof H=="object"?B.d.push({...H,key:P}):H!==!0&&B.d.push({key:P,description:H,type:L!=null?typeof L:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return v.create(this.key,P)}notEqualsTo(P){return p.create(this.key,P)}}e.$ij=B,e.$jj=(0,j.$4h)("contextKeyService");function te(U,P){return U<P?-1:U>P?1:0}function se(U,P,L,H){return U<L?-1:U>L?1:P<H?-1:P>H?1:0}function _(U,P){if(U.type===0||P.type===1)return!0;if(U.type===9)return P.type===9?oe(U.expr,P.expr):!1;if(P.type===9){for(const L of P.expr)if(_(U,L))return!0;return!1}if(U.type===6){if(P.type===6)return oe(P.expr,U.expr);for(const L of U.expr)if(_(L,P))return!0;return!1}return U.equals(P)}e.$kj=_;function oe(U,P){let L=0,H=0;for(;L<U.length&&H<P.length;){const q=U[L].cmp(P[H]);if(q<0)return!1;q===0&&L++,H++}return L===U.length}function K(U){return U.type===9?U.expr:[U]}}),define(le[95],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=e.$Gm=e.ID=void 0,e.ID="diagnosticsService",e.$Gm=(0,D.$4h)(e.ID);function N(j){return!!j.hostName&&!!j.errorMessage}e.$Hm=N;class A{async getPerformanceInfo(O,R){return{}}async getSystemInfo(O,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,R){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$Im=A}),define(le[96],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=void 0,e.$5n=(0,D.$4h)("downloadService")}),define(le[14],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=void 0,e.$$h=(0,D.$4h)("environmentService"),e.$_h=(0,D.$5h)(e.$$h)}),define(le[29],he([0,1,152,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$no=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=void 0,e.$bo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$co=new RegExp(e.$bo),e.$do="__web_extension",e.$eo="skipWalkthrough",e.$fo="extensionsSync",e.$go="dependecyOrPackExtensionInstall";function A(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$ho=A;function j(l){switch(l){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$io=j;function O(l,f){switch(l){case 3:return f==="x64"?"win32-x64":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$jo=O;function R(l,f){return f==="web"&&!l.includes("web")}e.$ko=R;function k(l,f,m){return R(f,m)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===m}e.$lo=k;function g(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}e.$mo=g;var C;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var d;(function(l){l.Install="install",l.Uninstall="uninstall"})(d||(e.StatisticType=d={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$no=(0,N.$4h)("extensionGalleryService");var $;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var y;(function(l){l.UnknownError="UnknownError",l.PackageIsInvalidZip="PackageIsInvalidZip",l.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(y||(e.ExtensionSignaturetErrorCode=y={}));class b extends Error{constructor(f,m){super(f),this.code=m,this.name=m}}e.$oo=b,e.$po=(0,N.$4h)("extensionManagementService"),e.$qo="extensionsIdentifiers/disabled",e.$ro="extensionsIdentifiers/enabled",e.$so=(0,N.$4h)("IGlobalExtensionEnablementService"),e.$to=(0,N.$4h)("IExtensionTipsService"),e.$uo=(0,D.localize)(0,null),e.$vo={value:e.$uo,original:"Extensions"},e.$wo=(0,D.localize2)(1,"Preferences")}),define(le[188],he([0,1,3,2,30,10,92,29]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=void 0;function k(b,l){return b?j.URI.revive(l?l.transformIncoming(b):b):void 0}function g(b,l){return l?l.transformOutgoingURI(b):b}function C(b,l){l=l||O.$3m;const f=b.manifest;return{...(0,O.$6m)({...b,manifest:void 0},l),manifest:f}}function S(b,l){return b?.profileLocation?(0,O.$6m)(b,l??O.$3m):b}function d(b,l){return l?(0,A.$mn)(b,f=>f instanceof j.URI?l.transformOutgoingURI(f):void 0):b}class c{constructor(l,f){this.a=l,this.b=f,this.onInstallExtension=D.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,f){const m=this.b(l);switch(f){case"onInstallExtension":return D.Event.map(this.onInstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,h=>h.map(E=>({...E,local:E.local?d(E.local,m):E.local,profileLocation:E.profileLocation?g(E.profileLocation,m):E.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,h=>({...h,profileLocation:h.profileLocation?g(h.profileLocation,m):h.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,h=>d(h,m))}throw new Error("Invalid listen")}async call(l,f,m){const h=this.b(l);switch(f){case"zip":{const E=C(m[0],h),n=await this.a.zip(E);return g(n,h)}case"unzip":return this.a.unzip(k(m[0],h));case"install":return this.a.install(k(m[0],h),S(m[1],h));case"installFromLocation":return this.a.installFromLocation(k(m[0],h),k(m[1],h));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],k(m[1],h),k(m[2],h));case"getManifest":return this.a.getManifest(k(m[0],h));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],S(m[1],h));case"installGalleryExtensions":{const E=m[0];return this.a.installGalleryExtensions(E.map(({extension:n,options:o})=>({extension:n,options:S(o,h)??{}})))}case"uninstall":return this.a.uninstall(C(m[0],h),S(m[1],h));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(m[0],h));case"getInstalled":return(await this.a.getInstalled(m[0],k(m[1],h))).map(n=>d(n,h));case"toggleAppliationScope":{const E=await this.a.toggleAppliationScope(C(m[0],h),k(m[1],h));return d(E,h)}case"copyExtensions":return this.a.copyExtensions(k(m[0],h),k(m[1],h));case"updateMetadata":{const E=await this.a.updateMetadata(C(m[0],h),m[1],k(m[2],h));return d(E,h)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$xp=c;class $ extends N.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.m=l,this.c=this.B(new D.$Td),this.f=this.B(new D.$Td),this.g=this.B(new D.$Td),this.h=this.B(new D.$Td),this.j=this.B(new D.$Td),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?j.URI.revive(f.source):f.source,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(m=>({...m,local:m.local?C(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:j.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(l,f){l.fire(f)}r(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(l){const f=await this.getTargetPlatform();return l.allTargetPlatforms.some(m=>(0,R.$lo)(m,l.allTargetPlatforms,f))}zip(l){return Promise.resolve(this.m.call("zip",[l]).then(f=>j.URI.revive(f)))}unzip(l){return Promise.resolve(this.m.call("unzip",[l]))}install(l,f){return Promise.resolve(this.m.call("install",[l,f])).then(m=>C(m,null))}installFromLocation(l,f){return Promise.resolve(this.m.call("installFromLocation",[l,f])).then(m=>C(m,null))}async installExtensionsFromProfile(l,f,m){return(await this.m.call("installExtensionsFromProfile",[l,f,m])).map(E=>C(E,null))}getManifest(l){return Promise.resolve(this.m.call("getManifest",[l]))}installFromGallery(l,f){return Promise.resolve(this.m.call("installFromGallery",[l,f])).then(m=>C(m,null))}async installGalleryExtensions(l){return(await this.m.call("installGalleryExtensions",[l])).map(m=>({...m,local:m.local?C(m.local,null):m.local,source:this.r(m.source)?j.URI.revive(m.source):m.source,profileLocation:j.URI.revive(m.profileLocation)}))}uninstall(l,f){return Promise.resolve(this.m.call("uninstall",[l,f]))}reinstallFromGallery(l){return Promise.resolve(this.m.call("reinstallFromGallery",[l])).then(f=>C(f,null))}getInstalled(l=null,f){return Promise.resolve(this.m.call("getInstalled",[l,f])).then(m=>m.map(h=>C(h,null)))}updateMetadata(l,f,m){return Promise.resolve(this.m.call("updateMetadata",[l,f,m])).then(h=>C(h,null))}toggleAppliationScope(l,f){return this.m.call("toggleAppliationScope",[l,f]).then(m=>C(m,null))}copyExtensions(l,f){return this.m.call("copyExtensions",[l,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(l,f,m){const h=await this.m.call("download",[l,f,m]);return j.URI.revive(h)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$yp=$;class y{constructor(l){this.a=l}listen(l,f){throw new Error("Invalid listen")}call(l,f,m){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$zp=y}),define(le[97],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=void 0,e.$up=(0,D.$4h)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((j,O)=>ne(["node-vsce-sign"],async R=>j(R),O))),this.a}async verify(j,O,R){let k;try{k=await this.b()}catch{return!1}return k.verify(j,O,R)}}e.$vp=N}),define(le[98],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TYb=e.RecommendationsNotificationResult=e.$SYb=e.RecommendationSource=void 0;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function A(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$SYb=A;var j;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$TYb=(0,D.$4h)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,47,16,27,12,10,159,4,5,23,52]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.FileKind=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.FileOperationResult=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.FileChangeType=e.$Gk=e.FileOperation=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.FileSystemProviderErrorCode=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.FileSystemProviderCapabilities=e.$qk=e.FilePermission=e.FileType=e.$pk=e.$ok=void 0,e.$ok=(0,k.$4h)("fileService");function d(_){return _.create===!0}e.$pk=d;var c;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var $;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})($||(e.FilePermission=$={}));function y(_){const oe=_;return!!oe&&typeof oe.onDidChange=="function"}e.$qk=y;var b;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function l(_){return!!(_.capabilities&2)}e.$rk=l;function f(_){return!!(_.capabilities&8)}e.$sk=f;function m(_){return!!(_.capabilities&131072)}e.$tk=m;function h(_){return!!(_.capabilities&4)}e.$uk=h;function E(_){return!!(_.capabilities&16)}e.$vk=E;function n(_){return l(_)?!!(_.capabilities&16384):!1}e.$wk=n;function o(_){return l(_)?!!(_.capabilities&32768):!1}e.$xk=o;function s(_){return!!(_.capabilities&65536)}e.$yk=s;function i(_){return!!(_.capabilities&2048)}e.$zk=i;var t;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(oe,K){const U=new r(oe.toString(),K);return w(U,K),U}constructor(oe,K){super(oe),this.code=K}}e.$Ak=r;function a(_,oe){return r.create(_,oe)}e.$Bk=a;function v(_){return _||a((0,R.localize)(0,null),t.Unknown)}e.$Ck=v;function w(_,oe){return _.name=oe?`${oe} (FileSystemError)`:"FileSystemError",_}e.$Dk=w;function u(_){if(!_)return t.Unknown;if(_ instanceof r)return _.code;const oe=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!oe)return t.Unknown;switch(oe[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Ek=u;function p(_){if(_ instanceof Z)return _.fileOperationResult;switch(u(_)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Fk=p;var I;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class T{constructor(oe,K,U){this.resource=oe,this.operation=K,this.target=U}isOperation(oe){return this.operation===oe}}e.$Gk=T;var F;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(F||(e.FileChangeType=F={}));class M{static{this.a=null}constructor(oe,K){this.c=K,this.b=void 0,this.d=new S.$V(()=>{const U=D.$0h.forUris(()=>this.c);return U.fill(this.rawAdded.map(P=>[P,!0])),U}),this.f=new S.$V(()=>{const U=D.$0h.forUris(()=>this.c);return U.fill(this.rawUpdated.map(P=>[P,!0])),U}),this.g=new S.$V(()=>{const U=D.$0h.forUris(()=>this.c);return U.fill(this.rawDeleted.map(P=>[P,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of oe){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==M.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(oe,...K){return this.h(oe,{includeChildren:!1},...K)}affects(oe,...K){return this.h(oe,{includeChildren:!0},...K)}h(oe,K,...U){if(!oe)return!1;const P=U.length>0;return!!((!P||U.includes(1))&&(this.d.value.get(oe)||K.includeChildren&&this.d.value.findSuperstr(oe))||(!P||U.includes(0))&&(this.f.value.get(oe)||K.includeChildren&&this.f.value.findSuperstr(oe))||(!P||U.includes(2))&&(this.g.value.findSubstr(oe)||K.includeChildren&&this.g.value.findSuperstr(oe)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(oe){return this.b===oe}hasCorrelation(){return typeof this.b=="number"}}e.$Hk=M;function z(_,oe,K){return!_||!oe||_===oe||oe.length>_.length?!1:(oe.charAt(oe.length-1)!==N.sep&&(oe+=N.sep),K?(0,A.$$e)(_,oe):_.indexOf(oe)===0)}e.$Ik=z;class Z extends Error{constructor(oe,K,U){super(oe),this.fileOperationResult=K,this.options=U}}e.$Jk=Z;class J extends Z{constructor(oe,K,U,P){super(oe,K,P),this.fileOperationResult=K,this.size=U}}e.$Kk=J;class x extends Z{constructor(oe,K,U){super(oe,2,U),this.stat=K}}e.$Lk=x;var G;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$Mk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Nk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ok="files.associations",e.$Pk="files.exclude",e.$Qk="files.readonlyInclude",e.$Rk="files.readonlyExclude",e.$Sk="files.readonlyFromPermissions";var Q;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(Q||(e.FileKind=Q={})),e.$Tk="";function V(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$Uk=V;async function B(_,oe){if(!oe.hasProvider(O.URI.from({scheme:_.scheme})))return new Promise(K=>{const U=oe.onDidChangeFileSystemProviderRegistrations(P=>{P.scheme===_.scheme&&P.added&&(U.dispose(),K())})})}e.$Vk=B;class te{static{this.KB=1024}static{this.MB=te.KB*te.KB}static{this.GB=te.MB*te.KB}static{this.TB=te.GB*te.KB}static formatSize(oe){return(0,j.$Kf)(oe)||(oe=0),oe<te.KB?(0,R.localize)(1,null,oe.toFixed(0)):oe<te.MB?(0,R.localize)(2,null,(oe/te.KB).toFixed(2)):oe<te.GB?(0,R.localize)(3,null,(oe/te.MB).toFixed(2)):oe<te.TB?(0,R.localize)(4,null,(oe/te.GB).toFixed(2)):(0,R.localize)(5,null,(oe/te.TB).toFixed(2))}}e.$Wk=te;function se(_){const oe=typeof _=="string"||_?.scheme===C.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===C.Schemas.file?1024*te.MB:oe?10*te.MB:g.$o?50*te.MB:1024*te.MB}e.$Xk=se});var X=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(le[189],he([0,1,72,46,11]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a_b=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const k=(await this.a.readFileStream(R)).value;return new Promise((g,C)=>{const S=(0,D.createHash)("md5");(0,N.$_d)(k,{onData:d=>S.update(d.buffer),onError:d=>C(d),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$a_b=j,e.$a_b=j=ye([X(0,A.$ok)],j)}),define(le[99],he([0,1,15,7,160,11]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0;async function O(C,S,d,c,$,y){let b;try{await R(C,S,d,c,$,y)}catch(l){b=l}finally{b&&$.errorTransformer&&(b=$.errorTransformer(b)),typeof b<"u"&&d.error(b),d.end()}}e.$3p=O;async function R(C,S,d,c,$,y){k(y);const b=await C.open(S,{create:!1});try{k(y);let l=0,f=0,m=$&&typeof $.length=="number"?$.length:void 0,h=D.$he.alloc(Math.min($.bufferSize,typeof m=="number"?m:$.bufferSize)),E=$&&typeof $.position=="number"?$.position:0,n=0;do f=await C.read(b,E,h.buffer,n,h.byteLength-n),E+=f,n+=f,l+=f,typeof m=="number"&&(m-=f),n===h.byteLength&&(await d.write(c(h)),h=D.$he.alloc(Math.min($.bufferSize,typeof m=="number"?m:$.bufferSize)),n=0);while(f>0&&(typeof m!="number"||m>0)&&k(y)&&g(l,$));if(n>0){let o=n;typeof m=="number"&&(o=Math.min(n,m)),d.write(c(h.slice(0,o)))}}catch(l){throw(0,j.$Ck)(l)}finally{await C.close(b)}}function k(C){if(C.isCancellationRequested)throw(0,N.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,j.$Bk)((0,A.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[49],he([0,1,91,2,16,5,10,11]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=e.$$p=e.$0p=e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=void 0;function k(l){return l.recursive===!0}e.$5p=k;class g extends N.$Tc{static{this.a=5}constructor(f,m,h,E){super(),this.h=f,this.j=m,this.m=h,this.n=E,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const f=new N.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(m=>this.h(m))),f.add(this.b.onDidLogMessage(m=>this.j(m))),f.add(this.b.onDidError(m=>this.t(m)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$6p=g;class C extends g{constructor(f,m,h){super(f,m,h,{type:"node.js",restartOnError:!1})}}e.$7p=C;class S extends g{constructor(f,m,h){super(f,m,h,{type:"universal",restartOnError:!0})}}e.$8p=S;function d(l){return l.map(f=>({type:f.type,resource:O.URI.revive(f.resource),cId:f.cId}))}e.$9p=d;function c(l){const f=new b;for(const m of l)f.processEvent(m);return f.coalesce()}e.$0p=c;function $(l,f){return typeof f=="string"&&!f.startsWith(D.$Gj)&&!(0,A.$ic)(f)?{base:l,pattern:f}:f}e.$$p=$;function y(l,f){const m=[];for(const h of f)m.push((0,D.$Kj)($(l,h)));return m}e.$_p=y;class b{constructor(){this.a=new Set,this.b=new Map}c(f){return j.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const m=this.b.get(this.c(f));let h=!1;if(m){const E=m.type,n=f.type;m.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?h=!0:E===1&&n===2?(this.b.delete(this.c(f)),this.a.delete(m)):E===2&&n===1?m.type=0:E===1&&n===0||(m.type=n)}else h=!0;h&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],m=[];return Array.from(this.a).filter(h=>h.type!==2?(f.push(h),!1):!0).sort((h,E)=>h.resource.fsPath.length-E.resource.fsPath.length).filter(h=>m.some(E=>(0,R.$Ik)(h.resource.fsPath,E,!j.$k))?!1:(m.push(h.resource.fsPath),!0)).concat(f)}}}),define(le[190],he([0,1,15,38,7,3,2,46,32,11,49]),function(ne,e,D,N,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6N=e.$5N=void 0,e.$5N="localFilesystem";class S extends O.$Tc{constructor(c,$){super(),this.a=c,this.b=$,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Td),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Td),this.onDidWatchError=this.g.event,this.h=(0,k.$og)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(c){return this.a.call("stat",[c])}readdir(c){return this.a.call("readdir",[c])}async readFile(c,$){const{buffer:y}=await this.a.call("readFile",[c,$]);return y}readFileStream(c,$,y){const b=(0,R.$8d)(f=>D.$he.concat(f.map(m=>D.$he.wrap(m))).buffer),l=new O.$Sc;return l.add(this.a.listen("readFileStream",[c,$])(f=>{if(f instanceof D.$he)b.write(f.buffer);else{if(f==="end")b.end();else{let m;if(f instanceof Error)m=f;else{const h=f;m=(0,g.$Bk)(h.message??(0,N.$Oi)(h),h.code??g.FileSystemProviderErrorCode.Unknown)}b.error(m),b.end()}l.dispose()}})),l.add(y.onCancellationRequested(()=>{b.error((0,A.$6)()),b.end(),l.dispose()})),b}writeFile(c,$,y){return this.a.call("writeFile",[c,D.$he.wrap($),y])}open(c,$){return this.a.call("open",[c,$])}close(c){return this.a.call("close",[c])}async read(c,$,y,b,l){const[f,m]=await this.a.call("read",[c,$,l]);return y.set(f.buffer.slice(0,m),b),m}write(c,$,y,b,l){return this.a.call("write",[c,$,D.$he.wrap(y),b,l])}mkdir(c){return this.a.call("mkdir",[c])}delete(c,$){return this.a.call("delete",[c,$])}rename(c,$,y){return this.a.call("rename",[c,$,y])}copy(c,$,y){return this.a.call("copy",[c,$,y])}cloneFile(c,$){return this.a.call("cloneFile",[c,$])}j(){this.B(this.a.listen("fileChange",[this.h])(c=>{if(Array.isArray(c)){const $=c;this.f.fire((0,C.$9p)($))}else{const $=c;this.g.fire($)}}))}watch(c,$){const y=(0,k.$og)();return this.a.call("watch",[this.h,y,c,$]),(0,O.$Rc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$6N=S}),define(le[191],he([0,1,54,6,26,48,2,88,16,5,19,10,143,31,49]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$mq=void 0;class y extends O.$Tc{static{this.a=100}static{this.b=75}constructor(f,m,h,E){super(),this.m=f,this.n=m,this.r=h,this.s=E,this.c=this.B(new N.$gh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.n(n))),this.f=this.B(new N.$fh(n=>this.z(n),y.b)),this.g=(0,$.$_p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$_p)(this.m.path,this.m.includes):void 0,this.j=new A.$4d,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const m=await c.Promises.stat(f);this.B(await this.w(f,m.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let m=f.path;try{m=await c.Promises.realpath(f.path),f.path===m&&(m=await(0,d.$jq)(f.path)??f.path),f.path!==m&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${m})`)}catch{}return m}async w(f,m){if(g.$j&&(0,j.$6f)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),O.$Tc.None;const h=new A.$4d(this.j.token),E=new O.$Sc;try{const n=S.URI.file(this.m.path),o=(0,k.$nc)(f),s=(0,D.watch)(f);E.add((0,O.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${f}'`);const i=new Set;if(m)try{for(const r of await c.Promises.readdir(f))i.add(r)}catch(r){this.D(r)}const t=new Map;E.add((0,O.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),s.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),s.on("change",(r,a)=>{if(h.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let v="";if(a&&(v=a.toString(),g.$j&&(v=(0,R.$El)(v))),!(!v||r!=="change"&&r!=="rename"))if(m)if(r==="rename"){t.get(v)?.dispose();const w=setTimeout(async()=>{if(t.delete(v),v===o&&!await c.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(f,v));if(h.token.isCancellationRequested)return;let p;u?i.has(v)?p=0:(p=1,i.add(v)):(i.delete(v),p=2),this.y({resource:(0,C.$Fg)(n,v),type:p,cId:this.m.correlationId})},y.a);t.set(v,(0,O.$Rc)(()=>clearTimeout(w)))}else{let w;i.has(v)?w=0:(w=1,i.add(v)),this.y({resource:(0,C.$Fg)(n,v),type:w,cId:this.m.correlationId})}else if(r==="rename"||v!==o){const w=setTimeout(async()=>{const u=await c.Promises.exists(f);h.token.isCancellationRequested||(u?(this.y({resource:n,type:0,cId:this.m.correlationId},!0),E.add(await this.w(f,!1))):(this.y({resource:n,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},y.a);E.clear(),E.add((0,O.$Rc)(()=>clearTimeout(w)))}else this.y({resource:n,type:0,cId:this.m.correlationId},!0)})}catch(n){await c.Promises.exists(f)&&!h.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${n.toString()})`)}return(0,O.$Rc)(()=>{h.dispose(!0),E.dispose()})}y(f,m=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!m&&this.g.some(h=>h(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!m&&this.h&&this.h.length>0&&!this.h.some(h=>h(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const m=(0,$.$0p)(f);if(m.length>0){if(this.s)for(const E of m)this.G(` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`);this.c.work(m)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${m[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${m.length}, most recent change: ${m[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$k)return c.Promises.exists(f);try{const m=(0,k.$nc)(f);return(await c.Promises.readdir((0,k.$mc)(f))).some(E=>E===m)}catch(m){return this.G(m),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$mq=y;async function b(l,f,m,h,E=512){const n=await c.Promises.open(l,"r"),o=Buffer.allocUnsafe(E),s=new A.$4d(h);let i,t=!1;const r={path:l,excludes:[],recursive:!1},a=new y(r,v=>{(async()=>{for(const{type:w}of v)if(w===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:u}=await c.Promises.read(n,o,0,E,null);if(!u||s.token.isCancellationRequested)break;f(o.slice(0,u))}}catch(u){i=new Error(u),s.dispose(!0)}finally{t=!1}}})()});return await a.ready,m(),new Promise((v,w)=>{s.token.onCancellationRequested(async()=>{a.dispose();try{await c.Promises.close(n)}catch(u){i=new Error(u)}i?w(i):v()})})}e.$nq=b}),define(le[192],he([0,1,3,91,2,5,191]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=void 0;class R extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Td),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Td),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(c=>{const $=this.c.get(c.path);return $?!(0,N.$Oj)($.request.excludes,c.excludes)||!(0,N.$Oj)($.request.includes,c.includes):!0}),d=Array.from(this.c.values()).filter(({request:c})=>!C.find($=>$.path===c.path&&(0,N.$Oj)($.excludes,c.excludes)&&(0,N.$Oj)($.includes,c.includes))).map(({request:c})=>c.path);S.length&&this.m(`Request to start watching: ${S.map(c=>`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`).join(",")}`),d.length&&this.m(`Request to stop watching: ${d.join(",")}`);for(const c of d)this.h(c);for(const c of S)this.g(c)}g(g){const C=new O.$mq(g,d=>this.a.fire(d),d=>this.b.fire(d),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const d=j.$k?S.path:S.path.toLowerCase();let c=C.get(S.correlationId);c||(c=new Map,C.set(S.correlationId,c)),c.set(d,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$oq=R}),define(le[193],he([0,1,49,192]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=void 0;class A extends D.$7p{constructor(O,R,k){super(O,R,k),this.s()}r(O){return O.add(new N.$oq)}}e.$pq=A}),define(le[194],he([0,1,23,40,93,49]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=void 0;class O extends j.$8p{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new A.$gq(D.$mg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),N.ProxyChannel.toService((0,N.$Kh)(g.getChannel("watcher")))}}e.$hq=O}),define(le[73],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=void 0;class D{constructor(...A){this.a=new Map;for(const[j,O]of A)this.set(j,O)}set(A,j){const O=this.a.get(A);return this.a.set(A,j),O}has(A){return this.a.has(A)}get(A){return this.a.get(A)}}e.$2h=D}),define(le[195],he([0,1,6,7,2,71,186,4,73,87]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=void 0;const C=!1;class S extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class d{constructor(b=new k.$2h,l=!1,f,m=C){this.f=b,this.g=l,this.h=f,this.i=m,this.o=new Set,this.f.set(R.$3h,this),this._globalGraph=m?f?._globalGraph??new O.$sq(h=>h):void 0}createChild(b){return new d(b,this.g,this,this.i)}invokeFunction(b,...l){const f=$.traceInvocation(this.i,b);let m=!1;try{return b({get:E=>{if(m)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const n=this.m(E,f);if(!n)throw new Error(`[invokeFunction] unknown service '${E}'`);return n}},...l)}finally{m=!0,f.stop()}}createInstance(b,...l){let f,m;return b instanceof j.$1h?(f=$.traceCreation(this.i,b.ctor),m=this.j(b.ctor,b.staticArguments.concat(l),f)):(f=$.traceCreation(this.i,b),m=this.j(b,l,f)),f.stop(),m}j(b,l=[],f){const m=R._util.getServiceDependencies(b).sort((n,o)=>n.index-o.index),h=[];for(const n of m){const o=this.m(n.id,f);o||this.u(`[createInstance] ${b.name} depends on UNKNOWN service ${n.id}.`,!1),h.push(o)}const E=m.length>0?m[0].index:l.length;if(l.length!==E){console.trace(`[createInstance] First service dependency of ${b.name} at position ${E+1} conflicts with ${l.length} static arguments`);const n=E-l.length;n>0?l=l.concat(new Array(n)):l=l.slice(0,E)}return Reflect.construct(b,l.concat(h))}k(b,l){if(this.f.get(b)instanceof j.$1h)this.f.set(b,l);else if(this.h)this.h.k(b,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(b){const l=this.f.get(b);return!l&&this.h?this.h.l(b):l}m(b,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const f=this.l(b);return f instanceof j.$1h?this.q(b,f,l.branch(b,!0)):(l.branch(b,!1),f)}q(b,l,f){if(this.o.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.o.add(b);try{return this.r(b,l,f)}finally{this.o.delete(b)}}r(b,l,f){const m=new O.$sq(n=>n.id.toString());let h=0;const E=[{id:b,desc:l,_trace:f}];for(;E.length;){const n=E.pop();if(m.lookupOrInsertNode(n),h++>1e3)throw new S(m);for(const o of R._util.getServiceDependencies(n.desc.ctor)){const s=this.l(o.id);if(s||this.u(`[createInstance] ${b} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(o.id)),s instanceof j.$1h){const i={id:o.id,desc:s,_trace:n._trace.branch(o.id,!0)};m.insertEdge(n,i),E.push(i)}}}for(;;){const n=m.roots();if(n.length===0){if(!m.isEmpty())throw new S(m);break}for(const{data:o}of n){if(this.l(o.id)instanceof j.$1h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}m.removeNode(o)}}return this.l(b)}s(b,l,f=[],m,h){if(this.f.get(b)instanceof j.$1h)return this.t(b,l,f,m,h);if(this.h)return this.h.s(b,l,f,m,h);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(b,l,f=[],m,h){if(m){const E=new d(void 0,this.g,this,this.i);E.c=String(b);const n=new Map,o=new D.$kh(()=>{const s=E.j(l,f,h);for(const[i,t]of n){const r=s[i];if(typeof r=="function")for(const a of t)r.apply(s,a)}return n.clear(),s});return new Proxy(Object.create(null),{get(s,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let a=n.get(i);return a||(a=new g.$4c,n.set(i,a)),(w,u,p)=>{const I=a.push([w,u,p]);return(0,A.$Rc)(I)}}if(i in s)return s[i];const t=o.value;let r=t[i];return typeof r!="function"||(r=r.bind(t),s[i]=r),r},set(s,i,t){return o.value[i]=t,!0},getPrototypeOf(s){return l.prototype}})}else return this.j(l,f,h)}u(b,l){if(l&&console.warn(b),this.g)throw new Error(b)}}e.$tq=d;var c;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(c||(c={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(b,l){return b?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(b,l){return b?new $(1,l.name):$.c}static{this.f=0}constructor(b,l){this.type=b,this.name=l,this.g=Date.now(),this.h=[]}branch(b,l){const f=new $(3,b.toString());return this.h.push([b,l,f]),f}stop(){const b=Date.now()-this.g;$.f+=b;let l=!1;function f(h,E){const n=[],o=new Array(h+1).join("	");for(const[s,i,t]of E.h)if(i&&t){l=!0,n.push(`${o}CREATES -> ${s}`);const r=f(h+1,t);r&&n.push(r)}else n.push(`${o}uses -> ${s}`);return n.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(b>2||l)&&$.all.add(m.join(`
`))}}e.$uq=$}),define(le[56],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0,e.$J$b=(0,D.$4h)("mainProcessService");class N{constructor(j,O){this.a=j,this.b=O}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,O){this.a.registerChannel(j,O)}}e.$K$b=N}),define(le[74],he([0,1,26,2,5,162,29,4]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$8q=k,e.$9q=(0,R.$4h)("languagePackService");let g=class extends N.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new D.$4d;setTimeout(()=>S.cancel(),1e3);let d;try{d=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const $=d.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(b=>b.startsWith("lp-"))).map(y=>{const b=y.properties.localizedLanguages?.[0],l=k(y);return{...this.f(l,b,y),extensionId:y.identifier.id,galleryExtension:y}});return $.push(this.f("en","English")),$}f(S,d,c){const $=d??S;let y;if($!==S&&(y=`(${S})`),S.toLowerCase()===A.$w.toLowerCase()&&(y??="",y+=(0,j.localize)(0,null)),c?.installCount){y??="";const b=c.installCount;let l;b>1e6?l=`${Math.floor(b/1e5)/10}M`:b>1e3?l=`${Math.floor(b/1e3)}K`:l=String(b),y+=` $(cloud-download) ${l}`}return{id:S,label:$,description:y}}};e.$0q=g,e.$0q=g=ye([X(0,O.$no)],g)}),define(le[196],he([0,1,2,74]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0;let A=class extends D.$Tc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$9$b=A,e.$9$b=A=ye([X(0,N.$9q)],A)}),define(le[8],he([0,1,38,3,53,2,34,5,19,12,10,94,4]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.log=e.$oj=e.LogLevel=e.$nj=e.$mj=e.$lj=void 0,e.$lj=(0,d.$4h)("logService"),e.$mj=(0,d.$4h)("loggerService");function c(){return new Date().toISOString()}function $(w){return(0,g.$Kf)(w)}e.$nj=$;var y;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$oj=y.Info;function b(w,u,p){switch(u){case y.Trace:w.trace(p);break;case y.Debug:w.debug(p);break;case y.Info:w.info(p);break;case y.Warning:w.warn(p);break;case y.Error:w.error(p);break;case y.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=b;function l(w,u=!1){let p="";for(let I=0;I<w.length;I++){let T=w[I];if(T instanceof Error&&(T=(0,D.$Oi)(T,u)),typeof T=="object")try{T=JSON.stringify(T)}catch{}p+=(I>0?" ":"")+T}return p}class f extends j.$Tc{constructor(){super(...arguments),this.b=e.$oj,this.c=this.B(new N.$Td),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==y.Off&&this.b<=u}}e.$qj=f;class m extends f{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(y.Trace)&&this.g(y.Trace,l([u,...p],!0))}debug(u,...p){this.f(y.Debug)&&this.g(y.Debug,l([u,...p]))}info(u,...p){this.f(y.Info)&&this.g(y.Info,l([u,...p]))}warn(u,...p){this.f(y.Warning)&&this.g(y.Warning,l([u,...p]))}error(u,...p){if(this.f(y.Error))if(u instanceof Error){const I=Array.prototype.slice.call(arguments);I[0]=u.stack,this.g(y.Error,l(I))}else this.g(y.Error,l([u,...p]))}flush(){}}e.$rj=m;class h extends f{constructor(u=e.$oj){super(),this.setLevel(u),this.g=!R.$i}trace(u,...p){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,u,...p):console.log(`[main ${c()}]`,u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,u,...p):console.log(`[main ${c()}]`,u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,u,...p):console.log(`[main ${c()}]`,u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,u,...p):console.warn(`[main ${c()}]`,u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,u,...p):console.error(`[main ${c()}]`,u,...p))}flush(){}}e.$sj=h;class E extends f{constructor(u=e.$oj,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}flush(){}}e.$tj=E;class n extends f{constructor(u,p=e.$oj){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(u),...p])}debug(u,...p){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(u),...p])}info(u,...p){this.f(y.Info)&&this.g.log(y.Info,[this.h(u),...p])}warn(u,...p){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(u),...p])}error(u,...p){this.f(y.Error)&&this.g.log(y.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,D.$Oi)(u,this.f(y.Trace))}flush(){}}e.$uj=n;class o extends f{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const I of this.g)I.trace(u,...p)}debug(u,...p){for(const I of this.g)I.debug(u,...p)}info(u,...p){for(const I of this.g)I.info(u,...p)}warn(u,...p){for(const I of this.g)I.warn(u,...p)}error(u,...p){for(const I of this.g)I.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose();super.dispose()}}e.$vj=o;class s extends j.$Tc{constructor(u,p,I){if(super(),this.h=u,this.j=p,this.b=new O.$Ac,this.c=this.B(new N.$Td),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Td),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Td),this.onDidChangeVisibility=this.g.event,I)for(const T of I)this.b.set(T.resource,{logger:void 0,info:T})}m(u){return(0,g.$Gf)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const I=this.n(u),T=(0,g.$Gf)(u)?u:p?.id??(0,A.$Ri)(I.toString()).toString(16);let F=this.b.get(I)?.logger;const M=p?.logLevel==="always"?y.Trace:p?.logLevel;F||(F=this.s(I,M??this.getLogLevel(I)??this.h,{...p,id:T}));const z={logger:F,info:{resource:I,id:T,logLevel:M,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(z.info),this.b.set(I,z),F}n(u){return(0,g.$Gf)(u)?(0,k.$Fg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(C.URI.isUri(u)){const I=u,T=p,F=this.b.get(I);F&&T!==F.info.logLevel&&(F.info.logLevel=T===this.h?void 0:T,F.logger?.setLevel(T),this.b.set(F.info.resource,F),this.f.fire([I,T]))}else{this.h=u;for(const[I,T]of this.b.entries())this.b.get(I)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const I=this.m(u);I&&p!==!I.info.hidden&&(I.info.hidden=!p,this.b.set(I.info.resource,I),this.g.fire([I.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$wj=s;class i{constructor(){this.onDidChangeLogLevel=new N.$Td().event}setLevel(u){}getLevel(){return y.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$xj=i;class t extends i{}e.$yj=t;function r(w){if(w.verbose)return y.Trace;if(typeof w.logLevel=="string"){const u=v(w.logLevel.toLowerCase());if(u!==void 0)return u}return e.$oj}e.$zj=r;function a(w){switch(w){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$Aj=a;function v(w){switch(w){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$Bj=v,e.$Cj=new S.$ij("logLevel",a(y.Info))}),define(le[197],he([0,1,6,7,2,23,16,19,31,14,8]),function(ne,e,D,N,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=void 0;let S=class extends A.$Tc{constructor(c,$){super(),this.a=c,this.b=$,this.B(new D.$dh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const c=(0,R.$Cg)(this.a.logsHome),$=(0,R.$Eg)(this.a.logsHome.with({scheme:j.Schemas.file})).fsPath,l=(await k.Promises.readdir($)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==c),f=l.slice(0,Math.max(0,l.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(m=>k.Promises.rm((0,O.$jc)($,m)))))}catch(c){(0,N.$1)(c)}}};e.$0$b=S,e.$0$b=S=ye([X(0,g.$$h),X(1,C.$lj)],S)}),define(le[198],he([0,1,18,6,7,3,2,16,49,8]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=void 0;class C extends O.$Tc{constructor(d,c){super(),this.a=d,this.b=c,this.c=this.B(new j.$Td),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Td),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$2g(0)),this.w=[],this.y=this.B(new N.$2g(0))}watch(d,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(d,c):this.z(d,c)}n(d,c){const $={path:this.H(d),excludes:c.excludes,includes:c.includes,recursive:c.recursive,correlationId:c.correlationId},y=(0,D.$Ub)(this.j,$);return this.r(),(0,O.$Rc)(()=>{y(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,A.$1)(d))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,k.$9p)(c)),c=>this.G(c),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const c of this.j)(0,k.$5p)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const c of this.j)(0,k.$5p)(c)&&d.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,c){const $={path:this.H(d),excludes:c.excludes,includes:c.includes,recursive:!1,correlationId:c.correlationId},y=(0,D.$Ub)(this.w,$);return this.C(),(0,O.$Rc)(()=>{y(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,A.$1)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,k.$9p)(d)),d=>this.G(d),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.a[d.type](d.message)}H(d){return(0,R.$hc)(d.fsPath)}}e.$aq=C}),define(le[199],he([0,1,18,6,15,26,3,53,61,2,47,23,100,19,46,158,11,99,8,7]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=void 0;let E=class extends g.$Tc{static{h=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new O.$Td),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$Td),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$Td),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$Td),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$Td),this.Y=this.B(new O.$Td),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$Td),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$ah)}registerProvider(o,s){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,d.mark)(`code/registerFilesystem/${o}`);const i=new g.$Sc;return this.h.set(o,s),this.c.fire({added:!0,scheme:o,provider:s}),i.add(s.onDidChangeFile(t=>{const r=new b.$Hk(t,!this.S(s));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(t=>this.Z.fire(new Error(t)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:s}),this.h.delete(o),(0,g.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const s=[];this.f.fire({scheme:o,join(i){s.push(i)}}),!this.h.has(o)&&await N.Promises.settled(s)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,s){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return k.Iterable.map(this.h,([o,s])=>({scheme:o,capabilities:s.capabilities}))}async j(o){if(!(0,c.$Jg)(o))throw new b.$Jk((0,y.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const s=this.h.get(o.scheme);if(!s){const i=new m.$bb;throw i.message=(0,y.localize)(1,null,o.toString()),i}return s}async m(o){const s=await this.j(o);if((0,b.$uk)(s)||(0,b.$rk)(s)||(0,b.$vk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const s=await this.j(o);if((0,b.$uk)(s)||(0,b.$rk)(s))return s;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,s){try{return await this.s(o,s)}catch(i){throw(0,b.$Ek)(i)===b.FileSystemProviderErrorCode.FileNotFound?new b.$Jk((0,y.localize)(2,null,this.sb(o)),1):(0,b.$Ck)(i)}}async s(o,s){const i=await this.j(o),t=this.S(i),r=s?.resolveTo,a=s?.resolveSingleChildDescendants,v=s?.resolveMetadata,w=await i.stat(o);let u;return this.t(i,o,w,void 0,!!v,(p,I)=>(u||(u=C.$0h.forUris(()=>!t),u.set(o,!0),r&&u.fill(!0,r)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?I===1:!1))}async t(o,s,i,t,r,a){const{providerExtUri:v}=this.R(o),w={resource:s,name:v.basename(s),isFile:(i.type&b.FileType.File)!==0,isDirectory:(i.type&b.FileType.Directory)!==0,isSymbolicLink:(i.type&b.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&b.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Uk)({mtime:i.mtime,size:i.size}),children:void 0};if(w.isDirectory&&a(w,t)){try{const u=await o.readdir(s),p=await N.Promises.settled(u.map(async([I,T])=>{try{const F=v.joinPath(s,I),M=r?await o.stat(F):{type:T};return await this.t(o,F,M,u.length,r,a)}catch(F){return this.b.trace(F),null}}));w.children=(0,D.$Hb)(p)}catch(u){this.b.trace(u),w.children=[]}return w}return w}async resolveAll(o){return N.Promises.settled(o.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const s=await this.j(o),i=await s.stat(o);return this.t(s,o,i,void 0,!0,()=>!1)}async exists(o){const s=await this.j(o);try{return!!await s.stat(o)}catch{return!1}}async canCreateFile(o,s){try{await this.u(o,s)}catch(i){return i}return!0}async u(o,s){if(!s?.overwrite&&await this.exists(o))throw new b.$Jk((0,y.localize)(3,null,this.sb(o)),3,s)}async createFile(o,s=A.$he.fromString(""),i){await this.u(o,i);const t=await this.writeFile(o,s);return this.r.fire(new b.$Gk(o,0,t)),t}async writeFile(o,s,i){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=i;if((0,b.$xk)(t)&&!a?.atomic){const v=t.enforceAtomicWriteFile?.(o);v&&(a={...i,atomic:v})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let w;if((0,b.$rk)(t)&&!(s instanceof A.$he))if((0,$.$6d)(s)){const u=await(0,$.$ae)(s,3);u.ended?w=A.$he.concat(u.buffer):w=u}else w=(0,$.$0d)(s,u=>A.$he.concat(u),3);else w=s;!(0,b.$uk)(t)||(0,b.$rk)(t)&&w instanceof A.$he||(0,b.$rk)(t)&&(0,b.$xk)(t)&&a?.atomic?await this.hb(t,o,a,w):await this.db(t,o,a,w instanceof A.$he?(0,A.$se)(w):w),this.r.fire(new b.$Gk(o,4))}catch(v){throw new b.$Jk((0,y.localize)(4,null,this.sb(o),(0,b.$Ck)(v).toString()),(0,b.$Fk)(v),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,s,i){const t=!!i?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(o.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(t)throw new Error((0,y.localize)(8,null,this.sb(s)))}let a;try{a=await o.stat(s)}catch{return}if(a.type&b.FileType.Directory)throw new b.$Jk((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,a),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==b.$Tk&&typeof a.mtime=="number"&&typeof a.size=="number"&&i.mtime<a.mtime&&i.etag!==(0,b.$Uk)({mtime:i.mtime,size:a.size}))throw new b.$Jk((0,y.localize)(10,null),3,i);return a}async readFile(o,s,i){const t=await this.m(o);return s?.atomic?this.z(t,o,s,i):this.C(t,o,s,i)}async z(o,s,i,t){return new Promise((r,a)=>{this.cb.queueFor(s,this.R(o).providerExtUri).queue(async()=>{try{const v=await this.C(o,s,i,t);r(v)}catch(v){a(v)}})})}async C(o,s,i,t){const r=await this.D(o,s,{...i,preferUnbuffered:!0},t);return{...r,value:await(0,A.$te)(r.value)}}async readFileStream(o,s,i){const t=await this.m(o);return this.D(t,o,s,i)}async D(o,s,i,t){const r=new j.$4d(t);let a=i;(0,b.$wk)(o)&&o.enforceAtomicReadFile?.(s)&&(a={...i,atomic:!0});const v=this.J(s,a).then(u=>u,u=>{throw r.dispose(!0),u});let w;try{return typeof a?.etag=="string"&&a.etag!==b.$Tk&&await v,a?.atomic&&(0,b.$wk)(o)||!((0,b.$uk)(o)||(0,b.$vk)(o))||(0,b.$rk)(o)&&a?.preferUnbuffered?w=this.I(o,s,a):(0,b.$vk)(o)?w=this.G(o,s,r.token,a):w=this.H(o,s,r.token,a),w.on("end",()=>r.dispose()),w.on("error",()=>r.dispose()),{...await v,value:w}}catch(u){throw w&&await(0,$.$$d)(w),this.F(u,s,a)}}F(o,s,i){const t=(0,y.localize)(11,null,this.sb(s),(0,b.$Ck)(o).toString());return o instanceof b.$Lk?new b.$Lk(t,o.stat,i):o instanceof b.$Kk?new b.$Kk(t,o.fileOperationResult,o.size,o.options):new b.$Jk(t,(0,b.$Fk)(o),i)}G(o,s,i,t=Object.create(null)){const r=o.readFileStream(s,t,i);return(0,$.$ee)(r,{data:a=>a instanceof A.$he?a:A.$he.wrap(a),error:a=>this.F(a,s,t)},a=>A.$he.concat(a))}H(o,s,i,t=Object.create(null)){const r=(0,A.$xe)();return(0,l.$3p)(o,s,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,s,t)},i),r}I(o,s,i){const t=(0,$.$8d)(r=>A.$he.concat(r));return(async()=>{try{let r;i?.atomic&&(0,b.$wk)(o)?r=await o.readFile(s,{atomic:!0}):r=await o.readFile(s),typeof i?.position=="number"&&(r=r.slice(i.position)),typeof i?.length=="number"&&(r=r.slice(0,i.length)),this.L(s,r.byteLength,i),t.end(A.$he.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,s){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new b.$Jk((0,y.localize)(12,null,this.sb(o)),0,s);if(typeof s?.etag=="string"&&s.etag!==b.$Tk&&s.etag===i.etag)throw new b.$Lk((0,y.localize)(13,null),i,s);return this.L(o,i.size,s),i}L(o,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new b.$Kk((0,y.localize)(14,null,this.sb(o)),7,s,i)}async canMove(o,s,i){return this.M(o,s,"move",i)}async canCopy(o,s,i){return this.M(o,s,"copy",i)}async M(o,s,i,t){if(o.toString()!==s.toString())try{const r=i==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(s),s);await this.Q(r,o,a,s,i,t)}catch(r){return r}return!0}async move(o,s,i){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(s),s),a=await this.N(t,o,r,s,"move",!!i),v=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$Gk(o,a==="move"?2:3,v)),v}async copy(o,s,i){const t=await this.m(o),r=this.qb(await this.n(s),s),a=await this.N(t,o,r,s,"copy",!!i),v=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$Gk(o,a==="copy"?3:2,v)),v}async N(o,s,i,t,r,a){if(s.toString()===t.toString())return r;const{exists:v,isSameResourceWithDifferentPathCase:w}=await this.Q(o,s,i,t,r,a);if(v&&!w&&a&&await this.del(t,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(t)),r==="copy"){if(o===i&&(0,b.$sk)(o))await o.copy(s,t,{overwrite:a});else{const u=await this.resolve(s);u.isDirectory?await this.P(o,u,i,t):await this.O(o,s,i,t)}return r}else return o===i?(await o.rename(s,t,{overwrite:a}),r):(await this.N(o,s,i,t,"copy",a),await this.del(s,{recursive:!0}),"copy")}async O(o,s,i,t){if((0,b.$uk)(o)&&(0,b.$uk)(i))return this.jb(o,s,i,t);if((0,b.$uk)(o)&&(0,b.$rk)(i))return this.pb(o,s,i,t);if((0,b.$rk)(o)&&(0,b.$uk)(i))return this.nb(o,s,i,t);if((0,b.$rk)(o)&&(0,b.$rk)(i))return this.lb(o,s,i,t)}async P(o,s,i,t){await i.mkdir(t),Array.isArray(s.children)&&await N.Promises.settled(s.children.map(async r=>{const a=this.R(i).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),i,a):this.O(o,r.resource,i,a)}))}async Q(o,s,i,t,r,a){let v=!1;if(o===i){const{providerExtUri:u,isPathCaseSensitive:p}=this.R(o);if(p||(v=u.isEqual(s,t)),v&&r==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(t)));if(!v&&u.isEqualOrParent(t,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(t)))}const w=await this.exists(t);if(w&&!v){if(!a)throw new b.$Jk((0,y.localize)(17,null,this.sb(s),this.sb(t)),4);if(o===i){const{providerExtUri:u}=this.R(o);if(u.isEqualOrParent(s,t))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(t)))}}return{exists:w,isSameResourceWithDifferentPathCase:v}}R(o){const s=this.S(o);return{providerExtUri:s?c.$vg:c.$xg,isPathCaseSensitive:s}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const s=this.qb(await this.j(o),o);await this.U(s,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new b.$Gk(o,0,i)),i}async U(o,s){const i=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(s,t.dirname(s));)try{if(!((await o.stat(s)).type&b.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(r){if((0,b.$Ek)(r)!==b.FileSystemProviderErrorCode.FileNotFound)throw r;i.push(t.basename(s)),s=t.dirname(s)}for(let r=i.length-1;r>=0;r--){s=t.joinPath(s,i[r]);try{await o.mkdir(s)}catch(a){if((0,b.$Ek)(a)!==b.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,s){try{await this.W(o,s)}catch(i){return i}return!0}async W(o,s){const i=this.qb(await this.j(o),o),t=!!s?.useTrash;if(t&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(o)));const r=s?.atomic;if(r&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,y.localize)(22,null,this.sb(o)));let a;try{a=await i.stat(o)}catch{}if(a)this.rb(o,a);else throw new b.$Jk((0,y.localize)(23,null,this.sb(o)),1);if(!!!s?.recursive){const w=await this.resolve(o);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(o)))}return i}async del(o,s){const i=await this.W(o,s);let t=s;if((0,b.$yk)(i)&&!t?.atomic){const w=i.enforceAtomicDelete?.(o);w&&(t={...s,atomic:w})}const r=!!t?.useTrash,a=!!t?.recursive,v=t?.atomic??!1;await i.delete(o,{recursive:a,useTrash:r,atomic:v}),this.r.fire(new b.$Gk(o,1))}async cloneFile(o,s){const i=await this.j(o),t=this.qb(await this.n(s),s);if(i===t&&this.R(i).providerExtUri.isEqual(o,s))return;if(i===t&&(0,b.$tk)(i))return i.cloneFile(o,s);await this.U(t,this.R(t).providerExtUri.dirname(s));const r=this.cb.queueFor(o,this.R(i).providerExtUri);return i===t&&(0,b.$sk)(i)?r.queue(()=>i.copy(o,s,{overwrite:!0})):r.queue(()=>this.O(i,o,t,s))}static{this.ab=0}createWatcher(o,s){return this.watch(o,{...s,correlationId:h.ab++})}watch(o,s={recursive:!1,excludes:[]}){const i=new g.$Sc;let t=!1,r=()=>{t=!0};i.add((0,g.$Rc)(()=>r())),(async()=>{try{const v=await this.bb(o,s);t?(0,g.$Oc)(v):r=()=>(0,g.$Oc)(v)}catch(v){this.b.error(v)}})();const a=s.correlationId;if(typeof a=="number"){const v=i.add(new O.$Td);return i.add(this.X.event(u=>{u.correlates(a)&&v.fire(u)})),{onDidChange:v.event,dispose:()=>i.dispose()}}return i}async bb(o,s){const i=await this.j(o),t=(0,R.$Ri)([this.R(i).providerExtUri.getComparisonKey(o),s]);let r=this.$.get(t);return r||(r={count:0,disposable:i.watch(o,s)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,s,i,t){return this.cb.queueFor(s,this.R(o).providerExtUri).queue(async()=>{const r=await o.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,$.$6d)(t)||(0,$.$7d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,b.$Ck)(a)}finally{await o.close(r)}})}async eb(o,s,i){let t=0,r;if((0,$.$7d)(i)){if(i.buffer.length>0){const a=A.$he.concat(i.buffer);await this.gb(o,s,a,a.byteLength,t,0),t+=a.byteLength}if(i.ended)return;r=i.stream}else r=i;return new Promise((a,v)=>{(0,$.$_d)(r,{onData:async w=>{r.pause();try{await this.gb(o,s,w,w.byteLength,t,0)}catch(u){return v(u)}t+=w.byteLength,setTimeout(()=>r.resume())},onError:w=>v(w),onEnd:()=>a()})})}async fb(o,s,i){let t=0,r;for(;(r=i.read())!==null;)await this.gb(o,s,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,s,i,t,r,a){let v=0;for(;v<t;){const w=await o.write(s,r+v,i.buffer,a+v,t-v);v+=w}}async hb(o,s,i,t){return this.cb.queueFor(s,this.R(o).providerExtUri).queue(()=>this.ib(o,s,i,t))}async ib(o,s,i,t){let r;t instanceof A.$he?r=t:(0,$.$6d)(t)?r=await(0,A.$te)(t):(0,$.$7d)(t)?r=await(0,A.$ue)(t):r=(0,A.$re)(t),await o.writeFile(s,r.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,s,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.kb(o,s,i,t))}async kb(o,s,i,t){let r,a;try{r=await o.open(s,{create:!1}),a=await i.open(t,{create:!0,unlock:!1});const v=A.$he.alloc(this.a);let w=0,u=0,p=0;do p=await o.read(r,w,v.buffer,u,v.byteLength-u),await this.gb(i,a,v,p,w,u),w+=p,u+=p,u===v.byteLength&&(u=0);while(p>0)}catch(v){throw(0,b.$Ck)(v)}finally{await N.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?i.close(a):Promise.resolve()])}}async lb(o,s,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.mb(o,s,i,t))}async mb(o,s,i,t){return i.writeFile(t,await o.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,s,i,t){return this.cb.queueFor(t,this.R(i).providerExtUri).queue(()=>this.ob(o,s,i,t))}async ob(o,s,i,t){const r=await i.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(s);await this.gb(i,r,A.$he.wrap(a),a.byteLength,0,0)}catch(a){throw(0,b.$Ck)(a)}finally{await i.close(r)}}async pb(o,s,i,t){const r=await(0,A.$te)(this.H(o,s,j.CancellationToken.None));await this.hb(i,t,void 0,r)}qb(o,s){if(o.capabilities&2048)throw new b.$Jk((0,y.localize)(25,null,this.sb(s)),6);return o}rb(o,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.$Jk((0,y.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$4p=E,e.$4p=E=h=ye([X(0,f.$lj)],E)}),define(le[200],he([0,1,54,270,6,34,15,3,48,2,16,5,19,46,31,161,11,99,198,38,194,193]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(o){console.error(`Error enabling graceful-fs: ${(0,m.$Oi)(o)}`)}})();class n extends f.$aq{static{this.I=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=R.Event.None,this.N=new j.$Ac(t=>d.$wg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:i,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(s));return{type:this.M(i,t),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:b.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await $.Promises.readdir(this.H(s),{withFileTypes:!0}),t=[];return await Promise.all(i.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,d.$Fg)(s,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(i){throw this.fb(i)}}M(s,i){let t;return i?.dangling?t=b.FileType.Unknown:s.isFile()?t=b.FileType.File:s.isDirectory()?t=b.FileType.Directory:t=b.FileType.Unknown,i&&(t|=b.FileType.SymbolicLink),t}async O(s){const i=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let t;for(;t=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await t.wait();const r=new A.$3g;return this.N.set(s,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(s)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),r.open()})}async readFile(s,i){let t;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),t=await this.O(s));const r=this.H(s);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(s){n.I&&this.a.trace(s)}readFileStream(s,i,t){const r=(0,c.$8d)(a=>O.$he.concat(a.map(v=>O.$he.wrap(v))).buffer);return(0,l.$3p)(this,s,r,a=>a.buffer,{...i,bufferSize:256*1024},t),r}async writeFile(s,i,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,d.$Fg)((0,d.$Eg)(s),`${(0,d.$Cg)(s)}${t.atomic.postfix}`),i,t):this.S(s,i,t)}async Q(s){try{const i=this.H(s),{symbolicLink:t}=await $.SymlinkSupport.stat(i);if(t)return!1}catch{}return!0}async R(s,i,t,r){const a=new g.$Sc;try{a.add(await this.O(s)),a.add(await this.O(i)),await this.S(i,t,r,!0);try{await this.rename(i,s,{overwrite:!0})}catch(v){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw v}}finally{a.dispose()}}async S(s,i,t,r){let a;try{const v=this.H(s);if(!t.create||!t.overwrite){if(await $.Promises.exists(v)){if(!t.overwrite)throw(0,b.$Bk)((0,y.localize)(0,null),b.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,b.$Bk)((0,y.localize)(1,null),b.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:t.unlock},r),await this.write(a,0,i,0,i.byteLength)}catch(v){throw await this.gb(s,v)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(s){n.Y=s}async open(s,i,t){const r=this.H(s);let a;(0,b.$pk)(i)&&!t&&(a=await this.O(s));let v;try{if((0,b.$pk)(i)&&i.unlock)try{const{stat:u}=await $.SymlinkSupport.stat(r);u.mode&128||await $.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let w;if((0,b.$pk)(i)){if(S.$i)try{await $.Promises.truncate(r,0),w="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}w||(w="w")}else w="r";v=await $.Promises.open(r,w)}catch(w){throw a?.dispose(),(0,b.$pk)(i)?await this.gb(s,w):this.fb(w)}if(this.U.set(v,0),(0,b.$pk)(i)&&this.X.set(v,s),a){const w=this.W.get(v);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${v} (${r})`),this.W.set(v,a),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${v} (${r})`),w.dispose())}return v}async close(s){const i=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&n.Y)try{await $.Promises.fdatasync(s)}catch(t){n.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(s)}catch(t){throw this.fb(t)}finally{i&&(this.W.get(s)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,t,r,a){const v=this.Z(s,i);let w=null;try{w=(await $.Promises.read(s,t,r,a,v)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(s,v,w)}return w}Z(s,i){return i===this.U.get(s)?null:i}$(s,i,t){const r=this.U.get(s);typeof r=="number"&&(typeof i=="number"||(typeof t=="number"?this.U.set(s,r+t):this.U.delete(s)))}async write(s,i,t,r,a){return(0,A.$lh)(()=>this.ab(s,i,t,r,a),100,3)}async ab(s,i,t,r,a){const v=this.Z(s,i);let w=null;try{w=(await $.Promises.write(s,t,r,a,v)).bytesWritten}catch(u){throw await this.gb(this.X.get(s),u)}finally{this.$(s,v,w)}return w}async mkdir(s){try{await $.Promises.mkdir(this.H(s))}catch(i){throw this.fb(i)}}async delete(s,i){try{const t=this.H(s);if(i.recursive){let r;i?.atomic!==!1&&i.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${i.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:v,symbolicLink:w}=await $.SymlinkSupport.stat(t);a=v.isDirectory()&&!w}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(s,i,t){const r=this.H(s),a=this.H(i);if(r!==a)try{await this.bb(s,i,"move",t.overwrite),await $.Promises.rename(r,a)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async copy(s,i,t){const r=this.H(s),a=this.H(i);if(r!==a)try{await this.bb(s,i,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,y.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),v.toString()))),this.fb(v)}}async bb(s,i,t,r){const a=this.H(s),v=this.H(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,k.$5f)(a,v,!0)),w){if(t==="copy")throw(0,b.$Bk)((0,y.localize)(4,null),b.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(s);if(!p)throw(0,b.$Bk)((0,y.localize)(5,null),b.FileSystemProviderErrorCode.FileNotFound);const I=await this.L(i);if(I){if(!r)throw(0,b.$Bk)((0,y.localize)(6,null),b.FileSystemProviderErrorCode.FileExists);p.type&b.FileType.File&&I.type&b.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.cb(s,i,!1)}async cb(s,i,t){const r=this.H(s),a=this.H(i),v=!!(this.capabilities&1024);if((0,k.$5f)(r,a,!v))return;const w=new g.$Sc;try{w.add(await this.O(s)),w.add(await this.O(i)),t&&await $.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(s,i,!0);throw this.fb(u)}finally{w.dispose()}}t(s,i,t){return new h.$hq(r=>s(r),r=>i(r),t)}F(s,i,t){return new E.$pq(r=>s(r),r=>i(r),t)}fb(s){if(s instanceof b.$Ak)return s;let i=s,t;switch(s.code){case"ENOENT":t=b.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=b.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=b.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=b.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=b.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=b.FileSystemProviderErrorCode.Unknown;break;default:t=b.FileSystemProviderErrorCode.Unknown}return(0,b.$Bk)(i,t)}async gb(s,i){let t=this.fb(i);if(s&&t.code===b.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(s));r.mode&128||(t=(0,b.$Bk)(i,b.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$qq=n}),define(le[101],he([0,1,3,2,4,8]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=e.$z_b=void 0,e.$z_b=(0,A.$4h)("sharedProcessLifecycleService");let O=class extends N.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new D.$Td),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$A_b=O,e.$A_b=O=ye([X(0,j.$lj)],O)}),define(le[201],he([0,1,10,3,8,2]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=e.$qr=e.$pr=void 0;class O extends A.$wj{constructor(S,d,c,$,y){super(d,c,$),this.r=S,this.t=y,this.B(y.listen("onDidChangeLogLevel",S)(b=>{(0,A.$nj)(b)?super.setLogLevel(b):super.setLogLevel(D.URI.revive(b[0]),b[1])})),this.B(y.listen("onDidChangeVisibility",S)(([b,l])=>super.setVisibility(D.URI.revive(b),l))),this.B(y.listen("onDidChangeLoggers",S)(({added:b,removed:l})=>{for(const f of b)super.registerLogger({...f,resource:D.URI.revive(f.resource)});for(const f of l)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new A.$uj({log:(S,d)=>{this.t.call("consoleLog",[S,d])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,d){super.setLogLevel(S,d),this.t.call("setLogLevel",[S,d])}setVisibility(S,d){super.setVisibility(S,d),this.t.call("setVisibility",[this.n(S),d])}s(S,d,c){return new R(this.t,S,d,c,this.r)}static setLogLevel(S,d,c){return S.call("setLogLevel",[d,c])}}e.$pr=O;class R extends A.$rj{constructor(S,d,c,$,y){super($?.logLevel==="always"),this.r=S,this.s=d,this.m=!1,this.n=[],this.setLevel(c),this.r.call("createLogger",[d,$,y]).then(()=>{this.u(this.n),this.m=!0})}g(S,d){const c=[[S,d]];this.m?this.u(c):this.n.push(...c)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,d){this.a=S,this.b=d}listen(S,d){const c=this.b(S);switch(d){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(y=>this.c(y,c)),removed:[...$.removed].map(y=>this.c(y,c))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,$=>[c.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,$=>(0,A.$nj)($)?$:[c.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${d}`)}async call(S,d,c){const $=this.b(S);switch(d){case"setLogLevel":return(0,A.$nj)(c[0])?this.a.setLogLevel(c[0]):this.a.setLogLevel(D.URI.revive($.transformIncoming(c[0][0])),c[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,$)))}throw new Error(`Call not found: ${d}`)}c(S,d){return{...S,resource:d.transformOutgoingURI(S.resource)}}}e.$qr=k;class g extends j.$Tc{constructor(S,d){super(),d.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(c=>d.call("setLogLevel",[c]))),d.call("getRegisteredLoggers").then(c=>{for(const $ of c)S.registerLogger({...$,resource:D.URI.revive($.resource)})}),this.B(d.listen("onDidChangeVisibility")(([c,$])=>S.setVisibility(D.URI.revive(c),$))),this.B(d.listen("onDidChangeLoggers")(({added:c,removed:$})=>{for(const y of c)S.registerLogger({...y,resource:D.URI.revive(y.resource)});for(const y of $)S.deregisterLogger(y.resource)}))}}e.$rr=g}),define(le[202],he([0,1,2,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kO=void 0;class A extends D.$Tc{constructor(O,R=[]){super(),this.a=new N.$vj([O,...R]),this.B(O.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...R){this.a.trace(O,...R)}debug(O,...R){this.a.debug(O,...R)}info(O,...R){this.a.info(O,...R)}warn(O,...R){this.a.warn(O,...R)}error(O,...R){this.a.error(O,...R)}flush(){this.a.flush()}}e.$kO=A}),define(le[57],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v0b=void 0,e.$v0b=(0,D.$4h)("nativeHostService")}),define(le[203],he([0,1,40,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=void 0;let A=class{constructor(O,R){return this.windowId=O,D.ProxyChannel.toService(R.getChannel("nativeHost"),{context:O,properties:(()=>{const k=new Map;return k.set("windowId",O),k})()})}};e.$P$b=A,e.$P$b=A=ye([X(1,N.$J$b)],A)}),define(le[58],he([0,1,3,61,2,4]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=void 0,e.$yn=(0,j.$4h)("policy");class O extends A.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$Td),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),N.Iterable.reduce(this.g.entries(),(S,[d,c])=>({...S,[d]:c}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$zn=O;class R{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$An=R}),define(le[204],he([0,1,3,2,58]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=e.$f$b=void 0;class j{constructor(k){this.b=k,this.a=new N.$Sc}listen(k,g){switch(g){case"onDidChange":return D.Event.map(this.b.onDidChange,C=>C.reduce((S,d)=>({...S,[d]:this.b.getPolicyValue(d)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$f$b=j;class O extends A.$zn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:d}=k[C];this.f[C]=S,d!==void 0&&this.g.set(C,d)}this.a.listen("onDidChange")(C=>{for(const S in C){const d=C[S];d===null?this.g.delete(S):this.g.set(S,d)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$g$b=O}),define(le[102],he([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.context<"u"){const j=A.context.configuration();if(j)N=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:j.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(le[25],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=void 0,e.$Dj=(0,D.$4h)("productService"),e.$Ej="vscode://schemas/vscode-product"}),define(le[205],he([0,1,6,7,2,16,31,8,25]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7$b=void 0;let g=class extends A.$Tc{constructor(S,d,c){super(),this.b=d,this.c=c,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new D.$dh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),c=(0,j.$mc)(S),$=(0,j.$nc)(S),y=await O.Promises.readdir(c);await Promise.all(y.map(async b=>{if(b===$)return;const l=(0,j.$jc)(c,b),f=await O.Promises.stat(l);if(f.isDirectory()&&d-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${b}.`),O.Promises.rm(l)}))}catch(d){(0,N.$1)(d)}}};e.$7$b=g,e.$7$b=g=ye([X(1,k.$Dj),X(2,R.$lj)],g)}),define(le[206],he([0,1,6,7,2,16,31,14,8,25]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=void 0;let C=class extends A.$Tc{constructor(d,c,$){super(),this.b=d,this.c=c,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$dh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),c=JSON.parse(await O.Promises.readFile((0,j.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(c)){const m=c[f];d[`${m.hash}.${f}`]=!0}const $=(0,j.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists($))return;const b=await O.Promises.readdir($);for(const f of b){if(d[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await O.Promises.rm((0,j.$jc)($,f))}const l=Date.now();for(const f of Object.keys(d)){const m=(0,j.$jc)($,f),h=await O.Promises.readdir(m);for(const E of h){if(E==="tcf.json")continue;const n=(0,j.$jc)(m,E),o=await O.Promises.stat(n);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$jc)(f,E)}`),await O.Promises.rm(n))}}}catch(d){(0,N.$1)(d)}}};e.$8$b=C,e.$8$b=C=ye([X(0,R.$_h),X(1,k.$lj),X(2,g.$Dj)],C)}),define(le[207],he([0,1,16,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$_E=void 0,e.$_E=(0,N.$4h)("IV8InspectProfilingService");var A;(function(j){function O(k){return!!(k.samples&&k.timeDeltas)}j.isValidProfile=O;function R(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,D.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,D.$jc)(g,(0,D.$nc)(C.callFrame.url)));return k}j.rewriteAbsolutePaths=R})(A||(e.Utils=A={}))}),define(le[208],he([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;class N{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((g,C)=>{ne(["v8-inspect-profiler"],g,C)})).startProfiling({port:j.port,checkForPaused:!0}),k=(0,D.$og)();return this.a.set(k,R),k}async stopProfiling(j){const O=this.a.get(j);if(!O)throw new Error(`UNKNOWN session '${j}'`);const R=await O.stop();return this.a.delete(j),R.profile}}e.$p_b=N}),define(le[41],he([0,1,126,12]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0;class A{constructor(){this.a=new Map}add(O,R){D.ok(N.$Gf(O)),D.ok(N.$If(R)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,R)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$wn=new A}),define(le[103],he([0,1,3,41]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0,e.$xn={JSONContribution:"base.contributions.json"};function A(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new D.$Td,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[A(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const O=new j;N.$wn.add(e.$xn.JSONContribution,O)}),define(le[50],he([0,1,18,3,12,148,20,103,41]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.ConfigurationScope=e.$Bn=e.EditPresentationTypes=void 0;var g;(function(E){E.Multiline="multilineText",E.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Bn={Configuration:"base.contributions.configuration"};var C;(function(E){E[E.APPLICATION=1]="APPLICATION",E[E.MACHINE=2]="MACHINE",E[E.WINDOW=3]="WINDOW",E[E.RESOURCE=4]="RESOURCE",E[E.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",E[E.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$Cn={properties:{},patternProperties:{}},e.$Dn={properties:{},patternProperties:{}},e.$En={properties:{},patternProperties:{}},e.$Fn={properties:{},patternProperties:{}},e.$Gn={properties:{},patternProperties:{}},e.$Hn={properties:{},patternProperties:{}},e.$In="vscode://schemas/settings/resourceLanguage",e.$Jn="vscode://schemas/settings/configurationDefaults";const S=k.$wn.as(R.$xn.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$Td,this.onDidSchemaChange=this.i.event,this.j=new N.$Td,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$In,this.g),this.v()}registerConfiguration(n,o=!0){this.registerConfigurations([n],o)}registerConfigurations(n,o=!0){const s=new Set;this.n(n,o,s),S.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(n){const o=new Set;this.o(n,o),S.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:n,remove:o}){const s=new Set;this.o(o,s),this.n(n,!1,s),S.registerSchema(e.$In,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(n){const o=new Set;this.k(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(n,o){const s=[];for(const{overrides:i,source:t}of n)for(const r in i)if(o.add(r),e.$Ln.test(r)){const a=this.a.get(r),v=a?.valuesSources??new Map;if(t)for(const I of Object.keys(i[r]))v.set(I,t);const w={...a?.value||{},...i[r]};this.a.set(r,{source:t,value:w,valuesSources:v});const u=(0,O.$Hi)(r),p={type:"object",default:w,description:j.localize(1,null,u),$ref:e.$In,defaultDefaultValue:w,source:A.$Gf(t)?void 0:t,defaultValueSource:t};s.push(...y(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:i[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(s)}deregisterDefaultConfigurations(n){const o=new Set;this.l(n,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(n,o){for(const{overrides:s,source:i}of n)for(const t in s){const r=this.a.get(t),a=A.$Gf(i)?i:i?.id,v=A.$Gf(r?.source)?r?.source:r?.source?.id;if(a===v)if(o.add(t),this.a.delete(t),e.$Ln.test(t))delete this.d[t],delete this.b.properties[t];else{const w=this.d[t];w&&(this.w(t,w),this.r(t,w))}}this.u()}deltaConfiguration(n){let o=!1;const s=new Set;n.removedDefaults&&(this.l(n.removedDefaults,s),o=!0),n.addedDefaults&&(this.k(n.addedDefaults,s),o=!0),n.removedConfigurations&&this.o(n.removedConfigurations,s),n.addedConfigurations&&this.n(n.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const o of n)this.h.add(o);this.u()}n(n,o,s){n.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(n,o){const s=i=>{if(i.properties)for(const t in i.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,i.properties[t])}i.allOf?.forEach(t=>s(t))};for(const i of n){s(i);const t=this.c.indexOf(i);t!==-1&&this.c.splice(t,1)}}p(n,o=!0,s,i,t=3,r){t=A.$Pf(n.scope)?t:n.scope;const a=n.properties;if(a)for(const w in a){const u=a[w];if(o&&m(w,u)){delete a[w];continue}if(u.source=s,u.defaultDefaultValue=a[w].default,this.w(w,u),e.$Ln.test(w)?u.scope=void 0:(u.scope=A.$Pf(u.scope)?t:u.scope,u.restricted=A.$Pf(u.restricted)?!!i?.includes(w):u.restricted),a[w].hasOwnProperty("included")&&!a[w].included){this.f[w]=a[w],delete a[w];continue}else this.d[w]=a[w],a[w].policy?.name&&this.e.set(a[w].policy.name,w);!a[w].deprecationMessage&&a[w].markdownDeprecationMessage&&(a[w].deprecationMessage=a[w].markdownDeprecationMessage),r.add(w)}const v=n.allOf;if(v)for(const w of v)this.p(w,o,s,i,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const o=s=>{const i=s.properties;if(i)for(const r in i)this.r(r,i[r]);s.allOf?.forEach(o)};o(n)}r(n,o){switch(e.$Cn.properties[n]=o,o.scope){case 1:e.$Dn.properties[n]=o;break;case 2:e.$En.properties[n]=o;break;case 6:e.$Fn.properties[n]=o;break;case 3:e.$Gn.properties[n]=o;break;case 4:e.$Hn.properties[n]=o;break;case 5:e.$Hn.properties[n]=o,this.g.properties[n]=o;break}}s(n,o){switch(delete e.$Cn.properties[n],o.scope){case 1:delete e.$Dn.properties[n];break;case 2:delete e.$En.properties[n];break;case 6:delete e.$Fn.properties[n];break;case 3:delete e.$Gn.properties[n];break;case 4:case 5:delete e.$Hn.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const o=`[${n}]`,s={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$In};this.w(o,s),e.$Cn.properties[o]=s,e.$Dn.properties[o]=s,e.$En.properties[o]=s,e.$Fn.properties[o]=s,e.$Gn.properties[o]=s,e.$Hn.properties[o]=s}}v(){const n={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$In};e.$Cn.patternProperties[e.$Kn]=n,e.$Dn.patternProperties[e.$Kn]=n,e.$En.patternProperties[e.$Kn]=n,e.$Fn.patternProperties[e.$Kn]=n,e.$Gn.patternProperties[e.$Kn]=n,e.$Hn.patternProperties[e.$Kn]=n,this.i.fire()}w(n,o){const s=this.a.get(n);let i=s?.value,t=s?.source;A.$Nf(i)&&(i=o.defaultDefaultValue,t=void 0),A.$Nf(i)&&(i=l(o.type)),o.default=i,o.defaultValueSource=t}}const c="\\[([^\\]]+)\\]",$=new RegExp(c,"g");e.$Kn=`^(${c})+$`,e.$Ln=new RegExp(e.$Kn);function y(E){const n=[];if(e.$Ln.test(E)){let o=$.exec(E);for(;o?.length;){const s=o[1].trim();s&&n.push(s),o=$.exec(E)}}return(0,D.$Mb)(n)}e.$Mn=y;function b(E){return E.reduce((n,o)=>`${n}[${o}]`,"")}e.$Nn=b;function l(E){switch(Array.isArray(E)?E[0]:E){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$On=l;const f=new d;k.$wn.add(e.$Bn.Configuration,f);function m(E,n){return E.trim()?e.$Ln.test(E)?j.localize(7,null,E):f.getConfigurationProperties()[E]!==void 0?j.localize(8,null,E):n.policy?.name&&f.getPolicyConfigurations().get(n.policy?.name)!==void 0?j.localize(9,null,E,n.policy?.name,f.getPolicyConfigurations().get(n.policy?.name)):null:j.localize(6,null)}e.$Pn=m;function h(){const E=[],n=f.getConfigurationProperties();for(const o of Object.keys(n))E.push([o,n[o].scope]);return E.push(["launch",4]),E.push(["task",4]),E}e.$Qn=h}),define(le[75],he([0,1,18,3,35,2,34,30,12,10,20,50,41]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=void 0;function c(o){return Object.isFrozen(o)?o:R.$ln(o)}class ${constructor(s={},i=[],t=[],r){this.b=s,this.c=i,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof $)return i;const t=new y("");return t.parseRaw(i),t.configurationModel});this.f=s.reduce((i,t)=>t===i?t:i.merge(t),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,C.$Fi)(this.contents,s):this.contents}inspect(s,i){const t=this.rawConfiguration.getValue(s),r=i?this.rawConfiguration.getOverrideValue(s,i):void 0,a=i?this.rawConfiguration.override(i).getValue(s):t;return{value:t,override:r,merged:a}}getOverrideValue(s,i){const t=this.i(i);return t?s?(0,C.$Fi)(t,s):t:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const t of this.overrides)t.identifiers.includes(s)&&i.push(...t.keys);return D.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return D.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.g(s),this.a.set(s,i)),i}merge(...s){const i=R.$kn(this.contents),t=R.$kn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const v of s)if(a.push(...v.raw?.length?v.raw:[v]),!v.isEmpty()){this.h(i,v.contents);for(const w of v.overrides){const[u]=t.filter(p=>D.$ub(p.identifiers,w.identifiers));u?(this.h(u.contents,w.contents),u.keys.push(...w.keys),u.keys=D.$Mb(u.keys)):t.push(R.$kn(w))}for(const w of v.keys)r.indexOf(w)===-1&&r.push(w)}return new $(i,r,t,a.every(v=>v instanceof $)?void 0:a)}g(s){const i=this.i(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const t={};for(const r of D.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let a=this.contents[r];const v=i[r];v&&(typeof a=="object"&&typeof v=="object"?(a=R.$kn(a),this.h(a,v)):a=v),t[r]=a}return new $(t,this.keys,this.overrides)}h(s,i){for(const t of Object.keys(i)){if(t in s&&k.$If(s[t])&&k.$If(i[t])){this.h(s[t],i[t]);continue}s[t]=R.$kn(i[t])}}i(s){let i=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=R.$kn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===s?i=a.contents:a.identifiers.includes(s)&&r(a.contents);return r(i),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.j(s,i,!0)}setValue(s,i){this.j(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,C.$Ei)(this.contents,s),S.$Ln.test(s)&&this.overrides.splice(this.overrides.findIndex(t=>D.$ub(t.identifiers,(0,S.$Mn)(s))),1))}j(s,i,t){(0,C.$Di)(this.contents,s,i,r=>console.error(r)),t=t||this.keys.indexOf(s)===-1,t&&this.keys.push(s),S.$Ln.test(s)&&this.overrides.push({identifiers:(0,S.$Mn)(s),keys:Object.keys(this.contents[s]),contents:(0,C.$Ci)(this.contents[s],r=>console.error(r))})}}e.$Rn=$;class y{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!k.$Pf(s)){const t=this.g(s);this.parseRaw(t,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:t,keys:r,overrides:a,restricted:v,hasExcludedProperties:w}=this.h(s,i);this.b=new $(t,r,a,w?[s]:void 0),this.c=v||[]}g(s){let i={},t=null,r=[];const a=[],v=[];function w(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};w(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];w(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(p,I,T)=>{v.push({error:p,offset:I,length:T})}};if(s)try{A.$hn(s,u),i=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return i}h(s,i){const t=d.$wn.as(S.$Bn.Configuration).getConfigurationProperties(),r=this.i(s,t,!0,i);s=r.raw;const a=(0,C.$Ci)(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),v=Object.keys(s),w=this.j(s,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:v,overrides:w,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(s,i,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:a};const v={},w=[];for(const u in s)if(S.$Ln.test(u)&&t){const p=this.i(s[u],i,!1,r);v[u]=p.raw,a=a||p.hasExcludedProperties,w.push(...p.restricted)}else{const p=i[u],I=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&w.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(I===void 0||r.scopes===void 0||r.scopes.includes(I))&&!(r.skipRestricted&&p?.restricted))?v[u]=s[u]:a=!0}return{raw:v,restricted:w,hasExcludedProperties:a}}j(s,i){const t=[];for(const r of Object.keys(s))if(S.$Ln.test(r)){const a={};for(const v in s[r])a[v]=s[r][v];t.push({identifiers:(0,S.$Mn)(r),keys:Object.keys(a),contents:(0,C.$Ci)(a,i)})}return t}}e.$Sn=y;class b extends j.$Tc{constructor(s,i,t,r){super(),this.c=s,this.f=i,this.g=r,this.b=this.B(new N.$Td),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Tn=b;class l{constructor(s,i,t,r,a,v,w,u,p,I,T,F,M){this.a=s,this.b=i,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=v,this.g=w,this.h=u,this.i=p,this.j=I,this.k=T,this.l=F,this.m=M}get value(){return c(this.c)}n(s,i,t){const r=s.inspect(i,t);return{get value(){return c(r.value)},get override(){return c(r.override)},get merged(){return c(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(s,i,t,r,a=new $,v=new $,w=new O.$Ac,u=new $,p=new O.$Ac){this.c=s,this.d=i,this.f=t,this.g=r,this.h=a,this.i=v,this.j=w,this.l=u,this.m=p,this.a=null,this.b=new O.$Ac,this.n=null}getValue(s,i,t){return this.p(s,i,t).getValue(s)}updateValue(s,i,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,i===void 0?r.removeValue(s):r.setValue(s,i),t.resource||(this.a=null)}inspect(s,i,t){const r=this.p(s,i,t),a=this.t(i.resource,t),v=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(s,p)!==void 0&&w.add(p);return new l(s,i,r.getValue(s),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,v)}keys(s){const i=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,i){this.j.set(s,i),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const t=[];if(!i){const{added:r,updated:a,removed:v}=E(this.c,s);i=[...r,...a,...v]}for(const r of i)for(const a of(0,S.$Mn)(r)){const v=this.c.getKeysForOverrideIdentifier(a),w=s.getKeysForOverrideIdentifier(a),u=[...w.filter(p=>v.indexOf(p)===-1),...v.filter(p=>w.indexOf(p)===-1),...v.filter(p=>!R.$on(this.c.override(a).getValue(p),s.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(s),{keys:i,overrides:t}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:t,removed:r}=E(this.d,s),a=[...i,...t,...r];return a.length&&this.updatePolicyConfiguration(s),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:t,removed:r,overrides:a}=E(this.applicationConfiguration,s),v=[...i,...t,...r];return v.length&&this.updateApplicationConfiguration(s),{keys:v,overrides:a}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:t,removed:r,overrides:a}=E(this.localUserConfiguration,s),v=[...i,...t,...r];return v.length&&this.updateLocalUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:t,removed:r,overrides:a}=E(this.remoteUserConfiguration,s),v=[...i,...t,...r];return v.length&&this.updateRemoteUserConfiguration(s),{keys:v,overrides:a}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:t,removed:r,overrides:a}=E(this.workspaceConfiguration,s),v=[...i,...t,...r];return v.length&&this.updateWorkspaceConfiguration(s),{keys:v,overrides:a}}compareAndUpdateFolderConfiguration(s,i){const t=this.folderConfigurations.get(s),{added:r,updated:a,removed:v,overrides:w}=E(t,i),u=[...r,...a,...v];return(u.length||!t)&&this.updateFolderConfiguration(s,i),{keys:u,overrides:w}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:t,updated:r,removed:a,overrides:v}=E(i,void 0);return{keys:[...t,...r,...a],overrides:v}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,i,t){let r=this.q(i,t);return i.overrideIdentifier&&(r=r.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(r=r.merge(this.d)),r}q({resource:s},i){let t=this.r();if(i&&s){const r=i.getFolder(s);r&&(t=this.s(r.uri)||t);const a=this.m.get(s);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let i=this.b.get(s);if(!i){const t=this.r(),r=this.j.get(s);r?(i=t.merge(r),this.b.set(s,i)):i=t}return i}t(s,i){if(i&&s){const t=i.getFolder(s);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,i)=>{const{contents:t,overrides:r,keys:a}=this.j.get(i);return s.push([i,{contents:t,overrides:r,keys:a}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.i.keys.forEach(i=>s.add(i)),this.j.forEach(i=>i.keys.forEach(t=>s.add(t))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(t=>s.add(t))),[...s.values()]}v(s){const i=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(t=>i.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(t=>i.add(t)),this.i.getKeysForOverrideIdentifier(s).forEach(t=>i.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(s).forEach(r=>i.add(r))),[...i.values()]}static parse(s){const i=this.w(s.defaults),t=this.w(s.policy),r=this.w(s.application),a=this.w(s.user),v=this.w(s.workspace),w=s.folders.reduce((u,p)=>(u.set(g.URI.revive(p[0]),this.w(p[1])),u),new O.$Ac);return new f(i,t,r,a,new $,v,w,new $,new O.$Ac)}static w(s){return new $(s.contents,s.keys,s.overrides)}}e.$Un=f;function m(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const s=new Set,i=new Map;for(const r of o)r.keys.forEach(a=>s.add(a)),r.overrides.forEach(([a,v])=>{const w=(0,O.$xc)(i,a,new Set);v.forEach(u=>w.add(u))});const t=[];return i.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...s.values()],overrides:t}}e.$Vn=m;class h{constructor(s,i,t,r){this.change=s,this.f=i,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of s.keys)this.affectedKeys.add(a);for(const[,a]of s.overrides)for(const v of a)this.affectedKeys.add(v);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(s,i){const t=this.a+s,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const v=this.d.charCodeAt(a);if(v!==this.b&&v!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,u=this.g.getValue(s,i,this.h);return!R.$on(w,u)}return!0}}e.$Wn=h;function E(o,s){const{added:i,removed:t,updated:r}=n(s?.rawConfiguration,o?.rawConfiguration),a=[],v=o?.getAllOverrideIdentifiers()||[],w=s?.getAllOverrideIdentifiers()||[];if(s){const u=w.filter(p=>!v.includes(p));for(const p of u)a.push([p,s.getKeysForOverrideIdentifier(p)])}if(o){const u=v.filter(p=>!w.includes(p));for(const p of u)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(s&&o){for(const u of v)if(w.includes(u)){const p=n({contents:o.getOverrideValue(void 0,u)||{},keys:o.getKeysForOverrideIdentifier(u)},{contents:s.getOverrideValue(void 0,u)||{},keys:s.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:i,removed:t,updated:r,overrides:a}}function n(o,s){const i=o?s?o.keys.filter(a=>s.keys.indexOf(a)===-1):[...o.keys]:[],t=s?o?s.keys.filter(a=>o.keys.indexOf(a)===-1):[...s.keys]:[],r=[];if(o&&s){for(const a of s.keys)if(o.keys.indexOf(a)!==-1){const v=(0,C.$Fi)(s.contents,a),w=(0,C.$Fi)(o.contents,a);R.$on(v,w)||r.push(a)}}return{added:i,removed:t,updated:r}}}),define(le[209],he([0,1,18,3,2,30,12,75,50,8,58,41]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=e.$Yn=e.$Xn=void 0;class d extends A.$Tc{constructor(){super(...arguments),this.a=this.B(new N.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Rn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$wn.as(k.$Bn.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:l})=>this.c(Array.from(b),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(b,l){this.h(b,S.$wn.as(k.$Bn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}f(){return{}}g(){this.b=new R.$Rn;const b=S.$wn.as(k.$Bn.Configuration).getConfigurationProperties();this.h(Object.keys(b),b)}h(b,l){const f=this.f();for(const m of b){const h=f[m],E=l[m];h!==void 0?this.b.addValue(m,h):E?this.b.addValue(m,E.default):this.b.removeValue(m)}}}e.$Xn=d;class c{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new R.$Rn}async initialize(){return this.configurationModel}}e.$Yn=c;let $=class extends A.$Tc{get configurationModel(){return this.b}constructor(b,l,f){super(),this.c=b,this.f=l,this.g=f,this.a=this.B(new N.$Td),this.onDidChangeConfiguration=this.a.event,this.b=new R.$Rn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const l={},f=[],m=S.$wn.as(k.$Bn.Configuration).getConfigurationProperties();for(const h of b){const E=m[h];if(!E){f.push(h);continue}if(E.policy){if(E.type!=="string"&&E.type!=="number"){this.g.warn(`Policy ${E.policy.name} has unsupported type ${E.type}`);continue}f.push(h),l[E.policy.name]={type:E.type}}}return(0,O.$Tf)(l)||await this.f.updatePolicyDefinitions(l),f}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const l=S.$wn.as(k.$Bn.Configuration).getPolicyConfigurations(),f=(0,D.$Hb)(b.map(m=>l.get(m)));this.m(f,!0)}m(b,l){this.g.trace("PolicyConfiguration#update",b);const f=S.$wn.as(k.$Bn.Configuration).getConfigurationProperties(),m=[],h=this.b.isEmpty();for(const E of b){const n=f[E]?.policy?.name;if(n){const o=this.f.getPolicyValue(n);(h?o!==void 0:!(0,j.$on)(this.b.getValue(E),o))&&m.push([E,o])}else this.b.getValue(E)!==void 0&&m.push([E,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const E=this.b;this.b=new R.$Rn;for(const n of E.keys)this.b.setValue(n,E.getValue(n));for(const[n,o]of m)o===void 0?this.b.removeValue(n):this.b.setValue(n,o);l&&this.a.fire(this.b)}}};e.$Zn=$,e.$Zn=$=ye([X(1,C.$yn),X(2,g.$lj)],$)}),define(le[210],he([0,1,6,3,2,19,20,75,209,58]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=void 0;class C extends A.$Tc{constructor(d,c,$,y){super(),this.j=d,this.h=this.B(new N.$Td),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new k.$Xn),this.c=$ instanceof g.$An?new k.$Yn:this.B(new k.$Zn(this.b,$,y)),this.f=this.B(new R.$Tn(this.j,{},j.$wg,c)),this.a=new R.$Un(this.b.configurationModel,this.c.configurationModel,new R.$Rn,new R.$Rn),this.g=this.B(new D.$dh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:b,properties:l})=>this.n(b,l))),this.B(this.c.onDidChangeConfiguration(b=>this.r(b))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[d,c,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$Un(d,c,new R.$Rn,$)}getConfigurationData(){return this.a.toData()}getValue(d,c){const $=typeof d=="string"?d:void 0,y=(0,O.$yi)(d)?d:(0,O.$yi)(c)?c:{};return this.a.getValue($,y,void 0)}updateValue(d,c,$,y){return Promise.reject(new Error("not supported"))}inspect(d){return this.a.inspect(d,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const d=await this.f.loadConfiguration();this.m(d)}m(d){const c=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(d);this.s($,c,2)}n(d,c){const $=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(d,c);this.s(y,$,7)}r(d){const c=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(d);this.s($,c,7)}s(d,c,$){const y=new R.$Wn(d,{data:c},this.a);y.source=$,y.sourceConfig=this.t($),this.h.fire(y)}t(d){switch(d){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$1n=C}),define(le[211],he([0,1,15,3,2,67]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lrb=e.$krb=e.$jrb=e.$irb=void 0;const O=(g,C,S)=>{const d=new Uint8Array(16);for(let y=0;y<16;y++)d[y]=Math.round(Math.random()*256);const c=(0,D.$Be)(D.$he.wrap(d));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${c}`].join(`\r
`)+`\r
\r
`};e.$irb=O,e.$jrb=D.$he.fromString(`\r
\r
`);async function R(g,C,S,d,c){g.write(D.$he.fromString((0,e.$irb)(C,S,d)));const $=new A.$Sc;try{return await new Promise((y,b)=>{let l;$.add(g.onData(f=>{l?l=D.$he.concat([l,f],l.byteLength+f.byteLength):l=f;const m=l.indexOf(e.$jrb);if(m===-1)return;y(g),g.pauseData();const h=l.slice(m+e.$jrb.byteLength);h.byteLength&&c.onData.fire(h)})),$.add(g.onClose(f=>b(f??new Error("socket closed")))),$.add(g.onEnd(()=>b(new Error("socket ended"))))})}catch(y){throw g.dispose(),y}finally{$.dispose()}}e.$krb=R;class k extends A.$Tc{constructor(C,S){super(),this.g=C,this.a=this.B(new N.$Wd),this.onData=(...d)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...d)),this.b=this.B(new N.$Td),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(d=>this.a.fire(d))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){j.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$lrb=k}),define(le[212],he([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0k=e.$9k=e.RemoteAuthorityResolverErrorCode=e.$8k=e.$7k=e.RemoteConnectionType=e.$6k=void 0,e.$6k=(0,N.$4h)("remoteAuthorityResolverService");var A;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(A||(e.RemoteConnectionType=A={}));class j{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$7k=j;class O{constructor(S,d){this.host=S,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$8k=O;var R;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class k extends D.$bb{static isNotAvailable(S){return S instanceof k&&S._code===R.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===R.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===R.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===R.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,d=R.Unknown,c){super(S),this._message=S,this._code=d,this._detail=c,this.isHandled=d===R.NotAvailable&&c===!0,Object.setPrototypeOf(this,k.prototype)}}e.$9k=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$0k=g}),define(le[76],he([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=e.$al=e.$_k=e.$$k=void 0;function N(g){return g.scheme===D.Schemas.vscodeRemote?g.authority:void 0}e.$$k=N;function A(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$_k=A;function j(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$al=j;function O(g){const{host:C,port:S}=k(g);if(typeof S>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:C,port:S}}e.$bl=O;function R(g,C){let{host:S,port:d}=k(g);return typeof d>"u"&&(d=C),{host:S,port:d}}e.$cl=R;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const d=g.match(/(.*):(\d+)$/);return d?{host:d[1],port:parseInt(d[2],10)}:{host:g,port:void 0}}}),define(le[44],he([0,1,27,4,76]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.$km=e.$jm=e.TargetPlatform=e.ExtensionType=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=void 0,e.$dm="extensions.user.cache",e.$em="extensions.builtin.cache",e.$fm="undefined_publisher",e.$gm=["ui","workspace","web"];function j(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$hm=j,e.$im=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(O||(e.ExtensionType=O={}));var R;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class k{constructor(b){this.value=b,this._lower=b.toLowerCase()}static equals(b,l){if(typeof b>"u"||b===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof b=="string"||typeof l=="string"){const f=typeof b=="string"?b:b.value,m=typeof l=="string"?l:l.value;return D.$0e(f,m)}return b._lower===l._lower}static toKey(b){return typeof b=="string"?b.toLowerCase():b._lower}}e.$jm=k;class g{get size(){return this.c.size}constructor(b){if(this.c=new Set,b)for(const l of b)this.add(l)}add(b){this.c.add(k.toKey(b))}delete(b){return this.c.delete(k.toKey(b))}has(b){return this.c.has(k.toKey(b))}}e.$km=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(b){this.c.delete(k.toKey(b))}get(b){return this.c.get(k.toKey(b))}has(b){return this.c.has(k.toKey(b))}set(b,l){this.c.set(k.toKey(b),l)}values(){return this.c.values()}forEach(b){this.c.forEach(b)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$lm=C;function S(y){return d(y)}e.$mm=S;function d(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$nm=d;function c(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$om=c;function $(y,b){if(b){const l=`onResolveRemoteAuthority:${(0,A.$_k)(b)}`;return!!y.activationEvents?.includes(l)}return!1}e.$pm=$,e.$qm=(0,N.$4h)("IBuiltinExtensionsScannerService")}),define(le[213],he([0,1,2,44,11]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;class j extends D.$Tc{constructor(R,k,g,C,S){super(),this.a=R,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(d=>this.g(d))),this.B(C.onDidUninstallExtension(d=>this.h(d)))}g(R){for(const k of R)k.local&&this.invalidate(k.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,R)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,N.$dm))}catch(k){(0,A.$Fk)(k)!==1&&this.f.error(k)}}}e.$Wp=j}),define(le[214],he([0,1,6,15,26,7,3,2,100,62,32,67,212,76]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.$ll=e.$kl=e.PersistentConnectionEventType=e.$jl=e.$il=e.$hl=e.ConnectionType=void 0;const $=30*1e3;var y;(function(U){U[U.Management=1]="Management",U[U.ExtensionHost=2]="ExtensionHost",U[U.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function b(U){switch(U){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(U){const P=new A.$4d;return setTimeout(()=>P.cancel(),U),P.token}function f(U,P){if(U.isCancellationRequested||P.isCancellationRequested)return A.CancellationToken.Cancelled;const L=new A.$4d;return U.onCancellationRequested(()=>L.cancel()),P.onCancellationRequested(()=>L.cancel()),L.token}class m{get didTimeout(){return this.c==="timedout"}constructor(P){this.c="pending",this.d=new R.$Sc,this.promise=new Promise((L,H)=>{this.f=L,this.g=H}),P.isCancellationRequested?this.h():this.d.add(P.onCancellationRequested(()=>this.h()))}registerDisposable(P){this.c==="pending"?this.d.add(P):P.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const P=new Error("Time limit reached");return P.code="ETIMEDOUT",P.syscall="connect",P}resolve(P){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(P))}reject(P){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(P))}}function h(U,P){const L=new m(P);return L.registerDisposable(U.onControlMessage(H=>{const q=JSON.parse(H.toString()),ee=B(q);ee?L.reject(ee):L.resolve(q)})),L.promise}function E(U,P,L,H,q,ee,W,Y){const ie=new m(Y),ce=g.$Pd.create(!1);return U.info(`Creating a socket (${W})...`),k.mark(`code/willCreateSocket/${ee}`),P.connect(L,H,q,W).then(ae=>{ie.didTimeout?(k.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${W}) finished after ${ce.elapsed()} ms, but this is too late and has timed out already.`),ae?.dispose()):(k.mark(`code/didCreateSocketOK/${ee}`),U.info(`Creating a socket (${W}) was successful after ${ce.elapsed()} ms.`),ie.resolve(ae))},ae=>{k.mark(`code/didCreateSocketError/${ee}`),U.info(`Creating a socket (${W}) returned an error after ${ce.elapsed()} ms.`),U.error(ae),ie.reject(ae)}),ie.promise}function n(U,P){const L=new m(P);return U.then(H=>{L.didTimeout||L.resolve(H)},H=>{L.didTimeout||L.reject(H)}),L.promise}async function o(U,P,L,H){const q=oe(U,P);U.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await E(U.logService,U.remoteSocketFactoryService,U.connectTo,(0,c.$al)(U),`reconnectionToken=${U.reconnectionToken}&reconnection=${U.reconnectionProtocol?"true":"false"}`,b(P),`renderer-${b(P)}-${U.reconnectionToken}`,H)}catch(ae){throw U.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),U.logService.error(ae),ae}U.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let W,Y;U.reconnectionProtocol?(U.reconnectionProtocol.beginAcceptReconnection(ee,null),W=U.reconnectionProtocol,Y=!1):(W=new S.$Rh({socket:ee}),Y=!0),U.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const ie=await n(U.signService.createNewMessage((0,C.$og)()),H),ce={type:"auth",auth:U.connectionToken||"00000000000000000000",data:ie.data};W.sendControl(N.$he.fromString(JSON.stringify(ce)));try{const ae=await h(W,f(H,l(1e4)));if(ae.type!=="sign"||typeof ae.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(U.logService.trace(`${q} 4/6. received SignRequest control message.`),!await n(U.signService.validate(ie,ae.signedData),H)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const de=await n(U.signService.sign(ae.data),H),we={type:"connectionType",commit:U.commit,signedData:de,desiredConnectionType:P};return L&&(we.args=L),U.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),W.sendControl(N.$he.fromString(JSON.stringify(we))),{protocol:W,ownsProtocol:Y}}catch(ae){throw ae&&ae.code==="ETIMEDOUT"&&(U.logService.error(`${q} the handshake timed out. Error:`),U.logService.error(ae)),ae&&ae.code==="VSCODE_CONNECTION_ERROR"&&(U.logService.error(`${q} received error control message when negotiating connection. Error:`),U.logService.error(ae)),Y&&V(W),ae}}async function s(U,P,L,H){const q=Date.now(),ee=oe(U,P),{protocol:W,ownsProtocol:Y}=await o(U,P,L,H),ie=new m(H);return ie.registerDisposable(W.onControlMessage(ce=>{const ae=JSON.parse(ce.toString()),fe=B(ae);fe?(U.logService.error(`${ee} received error control message when negotiating connection. Error:`),U.logService.error(fe),Y&&V(W),ie.reject(fe)):(U.reconnectionProtocol?.endAcceptReconnection(),U.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${K(q)}!`),ie.resolve({protocol:W,firstMessage:ae}))})),ie.promise}async function i(U,P){const{protocol:L}=await s(U,1,void 0,P);return{protocol:L}}async function t(U,P,L){const{protocol:H,firstMessage:q}=await s(U,2,P,L),ee=q&&q.debugPort;return{protocol:H,debugPort:ee}}async function r(U,P,L){const H=Date.now(),q=oe(U,3),{protocol:ee}=await o(U,3,P,L);return U.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${K(H)}!`),ee}async function a(U,P,L){const{connectTo:H,connectionToken:q}=await U.addressProvider.getAddress();return{commit:U.commit,quality:U.quality,connectTo:H,connectionToken:q,reconnectionToken:P,reconnectionProtocol:L,remoteSocketFactoryService:U.remoteSocketFactoryService,signService:U.signService,logService:U.logService}}async function v(U,P,L){return u(U,async H=>{const{protocol:q}=await i(H,A.CancellationToken.None);return new G(U,P,L,H.reconnectionToken,q)})}e.$hl=v;async function w(U,P){return u(U,async L=>{const{protocol:H,debugPort:q}=await t(L,P,A.CancellationToken.None);return new Q(U,P,L.reconnectionToken,H,q)})}e.$il=w;async function u(U,P){for(let H=1;;H++)try{const q=(0,C.$og)(),ee=await a(U,q,null);return await P(ee)}catch(q){if(H<5)U.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),U.logService.error(q);else throw U.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),U.logService.error(q),x.triggerPermanentFailure(0,0,d.$9k.isHandled(q)),q}}async function p(U,P,L){const H=await a(U,(0,C.$og)(),null);return await r(H,{host:P,port:L},A.CancellationToken.None)}e.$jl=p;function I(U){return(0,D.$Rg)(P=>new Promise((L,H)=>{const q=setTimeout(L,U*1e3);P.onCancellationRequested(()=>{clearTimeout(q),L()})}))}var T;(function(U){U[U.ConnectionLost=0]="ConnectionLost",U[U.ReconnectionWait=1]="ReconnectionWait",U[U.ReconnectionRunning=2]="ReconnectionRunning",U[U.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",U[U.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class F{constructor(P,L){this.reconnectionToken=P,this.millisSinceLastIncomingData=L,this.type=0}}e.$kl=F;class M{constructor(P,L,H,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=L,this.durationSeconds=H,this.c=q,this.type=1}skipWait(){this.c.cancel()}}e.$ll=M;class z{constructor(P,L,H){this.reconnectionToken=P,this.millisSinceLastIncomingData=L,this.attempt=H,this.type=2}}e.$ml=z;class Z{constructor(P,L,H){this.reconnectionToken=P,this.millisSinceLastIncomingData=L,this.attempt=H,this.type=4}}e.$nl=Z;class J{constructor(P,L,H,q){this.reconnectionToken=P,this.millisSinceLastIncomingData=L,this.attempt=H,this.handled=q,this.type=3}}e.$ol=J;class x extends R.$Tc{static triggerPermanentFailure(P,L,H){this._permanentFailure=!0,this.f=P,this.g=L,this.h=H,this.j.forEach(q=>q.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(P=>P.y())}static debugPauseSocketWriting(){this.j.forEach(P=>P.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(P,L,H,q,ee){super(),this.t=P,this.u=L,this.reconnectionToken=H,this.protocol=q,this.w=ee,this.m=this.B(new O.$Td),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Z(this.reconnectionToken,0,0)),this.B(q.onSocketClose(W=>{const Y=_(this.t,this.reconnectionToken,!0);W?W.type===0?(this.u.logService.info(`${Y} received socket close event (hadError: ${W.hadError}).`),W.error&&this.u.logService.error(W.error)):(this.u.logService.info(`${Y} received socket close event (wasClean: ${W.wasClean}, code: ${W.code}, reason: ${W.reason}).`),W.event&&this.u.logService.error(W.event)):this.u.logService.info(`${Y} received socket close event.`),this.y()})),this.B(q.onSocketTimeout(W=>{const Y=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${W.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${W.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${W.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,R.$Rc)(()=>{const W=x.j.indexOf(this);W>=0&&x.j.splice(W,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const P=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${P} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const q=H<L.length?L[H]:L[L.length-1];try{if(q>0){const W=I(q);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,W)),this.u.logService.info(`${P} waiting for ${q} seconds before reconnecting...`);try{await W}catch{}}if(this.n){this.u.logService.error(`${P} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.u.logService.info(`${P} resolving connection...`);const ee=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${P} connecting to ${ee.connectTo}...`),await this.G(ee,l($)),this.u.logService.info(`${P} reconnected!`),this.m.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${P} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.u.logService.error(`${P} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(d.$9k.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${P} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${P} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,j.$4)(ee)){this.u.logService.info(`${P} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof d.$9k){this.u.logService.error(`${P} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,d.$9k.isHandled(ee));break}this.u.logService.error(`${P} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.n&&!this.s)}C(P,L,H){this.w?x.triggerPermanentFailure(P,L,H):this.D(P,L,H)}D(P,L,H){this.m.fire(new J(this.reconnectionToken,P,L,H)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$pl=x;class G extends x{constructor(P,L,H,q,ee){super(1,P,q,ee,!0),this.client=this.B(new S.$Ph(ee,{remoteAuthority:L,clientId:H},P.ipcLogger))}async G(P,L){await i(P,L)}}e.$ql=G;class Q extends x{constructor(P,L,H,q,ee){super(2,P,H,q,!1),this.H=L,this.debugPort=ee}async G(P,L){await t(P,this.H,L)}}e.$rl=Q;function V(U){try{U.acceptDisconnect();const P=U.getSocket();U.dispose(),P.dispose()}catch(P){(0,j.$1)(P)}}function B(U){if(U&&U.type==="error"){const P=new Error(`Connection error: ${U.reason}`);return P.code="VSCODE_CONNECTION_ERROR",P}return null}function te(U,P){for(;U.length<P;)U+=" ";return U}function se(U,P){return`[remote-connection][${te(b(U),13)}][${P.substr(0,5)}\u2026]`}function _(U,P,L){return`${se(U,P)}[${L?"reconnect":"initial"}]`}function oe(U,P){return`${_(P,U.reconnectionToken,!!U.reconnectionProtocol)}[${U.connectTo}]`}function K(U){return`${Date.now()-U} ms`}}),define(le[104],he([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=void 0,e.$dl=(0,N.$4h)("remoteSocketFactoryService");class A{constructor(){this.a={}}register(O,R){return this.a[O]??=[],this.a[O].push(R),(0,D.$Rc)(()=>{const k=this.a[O]?.indexOf(R);typeof k=="number"&&k>=0&&this.a[O]?.splice(k,1)})}b(O){return(this.a[O.type]||[]).find(k=>k.supports(O))}connect(O,R,k,g){const C=this.b(O);if(!C)throw new Error(`No socket factory found for ${O}`);return C.connect(O,R,k,g)}}e.$el=A}),define(le[215],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n_b=e.$m_b=void 0,e.$m_b=(0,D.$4h)("sharedProcessTunnelService"),e.$n_b="sharedProcessTunnel"}),define(le[105],he([0,1,4,163]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=e.$w_b=e.$v_b=e.$u_b=e.$t_b=e.TunnelStates=e.$s_b=e.$r_b=void 0,e.$r_b=(0,D.$4h)("IRemoteTunnelService"),e.$s_b={active:!1};var A;(function(j){j.disconnected=O=>({type:"disconnected",onTokenFailed:O}),j.connected=(O,R)=>({type:"connected",info:O,serviceInstallFailed:R}),j.connecting=O=>({type:"connecting",progress:O}),j.uninitialized={type:"uninitialized"}})(A||(e.TunnelStates=A={})),e.$t_b="remote.tunnels.access",e.$u_b=e.$t_b+".hostNameOverride",e.$v_b=e.$t_b+".preventSleep",e.$w_b="remoteTunnelService",e.$x_b=(0,N.localize)(0,null)}),define(le[59],he([0,1,15,7,2,165,50,4,8,41]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=void 0,e.$9o=(0,R.$4h)("requestService");class C{constructor(E){this.b=E}toJSON(){if(!this.a){const E=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?E[n]="*****":E[n]=this.b[n];this.a=E}return this.a}}class S extends A.$Tc{constructor(E){super(),this.b=0,this.a=E.createLogger("network",{name:(0,j.localize)(0,null),when:k.$Cj.isEqualTo((0,k.$Aj)(k.LogLevel.Trace)).serialize()})}async c(E,n,o){const s=`${E} #${++this.b}: ${n.url}`;this.a.trace(`${s} - begin`,n.type,new C(n.headers??{}));try{const i=await o();return this.a.trace(`${s} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,n.type,(0,N.$0)(i)),i}}}e.$0o=S;function d(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$$o=d;function c(h){return h.res.statusCode===204}e.$_o=c;async function $(h){return c(h)?null:(await(0,D.$te)(h.stream)).toString()}e.$ap=$;async function y(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);return $(h)}e.$bp=y;async function b(h){if(!d(h))throw new Error("Server returned "+h.res.statusCode);if(c(h))return null;const n=(await(0,D.$te)(h.stream)).toString();try{return JSON.parse(n)}catch(o){throw o.message+=`:
`+n,o}}e.$cp=b;function l(h){m(h)}e.$dp=l;let f;function m(h){const E=g.$wn.as(O.$Bn.Configuration),n=f;f={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},E.updateConfigurations({add:[f],remove:n?[n]:[]})}m(1)}),define(le[216],he([0,1,26,23,11,59]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zO=void 0;let O=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=D.CancellationToken.None){if(k.scheme===N.Schemas.file||k.scheme===N.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},d=await this.a.request(S,C);if(d.res.statusCode===200)await this.b.writeFile(g,d.stream);else{const c=await(0,j.$bp)(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${c}`)}}};e.$zO=O,e.$zO=O=ye([X(0,j.$9o),X(1,A.$ok)],O)}),define(le[217],he([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class A{constructor(R){this.a=R}listen(R,k){throw new Error("Invalid listen")}call(R,k,g,C=N.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:d})=>{const c=await(0,D.$te)(d);return[{statusCode:S.statusCode,headers:S.headers},c]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$_q=A;class j{constructor(R){this.a=R}async request(R,k){const[g,C]=await this.a.call("request",[R],k);return{res:g,stream:(0,D.$ve)(C)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$ar=j}),define(le[218],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R0b=e.$Q0b=e.$P0b=void 0,e.$P0b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Q0b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$R0b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[219],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(A){try{const j=await this.c();if(j){const O=String(D.a++);return this.b.set(O,j),{id:O,data:j.createNewMessage(A)}}}catch{}return{id:"",data:A}}async validate(A,j){if(!A.id)return!0;const O=this.b.get(A.id);if(!O)return!1;this.b.delete(A.id);try{return O.validate(j)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(A){try{return await this.d(A)}catch{}return A}}e.$K6b=D}),define(le[106],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl="signService",e.$gl=(0,D.$4h)(e.$fl)}),define(le[220],he([0,1,219]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F$b=void 0;class N extends D.$K6b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(O=>new O.signer().sign(j))}h(){return new Promise((j,O)=>ne(["vsda"],j,O))}}e.$F$b=N}),define(le[77],he([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oFb=e.$nFb=e.$mFb=e.$lFb=void 0;class A extends N.$Tc{constructor(S,d,c){super(),this.a=S,this.b=d,this.c=c}async getItems(){const S={profile:this.b,workspace:this.c},d=await this.a.call("getItems",S);return new Map(d)}updateItems(S){const d={profile:this.b,workspace:this.c};return S.insert&&(d.insert=Array.from(S.insert.entries())),S.delete&&(d.delete=Array.from(S.delete.values())),this.a.call("updateItems",d)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class j extends A{constructor(S,d){super(S,d,void 0),this.f=this.B(new D.$Td),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class O extends j{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$lFb=O;class R extends j{constructor(S,d){super(S,d)}async close(){this.dispose()}}e.$mFb=R;class k extends A{constructor(S,d){super(S,void 0,d),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$nFb=k;class g{constructor(S){this.a=S}isUsed(S){const d={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",d)}}e.$oFb=g}),define(le[107],he([0,1,5,37,32]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yo=e.$xo=void 0;function j(k){if(D.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function O(k,g,C,S,d,c,$,y,b){const l=Object.create(null);l["common.machineId"]=c,l["common.sqmId"]=$,l.sessionID=(0,A.$og)()+Date.now(),l.commitHash=S,l.version=d,l["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,D.$h)(D.$u),l["common.nodePlatform"]=N.$dc,l["common.nodeArch"]=C,l["common.product"]=b||"desktop",y&&(l["common.msftInternal"]=y);let f=0;const m=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-m,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),D.$l&&(l["common.snap"]="true");const h=j(g);return h&&(l["common.platformDetail"]=h),l}e.$xo=O;function R(k){const g=N.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$yo=R}),define(le[22],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=void 0,e.$sl=(0,D.$4h)("telemetryService"),e.$tl=(0,D.$4h)("customEndpointTelemetryService"),e.$ul="telemetry.currentSessionDate",e.$vl="telemetry.firstSessionDate",e.$wl="telemetry.lastSessionDate",e.$xl="telemetry.machineId",e.$yl="telemetry.sqmId",e.$zl="telemetry",e.$Al="telemetry.telemetryLevel",e.$Bl="telemetry.enableCrashReporter",e.$Cl="telemetry.enableTelemetry";var N;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var A;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(A||(e.TelemetryConfiguration=A={}))}),define(le[221],he([0,1,36,6,35,23,16,5,10,142,31,145,95,11,25,22]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=e.$Vr=e.$Ur=void 0;const b=new Map;async function l(n,o){const s=`${n}::${o.join(":")}`,i=b.get(s);if(i)return i;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,v=2e4;function w(p,I,T,F){const M=I.substring(p.length+1);return N.Promises.withAsyncBody(async z=>{let Z;try{Z=await C.Promises.readdir(I,{withFileTypes:!0})}catch{z();return}if(F.count>=v){F.count+=Z.length,F.maxReached=!0,z();return}let J=Z.length;if(J===0){z();return}let x=Z;F.count+Z.length>v&&(F.maxReached=!0,J=v-F.count,x=Z.slice(0,J)),F.count+=Z.length;for(const G of x)if(G.isDirectory()){if(T.includes(G.name)||await w(p,(0,O.$jc)(I,G.name),T,F),--J===0){z();return}}else{const Q=G.name.lastIndexOf(".");if(Q>=0){const V=G.name.substring(Q+1);V&&r.set(V,(r.get(V)??0)+1)}for(const V of t)V.relativePathPattern?.test(M)!==!1&&V.filePattern.test(G.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--J===0){z();return}}})}const u=N.Promises.withAsyncBody(async p=>{const I={count:0,maxReached:!1};await w(n,n,o,I);const T=await h(n);p({configFiles:f(a),fileTypes:f(r),fileCount:I.count,maxFilesReached:I.maxReached,launchConfigFiles:T})});return b.set(s,u),u}e.$Ur=l;function f(n){return Array.from(n.entries(),([o,s])=>({name:o,count:s})).sort((o,s)=>s.count-o.count)}function m(){const n={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/c.$Wk.GB).toFixed(2)}GB (${(D.freemem()/c.$Wk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$8m.value()*100)}%`},o=D.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.$Vr=m;async function h(n){try{const o=new Map,s=(0,O.$jc)(n,".vscode","launch.json"),i=await C.Promises.readFile(s),t=[],r=(0,A.$an)(i.toString(),t);if(t.length)return console.log(`Unable to parse ${s}`),[];if((0,A.$jn)(r)==="object"&&r.configurations)for(const a of r.configurations){const v=a.type;v&&(o.has(v)?o.set(v,o.get(v)+1):o.set(v,1))}return f(o)}catch{return[]}}e.$Wr=h;let E=class{constructor(o,s){this.c=o,this.d=s}f(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}g(o){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const i=D.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(D.totalmem()/c.$Wk.GB).toFixed(2)}GB (${(D.freemem()/c.$Wk.GB).toFixed(2)}GB free)`),R.$i||s.push(`Load (avg):       ${D.loadavg().map(t=>Math.round(t)).join(", ")}`),s.push(`VM:               ${Math.round(g.$8m.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,S.$Tr)(o.mainPID),this.k(o)]).then(async i=>{let[t,r]=i,a=this.m(o,t);return s.forEach(v=>{if((0,d.$Hm)(v))a+=`
${v.errorMessage}`,r+=`
${v.errorMessage}`;else if(a+=`

Remote: ${v.hostName}`,v.processes&&(a+=`
${this.m(o,v.processes)}`),v.workspaceMetadata){r+=`
|  Remote: ${v.hostName}`;for(const w of Object.keys(v.workspaceMetadata)){const u=v.workspaceMetadata[w];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${w}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,s){const{memory:i,vmHint:t,os:r,cpus:a}=m(),v={os:r,memory:i,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return R.$i||(v.load=`${D.loadavg().map(w=>Math.round(w)).join(", ")}`),R.$k&&(v.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(v)}async getDiagnostics(o,s){const i=[];return(0,S.$Tr)(o.mainPID).then(async t=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),s.forEach(r=>{if((0,d.$Hm)(r))i.push(`
${r.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${r.hostName}`),i.push(this.f(r.machineInfo)),r.processes&&i.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const v=r.workspaceMetadata[a];let w=`${v.fileCount} files`;v.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${a}): ${w}`),i.push(this.h(v))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const s=[];let t=0;const r=(u,p)=>{const I=` ${u}(${p})`;t+I.length>60?(s.push(a),a="|                 ",t=a.length):t+=I.length,a+=I};let a="|      File types:";const v=10,w=o.fileTypes.length>v?v:o.fileTypes.length;for(let u=0;u<w;u++){const p=o.fileTypes[u];r(p.name,p.count)}if(s.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(u=>{r(u.name,u.count)}),s.push(a)),o.launchConfigFiles.length>0){let u="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const I=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=I}),s.push(u)}return s.join(`
`)}j(o){const s=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const s=[],i=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(s.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===j.Schemas.file){const v=a.fsPath;i.push(l(v,["node_modules",".git"]).then(w=>{let u=`${w.fileCount} files`;w.maxFilesReached&&(u=`more than ${u}`),s.push(`|    Folder (${(0,O.$nc)(v)}): ${u}`),s.push(this.h(w))}).catch(w=>{s.push(`|      Error: Unable to collect workspace stats for folder ${v} (${w.toString()})`)}))}else s.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(t=>s.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,s){const i=new Map;o.windows.forEach(r=>i.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>i.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),s&&this.n(o.mainPID,i,t,s,0),t.join(`
`)}n(o,s,i,t,r){const a=r===0;let v;a?v=t.pid===o?`${this.d.applicationName} main`:"remote agent":s.has(t.pid)?v=s.get(t.pid):v=`${"  ".repeat(r)} ${t.name}`;const w=process.platform==="win32"?t.mem:D.totalmem()*(t.mem/100);i.push(`${t.load.toFixed(0).padStart(5," ")}	${(w/c.$Wk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${v}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(o,s,i,u,r+1))}async getWorkspaceFileExtensions(o){const s=new Set;for(const{uri:i}of o.folders){const t=k.URI.revive(i);if(t.scheme!==j.Schemas.file)continue;const r=t.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(v=>s.add(v.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const i=k.URI.revive(s);if(i.scheme!==j.Schemas.file)continue;const t=i.fsPath;try{const r=await l(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Xr=E,e.$Xr=E=ye([X(0,y.$sl),X(1,$.$Dj)],E)}),define(le[108],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=e.$U0b=void 0;class D{constructor(j){this.b=j}listen(j,O){throw new Error(`Event not found: ${O}`)}call(j,O,{eventName:R,data:k}){return this.b.forEach(g=>g.log(R,k)),Promise.resolve(null)}}e.$U0b=D;class N{constructor(j){this.b=j}log(j,O){return this.b.call("log",{eventName:j,data:O}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$V0b=N}),define(le[45],he([0,1,30,12,3,20,76,107,22]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=void 0;class g{constructor(t){this.value=t,this.isTrustedTelemetryValue=!0}}e.$zo=g;class C{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Ao=C,e.$Bo=new C;class S{async publicLog(t,r,a){}async publicLogError(t,r,a){}}e.$Co=S,e.$Do="telemetry",e.$Eo="extensionTelemetryLog",e.$Fo={log:()=>null,flush:()=>Promise.resolve(null)};function d(i,t){return A.Event.debounce(t.onDidChangeConfiguration,(a,v)=>{const w=a?new Set([...a.affectedKeys,...v.affectedKeys]):v.affectedKeys;return{...v,affectedKeys:w}},1e3,!0)(a=>{a.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,j.$Ai)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$Go=d;function c(i,t){return!t.isBuilt&&!t.disableTelemetry?!0:!(t.disableTelemetry||!i.enableTelemetry)}e.$Ho=c;function $(i,t){return t.extensionTestsLocationURI?!0:!(t.isBuilt||t.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$Io=$;function y(i){const t=i.getValue(k.$Al),r=i.getValue(k.$Bl);if(i.getValue(k.$Cl)===!1||r===!1)return 0;switch(t??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Jo=y;function b(i){const t={},r={},a={};m(i,a);for(let v in a){v=v.length>150?v.substr(v.length-149):v;const w=a[v];typeof w=="number"?r[v]=w:typeof w=="boolean"?r[v]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${v} has been trimmed to 8192, the original length is ${w.length}`),t[v]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(t[v]=w)}return{properties:t,measurements:r}}e.$Ko=b;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(i){if(!i)return"none";const t=(0,O.$_k)(i);return l.has(t)?t:"other"}e.$Lo=f;function m(i,t,r=0,a){if(i)for(const v of Object.getOwnPropertyNames(i)){const w=i[v],u=a?a+v:v;Array.isArray(w)?t[u]=(0,D.$pn)(w):w instanceof Date?t[u]=w.toISOString():(0,N.$If)(w)?r<2?m(w,t,r+1,u+"."):t[u]=(0,D.$pn)(w):t[u]=w}}function h(i,t){const r=i.msftInternalDomains||[],a=t.getValue("telemetry.internalTesting");return(0,R.$yo)(r)||a}e.$Mo=h;function E(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$No=E;function n(i,t){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let r=i;const a=[];for(const p of t)for(;;){const I=p.exec(i);if(!I)break;a.push([I.index,p.lastIndex])}const v=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(r="";;){const p=w.exec(i);if(!p)break;const I=a.some(([T,F])=>p.index<F&&T<w.lastIndex);!v.test(p[0])&&!I&&(r+=i.substring(u,p.index)+"<REDACTED: user-file-path>",u=w.lastIndex)}return u<i.length&&(r+=i.substr(u)),r}function o(i){if(!i)return i;const t=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of t)if(r.regex.test(i))return`<REDACTED: ${r.label}>`;return i}function s(i,t){return(0,D.$mn)(i,r=>{if(r instanceof g||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=n(a,t);for(const v of t)a=a.replace(v,"");return a=o(a),a}})}e.$Oo=s}),define(le[33],he([0,1,27,29,44,5,10,7,37,45]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=void 0;function C(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,D.$5e)(s.id,i.id)===0}e.$Po=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(i){const t=i.manifest?i.manifest.version:i.version,r=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new d(i.identifier,t,r)}static parse(i){const t=S.exec(i);return t&&t[1]&&t[2]?new d({id:t[1]},t[2],t[4]||void 0):null}constructor(i,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof d?C(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Qo=d;const c=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(s){const i=c.exec(s);return i&&i[1]?[b(i[1]),i[2]]:[b(s),void 0]}e.$Ro=$;function y(s,i){return`${s}.${i}`}e.$So=y;function b(s){return s.toLowerCase()}e.$To=b;function l(s,i){return b(y(s??A.$fm,i))}e.$Uo=l;function f(s,i){const t=[],r=a=>{for(const v of t)if(v.some(w=>C(i(w),i(a))))return v;return null};for(const a of s){const v=r(a);v?v.push(a):t.push([a])}return t}e.$Vo=f;function m(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$Wo=m;function h(s){return{id:new g.$zo(s.identifier.id),name:new g.$zo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Xo=h,e.$Yo=new A.$jm("pprice.better-merge");function E(s,i){const t=[],r=i.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(v=>!C(v.identifier,{id:a}))){const v=s.filter(w=>C(w.identifier,{id:a}));v.length===1&&(t.push(v[0]),r.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$Zo=E;async function n(s,i){if(!j.$k)return!1;let t;try{t=(await s.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await s.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){i.debug("Error while getting the os-release file.",(0,R.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(s,i){const t=await n(s,i),r=(0,N.$jo)(t?"alpine":j.$u,k.$ec);return i.debug("ComputeTargetPlatform:",r),r}e.$1o=o}),define(le[222],he([0,1,18,2,19,10,11,25,6,3,16,5,37,33]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S8b=e.$R8b=void 0;let $=class extends N.$Tc{constructor(m,h){super(),this.b=m,this.c=h,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,E])=>this.a.set(E.configPath,E))}getConfigBasedTips(m){return this.f(m)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(m){const h=[];for(const[E,n]of this.a)if(!(n.configScheme&&n.configScheme!==m.scheme))try{const o=(await this.b.readFile((0,A.$Fg)(m,E))).value.toString();for(const[s,i]of Object.entries(n.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(o))&&h.push({extensionId:s,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return h}};e.$R8b=$,e.$R8b=$=ye([X(0,O.$ok),X(1,R.$Dj)],$);const y="extensionTips/promptedExecutableTips",b="extensionTips/lastPromptedMediumImpExeTime";class l extends ${constructor(m,h,E,n,o,s,i,t){super(i,t),this.r=m,this.s=h,this.t=E,this.u=n,this.w=o,this.z=s,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const v=[],w=[],u=[];Object.entries(a.recommendations).forEach(([p,I])=>{I.important?a.important?v.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):w.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack}):u.push({extensionId:p,extensionName:I.name,isExtensionPack:!!I.isExtensionPack})}),v.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v}),w.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),(0,k.$6g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const m=await this.O(this.g),h=await this.O(this.h);return[...m,...h]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const m=await this.O(this.g),h=await this.O(this.h),E=await this.u.getInstalled();this.m=this.D(m,E),this.n=this.D(h,E)}D(m,h){const E=new Map;m.forEach(t=>E.set(t.extensionId.toLowerCase(),t));const{installed:n,uninstalled:o}=this.N([...E.keys()],h);for(const t of n){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=E.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const s=this.L(),i=new Map;for(const t of o){const r=E.get(t);if(r&&(!s[r.exeName]||!s[r.exeName].includes(r.extensionId))){let a=i.get(r.exeName);a||(a=[],i.set(r.exeName,a)),a.push(r)}}return i}F(){if(this.m.size===0)return;const[m,h]=[...this.m.entries()][0];this.H(h).then(E=>{switch(E){case"reacted":this.M(h[0].exeName,h);break;case"ignored":this.m.delete(m);break;case"incompatibleWindow":{const n=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(n(()=>this.F()));break}case"toomany":{const n=this.B(new N.$Uc);n.value=(0,k.$6g)(()=>{n.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const m=this.I(),h=Date.now()-m,E=7*24*60*60*1e3;if(h<E){const s=this.B(new N.$Uc);s.value=(0,k.$6g)(()=>{s.dispose(),this.G()},E-h);return}const[n,o]=[...this.n.entries()][0];this.H(o).then(s=>{switch(s){case"reacted":{this.J(Date.now()),this.n.delete(n),this.M(o[0].exeName,o);const i=this.B(new N.$Uc);i.value=(0,k.$6g)(()=>{i.dispose(),this.G()},E);break}case"ignored":this.n.delete(n),this.G();break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.G()));break}case"toomany":{const i=this.B(new N.$Uc);i.value=(0,k.$6g)(()=>{i.dispose(),this.G()},60*60*1e3);break}}})}async H(m){const h=await this.u.getInstalled(1),E=m.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(o=>h.every(s=>!(0,c.$Po)(s.identifier,{id:o})))).map(({extensionId:n})=>n.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:E,source:3,name:m[0].exeFriendlyName,searchValue:`@exe:"${m[0].exeName}"`})}I(){let m=this.w.getNumber(b,-1);return m||(m=Date.now(),this.J(m)),m}J(m){this.w.store(b,m,-1,1)}L(){return JSON.parse(this.w.get(y,-1,"{}"))}M(m,h){const E=this.L();E[m]=h.map(({extensionId:n})=>n.toLowerCase()),this.w.store(y,JSON.stringify(E),-1,0)}N(m,h){const E=[],n=[],o=h.reduce((s,i)=>(s.add(i.identifier.id.toLowerCase()),s),new Set);return m.forEach(s=>{o.has(s.toLowerCase())?E.push(s):n.push(s)}),{installed:E,uninstalled:n}}async O(m){const h=[],E=new Map;for(const n of m.keys()){const o=m.get(n);if(!o||!(0,D.$Lb)(o.recommendations))continue;const s=[];S.$i?o.windowsPath&&s.push(o.windowsPath.replace("%USERPROFILE%",()=>d.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>d.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>d.env.ProgramFiles).replace("%APPDATA%",()=>d.env.APPDATA).replace("%WINDIR%",()=>d.env.WINDIR)):(s.push((0,C.$jc)("/usr/local/bin",n)),s.push((0,C.$jc)("/usr/bin",n)),s.push((0,C.$jc)(this.r.fsPath,n)));for(const i of s){let t=E.get(i);if(t===void 0&&(t=await this.b.exists(j.URI.file(i)),E.set(i,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:v,whenNotInstalled:w}of o.recommendations)h.push({extensionId:r,extensionName:a,isExtensionPack:v,exeName:n,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:w})}}return h}}e.$S8b=l}),define(le[223],he([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Yb=void 0;async function A(j,O,R,k,g){try{const C=await j.getExtensionsControlManifest();if(!C.deprecated)return;const S=await j.getInstalled(1);for(const[d,c]of Object.entries(C.deprecated)){if(!c?.extension)continue;const{id:$,autoMigrate:y,preRelease:b}=c.extension;if(!y)continue;const l=S.find(m=>(0,N.$Po)(m.identifier,{id:d}));if(!l)continue;const f=(await O.getExtensions([{id:$,preRelease:b}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${l.identifier.id}' extension to '${$}' extension...`);const m=!k.getDisabledExtensions().some(E=>(0,N.$Po)(E,l.identifier));await j.uninstall(l),g.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let h=S.find(E=>(0,N.$Po)(E.identifier,{id:$}));(!h||!h.isPreReleaseVersion&&m)&&(h=await j.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${h.identifier.id}'`),m||(await k.disableExtension(h.identifier),g.info(`Disabled the pre-release extension '${h.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),y.storage&&(R.addToMigrationList((0,N.$So)(l.manifest.publisher,l.manifest.name),(0,N.$So)(h.manifest.publisher,h.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${l.identifier.id}' extension to '${$}' extension.`)}catch(m){g.error(m)}}}catch(C){g.error(C)}}e.$0Yb=A}),define(le[224],he([0,1,6,7,2,23,19,55,12,32,31,69,20,14,29,33,97,11,8]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;let h=class extends A.$Tc{static{m=this}static{this.c=".sigzip"}constructor(n,o,s,i,t,r){super(),this.h=o,this.j=s,this.m=i,this.n=t,this.r=r,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(n,o,s){await this.g;const i=(0,O.$Fg)(this.extensionsDownloadDir,this.z(n));try{await this.w(n,i,r=>this.j.download(n,r,o))}catch(r){throw new $.$oo(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(s&&this.t(n)){const r=await this.u(n);try{t=await this.n.verify(i.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const v=a;if(t=v.code,v.output&&this.r.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${v.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(i)}catch(w){this.r.error(w)}throw new $.$oo(S.$Ap,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${n.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${n.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${n.identifier.id}`),{location:i,verificationStatus:t}}t(n){if(!n.isSigned)return!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Mf)(o)?o:!0}async u(n){await this.g;const o=(0,O.$Fg)(this.extensionsDownloadDir,`${this.z(n)}${m.c}`);return await this.w(n,o,s=>this.j.downloadSignatureArchive(n,s)),o}async w(n,o,s){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await s(o);return}const i=(0,O.$Fg)(this.extensionsDownloadDir,`.${(0,g.$og)()}`);await this.h.exists(i)||await s(i);try{await C.Promises.rename(i.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(i)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(t)}. Deleted the file from downloaded location`,i.path),t}}async delete(n){await this.g,await this.h.del(n)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const o=[],s=[],i=[];for(const a of n.children)if(a.name.endsWith(m.c))i.push(a.resource);else{const v=y.$Qo.parse(a.name);v&&s.push([v,a])}const t=(0,y.$Vo)(s,([a])=>a),r=[];for(const a of t)a.sort((v,w)=>R.rcompare(v[0].version,w[0].version)),o.push(...a.slice(1).map(v=>v[1].resource)),r.push(a[0][1]);r.sort((a,v)=>a.mtime-v.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...i),await D.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(n){this.r.error(n)}}z(n){return this.f?y.$Qo.create(n).toString().toLowerCase():(0,g.$og)()}};e.$Tp=h,e.$Tp=h=m=ye([X(0,c.$_h),X(1,l.$ok),X(2,$.$no),X(3,d.$xi),X(4,b.$up),X(5,f.$lj)],h)}),define(le[225],he([0,1,3,2,34,33,44]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;class R extends N.$Tc{constructor(g,C,S,d,c,$,y){super(),this.f=g,this.g=C,this.h=S,this.j=d,this.m=c,this.n=$,this.r=y,this.a=this.B(new D.$Td),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$3c),this.s().then(null,b=>y.error(b))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,N.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const d of g.extensions){const c=this.L(d.identifier,d.version);g.error?this.I(c,g.profileLocation):(this.J(c,g.profileLocation),this.b.has(c)||(this.r.debug("Extension is removed from all profiles",d.identifier.id,d.version),S.push(this.f.scanInstalledExtensionAtLocation(d.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",d.location.toString())},$=>this.r.error($)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(d){this.r.error(d)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],d=await this.j.scanProfileExtensions(g),c=new Set,$=new Set;for(const[y,b]of this.b)b.has(g)&&$.add(y);for(const y of d){const b=this.L(y.identifier,y.version);c.add(b),$.has(b)||(C.push(y.identifier),this.I(b,g))}for(const y of $)if(!c.has(y)){const b=this.M(y);b&&(S.push(b.identifier),this.J(y,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new A.$Bc(d=>this.m.extUri.getComparisonKey(d))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${O.$jm.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,j.$Ro)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$Xp=R}),define(le[226],he([0,1,43,45]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;async function A(j,O,R,k,g,C,S){const d={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${O.nameShort})`};if((0,N.$Ho)(O,R)&&(0,N.$Jo)(k)===3){const c=await(0,D.$pp)(R,g,C);d["X-Market-User-Id"]=c,d["VSCode-SessionId"]=S.machineId||c}return d}e.$qp=A}),define(le[227],he([0,1,72,18,6,2,23,16,31,14,29,33,8,74,10]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;let y=class extends c.$0q{constructor(m,h,E,n){super(E),this.h=m,this.j=n,this.g=this.B(new b(h,n)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(m,h){const n=(await this.g.getLanguagePacks())[h];if(!n){this.j.warn(`No language pack found for ${h}`);return}const o=n.translations[m];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),h=Object.keys(m).map(E=>{const n=m[E];return{...this.f(E,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((E,n)=>E.label.localeCompare(n.label)),h}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const h=await this.g.getLanguagePacks();Object.keys(h).some(E=>h[E]&&h[E].extensions.some(n=>(0,S.$Po)(n.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),E=await this.g.update(h);return!(0,N.$ub)(Object.keys(m),Object.keys(E))}};e.$$q=y,e.$$q=y=ye([X(0,C.$po),X(1,g.$_h),X(2,C.$no),X(3,d.$lj)],y);let b=class extends j.$Tc{constructor(m,h){super(),this.j=h,this.c={},this.f=(0,R.$jc)(m.userDataPath,"languagepacks.json"),this.g=new A.$$g}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(h=>{Object.keys(h).forEach(E=>delete h[E]),this.m(h,...m)}).then(()=>this.c)}m(m,...h){for(const E of h)E&&E.manifest&&E.manifest.contributes&&E.manifest.contributes.localizations&&E.manifest.contributes.localizations.length&&this.n(m,E);Object.keys(m).forEach(E=>this.r(m[E]))}n(m,h){const E=h.identifier,n=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const o of n)if(h.location.scheme===O.Schemas.file&&l(o)){let s=m[o.languageId];s||(s={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},m[o.languageId]=s);const i=s.extensions.filter(t=>(0,S.$Po)(t.extensionIdentifier,E))[0];i?i.version=h.manifest.version:s.extensions.push({extensionIdentifier:E,version:h.manifest.version});for(const t of o.translations)s.translations[t.id]=(0,R.$jc)(h.location.fsPath,t.path)}}r(m){if(m){const h=(0,D.createHash)("md5");for(const E of m.extensions)h.update(E.extensionIdentifier.uuid||E.extensionIdentifier.id).update(E.version);m.hash=h.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let h=null;return k.Promises.readFile(this.f,"utf8").then(void 0,E=>E.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(E)).then(E=>{try{return JSON.parse(E)}catch{return{}}}).then(E=>(h=m(E),E)).then(E=>{for(const o of Object.keys(E))E[o]||delete E[o];this.c=E,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),k.Promises.writeFile(this.f,n)}).then(()=>h,E=>this.j.error(E))})}};b=ye([X(0,g.$_h),X(1,d.$lj)],b);function l(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const m of f.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(le[228],he([0,1,141,7,30,45]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0N=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function k(C,S,d){const c=await(0,D.$8C)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,D.$8C)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new c.AppInsightsCore,b=new $.PostChannel,l={instrumentationKey:C,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(d){l.extensionConfig={};const f={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:d};l.extensionConfig[b.identifier]=f}return y.initialize(l,[]),y.addTelemetryInitializer(f=>{f.ext=f.ext??{},f.ext.web=f.ext.web??{},f.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),y}class g{constructor(S,d,c,$,y){this.e=S,this.f=d,this.g=c,this.h=y,this.c=O,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(d=>{S(d)},d=>{(0,N.$1)(d),console.error(d)})}}log(S,d){if(!this.a)return;d=(0,A.$nn)(d,this.g),d=(0,j.$Ko)(d);const c=this.f+"/"+S;try{this.i($=>{$.pluginVersionString=d?.properties.version??"Unknown",$.track({name:c,baseData:{name:c,properties:d?.properties,measurements:d?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(d=>{d.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$0N=g}),define(le[109],he([0,1,2,166,14,8,25,45]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f8b=void 0;let k=class extends D.$Tc{constructor(C,S,d,c,$=""){super(),this.b=$;const y=S.getLogger(R.$Do);if(y)this.a=this.B(y);else{const l=(0,R.$Io)(c,d)?" (Not Sent)":"",f=()=>(0,R.$Ho)(c,d)&&C.getLevel()===j.LogLevel.Trace;this.a=this.B(S.createLogger(R.$Do,{name:(0,N.localize)(0,null,l),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(R.$Do,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,R.$Ko)(S))}};e.$f8b=k,e.$f8b=k=ye([X(0,j.$lj),X(1,j.$mj),X(2,A.$$h),X(3,O.$Dj)],k)}),define(le[110],he([0,1,2,30,5,27,167,20,50,102,25,41,22,45]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,f,m){this.k=f,this.l=m,this.d={},this.i=new D.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,j.$Me)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Me)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(d.$Al)||h.affectsConfiguration(d.$Cl)||h.affectsConfiguration(d.$Bl))&&this.m()}))}setExperimentProperty(l,f){this.d[l]=f}m(){let l=(0,c.$Jo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const m=f.usage?3:f.error?2:0;l=Math.min(l,m)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,f,m){this.g<f||(m=(0,N.$nn)(m,this.d),m=(0,c.$Oo)(m,this.j),m=(0,N.$nn)(m,this.c),this.b.forEach(h=>h.log(l,m)))}publicLog(l,f){this.n(l,3,f)}publicLog2(l,f){this.publicLog(l,f)}publicLogError(l,f){this.h&&this.n(l,2,f)}publicLogError2(l,f){this.publicLogError(l,f)}};e.$er=$,e.$er=$=ye([X(1,R.$xi),X(2,C.$Dj)],$);function y(){const b=(0,O.localize)(0,null,g.default.nameLong),l=g.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=A.$o?"":(0,O.localize)(3,null),m=(0,O.localize)(4,null),h=(0,O.localize)(5,null),E=(0,O.localize)(6,null),n=(0,O.localize)(7,null),o=`
|       | ${m} | ${h} | ${E} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,O.localize)(8,null);return`
${b} ${l} ${f}

&nbsp;

${n}
${o}

&nbsp;

${s}
`}S.$wn.as(k.$Bn.Configuration).registerConfiguration({id:d.$zl,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[d.$Al]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$wn.as(k.$Bn.Configuration).registerConfiguration({id:d.$zl,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[d.$Cl]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,O.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,O.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${d.$Al}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[229],he([0,1,15,26,271,228]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$N=void 0;async function O(C,S){const d=await S.request(C,N.CancellationToken.None),c=(await(0,D.$te)(d.stream)).toString(),$=d.res.statusCode??200;return{headers:d.res.headers,statusCode:$,responseData:c}}async function R(C){const S={method:C.type,headers:C.headers};return new Promise((c,$)=>{const y=A.request(C.url??"",S,b=>{b.on("data",function(l){c({headers:b.headers,statusCode:b.statusCode??200,responseData:l.toString()})}),b.on("error",function(l){$(l)})});y.write(C.data,b=>{b&&$(b)}),y.end()})}async function k(C,S,d){const c=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),$={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:c};try{const y=C?await O($,C):await R($);d(y.statusCode,y.headers,y.responseData)}catch{d(0,{})}}class g extends j.$0N{constructor(S,d,c,$,y){const b={sendPOST:(l,f)=>{k(S,l,f)}};super(d,c,$,y,b)}}e.$$N=g}),define(le[230],he([0,1,23,93,20,14,8,25,22,108,109,110]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=void 0;let d=class{constructor($,y,b,l,f,m){this.b=$,this.c=y,this.d=b,this.e=l,this.f=f,this.g=m,this.a=new Map}h($){if(!this.a.has($.id)){const y=Object.create(null);y["common.vscodemachineid"]=this.c.machineId,y["common.vscodesessionid"]=this.c.sessionId;const b=[$.id,JSON.stringify(y),$.aiKey],f=new N.$gq(D.$mg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:b,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),m=[new g.$V0b(f),new C.$f8b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new S.$er({appenders:m,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,y,b){this.h($).publicLog(y,b)}publicLogError($,y,b){this.h($).publicLogError(y,b)}};e.$b_b=d,e.$b_b=d=ye([X(0,A.$xi),X(1,k.$sl),X(2,O.$lj),X(3,O.$mj),X(4,j.$$h),X(5,R.$Dj)],d)}),define(le[78],he([0,1,3,20,4,8]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.$tv=e.ProvidedOnAutoForward=e.$sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$rv=e.$qv=void 0,e.$qv=(0,A.$4h)("tunnelService"),e.$rv=(0,A.$4h)("sharedTunnelsService");var O;(function(b){b.Http="http",b.Https="https"})(O||(e.TunnelProtocol=O={}));var R;(function(b){b.ConstantPrivate="constantPrivate",b.Private="private",b.Public="public"})(R||(e.TunnelPrivacyId=R={}));function k(b){return!!b.forwardPort}e.$sv=k;var g;(function(b){b[b.Notify=1]="Notify",b[b.OpenBrowser=2]="OpenBrowser",b[b.OpenPreview=3]="OpenPreview",b[b.Silent=4]="Silent",b[b.Ignore=5]="Ignore",b[b.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(b){if(b.scheme!=="http"&&b.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(b.authority);if(l)return{address:l[1],port:+l[2]}}e.$tv=C,e.$uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(b){return e.$uv.indexOf(b)>=0}e.$vv=S,e.$wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(b){return e.$wv.indexOf(b)>=0}e.$xv=d;function c(b,l,f,m){if(f===1)return!1;if(f===2&&d(l)){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(h?.length===4&&parseInt(h[1])>=18)return!1}return b<1024}e.$yv=c;class ${constructor(l,f,m){this.remoteAddress=l,this.localAddress=f,this.b=m,this.a=new D.$Td,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$zv=$;let y=class{constructor(l,f){this.j=l,this.k=f,this.a=new D.$Td,this.onTunnelOpened=this.a.event,this.b=new D.$Td,this.onTunnelClosed=this.b.event,this.c=new D.$Td,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const l=this.k.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.f=l,l?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.g=l.elevation,this.h=l.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const l=[],f=Array.from(this.e.values());for(const m of f){const h=Array.from(m.values());for(const E of h){const n=await E.value;n&&typeof n!="string"&&l.push(n)}}return l}async dispose(){for(const l of this.e.values()){for(const{value:f}of l.values())await f.then(m=>typeof m!="string"?m?.dispose():void 0);l.clear()}this.e.clear()}setEnvironmentTunnel(l,f,m,h,E){this.p(l,f,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:f,localAddress:m,privacy:h,protocol:E,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,f){(d(l)||S(l))&&(l=e.$uv[0]);const m=this.r(l,f);if(m)return++m.refcount,m.value}openTunnel(l,f,m,h,E,n=!1,o,s){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${m} on local port ${E}.`);const i=this.f??l;if(!i)return;if(f||(f="localhost"),h||(h=this.l),this.f&&this.i.has(m)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.s(i,f,m,h,E,n,o,s);return t?t.then(r=>{if(r){if(typeof r=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(f,m),r}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(f,m);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.n(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==m)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}n(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const f=this.e.get(l.tunnelRemoteHost);if(f){const m=f.get(l.tunnelRemotePort);m&&(m.refcount--,await this.o(l.tunnelRemoteHost,l.tunnelRemotePort,m))}}}}async o(l,f,m){if(m.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${f}.`);const h=m.value.then(async E=>{E&&typeof E!="string"&&(await E.dispose(!0),this.b.fire({host:E.tunnelRemoteHost,port:E.tunnelRemotePort}))});return this.e.has(l)&&this.e.get(l).delete(f),h}}async closeTunnel(l,f){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${f} `);const m=this.e.get(l);if(m&&m.has(f)){const h=m.get(f);h.refcount=0,await this.o(l,f,h)}}p(l,f,m){this.e.has(l)||this.e.set(l,new Map),this.e.get(l).set(f,{refcount:1,value:m})}async q(l,f){const m=this.e.get(l);if(m){const h=m.get(f),E=h?await h.value:void 0;(!E||typeof E=="string")&&m.delete(f),m.size===0&&this.e.delete(l)}}r(l,f){const m=[l];S(l)?(m.push(...e.$uv),m.push(...e.$wv)):d(l)&&m.push(...e.$wv);const h=m.map(E=>this.e.get(E));for(const E of h){const n=E?.get(f);if(n)return n}}canTunnel(l){return!!C(l)}t(l,f,m,h,E,n,o){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${m} on local port ${h}.`);const s=m;this.i.add(s);const i=h===void 0?m:h,t={elevationRequired:E?this.isPortPrivileged(i):!1},r={remoteAddress:{host:f,port:m},localAddressPort:h,privacy:n,public:n?n!==R.Private:void 0,protocol:o},a=l.forwardPort(r,t);return a?(this.p(f,m,a),a.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(s)})):this.i.delete(s),a}};e.$Av=y,e.$Av=y=ye([X(0,j.$lj),X(1,N.$xi)],y)}),define(le[231],he([0,1,8,78,2,7,6]),function(ne,e,D,N,A,j,O){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=void 0;class k extends A.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$oh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends A.$Tc{static{R=this}static{this.a=0}constructor(S,d){super(),this.f=S,this.g=d,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++R.a)}}async startTunnel(S,d,c,$,y,b,l){const f=new k,m=await Promise.resolve(this.f.openTunnel(S,f,c,$,y,b,l));if(!m||typeof m=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${c}:${$} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(d))throw this.c.delete(d),f.dispose(),await m.dispose(),(0,j.$6)();return f.setTunnel(m),this.b.set(d,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${d}: ${m.localAddress} (local) to ${c}:${$} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(S,d){const c=this.b.get(S);c&&c.setAddress(d)}async destroyTunnel(S){const d=this.b.get(S);if(d){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await d.dispose();return}this.c.add(S)}};e.$o_b=g,e.$o_b=g=R=ye([X(0,N.$rv),X(1,D.$lj)],g)}),define(le[28],he([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=void 0,e.$Yk=(0,D.$4h)("IUriIdentityService")}),define(le[232],he([0,1,28,185,11,19,127,3,2]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qr=void 0;class g{static{this._clock=0}constructor(d){this.uri=d,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(d){this.g=d,this.c=new k.$Sc,this.f=2**16;const c=new Map,$=y=>{let b=c.get(y.scheme);return b===void 0&&(b=d.hasProvider(y)&&!this.g.hasCapability(y,1024),c.set(y.scheme,b)),b};this.c.add(R.Event.any(d.onDidChangeFileSystemProviderRegistrations,d.onDidChangeFileSystemProviderCapabilities)(y=>{c.delete(y.scheme)})),this.extUri=new j.$ug($),this.d=new O.$Pr((y,b)=>this.extUri.compare(y,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(d){this.g.hasProvider(d)&&(d=(0,j.$Gg)(d));const c=this.d.get(d);return c?c.touch().uri.with({fragment:d.fragment}):(this.d.set(d,new g(d)),this.h(),d)}h(){if(this.d.size<this.f)return;const d=[...this.d.entries()].sort(($,y)=>$[1].time<y[1].time?1:$[1].time>y[1].time?-1:0);g._clock=0,this.d.clear();const c=this.f*.5;for(let $=0;$<c;$++)this.d.set(d[$][0],d[$][1].touch())}};e.$Qr=C,e.$Qr=C=ye([X(0,A.$ok)],C),(0,N.$Nr)(D.$Yk,C,1)}),define(le[233],he([0,1,3,2,11,47,34]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class R extends N.$Tc{constructor(g,C,S,d,c,$){super(),this.f=g,this.g=C,this.h=S,this.j=d,this.m=c,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$Td),this.onDidChangeFile=this.a.event,this.b=j.$0h.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(d.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,d,c){return this.g.read(g,C,S,d,c)}write(g,C,S,d,c){return this.g.write(g,C,S,d,c)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,N.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,A.$sk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,A.$tk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const d=this.u(S.resource);this.b.findSubstr(d)&&C.push({resource:d,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$I$b=R}),define(le[79],he([0,1,86]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Eb=e.$4Eb=e.edit=void 0;function N(O,R,k,g){const C=(0,D.$5T)(O,R,k,g)[0];return C&&(O=O.substring(0,C.offset)+C.content+O.substring(C.offset+C.length)),O}e.edit=N;function A(O,R,k){let g=k;for(;g>=0;){if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1)return g+1;if(g--,R.length===2&&g>=0&&O.charAt(g)===R.charAt(0))return g+2}return 0}e.$4Eb=A;function j(O,R,k){let g=k;for(;g>=0;)if(O.charAt(g)===R.charAt(R.length-1)&&R.length===1||(g++,R.length===2&&g>=0&&O.charAt(g)===R.charAt(1)))return g;return O.length-1}e.$5Eb=j}),define(le[234],he([0,1,30,55,12]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;function j(c,$,y,b,l,f){const m=[],h=[],E=[];if(!$){const z=c.filter(({identifier:Z})=>l.every(J=>J.toLowerCase()!==Z.id.toLowerCase()));return{local:{added:m,removed:h,updated:E},remote:z.length>0?{added:z,updated:[],removed:[],all:z}:null}}c=c.map(S),$=$.map(S),y=y?y.map(S):null;const n=new Map,o=z=>{z.uuid&&n.set(z.id.toLowerCase(),z.uuid)};c.forEach(({identifier:z})=>o(z)),$.forEach(({identifier:z})=>o(z)),y?.forEach(({identifier:z})=>o(z)),b?.forEach(({identifier:z})=>o(z)),f?.forEach(z=>o(z));const s=z=>{const Z=z.identifier.uuid||n.get(z.identifier.id.toLowerCase());return Z?`uuid:${Z}`:`id:${z.identifier.id.toLowerCase()}`},i=(z,Z)=>(z.set(s(Z),Z),z),t=c.reduce(i,new Map),r=$.reduce(i,new Map),a=$.reduce((z,Z)=>i(z,(0,D.$kn)(Z)),new Map),v=y?y.reduce(i,new Map):null,w=b.reduce(i,new Map),u=l.reduce((z,Z)=>{const J=n.get(Z.toLowerCase());return z.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)},new Set),p=f?f.reduce((z,{id:Z,uuid:J})=>(J=J??n.get(Z.toLowerCase()),z.add(J?`uuid:${J}`:`id:${Z.toLowerCase()}`)),new Set):null,I=O(t,r,u,!1);if(I.added.size>0||I.removed.size>0||I.updated.size>0){const z=O(v,t,u,!1),Z=O(v,r,u,!0),J=(x,G,Q,V)=>{let B,te,se;return G.installed?(B=V.pinned,se=V.preRelease,B&&(te=V.version)):(B=Q.pinned,se=Q.preRelease,B&&(te=Q.version)),B===void 0&&(B=G.pinned,B&&(te=G.version)),se===void 0&&(se=G.preRelease),{...V,installed:G.installed||Q.installed,pinned:B,preRelease:se,version:te??(Q.version&&(!G.installed||N.gt(Q.version,G.version))?Q.version:G.version),state:k(G,Q,v?.get(x))}};for(const x of Z.removed.values()){const G=t.get(x);if(!G)continue;const Q=(0,A.$Rf)(v?.get(x)),V=p&&!p.has(x)&&Q.installed;G.installed&&V?h.push(G.identifier):a.set(x,G)}for(const x of Z.added.values()){const G=(0,A.$Rf)(r.get(x)),Q=t.get(x);if(Q){if(I.updated.has(x)){const V=J(x,Q,G,G);R(Q,G,!1,!1)||E.push(d(V,x)),a.set(x,V)}}else G.installed&&m.push(d(G,x))}for(const x of Z.updated.values()){const G=(0,A.$Rf)(r.get(x)),Q=(0,A.$Rf)(v?.get(x)),V=t.get(x);if(V)if(p&&!p.has(x)&&Q.installed&&V.installed&&!G.installed)h.push(V.identifier);else{const te=J(x,V,G,G);E.push(d(te,x)),a.set(x,te)}else G.installed&&m.push(d(G,x))}for(const x of z.added.values())Z.added.has(x)||a.set(x,(0,A.$Rf)(t.get(x)));for(const x of z.updated.values()){if(Z.removed.has(x)||Z.updated.has(x))continue;const G=(0,A.$Rf)(t.get(x)),Q=(0,A.$Rf)(r.get(x));a.set(x,J(x,G,Q,G))}for(const x of z.removed.values())Z.updated.has(x)||Z.removed.has(x)||w.has(x)||(0,A.$Rf)(r.get(x)).installed&&p&&(p.has(x)||!(0,A.$Rf)(v?.get(x)).installed||a.delete(x))}const T=[],F=O(r,a,new Set,!0),M=F.added.size>0||F.updated.size>0||F.removed.size>0;return M&&a.forEach((z,Z)=>T.push(d(z,Z))),{local:{added:m,removed:h,updated:E},remote:M?{added:[...F.added].map(z=>a.get(z)),updated:[...F.updated].map(z=>a.get(z)),removed:[...F.removed].map(z=>r.get(z)),all:T}:null}}e.$X6b=j;function O(c,$,y,b){const l=c?[...c.keys()].filter(n=>!y.has(n)):[],f=[...$.keys()].filter(n=>!y.has(n)),m=f.filter(n=>!l.includes(n)).reduce((n,o)=>(n.add(o),n),new Set),h=l.filter(n=>!f.includes(n)).reduce((n,o)=>(n.add(o),n),new Set),E=new Set;for(const n of l){if(h.has(n))continue;const o=c.get(n),s=$.get(n);(!s||!R(o,s,b,!0))&&E.add(n)}return{added:m,removed:h,updated:E}}function R(c,$,y,b){return!(c.disabled!==$.disabled||!!c.isApplicationScoped!=!!$.isApplicationScoped||b&&c.installed!==$.installed||c.installed&&$.installed&&(c.preRelease!==$.preRelease||c.pinned!==$.pinned||$.pinned&&c.version!==$.version)||!C(c.state,$.state)||y&&c.version!==$.version)}function k(c,$,y){const b=c.state,l=$.state,f=y?.state;if(!$.version||b&&N.gt(c.version,$.version))return b;if(l&&N.gt($.version,c.version)||!b)return l;if(!l)return b;const m=(0,D.$kn)(b),h=f?g(f,l):{added:Object.keys(l).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set},E=f?g(f,b):{added:Object.keys(b).reduce((n,o)=>(n.add(o),n),new Set),removed:new Set,updated:new Set};for(const n of[...h.added.values(),...h.updated.values()])m[n]=l[n];for(const n of h.removed.values())E.updated.has(n)||delete m[n];return m}function g(c,$){const y=Object.keys(c),b=Object.keys($),l=b.filter(h=>!y.includes(h)).reduce((h,E)=>(h.add(E),h),new Set),f=y.filter(h=>!b.includes(h)).reduce((h,E)=>(h.add(E),h),new Set),m=new Set;for(const h of y){if(f.has(h))continue;const E=c[h],n=$[h];(0,D.$on)(E,n)||m.add(h)}return{added:l,removed:f,updated:m}}function C(c={},$={}){const{added:y,removed:b,updated:l}=g(c,$);return y.size===0&&b.size===0&&l.size===0}function S(c){return{...c,disabled:!!c.disabled,installed:!!c.installed}}function d(c,$){const y={...c,identifier:{id:c.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!c.preRelease,pinned:!!c.pinned};return c.disabled||delete y.disabled,c.installed||delete y.installed,c.state||delete y.state,c.isApplicationScoped||delete y.isApplicationScoped,y}}),define(le[111],he([0,1,18,20,4]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7Gb=e.$6Gb=void 0,e.$6Gb=(0,A.$4h)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(R,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==R&&C!==`-${R}`),k&&g.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(R){const k=R.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),g=this.b().map(d=>d.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const d of g)d.startsWith("-")?S.push(d.substring(1)):C.push(d);return(0,D.$Mb)([...k,...C].filter(d=>!S.includes(d)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$7Gb=j,e.$7Gb=j=ye([X(0,N.$xi)],j)}),define(le[235],he([0,1,18,35,30,94,79]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;function R(h){return(0,N.$an)(h)||[]}async function k(h,E,n,o,s){const i=R(h),t=R(E),r=n?R(n):null,a=[...i,...t,...r||[]].map(J=>J.key),v=await s.resolveUserBindings(a),w=C(i,t,r,v);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:h,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:E,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};const u=d(i),p=d(t),I=r?d(r):null,T=$(u,p,v),F=I?$(I,u,v):{added:[...u.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},M=I?$(I,p,v):{added:[...p.keys()].reduce((J,x)=>(J.add(x),J),new Set),removed:new Set,updated:new Set},z=g(T,F,M);let Z=h;for(const J of z.removed.values())z.conflicts.has(J)||(Z=f(Z,J,o));for(const J of z.added.values()){if(z.conflicts.has(J))continue;const x=p.get(J);if(x.some(G=>G.command!==`-${J}`&&w.conflicts.has(v[G.key]))){z.conflicts.add(J);continue}Z=l(Z,x,o)}for(const J of z.updated.values()){if(z.conflicts.has(J))continue;const x=p.get(J);if(x.some(G=>G.command!==`-${J}`&&w.conflicts.has(v[G.key]))){z.conflicts.add(J);continue}Z=m(Z,J,x,o)}return{mergeContent:Z,hasChanges:!0,hasConflicts:z.conflicts.size>0}}e.$46b=k;function g(h,E,n){const o=new Set,s=new Set,i=new Set,t=new Set;for(const r of E.removed.values())n.updated.has(r)&&t.add(r);for(const r of n.removed.values())t.has(r)||(E.updated.has(r)?t.add(r):s.add(r));for(const r of E.added.values())t.has(r)||n.added.has(r)&&h.updated.has(r)&&t.add(r);for(const r of n.added.values())t.has(r)||(E.added.has(r)?h.updated.has(r)&&t.add(r):o.add(r));for(const r of E.updated.values())t.has(r)||n.updated.has(r)&&h.updated.has(r)&&t.add(r);for(const r of n.updated.values())t.has(r)||(E.updated.has(r)?h.updated.has(r)&&t.add(r):i.add(r));return{added:o,removed:s,updated:i,conflicts:t}}function C(h,E,n,o){const s=new Set,i=S(h,o),t=S(E,o),r=n?S(n,o):null,a=c(i,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const v=r?c(r,i):{added:[...i.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:s,removed:s,updated:s,conflicts:s};const w=r?c(r,t):{added:[...t.keys()].reduce((F,M)=>(F.add(M),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:s,removed:s,updated:s,conflicts:s};const{added:u,removed:p,updated:I,conflicts:T}=g(a,v,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:I,conflicts:T}}function S(h,E){const n=new Map;for(const o of h){const s=E[o.key];let i=n.get(s);i||(i=[],n.set(s,i)),i.push(o)}return n}function d(h){const E=new Map;for(const n of h){const o=n.command[0]==="-"?n.command.substring(1):n.command;let s=E.get(o);s||(s=[],E.set(o,s)),s.push(n)}return E}function c(h,E){const n=[...h.keys()],o=[...E.keys()],s=o.filter(r=>!n.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=n.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of n){if(i.has(r))continue;const a=h.get(r).map(w=>({...w,key:r})),v=E.get(r).map(w=>({...w,key:r}));(0,D.$ub)(a,v,(w,u)=>b(w,u))||t.add(r)}return{added:s,removed:i,updated:t}}function $(h,E,n){const o=[...h.keys()],s=[...E.keys()],i=s.filter(a=>!o.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),t=o.filter(a=>!s.includes(a)).reduce((a,v)=>(a.add(v),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const v=h.get(a).map(u=>({...u,key:n[u.key]})),w=E.get(a).map(u=>({...u,key:n[u.key]}));y(v,w)||r.add(a)}return{added:i,removed:t,updated:r}}function y(h,E){return!(!(0,D.$ub)(h.filter(({command:n})=>n[0]!=="-"),E.filter(({command:n})=>n[0]!=="-"),(n,o)=>b(n,o))||!(0,D.$ub)(h.filter(({command:n})=>n[0]==="-"),E.filter(({command:n})=>n[0]==="-"),(n,o)=>b(n,o)))}function b(h,E){if(h.command!==E.command||h.key!==E.key)return!1;const n=j.$2i.deserialize(h.when),o=j.$2i.deserialize(E.when);return!(n&&!o||!n&&o||n&&o&&!n.equals(o)||!A.$on(h.args,E.args))}function l(h,E,n){for(const o of E)h=O.edit(h,[-1],o,n);return h}function f(h,E,n){const o=R(h);for(let s=o.length-1;s>=0;s--)(o[s].command===E||o[s].command===`-${E}`)&&(h=O.edit(h,[s],void 0,n));return h}function m(h,E,n,o){const s=R(h),i=s.findIndex(t=>t.command===E||t.command===`-${E}`);for(let t=s.length-1;t>=0;t--)(s[t].command===E||s[t].command===`-${E}`)&&(h=O.edit(h,[t],void 0,o));for(let t=n.length-1;t>=0;t--)h=O.edit(h,[i],n[t],o);return h}}),define(le[236],he([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=e.$$6b=void 0;function D(j,O,R){const k={},g={},C=new Set;if(!O)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const S=N(j,O);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=N(R,j),c=N(R,O),$={},y={},b=new Set,l=new Set;for(const f of d.removed.values())c.updated.has(f)?k[f]=O[f]:b.add(f);for(const f of c.removed.values())l.has(f)||(d.updated.has(f)?l.add(f):C.add(f));for(const f of d.updated.values())l.has(f)||(c.updated.has(f)?S.updated.has(f)&&l.add(f):y[f]=j[f]);for(const f of c.updated.values())l.has(f)||(d.updated.has(f)?S.updated.has(f)&&l.add(f):j[f]!==void 0&&(g[f]=O[f]));for(const f of d.added.values())l.has(f)||(c.added.has(f)?S.updated.has(f)&&l.add(f):$[f]=j[f]);for(const f of c.added.values())l.has(f)||(d.added.has(f)?S.updated.has(f)&&l.add(f):k[f]=O[f]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:$,removed:[...b.values()],updated:y},conflicts:[...l.values()]}}e.$$6b=D;function N(j,O){const R=j?Object.keys(j):[],k=O?Object.keys(O):[],g=k.filter(d=>!R.includes(d)).reduce((d,c)=>(d.add(c),d),new Set),C=R.filter(d=>!k.includes(d)).reduce((d,c)=>(d.add(c),d),new Set),S=new Set;for(const d of R){if(C.has(d))continue;const c=j[d],$=O[d];c!==$&&S.add(d)}return{added:g,removed:C,updated:S}}function A(j,O){const{added:R,removed:k,updated:g}=N(j,O);return R.size===0&&k.size===0&&g.size===0}e.$_6b=A}),define(le[237],he([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V8b=void 0;function N(j,O,R,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!O){const d=j.filter(({id:c})=>!k.includes(c));return d.length?C.added=d:C=null,{local:g,remote:C}}const S=A(j,O,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const d=A(R,j,k),c=A(R,O,k);for(const $ of c.removed){const y=j.find(b=>b.id===$);y&&g.removed.push(y)}for(const $ of c.added){const y=O.find(b=>b.id===$);d.added.includes($)?S.updated.includes($)&&g.updated.push(y):g.added.push(y)}for(const $ of c.updated)g.updated.push(O.find(y=>y.id===$));for(const $ of d.added)c.added.includes($)||C.added.push(j.find(y=>y.id===$));for(const $ of d.updated)c.removed.includes($)||c.updated.includes($)||C.updated.push(j.find(y=>y.id===$));for(const $ of d.removed){const y=O.find(b=>b.id===$);y&&C.removed.push(y)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$V8b=N;function A(j,O,R){j=j?j.filter(({id:c})=>!R.includes(c)):[],O=O.filter(({id:c})=>!R.includes(c));const k=j.map(({id:c})=>c),g=O.map(({id:c})=>c),C=g.filter(c=>!k.includes(c)),S=k.filter(c=>!g.includes(c)),d=[];for(const{id:c,name:$,shortName:y,icon:b,useDefaultFlags:l}of j){if(S.includes(c))continue;const f=O.find(m=>m.id===c);(!f||f.name!==$||f.shortName!==y||f.icon!==b||!(0,D.$on)(f.useDefaultFlags,l))&&d.push(c)}return{added:C,removed:S,updated:d}}}),define(le[24],he([0,1,18,12,173,50,29,4,103,41]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gnb=e.$fnb=e.$enb=e.$dnb=e.$cnb=e.$bnb=e.$anb=e.$_mb=e.$$mb=e.$0mb=e.$9mb=e.MergeState=e.Change=e.SyncStatus=e.$8mb=e.$7mb=e.$6mb=e.UserDataSyncErrorCode=e.$5mb=e.$4mb=e.$3mb=e.$2mb=e.$1mb=e.$Zmb=e.$Ymb=e.$Xmb=e.$Wmb=e.SyncResource=e.$Vmb=e.$Umb=e.$Tmb=e.$Smb=e.$Rmb=e.$Qmb=void 0;function C(){const t=g.$wn.as(j.$Bn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Qmb=C;function S(){const t=g.$wn.as(j.$Bn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(w=>!!t[w].ignoreSync),a=Object.keys(t).filter(w=>t[w].scope===2||t[w].scope===6),v=C();return(0,D.$Mb)([...r,...a,...v])}e.$Rmb=S,e.$Smb="settingsSync",e.$Tmb="settingsSync.keybindingsPerPlatform";function d(){const t="vscode://schemas/ignoredSettings",r=g.$wn.as(j.$Bn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,A.localize)(0,null),type:"object",properties:{[e.$Tmb]:{type:"boolean",description:(0,A.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,A.localize)(2,null),items:[{type:"string",pattern:O.$bo,errorMessage:(0,A.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,A.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$wn.as(k.$xn.JSONContribution),v=()=>{const w=C(),u=S(),p=Object.keys(j.$Cn.properties).filter(F=>!u.includes(F)),I=u.filter(F=>!w.includes(F)),T={items:{type:"string",enum:[...p,...I.map(F=>`-${F}`)]}};a.registerSchema(t,T)};return r.onDidUpdateConfiguration(()=>v())}e.$Umb=d;function c(t){return t&&(0,N.$If)(t)&&(0,N.$Gf)(t.id)&&Array.isArray(t.scopes)}e.$Vmb=c;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Wmb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function y(t,...r){return t?[t,...r]:r}e.$Xmb=y;function b(t,r,a,v){return v.joinPath(a.userDataSyncHome,...y(t,r,`lastSync${r}.json`))}e.$Ymb=b,e.$Zmb=(0,R.$4h)("IUserDataSyncStoreManagementService"),e.$1mb=(0,R.$4h)("IUserDataSyncStoreService"),e.$2mb=(0,R.$4h)("IUserDataSyncLocalStoreService"),e.$3mb="x-operation-id",e.$4mb="X-Execution-Id";function l(t){const r={};return r[e.$4mb]=t,r}e.$5mb=l;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class m extends Error{constructor(r,a,v,w){super(r),this.code=a,this.resource=v,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$6mb=m;class h extends m{constructor(r,a,v,w,u){super(r,v,void 0,u),this.url=a,this.serverCode=w}}e.$7mb=h;class E extends m{constructor(r,a){super(r,a)}}e.$8mb=E,function(t){function r(a){if(a instanceof t)return a;const v=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(v&&v[1]){const w=v[2]==="unknown"?void 0:v[2],u=v[3]==="unknown"?void 0:v[3];return new t(a.message,v[1],w,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(m||(e.$6mb=m={}));var n;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var s;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(s||(e.MergeState=s={})),e.$9mb="sync.store.url.type";function i(t){return`sync.enable.${t}`}e.$0mb=i,e.$$mb=(0,R.$4h)("IUserDataSyncEnablementService"),e.$_mb=(0,R.$4h)("IUserDataSyncService"),e.$anb=(0,R.$4h)("IUserDataSyncResourceProviderService"),e.$bnb=(0,R.$4h)("IUserDataAutoSyncService"),e.$cnb=(0,R.$4h)("IUserDataSyncUtilService"),e.$dnb=(0,R.$4h)("IUserDataSyncLogService"),e.$enb="userDataSync",e.$fnb="vscode-userdata-sync",e.$gnb="preview"}),define(le[238],he([0,1,30,24]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pGb=void 0;function A(O,R,k,g,C){if(!R)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const S=j(O,R);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const d=k?j(k,R):{added:Object.keys(R).reduce((f,m)=>(f.add(m),f),new Set),removed:new Set,updated:new Set},c=k?j(k,O):{added:Object.keys(O).reduce((f,m)=>(f.add(m),f),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},y=D.$kn(R),b=!k;for(const f of c.added.values())f!==N.$9mb&&b&&d.added.has(f)||(y[f]=O[f]);for(const f of c.updated.values())y[f]=O[f];for(const f of c.removed.values())g.unregistered.includes(f)||delete y[f];for(const f of d.added.values()){const m=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(k&&c.added.has(f))continue;const h=O[f];h&&h.value===m.value||f===N.$9mb&&b&&c.added.has(f)||(h?$.updated[f]=m:$.added[f]=m)}for(const f of d.updated.values()){const m=R[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(c.updated.has(f)||c.removed.has(f))continue;const h=O[f];h&&h.value===m.value||($.updated[f]=m)}for(const f of d.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}c.updated.has(f)||c.removed.has(f)||$.removed.push(f)}const l=j(R,y);return{local:$,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:y}}}e.$pGb=A;function j(O,R){const k=Object.keys(O),g=Object.keys(R),C=g.filter(c=>!k.includes(c)).reduce((c,$)=>(c.add($),c),new Set),S=k.filter(c=>!g.includes(c)).reduce((c,$)=>(c.add($),c),new Set),d=new Set;for(const c of k){if(S.has(c))continue;const $=O[c],y=R[c];D.$on($,y)||d.add(c)}return{added:C,removed:S,updated:d}}}),define(le[239],he([0,1,18,35,86,42,30,79,24]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Eb=e.$0Eb=e.$9Eb=e.$8Eb=e.$7Eb=e.$6Eb=void 0;function g(a,v,w){let u=[];w?u=S(w):u=C(v);const p=[],I=[...(0,k.$Qmb)()];if(Array.isArray(u))for(const T of u)T.startsWith("-")?I.push(T.substring(1)):p.push(T);return(0,D.$Mb)([...a,...p].filter(T=>!I.includes(T)))}e.$6Eb=g;function C(a){let v=a.inspect("settingsSync.ignoredSettings").userValue;return v!==void 0||(v=a.inspect("sync.ignoredSettings").userValue,v!==void 0)?v:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const v=(0,N.$an)(a);return v?v["settingsSync.ignoredSettings"]||v["sync.ignoredSettings"]||[]:[]}function d(a,v){const w=(0,N.$an)(a)||{};let u="{}";for(const p of Object.keys(w)){const I=(0,A.$5T)(u,[p],w[p],v);u=(0,A.$8T)(u,I)}return u}e.$7Eb=d;function c(a,v,w,u){if(w.length){const p=r(v),I=(0,N.$an)(v)||{},T=(0,N.$an)(a);if(!T)return a;const F=[];for(const M of w){const z=I[M],Z=T[M];z===void 0?a=R.edit(a,[M],void 0,u):Z!==void 0?a=R.edit(a,[M],z,u):F.push(n(M,p))}F.sort((M,z)=>M.startOffset-z.startOffset),F.forEach(M=>a=f(M.setting.key,v,a,u))}return a}e.$8Eb=c;function $(a,v,w,u,p,I){const T=c(a,v,u,I),F=w!==T,M=w!==v;if(!F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!M)return{conflictsSettings:[],localContent:null,remoteContent:T,hasConflicts:!1};if(M&&!F)return{conflictsSettings:[],localContent:c(v,a,u,I),remoteContent:null,hasConflicts:!1};if(w===null&&b(a)){const L=y(a,v,u)?null:c(v,a,u,I);return{conflictsSettings:[],localContent:L,remoteContent:null,hasConflicts:!1}}let z=a,Z=v;const J=(0,N.$an)(a),x=(0,N.$an)(v),G=w?(0,N.$an)(w):null,Q=u.reduce((L,H)=>(L.add(H),L),new Set),V=l(J,x,Q),B=l(G,J,Q),te=l(G,x,Q),se=new Map,_=new Set,oe=L=>{_.add(L);const H=p.filter(({key:q})=>q===L)[0];H?(z=R.edit(z,[L],H.value,I),Z=R.edit(Z,[L],H.value,I)):se.set(L,{key:L,localValue:J[L],remoteValue:x[L]})};for(const L of B.removed.values())te.updated.has(L)?oe(L):Z=R.edit(Z,[L],void 0,I);for(const L of te.removed.values())_.has(L)||(B.updated.has(L)?oe(L):z=R.edit(z,[L],void 0,I));for(const L of B.updated.values())_.has(L)||(te.updated.has(L)?V.updated.has(L)&&oe(L):Z=R.edit(Z,[L],J[L],I));for(const L of te.updated.values())_.has(L)||(B.updated.has(L)?V.updated.has(L)&&oe(L):z=R.edit(z,[L],x[L],I));for(const L of B.added.values())_.has(L)||(te.added.has(L)?V.updated.has(L)&&oe(L):Z=f(L,z,Z,I));for(const L of te.added.values())_.has(L)||(B.added.has(L)?V.updated.has(L)&&oe(L):z=f(L,Z,z,I));const K=se.size>0||!y(z,Z,u),U=K||!y(z,a,[]),P=K||!y(Z,v,[]);return{localContent:U?z:null,remoteContent:P?Z:null,conflictsSettings:[...se.values()],hasConflicts:K}}e.$9Eb=$;function y(a,v,w){if(a===v)return!0;const u=(0,N.$an)(a),p=(0,N.$an)(v),I=w.reduce((M,z)=>(M.add(z),M),new Set),T=r(a).filter(M=>!(M.setting&&I.has(M.setting.key))),F=r(v).filter(M=>!(M.setting&&I.has(M.setting.key)));if(T.length!==F.length)return!1;for(let M=0;M<T.length;M++){const z=T[M],Z=F[M];if(z.setting&&Z.setting){if(z.setting.key!==Z.setting.key||!O.$on(u[z.setting.key],p[z.setting.key]))return!1}else if(!z.setting&&!Z.setting){if(z.value!==Z.value)return!1}else return!1}return!0}function b(a){return a?r(a).length===0:!0}e.$0Eb=b;function l(a,v,w){const u=a?Object.keys(a).filter(M=>!w.has(M)):[],p=Object.keys(v).filter(M=>!w.has(M)),I=p.filter(M=>!u.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),T=u.filter(M=>!p.includes(M)).reduce((M,z)=>(M.add(z),M),new Set),F=new Set;if(a)for(const M of u){if(T.has(M))continue;const z=a[M],Z=v[M];O.$on(z,Z)||F.add(M)}return{added:I,removed:T,updated:F}}function f(a,v,w,u){const p=(0,N.$an)(v),I=r(v),T=r(w),F=m(a,I,T);return h(w,a,p[a],F,T,u)}e.$$Eb=f;function m(a,v,w){const u=v.findIndex(I=>I.setting?.key===a),p=v[u-1];if(p){if(p.setting){const T=n(p.setting.key,w);if(T)return{index:w.indexOf(T),insertAfter:!0}}else{const T=o(u,v);if(T){const F=n(T.setting.key,w);if(F){const M=s(w.indexOf(F),w),z=i(v,T,v[u]);if(M){const Z=i(w,F,M),J=t(z,Z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.indexOf(M),insertAfter:!1}}else{const Z=i(w,F,w[w.length-1]),J=t(z,Z);return J?{index:w.indexOf(J),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const I=v[u+1];if(I)if(I.setting){const T=n(I.setting.key,w);if(T)return{index:w.indexOf(T),insertAfter:!1}}else{const T=s(u,v);if(T){const F=n(T.setting.key,w);if(F){const M=o(w.indexOf(F),w),z=i(v,v[u],T);if(M){const Z=i(w,M,F),J=t(z.reverse(),Z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:w.indexOf(M),insertAfter:!0}}else{const Z=i(w,w[0],F),J=t(z.reverse(),Z.reverse());return J?{index:w.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function h(a,v,w,u,p,I){let T;return u.index===-1?T=(0,A.$5T)(a,[v],w,I):T=E(a,v,w,u,p,I).map(F=>(0,A.$6T)(a,F,I)[0]),(0,A.$8T)(a,T)}function E(a,v,w,u,p,I){const T=`${JSON.stringify(v)}: ${JSON.stringify(w)}`,F=(0,j.$2T)(I,a),M=p[u.index];if(u.insertAfter){const z=[];if(M.setting)z.push({offset:M.endOffset,length:0,content:","+T});else{const Z=s(u.index,p),J=o(u.index,p),x=J?.setting?.commaOffset;J&&x===void 0&&z.push({offset:J.endOffset,length:0,content:","});const G=x!==void 0&&x>M.endOffset;z.push({offset:G?x+1:M.endOffset,length:0,content:Z?F+T+",":F+T})}return z}else{if(M.setting)return[{offset:M.startOffset,length:0,content:T+","}];const z=(p[u.index-1]&&!p[u.index-1].setting?F:"")+T+(s(u.index,p)?",":"")+F;return[{offset:M.startOffset,length:0,content:z}]}}function n(a,v){return v.filter(w=>w.setting?.key===a)[0]}function o(a,v){for(let w=a-1;w>=0;w--)if(v[w].setting)return v[w]}function s(a,v){for(let w=a+1;w<v.length;w++)if(v[w].setting)return v[w]}function i(a,v,w){const u=a.indexOf(v),p=a.indexOf(w);return a.filter((I,T)=>u<T&&T<p)}function t(a,v){if(a.length&&v.length){let w=0;for(;w<v.length&&w<a.length;w++)if(a[w].value!==v[w].value)return v[w-1];return v[w-1]}}function r(a){const v=[];let w=-1,u,p;const I={onObjectBegin:T=>{w++},onObjectProperty:(T,F,M)=>{w===0&&(u=F,p=T)},onObjectEnd:(T,F)=>{w--,w===0&&v.push({startOffset:u,endOffset:T+F,value:a.substring(u,T+F),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(T,F)=>{w++},onArrayEnd:(T,F)=>{w--,w===0&&v.push({startOffset:u,endOffset:T+F,value:a.substring(u,T+F),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(T,F,M)=>{w===0&&v.push({startOffset:u,endOffset:F+M,value:a.substring(u,F+M),setting:{key:p,commaOffset:void 0}})},onSeparator:(T,F,M)=>{if(w===0&&T===","){let z=v.length-1;for(;z>=0&&!v[z].setting;z--);const Z=v[z];Z&&v.splice(z,1,{startOffset:Z.startOffset,endOffset:Z.endOffset,value:Z.value,setting:{key:Z.setting.key,commaOffset:F}})}},onComment:(T,F)=>{w===0&&v.push({startOffset:T,endOffset:T+F,value:a.substring(T,T+F)})}};return(0,N.$hn)(a,I),v}}),define(le[80],he([0,1,3,2,4,24]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QEb=e.$PEb=void 0,e.$PEb=(0,A.$4h)("IUserDataSyncAccountService");let O=class extends N.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new D.$Td),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$Td),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$QEb=O,e.$QEb=O=ye([X(0,j.$1mb),X(1,j.$dnb)],O)}),define(le[240],he([0,1,2,10]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=e.$h_b=e.$g_b=e.$f_b=e.$e_b=e.$d_b=e.$c_b=void 0;class A{constructor(d){this.a=d}listen(d,c){switch(c){case"onError":return this.a.onError}throw new Error(`Event not found: ${c}`)}call(d,c,$){switch(c){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$c_b=A;class j{constructor(d){this.a=d}listen(d,c){throw new Error(`Event not found: ${c}`)}call(d,c,$){switch(c){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive($[0]))}throw new Error("Invalid call")}}e.$d_b=j;class O{constructor(d){this.a=d}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.a.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.a.call("resolveFormattingOptions",[d])}}e.$e_b=O;class R{constructor(d){this.a=d}listen(d,c){switch(c){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${c}`)}async call(d,c,$){switch(c){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$f_b=R;class k{constructor(d){this.a=d}listen(d,c){switch(c){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${c}`)}call(d,c,$){switch(c){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$g_b=k;class g{constructor(d){this.a=d}listen(d,c){switch(c){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${c}`)}call(d,c,$){switch(c){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$h_b=g;class C extends D.$Tc{constructor(d){super(),this.a=d,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.a.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.a.call("getPreviousUserDataSyncStore");return this.b(d)}b(d){return{url:N.URI.revive(d.url),type:d.type,defaultUrl:N.URI.revive(d.defaultUrl),insidersUrl:N.URI.revive(d.insidersUrl),stableUrl:N.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.$i_b=C}),define(le[241],he([0,1,19,174,14,8,24]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Gb=void 0;let R=class extends j.$qj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,D.$Fg)(C.logsHome,`${O.$enb}.log`),{id:O.$enb,name:(0,N.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$8Gb=R,e.$8Gb=R=ye([X(0,j.$mj),X(1,A.$$h)],R)}),define(le[242],he([0,1,6,3,2]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d$b=void 0;class j extends A.$Tc{constructor({onDidOpenMainWindow:R,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new A.$Sc),N.Event.latch(N.Event.any(R,k))(this.f,this,this.a),this.b=(0,D.$Rg)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$d$b=j}),define(le[112],he([0,1,177,16,47,19,10,4,23]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.WorkbenchState=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=void 0,e.$ai=(0,R.$4h)("contextService");function g(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.uri)}e.$bi=g;function C(i){return typeof i?.id=="string"&&!g(i)&&!d(i)}e.$ci=C,e.$di={id:"ext-dev"},e.$ei={id:"empty-window"};function S(i,t){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.$nc)(i)}:t?e.$di:e.$ei;const r=i;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$fi=S;function d(i){const t=i;return typeof t?.id=="string"&&O.URI.isUri(t.configPath)}e.$gi=d;function c(i){const t=i;if(t?.uri)return{id:t.id,uri:O.URI.revive(t.uri)};const r=i;if(r?.configPath)return{id:r.id,configPath:O.URI.revive(r.configPath)};if(i?.id)return{id:i.id}}e.$hi=c;var $;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function y(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ii=y;function b(i){const t=i;return!!(t&&typeof t=="object"&&O.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$ji=b;class l{constructor(t,r,a,v,w){this.h=t,this.j=a,this.k=v,this.l=w,this.c=A.$0h.forUris(this.l,()=>!0),this.folders=r}update(t){this.h=t.id,this.k=t.configuration,this.j=t.transient,this.l=t.l,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(t){this.k=t}getFolder(t){return t&&this.c.findSubstr(t)||null}n(){this.c=A.$0h.forUris(this.l,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$ki=l;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,j.$Fg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$li=f;function m(i){return new f({uri:i,index:0,name:(0,j.$Bg)(i)},{uri:i.toString()})}e.$mi=m,e.$ni="code-workspace",e.$oi=`.${e.$ni}`,e.$pi=[{name:(0,D.localize)(0,null),extensions:[e.$ni]}],e.$qi="workspace.json";function h(i,t){return j.$wg.isEqualOrParent(i,t.untitledWorkspacesHome)}e.$ri=h;function E(i){let t;return O.URI.isUri(i)?t=i:t=i.configuration,t?.scheme===k.Schemas.tmp}e.$si=E,e.$ti="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$ti}e.$ui=n;function o(i,t){return!h(i,t)&&!E(i)}e.$vi=o;function s(i){return(typeof i=="string"?(0,N.$oc)(i):(0,j.$Dg)(i))===e.$oi}e.$wi=s}),define(le[17],he([0,1,53,3,2,19,10,168,14,11,4,8,112,34,28,6,32,27,12]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.ProfileResourceType=void 0;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function h(i){const t=i;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&O.URI.isUri(t.location)&&O.URI.isUri(t.globalStorageHome)&&O.URI.isUri(t.settingsResource)&&O.URI.isUri(t.keybindingsResource)&&O.URI.isUri(t.tasksResource)&&O.URI.isUri(t.snippetsHome)&&O.URI.isUri(t.extensionsResource))}e.$Zk=h,e.$1k=(0,C.$4h)("IUserDataProfilesService");function E(i,t){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:O.URI.revive(i.location).with({scheme:t}),globalStorageHome:O.URI.revive(i.globalStorageHome).with({scheme:t}),settingsResource:O.URI.revive(i.settingsResource).with({scheme:t}),keybindingsResource:O.URI.revive(i.keybindingsResource).with({scheme:t}),tasksResource:O.URI.revive(i.tasksResource).with({scheme:t}),snippetsHome:O.URI.revive(i.snippetsHome).with({scheme:t}),extensionsResource:O.URI.revive(i.extensionsResource).with({scheme:t}),cacheHome:O.URI.revive(i.cacheHome).with({scheme:t}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$2k=E;function n(i,t,r,a,v,w){return{id:i,name:t,location:r,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:w&&v?.useDefaultFlags?.globalState?w.globalStorageHome:(0,j.$Fg)(r,"globalStorage"),settingsResource:w&&v?.useDefaultFlags?.settings?w.settingsResource:(0,j.$Fg)(r,"settings.json"),keybindingsResource:w&&v?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,j.$Fg)(r,"keybindings.json"),tasksResource:w&&v?.useDefaultFlags?.tasks?w.tasksResource:(0,j.$Fg)(r,"tasks.json"),snippetsHome:w&&v?.useDefaultFlags?.snippets?w.snippetsHome:(0,j.$Fg)(r,"snippets"),extensionsResource:w&&v?.useDefaultFlags?.extensions?w.extensionsResource:(0,j.$Fg)(r,"extensions.json"),cacheHome:(0,j.$Fg)(a,i),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}e.$3k=n;let o=class extends A.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,v){super(),this.t=t,this.u=r,this.w=a,this.y=v,this.f=!0,this.h=this.B(new N.$Td),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Td),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Td),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Td),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new c.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Fg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Fg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,f.$Gf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}r.push(n((0,j.$Cg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},t))}}catch(w){this.y.error(w)}const a=new c.$Ac,v=new Map;if(r.length)try{const w=this.Q();if(w.workspaces)for(const[u,p]of Object.entries(w.workspaces)){const I=O.URI.parse(u),T=r.find(F=>F.id===p);T&&a.set(I,T)}if(w.emptyWindows)for(const[u,p]of Object.entries(w.emptyWindows)){const I=r.find(T=>T.id===p);I&&v.set(u,I)}}catch(w){this.y.error(w)}this.z={profiles:r,workspaces:a,emptyWindows:v}}return this.z}D(){const t=n("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,l.$Me)(r)}\\s(\\d+)`);let v=0;for(const u of this.profiles){const p=a.exec(u.name),I=p?parseInt(p[1]):0;v=I>v?I:v}const w=`${r} ${v+1}`;return this.createProfile((0,D.$Ri)((0,b.$og)()).toString(16),w,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,D.$Ri)((0,b.$og)()).toString(16),t,r,a)}async createProfile(t,r,a,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(t,r,a);return v&&await this.setProfileForWorkspace(v,w),w}async F(t,r,a){if(!(0,f.$Gf)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(r);return v||(v=(async()=>{try{const w=this.profiles.find(I=>I.name===r||I.id===t);if(w)return w;const u=n(t,r,(0,j.$Fg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(I){p.push(I)}}),await y.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,v)),v}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(v=>v.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=n(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(v=>v.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(v){a.push(v)}});try{await Promise.allSettled(a)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(v){(0,g.$Fk)(v)!==1&&this.y.error(v)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(v=>v.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return O.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,d.$bi)(t)?t.uri:(0,d.$gi)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const v=[...this.profiles,...t],w=[];this.s.profiles=[];for(let u of v)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):w.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(w),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const v=this.G(t),w=a?this.s:this.C;O.URI.isUri(v)?(w.workspaces.delete(v),r&&w.workspaces.set(v,r)):(w.emptyWindows.delete(v),r&&w.emptyWindows.set(v,r)),a||this.M()}M(){const t={};for(const[a,v]of this.C.workspaces.entries())t[a.toString()]=v.id;const r={};for(const[a,v]of this.C.emptyWindows.entries())r[a.toString()]=v.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[w,u]of Object.entries(t.workspaces)){const p=O.URI.parse(u);r[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const v={};if(t.emptyWindows)for(const[w,u]of Object.entries(t.emptyWindows)){const p=O.URI.parse(u);v[w]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:v}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$4k=o,e.$4k=o=ye([X(0,k.$$h),X(1,g.$ok),X(2,$.$Yk),X(3,S.$lj)],o);class s extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$5k=s}),define(le[243],he([0,1,6,2,17]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0;let j=class extends N.$Tc{constructor(R){super(),this.B(new D.$dh(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$q_b=j,e.$q_b=j=ye([X(0,A.$1k)],j)}),define(le[244],he([0,1,18,6,26,7,3,2,5,12,10,151,29,33,44,8,25,22,28,17]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ip=e.$Hp=e.$Gp=e.$Fp=void 0;let h=class extends R.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,v,w,u){super(),this.z=t,this.C=r,this.D=a,this.F=v,this.G=w,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$Td),this.s=this.B(new O.$Td),this.t=this.B(new O.$Td),this.u=this.B(new O.$Td),this.w=this.B(new O.$Td),this.y=[],this.B((0,R.$Rc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,d.$lo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const v=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:w})=>(0,c.$Po)(w,t.identifier));if(v?.local)return v?.local;throw v?.error?v.error:n(new Error(`Unknown error while installing extension ${t.identifier.id}`))}catch(a){throw n(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new d.$oo(S.localize(0,null),d.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(t.map(async({extension:v,options:w})=>{try{const u=await this.O(v,!!w?.installGivenVersion,!!w?.installPreReleaseVersion);a.push({...u,options:w})}catch(u){r.push({identifier:v.identifier,operation:2,source:v,error:u})}})),a.length&&r.push(...await this.I(a));for(const v of r)v.error&&(this.F.error("Failed to install extension.",v.identifier.id),this.F.error(v.error),v.source&&!C.URI.isUri(v.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,c.$Xo)(v.source),error:v.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$mm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const v of this.H.profiles){const w=(await this.getInstalled(1,v.extensionsResource)).find(u=>(0,c.$Po)(u.identifier,t.identifier));w?this.w.fire(w):this.u.fire({identifier:t.identifier,profileLocation:v.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const v=await this.J(a,(w,u)=>t.some(p=>(0,c.$To)(u.identifier.id)===(0,c.$Uo)(p.manifest.publisher,p.manifest.name))?!1:this.L(w,u));r.push(...v)}catch(v){r.push({identifier:{id:(0,c.$Uo)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:v})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},v){const w=a.isApplicationScoped||a.isBuiltin||(0,$.$mm)(t),u={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},p=Z=>`${c.$Qo.create(Z).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Z=this.j.get(p(r));if(Z)return this.F.info("Extensions is already requested to install",r.identifier.id),await Z.task.waitUntilTaskIsFinished(),[]}const I=[],T=[],F=[],M=this.Z(t,r,u);C.URI.isUri(r)||this.j.set(p(r),{task:M,waitingTasks:[]}),this.n.fire({identifier:M.identifier,source:r,profileLocation:u.profileLocation}),this.F.info("Installing extension:",M.identifier.id),I.push({task:M,manifest:t});let z=!1;try{if(u.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const J=await this.N(M.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),x=await this.getInstalled(void 0,u.profileLocation),G={...u,donotIncludePackAndDependencies:!0,context:{...u.context,[d.$go]:!0}};for(const{gallery:Q,manifest:V}of(0,D.$Mb)(J,({gallery:B})=>B.identifier.id)){z=z||!!V.extensionDependencies?.some(se=>(0,c.$Po)({id:se},M.identifier));const B=p(Q),te=this.j.get(B);if(te){if(v(M,te.task)){const se=te.task.identifier;this.F.info("Waiting for already requested installing extension",se.id,M.identifier.id),te.waitingTasks.push(M),T.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,_=>_.some(oe=>(0,c.$Po)(oe.identifier,se)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",se.id,M.identifier.id),!_.find(K=>(0,c.$Po)(K.identifier,se))?.local)throw new Error(`Extension ${se.id} is not installed`)}))}}else if(!x.some(({identifier:se})=>(0,c.$Po)(se,Q.identifier))){const se=this.Z(V,Q,G);this.j.set(B,{task:se,waitingTasks:[M]}),this.n.fire({identifier:se.identifier,source:Q,profileLocation:u.profileLocation}),this.F.info("Installing extension:",se.identifier.id,M.identifier.id),I.push({task:se,manifest:V})}}}catch(J){if(C.URI.isUri(M.source))(0,D.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",M.identifier.id,J.message),(0,D.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",M.identifier.id,J.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),J}const Z=I.reduce((J,{task:x,manifest:G})=>(J.set(x.identifier.id.toLowerCase(),{task:x,manifest:G}),J),new Map);for(;Z.size;){let J;const x=[...Z.values()].filter(({manifest:G})=>!G.extensionDependencies?.some(Q=>Z.has(Q.toLowerCase())));x.length?J=Z.size===1?x:x.filter(({task:G})=>!(G===M&&!z)):(this.F.info("Found extensions with circular dependencies",x.map(({task:G})=>G.identifier.id)),J=[...Z.values()]),await this.M(J.map(async({task:G})=>{const Q=new Date().getTime();try{const V=await G.run();if(await this.M(this.y.map(B=>B.postInstall(V,G.source,u,A.CancellationToken.None))),!C.URI.isUri(G.source)){const B=G.operation===3,te=B?void 0:(new Date().getTime()-G.source.lastUpdated)/1e3;if(o(this.C,B?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Xo)(G.source),verificationStatus:G.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:te}),k.$o&&G.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}F.push({local:V,identifier:G.identifier,operation:G.operation,source:G.source,context:G.options.context,profileLocation:G.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){throw C.URI.isUri(G.source)||o(this.C,G.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,c.$Xo)(G.source),verificationStatus:G.verificationStatus,duration:new Date().getTime()-Q,error:V}),this.F.error("Error while installing the extension:",G.identifier.id),V}finally{Z.delete(G.identifier.id.toLowerCase())}}))}return T.length&&await this.M(T),F.forEach(({identifier:J})=>this.F.info("Extension installed successfully:",J.id)),F}catch(Z){if(I.forEach(({task:J})=>J.cancel()),F.length)try{const J=await Promise.allSettled(F.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let x=0;x<J.length;x++){const G=J[x],{identifier:Q}=F[x];G.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,j.$0)(G.reason))}}catch(J){this.F.warn("Error while rolling back extensions",(0,j.$0)(J),F.map(({identifier:x})=>x.id))}return I.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:u.context,profileLocation:u.profileLocation,error:Z}))}finally{for(const{task:Z}of I)Z.source&&!C.URI.isUri(Z.source)&&this.j.delete(p(Z.source))}}L(t,r){for(const[,{task:a,waitingTasks:v}]of this.j.entries())if(a===t&&(v.includes(r)||v.some(w=>this.L(w,r)))||a===r&&v[0]&&!this.L(t,v[0]))return!1;return!0}async M(t){const r=[],a=[],v=await Promise.allSettled(t);for(const w of v)w.status==="fulfilled"?r.push(w.value):a.push(w.reason);if(a.length)throw E(a);return r}async N(t,r,a,v,w){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,w),p=[],I=[],T=async(F,M)=>{p.push(F);const z=M.extensionDependencies||[],Z=[...z];if(M.extensionPack){const J=a?u.find(x=>(0,c.$Po)(x.identifier,F)):void 0;for(const x of M.extensionPack)J&&J.manifest.extensionPack&&J.manifest.extensionPack.some(G=>(0,c.$Po)({id:G},{id:x}))||Z.every(G=>!(0,c.$Po)({id:G},{id:x}))&&Z.push(x)}if(Z.length){const J=Z.filter(x=>p.every(G=>!(0,c.$Po)(G,{id:x})));if(J.length){const x=await this.z.getExtensions(J.map(G=>({id:G,preRelease:v})),A.CancellationToken.None);for(const G of x){if(p.find(B=>(0,c.$Po)(B,G.identifier)))continue;const Q=z.some(B=>(0,c.$Po)({id:B},G.identifier));let V;try{V=await this.O(G,!1,v)}catch(B){if(Q)throw B;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,j.$0)(B));continue}I.push({gallery:V.extension,manifest:V.manifest}),await T(V.extension.identifier,V.manifest)}}}};return await T(t,r),I}async O(t,r,a){let v;const w=await this.getExtensionsControlManifest();if(w.malicious.some(I=>(0,c.$Po)(t.identifier,I)))throw new d.$oo(S.localize(1,null,t.identifier.id),d.ExtensionManagementErrorCode.Malicious);const u=w.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),v=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0],!v)throw new d.$oo(S.localize(2,null,t.identifier.id,u.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const I=await this.getTargetPlatform();throw new d.$oo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,d.$ho)(I)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(v=await this.P(t,r,a),!v)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],A.CancellationToken.None))[0]?new d.$oo(S.localize(4,null,t.displayName??t.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$oo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",v.identifier.id);const p=await this.z.getManifest(v,A.CancellationToken.None);if(p===null)throw new d.$oo(`Missing manifest for extension ${v.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(p.version!==v.version)throw new d.$oo(`Cannot install '${v.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:v,manifest:p}}async P(t,r,a){const v=await this.getTargetPlatform();let w=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(w=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null),!w&&await this.z.isExtensionCompatible(t,a,v)&&(w=t),w||(r?w=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:v,compatible:!0},A.CancellationToken.None))[0]||null:w=await this.z.getCompatibleExtension(t,a,v)),w}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},v=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,w=this.m.get(v(t.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),w.waitUntilTaskIsFinished();const u=F=>{const M=this.$(F,a);return this.m.set(v(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.t.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),M},p=(F,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,c.$Wo)(F),error:M}),this.u.fire({identifier:F.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},I=[],T=[];try{I.push(u(t));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.U(t,F);for(const z of M)this.m.has(v(z.identifier))?this.F.info("Extensions is already requested to uninstall",z.identifier.id):I.push(u(z))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(I.map(M=>M.extension),F,t),await this.M(I.map(async M=>{try{if(await M.run(),await this.M(this.y.map(z=>z.postUninstall(M.extension,a,A.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}p(M.extension)}catch(z){const Z=z instanceof d.$oo?z:new d.$oo((0,j.$0)(z),d.ExtensionManagementErrorCode.Internal);throw p(M.extension,Z),Z}finally{T.push(M)}}))}catch(F){const M=F instanceof d.$oo?F:new d.$oo((0,j.$0)(F),d.ExtensionManagementErrorCode.Internal);for(const z of I){try{z.cancel()}catch{}T.includes(z)||p(z.extension,M)}throw M}finally{for(const F of I)this.m.delete(v(F.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}R(t,r,a){for(const v of t){const w=this.W(v,r);if(w.length){const u=w.filter(p=>!t.some(I=>(0,c.$Po)(I.identifier,p.identifier)));if(u.length)throw new Error(this.S(v,u,a))}}}S(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const v=t.manifest.extensionPack?t.manifest.extensionPack:[];if(v.length){const w=r.filter(p=>!p.isBuiltin&&v.some(I=>(0,c.$Po)({id:I},p.identifier))),u=[];for(const p of w)u.push(...this.U(p,r,a));return[...w,...u]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(v=>(0,c.$Po)({id:v},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Fp=h,e.$Fp=h=ye([X(0,d.$no),X(1,l.$sl),X(2,f.$Yk),X(3,y.$lj),X(4,b.$Dj),X(5,m.$1k)],h);function E(i){const t=Array.isArray(i)?i:[i];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Gp=E;function n(i){if(i instanceof d.$oo)return i;const t=new d.$oo(i.message,d.ExtensionManagementErrorCode.Internal);return t.stack=i.stack,t}e.$Hp=n;function o(i,t,{extensionData:r,verificationStatus:a,duration:v,error:w,durationSinceUpdate:u}){let p,I;(0,g.$Of)(a)&&(a===!0?a="Verified":(a===!1||(p=d.ExtensionManagementErrorCode.Signature,I=a),a="Unverified")),w&&(w instanceof d.$oo?(p=w.code,w.code===d.ExtensionManagementErrorCode.Signature&&(I=w.message)):p=d.ExtensionManagementErrorCode.Internal),i.publicLog(t,{...r,verificationStatus:a,success:!w,duration:v,errorcode:p,errorcodeDetail:I,durationSinceUpdate:u})}class s{constructor(){this.d=new N.$3g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.$Rg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$Rg)(t=>new Promise((r,a)=>{const v=t.onCancellationRequested(()=>{v.dispose(),a(new j.$5)})})),this.d.open()),this.g.cancel()}}e.$Ip=s}),define(le[51],he([0,1,6,15,2,3,34,10,29,33,11,4,8,17,28,12,7,22]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class m extends Error{constructor(s,i){super(s),this.code=i}}e.$Jp=m,e.$Kp=(0,S.$4h)("IExtensionsProfileScannerService");let h=class extends A.$Tc{constructor(s,i,t,r,a,v){super(),this.j=s,this.m=i,this.n=t,this.r=r,this.s=a,this.t=v,this.b=this.B(new j.$Td),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Td),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Td),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Td),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i){const t=[],r=[];try{return await this.u(i,a=>{const v=[];for(const w of a)s.some(([u])=>(0,g.$Po)(u.identifier,w.identifier)&&u.manifest.version!==w.version)?t.push(w):v.push(w);for(const[w,u]of s){const p=v.findIndex(T=>(0,g.$Po)(T.identifier,w.identifier)&&T.version===w.manifest.version),I={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:u};p===-1?(r.push(I),v.push(I)):v.splice(p,1,I)}return r.length&&this.b.fire({extensions:r,profileLocation:i}),t.length&&this.f.fire({extensions:t,profileLocation:i}),v}),r.length&&this.c.fire({extensions:r,profileLocation:i}),t.length&&this.g.fire({extensions:t,profileLocation:i}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:i}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:i}),a}}async updateMetadata(s,i){const t=[];return await this.u(i,r=>{const a=[];for(const v of r){const w=s.find(([u])=>(0,g.$Po)(u.identifier,v.identifier)&&u.manifest.version===v.version);w&&(v.metadata={...v.metadata,...w[1]},t.push(v)),a.push(v)}return a}),t}async removeExtensionFromProfile(s,i){const t=[];try{await this.u(i,r=>{const a=[];for(const v of r)(0,g.$Po)(v.identifier,s.identifier)?t.push(v):a.push(v);return t.length&&this.f.fire({extensions:t,profileLocation:i}),a}),t.length&&this.g.fire({extensions:t,profileLocation:i})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:i}),r}}async u(s,i,t){return this.F(s).queue(async()=>{let r=[],a;try{const v=await this.m.readFile(s);a=JSON.parse(v.value.toString().trim()||"[]")}catch(v){if((0,C.$Fk)(v)!==1)throw v;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new m((0,b.$0)(v),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(s);let v=!1;for(const w of a){E(w)||this.w(s);let u;if((0,y.$Gf)(w.relativeLocation)&&w.relativeLocation)u=this.z(w.relativeLocation);else if((0,y.$Gf)(w.location))u=this.z(w.location),v=!0,w.relativeLocation=w.location,w.location=u.toJSON();else{u=R.URI.revive(w.location);const p=this.y(u);p&&(v=!0,w.relativeLocation=p)}r.push({identifier:w.identifier,location:u,version:w.version,metadata:w.metadata})}v&&await this.m.writeFile(s,N.$he.fromString(JSON.stringify(a)))}if(i){r=i(r);const v=r.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.y(w.location),metadata:w.metadata}));await this.m.writeFile(s,N.$he.fromString(JSON.stringify(v)))}return r})}w(s){const i=new m(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(s)).value.toString()}catch(a){if((0,C.$Fk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",s.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(v=>E(v))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$he.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Fk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(s)}catch(a){(0,C.$Fk)(a)!==1&&this.t.error(a)}try{await this.m.del(i)}catch(a){(0,C.$Fk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(s){let i=this.h.get(s);return i||(i=new D.$$g,this.h.set(s,i)),i}};e.$Lp=h,e.$Lp=h=ye([X(1,C.$ok),X(2,c.$1k),X(3,$.$Yk),X(4,l.$sl),X(5,d.$lj)],h);function E(o){return(0,y.$If)(o)&&(0,k.$mo)(o.identifier)&&(n(o.location)||(0,y.$Gf)(o.location)&&o.location)&&((0,y.$Nf)(o.relativeLocation)||(0,y.$Gf)(o.relativeLocation))&&o.version&&(0,y.$Gf)(o.version)}function n(o){return o?(0,y.$Gf)(o.path)&&(0,y.$Gf)(o.scheme):!1}}),define(le[81],he([0,1,18,6,30,15,7,35,137,2,23,16,5,19,55,89,12,10,154,14,33,44,70,11,4,8,25,3,65,51,17,28,182]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o,s,i,t,r,a,v,w,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=e.$Qp=e.$Pp=e.$Op=e.Translations=void 0;var I;(function(x){function G(Q,V){if(Q===V)return!0;const B=Object.keys(Q),te=new Set;for(const se of Object.keys(V))te.add(se);if(B.length!==te.size)return!1;for(const se of B){if(Q[se]!==V[se])return!1;te.delete(se)}return te.size===0}x.equals=G})(I||(e.Translations=I={})),e.$Op=(0,s.$4h)("IExtensionsScannerService");let T=class extends g.$Tc{constructor(G,Q,V,B,te,se,_,oe,K,U,P,L){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=Q,this.r=V,this.s=B,this.t=te,this.u=se,this.w=_,this.y=oe,this.z=K,this.C=U,this.D=P,this.F=L,this.g=this.B(new r.$Td),this.onDidChangeCache=this.g.event,this.h=(0,c.$Fg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(z,this.s,this.h)),this.m=this.B(this.F.createInstance(z,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$1o)(this.w,this.y)),this.G}async scanAllExtensions(G,Q,V){const[B,te]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(Q)]),se=V?await this.scanExtensionsUnderDevelopment(G,[...B,...te]):[];return this.L(B,te,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const Q=[];Q.push(this.M(!!G.useCache,G.language)),Q.push(this.N(G.language,!!G.checkControlFile));const[V,B]=await Promise.all(Q);return this.J([...V,...B],0,G,!1)}async scanUserExtensions(G){const Q=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.P(Q,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,V),te=G.useCache&&!B.devMode&&B.excludeObsolete?this.m:this.n;let se;try{se=await te.scanExtensions(B)}catch(_){if(_ instanceof v.$Jp&&_.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await te.scanExtensions(B);else throw _}return se=await this.J(se,1,G,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(G,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(B=>B.scheme===C.Schemas.file).map(async B=>{const te=await this.P(B,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(te)).map(_=>(_.type=Q.find(oe=>(0,h.$Po)(oe.identifier,_.identifier))?.type??_.type,this.n.validate(_,te)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,Q,V){const B=await this.P(G,!1,Q,!0,V.language,!0,void 0),te=await this.n.scanExtension(B);return!te||!V.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(G,Q,V){const B=await this.P(G,!1,Q,!0,V.language,!0,void 0),te=await this.n.scanOneOrMultipleExtensions(B);return this.J(te,Q,V,!0)}async scanMetadata(G){const Q=(0,c.$Fg)(G,"package.json"),V=(await this.w.readFile(Q)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,Q){const V=(0,c.$Fg)(G,"package.json"),B=(await this.w.readFile(V)).value.toString(),te=JSON.parse(B);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,te.__metadata={...te.__metadata,...Q},await this.w.writeFile((0,c.$Fg)(G,"package.json"),j.$he.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof v.$Jp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$he.fromString(JSON.stringify([])))}catch(Q){(0,o.$Fk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,Q,V,B){return V.includeAllVersions||(G=this.L(Q===0?G:void 0,Q===1?G:void 0,Q==="development"?G:void 0,await this.getTargetPlatform(),B)),V.includeInvalid||(G=G.filter(te=>te.isValid)),G.sort((te,se)=>{const _=S.$nc(te.location.fsPath),oe=S.$nc(se.location.fsPath);return _<oe?-1:_>oe?1:0})}L(G,Q,V,B,te){const se=(oe,K,U)=>{if(oe.isValid&&!K.isValid)return!1;if(oe.isValid===K.isValid){if(te&&$.gt(oe.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${oe.location.path} with version ${oe.manifest.version}`),!1;if($.eq(oe.manifest.version,K.manifest.version)){if(oe.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${oe.location.path} with same version`),!1;if(oe.targetPlatform===B)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${oe.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${oe.location.path} with ${K.location.path}.`),!0},_=new E.$lm;return G?.forEach(oe=>{const K=_.get(oe.identifier.id);(!K||se(K,oe,!1))&&_.set(oe.identifier.id,oe)}),Q?.forEach(oe=>{const K=_.get(oe.identifier.id);if(!K&&G&&oe.type===0){this.y.debug(`Skipping obsolete system extension ${oe.location.path}.`);return}(!K||se(K,oe,!1))&&_.set(oe.identifier.id,oe)}),V?.forEach(oe=>{const K=_.get(oe.identifier.id);(!K||se(K,oe,!0))&&_.set(oe.identifier.id,oe),_.set(oe.identifier.id,oe)}),[..._.values()]}async M(G,Q){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),te=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",te.length),te}async N(G,Q){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const B=Q?await this.O():{},te=[],se=l.URI.file(S.$hc(S.$jc(C.$mg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const oe of V){const K=B[oe.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":te.push((0,c.$Fg)(se,oe.name));break;default:te.push(l.URI.file(K));break}}const _=await Promise.all(te.map(async oe=>this.n.scanExtension(await this.P(oe,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",_.length),(0,D.$Hb)(_)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,Q,V,B,te,se,_){const oe=await this.f(te??d.$w),K=await this.Q(G),U=Q&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,P=U?await this.Q(U):void 0;return new F(G,K,U,P,Q,_,V,B,se,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,te,oe)}async Q(G){try{const Q=await this.w.stat(G);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$Pp=T,e.$Pp=T=ye([X(4,w.$1k),X(5,v.$Kp),X(6,o.$ok),X(7,i.$lj),X(8,m.$$h),X(9,t.$Dj),X(10,u.$Yk),X(11,s.$3h)],T);class F{constructor(G,Q,V,B,te,se,_,oe,K,U,P,L,H,q,ee){this.location=G,this.mtime=Q,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=B,this.profile=te,this.profileScanOptions=se,this.type=_,this.excludeObsolete=oe,this.validate=K,this.productVersion=U,this.productDate=P,this.productCommit=L,this.devMode=H,this.language=q,this.translations=ee}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,Q){return(0,c.$yg)(G.location,Q.location)&&G.mtime===Q.mtime&&(0,c.$yg)(G.applicationExtensionslocation,Q.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&G.profile===Q.profile&&A.$on(G.profileScanOptions,Q.profileScanOptions)&&G.type===Q.type&&G.excludeObsolete===Q.excludeObsolete&&G.validate===Q.validate&&G.productVersion===Q.productVersion&&G.productDate===Q.productDate&&G.productCommit===Q.productCommit&&G.devMode===Q.devMode&&G.language===Q.language&&I.equals(G.translations,Q.translations)}}e.$Qp=F;let M=class extends g.$Tc{constructor(G,Q,V,B,te){super(),this.f=G,this.g=Q,this.h=V,this.j=B,this.m=te}async scanExtensions(G){const Q=G.profile?await this.r(G):await this.n(G);let V={};if(G.excludeObsolete&&G.type===1)try{const B=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(B)}catch{}return(0,b.$Tf)(V)?Q:Q.filter(B=>!V[h.$Qo.create(B).toString()])}async n(G){const Q=await this.j.resolve(G.location);if(!Q.children?.length)return[];const V=await Promise.all(Q.children.map(async B=>{if(!B.isDirectory||G.type===1&&(0,c.$Cg)(B.resource).indexOf(".")===0)return null;const te=new F(B.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(te)}));return(0,D.$Hb)(V).sort((B,te)=>B.location.path<te.location.path?-1:1)}async r(G){let Q=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){Q=Q.filter(B=>!B.metadata?.isApplicationScoped);const V=await this.s(G.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,G);Q.push(...V)}return Q}async s(G,Q,V){const B=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!B.length)return[];const te=await Promise.all(B.map(async se=>{if(Q(se)){const _=new F(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(_,se.metadata)}return null}));return(0,D.$Hb)(te)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,c.$Fg)(G.location,"package.json"))){const Q=await this.scanExtension(G);return Q?[Q]:[]}else return await this.scanExtensions(G)}catch(Q){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,O.$0)(Q)),[]}}async scanExtension(G,Q){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=E.$fm),Q=Q??V.__metadata,delete V.__metadata;const B=(0,h.$Uo)(V.publisher,V.name),te=Q?.id?{id:B,uuid:Q.id}:{id:B},se=Q?.isSystem?0:G.type,_=se===0||!!Q?.isBuiltin;V=await this.t(G.location,V,F.createNlsConfiguration(G));const oe={type:se,identifier:te,manifest:V,location:G.location,isBuiltin:_,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return G.validate?this.validate(oe,G):oe}}catch(V){G.type!==0&&this.m.error(V)}return null}validate(G,Q){let V=!0;const B=(0,n.$6o)(Q.productVersion,Q.productDate,Q.location,G.manifest,G.isBuiltin);for(const[te,se]of B)te===y.default.Error&&(V=!1,this.m.error(this.z(Q.location,se)));return G.isValid=V,G.validations=B,G}async scanExtensionManifest(G){const Q=(0,c.$Fg)(G,"package.json");let V;try{V=(await this.j.readFile(Q)).value.toString()}catch(te){return(0,o.$Fk)(te)!==1&&this.m.error(this.z(G,(0,f.localize)(0,null,Q.path,te.message))),null}let B;try{B=JSON.parse(V)}catch{const se=[];(0,R.$an)(V,se);for(const _ of se)this.m.error(this.z(G,(0,f.localize)(1,null,Q.path,_.offset,_.length,(0,k.$Mp)(_.error))));return null}return(0,R.$jn)(B)!=="object"?(this.m.error(this.z(G,(0,f.localize)(2,null,Q.path))),null):B}async t(G,Q,V){const B=await this.u(G,Q,V);if(B)try{const te=[],se=await this.w(B.default,te);if(te.length>0)return te.forEach(oe=>{this.m.error(this.z(G,(0,f.localize)(3,null,B.default?.path,(0,k.$Mp)(oe.error))))}),Q;if((0,R.$jn)(B)!=="object")return this.m.error(this.z(G,(0,f.localize)(4,null,B.default?.path))),Q;const _=B.values||Object.create(null);return(0,p.$Np)(this.m,Q,_,se)}catch{}return Q}async u(G,Q,V){const B=(0,c.$Fg)(G,"package.nls.json"),te=(K,U)=>{U.forEach(P=>{this.m.error(this.z(G,(0,f.localize)(5,null,K?.path,(0,k.$Mp)(P.error))))})},se=K=>{this.m.error(this.z(G,(0,f.localize)(6,null,K?.path)))},_=`${Q.publisher}.${Q.name}`,oe=V.translations[_];if(oe)try{const K=l.URI.file(oe),U=(await this.j.readFile(K)).value.toString(),P=[],L=(0,R.$an)(U,P);return P.length>0?(te(K,P),{values:void 0,default:B}):(0,R.$jn)(L)!=="object"?(se(K),{values:void 0,default:B}):{values:L.contents?L.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.j.exists(B))return;let U;try{U=await this.y(G,V)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const P=(await this.j.readFile(U.localized)).value.toString(),L=[],H=(0,R.$an)(P,L);return L.length>0?(te(U.localized,L),{values:void 0,default:U.original}):(0,R.$jn)(H)!=="object"?(se(U.localized),{values:void 0,default:U.original}):{values:H,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(G,Q){if(G)try{const V=(await this.j.readFile(G)).value.toString();return(0,R.$an)(V,Q)}catch{}}y(G,Q){return new Promise((V,B)=>{const te=se=>{const _=(0,c.$Fg)(G,`package.nls.${se}.json`);this.j.exists(_).then(oe=>{oe&&V({localized:_,original:(0,c.$Fg)(G,"package.nls.json")});const K=se.lastIndexOf("-");K===-1?V({localized:(0,c.$Fg)(G,"package.nls.json"),original:null}):(se=se.substring(0,K),te(se))})};if(Q.devMode||Q.pseudo||!Q.language)return V({localized:(0,c.$Fg)(G,"package.nls.json"),original:null});te(Q.language)})}z(G,Q){return`[${G.path}]: ${Q}`}};M=ye([X(1,v.$Kp),X(2,u.$Yk),X(3,o.$ok),X(4,i.$lj)],M);let z=class extends M{constructor(G,Q,V,B,te,se,_){super(Q,B,te,se,_),this.G=G,this.H=V,this.D=this.B(new N.$2g(3e3)),this.F=this.B(new r.$Td),this.onDidChangeCache=this.F.event}async scanExtensions(G){const Q=this.M(G),V=await this.I(Q);if(this.C=G,V&&V.input&&F.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),V.result.map(te=>(te.location=l.URI.revive(te.location),te));const B=await super.scanExtensions(G);return await this.J(Q,{input:G,result:B}),B}async I(G){try{const Q=await this.j.readFile(G),V=JSON.parse(Q.value.toString());return{result:V.result,input:(0,a.$Ah)(V.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",G.path,(0,O.$0)(Q))}return null}async J(G,Q){try{await this.j.writeFile(G,j.$he.fromString(JSON.stringify(Q)))}catch(V){this.m.debug("Error while writing the extension cache file:",G.path,(0,O.$0)(V))}}async L(){if(!this.C)return;const G=this.M(this.C),Q=await this.I(G);if(!Q)return;const V=Q.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!A.$on(B,V))try{this.m.info("Invalidating Cache",V,B),await this.j.del(G),this.F.fire()}catch(te){this.m.error(te)}}M(G){const Q=this.N(G);return this.h.extUri.joinPath(Q.cacheHome,G.type===0?E.$em:E.$dm)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(G.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};z=ye([X(2,w.$1k),X(3,v.$Kp),X(4,u.$Yk),X(5,o.$ok),X(6,i.$lj)],z);function Z(x,G){const Q=(0,h.$So)(x.manifest.publisher,x.manifest.name);return{id:Q,identifier:new E.$jm(Q),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:G,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$Rp=Z;class J extends T{constructor(G,Q,V,B,te,se,_,oe,K,U,P,L){super(G,Q,(0,c.$Fg)(V,".vscode-oss-dev","extensions","control.json"),B,te,se,_,oe,K,U,P,L),this.R=(async()=>{if(d.$z)try{const H=await this.w.readFile(l.URI.file(d.$z));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$Sp=J}),define(le[245],he([0,1,66,6,38,3,2,23,16,31,8,17]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=void 0;let d=class extends O.$Tc{constructor($,y){super(),this.b=$,this.f=y,this.a=new N.$0g(5)}async postUninstall($){const y=this.g($,"uninstall");y&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(b)}}));try{await g.Promises.rm(this.m($))}catch(b){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(b)}}g($,y){const b=`vscode:${y}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[b]=="string"){const l=$.manifest.scripts[b].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${b} should be a node script`),null):{script:(0,k.$jc)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,y,b,l,f){return new Promise((m,h)=>{const E=this.j($,y,b,f);let n;const o=s=>{n&&(clearTimeout(n),n=null),s?h(s):m(void 0)};E.on("error",s=>{o((0,A.$Oi)(s)||"Unknown")}),E.on("exit",(s,i)=>{o(s?`post-${y} process exited with code ${s}`:void 0)}),l&&(n=setTimeout(()=>{n=null,E.kill(),h("timed out")},5e3))})}j($,y,b,l){const f={silent:!0,execArgv:void 0},m=(0,D.fork)($,[`--type=extension-post-${y}`,...b],f);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const h=j.Event.fromNodeEventEmitter(m.stdout,"data"),E=j.Event.fromNodeEventEmitter(m.stderr,"data");h(s=>this.f.info(l.identifier.id,l.manifest.version,`post-${y}`,s)),E(s=>this.f.error(l.identifier.id,l.manifest.version,`post-${y}`,s));const n=j.Event.any(j.Event.map(h,s=>({data:`%c${s}`,format:[""]})),j.Event.map(E,s=>({data:`%c${s}`,format:["color: red"]})));return j.Event.debounce(n,(s,i)=>s?{data:s.data+i.data,format:[...s.format,...i.format]}:{data:i.data,format:i.format},100)(s=>{console.group(l.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),m}m($){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Up=d,e.$Up=d=ye([X(0,S.$1k),X(1,C.$lj)],d)}),define(le[113],he([0,1,6,15,26,38,7,3,53,2,34,23,16,19,55,12,10,32,31,69,155,96,14,244,29,33,51,81,224,245,183,213,225,70,11,4,8,25,22,28,17]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o,s,i,t,r,a,v,w,u,p,I,T,F,M,z,Z,J,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.$Zp=e.$Yp=void 0,e.$Yp=(0,F.$5h)(s.$po);const G=".vsctmp";let Q=class extends o.$Fp{constructor(K,U,P,L,H,q,ee,W,Y,ie,ce,ae){super(K,U,ce,P,ie,ae),this.fb=H,this.gb=q,this.hb=ee,this.ib=Y,this.eb=new Map,this.rb=new C.$Bc;const fe=this.B(W.createInstance(v.$Up));this.bb=this.B(W.createInstance(V,we=>fe.postUninstall(we))),this.cb=this.B(new u.$Wp(ae,Y,ce,this,this.F)),this.db=this.B(W.createInstance(a.$Tp));const de=this.B(new p.$Xp(this,this.fb,ae,q,ce,Y,P));this.B(de.onDidChangeExtensionsByAnotherSource(we=>this.qb(we))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$1o)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const U=await this.pb(K),P=await(0,m.zip)((0,c.$Fg)(this.db.extensionsDownloadDir,(0,l.$og)()).fsPath,U);return b.URI.file(P)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:U,cleanup:P}=await this.lb(K),L=d.$kc(U.fsPath);try{return await(0,w.$Vp)(L)}finally{await P()}}getInstalled(K,U=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,U)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,U={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:P,cleanup:L}=await this.lb(K);try{const H=await(0,w.$Vp)(d.$kc(P.fsPath)),q=(0,i.$Uo)(H.publisher,H.name);if(H.engines&&H.engines.vscode&&!(0,I.$8o)(H.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,q,this.G.version));const W=(await this.I([{manifest:H,extension:P,options:U}])).find(({identifier:Y})=>(0,i.$Po)(Y,{id:q}));if(W?.local)return W.local;throw W?.error?W.error:(0,o.$Hp)(new Error(`Unknown error while installing extension ${q}`))}finally{await L()}}async installFromLocation(K,U){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const P=await this.bb.scanUserExtensionAtLocation(K);if(!P)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[P,void 0]],U),this.F.info("Successfully installed extension",P.identifier.id,U.toString()),P}async installExtensionsFromProfile(K,U,P){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,U.toString(),P.toString());const L=(await this.bb.scanExtensions(1,U)).filter(H=>K.some(q=>(0,i.$Po)(q,H.identifier)));if(L.length){const H=await Promise.all(L.map(q=>this.bb.scanMetadata(q,U)));await this.ub(L.map((q,ee)=>[q,H[ee]]),P),this.F.info("Successfully installed extensions",L.map(q=>q.identifier.id),P.toString())}return L}async updateMetadata(K,U,P=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),K=await this.bb.updateMetadata(K,U,P),this.cb.invalidate(P),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const U=await this.getTargetPlatform(),[P]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:U,compatible:!0},A.CancellationToken.None);if(!P)throw new Error(h.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(L){throw new Error(h.localize(3,null,(0,j.$Oi)(L)))}return this.installFromGallery(P)}ab(K,U,P,L){return this.bb.copyExtension(K,U,P,L)}copyExtensions(K,U){return this.bb.copyExtensions(K,U)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,U,P){const{location:L}=await this.db.download(K,U,!P);return L}async lb(K){if(K.scheme===S.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const U=(0,c.$Fg)(this.db.extensionsDownloadDir,(0,l.$og)());return await this.hb.download(K,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.ib.del(U)}catch(L){this.F.error(L)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,U,P){if(b.URI.isUri(U))return new se(K,U,P,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const L=i.$Qo.create(U).toString();let H=this.eb.get(L);return H||(this.eb.set(L,H=new te(K,U,P,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),H.waitUntilTaskIsFinished().finally(()=>this.eb.delete(L))),H}$(K,U){return new _(K,U.profileLocation,this.gb)}async pb(K){const U=async L=>{let H=await f.Promises.readdir(L);H=H.map(W=>d.$jc(L,W));const q=await Promise.all(H.map(W=>f.Promises.stat(W)));let ee=Promise.resolve([]);return q.forEach((W,Y)=>{const ie=H[Y];W.isFile()&&(ee=ee.then(ce=>[...ce,ie])),W.isDirectory()&&(ee=ee.then(ce=>U(ie).then(ae=>[...ce,...ae])))}),ee};return(await U(K.location.fsPath)).map(L=>({path:`extension/${d.$lc(K.location.fsPath,L)}`,localPath:L}))}async qb({added:K,removed:U}){if(U){const P=K&&this.D.extUri.isEqual(U.profileLocation,K.profileLocation)?U.extensions.filter(L=>K.extensions.every(H=>!(0,i.$Po)(H,L))):U.extensions;for(const L of P)this.F.info("Extensions removed from another source",L.id,U.profileLocation.toString()),this.u.fire({identifier:L,profileLocation:U.profileLocation})}if(K){const L=(await this.bb.scanExtensions(1,K.profileLocation)).filter(H=>K.extensions.some(q=>(0,i.$Po)(q,H.identifier)));this.s.fire(L.map(H=>(this.F.info("Extensions added from another source",H.identifier.id,K.profileLocation.toString()),{identifier:H.identifier,local:H,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(U=>this.rb.add(U)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const U of K.children??[])U.isDirectory&&this.rb.add(U.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(U=>this.tb(U)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const U=[];for(const P of K.rawAdded){if(this.rb.has(P)||!this.D.extUri.isEqual(this.D.extUri.dirname(P),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(P,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(P).startsWith(".")||!(await this.ib.stat(P)).isDirectory)continue;const L=await this.bb.scanUserExtensionAtLocation(P);L&&L.installedTimestamp===void 0&&(this.rb.add(P),U.push(L))}U.length&&(await this.ub(U.map(P=>[P,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(P=>P.identifier.id)))}async ub(K,U){const P=K.map(L=>L[0]);await this.vb(P),await this.gb.addExtensionsToProfile(K,U),this.s.fire(P.map(L=>({local:L,identifier:L.identifier,operation:1,profileLocation:U})))}async vb(K){const U=await this.bb.getUninstalledExtensions();for(const P of K){const L=i.$Qo.create(P);U[L.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",L.id),await this.bb.setInstalled(L),this.F.info("Removed the extension from uninstalled list:",L.id))}}};e.$Zp=Q,e.$Zp=Q=ye([X(0,s.$no),X(1,Z.$sl),X(2,M.$lj),X(3,n.$_h),X(4,r.$Op),X(5,t.$Kp),X(6,E.$5n),X(7,F.$3h),X(8,T.$ok),X(9,z.$Dj),X(10,J.$Yk),X(11,x.$1k)],Q);let V=class extends g.$Tc{constructor(K,U,P,L,H,q){super(),this.j=K,this.m=U,this.n=P,this.s=L,this.t=H,this.u=q,this.h=this.B(new R.$Td),this.onExtract=this.h.event,this.c=(0,c.$Fg)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$$g}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,U){const P={includeInvalid:!0,profileLocation:U};let L=[];return K===null||K===0?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},P,!1)):K===1&&L.push(...await this.n.scanUserExtensions(P)),L=K!==null?L.filter(H=>H.type===K):L,Promise.all(L.map(H=>this.F(H)))}async scanAllUserExtensions(K){const U=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(U.map(P=>this.F(P)))}async scanUserExtensionAtLocation(K){try{const U=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(K,U,P,L,H){const q=K.toString(),ee=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$og)()}`)),W=b.URI.file(d.$jc(this.n.userExtensionsLocation.fsPath,q));let Y=await this.m.exists(W);if(Y&&L){try{await this.y(K.id,W,"removeExisting")}catch{throw new s.$oo(h.localize(4,null,W.fsPath,K.id),s.ExtensionManagementErrorCode.Delete)}Y=!1}if(!Y)try{try{this.u.trace(`Started extracting the extension from ${U} to ${W.fsPath}`),await(0,m.$Dp)(U,ee.fsPath,{sourcePath:"extension",overwrite:!0},H),this.u.info(`Extracted extension to ${W}:`,K.id)}catch(ie){let ce=s.ExtensionManagementErrorCode.Extract;throw ie instanceof m.$Bp&&(ie.type==="CorruptZip"?ce=s.ExtensionManagementErrorCode.CorruptZip:ie.type==="Incomplete"&&(ce=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$oo(ie.message,ce)}await this.n.updateMetadata(ee,P);try{this.u.trace(`Started renaming the extension from ${ee.fsPath} to ${W.fsPath}`),await this.C(ee.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ie){if(ie.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(ie)}. Deleted from extracted location`,ee),ie}this.h.fire(W)}catch(ie){try{await this.m.del(ee,{recursive:!0})}catch{}throw ie}return this.D(W,1)}async scanMetadata(K,U){return U?(await this.w(K,U))?.metadata:this.n.scanMetadata(K.location)}async w(K,U){return(await this.s.scanProfileExtensions(U)).find(L=>(0,i.$Po)(L.identifier,K.identifier))}async updateMetadata(K,U,P){return P?await this.s.updateMetadata([[K,U]],P):await this.n.updateMetadata(K.location,U),this.D(K.location,K.type,P)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const U=K.map(P=>i.$Qo.create(P));await this.z(P=>U.forEach(L=>{P[L.toString()]=!0,this.u.info("Marked extension as uninstalled",L.toString())}))}async setInstalled(K){await this.z(U=>delete U[K.toString()])}async removeExtension(K,U){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,U)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(U=>delete U[i.$Qo.create(K).toString()])}async copyExtension(K,U,P,L){const H=await this.w(K,U),q=await this.w(K,P);return L={...H?.metadata,...L},q?await this.s.updateMetadata([[K,{...q.metadata,...L}]],P):await this.s.addExtensionsToProfile([[K,L]],P),this.D(K.location,K.type,P)}async copyExtensions(K,U){const P=await this.scanExtensions(1,K),L=await Promise.all(P.filter(H=>!H.isApplicationScoped).map(async H=>[H,await this.scanMetadata(H,K)]));await this.s.addExtensionsToProfile(L,U)}async y(K,U,P){this.u.trace(`Deleting ${P} extension from disk`,K,U.fsPath);const L=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,k.$Ri)((0,l.$og)()).toString(16)}${G}`);await this.C(U.fsPath,L.fsPath),await this.m.del(L,{recursive:!0}),this.u.info(`Deleted ${P} extension from disk`,K,U.fsPath)}async z(K){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(L){if((0,T.$Fk)(L)!==1)throw L}let P={};if(U)try{P=JSON.parse(U)}catch{}return K&&(K(P),Object.keys(P).length?await this.m.writeFile(this.c,N.$he.fromString(JSON.stringify(P))):await this.m.del(this.c)),P})}async C(K,U){try{await f.Promises.rename(K,U,2*60*1e3)}catch(P){throw new s.$oo(P.message||h.localize(5,null,K,U),P.code||s.ExtensionManagementErrorCode.Rename)}}async D(K,U,P){if(P){const H=(await this.n.scanUserExtensions({profileLocation:P})).find(q=>this.t.extUri.isEqual(q.location,K));if(H)return this.F(H)}else{const L=await this.n.scanExistingExtension(K,U,{includeInvalid:!0});if(L)return this.F(L)}throw new Error(h.localize(6,null,K.path))}async F(K){const U=await this.m.resolve(K.location);let P,L;return U.children&&(P=U.children.find(({name:H})=>/^readme(\.txt|\.md|)$/i.test(H))?.resource,L=U.children.find(({name:H})=>/^changelog(\.txt|\.md|)$/i.test(H))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:P,changelogUrl:L,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),P=new Set;for(const H of U)K[i.$Qo.create(H).toString()]||P.add(H.identifier.id.toLowerCase());try{const H=(0,i.$Vo)(U,q=>q.identifier);await D.Promises.settled(H.map(async q=>{const ee=q.sort((W,Y)=>$.rcompare(W.manifest.version,Y.manifest.version))[0];P.has(ee.identifier.id.toLowerCase())||await this.j(await this.F(ee))}))}catch(H){this.u.error(H)}const L=U.filter(H=>H.metadata&&K[i.$Qo.create(H).toString()]);await Promise.allSettled(L.map(H=>this.removeUninstalledExtension(H)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,T.$Fk)(U)!==1&&this.u.error(U);return}if(K?.children)try{await Promise.allSettled(K.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(G))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(P){(0,T.$Fk)(P)!==1&&this.u.error(P)}}}))}catch{}}};e.$1p=V,e.$1p=V=ye([X(1,T.$ok),X(2,r.$Op),X(3,t.$Kp),X(4,J.$Yk),X(5,M.$lj)],V);class B extends o.$Ip{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,y.$Nf)(this.options.operation)?this.l:this.options.operation}constructor(K,U,P,L,H,q,ee,W,Y){super(),this.identifier=K,this.source=U,this.options=P,this.m=L,this.n=H,this.o=q,this.p=ee,this.q=W,this.s=Y,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[U,P]=await this.x(K);return this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[U,P]],this.j),U}async u({zipPath:K,key:U,metadata:P},L,H){let q=await this.v(U);return q||(this.s.trace("Extracting extension...",U.id),q=await this.m.extractUserExtension(U,K,P,L,H),this.s.info("Extracting extension completed.",U.id)),q}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(L=>i.$Qo.create(L).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class te extends B{constructor(K,U,P,L,H,q,ee,W,Y,ie){super(U.identifier,U,P,H,q,ee,W,Y,ie),this.y=U,this.z=L}async x(K){const P=(await this.m.scanExtensions(null,this.options.profileLocation)).find(ee=>(0,i.$Po)(ee.identifier,this.y.identifier));P&&(this.l=3);const L={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,isSystem:P?.type===0?!0:void 0,updated:!!P,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,y.$Mf)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:P?.preRelease)};if(P?.manifest.version===this.y.version)return[await this.m.updateMetadata(P,L),L];const{location:H,verificationStatus:q}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=q,this.B(H.fsPath),[await this.u({zipPath:H.fsPath,key:i.$Qo.create(this.y),metadata:L},!1,K),L]}catch(ee){try{await this.z.delete(H)}catch(W){this.s.warn("Error while deleting the downloaded file",H.toString(),(0,O.$0)(W))}throw ee}}async B(K){try{await(0,w.$Vp)(K)}catch(U){throw new s.$oo((0,o.$Gp)(U).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$2p=te;class se extends B{constructor(K,U,P,L,H,q,ee,W,Y,ie){super({id:(0,i.$Uo)(K.publisher,K.name)},U,P,H,q,ee,W,Y,ie),this.y=K,this.z=U,this.A=L}async h(K){const U=await super.h(K);return this.D(U,K),U}async x(K){const U=new i.$Qo(this.identifier,this.y.version),L=(await this.m.scanExtensions(1,this.options.profileLocation)).find(ee=>(0,i.$Po)(this.identifier,ee.identifier)),H={isApplicationScoped:this.options.isApplicationScoped||L?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||L?.isMachineScoped,isBuiltin:this.options.isBuiltin||L?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??L?.pinned};if(L)if(this.l=3,U.equals(new i.$Qo(L.identifier,L.manifest.version)))try{await this.m.removeExtension(L,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(L.manifest.version,this.y.version)&&await this.m.setUninstalled(L);else{const ee=await this.v(U);if(ee)try{await this.m.removeExtension(ee,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:d.$kc(this.z.fsPath),key:U,metadata:H},!0,K),H]}async D(K,U){try{let[P]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],U);if(P||([P]=await this.A.getExtensions([{id:K.identifier.id}],U)),P){const L={id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId,isPreReleaseVersion:P.properties.isPreReleaseVersion,preRelease:P.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,L,this.options.profileLocation)}}catch{}}}class _ extends o.$Ip{constructor(K,U,P){super(),this.extension=K,this.j=U,this.k=P}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,17,28,22,51,11,14,10]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=void 0;let C=class extends O.$Lp{constructor(d,c,$,y,b,l){super(g.URI.file(d.extensionsPath),c,$,y,b,l)}};e.$jO=C,e.$jO=C=ye([X(0,k.$_h),X(1,R.$ok),X(2,N.$1k),X(3,A.$Yk),X(4,j.$sl),X(5,D.$lj)],C)}),define(le[247],he([0,1,10,14,51,81,11,4,8,25,28,17]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;let d=class extends j.$Sp{constructor($,y,b,l,f,m,h,E){super(D.URI.file(f.builtinExtensionsPath),D.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,y,b,l,f,m,h,E)}};e.$h$b=d,e.$h$b=d=ye([X(0,S.$1k),X(1,A.$Kp),X(2,O.$ok),X(3,k.$lj),X(4,N.$_h),X(5,g.$Dj),X(6,C.$Yk),X(7,R.$3h)],d)}),define(le[21],he([0,1,6,3,2,100,12,68,4,17]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$jp=e.$ip=e.$hp=void 0,e.$hp="__$__isNewStorageMarker",e.$ip="__$__targetStorageMarker",e.$jp=(0,k.$4h)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var d;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function c(f){const m=f.get(e.$ip);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}e.$kp=c;class $ extends A.$Tc{static{this.a=60*1e3}constructor(m={flushInterval:$.a}){super(),this.m=m,this.b=this.B(new N.$Wd),this.c=this.B(new N.$Wd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Td),this.onWillSaveState=this.f.event,this.h=this.B(new D.$dh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new A.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,h,E){return N.Event.filter(this.b.event,n=>n.scope===m&&(h===void 0||n.key===h),E)}n(){this.j.value=(0,D.$hh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,A.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,h){const{key:E,external:n}=h;if(E===e.$ip){switch(m){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:E,target:this.J(m)[E],external:n})}w(m){this.f.fire({reason:m})}get(m,h,E){return this.P(h)?.get(m,E)}getBoolean(m,h,E){return this.P(h)?.getBoolean(m,E)}getNumber(m,h,E){return this.P(h)?.getNumber(m,E)}getObject(m,h,E){return this.P(h)?.getObject(m,E)}storeAll(m,h){this.y(()=>{for(const E of m)this.store(E.key,E.value,E.scope,E.target,h)})}store(m,h,E,n,o=!1){if((0,O.$Pf)(h)){this.remove(m,E,o);return}this.y(()=>{this.z(m,E,n),this.P(E)?.set(m,h,o)})}remove(m,h,E=!1){this.y(()=>{this.z(m,h,void 0),this.P(h)?.delete(m,E)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,h){const E=[],n=this.J(m);for(const o of Object.keys(n))n[o]===h&&E.push(o);return E}z(m,h,E,n=!1){const o=this.J(h);typeof E=="number"?o[m]!==E&&(o[m]=E,this.P(h)?.set(e.$ip,JSON.stringify(o),n)):typeof o[m]=="number"&&(delete o[m],this.P(h)?.set(e.$ip,JSON.stringify(o),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(m){switch(m){case-1:return this.I;case 0:return this.G;default:return this.D}}L(m){const h=this.P(m);return h?c(h):Object.create(null)}isNew(m){return this.getBoolean(e.$hp,m)===!0}async flush(m=C.NONE){this.f.fire({reason:m});const h=this.P(-1),E=this.P(0),n=this.P(1);switch(m){case C.NONE:await D.Promises.settled([h?.whenFlushed()??Promise.resolve(),E?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await D.Promises.settled([h?.flush(0)??Promise.resolve(),E?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,E=this.P(1)?.items??new Map;return l(m,h,E,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,h){return this.w(C.NONE),(0,g.$Zk)(m)?this.R(m,h):this.S(m,h)}M(m,h){return!(m.id===h.id||y(h)&&y(m))}N(m,h,E){this.y(()=>{const n=new Set;for(const[o,s]of m)n.add(o),h.get(o)!==s&&this.u(E,{key:o,external:!0});for(const[o]of h.items)n.has(o)||this.u(E,{key:o,external:!0})})}}e.$lp=$;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$mp=y;class b extends ${constructor(){super(),this.U=this.B(new R.$fp(new R.$gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$fp(new R.$gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$fp(new R.$gp,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(1,m))),this.B(this.W.onDidChangeStorage(m=>this.u(0,m))),this.B(this.U.onDidChangeStorage(m=>this.u(-1,m)))}P(m){switch(m){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(m){switch(m){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$np=b;async function l(f,m,h,E,n,o){const s=I=>{try{return JSON.parse(I)}catch{return I}},i=new Map,t=new Map;f.forEach((I,T)=>{i.set(T,I),t.set(T,s(I))});const r=new Map,a=new Map;m.forEach((I,T)=>{r.set(T,I),a.set(T,s(I))});const v=new Map,w=new Map;h.forEach((I,T)=>{v.set(T,I),w.set(T,s(I))}),console.group(E!==n?`Storage: Application (path: ${E})`:`Storage: Application & Profile (path: ${E}, default profile)`);const u=[];if(i.forEach((I,T)=>{u.push({key:T,value:I})}),console.table(u),console.groupEnd(),console.log(t),E!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const I=[];r.forEach((T,F)=>{I.push({key:F,value:T})}),console.table(I),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];v.forEach((I,T)=>{p.push({key:T,value:I})}),console.table(p),console.groupEnd(),console.log(w)}e.$op=l}),define(le[114],he([0,1,3,2,12,29,33,21]),function(ne,e,D,N,A,j,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OEb=e.$NEb=void 0;let k=class extends N.$Tc{constructor(S,d){super(),this.a=new D.$Td,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(c=>this.a.fire({extensions:c,source:"storage"}))),this.B(d.onDidInstallExtensions(c=>c.forEach(({local:$,operation:y})=>{$&&y===4&&this.f($.identifier)})))}async enableExtension(S,d){return this.f(S)?(this.a.fire({extensions:[S],source:d}),!0):!1}async disableExtension(S,d){return this.c(S)?(this.a.fire({extensions:[S],source:d}),!0):!1}getDisabledExtensions(){return this.h(j.$qo)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const d=this.getDisabledExtensions();return d.every(c=>!(0,O.$Po)(c,S))?(d.push(S),this.g(d),!0):!1}f(S){const d=this.getDisabledExtensions();for(let c=0;c<d.length;c++){const $=d[c];if((0,O.$Po)($,S))return d.splice(c,1),this.g(d),!0}return!1}g(S){this.j(j.$qo,S)}h(S){return this.b.get(S,0)}j(S,d){this.b.set(S,d,0)}};e.$NEb=k,e.$NEb=k=ye([X(0,R.$jp),X(1,j.$po)],k);class g extends N.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new D.$Td),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new N.$Sc))(d=>this.f(d)))}get(S,d){let c;return d===0?((0,A.$Pf)(this.a[S])&&(this.a[S]=this.g(S,d)),c=this.a[S]):c=this.g(S,d),JSON.parse(c)}set(S,d,c){const $=JSON.stringify(d.map(({id:b,uuid:l})=>({id:b,uuid:l})));this.g(S,c)!==$&&(c===0&&(d.length?this.a[S]=$:delete this.a[S]),this.h(S,d.length?$:void 0,c))}f(S){if(!(0,A.$Pf)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const c=this.get(S.key,S.scope);delete this.a[S.key];const $=this.get(S.key,S.scope),y=c.filter(l=>!$.some(f=>(0,O.$Po)(l,f))),b=$.filter(l=>!c.some(f=>(0,O.$Po)(f,l)));(y.length||b.length)&&this.b.fire([...y,...b])}}g(S,d){return this.c.get(S,d,"[]")}h(S,d,c){d?this.c.store(S,d,c,1):this.c.remove(S,c)}}e.$OEb=g}),define(le[248],he([0,1,18,26,7,5,37,12,10,20,14,29,33,70,11,8,25,59,226,21,22,62]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=void 0;const n=j.$o?"web":(0,S.$jo)(j.$u,O.$ec),o="X-Market-Search-Activity-Id";var s;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function i(...P){return String(P.reduce((L,H)=>L|H,0))}var t;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class u{constructor(L=w){this.d=L}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(L,H=this.d.pageSize){return new u({...this.d,pageNumber:L,pageSize:H})}withFilter(L,...H){const q=[...this.d.criteria,...H.length?H.map(ee=>({filterType:L,value:ee})):[{filterType:L}]];return new u({...this.d,criteria:q})}withSortBy(L){return new u({...this.d,sortBy:L})}withSortOrder(L){return new u({...this.d,sortOrder:L})}withFlags(...L){return new u({...this.d,flags:L.reduce((H,q)=>H|q,0)})}withAssetTypes(...L){return new u({...this.d,assetTypes:L})}withSource(L){return new u({...this.d,source:L})}get raw(){const{criteria:L,pageNumber:H,pageSize:q,sortBy:ee,sortOrder:W,flags:Y,assetTypes:ie}=this.d;return{filters:[{criteria:L,pageNumber:H,pageSize:q,sortBy:ee,sortOrder:W}],assetTypes:ie,flags:Y}}get searchText(){const L=this.d.criteria.filter(H=>H.filterType===t.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(L=>String(L.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(P,L){const H=(P||[]).filter(q=>q.statisticName===L)[0];return H?H.value:0}function I(P){const L="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(q=>q.assetType.indexOf(L)===0).reduce((q,ee)=>{const W=M(P,ee.assetType);return W&&q.push([ee.assetType.substring(L.length),W]),q},[])}function T(P){if(P.properties){const L=P.properties.filter(ee=>ee.key===r.Repository),H=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=L.filter(ee=>H.test(ee.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return M(P,r.Repository)}function F(P){return{uri:`${P.fallbackAssetUri}/${r.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${r.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function M(P,L){return P.files.filter(q=>q.assetType===L)[0]?{uri:`${P.assetUri}/${L}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${L}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function z(P,L){const H=P.properties?P.properties.filter(ee=>ee.key===L):[],q=H.length>0&&H[0].value;return q?q.split(",").map(ee=>(0,d.$To)(ee)):[]}function Z(P){const L=P.properties?P.properties.filter(H=>H.key===a.Engine):[];return L.length>0&&L[0].value||""}function J(P){const L=P.properties?P.properties.filter(H=>H.key===a.PreRelease):[];return L.length>0&&L[0].value==="true"}function x(P){const L=P.properties?P.properties.filter(q=>q.key===a.LocalizedLanguages):[],H=L.length>0&&L[0].value||"";return H?H.split(","):[]}function G(P){return P.properties?.find(L=>L.key===a.SponsorLink)?.value}function Q(P){return P.indexOf("preview")!==-1}function V(P){return P.targetPlatform?(0,S.$io)(P.targetPlatform):"undefined"}function B(P){const L=(0,D.$Mb)(P.versions.map(V)),H=!!P.tags?.includes(S.$do),q=L.indexOf("web");return H?q===-1&&L.push("web"):q!==-1&&L.splice(q,1),L}function te(P,L){for(let H=0;H<P.length;H++){const q=P[H];if(q.version===P[H-1]?.version){let ee=H;if(V(q)===L)for(;ee>0&&P[ee-1].version===q.version;)ee--;ee!==H&&(P.splice(H,1),P.splice(ee,0,q))}}return P}e.$rp=te;function se(P,L,H){P.telemetryData={index:L,querySource:H,queryActivityId:P.queryContext?.[o]}}function _(P,L,H,q){const ee=P.versions[0],W={manifest:M(L,r.Manifest),readme:M(L,r.Details),changelog:M(L,r.Changelog),license:M(L,r.License),repository:T(L),download:F(L),icon:M(L,r.Icon),signature:M(L,r.Signature),coreTranslations:I(L)};return{identifier:{id:(0,d.$Uo)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:L.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(ee),description:P.shortDescription||"",installCount:p(P.statistics,"install"),rating:p(P.statistics,"averagerating"),ratingCount:p(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:H,assets:W,properties:{dependencies:z(L,a.Dependency),extensionPack:z(L,a.ExtensionPack),engine:Z(L),localizedLanguages:x(L),targetPlatform:V(L),isPreReleaseVersion:J(L)},hasPreReleaseVersion:J(ee),hasReleaseVersion:!0,preview:Q(P.flags),isSigned:!!W.signature,queryContext:q}}let oe=class{constructor(L,H,q,ee,W,Y,ie,ce){this.k=H,this.l=q,this.n=ee,this.o=W,this.q=Y,this.u=ie,this.w=ce;const ae=ie.extensionsGallery,fe=ae?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=fe?ae.servicePPEUrl:ae?.serviceUrl,this.g=fe?void 0:ae?.searchUrl,this.h=ae?.controlUrl,this.j=(0,f.$qp)(ie.version,ie,this.n,this.w,this.q,L,this.o)}x(L=""){return`${this.d}${L}`}isEnabled(){return!!this.d}async getExtensions(L,H,q){const ee=N.CancellationToken.isCancellationToken(H)?{}:H,W=N.CancellationToken.isCancellationToken(H)?H:q,Y=[],ie=[],ce=[],ae=[];let fe=!0;for(const Ee of L){Ee.uuid?ie.push(Ee.uuid):Y.push(Ee.id);const Re=!!(Ee.version||Ee.preRelease);ce.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Re}),Ee.version&&ae.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),fe=fe&&!!Ee.hasPreRelease&&!Re}if(!ie.length&&!Y.length)return[];let de=new u().withPage(1,L.length);ie.length&&(de=de.withFilter(t.ExtensionId,...ie)),Y.length&&(de=de.withFilter(t.ExtensionName,...Y)),(ee.queryAllVersions||fe)&&(de=de.withFlags(de.flags,s.IncludeVersions)),ee.source&&(de=de.withSource(ee.source));const{extensions:we}=await this.z(de,{targetPlatform:ee.targetPlatform??n,includePreRelease:ce,versions:ae,compatible:!!ee.compatible},W);return ee.source&&we.forEach((Ee,Re)=>se(Ee,Re,ee.source)),we}async getCompatibleExtension(L,H,q){if((0,S.$ko)(L.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(L,H,q))return L;const ee=new u().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,L.identifier.uuid),{extensions:W}=await this.z(ee,{targetPlatform:q,compatible:!0,includePreRelease:H},N.CancellationToken.None);return W[0]||null}async isExtensionCompatible(L,H,q){if(!(0,S.$lo)(L.properties.targetPlatform,L.allTargetPlatforms,q)||!H&&L.properties.isPreReleaseVersion)return!1;let ee=L.properties.engine;if(!ee){const W=await this.getManifest(L,N.CancellationToken.None);if(!W)throw new Error("Manifest was not found");ee=W.engines.vscode}return(0,c.$8o)(ee,this.u.version,this.u.date)}async y(L,H,q,ee,W){if(!(0,S.$lo)(V(L),ee,W)||H!=="any"&&J(L)!==(H==="prerelease"))return!1;if(q)try{const Y=await this.E(L);if(!(0,c.$8o)(Y,this.u.version,this.u.date))return!1}catch(Y){return this.l.error(`Error while getting the engine for the version ${L.version}.`,(0,A.$0)(Y)),!1}return!0}async query(L,H){let q=L.text||"";const ee=L.pageSize??50;let W=new u().withPage(1,ee);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(W=W.withFilter(t.Category,we||de),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,de,we)=>(W=W.withFilter(t.Tag,we||de),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(W=W.withFilter(t.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),W=W.withFilter(t.SearchText,q)),W=W.withSortBy(0)):L.ids?W=W.withFilter(t.ExtensionId,...L.ids):L.names?W=W.withFilter(t.ExtensionName,...L.names):W=W.withSortBy(4),typeof L.sortBy=="number"&&(W=W.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(W=W.withSortOrder(L.sortOrder)),L.source&&(W=W.withSource(L.source));const Y=async(fe,de)=>{const{extensions:we,total:Ee}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!L.includePreRelease},de);return we.forEach((Re,Oe)=>se(Re,(fe.pageNumber-1)*fe.pageSize+Oe,L.source)),{extensions:we,total:Ee}},{extensions:ie,total:ce}=await Y(W,H),ae=async(fe,de)=>{if(de.isCancellationRequested)throw new A.$5;const{extensions:we}=await Y(W.withPage(fe+1),de);return we};return{firstPage:ie,total:ce,pageSize:W.pageSize,getPage:ae}}async z(L,H,q){const ee=L.flags;L.flags&s.IncludeLatestVersionOnly&&L.flags&s.IncludeVersions&&(L=L.withFlags(L.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(L.flags&s.IncludeLatestVersionOnly)&&!(L.flags&s.IncludeVersions)&&(L=L.withFlags(L.flags,s.IncludeLatestVersionOnly)),H.versions?.length&&(L=L.withFlags(L.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),L=L.withFlags(L.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:W,total:Y,context:ie}=await this.B(L,q);if(!(L.flags&s.IncludeLatestVersionOnly)){const de=[];for(const we of W){const Ee=await this.A(we,H,ie);Ee&&de.push(Ee)}return{extensions:de,total:Y}}const ae=[],fe=new Map;for(let de=0;de<W.length;de++){const we=W[de],Ee={id:(0,d.$Uo)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Re=(0,R.$Mf)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(Ne=>(0,d.$Po)(Ne,Ee))?.includePreRelease;if(H.compatible&&(0,S.$ko)(B(we),H.targetPlatform))continue;const Oe=await this.A(we,H,ie);!Oe||Oe.properties.isPreReleaseVersion&&(!Re||!Oe.hasReleaseVersion)||!Oe.properties.isPreReleaseVersion&&Oe.properties.targetPlatform!==H.targetPlatform&&Oe.hasPreReleaseVersion?fe.set(we.extensionId,de):ae.push([de,Oe])}if(fe.size){const de=new E.$Pd,we=new u().withFlags(ee&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,fe.size).withFilter(t.ExtensionId,...fe.keys()),{extensions:Ee}=await this.z(we,H,q);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:fe.size});for(const Re of Ee){const Oe=fe.get(Re.identifier.uuid);ae.push([Oe,Re])}}return{extensions:ae.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:Y}}async A(L,H,q){const ee={id:(0,d.$Uo)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},W=H.versions?.find(ae=>(0,d.$Po)(ae,ee))?.version,Y=(0,R.$Mf)(H.includePreRelease)?H.includePreRelease:!!H.includePreRelease.find(ae=>(0,d.$Po)(ae,ee))?.includePreRelease,ie=B(L),ce=te(L.versions,H.targetPlatform);if(H.compatible&&(0,S.$ko)(ie,H.targetPlatform))return null;for(let ae=0;ae<ce.length;ae++){const fe=ce[ae];if(!(W&&fe.version!==W)){if(await this.y(fe,Y?"any":"release",H.compatible,ie,H.targetPlatform))return _(L,fe,ie,q);if(W&&fe.version===W)return null}}return W||H.compatible?null:_(L,L.versions[0],ie)}async B(L,H){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,i(s.Unpublished));const q=await this.j,ee=JSON.stringify(L.raw),W={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(ee.length)},Y=new E.$Pd;let ie,ce,ae=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&L.criteria.some(de=>de.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:ee,headers:W},H),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:ae};const fe=await(0,l.$cp)(ie);if(fe){const de=fe.results[0],we=de.extensions,Ee=de.resultMetadata&&de.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ae=Ee&&Ee.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ae,context:{[o]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:ae}}catch(fe){throw ce=fe,fe}finally{this.o.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(ee.length),duration:Y.elapsed(),success:!!ie&&(0,l.$$o)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:ce?(0,A.$4)(ce)?"canceled":(0,A.$0)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ae)})}}async reportStatistic(L,H,q,ee){if(!this.isEnabled())return;const W=j.$o?this.x(`/itemName/${L}.${H}/version/${q}/statType/${ee==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${L}/extensions/${H}/${q}/stats?statType=${ee}`),Y=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:W,headers:ce},N.CancellationToken.None)}catch{}}async download(L,H,q){this.l.trace("ExtensionGalleryService#download",L.identifier.id);const ee=(0,d.$Xo)(L),W=new Date().getTime(),Y=de=>this.o.publicLog("galleryService:downloadVSIX",{...ee,duration:de}),ie=q===2?"install":q===3?"update":"",ce=ie?{uri:`${L.assets.download.uri}${k.URI.parse(L.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${L.assets.download.fallbackUri}${k.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:L.assets.download,ae=L.queryContext?.[o]?{[o]:L.queryContext[o]}:void 0,fe=await this.D(ce,ae?{headers:ae}:void 0);await this.q.writeFile(H,fe.stream),Y(new Date().getTime()-W)}async downloadSignatureArchive(L,H){if(!L.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",L.identifier.id);const q=await this.D(L.assets.signature);await this.q.writeFile(H,q.stream)}async getReadme(L,H){if(L.assets.readme){const q=await this.D(L.assets.readme,{},H);return await(0,l.$bp)(q)||""}return""}async getManifest(L,H){if(L.assets.manifest){const q=await this.D(L.assets.manifest,{},H),ee=await(0,l.$bp)(q);return ee?JSON.parse(ee):null}return null}async C(L,H){const q=M(L,r.Manifest);if(!q)throw new Error("Manifest was not found");const ee={"Accept-Encoding":"gzip"},W=await this.D(q,{headers:ee});return await(0,l.$cp)(W)}async getCoreTranslation(L,H){const q=L.assets.coreTranslations.filter(ee=>ee[0]===H.toUpperCase())[0];if(q){const ee=await this.D(q[1]),W=await(0,l.$bp)(ee);return W?JSON.parse(W):null}return null}async getChangelog(L,H){if(L.assets.changelog){const q=await this.D(L.assets.changelog,{},H);return await(0,l.$bp)(q)||""}return""}async getAllCompatibleVersions(L,H,q){let ee=new u().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?ee=ee.withFilter(t.ExtensionId,L.identifier.uuid):ee=ee.withFilter(t.ExtensionName,L.identifier.id);const{galleryExtensions:W}=await this.B(ee,N.CancellationToken.None);if(!W.length)return[];const Y=B(W[0]);if((0,S.$ko)(Y,q))return[];const ie=[];await Promise.all(W[0].versions.map(async fe=>{try{await this.y(fe,H?"any":"release",!0,Y,q)&&ie.push(fe)}catch{}}));const ce=[],ae=new Set;for(const fe of te(ie,q))ae.has(fe.version)||(ae.add(fe.version),ce.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:J(fe)}));return ce}async D(L,H={},q=N.CancellationToken.None){const ee=await this.j,W={type:"GET"},Y={...ee,...H.headers||{}};H={...H,...W,headers:Y};const ie=L.uri,ce=L.fallbackUri,ae={...H,url:ie};try{const fe=await this.k.request(ae,q);if(fe.res.statusCode===200)return fe;const de=await(0,l.$bp)(fe);throw new Error(`Expected 200, got back ${fe.res.statusCode} instead.

${de}`)}catch(fe){if((0,A.$4)(fe))throw fe;const de=(0,A.$0)(fe);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:de});const we={...H,url:ce};return this.k.request(we,q)}}async E(L){let H=Z(L);if(!H){const q=await this.C(L,N.CancellationToken.None);if(!q)throw new Error("Manifest was not found");H=q.engines.vscode}return H}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const L=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const H=await(0,l.$cp)(L),q=[],ee={},W=[];if(H){for(const Y of H.malicious)q.push({id:Y});if(H.migrateToPreRelease)for(const[Y,ie]of Object.entries(H.migrateToPreRelease))(!ie.engine||(0,c.$8o)(ie.engine,this.u.version,this.u.date))&&(ee[Y.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(H.deprecated)for(const[Y,ie]of Object.entries(H.deprecated))ie&&(ee[Y.toLowerCase()]=(0,R.$Mf)(ie)?{}:ie);if(H.search)for(const Y of H.search)W.push(Y)}return{malicious:q,deprecated:ee,search:W}}};oe=ye([X(1,l.$9o),X(2,y.$lj),X(3,C.$$h),X(4,h.$sl),X(5,$.$ok),X(6,b.$Dj),X(7,g.$xi)],oe);let K=class extends oe{constructor(L,H,q,ee,W,Y,ie,ce){super(L,H,q,ee,W,Y,ie,ce)}};e.$sp=K,e.$sp=K=ye([X(0,m.$jp),X(1,l.$9o),X(2,y.$lj),X(3,C.$$h),X(4,h.$sl),X(5,$.$ok),X(6,b.$Dj),X(7,g.$xi)],K);let U=class extends oe{constructor(L,H,q,ee,W,Y,ie){super(void 0,L,H,q,ee,W,Y,ie)}};e.$tp=U,e.$tp=U=ye([X(0,l.$9o),X(1,y.$lj),X(2,C.$$h),X(3,h.$sl),X(4,$.$ok),X(5,b.$Dj),X(6,g.$xi)],U)}),define(le[82],he([0,1,4,3,2,21,33,25,18,8,12]),function(ne,e,D,N,A,j,O,R,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$dv=e.$cv=void 0,e.$cv=(0,D.$4h)("IExtensionStorageService");const d=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let c=class extends A.$Tc{static{S=this}static{this.a=512*1024}static b(y){return`extensionKeys/${(0,O.$To)(y.id)}@${y.version}`}static c(y){const b=d.exec(y);if(b&&b[1])return{id:b[1],version:b[2]}}static async removeOutdatedExtensionVersions(y,b){const l=await y.getInstalled(),f=[];for(const[m,h]of S.f(b)){const E=l.find(n=>(0,O.$Po)(n.identifier,{id:m}))?.manifest.version;for(const n of h)E!==n&&f.push(S.b({id:m,version:n}))}for(const m of f)b.remove(m,0)}static f(y){const b=new Map,l=y.keys(0,1);for(const f of l){const m=S.c(f);if(m){let h=b.get(m.id.toLowerCase());h||b.set(m.id.toLowerCase(),h=[]),h.push(m.version)}}return b}constructor(y,b,l){super(),this.j=y,this.m=b,this.n=l,this.g=this.B(new N.$Td),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(y),this.B(this.j.onDidChangeValue(0,void 0,this.B(new A.$Sc))(f=>this.r(f)))}r(y){if(this.h.has(y.key.toLowerCase())){this.g.fire();return}const b=S.c(y.key);if(b){if(this.j.get(y.key,0)===void 0)this.h.delete(b.id.toLowerCase());else{let l=this.h.get(b.id.toLowerCase());l||this.h.set(b.id.toLowerCase(),l=[]),l.push(b.version),this.g.fire()}return}}s(y){if((0,C.$Gf)(y))return y;const b=y.manifest?y.manifest.publisher:y.publisher,l=y.manifest?y.manifest.name:y.name;return(0,O.$So)(b,l)}getExtensionState(y,b){const l=this.s(y),f=this.getExtensionStateRaw(y,b);if(f)try{return JSON.parse(f)}catch(m){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${l}, global: ${b}): ${m}`)}}getExtensionStateRaw(y,b){const l=this.s(y),f=this.j.get(l,b?0:1);return f&&f?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${l}, global: ${b}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(y,b,l){const f=this.s(y);b===void 0?this.j.remove(f,l?0:1):this.j.store(f,JSON.stringify(b),l?0:1,1)}setKeysForSync(y,b){this.j.store(S.b(y),JSON.stringify(b),0,1)}getKeysForSync(y){const b=this.m.extensionSyncedKeys?.[y.id.toLowerCase()],l=this.j.get(S.b(y),0),f=l?JSON.parse(l):void 0;return f&&b?(0,k.$Mb)([...f,...b]):f||b}addToMigrationList(y,b){if(y!==b){const l=this.t.filter(f=>!f.includes(y)&&!f.includes(b));l.push([y,b]),this.t=l}}getSourceExtensionToMigrate(y){const b=this.t.find(([,l])=>y===l);return b?b[0]:void 0}get t(){const y=this.j.get("extensionStorage.migrationList",-1,"[]");try{const b=JSON.parse(y);if(Array.isArray(b))return b}catch{}return[]}set t(y){y.length?this.j.store("extensionStorage.migrationList",JSON.stringify(y),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$dv=c,e.$dv=c=S=ye([X(0,j.$jp),X(1,R.$Dj),X(2,g.$lj)],c)}),define(le[249],he([0,1,2,29,82,223,113,8,21]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;let g=class extends D.$Tc{constructor(S,d,c,$,y,b){super(),S.cleanUp(),(0,j.$0Yb)(S,d,c,$,b),A.$dv.removeOutdatedExtensionVersions(S,y)}};e.$y_b=g,e.$y_b=g=ye([X(0,O.$Yp),X(1,N.$no),X(2,A.$cv),X(3,N.$so),X(4,k.$jp),X(5,R.$lj)],g)}),define(le[250],he([0,1,29,11,25,14,98,57,21,22,222]),function(ne,e,D,N,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;let S=class extends C.$S8b{constructor(c,$,y,b,l,f,m,h){super(c.userHome,l,$,y,b,f,m,h)}};e.$F_b=S,e.$F_b=S=ye([X(0,j.$_h),X(1,g.$sl),X(2,D.$po),X(3,k.$jp),X(4,R.$v0b),X(5,O.$TYb),X(6,N.$ok),X(7,A.$Dj)],S)}),define(le[251],he([0,1,105,3,22,14,2,8,16,66,25,5,6,101,20,164,36,21,12,131,19]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;const E=[D.$u_b,D.$v_b],n="remoteTunnelSession",o="remoteTunnelIsService";let s=class extends O.$Tc{constructor(a,v,w,u,p,I,T){super(),this.y=a,this.z=v,this.C=w,this.D=I,this.F=T,this.f=new N.$Td,this.onDidTokenFailed=this.f.event,this.g=new N.$Td,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$Td,this.onDidChangeMode=this.h.event,this.n=D.$s_b,this.w=!1,this.I=(F,M)=>{M?this.j.error(F):this.j.info(F)},this.j=this.B(u.createLogger((0,h.$Fg)(w.logsHome,`${D.$w_b}.log`),{id:D.$w_b,name:D.$x_b})),this.t=new d.$1g(100),this.B(this.j.onDidChangeLogLevel(F=>this.j.info("Log level changed to "+(0,R.$Aj)(F)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(I.onDidChangeConfiguration(F=>{E.some(M=>F.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(v){this.j.error(v)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(D.$s_b);try{a&&this.O("uninstallService",["service","uninstall"])}catch(v){this.j.error(v)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",v=!1;const w=(M,z)=>{z?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,y.localize)(0,null)))},u=this.O("status",["status"],w);this.r=u;try{if(await u,this.r!==u)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(z=>z.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(v=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(D.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const M=p.token;this.G(D.TunnelStates.connecting((0,y.localize)(1,null,p.accountLabel,p.providerId)));const z=(J,x)=>{J=J.replaceAll(M,"*".repeat(4)),w(J,x)},Z=this.O("login",["user","login","--provider",p.providerId,"--access-token",M,"--log",(0,R.$Aj)(this.j.getLevel())],z);this.r=Z;try{if(await Z,this.r!==Z)return}catch(J){this.j.error(J),this.r=void 0,this.f.fire(p),this.G(D.TunnelStates.disconnected(p));return}}const I=this.Q();I?this.G(D.TunnelStates.connecting((0,y.localize)(2,null,I))):this.G(D.TunnelStates.connecting((0,y.localize)(3,null)));const T=["--accept-server-license-terms","--log",(0,R.$Aj)(this.j.getLevel())];I?T.push("--name",I):T.push("--random-name");let F=!1;return this.n.active&&this.n.asService&&!v&&(F=await this.M(T)===!1),this.N(p,T,F)}async M(a){let v;try{v=await this.O("serviceInstall",["service","install",...a])}catch(w){this.j.error(w),v=1}if(v!==0){const w=(0,y.localize)(4,null);return this.j.warn(w),this.G(D.TunnelStates.connecting(w)),!1}return!0}async N(a,v,w){v.push("--parent-process-id",String(process.pid)),this.P()&&v.push("--no-sleep");let u=!1;const p=this.O("tunnel",v,(I,T)=>{T?this.j.error(I):this.j.info(I),I.includes("Connected to an existing tunnel process")&&(u=!0);const F=I.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(F){const M={link:F[1],domain:F[2],tunnelName:F[4],isAttached:u};this.G(D.TunnelStates.connected(M,w))}else I.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$s_b,this.G(D.TunnelStates.disconnected()))})}O(a,v,w=this.I){return(0,d.$Rg)(u=>new Promise((p,I)=>{u.isCancellationRequested&&p(-1);let T;const F=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{T&&(this.j.info(`${a} terminating(${T.pid})`),T.kill())}),!this.C.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${a} Spawning: cargo run -- tunnel ${v.join(" ")}
`,!1),T=(0,g.spawn)("cargo",["run","--","tunnel",...v],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:F});else{w(`Running tunnel CLI
`,!1);const M=this.J();w(`${a} Spawning: ${M} tunnel ${v.join(" ")}
`,!1),T=(0,g.spawn)(M,["tunnel",...v],{cwd:(0,b.homedir)(),stdio:F})}T.stdout.pipe(new m.$lU(`
`)).on("data",M=>{if(T){const z=M.toString();w(z,!1)}}),T.stderr.pipe(new m.$lU(`
`)).on("data",M=>{if(T){const z=M.toString();w(z,!0)}}),T.on("exit",M=>{T&&(w(`${a} exit(${T.pid}): + ${M} `,!1),T=void 0,p(M||0))}),T.on("error",M=>{T&&(w(`${a} error(${T.pid}): + ${M} `,!0),T=void 0,I())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$v_b)}Q(){let a=this.D.getValue(D.$u_b)||(0,b.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(n,-1),v=this.F.getBoolean(o,-1,!1);if(a){const w=JSON.parse(a);if(w&&(0,f.$Gf)(w.accountLabel)&&(0,f.$Gf)(w.sessionId)&&(0,f.$Gf)(w.providerId))return{active:!0,session:w,asService:v};this.j.error("Problems restoring session from storage, invalid format",w)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$s_b}S(a){if(a.active){const v={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(n,JSON.stringify(v),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(n,-1),this.F.remove(o,-1)}};e.$B_b=s,e.$B_b=s=ye([X(0,A.$sl),X(1,C.$Dj),X(2,j.$_h),X(3,R.$mj),X(4,c.$z_b),X(5,$.$xi),X(6,l.$jp)],s);function i(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&i(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,19,68,21,77,17]),function(ne,e,D,N,A,j,O,R,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;class C extends R.$lp{constructor(d,c,$,y){super(),this.bb=d,this.cb=c,this.db=$,this.eb=y,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Sc),this.ab=this.hb(this.bb)}fb(){const d=this.B(new k.$lFb(this.db.getChannel("storage"))),c=this.B(new O.$fp(d));return this.B(c.onDidChangeStorage($=>this.u(-1,$))),c}gb(d){this.X.clear(),this.W=d;let c;if((0,R.$mp)(d))c=this.U;else{const $=this.X.add(new k.$mFb(this.db.getChannel("storage"),d));c=this.X.add(new O.$fp($))}return this.X.add(c.onDidChangeStorage($=>this.u(0,$))),c}hb(d){this.$.clear(),this.Z=d?.id;let c;if(d){const $=this.$.add(new k.$nFb(this.db.getChannel("storage"),d));c=this.$.add(new O.$fp($)),this.$.add(c.onDidChangeStorage(y=>this.u(1,y)))}return c}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(d){switch(d){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(d){switch(d){case-1:return this.s.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:A.Schemas.file}).fsPath;default:return this.Z?`${(0,j.$Fg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:A.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(R.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(d){if(!this.M(this.W,d))return;const c=this.Y,$=c.items;c!==this.U&&await c.close(),this.Y=this.gb(d),await this.Y.init(),this.N($,this.Y,0)}async S(d,c){const $=this.ab,y=$?.items??new Map;await $?.close(),this.ab=this.hb(d),await this.ab.init(),this.N(y,this.ab,1)}hasScope(d){return(0,g.$Zk)(d)?this.W.id===d.id:this.Z===d.id}}e.$G_b=C}),define(le[253],he([0,1,3,2,17,92]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=e.$qO=void 0;class O{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,d=>({all:d.all.map(c=>(0,j.$4m)({...c},S)),added:d.added.map(c=>(0,j.$4m)({...c},S)),removed:d.removed.map(c=>(0,j.$4m)({...c},S)),updated:d.updated.map(c=>(0,j.$4m)({...c},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const d=this.b(g);switch(C){case"createProfile":{const c=await this.a.createProfile(S[0],S[1],S[2]);return(0,j.$4m)({...c},d)}case"updateProfile":{let c=(0,A.$2k)((0,j.$5m)(S[0],d),this.a.profilesHome.scheme);return c=await this.a.updateProfile(c,S[1]),(0,j.$4m)({...c},d)}case"removeProfile":{const c=(0,A.$2k)((0,j.$5m)(S[0],d),this.a.profilesHome.scheme);return this.a.removeProfile(c)}}throw new Error(`Invalid call ${C}`)}}e.$qO=O;class R extends N.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new D.$Td),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(d=>(0,A.$2k)(d,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(d=>{const c=d.added.map(b=>(0,A.$2k)(b,this.profilesHome.scheme)),$=d.removed.map(b=>(0,A.$2k)(b,this.profilesHome.scheme)),y=d.updated.map(b=>(0,A.$2k)(b,this.profilesHome.scheme));this.a=d.all.map(b=>(0,A.$2k)(b,this.profilesHome.scheme)),this.b.fire({added:c,removed:$,updated:y,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const d=await this.f.call("createNamedProfile",[g,C,S]);return(0,A.$2k)(d,this.profilesHome.scheme)}async createProfile(g,C,S,d){const c=await this.f.call("createProfile",[g,C,S,d]);return(0,A.$2k)(c,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,A.$2k)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,A.$2k)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$rO=R}),define(le[60],he([0,1,2,68,4,21,3,77,17]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rFb=e.$qFb=e.$pFb=void 0,e.$pFb=(0,A.$4h)("IUserDataProfileStorageService");let g=class extends D.$Tc{constructor(c){super(),this.a=c}async readStorageData(c){return this.withProfileScopedStorageService(c,async $=>this.b($))}async updateStorageData(c,$,y){return this.withProfileScopedStorageService(c,async b=>this.c(b,$,y))}async withProfileScopedStorageService(c,$){if(this.a.hasScope(c))return $(this.a);const y=await this.g(c),b=new S(y);try{await b.initialize();const l=await $(b);return await b.flush(),l}finally{b.dispose(),await this.f(y)}}b(c){const $=new Map,y=b=>{for(const l of c.keys(0,b))$.set(l,{value:c.get(l,0),target:b})};return y(0),y(1),$}c(c,$,y){c.storeAll(Array.from($.entries()).map(([b,l])=>({key:b,value:l,scope:0,target:y})),!0)}async f(c){try{await c.close()}finally{(0,D.$Nc)(c)&&c.dispose()}}};e.$qFb=g,e.$qFb=g=ye([X(0,j.$jp)],g);class C extends g{constructor(c,$,y,b){super(y),this.j=c;const l=c.getChannel("profileStorageListener"),f=this.B(new D.$Uc);this.h=this.B(new O.$Td({onWillAddFirstListener:()=>{f.value=l.listen("onDidChange")(m=>{b.trace("profile storage changes",m),this.h.fire({targetChanges:m.targetChanges.map(h=>(0,k.$2k)(h,$.profilesHome.scheme)),valueChanges:m.valueChanges.map(h=>({...h,profile:(0,k.$2k)(h.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(c){const $=this.j.getChannel("storage");return(0,j.$mp)(c)?new R.$lFb($):new R.$mFb($,c)}}e.$rFb=C;class S extends j.$lp{constructor(c){super({flushInterval:100}),this.s=this.B(new N.$fp(c))}O(){return this.s.init()}P(c){return c===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,21,8,17,56,60]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=void 0;let R=class extends O.$rFb{constructor(g,C,S,d){super(g,C,S,d)}};e.$l_b=R,e.$l_b=R=ye([X(0,j.$J$b),X(1,A.$1k),X(2,D.$jp),X(3,N.$lj)],R)}),define(le[39],he([0,1,18,6,15,26,3,35,2,27,12,169,20,14,11,8,43,21,22,28,24,17]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oGb=e.$nGb=e.$mGb=e.$lGb=e.$kGb=e.$jGb=e.$iGb=void 0;function n(v){return!!(v&&v.ref!==void 0&&typeof v.ref=="string"&&v.ref!==""&&v.syncData!==void 0&&(v.syncData===null||o(v.syncData)))}e.$iGb=n;function o(v){return!!(v&&v.version!==void 0&&typeof v.version=="number"&&v.content!==void 0&&typeof v.content=="string"&&(Object.keys(v).length===2||Object.keys(v).length===3&&v.machineId!==void 0&&typeof v.machineId=="string"))}e.$jGb=o;function s(v,w){return`${(0,g.$yf)(v)}${w.isDefault?"":` (${w.name})`}`}e.$kGb=s;let i=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(w,u,p,I,T,F,M,z,Z,J,x,G){super(),this.syncResource=w,this.collection=u,this.G=p,this.H=I,this.I=T,this.J=F,this.L=M,this.M=z,this.N=Z,this.O=J,this.P=x,this.c=null,this.m="idle",this.n=this.B(new O.$Td),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$Td),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$2g(50)),this.w=this.B(new O.$Td),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=s(w.syncResource,w.profile),this.h=G.extUri,this.f=this.h.joinPath(I.userDataSyncHome,...(0,h.$Xmb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,h.$gnb),this.y=(0,h.$Ymb)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,I,this.h),this.j=(0,b.$pp)(I,p,T)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const u=await this.Y(w.remoteUserData,w.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.ub(w):!0)&&this.w.fire()}}S(w){this.m!==w&&(this.m=w,this.n.fire(w))}async sync(w,u={}){await this.U(w,!0,this.ob(),u)}async preview(w,u,p={}){return this.U(w,!1,u,p)}async apply(w,u={}){try{this.F={...u};const p=await this.ab(w);return this.S(p),this.c}finally{this.F={}}}async U(w,u,p,I){try{if(this.F={...I},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let T="idle";try{const F=await this.getLastSyncUserData(),M=await this.X(w,F);return T=await this.Y(M,F,u,p),T==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):T==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(T)}}finally{this.F={}}}async replace(w){const u=this.kb(w);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),I=await this.X(null,p),T=await this.W(I),F=await this.qb({ref:I.ref,syncData:u},p,T,this.ob(),j.CancellationToken.None),M=[];for(const z of F){const Z=await this.sb(z,z.remoteResource,void 0,j.CancellationToken.None),{remoteChange:J}=await this.sb(z,z.previewResource,z.remoteContent,j.CancellationToken.None);M.push([z,{...Z,remoteChange:J!==0?J:2}])}await this.tb(I,p,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(w){const u=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===u}async X(w,u){if(u){const p=w?w[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(w,u,p,I){if(w.syncData&&w.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new h.$6mb((0,S.localize)(0,null,this.resource,this.pb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(w,u,p,I)}catch(T){if(T instanceof h.$6mb)switch(T.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(w,u,p,I);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(w,u,p,I)}throw T}}async Z(w,u,p,I){try{const T=await this.W(w),F=!T&&u===null&&this.gb()!==void 0,M=p&&!F;this.c||(this.c=(0,N.$Rg)(Z=>this.eb(w,u,T,M,I,Z)));let z=await this.c;if(p&&F){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Z of z.resourcePreviews)z=await this.accept(Z.remoteResource)||z}return this.cb(z.resourcePreviews),z.resourcePreviews.some(({mergeState:Z})=>Z==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(T){throw this.c=null,T}}async merge(w){return await this.$(w,async u=>{const p=await this.rb(u,j.CancellationToken.None);await this.G.writeFile(u.previewResource,A.$he.fromString(p?.content||""));const I=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,j.CancellationToken.None):void 0;return u.acceptResult=I,u.mergeState=p.hasConflicts?"conflict":I?"accepted":"preview",u.localChange=I?I.localChange:p.localChange,u.remoteChange=I?I.remoteChange:p.remoteChange,u}),this.c}async accept(w,u){return await this.$(w,async p=>{const I=await this.sb(p,w,u,j.CancellationToken.None);return p.acceptResult=I,p.mergeState="accepted",p.localChange=I.localChange,p.remoteChange=I.remoteChange,p}),this.c}async discard(w){return await this.$(w,async u=>{const p=await this.rb(u,j.CancellationToken.None);return await this.G.writeFile(u.previewResource,A.$he.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(w,u){if(!this.c)return;let p=await this.c;const I=p.resourcePreviews.findIndex(({localResource:T,remoteResource:F,previewResource:M})=>this.h.isEqual(T,w)||this.h.isEqual(F,w)||this.h.isEqual(M,w));I!==-1&&(this.c=(0,N.$Rg)(async T=>{const F=[...p.resourcePreviews];return F[I]=await u(F[I]),{...p,resourcePreviews:F}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:T})=>T==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(w){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),w),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(w){const u=w.filter(({mergeState:p})=>p==="conflict");(0,D.$ub)(this.s,u,(p,I)=>this.h.isEqual(p.previewResource,I.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async db(w){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,w))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,w))return p.remoteContent;if(this.h.isEqual(p.localResource,w))return p.localContent;if(this.h.isEqual(p.baseResource,w))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(w){(0,$.$Fk)(w)!==1&&this.O.error(w)}}async eb(w,u,p,I,T,F){const M=await this.qb(w,u,p,T,F),z=[];for(const Z of M){const J=Z.previewResource.with({scheme:h.$fnb,authority:"accepted"});if(Z.localChange===0&&Z.remoteChange===0)z.push({...Z,acceptedResource:J,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=I?await this.rb(Z,F):void 0;if(F.isCancellationRequested)break;await this.G.writeFile(Z.previewResource,A.$he.fromString(x?.content||""));const G=x&&!x.hasConflicts?await this.sb(Z,Z.previewResource,void 0,F):void 0;z.push({...Z,acceptResult:G,mergeState:x?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:x?x.localChange:Z.localChange,remoteChange:G?G.remoteChange:x?x.remoteChange:Z.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:u,resourcePreviews:z,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let w=this.gb();if(w||(w=await this.jb()),!w)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(w),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let I,T=1;for(;I===void 0&&T++<6;)try{const F=await this.hb();F&&(F.ref===u.ref?I=F.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof $.$Jk&&F.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(F instanceof h.$6mb)throw F;this.O.error(F,T)}}if(I===void 0)try{const F=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);I=F===null?null:this.kb(F),await this.ib({ref:u.ref,syncData:I})}catch(F){if(F instanceof h.$6mb&&F.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw F}return I===void 0?null:{...u,syncData:I}}async fb(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),I={ref:w.ref,version:p,...u};this.I.store(this.z,JSON.stringify(I),-1,1),await this.ib(w)}gb(){return this.I.get(this.z,-1)}async hb(){const w=(await this.G.readFile(this.y)).value.toString();try{const u=w?JSON.parse(w):void 0;if(n(u))return u}catch(u){this.O.error(u)}}async ib(w){await this.G.writeFile(this.y,A.$he.fromString(JSON.stringify(w)))}async jb(){try{const w=await this.G.readFile(this.y),u=JSON.parse(w.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(w){w instanceof $.$Jk&&w.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(w)}return this.I.get(this.z,-1)}async getRemoteUserData(w){const{ref:u,content:p}=await this.lb(w);let I=null;return p!==null&&(I=this.kb(p)),{ref:u,syncData:I}}kb(w){try{const u=JSON.parse(w);if(o(u))return u}catch(u){this.O.error(u)}throw new h.$6mb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(w){const u=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(w,u){const p=await this.j,I={version:this.pb,machineId:p,content:w};try{return u=await this.J.writeResource(this.resource,JSON.stringify(I),u,this.collection,this.F),{ref:u,syncData:I}}catch(T){throw T instanceof h.$6mb&&T.code==="TooLarge"&&(T=new h.$6mb(T.message,T.code,this.resource)),T}}async nb(w){const u={version:this.pb,content:w};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(h.$Smb)}};e.$lGb=i,e.$lGb=i=ye([X(2,$.$ok),X(3,c.$$h),X(4,l.$jp),X(5,h.$1mb),X(6,h.$2mb),X(7,h.$$mb),X(8,f.$sl),X(9,h.$dnb),X(10,d.$xi),X(11,m.$Yk)],i);let t=class extends i{constructor(w,u,p,I,T,F,M,z,Z,J,x,G,Q){super(u,p,I,T,F,M,z,Z,J,x,G,Q),this.r=w,this.B(this.G.watch(this.h.dirname(w))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(w,u,p){try{u?await this.G.writeFile(this.r,A.$he.fromString(w),p?void 0:u):await this.G.createFile(this.r,A.$he.fromString(w),{overwrite:p})}catch(I){throw I instanceof $.$Jk&&I.fileOperationResult===1||I instanceof $.$Jk&&I.fileOperationResult===3?new h.$6mb(I.message,"LocalPreconditionFailed"):I}}async xb(){try{await this.G.del(this.r)}catch(w){if(!(w instanceof $.$Jk&&w.fileOperationResult===1))throw w}}yb(w){w.contains(this.r)&&this.Q()}};e.$mGb=t,e.$mGb=t=ye([X(3,$.$ok),X(4,c.$$h),X(5,l.$jp),X(6,h.$1mb),X(7,h.$2mb),X(8,h.$$mb),X(9,f.$sl),X(10,h.$dnb),X(11,d.$xi),X(12,m.$Yk)],t);let r=class extends t{constructor(w,u,p,I,T,F,M,z,Z,J,x,G,Q,V){super(w,u,p,I,T,F,M,z,Z,J,x,Q,V),this.zb=G,this.Bb=void 0}Ab(w,u){const p=[],I=(0,R.$an)(w,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$Nf)(I)&&u!==Array.isArray(I)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$nGb=r,e.$nGb=r=ye([X(3,$.$ok),X(4,c.$$h),X(5,l.$jp),X(6,h.$1mb),X(7,h.$2mb),X(8,h.$$mb),X(9,f.$sl),X(10,h.$dnb),X(11,h.$cnb),X(12,d.$xi),X(13,m.$Yk)],r);let a=class{constructor(w,u,p,I,T,F,M){this.resource=w,this.g=u,this.h=p,this.j=I,this.k=T,this.l=F,this.d=M.extUri,this.f=(0,h.$Ymb)(void 0,this.resource,p,this.d)}async initialize({ref:w,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:w,syncData:p})}catch(I){this.j.error(I)}}m(w){try{const u=JSON.parse(w);if(o(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:w.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,A.$he.fromString(JSON.stringify(w)))}};e.$oGb=a,e.$oGb=a=ye([X(1,E.$1k),X(2,c.$$h),X(3,y.$lj),X(4,$.$ok),X(5,l.$jp),X(6,m.$Yk)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,20,14,114,29,33,82,44,11,4,73,8,21,22,28,17,39,234,111,24,60]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o,s,i,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=e.$26b=e.$16b=e.$Z6b=e.$Y6b=void 0;async function v(F,M){const z=JSON.parse(F.content);if(F.version===1||F.version===2){const Z=(await M.getInstalled(0)).filter(J=>J.isBuiltin);for(const J of z)F.version===1&&(J.enabled===!1&&(J.disabled=!0),delete J.enabled),F.version===2&&Z.every(x=>!(0,c.$Po)(x.identifier,J.identifier))&&(J.installed=!0)}return z}function w(F){return JSON.parse(F.content)}e.$Y6b=w;function u(F,M){return F.sort((z,Z)=>!z.identifier.uuid&&Z.identifier.uuid?-1:z.identifier.uuid&&!Z.identifier.uuid?1:(0,k.$3e)(z.identifier.id,Z.identifier.id)),M?(0,O.$1T)(F,{}):JSON.stringify(F)}e.$Z6b=u;let p=class extends s.$lGb{constructor(M,z,Z,J,x,G,Q,V,B,te,se,_,oe,K,U,P,L){super({syncResource:"extensions",profile:M},z,J,Z,x,G,Q,_,oe,te,se,U),this.Cb=V,this.Db=B,this.Eb=L,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$fnb,authority:"base"}),this.yb=this.wb.with({scheme:r.$fnb,authority:"local"}),this.zb=this.wb.with({scheme:r.$fnb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$fnb,authority:"accepted"}),this.Bb=this.Eb.createInstance(I),this.B(j.Event.any(j.Event.filter(this.Cb.onDidInstallExtensions,H=>H.some(({local:q})=>!!q)),j.Event.filter(this.Cb.onDidUninstallExtension,H=>!H.error),j.Event.filter(P.onDidChange,H=>H.valueChanges.some(({profile:q,changes:ee})=>this.syncResource.profile.id===q.id&&ee.some(W=>W.key===d.$qo))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,z){const Z=M.syncData?await v(M.syncData,this.Cb):null,J=z?.skippedExtensions??[],x=z?.builtinExtensions??null,G=z?.syncData?await v(z.syncData,this.Cb):null,{localExtensions:Q,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);Z?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:te}=(0,i.$X6b)(Q,Z,G,J,V,x),se={local:B,remote:te,content:this.Hb(Q,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:te!==null?2:0},_=this.Ob(Q,!1);return[{skippedExtensions:J,builtinExtensions:x,baseResource:this.xb,baseContent:G?this.Ob(G,!1):_,localResource:this.yb,localContent:_,localExtensions:Q,remoteResource:this.zb,remoteExtensions:Z,remoteContent:Z?this.Ob(Z,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(M){const z=M.syncData?await v(M.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:J}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,i.$X6b)(Z,z,z,M.skippedExtensions||[],J,M.builtinExtensions||[]);return x!==null}Hb(M,z,Z,J){const x=[...z,...Z],G=new Set,Q=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};x.forEach(({identifier:V})=>Q(V)),J.forEach(Q);for(const V of M)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||x.push(V);return this.Ob(x,!1)}async rb(M,z){return{...M.previewResult,hasConflicts:!1}}async sb(M,z,Z,J){if(this.h.isEqual(z,this.yb))return this.Kb(M);if(this.h.isEqual(z,this.zb))return this.Lb(M);if(this.h.isEqual(z,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${z.toString()}`)}async Kb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),J=(0,i.$X6b)(M.localExtensions,null,null,M.skippedExtensions,Z,M.builtinExtensions),{local:x,remote:G}=J;return{content:M.localContent,local:x,remote:G,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Lb(M){const z=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Z=this.Db.getIgnoredExtensions(z),J=M.remoteContent?JSON.parse(M.remoteContent):null;if(J!==null){const x=(0,i.$X6b)(M.localExtensions,J,M.localExtensions,[],Z,M.builtinExtensions),{local:G,remote:Q}=x;return{content:M.remoteContent,local:G,remote:Q,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:Q!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,z,Z,J){let{skippedExtensions:x,builtinExtensions:G,localExtensions:Q}=Z[0][0];const{local:V,remote:B,localChange:te,remoteChange:se}=Z[0][1];if(te===0&&se===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),te!==0&&(await this.nb(JSON.stringify(Q)),x=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,x,this.syncResource.profile)),B){this.O.trace(`${this.D}: Updating remote extensions...`);const _=JSON.stringify(B.all);M=await this.mb(_,J?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(oe=>oe.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(oe=>oe.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(oe=>oe.identifier.id))}.`:""}`)}z?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(Q,G),await this.fb(M,{skippedExtensions:x,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(_=>_.identifier.id))}.`:""}`))}Nb(M,z){const Z=new Set,J=[];for(const x of M)Z.add(x.identifier.id.toLowerCase()),x.installed||J.push(x.identifier);if(z)for(const x of z)Z.has(x.id.toLowerCase())||J.push(x);return J}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const z=await this.db(M);return z&&this.Ob(JSON.parse(z),!0)}return null}Ob(M,z){return u(M,z)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(z=>z.installed||z.disabled))return!0}catch{}return!1}};e.$16b=p,e.$16b=p=ye([X(2,C.$$h),X(3,b.$ok),X(4,h.$jp),X(5,r.$1mb),X(6,r.$2mb),X(7,d.$po),X(8,t.$6Gb),X(9,r.$dnb),X(10,g.$xi),X(11,r.$$mb),X(12,E.$sl),X(13,$.$cv),X(14,n.$Yk),X(15,a.$pFb),X(16,l.$3h)],p);let I=class{constructor(M,z,Z,J,x,G){this.a=M,this.b=z,this.c=Z,this.d=J,this.f=x,this.g=G}async getLocalExtensions(M){const z=await this.a.getInstalled(void 0,M.extensionsResource),Z=this.d.getIgnoredExtensions(z);return{localExtensions:await this.j(M,async(x,G)=>{const Q=x.getDisabledExtensions();return z.map(V=>{const{identifier:B,isBuiltin:te,manifest:se,preRelease:_,pinned:oe,isApplicationScoped:K}=V,U={identifier:B,preRelease:_,version:se.version,pinned:!!oe};K&&!(0,y.$mm)(se)&&(U.isApplicationScoped=K),Q.some(P=>(0,c.$Po)(P,B))&&(U.disabled=!0),te||(U.installed=!0);try{const P=G.getKeysForSync({id:B.id,version:se.version});if(P){const L=G.getExtensionState(V,!0)||{};U.state=Object.keys(L).reduce((H,q)=>(P.includes(q)&&(H[q]=L[q]),H),{})}}catch(P){this.g.info(`${(0,s.$kGb)("extensions",M)}: Error while parsing extension state`,(0,A.$0)(P))}return U})}),ignoredExtensions:Z}}async updateLocalExtensions(M,z,Z,J,x){const G=(0,s.$kGb)("extensions",x),Q=[],V=new Map,B=[],te=[],se=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Z.length)&&await this.j(x,async(K,U)=>{await D.Promises.settled([...M,...Z].map(async P=>{const L=se.find(ee=>(0,c.$Po)(ee.identifier,P.identifier));if(L&&L.isBuiltin){P.state&&L.manifest.version===P.version&&this.h(P.state,L,L.manifest.version,U),K.getDisabledExtensions().some(W=>(0,c.$Po)(W,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${G}: Disabling extension...`,P.identifier.id),await K.disableExtension(P.identifier),this.g.info(`${G}: Disabled extension`,P.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,P.identifier.id),await K.enableExtension(P.identifier),this.g.info(`${G}: Enabled extension`,P.identifier.id))),B.push(P.identifier);return}const H=P.pinned?P.version:void 0,q=(await this.c.getExtensions([{...P.identifier,version:H,preRelease:H?void 0:P.preRelease}],N.CancellationToken.None))[0];if(P.state&&(L?L.manifest.version===P.version:q)&&this.h(P.state,L||q,L?.manifest.version,U),q)try{K.getDisabledExtensions().some(W=>(0,c.$Po)(W,P.identifier))!==!!P.disabled&&(P.disabled?(this.g.trace(`${G}: Disabling extension...`,P.identifier.id,q.version),await K.disableExtension(q.identifier),this.g.info(`${G}: Disabled extension`,P.identifier.id,q.version)):(this.g.trace(`${G}: Enabling extension...`,P.identifier.id,q.version),await K.enableExtension(q.identifier),this.g.info(`${G}: Enabled extension`,P.identifier.id,q.version))),(!L||L.preRelease!==P.preRelease||L.pinned!==P.pinned||H&&L.manifest.version!==H)&&(await this.a.canInstall(q)?(Q.push({extension:q,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:P.pinned&&!!P.version,installPreReleaseVersion:P.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:P.isApplicationScoped,context:{[d.$eo]:!0,[d.$fo]:!0}}}),V.set(q.identifier.id.toLowerCase(),P)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,q.displayName||q.identifier.id),te.push(P)))}catch(ee){te.push(P),this.g.error(ee),this.g.info(`${G}: Skipped synchronizing extension`,q.displayName||q.identifier.id)}else te.push(P),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,P.identifier.id)}))}),z.length){const K=se.filter(({identifier:U,isBuiltin:P})=>!P&&z.some(L=>(0,c.$Po)(U,L)));await D.Promises.settled(K.map(async U=>{this.g.trace(`${G}: Uninstalling local extension...`,U.identifier.id),await this.a.uninstall(U,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,U.identifier.id),B.push(U.identifier)}))}const _=await this.a.installGalleryExtensions(Q);for(const{identifier:K,local:U,error:P,source:L}of _){const H=L;if(U)this.g.info(`${G}: Installed extension.`,K.id,H.version),B.push(K);else{const q=V.get(K.id.toLowerCase());q&&(te.push(q),this.g.info(`${G}: Skipped synchronizing extension`,H.displayName||H.identifier.id)),P instanceof d.$oo&&[d.ExtensionManagementErrorCode.Incompatible,d.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(P.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,H.displayName||H.identifier.id):P&&this.g.error(P)}}const oe=[];for(const K of J)B.some(U=>(0,c.$Po)(U,K.identifier))||oe.push(K);for(const K of te)oe.some(U=>(0,c.$Po)(U.identifier,K.identifier))||oe.push(K);return oe}h(M,z,Z,J){const x=J.getExtensionState(z,!0)||{},G=Z?J.getKeysForSync({id:z.identifier.id,version:Z}):void 0;G?G.forEach(Q=>{x[Q]=M[Q]}):Object.keys(M).forEach(Q=>x[Q]=M[Q]),J.setExtensionState(z,x,!0)}async j(M,z){return this.b.withProfileScopedStorageService(M,async Z=>{const J=new R.$Sc,x=this.f.createChild(new f.$2h([h.$jp,Z])),G=J.add(x.createInstance(S.$NEb)),Q=J.add(x.createInstance($.$dv));try{return await z(G,Q)}finally{J.dispose()}})}};e.$26b=I,e.$26b=I=ye([X(0,d.$po),X(1,a.$pFb),X(2,d.$no),X(3,t.$6Gb),X(4,l.$3h),X(5,r.$dnb)],I);let T=class extends s.$oGb{constructor(M,z,Z,J,x,G,Q,V){super("extensions",J,x,G,Z,Q,V),this.p=M,this.q=z}async t(M){return M.syncData?await v(M.syncData,this.p):null}u(M,z){const Z=[],J=[],x=[];for(const G of M){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const Q=z.find(V=>(0,c.$Po)(V.identifier,G.identifier));Q?(Z.push(Q),G.disabled&&x.push(G.identifier)):G.installed&&(J.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&x.push(G.identifier))}return{installedExtensions:Z,newExtensions:J,disabledExtensions:x,remoteExtensions:M}}};e.$36b=T,e.$36b=T=ye([X(0,d.$po),X(1,t.$6Gb),X(2,b.$ok),X(3,o.$1k),X(4,C.$$h),X(5,m.$lj),X(6,h.$jp),X(7,n.$Yk)],T)}),define(le[116],he([0,1,15,7,3,35,42,5,32,20,14,11,8,43,21,22,28,39,79,238,24,17,60,4]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uGb=e.$tGb=e.$sGb=e.$rGb=e.$qGb=void 0;const s="globalState.argv.",i=["locale"];function t(p,I){const T=p.storage?Object.keys(p.storage).sort():[],F={};return T.forEach(M=>F[M]=p.storage[M]),p.storage=F,I?(0,O.$1T)(p,{}):JSON.stringify(p)}e.$qGb=t;const r=1;let a=class extends l.$lGb{constructor(I,T,F,M,z,Z,J,x,G,Q,V,B,te,se){super({syncResource:"globalState",profile:I},T,M,x,B,z,Z,G,Q,J,V,te),this.Bb=F,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:h.$fnb,authority:"base"}),this.xb=this.vb.with({scheme:h.$fnb,authority:"local"}),this.yb=this.vb.with({scheme:h.$fnb,authority:"remote"}),this.zb=this.vb.with({scheme:h.$fnb,authority:"accepted"}),this.Ab=se.createInstance(v),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(A.Event.any(A.Event.filter(M.onDidFilesChange,_=>_.contains(this.H.argvResource)),A.Event.filter(F.onDidChange,_=>!!(_.targetChanges.some(oe=>this.syncResource.profile.id===oe.id)||_.valueChanges.some(({profile:oe,changes:K})=>this.syncResource.profile.id===oe.id&&K.some(U=>U.target===0)))))(()=>this.Q()))}async qb(I,T,F){const M=I.syncData?JSON.parse(I.syncData.content):null;T=T===null&&F?I:T;const z=T&&T.syncData?JSON.parse(T.syncData.content):null,Z=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const J=await this.Jb(z),{local:x,remote:G}=(0,m.$pGb)(Z.storage,M?M.storage:null,z?z.storage:null,J,this.O),Q={content:null,local:x,remote:G,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:G.all!==null?2:0},V=t(Z,!1);return[{baseResource:this.wb,baseContent:z?t(z,!1):V,localResource:this.xb,localContent:V,localUserData:Z,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Q,localChange:Q.localChange,remoteChange:Q.remoteChange,acceptedResource:this.zb,storageKeys:J}]}async ub(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(T===null)return!0;const F=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(T),{remote:z}=(0,m.$pGb)(F.storage,T.storage,T.storage,M,this.O);return z.all!==null}async rb(I,T){return{...I.previewResult,hasConflicts:!1}}async sb(I,T,F,M){if(this.h.isEqual(T,this.xb))return this.Gb(I);if(this.h.isEqual(T,this.yb))return this.Hb(I);if(this.h.isEqual(T,this.vb))return I.previewResult;throw new Error(`Invalid Resource: ${T.toString()}`)}async Gb(I){return{content:I.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(I.localUserData.storage),removed:[],updated:[],all:I.localUserData.storage},localChange:0,remoteChange:2}}async Hb(I){if(I.remoteContent!==null){const T=JSON.parse(I.remoteContent),{local:F,remote:M}=(0,m.$pGb)(I.localUserData.storage,T.storage,null,I.storageKeys,this.O);return{content:I.remoteContent,local:F,remote:M,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:I.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(I,T,F,M){const{localUserData:z}=F[0][0],{local:Z,remote:J,localChange:x,remoteChange:G}=F[0][1];if(x===0&&G===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(z)),await this.Ab.writeLocalGlobalState(Z,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Q=JSON.stringify({storage:J.all});I=await this.mb(Q,M?null:I.ref),this.O.info(`${this.D}: Updated remote ui state.${J.added.length?` Added: ${J.added}.`:""}${J.updated.length?` Updated: ${J.updated}.`:""}${J.removed.length?` Removed: ${J.removed}.`:""}`)}T?.ref!==I.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(I),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(I){if(this.h.isEqual(this.yb,I)||this.h.isEqual(this.wb,I)||this.h.isEqual(this.xb,I)||this.h.isEqual(this.zb,I)){const T=await this.db(I);return T&&t(JSON.parse(T),!0)}return null}async hasLocalData(){try{const{storage:I}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(I).length>1||I[`${s}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(I){const T=await this.Bb.readStorageData(this.syncResource.profile),F=[],M=[];for(const[J,x]of T)x.target===0?F.push(J):x.target===1&&M.push(J);const z=[...F,...M],Z=I?.storage?Object.keys(I.storage).filter(J=>!J.startsWith(s)&&!z.includes(J)&&T.get(J)!==void 0):[];if(!R.$o){const J=[...h.$Wmb.map(x=>(0,h.$0mb)(x)),h.$9mb];Z.push(...J),M.push(...J)}return{user:F,machine:M,unregistered:Z}}};e.$rGb=a,e.$rGb=a=ye([X(2,n.$pFb),X(3,S.$ok),X(4,h.$1mb),X(5,h.$2mb),X(6,h.$dnb),X(7,C.$$h),X(8,h.$$mb),X(9,y.$sl),X(10,g.$xi),X(11,$.$jp),X(12,b.$Yk),X(13,o.$3h)],a);let v=class{constructor(I,T,F,M){this.a=I,this.b=T,this.c=F,this.d=M}async getLocalGlobalState(I){const T={};if(I.isDefault){const M=await this.f(),z=(0,j.$an)(M);for(const Z of i)z[Z]!==void 0&&(T[`${s}${Z}`]={version:1,value:z[Z]})}const F=await this.c.readStorageData(I);for(const[M,z]of F)z.value&&z.target===0&&(T[M]={version:1,value:z.value});return{storage:T}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const I=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),I.value.toString()}catch(I){this.d.debug((0,N.$0)(I))}return"{}"}async writeLocalGlobalState({added:I,removed:T,updated:F},M){const z=(0,l.$kGb)("globalState",M),Z={},J=new Map,x=await this.c.readStorageData(M),G=(Q,V)=>{for(const B of Q){if(B.startsWith(s)){Z[B.substring(s.length)]=V?V[B].value:void 0;continue}if(V){const te=V[B];te.value!==x.get(B)?.value&&J.set(B,te.value)}else x.get(B)!==void 0&&J.set(B,void 0)}};if(G(Object.keys(I),I),G(Object.keys(F),F),G(T),Object.keys(Z).length){this.d.trace(`${z}: Updating locale...`);const Q=await this.f();let V=Q;for(const B of Object.keys(Z))V=(0,f.edit)(V,[B],Z[B],{});Q!==V&&(this.d.trace(`${z}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$he.fromString(V)),this.d.info(`${z}: Updated locale.`)),this.d.info(`${z}: Updated locale`)}J.size&&(this.d.trace(`${z}: Updating global state...`),await this.c.updateStorageData(M,J,0),this.d.info(`${z}: Updated global state`,[...J.keys()]))}};e.$sGb=v,e.$sGb=v=ye([X(0,S.$ok),X(1,C.$$h),X(2,n.$pFb),X(3,h.$dnb)],v);let w=class extends l.$oGb{constructor(I,T,F,M,z,Z){super("globalState",F,M,z,T,I,Z)}async o(I){const T=I.syncData?JSON.parse(I.syncData.content):null;if(!T){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},M={};for(const z of Object.keys(T.storage))z.startsWith(s)?F[z.substring(s.length)]=T.storage[z].value:this.l.get(z,0)===void 0&&(M[z]=T.storage[z].value);if(Object.keys(F).length){let z="{}";try{z=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Z of Object.keys(F))z=(0,f.edit)(z,[Z],F[Z],{});await this.k.writeFile(this.h.argvResource,D.$he.fromString(z))}if(Object.keys(M).length){const z=[];for(const Z of Object.keys(M))z.push({key:Z,value:M[Z],scope:0,target:0});this.l.storeAll(z,!0)}}};e.$tGb=w,e.$tGb=w=ye([X(0,$.$jp),X(1,S.$ok),X(2,E.$1k),X(3,C.$$h),X(4,h.$dnb),X(5,b.$Yk)],w);let u=class{constructor(I,T,F,M,z){this.a=I,this.b=T,this.c=F,this.d=M,this.f=z}getSyncStoreType(I){return this.h(I)?.storage[h.$9mb]?.value}async sync(I){const T=(0,h.$5mb)((0,k.$og)());try{return await this.g(I,T)}catch(F){if(F instanceof h.$6mb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(I,T)}throw F}}async g(I,T){const F=await this.a.readResource("globalState",null,void 0,T),M=this.h(F)||{storage:{}};M.storage[h.$9mb]={value:I,version:r};const z=await(0,c.$pp)(this.c,this.d,this.b),Z={version:r,machineId:z,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Z),F.ref,void 0,T)}h({content:I}){if(!I)return null;const T=JSON.parse(I);if((0,l.$jGb)(T))return T?JSON.parse(T.content):null;throw new Error("Invalid remote data")}};e.$uGb=u,e.$uGb=u=ye([X(1,$.$jp),X(2,C.$$h),X(3,S.$ok),X(4,d.$lj)],u)}),define(le[117],he([0,1,18,15,3,35,5,12,170,20,14,11,21,22,28,17,39,235,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=e.$56b=void 0;function m(n,o,s){try{const i=JSON.parse(n);if(!o)return(0,R.$Nf)(i.all)?null:i.all;switch(O.OS){case 2:return(0,R.$Nf)(i.mac)?null:i.mac;case 3:return(0,R.$Nf)(i.linux)?null:i.linux;case 1:return(0,R.$Nf)(i.windows)?null:i.windows}}catch(i){return s.error(i),null}}e.$56b=m;let h=class extends b.$nGb{constructor(o,s,i,t,r,a,v,w,u,p,I,T,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},s,w,u,p,i,t,v,T,r,I,a,F),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$fnb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$fnb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$fnb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$fnb,authority:"accepted"}),this.B(A.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,s,i,t){const r=o.syncData?m(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;s=s===null&&i?o:s;const a=s?this.Ob(s):null,v=await this.vb(),w=await this.Cb();let u=null,p=!1,I=!1,T=!1;if(r){let z=v?v.value.toString():"[]";if(z=z||"[]",this.Ab(z,!0))throw new f.$6mb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==z||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Z=await(0,l.$46b)(z,r,a,w,this.zb);Z.hasChanges&&(u=Z.mergeContent,T=Z.hasConflicts,p=T||Z.mergeContent!==z,I=T||Z.mergeContent!==r)}}else v&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=v.value.toString(),I=!0);const F={content:T?a:u,localChange:p?v?2:1:0,remoteChange:I?2:0,hasConflicts:T},M=v?v.value.toString():null;return[{fileContent:v,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:F.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.Eb,previewResult:F,acceptedResource:this.Ib}]}async ub(o){const s=this.Ob(o);if(s===null)return!0;const i=await this.vb(),t=i?i.value.toString():"",r=await this.Cb(),a=await(0,l.$46b)(t||"[]",s,s,r,this.zb);return a.hasConflicts||a.mergeContent!==s}async rb(o,s){return o.previewResult}async sb(o,s,i,t){if(this.h.isEqual(s,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(s,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(s,this.Eb))return i===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${s.toString()}`)}async tb(o,s,i,t){const{fileContent:r}=i[0][0];let{content:a,localChange:v,remoteChange:w}=i[0][1];if(v===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$6mb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(v!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),w!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(u,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}s?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const s=(0,j.$an)(o.value.toString());if((0,D.$Lb)(s))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:m(o.syncData.content,this.Qb(),this.O)}Pb(o,s){let i={};try{i=JSON.parse(s||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete i.all:i.all=o,O.OS){case 2:i.mac=o;break;case 3:i.linux=o;break;case 1:i.windows=o;break}return JSON.stringify(i)}Qb(){return!!this.P.getValue(f.$Tmb)}};e.$66b=h,e.$66b=h=ye([X(2,f.$1mb),X(3,f.$2mb),X(4,f.$dnb),X(5,g.$xi),X(6,f.$$mb),X(7,S.$ok),X(8,C.$$h),X(9,d.$jp),X(10,f.$cnb),X(11,c.$sl),X(12,$.$Yk)],h);let E=class extends b.$oGb{constructor(o,s,i,t,r,a){super("keybindings",s,i,t,o,r,a)}async o(o){const s=o.syncData?this.p(o.syncData.content):null;if(!s){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$he.fromString(s)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),s=(0,j.$an)(o.value.toString());return!(0,D.$Lb)(s)}catch(o){return o.fileOperationResult===1}}p(o){try{return m(o,!0,this.j)}catch(s){return this.j.error(s),null}}};e.$76b=E,e.$76b=E=ye([X(0,S.$ok),X(1,y.$1k),X(2,C.$$h),X(3,f.$dnb),X(4,d.$jp),X(5,$.$Yk)],E)}),define(le[118],he([0,1,15,3,171,20,75,14,29,11,21,22,28,17,39,239,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=e.$96b=e.$86b=void 0;function l(E){return E&&E.settings&&typeof E.settings=="string"&&Object.keys(E).length===1}function f(E){const n=JSON.parse(E);return l(n)?n:{settings:E}}e.$86b=f;let m=class extends $.$nGb{constructor(n,o,s,i,t,r,a,v,w,u,p,I,T,F){super(n.settingsResource,{syncResource:"settings",profile:n},o,s,i,t,r,a,p,I,v,w,u,F),this.Eb=T,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:b.$fnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.$fnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.$fnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.$fnb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(n){const o=await this.getLastSyncUserData(),s=await this.X(n,o),i=this.Lb(s),t=new O.$Sn(b.$Smb);return i?.settings&&t.parse(i.settings),t.configurationModel.getValue(b.$Smb)||{}}async qb(n,o,s){const i=await this.vb(),t=await this.Cb(),r=this.Lb(n);o=o===null&&s?n:o;const a=o?this.Lb(o):null,v=await this.Pb();let w=null,u=!1,p=!1,I=!1;if(r){let z=i?i.value.toString().trim():"{}";z=z||"{}",this.Qb(z),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Z=(0,y.$9Eb)(z,r.settings,a?a.settings:null,v,[],t);w=Z.localContent||Z.remoteContent,u=Z.localContent!==null,p=Z.remoteContent!==null,I=Z.hasConflicts}else i&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),w=i.value.toString().trim()||"{}",this.Qb(w),p=!0);const T=i?i.value.toString():null,F=a?.settings??null,M={content:I?F:w,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:I};return[{fileContent:i,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:T,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(n){const o=this.Lb(n);if(o===null)return!0;const s=await this.vb(),i=s?s.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,y.$9Eb)(i||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(n,o){const s=await this.Cb(),i=await this.Pb();return{...n.previewResult,content:n.previewResult.content?(0,y.$8Eb)(n.previewResult.content,"{}",i,s):null}}async sb(n,o,s,i){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:n.fileContent?(0,y.$8Eb)(n.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:n.remoteContent!==null?(0,y.$8Eb)(n.remoteContent,n.fileContent?n.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return s===void 0?{content:n.previewResult.content,localChange:n.previewResult.localChange,remoteChange:n.previewResult.remoteChange}:{content:s!==null?(0,y.$8Eb)(s,n.fileContent?n.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(n,o,s,i){const{fileContent:t}=s[0][0];let{content:r,localChange:a,remoteChange:v}=s[0][1];if(a===0&&v===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,i),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),v!==0){const w=await this.Cb(),u=this.Lb(n),p=await this.Pb(r);r=(0,y.$8Eb)(r,u?u.settings:"{}",p,w),this.O.trace(`${this.D}: Updating remote settings...`),n=await this.mb(JSON.stringify(this.Nb(r)),i?null:n.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==n.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(n),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const n=await this.vb();if(n)return!(0,y.$0Eb)(n.value.toString())}catch(n){if(n.fileOperationResult!==1)return!0}return!1}async resolveContent(n){return this.h.isEqual(this.remoteResource,n)||this.h.isEqual(this.localResource,n)||this.h.isEqual(this.acceptedResource,n)||this.h.isEqual(this.baseResource,n)?this.db(n):null}async db(n){let o=await super.db(n);if(o){const s=await this.Cb(),i=await this.Pb();o=(0,y.$8Eb)(o,"{}",i,s)}return o}Lb(n){return n.syncData?this.Mb(n.syncData.content):null}Mb(n){try{return f(n)}catch(o){this.O.error(o)}return null}Nb(n){return{settings:n}}async Pb(n){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const s=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,i=>i.some(({local:t})=>!!t)),N.Event.filter(this.Eb.onDidUninstallExtension,i=>!i.error))(()=>{s.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,y.$6Eb)(o,this.P,n)}Qb(n){if(this.Ab(n,!1))throw new b.$6mb((0,A.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$96b=m,e.$96b=m=ye([X(2,g.$ok),X(3,R.$$h),X(4,C.$jp),X(5,b.$1mb),X(6,b.$2mb),X(7,b.$dnb),X(8,b.$cnb),X(9,j.$xi),X(10,b.$$mb),X(11,S.$sl),X(12,k.$po),X(13,d.$Yk)],m);let h=class extends $.$oGb{constructor(n,o,s,i,t,r){super("settings",o,s,i,n,t,r)}async o(n){const o=n.syncData?this.p(n.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$he.fromString(o.settings)),await this.n(n)}async i(){try{const n=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,y.$0Eb)(n.value.toString().trim())}catch(n){return n.fileOperationResult===1}}p(n){try{return f(n)}catch(o){this.j.error(o)}return null}};e.$06b=h,e.$06b=h=ye([X(0,g.$ok),X(1,c.$1k),X(2,R.$$h),X(3,b.$dnb),X(4,C.$jp),X(5,d.$Yk)],h)}),define(le[119],he([0,1,15,3,30,20,14,11,21,22,28,17,39,236,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c7b=e.$b7b=e.$a7b=void 0;function y(f){return JSON.parse(f.content)}e.$a7b=y;let b=class extends d.$lGb{constructor(m,h,E,n,o,s,i,t,r,a,v,w){super({syncResource:"snippets",profile:m},h,n,E,o,s,i,a,v,t,r,w),this.pb=1,this.vb=m.snippetsHome,this.B(this.G.watch(E.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(m,h,E){const n=await this.Hb(),o=this.Gb(n),s=m.syncData?this.Fb(m.syncData):null;h=h===null&&E?m:h;const i=h&&h.syncData?this.Fb(h.syncData):null;s?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,c.$$6b)(o,s,i);return this.Bb(t,n,s||{},i||{})}async ub(m){const h=m.syncData?this.Fb(m.syncData):null;if(h===null)return!0;const E=await this.Hb(),n=this.Gb(E),o=(0,c.$$6b)(n,h,h);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(m,h){return m.previewResult}async sb(m,h,E,n){if(this.h.isEqualOrParent(h,this.g.with({scheme:$.$fnb,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(h,this.g.with({scheme:$.$fnb,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(h,this.g))return E===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:E,localChange:E===null?m.fileContent!==null?3:0:2,remoteChange:E===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${h.toString()}`)}async tb(m,h,E,n){const o=E.map(([s,i])=>({...s,acceptResult:i}));o.every(({localChange:s,remoteChange:i})=>s===0&&i===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:s})=>s!==0)&&(await this.Cb(o),await this.Db(o,n)),o.some(({remoteChange:s})=>s!==0)&&(m=await this.Eb(o,m,n)),h?.ref!==m.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(m),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:s}of o)try{await this.G.del(s)}catch{}}Bb(m,h,E,n){const o=new Map;for(const s of Object.keys(m.local.added)){const i={content:m.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s],previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of Object.keys(m.local.updated)){const i={content:m.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s],previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of m.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of Object.keys(m.remote.added)){const i={content:m.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of Object.keys(m.remote.updated)){const i={content:m.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s],localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s],previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of m.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s],previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of m.conflicts){const i={content:n[s]??null,hasConflicts:!0,localChange:h[s]?2:1,remoteChange:E[s]?2:1},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s]||null,localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}for(const s of Object.keys(h))if(!o.has(s)){const i={content:h[s]?h[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=h[s]?h[s].value.toString():null;o.set(s,{baseResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"base"}),baseContent:n[s]??null,localResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"local"}),fileContent:h[s]||null,localContent:t,remoteResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"remote"}),remoteContent:E[s]||null,previewResource:this.h.joinPath(this.g,s),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,s).with({scheme:$.$fnb,authority:"accepted"})})}return[...o.values()]}async resolveContent(m){return this.h.isEqualOrParent(m,this.g.with({scheme:$.$fnb,authority:"remote"}))||this.h.isEqualOrParent(m,this.g.with({scheme:$.$fnb,authority:"local"}))||this.h.isEqualOrParent(m,this.g.with({scheme:$.$fnb,authority:"base"}))||this.h.isEqualOrParent(m,this.g.with({scheme:$.$fnb,authority:"accepted"}))?this.db(m):null}async hasLocalData(){try{const m=await this.Hb();if(Object.keys(m).length)return!0}catch{}return!1}async Cb(m){const h={};for(const E of m)E.fileContent&&(h[this.h.basename(E.localResource)]=E.fileContent);await this.nb(JSON.stringify(this.Gb(h)))}async Db(m,h){for(const{fileContent:E,acceptResult:n,localResource:o,remoteResource:s,localChange:i}of m)if(i!==0){const t=s?this.h.basename(s):this.h.basename(o),r=this.h.joinPath(this.vb,t);i===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):i===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,D.$he.fromString(n.content),{overwrite:h}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,D.$he.fromString(n.content),h?void 0:E),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(m,h,E){const n=h.syncData?this.Fb(h.syncData):{},o=(0,A.$kn)(n);for(const{acceptResult:s,localResource:i,remoteResource:t,remoteChange:r}of m)if(r!==0){const a=i?this.h.basename(i):this.h.basename(t);r===3?delete o[a]:o[a]=s.content}return(0,c.$_6b)(n,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),h=await this.mb(JSON.stringify(o),E?null:h.ref),this.O.info(`${this.D}: Updated remote snippets`)),h}Fb(m){return y(m)}Gb(m){const h={};for(const E of Object.keys(m))h[E]=m[E].value.toString();return h}async Hb(){const m={};let h;try{h=await this.G.resolve(this.vb)}catch(E){if(E instanceof R.$Jk&&E.fileOperationResult===1)return m;throw E}for(const E of h.children||[]){const n=E.resource,o=this.h.extname(n);if(o===".json"||o===".code-snippets"){const s=this.h.relativePath(this.vb,n),i=await this.G.readFile(n);m[s]=i}}return m}};e.$b7b=b,e.$b7b=b=ye([X(2,O.$$h),X(3,R.$ok),X(4,k.$jp),X(5,$.$1mb),X(6,$.$2mb),X(7,$.$dnb),X(8,j.$xi),X(9,$.$$mb),X(10,g.$sl),X(11,C.$Yk)],b);let l=class extends d.$oGb{constructor(m,h,E,n,o,s){super("snippets",h,E,n,m,o,s)}async o(m){const h=m.syncData?JSON.parse(m.syncData.content):null;if(!h){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(h)){const o=h[n];if(o){const s=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(s,D.$he.fromString(o)),this.j.info("Created snippet",this.d.basename(s))}}await this.n(m)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};e.$c7b=l,e.$c7b=l=ye([X(0,R.$ok),X(1,S.$1k),X(2,O.$$h),X(3,$.$dnb),X(4,k.$jp),X(5,C.$Yk)],l)}),define(le[120],he([0,1,15,20,14,11,21,22,28,17,39,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f7b=e.$e7b=e.$d7b=void 0;function d(b,l){try{return JSON.parse(b).tasks??null}catch(f){return l.error(f),null}}e.$d7b=d;let c=class extends C.$mGb{constructor(l,f,m,h,E,n,o,s,i,t,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},f,s,i,t,m,h,o,r,E,n,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$fnb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$fnb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$fnb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$fnb,authority:"accepted"})}async qb(l,f,m,h){const E=l.syncData?d(l.syncData.content,this.O):null;f=f===null&&m?l:f;const n=f?.syncData?d(f.syncData.content,this.O):null,o=await this.vb();let s=null,i=!1,t=!1,r=!1;if(l.syncData){const w=o?o.value.toString():null;if(!n||n!==w||n!==E){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=y(w,E,n);s=u.content,r=u.hasConflicts,i=u.hasLocalChanged,t=u.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),s=o.value.toString(),t=!0);const a={content:r?n:s,localChange:i?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},v=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:n,localResource:this.Cb,localContent:v,localChange:a.localChange,remoteResource:this.Db,remoteContent:E,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(l){const f=l?.syncData?d(l.syncData.content,this.O):null;if(f===null)return!0;const m=await this.vb(),h=m?m.value.toString():null,E=y(h,f,f);return E.hasLocalChanged||E.hasRemoteChanged}async rb(l,f){return l.previewResult}async sb(l,f,m,h){if(this.h.isEqual(f,this.Cb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return m===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:m,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(l,f,m,h){const{fileContent:E}=m[0][0],{content:n,localChange:o,remoteChange:s}=m[0][1];if(o===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),E&&await this.nb(JSON.stringify(this.Kb(E.value.toString()))),n?await this.wb(n,E,h):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),s!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const i=JSON.stringify(this.Kb(n));l=await this.mb(i,h?null:l.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(l){return this.h.isEqual(this.Db,l)||this.h.isEqual(this.Bb,l)||this.h.isEqual(this.Cb,l)||this.h.isEqual(this.Eb,l)?this.db(l):null}Kb(l){return l?{tasks:l}:{}}};e.$e7b=c,e.$e7b=c=ye([X(2,S.$1mb),X(3,S.$2mb),X(4,S.$dnb),X(5,N.$xi),X(6,S.$$mb),X(7,j.$ok),X(8,A.$$h),X(9,O.$jp),X(10,R.$sl),X(11,k.$Yk)],c);let $=class extends C.$oGb{constructor(l,f,m,h,E,n){super("tasks",f,m,h,l,E,n),this.c=this.g.defaultProfile.tasksResource}async o(l){const f=l.syncData?d(l.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$he.fromString(f)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$f7b=$,e.$f7b=$=ye([X(0,j.$ok),X(1,g.$1k),X(2,A.$$h),X(3,S.$dnb),X(4,O.$jp),X(5,k.$Yk)],$);function y(b,l,f){if(b===null&&l===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(b===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const m=f!==b,h=f!==l;return!m&&!h?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:m&&!h?{content:b,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:h&&!m?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:b,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,20,14,11,21,22,28,17,39,237,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y8b=e.$X8b=e.$W8b=void 0;let c=class extends C.$lGb{constructor(l,f,m,h,E,n,o,s,i,t,r,a,v){super({syncResource:"profiles",profile:l},f,h,E,n,o,s,r,a,i,t,v),this.vb=m,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:d.$fnb,authority:"base"}),this.localResource=this.previewResource.with({scheme:d.$fnb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:d.$fnb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:d.$fnb,authority:"accepted"}),this.B(m.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?y(l.syncData):null}async getRemoteSyncedProfiles(l){const f=await this.getLastSyncUserData(),m=await this.X(l,f);return m?.syncData?y(m.syncData):null}async qb(l,f,m){if(!this.vb.isEnabled())throw new d.$6mb("Cannot sync profiles because they are disabled","LocalError");const h=l.syncData?y(l.syncData):null,E=f?.syncData?y(f.syncData):null,n=this.Db(),{local:o,remote:s}=(0,S.$V8b)(n,h,E,[]),i={local:o,remote:s,content:E?this.Eb(E):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:s!==null?2:0},t=$(n,!1);return[{baseResource:this.baseResource,baseContent:E?this.Eb(E):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:h?this.Eb(h):null,remoteProfiles:h,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async ub(l){const f=l?.syncData?y(l.syncData):null,m=this.Db(),{remote:h}=(0,S.$V8b)(m,f,f,[]);return!!h?.added.length||!!h?.removed.length||!!h?.updated.length}async rb(l,f){return{...l.previewResult,hasConflicts:!1}}async sb(l,f,m,h){if(this.h.isEqual(f,this.localResource))return this.Ab(l);if(this.h.isEqual(f,this.remoteResource))return this.Bb(l);if(this.h.isEqual(f,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(l){const f=this.Db(),m=(0,S.$V8b)(f,null,null,[]),{local:h,remote:E}=m;return{content:l.localContent,local:h,remote:E,localChange:h.added.length>0||h.removed.length>0||h.updated.length>0?2:0,remoteChange:E!==null?2:0}}async Bb(l){const f=l.remoteContent?JSON.parse(l.remoteContent):null,m=[],h=[];for(const E of this.Db()){const n=f?.find(o=>o.id===E.id);n&&(m.push({id:E.id,name:E.name,collection:n.collection}),h.push(E))}if(f!==null){const E=(0,S.$V8b)(h,f,m,[]),{local:n,remote:o}=E;return{content:l.remoteContent,local:n,remote:o,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(l,f,m,h){const{local:E,remote:n,localChange:o,remoteChange:s}=m[0][1];o===0&&s===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const i=m[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new d.$6mb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of E.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of E.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of E.updated){const a=this.vb.profiles.find(v=>v.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(s!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=i.length+(n?.added.length??0)<=20;if(r)for(const a of n?.added||[]){const v=await this.J.createCollection(this.F);t.push(v),i.push({id:a.id,name:a.name,collection:v,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of n?.removed||[])i.splice(i.findIndex(({id:v})=>a.id===v),1);for(const a of n?.updated||[]){const v=i.find(({id:w})=>a.id===w);v&&i.splice(i.indexOf(v),1,{...v,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(i,h?null:l.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&n?.added.length?` Added: ${JSON.stringify(n.added.map(a=>a.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(a=>a.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const v of t)await this.J.deleteCollection(v,this.F)}throw a}for(const a of n?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==l.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(l),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,f){return this.mb(this.Eb(l),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const f=await this.db(l);return f&&(0,D.$1T)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Eb(l){return JSON.stringify([...l].sort((f,m)=>f.name.localeCompare(m.name)))}};e.$W8b=c,e.$W8b=c=ye([X(2,g.$1k),X(3,j.$ok),X(4,A.$$h),X(5,O.$jp),X(6,d.$1mb),X(7,d.$2mb),X(8,d.$dnb),X(9,N.$xi),X(10,d.$$mb),X(11,R.$sl),X(12,k.$Yk)],c);function $(b,l){const f=[...b].sort((m,h)=>m.name.localeCompare(h.name)).map(m=>({id:m.id,name:m.name}));return l?(0,D.$1T)(f,{}):JSON.stringify(f)}e.$X8b=$;function y(b){return JSON.parse(b.content)}e.$Y8b=y}),define(le[255],he([0,1,3,2,5,14,21,22,24]),function(ne,e,D,N,A,j,O,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J8b=void 0;const g="sync.enable";let C=class extends N.$Tc{constructor(d,c,$,y){super(),this.c=d,this.f=c,this.g=$,this.h=y,this.a=new D.$Td,this.onDidChangeEnablement=this.a.event,this.b=new D.$Td,this.onDidChangeResourceEnablement=this.b.event,this.B(d.onDidChangeValue(-1,void 0,this.B(new N.$Sc))(b=>this.m(b)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(d){d&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:d}),this.c.store(g,d,-1,1))}isResourceEnabled(d){return this.c.getBoolean((0,k.$0mb)(d),-1,!0)}setResourceEnablement(d,c){if(this.isResourceEnabled(d)!==c){const $=(0,k.$0mb)(d);this.j($,c)}}getResourceSyncStateVersion(d){}j(d,c){this.c.store(d,c,-1,A.$o?0:1)}m(d){if(g===d.key){this.a.fire(this.isEnabled());return}const c=k.$Wmb.filter($=>(0,k.$0mb)($)===d.key)[0];if(c){this.b.fire([c,this.isResourceEnabled(c)]);return}}};e.$J8b=C,e.$J8b=C=ye([X(0,O.$jp),X(1,R.$sl),X(2,j.$$h),X(3,k.$Zmb)],C)}),define(le[256],he([0,1,6,15,64,2,19,20,14,11,17,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U8b=void 0;let d=class extends j.$Tc{constructor($,y,b,l,f){super(),this.a=$,this.b=y,this.c=b,this.f=l,this.g=f,this.h()}async h(){for(const y of this.g.profiles)for(const b of S.$Wmb)try{await this.m(this.j(b,y.isDefault?void 0:y.id))}catch(l){this.f.error(l)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(y){(0,g.$Fk)(y)!==1&&this.f.error(y);return}if($.children){for(const y of $.children)if(y.isDirectory&&!this.g.profiles.some(b=>b.id===y.name))try{this.f.info("Deleting non existing profile from backup",y.resource.path),await this.b.del(y.resource,{recursive:!0})}catch(b){this.f.error(b)}}}async getAllResourceRefs($,y,b){const l=this.j($,y,b);try{const f=await this.b.resolve(l);if(f.children)return f.children.filter(h=>h.isFile&&!h.name.startsWith("lastSync")).sort().reverse().map(h=>({ref:h.name,created:this.n(h)}))}catch(f){if((0,g.$Fk)(f)!==1)throw f}return[]}async resolveResourceContent($,y,b,l){const f=this.j($,b,l),m=(0,O.$Fg)(f,y);try{return(await this.b.readFile(m)).value.toString()}catch(h){return this.f.error(h),null}}async writeResource($,y,b,l,f){const m=this.j($,l,f),h=(0,O.$Fg)(m,`${(0,A.$um)(b).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(h,N.$he.fromString(y))}catch(E){this.f.error(E)}}j($,y,b=this.a.userDataSyncHome){return(0,O.$Fg)(b,...y?[y,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const y=await this.b.resolve($);if(y.children){const b=y.children.filter(h=>h.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(h.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=b.filter(h=>Date.now()-this.n(h)>l);const m=b.length-f.length;m<10&&(f=f.slice(10-m)),await D.Promises.settled(f.map(async h=>{this.f.info("Deleting from backup",h.resource.path),await this.b.del(h.resource)}))}}catch(y){this.f.error(y)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$U8b=d,e.$U8b=d=ye([X(0,k.$$h),X(1,g.$ok),X(2,R.$xi),X(3,S.$dnb),X(4,C.$1k)],d)}),define(le[83],he([0,1,3,2,5,27,175,14,11,4,25,43,21,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmb=e.$Omb=e.$Nmb=void 0,e.$Nmb=(0,g.$4h)("IUserDataSyncMachinesService");const y="sync.currentMachineName",b="Safari",l="Chrome",f="Edge",m="Firefox",h="Android";function E(s){switch(s){case b:case l:case f:case m:case h:case(0,A.$h)(0):return!0}return!1}e.$Omb=E;function n(){return A.$G?b:A.$E?l:A.$H?f:A.$F?m:A.$I?h:(0,A.$h)(A.$o?0:A.$u)}let o=class extends N.$Tc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(i,t,r,a,v,w){super(),this.h=r,this.j=a,this.m=v,this.n=w,this.c=this.B(new D.$Td),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$pp)(i,t,r)}async getMachines(i){const t=await this.f;return(await this.s(i)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(i){const t=await this.f,r=await this.s(i);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:n()}),await this.t(r))}async removeCurrentMachine(i){const t=await this.f,r=await this.s(i),a=r.machines.filter(({id:v})=>v!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(i,t,r){const a=await this.s(r),v=a.machines.find(({id:w})=>w===i);if(v){v.name=t,await this.t(a);const w=await this.f;i===w&&this.h.store(y,t,-1,1)}}async setEnablements(i){const t=await this.s();for(const[r,a]of i){const v=t.machines.find(w=>w.id===r);v&&(v.disabled=a?void 0:!0)}await this.t(t)}r(i){const t=this.h.get(y,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${n()} (${this.n.nameShort})`,a=new RegExp(`${(0,j.$Me)(r)}\\s#(\\d+)`);let v=0;for(const w of i){const u=a.exec(w.name),p=u?parseInt(u[1]):0;v=p>v?p:v}return`${r} #${v+1}`}async s(i){this.g=await this.u(i);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return t}async t(i){const t=JSON.stringify(i),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(i){if(this.g){const t=i&&i.latest?i.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(i){if(i.content!==null)try{return JSON.parse(i.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Pmb=o,e.$Pmb=o=$=ye([X(0,R.$$h),X(1,k.$ok),X(2,d.$jp),X(3,c.$1mb),X(4,c.$dnb),X(5,C.$Dj)],o)}),define(le[257],he([0,1,6,64,38,7,3,2,5,19,10,172,25,21,22,24,80,83]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$18b=void 0;const f="sync.disableMachineEventually",m="sync.sessionId",h="sync.storeUrl",E="sync.productQuality";let n=class extends R.$Tc{get n(){const i=this.H.get(h,-1);return i?C.URI.parse(i):void 0}set n(i){i?this.H.store(h,i.toString(),-1,1):this.H.remove(h,-1)}get s(){return this.H.get(E,-1)}set s(i){i?this.H.store(E,i,-1,1):this.H.remove(E,-1)}constructor(i,t,r,a,v,w,u,p,I,T){super(),this.u=t,this.w=r,this.y=a,this.z=v,this.C=w,this.D=u,this.F=p,this.G=I,this.H=T,this.a=this.B(new R.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$Td),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$2g(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=i.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$yg)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(v.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:i,message:t}=this.L();i?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$um)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(i,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(m,-1),i?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(i){this.y.isEnabled()!==i&&(this.y.setEnablement(i),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(i){if(!i){this.b=0;return}const t=y.$6mb.toUserDataSyncError(i);t instanceof y.$8mb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,D.$5g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(i,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...i),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$18b=n,e.$18b=n=ye([X(0,d.$Dj),X(1,y.$Zmb),X(2,y.$1mb),X(3,y.$$mb),X(4,y.$_mb),X(5,y.$dnb),X(6,b.$PEb),X(7,$.$sl),X(8,l.$Nmb),X(9,c.$jp)],n);class o extends R.$Tc{static{this.a="Interval"}constructor(i,t,r,a,v,w,u,p,I){super(),this.m=i,this.n=t,this.r=r,this.s=a,this.u=v,this.w=w,this.y=u,this.z=p,this.C=I,this.b=this.B(new R.$Uc),this.c=this.B(new O.$Td),this.onDidStartSync=this.c.event,this.f=this.B(new O.$Td),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,R.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,D.$6g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(i,t){const r=(0,D.$Rg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(v){if((0,j.$4)(v))return}return this.H(i,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$yg)(this.m,this.r.userDataSyncStore?.url)}async G(){const i=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!i&&(!(0,g.$yg)(t.defaultUrl,i.defaultUrl)||!(0,g.$yg)(t.insidersUrl,i.insidersUrl)||!(0,g.$yg)(t.stableUrl,i.stableUrl))}async H(i,t,r){this.y.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let a;try{await this.I(t,r)}catch(v){if(this.y.error(v),a=v,y.$6mb.toUserDataSyncError(v).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(w){this.y.error(w),a=w}}this.f.fire(a)}async I(i,t){if(this.h=await this.u.createSyncTask(this.g,i),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new y.$8mb((0,S.localize)(0,null),"DefaultServiceChanged"):new y.$8mb((0,S.localize)(1,null),"ServiceChanged"):new y.$8mb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(m,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new y.$8mb((0,S.localize)(3,null),"DefaultServiceChanged"):new y.$8mb((0,S.localize)(4,null),"ServiceChanged"):new y.$8mb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const v=a.find(u=>u.isCurrent);if(v?.disabled)throw new y.$8mb((0,S.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new y.$8mb((0,A.$Oi)(u),u instanceof y.$6mb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(m,this.g.session,-1,1),!t.isCancellationRequested&&(v||await this.w.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}}),define(le[258],he([0,1,10,176,14,11,43,21,28,24,17,39,119,118,117,20,120,115,116,4,121,42,27]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$w9b=void 0;let s=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,v,w,u,p,I,T,F){this.e=t,this.f=r,this.g=a,this.h=w,this.i=u,this.j=p,this.k=I,this.l=T,this.n=F,this.d=v.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,h.$Y8b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const v=this.L(a,"profiles");return(0,h.$Y8b)(v)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(w=>({...w,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:v,ref:w})=>({created:v,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:w,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:w,ref:u})=>({created:w,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(v=>v.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(v=>v.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,O.$pp)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,v,w){if(t){const{content:u}=await this.M(r,v,a);return u}return this.f.resolveResourceContent(r,v,a,w)}q(t,r,a){const v=this.L(r,t);switch(t){case"settings":return this.t(v,a);case"keybindings":return this.v(v,a);case"tasks":return this.x(v,a);case"snippets":return this.z(v,a);case"globalState":return this.E(v,a);case"extensions":return this.B(v,a);case"profiles":return this.H(v,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(v=>v.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),v=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}t(t,r){switch(r){case"settings.json":return(0,c.$86b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),v=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$56b)(t.content,!!this.l.getValue(g.$Tmb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),v=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}x(t,r){switch(r){case"tasks.json":return(0,b.$d7b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const v=this.L(a,"snippets");if(v){const w=(0,d.$a7b)(v),u=[];for(const p of Object.keys(w)){const I=this.d.joinPath(t,p),T=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);u.push({resource:I,comparableResource:T})}return u}}return[]}z(t,r){return(0,d.$a7b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),v=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}B(t,r){switch(r){case"extensions.json":return(0,l.$Z6b)((0,l.$Y6b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(l.$26b).getLocalExtensions(t);return(0,l.$Z6b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),v=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:v}]}E(t,r){switch(r){case"globalState.json":return(0,f.$qGb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$sGb).getLocalGlobalState(t);return(0,f.$qGb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),v=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:v}]}H(t,r){switch(r){case"profiles.json":return(0,E.$1T)(JSON.parse(t.content),{})}return null}async I(t){return(0,h.$X8b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,n.$Qe)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(D.URI.from({scheme:g.$fnb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$fnb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let v,w;const u=[];let p,I,T,F,M;for(;r.length;){const z=r.shift();z.startsWith("scheme:")?v=z.substring(7):z.startsWith("authority:")?w=z.substring(10):z.startsWith("syncResource:")?p=z.substring(13):z.startsWith("profile:")?I=z.substring(8):z.startsWith("collection:")?T=z.substring(11):z.startsWith("ref:")?F=z.substring(4):p?M=z:u.push(z)}return{remote:a,syncResource:p,profile:I,collection:T,ref:F,node:M,location:v&&w!==void 0?this.d.joinPath(D.URI.from({scheme:v,authority:w,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$jGb)(a))return a}catch(a){this.g.error(a)}throw new g.$6mb((0,N.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const v=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:v}}};e.$w9b=s,e.$w9b=s=o=ye([X(0,g.$1mb),X(1,g.$2mb),X(2,g.$dnb),X(3,k.$Yk),X(4,A.$$h),X(5,R.$jp),X(6,j.$ok),X(7,C.$1k),X(8,y.$xi),X(9,m.$3h)],s)}),define(le[259],he([0,1,18,6,26,38,3,2,19,12,32,20,29,11,4,21,22,17,115,116,117,118,119,120,121,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z8b=void 0;const t="sync.lastSyncTime";let r=class extends R.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,I,T,F,M,z,Z,J,x,G,Q){super(),this.C=p,this.D=I,this.F=T,this.G=F,this.H=M,this.I=z,this.J=Z,this.L=J,this.M=x,this.N=G,this.O=Q,this.f="uninitialized",this.g=this.B(new O.$Td),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$Td),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$Td),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$Td),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$Td),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$Td),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$Td),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=T.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,R.$Rc)(()=>this.bb()))}async createSyncTask(p,I){this.cb(),this.H.info("Sync started.");const T=new Date().getTime(),F=(0,C.$og)();try{const J=(0,i.$5mb)(F);I&&(J["Cache-Control"]="no-cache"),p=await this.D.manifest(p,J)}catch(J){const x=i.$6mb.toUserDataSyncError(J);throw w(x,F,this.F,this.I),x}const M=!1,z=this;let Z;return{manifest:p,async run(){if(M)throw new Error("Can run a task only once");Z=(0,N.$Rg)(J=>z.P(p,!1,F,J)),await Z.finally(()=>Z=void 0),z.H.info(`Sync done. Took ${new Date().getTime()-T}ms`),z.$()},stop(){return Z?.cancel(),z.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new i.$6mb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),I=(0,C.$og)(),T=(0,i.$5mb)(I);let F;try{F=await this.D.manifest(null,T)}catch(Z){const J=i.$6mb.toUserDataSyncError(Z);throw w(J,I,this.F,this.I),J}await this.resetLocal();const M=this,z=new A.$4d;return{id:I,async merge(){return M.P(F,!0,I,z.token)},async apply(){try{try{await M.R(F,I,z.token)}catch(Z){if(i.$6mb.toUserDataSyncError(Z).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(F,I,z.token);else throw Z}}catch(Z){throw M.H.error(Z),Z}M.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),M.$()},async stop(){z.cancel(),await M.U(),await M.resetLocal()}}}async P(p,I,T,F){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,p,I,T,F));const z=M.enabled.find(Z=>Z.resource==="profiles");if(z){const Z=await z.getLastSyncedProfiles()||[];if(F.isCancellationRequested)return;await this.Q(Z,p,I,T,F)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,I,T,F,M){for(const z of p){if(M.isCancellationRequested)return;const Z=this.M.profiles.find(x=>x.id===z.id);if(!Z){this.H.error(`Profile with id:${z.id} and name: ${z.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",z.name);const J=this.getOrCreateActiveProfileSynchronizer(Z,z);this.n.push(...await this.S(J,I,T,F,M))}for(const[z,Z]of this.z.entries())this.M.profiles.some(J=>J.id===Z[0].profile.id)||(Z[1].dispose(),this.z.delete(z))}async R(p,I,T){const F=this.ab();for(const x of F){if(T.isCancellationRequested)return;await x.apply(I,T)}const M=F.find(x=>x.profile.isDefault);if(!M)return;const z=M.enabled.find(x=>x.resource==="profiles");if(!z)return;const J=(await z.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>F.every(G=>G.profile.id!==x.id));J.length&&await this.Q(J,p,!1,I,T)}async S(p,I,T,F,M){return(await p.sync(I,T,F,M)).map(([Z,J])=>({profile:p.profile,syncResource:Z,error:J}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const I=await this.N.resolveContent(p);if(I)return I;for(const T of this.ab())for(const F of T.enabled){const M=await F.resolveContent(p);if(M)return M}return null}async replace(p){this.cb();const I=this.N.resolveUserDataSyncResource(p);if(!I)return;const T=await this.resolveContent(p.uri);T&&await this.W(I.profile,async F=>{if(I.syncResource===F.resource)return await F.replace(T),!0})}async accept(p,I,T,F){this.cb(),await this.W(p.profile,async M=>{if(p.syncResource===M.resource)return await M.accept(I,T),F&&await M.apply((0,g.$Mf)(F)?!1:F.force,(0,i.$5mb)((0,C.$og)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async I=>{if(I.resource!=="globalState"&&await I.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async I=>{if(await I.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(I){this.H.error(I)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),I=p.map(z=>z.collection),T=await this.D.getAllCollections(),F=T.filter(z=>!I.includes(z));F.length&&(this.H.info(`Deleting ${F.length} redundant collections on server`),await Promise.allSettled(F.map(z=>this.D.deleteCollection(z))),this.H.info("Deleted redundant collections on server"));const M=p.filter(z=>T.includes(z.collection));if(M.length!==p.length){const z=this.G.createInstance(s.$W8b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await z.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await z.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{z.dispose()}}}async saveRemoteActivityData(p){this.cb();const I=await this.D.getActivityData();await this.C.writeFile(p,I)}async extractActivityData(p,I){const T=(await this.C.readFile(p)).value.toString(),F=JSON.parse(T);if(F.resources)for(const M in F.resources)for(const z of F.resources[M])await this.O.writeResource(M,z.content,new Date(z.created*1e3),void 0,I);if(F.collections)for(const M in F.collections)for(const z in F.collections[M].resources)for(const Z of F.collections[M].resources?.[z]??[])await this.O.writeResource(z,Z.content,new Date(Z.created*1e3),M,I)}async W(p,I){const T=new R.$Sc;try{const F=this.z.get(p.id);if(F){const x=await this.X(F[0],I,T);return(0,g.$Nf)(x)?null:x}if(p.isDefault){const x=T.add(this.G.createInstance(a,p,void 0)),G=await this.X(x,I,T);return(0,g.$Nf)(G)?null:G}if(this.M.isEnabled())return null;const M=T.add(this.G.createInstance(s.$W8b,p,void 0)),z=await this.D.manifest(null),J=(await M.getRemoteSyncedProfiles(z?.latest??null)||[]).find(x=>x.id===p.id);if(J){const x=T.add(this.G.createInstance(a,p,J.collection)),G=await this.X(x,I,T);return(0,g.$Nf)(G)?null:G}return null}finally{T.dispose()}}async X(p,I,T){const F=[...p.enabled,...p.disabled.reduce((M,z)=>(z!=="workspaceState"&&M.push(T.add(p.createSynchronizer(z))),M),[])];for(const M of F){const z=await I(M);if(!(0,g.$Nf)(z))return z}}Y(p){const I=this.f;this.f!==p&&(this.f=p,this.g.fire(p),I==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(I=>I.conflicts).flat();(0,D.$ub)(this.j,p,(I,T)=>I.profile.id===T.profile.id&&I.syncResource===T.syncResource&&(0,D.$ub)(I.conflicts,T.conflicts,(F,M)=>(0,k.$yg)(F.previewResource,M.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,I){let T=this.z.get(p.id);if(T&&T[0].collection!==I?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),T[1].dispose(),T=void 0,this.z.delete(p.id)),!T){const F=new R.$Sc,M=F.add(this.G.createInstance(a,p,I?.collection));F.add(M.onDidChangeStatus(z=>this.Y(z))),F.add(M.onDidChangeConflicts(z=>this.Z())),F.add(M.onDidChangeLocal(z=>this.h.fire(z))),this.z.set(p.id,T=[M,F])}return T[0]}ab(){const p=[];for(const[I]of this.z.values())p.push(I);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Z8b=r,e.$Z8b=r=ye([X(0,c.$ok),X(1,i.$1mb),X(2,i.$Zmb),X(3,$.$3h),X(4,i.$dnb),X(5,b.$sl),X(6,y.$jp),X(7,i.$$mb),X(8,l.$1k),X(9,i.$anb),X(10,i.$2mb)],r);let a=class extends R.$Tc{get enabled(){return this.f.sort((p,I)=>p[1]-I[1]).map(([p])=>p)}get disabled(){return i.$Wmb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,I,T,F,M,z,Z,J,x,G){super(),this.profile=p,this.collection=I,this.r=T,this.t=F,this.u=M,this.w=z,this.y=Z,this.z=J,this.C=x,this.D=G,this.f=[],this.g="idle",this.h=this.B(new O.$Td),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$Td),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$Td),this.onDidChangeConflicts=this.n.event,this.B(T.onDidChangeResourceEnablement(([Q,V])=>this.F(Q,V))),this.B((0,R.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Q])=>Q.dispose())));for(const Q of i.$Wmb)T.isResourceEnabled(Q)&&this.G(Q)}F(p,I){I?this.G(p):this.H(p)}G(p){if(this.f.some(([M])=>M.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const I=new R.$Sc,T=I.add(this.createSynchronizer(p));I.add(T.onDidChangeStatus(()=>this.L())),I.add(T.onDidChangeConflicts(()=>this.M())),I.add(T.onDidChangeLocal(()=>this.j.fire(p)));const F=this.N(p);this.f.push([T,F,I])}H(p){const I=this.f.findIndex(([T])=>T.resource===p);if(I!==-1){const[[T,,F]]=this.f.splice(I,1);F.dispose(),this.L(),Promise.allSettled([T.stop(),T.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(E.$96b,this.profile,this.collection);case"keybindings":return this.t.createInstance(h.$66b,this.profile,this.collection);case"snippets":return this.t.createInstance(n.$b7b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$e7b,this.profile,this.collection);case"globalState":return this.t.createInstance(m.$rGb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$16b,this.profile,this.collection);case"profiles":return this.t.createInstance(s.$W8b,this.profile,this.collection)}}async sync(p,I,T,F){if(F.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const z=[],Z=(0,i.$5mb)(T),J=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=I?await this.I(J):{};for(const G of M){if(F.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(I){const Q=await G.preview(J,x,Z);if(Q)for(const V of Q.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await G.merge(V.previewResource)}else await G.sync(J,Z)}catch(Q){const V=i.$6mb.toUserDataSyncError(Q);if(w(V,T,this.w,this.y),v(Q))throw V;this.z.error(Q),this.z.error(`${G.resource}: ${(0,j.$Oi)(Q)}`),z.push([G.resource,V])}}return z}finally{this.L()}}async apply(p,I){const T=(0,i.$5mb)(p);for(const F of this.enabled){if(I.isCancellationRequested)return;try{await F.apply(!1,T)}catch(M){const z=i.$6mb.toUserDataSyncError(M);if(w(z,p,this.w,this.y),v(M))throw z;this.z.error(M),this.z.error(`${F.resource}: ${(0,j.$Oi)(M)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(I){this.z.error(I)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(I){this.z.error(`${p.resource}: ${(0,j.$Oi)(I)}`),this.z.error(I)}}async I(p){if(!this.profile.isDefault)return{};const I=this.D.getValue(i.$Smb),T=this.enabled.find(F=>F instanceof E.$96b);if(T){const F=await T.getRemoteUserDataSyncConfiguration(p);return{...I,...F}}return I}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(I=>I.status==="hasConflicts").filter(I=>I.conflicts.conflicts.length>0).map(I=>I.conflicts);(0,D.$ub)(this.m,p,(I,T)=>I.syncResource===T.syncResource&&(0,D.$ub)(I.conflicts,T.conflicts,(F,M)=>(0,k.$yg)(F.previewResource,M.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ye([X(2,i.$$mb),X(3,$.$3h),X(4,d.$no),X(5,i.$Zmb),X(6,b.$sl),X(7,i.$dnb),X(8,l.$1k),X(9,S.$xi)],a);function v(u){if(u instanceof i.$6mb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(u,p,I,T){T.publicLog2("sync/error",{code:u.code,serverCode:u instanceof i.$7mb?String(u.serverCode):void 0,url:u instanceof i.$7mb?u.url:void 0,resource:u.resource,executionId:p,service:I.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,17,24]),function(ne,e,D,N,A,j,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=e.$j_b=void 0;function R(d,c){return{...d,profile:(0,j.$2k)(d.profile,c.profilesHome.scheme)}}function k(d){return{created:d.created,uri:A.URI.revive(d.uri)}}class g{constructor(c,$,y){this.c=c,this.d=$,this.f=y,this.a=new Map,this.b=new D.$Td}listen(c,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(c,$,y){try{return await this.g(c,$,y)}catch(b){throw this.f.error(b),b}}async g(c,$,y){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(A.URI.revive(y[0]));case"accept":return this.c.accept(R(y[0],this.d),A.URI.revive(y[1]),y[2],y[3]);case"replace":return this.c.replace(k(y[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(A.URI.revive(y[0]));case"extractActivityData":return this.c.extractActivityData(A.URI.revive(y[0]),A.URI.revive(y[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const b=$.substring(11),l=y[0],f=this.h(l);switch(y=y.slice(1),b){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(c){const $=this.a.get(this.j(c));if(!$)throw new Error(`Manual sync taks not found: ${c}`);return $}async i(){const c=await this.c.createManualSyncTask();return this.a.set(this.j(c.id),c),c.id}j(c){return`manualSyncTask-${c}`}}e.$j_b=g;let C=class extends N.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(c,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new D.$Td),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$Td),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$Td),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$Td),this.onSyncErrors=this.m.event,this.a={call(y,b,l){return c.call(y,b,l).then(null,f=>{throw O.$6mb.toUserDataSyncError(f)})},listen(y,b){return c.listen(y,b)}},this.a.call("_getInitialData").then(([y,b,l])=>{this.s(y),this.t(b),l&&this.u(l),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(y=>this.t(y))),this.B(this.a.listen("onSyncErrors")(y=>this.m.fire(y.map(b=>({...b,error:O.$6mb.toUserDataSyncError(b.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const c=await this.a.call("createManualSyncTask"),$=this;return new S(c,{async call(b,l,f){return $.a.call(`manualSync/${b}`,[c,...Array.isArray(l)?l:[l]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(c,$,y,b){return this.a.call("accept",[c,$,y,b])}resolveContent(c){return this.a.call("resolveContent",[c])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(c){return this.a.call("replace",[c])}saveRemoteActivityData(c){return this.a.call("getRemoteActivityData",[c])}extractActivityData(c,$){return this.a.call("extractActivityData",[c,$])}async s(c){this.b=c,this.c.fire(c)}async t(c){this.f=c.map($=>({syncResource:$.syncResource,profile:(0,j.$2k)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(y=>({...y,baseResource:A.URI.revive(y.baseResource),localResource:A.URI.revive(y.localResource),remoteResource:A.URI.revive(y.remoteResource),previewResource:A.URI.revive(y.previewResource)}))})),this.g.fire(this.f)}u(c){this.h!==c&&(this.h=c,this.j.fire(c))}};e.$k_b=C,e.$k_b=C=ye([X(1,j.$1k)],C);class S extends N.$Tc{constructor(c,$){super(),this.id=c,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[261],he([0,1,6,26,7,3,2,139,5,19,12,10,32,20,14,11,25,59,43,21,24]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hGb=e.$gGb=e.$fGb=e.$eGb=e.$dGb=void 0;const E="configurationSync.store",n="sync.previous.store",o="sync.donot-make-requests-until",s="sync.user-session-id",i="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends O.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(h.$9mb,-1)}set c(T){this.h.store(h.$9mb,T,-1,k.$o?0:1)}constructor(T,F,M){super(),this.f=T,this.g=F,this.h=M,this.a=this.B(new j.$Td),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const z=this.B(new O.$Sc);this.B(j.Event.filter(M.onDidChangeValue(-1,h.$9mb,z),()=>this.c!==this.userDataSyncStore?.type,z)(()=>this.j()))}j(){this.b=this.m(this.f[E]),this.a.fire()}m(T){if(T&&(T=k.$o&&T.web?{...T,...T.web}:T,(0,C.$Gf)(T.url)&&(0,C.$If)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(F=>Array.isArray(T.authenticationProviders[F].scopes)))){const F=T,M=!!F.canSwitch,z=F.url===F.insidersUrl?"insiders":"stable",Z=(M?this.c:void 0)||z,J=Z==="insiders"?F.insidersUrl:Z==="stable"?F.stableUrl:F.url;return{url:S.URI.parse(J),type:Z,defaultType:z,defaultUrl:S.URI.parse(F.url),stableUrl:S.URI.parse(F.stableUrl),insidersUrl:S.URI.parse(F.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(F.authenticationProviders).reduce((x,G)=>(x.push({id:G,scopes:F.authenticationProviders[G].scopes}),x),[])}}}};e.$dGb=a,e.$dGb=a=ye([X(0,b.$Dj),X(1,c.$xi),X(2,m.$jp)],a);let v=class extends a{constructor(T,F,M){super(T,F,M);const z=this.h.get(n,-1);z&&(this.n=JSON.parse(z));const Z=this.f[E];Z?this.h.store(n,JSON.stringify(Z),-1,1):this.h.remove(n,-1)}async switch(T){T!==this.c&&(this.c=T,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$eGb=v,e.$eGb=v=ye([X(0,b.$Dj),X(1,c.$xi),X(2,m.$jp)],v);let w=class extends O.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(T,F,M,z,Z,J,x){super(),this.n=M,this.r=z,this.s=x,this.g=this.B(new j.$Td),this.onTokenFailed=this.g.event,this.h=this.B(new j.$Td),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new j.$Td),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(T),this.c=(0,f.$pp)(Z,J,x).then(G=>{const Q={"X-Client-Name":`${F.applicationName}${k.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,O.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(T,F){this.b={token:T,type:F}}t(T){this.a=T?(0,g.$Fg)(T,"v1"):void 0}u(){const T=this.s.getNumber(o,-1);T&&Date.now()<T&&this.y(new Date(T))}y(T){this.j?.getTime()!==T?.getTime()&&(this.j=T,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,D.$Rg)(F=>(0,D.$5g)(this.j.getTime()-Date.now(),F).then(()=>this.y(void 0))),this.w.then(null,F=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Fg)(this.a,"collection").toString();T={...T},T["Content-Type"]="application/json";const M=await this.D(F,{type:"GET",headers:T},[],N.CancellationToken.None);return(await(0,l.$cp)(M))?.map(({id:z})=>z)||[]}async createCollection(T={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,g.$Fg)(this.a,"collection").toString();T={...T},T["Content-Type"]=R.$7r.text;const M=await this.D(F,{type:"POST",headers:T},[],N.CancellationToken.None),z=await(0,l.$bp)(M);if(!z)throw new h.$7mb("Server did not return the collection id",F,"NoCollection",M.res.statusCode,M.res.headers[h.$3mb]);return z}async deleteCollection(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=T?(0,g.$Fg)(this.a,"collection",T).toString():(0,g.$Fg)(this.a,"collection").toString();F={...F},await this.D(M,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async getAllResourceRefs(T,F){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,F,T),z={},Z=await this.D(M.toString(),{type:"GET",headers:z},[],N.CancellationToken.None);return(await(0,l.$cp)(Z)||[]).map(({url:x,created:G})=>({ref:(0,g.$Hg)(M,M.with({path:x})),created:G*1e3}))}async resolveResourceContent(T,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Fg)(this.z(this.a,M,T),F).toString();z={...z},z["Cache-Control"]="no-cache";const J=await this.D(Z,{type:"GET",headers:z},[],N.CancellationToken.None);return await(0,l.$bp)(J)}async deleteResource(T,F,M){if(!this.a)throw new Error("No settings sync store url configured.");const z=F!==null?(0,g.$Fg)(this.z(this.a,M,T),F).toString():this.z(this.a,M,T).toString(),Z={};await this.D(z,{type:"DELETE",headers:Z},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Fg)(this.a,"resource").toString(),F={"Content-Type":R.$7r.text};await this.D(T,{type:"DELETE",headers:F},[],N.CancellationToken.None)}async readResource(T,F,M,z={}){if(!this.a)throw new Error("No settings sync store url configured.");const Z=(0,g.$Fg)(this.z(this.a,M,T),"latest").toString();z={...z},z["Cache-Control"]="no-cache",F&&(z["If-None-Match"]=F.ref);const J=await this.D(Z,{type:"GET",headers:z},[304],N.CancellationToken.None);let x=null;if(J.res.statusCode===304&&(x=F),x===null){const G=J.res.headers.etag;if(!G)throw new h.$7mb("Server did not return the ref",Z,"NoRef",J.res.statusCode,J.res.headers[h.$3mb]);const Q=await(0,l.$bp)(J);if(!Q&&J.res.statusCode===304)throw new h.$7mb("Empty response",Z,"EmptyResponse",J.res.statusCode,J.res.headers[h.$3mb]);x={ref:G,content:Q}}return x}async writeResource(T,F,M,z,Z={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=this.z(this.a,z,T).toString();Z={...Z},Z["Content-Type"]=R.$7r.text,M&&(Z["If-Match"]=M);const x=await this.D(J,{type:"POST",data:F,headers:Z},[],N.CancellationToken.None),G=x.res.headers.etag;if(!G)throw new h.$7mb("Server did not return the ref",J,"NoRef",x.res.statusCode,x.res.headers[h.$3mb]);return G}async manifest(T,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Fg)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",T&&(F["If-None-Match"]=T.ref);const z=await this.D(M,{type:"GET",headers:F},[304],N.CancellationToken.None);let Z=null;if(z.res.statusCode===304&&(Z=T),!Z){const x=z.res.headers.etag;if(!x)throw new h.$7mb("Server did not return the ref",M,"NoRef",z.res.statusCode,z.res.headers[h.$3mb]);const G=await(0,l.$bp)(z);if(!G&&z.res.statusCode===304)throw new h.$7mb("Empty response",M,"EmptyResponse",z.res.statusCode,z.res.headers[h.$3mb]);G&&(Z={...JSON.parse(G),ref:x})}const J=this.s.get(s,-1);return J&&Z&&J!==Z.session&&this.C(),Z===null&&J&&this.C(),Z&&this.s.store(s,Z.session,-1,1),Z}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Fg)(this.a,"download").toString(),F={},M=await this.D(T,{type:"GET",headers:F},[],N.CancellationToken.None);if(!(0,l.$$o)(M))throw new h.$7mb("Server returned "+M.res.statusCode,T,"EmptyResponse",M.res.statusCode,M.res.headers[h.$3mb]);if((0,l.$_o)(M))throw new h.$7mb("Empty response",T,"EmptyResponse",M.res.statusCode,M.res.headers[h.$3mb]);return M.stream}z(T,F,M){return F?(0,g.$Fg)(T,"collection",F,"resource",M):(0,g.$Fg)(T,"resource",M)}C(){this.s.remove(s,-1),this.s.remove(i,-1)}async D(T,F,M,z){if(!this.b)throw new h.$7mb("No Auth Token Available",T,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new h.$7mb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Z=await this.c;F.headers={...F.headers||{},...Z,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(F.headers),this.r.trace("Sending request to server",{url:T,type:F.type,headers:{...F.headers,authorization:void 0}});let J;try{J=await this.f.request(T,F,z)}catch(B){if(!(B instanceof h.$7mb)){let te="RequestFailed";const se=(0,A.$0)(B).toLowerCase();se.includes("xhr timeout")?te="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?te="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?te="RequestPathNotEscaped":se.includes("headers must be an object")?te="RequestHeadersNotObject":(0,A.$4)(B)&&(te="RequestCanceled"),B=new h.$7mb(`Connection refused for the request '${T}'.`,T,te,void 0,void 0)}throw this.r.info("Request failed",T),B}const x=J.res.headers[h.$3mb],G={url:T,status:J.res.statusCode,"execution-id":F.headers[h.$4mb],"operation-id":x},Q=(0,l.$$o)(J)||J.res.statusCode&&M.includes(J.res.statusCode);let V="";if(Q?this.r.trace("Request succeeded",G):(V=await(0,l.$ap)(J)||"",this.r.info("Request failed",G,V)),J.res.statusCode===401||J.res.statusCode===403){if(this.b=void 0,J.res.statusCode===401)throw this.g.fire("Unauthorized"),new h.$7mb(`${F.type} request '${T}' failed because of Unauthorized (401).`,T,"Unauthorized",J.res.statusCode,x);if(J.res.statusCode===403)throw this.g.fire("Forbidden"),new h.$7mb(`${F.type} request '${T}' failed because the access is forbidden (403).`,T,"Forbidden",J.res.statusCode,x)}if(this.h.fire(),J.res.statusCode===404)throw new h.$7mb(`${F.type} request '${T}' failed because the requested resource is not found (404).`,T,"NotFound",J.res.statusCode,x);if(J.res.statusCode===405)throw new h.$7mb(`${F.type} request '${T}' failed because the requested endpoint is not found (405). ${V}`,T,"MethodNotFound",J.res.statusCode,x);if(J.res.statusCode===409)throw new h.$7mb(`${F.type} request '${T}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,T,"Conflict",J.res.statusCode,x);if(J.res.statusCode===410)throw new h.$7mb(`${F.type} request '${T}' failed because the requested resource is not longer available (410).`,T,"Gone",J.res.statusCode,x);if(J.res.statusCode===412)throw new h.$7mb(`${F.type} request '${T}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,T,"PreconditionFailed",J.res.statusCode,x);if(J.res.statusCode===413)throw new h.$7mb(`${F.type} request '${T}' failed because of too large payload (413).`,T,"TooLarge",J.res.statusCode,x);if(J.res.statusCode===426)throw new h.$7mb(`${F.type} request '${T}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,T,"UpgradeRequired",J.res.statusCode,x);if(J.res.statusCode===429){const B=J.res.headers["retry-after"];throw B?(this.y(new Date(Date.now()+parseInt(B)*1e3)),new h.$7mb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"TooManyRequestsAndRetryAfter",J.res.statusCode,x)):new h.$7mb(`${F.type} request '${T}' failed because of too many requests (429).`,T,"RemoteTooManyRequests",J.res.statusCode,x)}if(!Q)throw new h.$7mb("Server returned "+J.res.statusCode,T,"Unknown",J.res.statusCode,x);return J}F(T){let F=this.s.get(i,-1);F===void 0&&(F=(0,d.$og)(),this.s.store(i,F,-1,1)),T["X-Machine-Session-Id"]=F;const M=this.s.get(s,-1);M!==void 0&&(T["X-User-Session-Id"]=M)}};e.$fGb=w,e.$fGb=w=ye([X(1,b.$Dj),X(2,l.$9o),X(3,h.$dnb),X(4,$.$$h),X(5,y.$ok),X(6,m.$jp)],w);let u=class extends w{constructor(T,F,M,z,Z,J,x){super(T.userDataSyncStore?.url,F,M,z,Z,J,x),this.B(T.onDidChangeUserDataSyncStore(()=>this.t(T.userDataSyncStore?.url)))}};e.$gGb=u,e.$gGb=u=ye([X(0,h.$Zmb),X(1,b.$Dj),X(2,l.$9o),X(3,h.$dnb),X(4,$.$$h),X(5,y.$ok),X(6,m.$jp)],u);class p{constructor(T,F,M,z){this.c=T,this.d=F,this.f=M,this.g=z,this.a=[],this.b=void 0}request(T,F,M){if(this.h()&&this.i(),F.url=T,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new h.$7mb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,T,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(T),this.f.request(F,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$hGb=p}),define(le[262],he([0,1,3,57,25,21,22,257,24,80,83]),function(ne,e,D,N,A,j,O,R,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=void 0;let S=class extends R.$18b{constructor(c,$,y,b,l,f,m,h,E,n,o){super(c,$,y,b,l,m,h,E,n,o),this.B(D.Event.debounce(D.Event.any(D.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(s,i)=>s?[...s,i]:[i],1e3)(s=>this.triggerSync(s,!0,!1)))}};e.$E_b=S,e.$E_b=S=ye([X(0,A.$Dj),X(1,k.$Zmb),X(2,k.$1mb),X(3,k.$$mb),X(4,k.$_mb),X(5,N.$v0b),X(6,k.$dnb),X(7,g.$PEb),X(8,O.$sl),X(9,C.$Nmb),X(10,j.$jp)],S)}),define(le[263],he([0,1,72,23,5,19]),function(ne,e,D,N,A,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y9b=e.$X9b=e.$W9b=e.$V9b=void 0,e.$V9b=128/4;function O(g){function C(){let S=g.scheme===N.Schemas.file?(0,j.$tg)(g):g.toString();return A.$k||(S=S.toLowerCase()),(0,D.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$W9b=O;function R(g,C){function S(){if(g.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let c;return A.$k?c=C.ino:A.$j?c=C.birthtime.getTime():A.$i&&(typeof C.birthtimeMs=="number"?c=Math.floor(C.birthtimeMs):c=C.birthtime.getTime()),(0,D.createHash)("md5").update(g.fsPath).update(c?String(c):"").digest("hex")}const d=S();if(typeof d=="string")return{id:d,uri:g}}e.$X9b=R;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Y9b=k}),define(le[264],he([0,1,6,7,2,16,31,14,8,77,112,263,57,56,23]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=void 0;let y=class extends A.$Tc{constructor(l,f,m,h){super(),this.a=l,this.b=f,this.c=m,this.f=h,this.B(new D.$dh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const l=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,f=await O.Promises.readdir(l),m=new g.$oFb(this.f.getChannel("storage"));await Promise.all(f.map(async h=>{const E=(0,j.$jc)(l,h);h.length===S.$V9b||h===C.$di.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(s=>s.workspace?.id===h)||await m.isUsed(E)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${h} as it seems to be an unused empty workspace.`),await O.Promises.rm(E))}))}catch(l){(0,N.$1)(l)}}};e.$$$b=y,e.$$$b=y=ye([X(0,R.$_h),X(1,k.$lj),X(2,d.$v0b),X(3,c.$J$b)],y)}),define(le[122],he([0,1,72,63,36,272,15,7,3,2,16,5,32,40,67]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=void 0;class y{traceSocketEvent(u,p){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=I=>{if(this.traceSocketEvent("error",{code:I?.code,message:I?.message}),I){if(I.code==="EPIPE")return;(0,R.$1)(I)}},this.socket.on("error",this.a),this.b=I=>{this.traceSocketEvent("close",{hadError:I}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=I=>{this.traceSocketEvent("read",I),u(O.$he.wrap(I))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=I=>{u({type:0,hadError:I,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,R.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const I=()=>{this.socket.off("close",I),this.socket.off("end",I),this.socket.off("error",I),this.socket.off("timeout",I),this.socket.off("drain",I),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",I),this.socket.on("end",I),this.socket.on("error",I),this.socket.on("timeout",I),this.socket.on("drain",I)})}}e.$Sh=y;var b;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(b||(b={}));var l;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(l||(l={}));class f extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,I,T){super(),this.f=this.B(new k.$Td),this.g=this.B(new k.$Td),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:I?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new m(this,p,I,T,this.f,(F,M)=>this.m(F,M))),this.B(this.a.onError(F=>{console.error(F),(0,R.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$Nh,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(u,{compressed:p,opcode:I}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let T=2;u.byteLength<126?T+=0:u.byteLength<2**16?T+=2:T+=8;const F=O.$he.alloc(T),M=p?64:0,z=I&15;if(F.writeUInt8(128|M|z,0),u.byteLength<126)F.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){F.writeUInt8(126,1);let Z=1;F.writeUInt8(u.byteLength>>>8&255,++Z),F.writeUInt8(u.byteLength>>>0&255,++Z)}else{F.writeUInt8(127,1);let Z=1;F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(0,++Z),F.writeUInt8(u.byteLength>>>24&255,++Z),F.writeUInt8(u.byteLength>>>16&255,++Z),F.writeUInt8(u.byteLength>>>8&255,++Z),F.writeUInt8(u.byteLength>>>0&255,++Z)}this.socket.write(O.$he.concat([F,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),I=p.readUInt8(0),T=(I&128)>>>7,F=(I&64)>>>6,M=I&15,z=p.readUInt8(1),Z=(z&128)>>>7,J=z&127;this.j.state=2,this.j.readLen=2+(Z?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),I=p.readUInt8(1),T=(I&128)>>>7;let F=I&127,M=1;F===126?F=p.readUInt8(++M)*2**8+p.readUInt8(++M):F===127&&(F=p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M));let z=0;T&&(z=p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M)),this.j.state=3,this.j.readLen=F,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),n(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Th=f;class m extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$he.alloc(0)}constructor(u,p,I,T,F,M){super(),this.n=u,this.r=F,this.s=M,this.a=this.B(new k.$Td),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Td),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Td),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new h(this.n,T,I,{windowBits:15})),this.f=this.B(new E(this.n,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(u,p){this.g.push({data:u,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:p}=this.g.shift();if(this.f&&p.compressed){const I=await this.w(this.f,u);this.s(I,p)}else this.s(u,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((I,T)=>{u.write(p),u.flush(F=>I(F))})}acceptFrame(u,p,I){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:I}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,I){return new Promise((T,F)=>{u.write(p),I&&u.write(O.$he.fromByteArray([0,0,255,255])),u.flush(M=>T(M))})}}class h extends g.$Tc{get recordedInflateBytes(){return this.j?O.$he.concat(this.f):O.$he.alloc(0)}constructor(u,p,I,T){super(),this.h=u,this.j=p,this.a=this.B(new k.$Td),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(O.$he.wrap(F))}),I&&(this.h.traceSocketEvent("zlibInflateInitialWrite",I.buffer),this.b.write(I.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=O.$he.concat(this.g);this.g.length=0,u(p)})}}class E extends g.$Tc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$Td),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",I=>{this.g.traceSocketEvent("zlibDeflateError",{message:I?.message,code:I?.code}),this.a.fire(I)}),this.b.on("data",I=>{this.g.traceSocketEvent("zlibDeflateData",I),this.f.push(O.$he.wrap(I))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=O.$he.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function n(w,u){if(u===0)return;const p=w.byteLength>>>2;for(let Z=0;Z<p;Z++){const J=w.readUInt32BE(Z*4);w.writeUInt32BE(J^u,Z*4)}const I=p*4,T=w.byteLength-I,F=u>>>24&255,M=u>>>16&255,z=u>>>8&255;T>=1&&w.writeUInt8(w.readUInt8(I)^F,I),T>=2&&w.writeUInt8(w.readUInt8(I+1)^M,I+1),T>=3&&w.writeUInt8(w.readUInt8(I+2)^z,I+2)}e.$Uh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function s(){const w=(0,d.$og)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const u=process.platform!=="darwin"&&e.$Uh?e.$Uh:(0,A.tmpdir)(),p=(0,C.$jc)(u,`vscode-ipc-${w}.sock`);return t(p),p}e.$Vh=s;function i(w,u,p){const T=(0,D.createHash)("sha256").update(w).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${p}-${u}-sock`;const F=p.substr(0,4),M=u.substr(0,6);let z;return process.platform!=="darwin"&&e.$Uh&&!process.env.VSCODE_PORTABLE?z=(0,C.$jc)(e.$Uh,`vscode-${T}-${F}-${M}.sock`):z=(0,C.$jc)(w,`${F}-${M}.sock`),t(z),z}e.$Wh=i;function t(w){const u=o[S.$u];typeof u=="number"&&w.length>=u&&console.warn(`WARNING: IPC handle "${w}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends c.$Hh{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,I=>({protocol:new $.$Oh(new y(I,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(I,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Xh=r;function a(w){return new Promise((u,p)=>{const I=(0,N.createServer)();I.on("error",p),I.listen(w,()=>{I.removeListener("error",p),u(new r(I))})})}e.$Yh=a;function v(w,u){return new Promise((p,I)=>{const T=(0,N.createConnection)(w,()=>{T.removeListener("error",I),p($.$Ph.fromSocket(new y(T,`ipc-client${u}`),u))});T.once("error",I)})}e.$Zh=v}),define(le[265],he([0,1,63,122,211]),function(ne,e,D,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0,e.$H_b=new class{supports(j){return!0}connect({host:j,port:O},R,k,g){return new Promise((C,S)=>{const d=D.createConnection({host:j,port:O},()=>{d.removeListener("error",S),d.write((0,A.$irb)(R,k,g));const c=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(d.off("data",c),C(new N.$Sh(d,g)))};d.on("data",c)});d.setNoDelay(!0),d.once("error",S)})}}}),define(le[266],he([0,1,63,36,132,122,6,2,5,20,8,25,214,104,106,78,15]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=e.$B$b=e.$A$b=void 0;async function l(n,o,s,i,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(n,o,s,i,t).waitForReady(),!(t&&A.$rg[t]||!A.$rg[r.tunnelLocalPort]));a--);return r}class f extends R.$Tc{constructor(o,s,i,t,r){super(),this.m=s,this.n=r,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=D.createServer(),this.c=new O.$3g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,s=(0,y.$xv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,A.$sg)(o,2,1e3,s),t=null;return this.b.listen(i,this.m),await this.c.wait(),t=this.b.address(),t||(i=0,this.b.listen(i,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const s=(0,y.$vv)(this.tunnelRemoteHost)||(0,y.$xv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,d.$jl)(this.a,s,this.tunnelRemotePort),t=i.getSocket(),r=i.readEntireBuffer();i.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof j.$Sh?t.socket.destroy():t.end()}),t instanceof j.$Sh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,s){s.onClose(()=>o.destroy()),s.onEnd(()=>o.end()),s.onData(i=>o.write(i.buffer)),o.on("data",i=>s.write(b.$he.wrap(i))),o.resume()}t(o,s){const i=s.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$A$b=f;let m=class extends y.$Av{constructor(o,s,i,t,r){super(s,r),this.u=o,this.v=i,this.w=t}isPortPrivileged(o){return(0,y.$yv)(o,this.l,k.OS,N.release())}s(o,s,i,t,r,a,v,w){const u=this.r(s,i);if(u)return++u.refcount,u.value;if((0,y.$sv)(o))return this.t(o,s,i,r,a,v,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${r}.`);const p={commit:this.w.commit,quality:this.w.quality,addressProvider:o,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},I=l(p,t,s,i,r);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(s,i,I),I}}};e.$B$b=m,e.$B$b=m=ye([X(0,c.$dl),X(1,C.$lj),X(2,$.$gl),X(3,S.$Dj),X(4,g.$xi)],m);let h=class extends m{constructor(o,s,i,t,r){super(o,s,i,t,r)}};e.$C$b=h,e.$C$b=h=ye([X(0,c.$dl),X(1,C.$lj),X(2,$.$gl),X(3,S.$Dj),X(4,g.$xi)],h);let E=class extends R.$Tc{constructor(o,s,i,t,r){super(),this.b=o,this.c=s,this.f=i,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,s,i,t,r,a,v,w,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${t} on local port ${a}.`),!this.a.has(o)){const p=new h(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(s,i,t,r,a,v,w,u)}};e.$D$b=E,e.$D$b=E=ye([X(0,c.$dl),X(1,C.$lj),X(2,S.$Dj),X(3,$.$gl),X(4,g.$xi)],E)}),define(le[273],he([0,1,36,38,7,2,23,10,18,3,40,146,205,206,196,197,264,187,189,20,210,95,221,96,216,14,114,248,29,97,188,113,98,11,199,200,71,4,195,73,74,227,8,201,102,25,59,21,107,22,108,109,110,45,230,82,111,24,80,256,240,241,83,255,259,260,261,60,254,242,106,220,78,266,215,231,28,232,5,233,190,208,207,81,247,17,51,204,58,253,229,243,105,258,249,9,202,101,251,246,217,184,57,203,262,250,56,252,104,265,181,218]),function(ne,e,D,N,A,j,O,R,k,g,C,S,d,c,$,y,b,l,f,m,h,E,n,o,s,i,t,r,a,v,w,u,p,I,T,F,M,z,Z,J,x,G,Q,V,B,te,se,_,oe,K,U,P,L,H,q,ee,W,Y,ie,ce,ae,fe,de,we,Ee,Re,Oe,Ne,ue,ge,me,Pe,Ce,Me,De,ze,Te,Fe,qe,re,$e,be,ve,pe,ke,Ie,Ae,Le,Ge,Ue,Be,We,Xe,tt,vt,Et,St,dt,kt,Pt,Ct,Rt,It,Ot,Dt,jt,$t,At,gt,Lt,Nt,st){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends j.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$CU(this)),this.b=void 0,this.c=this.B(new g.$Td),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,S.$DU)(process.parentPort,st.$P0b.exit,je)}async init(){const Se=await this.h();(0,Y.$Umb)(),Se.invokeFunction(je=>{const Ye=je.get(Q.$lj),Ve=je.get(K.$sl),Qe=je.get(Ie.$1k);Ye.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ye),this.n(Ve,Qe),this.B(Qe.onDidChangeProfiles(()=>this.n(Ve,Qe)))}),this.B((0,j.$Qc)(Se.createInstance(d.$7$b,this.f.codeCachePath),Se.createInstance(c.$8$b),Se.createInstance(b.$$$b),Se.createInstance(y.$0$b),Se.createInstance($.$9$b),Se.createInstance(vt.$y_b),Se.createInstance(We.$q_b)))}async h(){const Se=new J.$2h,je={_serviceBrand:void 0,...B.default};Se.set(te.$Dj,je);const Ye=new C.$Lh(He=>He==="main"),Ve=new $t.$K$b(this.a,Ye);Se.set($t.$J$b,Ve);const Qe=this.f.policiesData?new Le.$g$b(this.f.policiesData,Ve.getChannel("policy")):new Ge.$An;Se.set(Ge.$yn,Qe);const Je=new Nt.$zm(this.f.args,je);Se.set(i.$_h,Je);const et=new V.$pr(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),Ve.getChannel("logger"));Se.set(Q.$mj,et);const ot=this.B(et.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),ht=this.B(new Q.$tj(ot.getLevel())),Ke=this.B(new St.$kO(ot,[ht]));Se.set(Q.$lj,Ke),this.b=this.B(new dt.$A_b(Ke)),Se.set(dt.$z_b,this.b);const Ze=this.B(new T.$4p(Ke));Se.set(I.$ok,Ze);const ut=this.B(new F.$qq(Ke));Ze.registerProvider(O.Schemas.file,ut);const at=new Fe.$Qr(Ze);Se.set(Te.$Yk,at);const xe=this.B(new Ue.$rO(this.f.profiles.all,R.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),Ve.getChannel("userDataProfiles")));Se.set(Ie.$1k,xe);const ft=this.B(new re.$I$b(O.Schemas.file,this.B(new $e.$6N(Ve.getChannel($e.$5N),{pathCaseSensitive:qe.$k})),O.Schemas.vscodeUserData,xe,at,Ke));Ze.registerProvider(O.Schemas.vscodeUserData,ft);const _e=this.B(new h.$1n(xe.defaultProfile.settingsResource,Ze,Qe,Ke));Se.set(m.$xi,_e);const it=new At.$G_b(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},Ve,Je);Se.set(_.$jp,it),this.B((0,j.$Rc)(()=>it.flush())),await Promise.all([_e.initialize(),it.initialize()]);const bt=new Ct.$ar(Ve.getChannel("request"));Se.set(se.$9o,bt),Se.set(l.$_$b,new M.$1h(f.$a_b,void 0,!1)),Se.set(ve.$_E,new M.$1h(be.$p_b,void 0,!1));const wt=new Ot.$P$b(-1,Ve);Se.set(It.$v0b,wt),Se.set(o.$5n,new M.$1h(s.$zO,void 0,!0));const Ft=this.B(new ge.$d$b(wt)),Mt=new C.$Lh(He=>Ft.getActiveClientId().then(lt=>He===lt));Se.set(p.$TYb,new Rt.$C_b(this.a.getChannel("extensionRecommendationNotification",Mt)));let ct;const nt=[],pt=(0,H.$Mo)(je,_e);if((0,H.$Ho)(je,Je)){const He=new P.$f8b(Ke,et,Je,je);if(nt.push(He),!(0,H.$Io)(je,Je)&&je.aiConfig?.ariaKey){const lt=new Be.$$N(bt,pt,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,j.$Rc)(()=>lt.flush())),nt.push(lt)}ct=new L.$er({appenders:nt,commonProperties:(0,oe.$xo)((0,D.release)(),(0,D.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,H.$No)(Je)},_e,je)}else{ct=H.$Bo;const He=H.$Fo;nt.push(He)}this.a.registerChannel("telemetryAppender",new U.$U0b(nt)),Se.set(K.$sl,ct);const Ut=new q.$b_b(_e,ct,Ke,et,Je,je);Se.set(K.$tl,Ut),Se.set(Ae.$Kp,new M.$1h(Pt.$jO,void 0,!0)),Se.set(pe.$Op,new M.$1h(ke.$h$b,void 0,!0)),Se.set(v.$up,new M.$1h(v.$vp,void 0,!0)),Se.set(u.$Yp,new M.$1h(u.$Zp,void 0,!0)),Se.set(a.$no,new M.$1h(r.$sp,void 0,!0)),Se.set(a.$to,new M.$1h(jt.$F_b,void 0,!1)),Se.set(x.$9q,new M.$1h(G.$$q,void 0,!1)),Se.set(E.$Gm,new M.$1h(n.$Xr,void 0,!1)),Se.set(ie.$PEb,new M.$1h(ie.$QEb,void 0,!0)),Se.set(Y.$dnb,new M.$1h(fe.$8Gb,void 0,!0)),Se.set(Y.$cnb,new ae.$e_b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),Se.set(a.$so,new M.$1h(t.$NEb,void 0,!1)),Se.set(W.$6Gb,new M.$1h(W.$7Gb,void 0,!0)),Se.set(ee.$cv,new M.$1h(ee.$dv)),Se.set(Y.$Zmb,new M.$1h(Oe.$eGb,void 0,!0)),Se.set(Y.$1mb,new M.$1h(Oe.$gGb,void 0,!0)),Se.set(de.$Nmb,new M.$1h(de.$Pmb,void 0,!0)),Se.set(Y.$2mb,new M.$1h(ce.$U8b,void 0,!1)),Se.set(Y.$$mb,new M.$1h(we.$J8b,void 0,!0)),Se.set(Y.$_mb,new M.$1h(Ee.$Z8b,void 0,!1)),Se.set(Ne.$pFb,new M.$1h(ue.$l_b,void 0,!0)),Se.set(Y.$anb,new M.$1h(tt.$w9b,void 0,!0)),Se.set(me.$gl,new M.$1h(Pe.$F$b,void 0,!1));const yt=new gt.$el;return Se.set(gt.$dl,yt),yt.register(0,Lt.$H_b),Se.set(Ce.$rv,new M.$1h(Me.$D$b)),Se.set(De.$m_b,new M.$1h(ze.$o_b)),Se.set(Xe.$r_b,new M.$1h(kt.$B_b)),new Z.$tq(Se)}j(Se){const je=this.B(new j.$Sc),Ye=new w.$xp(Se.get(a.$po),()=>null);this.a.registerChannel("extensions",Ye);const Ve=C.ProxyChannel.fromService(Se.get(x.$9q),je);this.a.registerChannel("languagePacks",Ve);const Qe=C.ProxyChannel.fromService(Se.get(E.$Gm),je);this.a.registerChannel("diagnostics",Qe);const Je=new w.$zp(Se.get(a.$to));this.a.registerChannel("extensionTipsService",Je);const et=C.ProxyChannel.fromService(Se.get(l.$_$b),je);this.a.registerChannel("checksum",et);const ot=C.ProxyChannel.fromService(Se.get(ve.$_E),je);this.a.registerChannel("v8InspectProfiling",ot);const ht=new ae.$f_b(Se.get(de.$Nmb));this.a.registerChannel("userDataSyncMachines",ht);const Ke=C.ProxyChannel.fromService(Se.get(K.$tl),je);this.a.registerChannel("customEndpointTelemetry",Ke);const Ze=new ae.$g_b(Se.get(ie.$PEb));this.a.registerChannel("userDataSyncAccount",Ze);const ut=new ae.$h_b(Se.get(Y.$Zmb));this.a.registerChannel("userDataSyncStoreManagement",ut);const at=new Re.$j_b(Se.get(Y.$_mb),Se.get(Ie.$1k),Se.get(Q.$lj));this.a.registerChannel("userDataSync",at);const xe=this.B(Se.get(z.$3h).createInstance(Dt.$E_b)),ft=new ae.$c_b(xe);this.a.registerChannel("userDataAutoSync",ft),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(Y.$anb),je));const _e=C.ProxyChannel.fromService(Se.get(De.$m_b),je);this.a.registerChannel(De.$n_b,_e);const it=C.ProxyChannel.fromService(Se.get(Xe.$r_b),je);this.a.registerChannel("remoteTunnel",it)}m(Se){process.on("uncaughtException",je=>(0,A.$1)(je)),process.on("unhandledRejection",je=>(0,A.$1)(je)),(0,A.setUnexpectedErrorHandler)(je=>{const Ye=(0,N.$Oi)(je,!0);Ye&&Se.error(`[uncaught exception in sharedProcess]: ${Ye}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}handledClientConnection(Se){if(Se.data!==st.$R0b.response)return!1;const je=(0,k.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function mt(rt){const Se=new Tt(rt);process.parentPort.postMessage(st.$P0b.ipcReady),await Se.init(),process.parentPort.postMessage(st.$P0b.initDone)}e.main=mt,process.parentPort.once("message",rt=>{mt(rt.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1cfc62d46e6b9dd217cd485d7d4591136f421d70/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
